
CREATE INDEX XIE2PBS_MAPPING ON PBS_MAPPING
(MAIN_MULTUM_DRUG_CODE)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2PCS_CRITERIA ON PCS_CRITERIA
(CRITERIA_TYPE_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2PCS_HIERARCHY_QUEUE_RELTN ON PCS_HIERARCHY_QUEUE_RELTN
(QUEUE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2PW_COMP_GROUP ON PW_COMP_GROUP
(PATHWAY_COMP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RAD_TECH_FLD_FMT_R ON RAD_TECH_FLD_FMT_R
(PARENT_FIELD_ID, FORMAT_ID, SEQUENCE)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RAD_TECH_FMT_ERPRC_R ON RAD_TECH_FMT_ERPRC_R
(FORMAT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_ADJUSTMENT ON RC_F_ADJUSTMENT
(ACTIVITY_DT_NBR, RC_D_HEALTH_PLAN_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_CASH ON RC_F_CASH
(ACTIVITY_DT_NBR, RC_D_HEALTH_PLAN_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_CLAIM_EVENT ON RC_F_CLAIM_EVENT
(CLAIM_EVENT_DT_NBR, RC_D_FINANCIAL_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_DAILY_CDM_SMRY ON RC_F_DAILY_CDM_SMRY
(ACTIVITY_DT_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_DAILY_CENSUS ON RC_F_DAILY_CENSUS
(ADMISSION_DT_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_DAILY_CENSUS_SMRY ON RC_F_DAILY_CENSUS_SMRY
(RC_D_CENSUS_EVENT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_DAILY_CLAIM_EVENT_S ON RC_F_DAILY_CLAIM_EVENT_SMRY
(ACTIVITY_DT_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_DAILY_TRANS_SMRY ON RC_F_DAILY_TRANS_SMRY
(ACTIVITY_DT_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_DENIAL ON RC_F_DENIAL
(DENIAL_DT_NBR, RC_D_DENIAL_ALIAS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_MONTHLY_CDM_SMRY ON RC_F_MONTHLY_CDM_SMRY
(SHR_D_MONTH_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_MONTHLY_CENSUS_SMRY ON RC_F_MONTHLY_CENSUS_SMRY
(RC_D_CENSUS_EVENT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_MONTHLY_CLAIM_EVENT_S ON RC_F_MONTHLY_CLAIM_EVENT_SMRY
(RC_D_BILL_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_MONTHLY_DENIAL_SMRY ON RC_F_MONTHLY_DENIAL_SMRY
(RC_D_BILLING_ENTITY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_MONTHLY_TRANS_SMRY ON RC_F_MONTHLY_TRANS_SMRY
(RC_D_TRANSACTION_ALIAS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_PATIENT_AR_BALANCE ON RC_F_PATIENT_AR_BALANCE
(ACTIVITY_DT_NBR, RC_D_BILLING_ENTITY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_PATIENT_AR_BAL_SMRY ON RC_F_PATIENT_AR_BAL_SMRY
(ACTIVITY_DT_NBR, RC_D_DISCHARGE_AGE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2RC_F_REVENUE ON RC_F_REVENUE
(ACTIVITY_DT_NBR, RC_D_HEALTH_PLAN_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2REF_RANGE_FACTOR_RULE ON REF_RANGE_FACTOR_RULE
(FROM_GESTATION_DAYS, TO_GESTATION_DAYS, FROM_WEIGHT, FROM_WEIGHT_UNIT_CD, TO_WEIGHT, 
TO_WEIGHT_UNIT_CD, FROM_HEIGHT, FROM_HEIGHT_UNIT_CD, TO_HEIGHT, TO_HEIGHT_UNIT_CD, 
LOCATION_CD, ACTIVE_IND)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2REORG_CONSTRAINTS ON REORG_CONSTRAINTS
(OWNER, CONSTRAINT_NAME)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2REORG_LOG ON REORG_LOG
(ENTRY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2REQUESTER ON REQUESTER
(NAME_FIRST_KEY)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2SA_REF_EXCLUDE_ACTION ON SA_REF_EXCLUDE_ACTION
(SA_REF_DOC_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2SA_REF_EXCLUDE_ITEM ON SA_REF_EXCLUDE_ITEM
(SA_REF_DOC_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2SA_REF_EXCLUDE_PARAMETER ON SA_REF_EXCLUDE_PARAMETER
(SA_REF_DOC_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2SA_REF_REQUIRED_ACTION ON SA_REF_REQUIRED_ACTION
(SA_REF_DOC_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2SA_REF_REQUIRED_CATEGORY ON SA_REF_REQUIRED_CATEGORY
(SA_REF_DOC_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2SCH_FREQ ON SCH_FREQ
(PARENT_TABLE, PARENT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2SCH_NOMEN_LIST ON SCH_NOMEN_LIST
(END_NOMENCLATURE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2SI_COMSRV_MSG_MAP_R ON SI_COMSRV_MSG_MAP_R
(MAP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2SI_OEN_ENDPOINT ON SI_OEN_ENDPOINT
(ENDPOINT_TYPE)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2SI_OEN_SUBSCRIPTION_STEP_R ON SI_OEN_SUBSCRIPTION_STEP_R
(SI_OEN_STEP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2SN_RPT_FIELD_REF ON SN_RPT_FIELD_REF
(RPT_FIELD_GRP_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2STORAGE_CONTENT ON STORAGE_CONTENT
(CONTENT_STATUS_CD, UPDT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2STORAGE_CONTENT_EVENT ON STORAGE_CONTENT_EVENT
(STORAGE_ITEM_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2SURG_PROC_DETAIL ON SURG_PROC_DETAIL
(PROC_CNT)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2TEMPLATE_KEYWORD_RELTN ON TEMPLATE_KEYWORD_RELTN
(TEMPLATE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2THERAPEUTIC_CAT_ITEM ON THERAPEUTIC_CAT_ITEM
(UPDT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2TRACK_ACTION_LINK ON TRACK_ACTION_LINK
(LINK_TYPE_CD, ACTIVE_IND)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2TRACK_COMP_PREFS ON TRACK_COMP_PREFS
(TRACK_PREF_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2UCMR_CASE_STEP ON UCMR_CASE_STEP
(UCMR_CASE_WORKUP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2UCMR_CASE_TRIGGER ON UCMR_CASE_TRIGGER
(UCMR_CASE_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2UCMR_POSITION_MAP ON UCMR_POSITION_MAP
(LONG_TEXT_NOTES_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XIE2WORKLOAD_CODE ON WORKLOAD_CODE
(WORKLOAD_STANDARD_ID, CODE, BEG_EFFECTIVE_DT_TM, END_EFFECTIVE_DT_TM, ACTIVE_IND, 
EVENT_CD, UNITS, ITEM_FOR_COUNT_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XIE2WORKLOAD_GROUP ON WORKLOAD_GROUP
(BOOK_CD, CHAPTER_CD, SECTION_CD, WORKLOAD_CODE_ID, WORKLOAD_STANDARD_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3ADDRESS ON ADDRESS
(POSTAL_IDENTIFIER_KEY)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3BR_DATAMART_FILTER ON BR_DATAMART_FILTER
(INACTION_REASON_VALUE_SET_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3BR_DATAMART_TEXT ON BR_DATAMART_TEXT
(BR_DATAMART_FILTER_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3CCL_REPORT_AUDIT ON CCL_REPORT_AUDIT
(UPDT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3CLAIM_FLD_POSITION ON CLAIM_FLD_POSITION
(DEVICE_CD, PRINT_TRAY_CD, PAPER_TYPE_FLAG)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3CMT_CROSS_MAP ON CMT_CROSS_MAP
(TARGET_CONCEPT_CKI)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3CODE_VALUE_ALIAS ON CODE_VALUE_ALIAS
(UPDT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3CQM_BMDI_RESULTS_QUE ON CQM_BMDI_RESULTS_QUE
(CONTRIBUTOR_REFNUM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3CR_REPORT_SECTION ON CR_REPORT_SECTION
(SECTION_NAME_KEY)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3CR_REPORT_STATIC_REGION ON CR_REPORT_STATIC_REGION
(REGION_NAME_KEY)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3CR_REPORT_STYLE_PROFILE ON CR_REPORT_STYLE_PROFILE
(STYLE_PROFILE_NAME_KEY)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3CV_XREF ON CV_XREF
(XREF_INTERNAL_NAME)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3DCP_PL_QUERY_VALUE ON DCP_PL_QUERY_VALUE
(PARAMETER_ID, PARAMETER_SEQ, VALUE_NAME, VALUE_SEQ)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3DEVICE ON DEVICE
(LOCAL_ADDRESS)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3DISCRETE_TASK_ASSAY ON DISCRETE_TASK_ASSAY
(STRT_ASSAY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3DM_CHG_LOG ON DM_CHG_LOG
(CHG_DT_TM, TABLE_NAME)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3EEM_BENEFIT ON EEM_BENEFIT
(MNEMONIC_KEY_A_NLS)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3EEM_NETWORK ON EEM_NETWORK
(MNEMONIC_KEY_A_NLS)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3HE_SESSION ON HE_SESSION
(KNOWLEDGEBASE_NAME, STATUS_FLAG, PRIORITY, RULE_VERSION_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3HE_SESSION_CONSEQUENT ON HE_SESSION_CONSEQUENT
(KNOWLEDGEBASE_NAME, UPDT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3IO_TOTAL_DEFINITION ON IO_TOTAL_DEFINITION
(TASK_ASSAY_CD, END_EFFECTIVE_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3MIC_QC_TASK_DETAIL ON MIC_QC_TASK_DETAIL
(ACTIVE_COND_SCHEDULE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3MMC_ACTIVITY_ST ON MMC_ACTIVITY_ST
(CONTACT_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3MSG_FYI_ASSIGNMENT ON MSG_FYI_ASSIGNMENT
(POSITION_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3OMF_PVI_FOLDERS ON OMF_PVI_FOLDERS
(USER_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3OMF_PV_ITEMS ON OMF_PV_ITEMS
(PRSNL_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3OPS_SCHEDULE_PARAM ON OPS_SCHEDULE_PARAM
(ACTIVE_STATUS_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3OPS_SCHEDULE_TASK ON OPS_SCHEDULE_TASK
(PARENT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3ORDER_CATALOG ON ORDER_CATALOG
(CONCEPT_CKI)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3ORDER_CATALOG_SYNONYM ON ORDER_CATALOG_SYNONYM
(CATALOG_TYPE_CD, MNEMONIC_KEY_CAP)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3OUTCOME_CATALOG ON OUTCOME_CATALOG
(TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3PATHWAY_COMP ON PATHWAY_COMP
(PARENT_ENTITY_ID, PARENT_ENTITY_NAME)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3PBS_MAPPING ON PBS_MAPPING
(DRUG_SYNONYM_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RAD_TECH_FLD_FMT_R ON RAD_TECH_FLD_FMT_R
(FIELD_ID, PARENT_FIELD_ID, FORMAT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RC_F_ADJUSTMENT ON RC_F_ADJUSTMENT
(ACTIVITY_DT_NBR, RC_D_FINANCIAL_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RC_F_CASH ON RC_F_CASH
(ACTIVITY_DT_NBR, RC_D_FINANCIAL_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RC_F_CLAIM_EVENT ON RC_F_CLAIM_EVENT
(CLAIM_EVENT_DT_NBR, RC_D_BILLING_ENTITY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RC_F_DAILY_CENSUS ON RC_F_DAILY_CENSUS
(DISCHARGE_DT_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RC_F_DAILY_CENSUS_SMRY ON RC_F_DAILY_CENSUS_SMRY
(SHR_D_LOCATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RC_F_DAILY_CLAIM_EVENT_S ON RC_F_DAILY_CLAIM_EVENT_SMRY
(RC_D_BILL_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RC_F_DAILY_TRANS_SMRY ON RC_F_DAILY_TRANS_SMRY
(RC_D_TRANSACTION_ALIAS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RC_F_DENIAL ON RC_F_DENIAL
(DENIAL_DT_NBR, RC_D_HEALTH_PLAN_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RC_F_MONTHLY_CENSUS_SMRY ON RC_F_MONTHLY_CENSUS_SMRY
(SHR_D_LOCATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RC_F_MONTHLY_CLAIM_EVENT_S ON RC_F_MONTHLY_CLAIM_EVENT_SMRY
(RC_D_FINANCIAL_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RC_F_MONTHLY_DENIAL_SMRY ON RC_F_MONTHLY_DENIAL_SMRY
(RC_D_BILL_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RC_F_MONTHLY_TRANS_SMRY ON RC_F_MONTHLY_TRANS_SMRY
(RC_D_FINANCIAL_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RC_F_PATIENT_AR_BALANCE ON RC_F_PATIENT_AR_BALANCE
(ACTIVITY_DT_NBR, RC_D_RESP_HEALTH_PLAN_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RC_F_PATIENT_AR_BAL_SMRY ON RC_F_PATIENT_AR_BAL_SMRY
(ACTIVITY_DT_NBR, RC_D_FINANCIAL_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3RC_F_REVENUE ON RC_F_REVENUE
(ACTIVITY_DT_NBR, RC_D_ENCNTR_TYPE_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3REQUESTER ON REQUESTER
(REQUESTER_SOURCE_CD, REQUEST_REASON_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3SCH_NOMEN_LIST ON SCH_NOMEN_LIST
(BEG_IDENT, END_IDENT)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3SI_COMSRV_MSG_MAP_R ON SI_COMSRV_MSG_MAP_R
(PARAM_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3SI_OEN_ENDPOINT ON SI_OEN_ENDPOINT
(CONNECTION_TYPE)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3STORAGE_CONTENT_EVENT ON STORAGE_CONTENT_EVENT
(ACTION_CD, ACTION_DT_TM, STATION_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3THERAPEUTIC_CAT_ITEM ON THERAPEUTIC_CAT_ITEM
(EXTERNAL_IDENT)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3UCMR_CASE_STEP ON UCMR_CASE_STEP
(CASE_STEP_CAT_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3WORKLOAD_GROUP ON WORKLOAD_GROUP
(WORKLOAD_CODE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4ADDRESS ON ADDRESS
(UPDT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4CCL_REPORT_AUDIT ON CCL_REPORT_AUDIT
(OMF_OBJECT_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4CMT_CROSS_MAP ON CMT_CROSS_MAP
(UPDT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4CV_XREF ON CV_XREF
(DATASET_ID, ELEMENT_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4DCP_PL_QUERY_VALUE ON DCP_PL_QUERY_VALUE
(PARENT_ENTITY_NAME, PARENT_ENTITY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4DEVICE ON DEVICE
(DEVICE_TYPE_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4DISCRETE_TASK_ASSAY ON DISCRETE_TASK_ASSAY
(ACTIVITY_TYPE_CD, DEFAULT_RESULT_TYPE_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4HE_SESSION ON HE_SESSION
(EXPIRATION_DT_TM, KNOWLEDGEBASE_NAME, STATUS_FLAG)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4IO_TOTAL_DEFINITION ON IO_TOTAL_DEFINITION
(PREV_IO_TOTAL_DEFINITION_ID, END_EFFECTIVE_DT_TM, BEG_EFFECTIVE_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4MMC_ACTIVITY_ST ON MMC_ACTIVITY_ST
(CONTACT_PERSON_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4OMF_PVI_FOLDERS ON OMF_PVI_FOLDERS
(PRSNL_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4OPS_SCHEDULE_TASK ON OPS_SCHEDULE_TASK
(STATUS_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4ORDER_CATALOG ON ORDER_CATALOG
(UPDT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4ORDER_CATALOG_SYNONYM ON ORDER_CATALOG_SYNONYM
(ACTIVITY_TYPE_CD, MNEMONIC_KEY_CAP)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4OUTCOME_CATALOG ON OUTCOME_CATALOG
(EVENT_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4PBS_MAPPING ON PBS_MAPPING
(CNUM_CKI)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_ADJUSTMENT ON RC_F_ADJUSTMENT
(RC_D_TRANSACTION_BATCH_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_CASH ON RC_F_CASH
(RC_D_TRANSACTION_BATCH_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_CLAIM_EVENT ON RC_F_CLAIM_EVENT
(CLAIM_EVENT_DT_NBR, RC_D_BILL_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_DAILY_CDM_SMRY ON RC_F_DAILY_CDM_SMRY
(RC_D_BILLING_ENTITY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_DAILY_CENSUS ON RC_F_DAILY_CENSUS
(RC_D_CENSUS_EVENT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_DAILY_CENSUS_SMRY ON RC_F_DAILY_CENSUS_SMRY
(RC_D_PRI_FIN_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_DAILY_CLAIM_EVENT_S ON RC_F_DAILY_CLAIM_EVENT_SMRY
(RC_D_FINANCIAL_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_DAILY_TRANS_SMRY ON RC_F_DAILY_TRANS_SMRY
(RC_D_BILLING_ENTITY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_DENIAL ON RC_F_DENIAL
(SHR_D_LOCATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_MONTHLY_CDM_SMRY ON RC_F_MONTHLY_CDM_SMRY
(RC_D_BILLING_ENTITY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_MONTHLY_CENSUS_SMRY ON RC_F_MONTHLY_CENSUS_SMRY
(RC_D_PRI_FIN_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_MONTHLY_CLAIM_EVENT_S ON RC_F_MONTHLY_CLAIM_EVENT_SMRY
(RC_D_CLAIM_EVENT_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_MONTHLY_DENIAL_SMRY ON RC_F_MONTHLY_DENIAL_SMRY
(RC_D_DENIAL_ALIAS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_MONTHLY_TRANS_SMRY ON RC_F_MONTHLY_TRANS_SMRY
(SHR_D_MONTH_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_PATIENT_AR_BALANCE ON RC_F_PATIENT_AR_BALANCE
(ACTIVITY_DT_NBR, RC_D_PRI_HEALTH_PLAN_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_PATIENT_AR_BAL_SMRY ON RC_F_PATIENT_AR_BAL_SMRY
(ACTIVITY_DT_NBR, SHR_D_LOCATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4RC_F_REVENUE ON RC_F_REVENUE
(SERVICE_DT_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4REQUESTER ON REQUESTER
(PARENT_ENTITY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4SI_OEN_ENDPOINT ON SI_OEN_ENDPOINT
(PROTOCOL_TYPE)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4STORAGE_CONTENT_EVENT ON STORAGE_CONTENT_EVENT
(DESTINATION_CD, ACTION_DT_TM, ACTION_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE50SCH_NOMEN_LIST ON SCH_NOMEN_LIST
(CANDIDATE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5CQM_FSIESO_TR_1 ON CQM_FSIESO_TR_1
(LISTENER_ID, PROCESS_STATUS_FLAG)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5DISCRETE_TASK_ASSAY ON DISCRETE_TASK_ASSAY
(EVENT_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5DM_CHG_LOG ON DM_CHG_LOG
(TARGET_ENV_ID, LOG_TYPE, DELETE_IND, CONTEXT_NAME, TABLE_NAME)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5MMC_ACTIVITY_ST ON MMC_ACTIVITY_ST
(INITIATED_BY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5NOMENCLATURE ON NOMENCLATURE
(CONCEPT_CKI)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5OPS_SCHEDULE_TASK ON OPS_SCHEDULE_TASK
(ACTIVE_STATUS_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5ORDER_CATALOG_SYNONYM ON ORDER_CATALOG_SYNONYM
(MNEMONIC_KEY_CAP, SYNONYM_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5OUTCOME_CATALOG ON OUTCOME_CATALOG
(DESCRIPTION_A_NLS)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5RC_F_ADJUSTMENT ON RC_F_ADJUSTMENT
(INTERFACE_DT_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5RC_F_CASH ON RC_F_CASH
(INTERFACE_DT_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5RC_F_CLAIM_EVENT ON RC_F_CLAIM_EVENT
(CLAIM_EVENT_DT_NBR, RC_D_HEALTH_PLAN_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5RC_F_DAILY_CDM_SMRY ON RC_F_DAILY_CDM_SMRY
(RC_D_MEDICAL_SERVICE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5RC_F_DAILY_CENSUS ON RC_F_DAILY_CENSUS
(SHR_D_LOCATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5RC_F_DAILY_CENSUS_SMRY ON RC_F_DAILY_CENSUS_SMRY
(RC_D_ENCNTR_TYPE_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5RC_F_DAILY_CLAIM_EVENT_S ON RC_F_DAILY_CLAIM_EVENT_SMRY
(RC_D_CLAIM_EVENT_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5RC_F_DAILY_TRANS_SMRY ON RC_F_DAILY_TRANS_SMRY
(RC_D_MEDICAL_SERVICE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5RC_F_MONTHLY_CDM_SMRY ON RC_F_MONTHLY_CDM_SMRY
(RC_D_MEDICAL_SERVICE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5RC_F_MONTHLY_CENSUS_SMRY ON RC_F_MONTHLY_CENSUS_SMRY
(RC_D_ENCNTR_TYPE_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5RC_F_MONTHLY_CLAIM_EVENT_S ON RC_F_MONTHLY_CLAIM_EVENT_SMRY
(RC_D_BILLING_ENTITY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5RC_F_MONTHLY_TRANS_SMRY ON RC_F_MONTHLY_TRANS_SMRY
(RC_D_MEDICAL_SERVICE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5RC_F_PATIENT_AR_BALANCE ON RC_F_PATIENT_AR_BALANCE
(ACTIVITY_DT_NBR, RC_D_AGE_BY_BILL_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5RC_F_PATIENT_AR_BAL_SMRY ON RC_F_PATIENT_AR_BAL_SMRY
(ACTIVITY_DT_NBR, RC_D_RESP_FIN_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5RC_F_REVENUE ON RC_F_REVENUE
(GL_INTERFACE_DT_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5REQUESTER ON REQUESTER
(NAME_LAST_KEY_A_NLS)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6CQM_FSIESO_TR_1 ON CQM_FSIESO_TR_1
(QUEUE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6DEVICE ON DEVICE
(DMS_SERVICE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6DISCRETE_TASK_ASSAY ON DISCRETE_TASK_ASSAY
(CONCEPT_CKI)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6MMC_ACTIVITY_ST ON MMC_ACTIVITY_ST
(ACTIVITY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6NOMENCLATURE ON NOMENCLATURE
(UPDT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6ORDER_CATALOG_SYNONYM ON ORDER_CATALOG_SYNONYM
(MNEMONIC_KEY_CAP, MNEMONIC_TYPE_CD, CATALOG_TYPE_CD, ORDERABLE_TYPE_FLAG)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6OUTCOME_CATALOG ON OUTCOME_CATALOG
(EXPECTATION_A_NLS)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6RC_F_ADJUSTMENT ON RC_F_ADJUSTMENT
(POST_DT_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6RC_F_CASH ON RC_F_CASH
(POST_DT_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6RC_F_CLAIM_EVENT ON RC_F_CLAIM_EVENT
(SHR_D_LOCATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6RC_F_DAILY_CDM_SMRY ON RC_F_DAILY_CDM_SMRY
(SHR_D_LOCATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6RC_F_DAILY_CENSUS ON RC_F_DAILY_CENSUS
(SHR_D_PERSON_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6RC_F_DAILY_CLAIM_EVENT_S ON RC_F_DAILY_CLAIM_EVENT_SMRY
(RC_D_BILLING_ENTITY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6RC_F_DAILY_TRANS_SMRY ON RC_F_DAILY_TRANS_SMRY
(SHR_D_LOCATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6RC_F_MONTHLY_CDM_SMRY ON RC_F_MONTHLY_CDM_SMRY
(SHR_D_LOCATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6RC_F_MONTHLY_TRANS_SMRY ON RC_F_MONTHLY_TRANS_SMRY
(SHR_D_LOCATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6RC_F_PATIENT_AR_BALANCE ON RC_F_PATIENT_AR_BALANCE
(ACTIVITY_DT_NBR, RC_D_AGE_BY_DISCHARGE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6RC_F_PATIENT_AR_BAL_SMRY ON RC_F_PATIENT_AR_BAL_SMRY
(ACTIVITY_DT_NBR, RC_D_DUNNING_LEVEL_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6RC_F_REVENUE ON RC_F_REVENUE
(ACTIVITY_DT_NBR, RC_D_FINANCIAL_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6REQUESTER ON REQUESTER
(NAME_FIRST_KEY_A_NLS)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7DISCRETE_TASK_ASSAY ON DISCRETE_TASK_ASSAY
(HLA_LOCI_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7DM_CHG_LOG ON DM_CHG_LOG
(DM_CHG_LOG_EXCEPTION_ID, TARGET_ENV_ID, CONTEXT_NAME)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7MMC_ACTIVITY_ST ON MMC_ACTIVITY_ST
(REASON_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7NOMENCLATURE ON NOMENCLATURE
(SOURCE_STRING_KEYCAP_A_NLS, BEG_EFFECTIVE_DT_TM, END_EFFECTIVE_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7ORDER_CATALOG_SYNONYM ON ORDER_CATALOG_SYNONYM
(MNEMONIC_KEY_CAP_NLS, MNEMONIC_TYPE_CD, CATALOG_TYPE_CD, ORDERABLE_TYPE_FLAG)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7OUTCOME_CATALOG ON OUTCOME_CATALOG
(DESCRIPTION_A_NLS, EXPECTATION_A_NLS, OUTCOME_TYPE_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7RC_F_ADJUSTMENT ON RC_F_ADJUSTMENT
(BATCH_CREATED_DT_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7RC_F_CASH ON RC_F_CASH
(BATCH_CREATED_DT_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7RC_F_DAILY_CDM_SMRY ON RC_F_DAILY_CDM_SMRY
(RC_D_TIER_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7RC_F_DAILY_CENSUS ON RC_F_DAILY_CENSUS
(RC_D_PRI_FIN_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7RC_F_DAILY_TRANS_SMRY ON RC_F_DAILY_TRANS_SMRY
(RC_D_TIER_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7RC_F_MONTHLY_CDM_SMRY ON RC_F_MONTHLY_CDM_SMRY
(RC_D_TIER_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7RC_F_MONTHLY_TRANS_SMRY ON RC_F_MONTHLY_TRANS_SMRY
(RC_D_TIER_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7RC_F_PATIENT_AR_BALANCE ON RC_F_PATIENT_AR_BALANCE
(ACTIVITY_DT_NBR, SHR_D_PERSON_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7RC_F_PATIENT_AR_BAL_SMRY ON RC_F_PATIENT_AR_BAL_SMRY
(ACTIVITY_DT_NBR, RC_D_BALANCE_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7RC_F_REVENUE ON RC_F_REVENUE
(ACTIVITY_DT_NBR, RC_D_GL_ALIAS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE8DISCRETE_TASK_ASSAY ON DISCRETE_TASK_ASSAY
(MNEMONIC_KEY_CAP)
LOGGING
NOPARALLEL;


CREATE INDEX XIE8DM_CHG_LOG ON DM_CHG_LOG
(PTAM_MATCH_RESULT)
LOGGING
NOPARALLEL;


CREATE INDEX XIE8MMC_ACTIVITY_ST ON MMC_ACTIVITY_ST
(CASE_ST_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE8NOMENCLATURE ON NOMENCLATURE
(SOURCE_STRING_KEYCAP, BEG_EFFECTIVE_DT_TM, END_EFFECTIVE_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE8ORDER_CATALOG_SYNONYM ON ORDER_CATALOG_SYNONYM
(CKI, MNEMONIC_TYPE_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE8RC_F_CASH ON RC_F_CASH
(PAYMENT_METHOD_DT_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE8RC_F_DAILY_CDM_SMRY ON RC_F_DAILY_CDM_SMRY
(RC_D_GL_ALIAS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE8RC_F_DAILY_CENSUS ON RC_F_DAILY_CENSUS
(RC_D_ENCNTR_TYPE_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE8RC_F_MONTHLY_CDM_SMRY ON RC_F_MONTHLY_CDM_SMRY
(RC_D_GL_ALIAS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE8RC_F_PATIENT_AR_BALANCE ON RC_F_PATIENT_AR_BALANCE
(ACTIVITY_DT_NBR, SHR_D_LOCATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE8RC_F_PATIENT_AR_BAL_SMRY ON RC_F_PATIENT_AR_BAL_SMRY
(ACTIVITY_DT_NBR, RC_D_MEDICAL_SERVICE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE8RC_F_REVENUE ON RC_F_REVENUE
(SHR_D_PATIENT_LOCATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE90ORDER_CATALOG_SYNONYM ON ORDER_CATALOG_SYNONYM
(CONCEPT_CKI)
LOGGING
NOPARALLEL;


CREATE INDEX XIE9DISCRETE_TASK_ASSAY ON DISCRETE_TASK_ASSAY
(MNEMONIC_KEY_CAP_NLS)
LOGGING
NOPARALLEL;


CREATE INDEX XIE9DM_CHG_LOG ON DM_CHG_LOG
(CONTEXT_NAME, SINGLE_PASS_LOG_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE9NOMENCLATURE ON NOMENCLATURE
(SOURCE_IDENTIFIER_KEYCAP, BEG_EFFECTIVE_DT_TM, END_EFFECTIVE_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE9RC_F_DAILY_CDM_SMRY ON RC_F_DAILY_CDM_SMRY
(RC_D_ENCNTR_TYPE_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE9RC_F_DAILY_CENSUS ON RC_F_DAILY_CENSUS
(RC_D_ACCOMMODATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE9RC_F_MONTHLY_CDM_SMRY ON RC_F_MONTHLY_CDM_SMRY
(RC_D_ENCNTR_TYPE_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE9RC_F_PATIENT_AR_BALANCE ON RC_F_PATIENT_AR_BALANCE
(ACTIVITY_DT_NBR, RC_D_ENCNTR_TYPE_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE9RC_F_REVENUE ON RC_F_REVENUE
(SHR_D_PERFORMING_LOCATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE_ORDER_CATALOG ON ORDER_CATALOG
(CATALOG_TYPE_CD, ACTIVITY_TYPE_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF001BT_CONDITION ON BT_CONDITION
(BT_CONDITION_TREE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF001BT_CRITERIA_LIMIT ON BT_CRITERIA_LIMIT
(BT_COND_CRIT_R_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF001NOMEN_GROUP_RELTN ON NOMEN_GROUP_RELTN
(BT_COND_CRIT_R_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF001SELECTED_TASK ON SELECTED_TASK
(PFT_TASK_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF002BT_CONDITION ON BT_CONDITION
(PARENT_BT_COND_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF002NOMEN_GROUP_RELTN ON NOMEN_GROUP_RELTN
(NOMEN_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF003BT_CONDITION ON BT_CONDITION
(ACTIVE_IND)
LOGGING
NOPARALLEL;


CREATE INDEX XIF004BT_CONDITION ON BT_CONDITION
(CONDITION_NAME_KEY)
LOGGING
NOPARALLEL;


CREATE INDEX XIF11DEPENDENCY ON DEPENDENCY
(QUESTION_CD, PROCESS_CD, MODULE_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF12PM_RPT_HEADER ON PM_RPT_HEADER
(FIELD_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF12TL_MASTER_TAB_SET_XREF ON TL_MASTER_TAB_SET_XREF
(MASTER_TAB_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF13CONCEPT_HNAM_ADMIN ON CONCEPT_PROPERTY
(SEMANTIC_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF13DEPENDENCY ON DEPENDENCY
(QUESTION_CD, RESPONSE_CD, MODULE_CD, PROCESS_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF14PM_RPT_FILTER ON PM_RPT_FILTER
(FIELD_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF14REPORT_HISTORY_GROUPING_R ON REPORT_HISTORY_GROUPING_R
(TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF156PHASE_GROUP ON PHASE_GROUP
(TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF15PM_RPT_HEADER ON PM_RPT_HEADER
(REPORT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF16ORDER_TASK_XREF ON ORDER_TASK_XREF
(REFERENCE_TASK_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF1ATTRIB_FIELD_RELTN ON ATTRIB_FIELD_RELTN
(ATTRIB_CATALOG_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF1BT_COND_CRIT_RELTN ON BT_COND_CRIT_RELTN
(BT_CONDITION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF1BT_FIELD_RELTN ON BT_FIELD_RELTN
(UDV_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF1NOMENCLATURE ON NOMENCLATURE
(NOM_VER_GRP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF207CONTROL_LOT ON CONTROL_LOT
(CONTROL_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF20CODE_SET_FIELD_DOMAIN ON CODE_SET_FIELD_DOMAIN
(REFERENCE)
LOGGING
NOPARALLEL;


CREATE INDEX XIF225QC_STAT_PERIOD ON QC_STAT_PERIOD
(LOT_ID, SERVICE_RESOURCE_CD, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF242EQUATION ON EQUATION
(SERVICE_RESOURCE_CD, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF248DEPENDENCY_DOMAIN ON DEPENDENCY_DOMAIN
(OE_FORMAT_ID, DEPENDENCY_FIELD_ID, DEPENDENCY_SEQ, OE_FIELD_ID, ACTION_TYPE_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF24PM_RPT_FILTER_VALUES ON PM_RPT_FILTER_VALUES
(FILTER_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF261OE_FORMAT_FIELDS ON OE_FORMAT_FIELDS
(OE_FIELD_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF27PM_RPT_DISPLAY ON PM_RPT_DISPLAY
(REPORT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF2ATTRIB_FIELD_RELTN ON ATTRIB_FIELD_RELTN
(FIELD_CATALOG_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF2BT_COND_CRIT_RELTN ON BT_COND_CRIT_RELTN
(BT_CRITERIA_CAT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF2BT_FIELD_RELTN ON BT_FIELD_RELTN
(BILL_TEMPL_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF2MIC_QC_NODE ON MIC_QC_NODE
(SCHEDULE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF2NOMENCLATURE ON NOMENCLATURE
(CONCEPT_IDENTIFIER, CONCEPT_SOURCE_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF30CONCEPT_CONCEPT_R ON CONCEPT_CONCEPT_R
(RELATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF31CODE_DOMAIN_FILTER_DISPLA ON CODE_DOMAIN_FILTER_DISPLAY
(DOMAIN_ID, CODE_SET)
LOGGING
NOPARALLEL;


CREATE INDEX XIF32CONCEPT_CONCEPT_R ON CONCEPT_CONCEPT_R
(INVERSE_RELATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF35CODE_DOMAIN_FILTER_DISPLA ON CODE_DOMAIN_FILTER_DISPLAY
(CODE_VALUE)
LOGGING
NOPARALLEL;


CREATE INDEX XIF3BT_FIELD_RELTN ON BT_FIELD_RELTN
(ATTRIB_FIELD_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF411ORDER_CATALOG_SYNONYM ON ORDER_CATALOG_SYNONYM
(ORDER_SENTENCE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF48CODE_VALUE_EXTENSION ON CODE_VALUE_EXTENSION
(FIELD_NAME, CODE_SET)
LOGGING
NOPARALLEL;


CREATE INDEX XIF48CONCEPT_PROPERTY ON CONCEPT_PROPERTY
(LONG_TEXT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF4SEMANTIC_NETWORK ON SEMANTIC_NETWORK
(SEMANTIC_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF5ANSWER ON ANSWER
(QUESTION_CD, MODULE_CD, PROCESS_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF5BT_CONDITION ON BT_CONDITION
(END_EFFECTIVE_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIF5SEMANTIC_NETWORK ON SEMANTIC_NETWORK
(SEMANTIC_TYPE2_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF5_NOMENCLATURE ON NOMENCLATURE
(VOCAB_AXIS_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF61STRT_MFG_MODEL_R ON STRT_MFG_MODEL_R
(STRT_MFG_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF68PRODUCT_CATEGORY ON PRODUCT_CATEGORY
(PRODUCT_CLASS_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF6CONCEPT_SEMTYPE_R ON CONCEPT_SEMTYPE_R
(SEMANTIC_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF6PM_RPT_FILTER ON PM_RPT_FILTER
(REPORT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKACCESSION_ASSIGNMENT ON ACCESSION_ASSIGNMENT
(ACC_ASSIGN_POOL_ID, ACC_ASSIGN_DATE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKACCESSION_EXTERNAL_SMRY ON ACCESSION_EXTERNAL_SMRY
(ACCESSION_EXTERNAL_SMRY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKADDRESS ON ADDRESS
(ADDRESS_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKALIQUOTTED_PRIMER_KIT ON ALIQUOTTED_PRIMER_KIT
(LOT_NUMBER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKANSWER ON ANSWER
(QUESTION_CD, ANSWER_ID, SEQUENCE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAPP_TRANSLATION ON APP_TRANSLATION
(TRANSLATION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAP_ACCN_TEMPLATE_DETAIL ON AP_ACCN_TEMPLATE_DETAIL
(TEMPLATE_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAP_DIAG_QUERY_PARAM ON AP_DIAG_QUERY_PARAM
(QUERY_PARAM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAP_PROMPT ON AP_PROMPT
(AP_PROMPT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAP_PROMPT_FIELD ON AP_PROMPT_FIELD
(AP_PROMPT_FIELD_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAP_TAG ON AP_TAG
(TAG_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKATTRIB_FIELD_RELTN ON ATTRIB_FIELD_RELTN
(ATTRIB_FIELD_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_APPLICATION ON AT_APPLICATION
(AP_APPLICATION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_BATCH ON AT_BATCH
(BA_BATCH_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_BATCHOBJECTIVE ON AT_BATCHOBJECTIVE
(BO_OBJECTIVE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_BUCKET ON AT_BUCKET
(BK_BUCKET_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_DEVICEPRODUCT ON AT_DEVICEPRODUCT
(DP_DEVICE_ID, DP_PRODUCT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_KEYWORD ON AT_KEYWORD
(KY_KEYWORD_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_LIBRARY ON AT_LIBRARY
(LB_LIBRARY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_LOCK ON AT_LOCK
(LK_TYPE_ID, LK_ENTITY)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_MNEMONICTYPE ON AT_MNEMONICTYPE
(MN_MNEM_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_PARAMETER ON AT_PARAMETER
(PM_PARAM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_PASSWORD ON AT_PASSWORD
(PW_DOMAIN_ID, PW_USERNAME)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_PLAN ON AT_PLAN
(PL_PLAN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_POPUPCOMPONENT ON AT_POPUPCOMPONENT
(PC_COMPONENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_QUERY ON AT_QUERY
(QY_QUERY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_RUN ON AT_RUN
(RN_RUN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_RUNOBJECTIVE ON AT_RUNOBJECTIVE
(RO_OBJECTIVE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_SCREENSHOT ON AT_SCREENSHOT
(SC_SCREEN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAUDIT_EVENT ON AUDIT_EVENT
(AUDIT_EVENT_NBR)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAUDIT_REQUEST ON AUDIT_REQUEST
(AUDIT_REQUEST_NBR)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBBHIST_SPECIAL_TESTING ON BBHIST_SPECIAL_TESTING
(BBHIST_SPECIAL_TESTING_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBB_ISBT_ADD_INFO ON BB_ISBT_ADD_INFO
(BB_ISBT_ADD_INFO_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBB_MOD_DEVICE ON BB_MOD_DEVICE
(OPTION_ID, DEVICE_TYPE_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBB_QC_TROUBLESHOOTING ON BB_QC_TROUBLESHOOTING
(TROUBLESHOOTING_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBLOB_SUMMARY_REF ON BLOB_SUMMARY_REF
(BLOB_REF_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBLOT_BATCH ON BLOT_BATCH
(BLOT_BATCH_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBLOT_SPECIFICITY ON BLOT_SPECIFICITY
(LOT_NUMBER_ID, ALLELE_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBLOT_STRIP ON BLOT_STRIP
(LOT_NUMBER_ID, STRIP_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_ADO_PROPOSED_DETAIL ON BR_ADO_PROPOSED_DETAIL
(BR_ADO_PROPOSED_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_ADO_PROPOSED_OPTION ON BR_ADO_PROPOSED_OPTION
(BR_ADO_PROPOSED_OPTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_ADO_PROPOSED_ORD_LIST ON BR_ADO_PROPOSED_ORD_LIST
(BR_ADO_PROPOSED_ORD_LIST_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_BP_ACTIVITY ON BR_BP_ACTIVITY
(BR_BP_ACTIVITY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_BP_ACT_GROUP ON BR_BP_ACT_GROUP
(BR_BP_ACT_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_BP_ACT_GROUP_R ON BR_BP_ACT_GROUP_R
(BR_BP_ACT_GROUP_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_BP_ACT_LONG_DESC ON BR_BP_ACT_LONG_DESC
(BR_BP_ACT_LONG_DESC_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_CKI_CLIENT_DATA ON BR_CKI_CLIENT_DATA
(BR_CKI_CLIENT_DATA_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_CKI_CLIENT_DATA_FIELD ON BR_CKI_CLIENT_DATA_FIELD
(BR_CKI_CLIENT_DATA_FIELD_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_DATAMART_FILTER ON BR_DATAMART_FILTER
(BR_DATAMART_FILTER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_DATAMART_FILTER_DETAIL ON BR_DATAMART_FILTER_DETAIL
(BR_DATAMART_FILTER_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_DATAMART_REPORT_FILTER_R ON BR_DATAMART_REPORT_FILTER_R
(BR_DATAMART_REPORT_FILTER_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_DATAMART_TEXT ON BR_DATAMART_TEXT
(BR_DATAMART_TEXT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_DATAMART_VALUE ON BR_DATAMART_VALUE
(BR_DATAMART_VALUE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBT_CONDITION ON BT_CONDITION
(BT_CONDITION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBT_COND_CRIT_RELTN ON BT_COND_CRIT_RELTN
(BT_COND_CRIT_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBT_CRITERIA_LIMIT ON BT_CRITERIA_LIMIT
(BT_CRITERIA_LIMIT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBT_FIELD_RELTN ON BT_FIELD_RELTN
(BT_FIELD_RELTN_ID, BT_FIELD_VRSN_NBR)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCASE_SPECIMEN_TYPE_R ON CASE_SPECIMEN_TYPE_R
(CASE_TYPE_CD, SPECIMEN_MEANING)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCCL_FIELD_MAP ON CCL_FIELD_MAP
(FIELD_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCCL_FORMAT_DETAIL ON CCL_FORMAT_DETAIL
(OBJECT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCCL_LAYOUT_SECTION ON CCL_LAYOUT_SECTION
(SECTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCCL_REPORT_OBJECT_R ON CCL_REPORT_OBJECT_R
(REP_OBJ_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCCR_CONTENT ON CCR_CONTENT
(CONTENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCCR_CONTENT_SECTION_RELTN ON CCR_CONTENT_SECTION_RELTN
(CONTENT_SECTION_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCCR_CONTENT_VIEW_FILTER ON CCR_CONTENT_VIEW_FILTER
(CONTENT_VIEW_FILTER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCCR_FILTER_VALUE ON CCR_FILTER_VALUE
(FILTER_VALUE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_FORMAT ON CHART_FORMAT
(CHART_FORMAT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_FORM_MM_FLDS ON CHART_FORM_MM_FLDS
(CHART_FORMAT_ID, FIELD_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_FORM_SECTS ON CHART_FORM_SECTS
(CHART_FORMAT_ID, CHART_SECTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_GROUP ON CHART_GROUP
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_HLA_FORMAT ON CHART_HLA_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_HORZ_FORMAT ON CHART_HORZ_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_IMAGE_MM_FLDS ON CHART_IMAGE_MM_FLDS
(CHART_FORMAT_ID, FIELD_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_IMMUNIZ_FORMAT ON CHART_IMMUNIZ_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_LISTVIEW_FORMAT ON CHART_LISTVIEW_FORMAT
(CHART_LISTVIEW_FORMAT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_MAR_FORMAT ON CHART_MAR_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_MICRO_FORMAT ON CHART_MICRO_FORMAT
(CHART_GROUP_ID, OPTION_FLAG)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_NAME_HIST_FORMAT ON CHART_NAME_HIST_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_ORDERS_FORMAT ON CHART_ORDERS_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_ORD_SUM_FILTER ON CHART_ORD_SUM_FILTER
(CHART_GROUP_ID, SEQUENCE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_PROBLEM_FORMAT ON CHART_PROBLEM_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_PROCHIST_FORMAT ON CHART_PROCHIST_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_RAD_FORMAT ON CHART_RAD_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_REQUEST_ARCHIVE ON CHART_REQUEST_ARCHIVE
(CHART_REQUEST_ARCHIVE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_SERVER_PRINTER ON CHART_SERVER_PRINTER
(CHART_SERVER_PRINTER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_VERT_FORMAT ON CHART_VERT_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_XENCNTR_FORMAT ON CHART_XENCNTR_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_ZONAL_FORMAT ON CHART_ZONAL_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCLAIM_FLD_POSITION ON CLAIM_FLD_POSITION
(CLAIM_FLD_POSITION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCLINICAL_NOTE_TEMPLATE ON CLINICAL_NOTE_TEMPLATE
(TEMPLATE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCMT_CODE_VALUE_LOAD ON CMT_CODE_VALUE_LOAD
(CODE_VALUE_UUID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCMT_IMPORT_LOG ON CMT_IMPORT_LOG
(CMT_IMPORT_LOG_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCMT_IMPORT_LOG_MSG ON CMT_IMPORT_LOG_MSG
(CMT_IMPORT_LOG_MSG_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCNT_ALPHA_RESPONSE ON CNT_ALPHA_RESPONSE
(CNT_ALPHA_RESPONSE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCNT_DATA_MAP ON CNT_DATA_MAP
(CNT_DATA_MAP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCNT_DCP_INTERP ON CNT_DCP_INTERP
(CNT_DCP_INTERP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCNT_DCP_INTERP_COMPONENT ON CNT_DCP_INTERP_COMPONENT
(CNT_DCP_INTERP_COMPONENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCNT_DTA ON CNT_DTA
(CNT_DTA_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCNT_INPUT_KEY ON CNT_INPUT_KEY
(CNT_INPUT_KEY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCNT_PF_SECTION_R ON CNT_PF_SECTION_R
(CNT_PF_SECTION_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCNT_RRF ON CNT_RRF
(CNT_RRF_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCNT_RRF_AR_R ON CNT_RRF_AR_R
(CNT_RRF_AR_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCNT_SECTION ON CNT_SECTION
(CNT_SECTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCNT_SECTION_DTA_R ON CNT_SECTION_DTA_R
(CNT_SECTION_DTA_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCODE_CDF_EXT ON CODE_CDF_EXT
(CODE_SET, CDF_MEANING, FIELD_NAME)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCODE_DOMAIN_FILTER ON CODE_DOMAIN_FILTER
(CODE_SET, DOMAIN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCODE_DOMAIN_FILTER_DISPLAY ON CODE_DOMAIN_FILTER_DISPLAY
(CODE_SET, DOMAIN_ID, CODE_VALUE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCODE_SET_EXTENSION ON CODE_SET_EXTENSION
(CODE_SET, FIELD_NAME)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCODE_SET_FIELD_DOMAIN ON CODE_SET_FIELD_DOMAIN
(CODE_SET, REFERENCE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCODE_VALUE_CHANGES ON CODE_VALUE_CHANGES
(CODE_VALUE_CHANGES_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCODE_VALUE_EXTENSION ON CODE_VALUE_EXTENSION
(CODE_VALUE, FIELD_NAME, CODE_SET)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCODE_VAL_GRP_RELTN ON CODE_VAL_GRP_RELTN
(CODE_VAL_GRP_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCONCEPT_CONCEPT_R ON CONCEPT_CONCEPT_R
(CONCEPT_CONCEPT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCONCEPT_PROPERTY ON CONCEPT_PROPERTY
(CONCEPT_PROPERTY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCONCEPT_SEMTYPE_R ON CONCEPT_SEMTYPE_R
(CONCEPT_SEMTYPE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCONDITIONAL_BEHAVIOR ON CONDITIONAL_BEHAVIOR
(CONDITION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCOND_REQUIRED_PROPS ON COND_REQUIRED_PROPS
(VALUE_IND, PROPERTY_ID, COND_PROPERTY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCONTROL_LOT ON CONTROL_LOT
(LOT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCOST_ADJ_FLEX ON COST_ADJ_FLEX
(COST_ADJ_FLEX_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCQM_BMDI_RESULTS_QUE ON CQM_BMDI_RESULTS_QUE
(QUEUE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCQM_FSIESO_TR_1 ON CQM_FSIESO_TR_1
(TRIGGER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCQM_MDRESULTS_LOG ON CQM_MDRESULTS_LOG
(LOG_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCQM_MDRESULTS_PAR ON CQM_MDRESULTS_PAR
(PARAM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCQM_MICRESULTS_LOG ON CQM_MICRESULTS_LOG
(LOG_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCQM_MICRESULTS_PAR ON CQM_MICRESULTS_PAR
(PARAM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCR_REPORT_SECTION ON CR_REPORT_SECTION
(REPORT_SECTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCR_REPORT_STATIC_REGION ON CR_REPORT_STATIC_REGION
(REPORT_STATIC_REGION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCR_REPORT_STYLE_PROFILE ON CR_REPORT_STYLE_PROFILE
(REPORT_STYLE_PROFILE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCR_REPORT_WATERMARK ON CR_REPORT_WATERMARK
(REPORT_WATERMARK_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCS_CPP_RULE ON CS_CPP_RULE
(CS_CPP_RULE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCV_COMPONENT ON CV_COMPONENT
(COMPONENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCV_OPERATOR ON CV_OPERATOR
(OPERATOR_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCV_XREF ON CV_XREF
(XREF_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDA_BUS_VIEW ON DA_BUS_VIEW
(DA_BUS_VIEW_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDA_DOMAIN ON DA_DOMAIN
(DA_DOMAIN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDA_DOMAIN_BV_RELTN ON DA_DOMAIN_BV_RELTN
(DA_DOMAIN_BV_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDA_ELEMENT ON DA_ELEMENT
(DA_ELEMENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDA_GROUP_SECURITY ON DA_GROUP_SECURITY
(DA_GROUP_SECURITY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDA_LV_TABLE_ELEM_RELTN ON DA_LV_TABLE_ELEM_RELTN
(DA_LV_TABLE_ELEM_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDA_TABLE_RELTN ON DA_TABLE_RELTN
(DA_TABLE_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDCP_CF_TRANS_CAT_RELTN ON DCP_CF_TRANS_CAT_RELTN
(DCP_CF_TRANS_CAT_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDCP_PL_QUERY_LIST ON DCP_PL_QUERY_LIST
(PATIENT_LIST_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDCP_PL_QUERY_VALUE ON DCP_PL_QUERY_VALUE
(QUERY_VALUE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDD_REF_FILTER ON DD_REF_FILTER
(DD_REF_FILTER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDD_REF_FORMAT ON DD_REF_FORMAT
(DD_REF_FORMAT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDEPENDENCY ON DEPENDENCY
(QUESTION_CD, RESPONSE_CD, DEPEND_QUEST_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDEPENDENCY_DOMAIN ON DEPENDENCY_DOMAIN
(OE_FORMAT_ID, ACTION_TYPE_CD, OE_FIELD_ID, DEPENDENCY_FIELD_ID, DEPENDENCY_SEQ, 
DEP_DOMAIN_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDEVICE ON DEVICE
(DEVICE_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDISCRETE_TASK_ASSAY ON DISCRETE_TASK_ASSAY
(TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDMS_ASSOCIATION ON DMS_ASSOCIATION
(DMS_ASSOCIATION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDMS_CONTENT_TYPE ON DMS_CONTENT_TYPE
(DMS_CONTENT_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDMS_EVENT_REASON_R ON DMS_EVENT_REASON_R
(DMS_EVENT_REASON_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDMS_MEDIA_METADATA_REF ON DMS_MEDIA_METADATA_REF
(DMS_MEDIA_METADATA_REF_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDM_ADS_CONFIG_DRIVER ON DM_ADS_CONFIG_DRIVER
(DM_ADS_CONFIG_DRIVER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDM_ADS_CONFIG_EXTRACT ON DM_ADS_CONFIG_EXTRACT
(DM_ADS_CONFIG_EXTRACT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDM_CB_ANSWERS ON DM_CB_ANSWERS
(ANSWER_NBR)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDM_CB_HISTORY ON DM_CB_HISTORY
(HISTORY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDM_CB_OBJECTS ON DM_CB_OBJECTS
(OBJECT_NAME, OBJECT_TYPE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDM_CHG_LOG ON DM_CHG_LOG
(LOG_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDM_DS_SERVER_RELTN ON DM_DS_SERVER_RELTN
(DM_DS_SERVER_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDM_PURGE_HISTORY ON DM_PURGE_HISTORY
(DM_PURGE_HISTORY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDM_VDATA_EXCLUDE_DTL ON DM_VDATA_EXCLUDE_DTL
(DM_VDATA_EXCLUDE_DTL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDOC_SET_ELEMENT_REF ON DOC_SET_ELEMENT_REF
(DOC_SET_ELEMENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDRC_DOSE_RANGE_CHECK ON DRC_DOSE_RANGE
(DRC_DOSE_RANGE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDRC_DOSE_RANGE_CHECK_VER ON DRC_DOSE_RANGE_VER
(DRC_DOSE_RANGE_ID, VER_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDRUG_CLASS_INT_CUSTOM ON DRUG_CLASS_INT_CUSTOM
(DRUG_CLASS_INT_CUSTOM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDTA_OFFSET_MIN ON DTA_OFFSET_MIN
(DTA_OFFSET_MIN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDTA_VERSION ON DTA_VERSION
(DTA_VERSION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEA_PASSWORD_HISTORY ON EA_PASSWORD_HISTORY
(EA_PASSWORD_HISTORY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEA_TRANSACTION_HIST ON EA_TRANSACTION_HIST
(EA_TRANSACTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEA_TRANSACTION_MAIN ON EA_TRANSACTION_MAIN
(EA_TRANSACTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_BENEFIT ON EEM_BENEFIT
(EEM_BENEFIT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_BENEFIT_PLAN ON EEM_BENEFIT_PLAN
(BENEFIT_PLAN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_BENEFIT_RELTN ON EEM_BENEFIT_RELTN
(EEM_BENEFIT_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_COMMENT ON EEM_COMMENT
(EEM_COMMENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_FILE ON EEM_FILE
(EEM_FILE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_FILE_CHECK ON EEM_FILE_CHECK
(EEM_FILE_ID, BEG_DT_TM)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_FILE_RELTN ON EEM_FILE_RELTN
(FILE_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_NETWORK ON EEM_NETWORK
(NETWORK_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_PROV_TAX_RELTN ON EEM_PROV_TAX_RELTN
(EEM_PROV_TAX_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_SERVICE_TYPE ON EEM_SERVICE_TYPE
(SERVICE_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKELIG_QUEST_LIBRARY ON ELIG_QUEST_LIBRARY
(ELIG_QUEST_LIBRARY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKENCNTR_CLIN_REVIEW_ADDNDM ON ENCNTR_CLIN_REVIEW_ADDNDM
(ENCNTR_CLIN_REVIEW_ADDNDM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEQUATION ON EQUATION
(EQUATION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEQUATION_COMPONENT ON EQUATION_COMPONENT
(EQUATION_ID, SEQUENCE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEQUIPMENT_MASTER ON EQUIPMENT_MASTER
(ITEM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKESO_FIELD_FILTER_RELTN ON ESO_FIELD_FILTER_RELTN
(FIELD_FILTER_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKESO_FILTER_COND_RELTN ON ESO_FILTER_COND_RELTN
(FILTER_COND_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKETR_LOCATION_CHANGE_LOG ON ETR_LOCATION_CHANGE_LOG
(ETR_LOCATION_CHANGE_LOG_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKE_CCL_REPORT_AUDIT ON CCL_REPORT_AUDIT
(REPORT_EVENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_AGE_LIMIT_DETAIL ON FB_AGE_LIMIT_DETAIL
(FB_AGE_LIMIT_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_ALT_DETAIL ON FB_ALT_DETAIL
(FB_ALT_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_ALT_DETAIL_ITEM ON FB_ALT_DETAIL_ITEM
(FB_ALT_DETAIL_ITEM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_COPAY_DRUG_DETAIL ON FB_COPAY_DRUG_DETAIL
(FB_COPAY_DRUG_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_COPAY_SMRY_CLASS ON FB_COPAY_SMRY_CLASS
(FB_COPAY_SMRY_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_GENDER_LIMIT_DETAIL ON FB_GENDER_LIMIT_DETAIL
(FB_GENDER_LIMIT_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_MED_NECESSITY_DETAIL ON FB_MED_NECESSITY_DETAIL
(FB_MED_NECESSITY_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_PRIOR_AUTH_CLASS ON FB_PRIOR_AUTH_CLASS
(FB_PRIOR_AUTH_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_PRIOR_AUTH_DETAIL ON FB_PRIOR_AUTH_DETAIL
(FB_PRIOR_AUTH_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_PROD_EXC_DETAIL ON FB_PROD_EXC_DETAIL
(FB_PROD_EXC_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_QTY_LIMIT_DETAIL ON FB_QTY_LIMIT_DETAIL
(FB_QTY_LIMIT_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_RSRC_DRUG_DETAIL ON FB_RSRC_DRUG_DETAIL
(FB_RSRC_DRUG_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_RSRC_SMRY_LINK ON FB_RSRC_SMRY_LINK
(FB_RSRC_SMRY_LINK_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_STATUS_CLASS ON FB_STATUS_CLASS
(FB_STATUS_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_STATUS_DETAIL ON FB_STATUS_DETAIL
(FB_STATUS_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_STEP_MEDS_DETAIL ON FB_STEP_MEDS_DETAIL
(FB_STEP_MEDS_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_STEP_MEDS_DETAIL_ITEM ON FB_STEP_MEDS_DETAIL_ITEM
(FB_STEP_MEDS_DETAIL_ITEM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_STEP_THERAPY_DETAIL ON FB_STEP_THERAPY_DETAIL
(FB_STEP_THERAPY_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_TEXT_MSG_CLASS ON FB_TXT_MSG_CLASS
(FB_TXT_MSG_CLASS_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFB_TEXT_MSG_DETAIL ON FB_TXT_MSG_DETAIL
(FB_TXT_MSG_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHANDHELD_CONTAINER ON HANDHELD_CONTAINER
(COLLECTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHE_KNOWLEDGEBASE ON HE_KNOWLEDGEBASE
(KNOWLEDGEBASE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHE_RULE_GROUP ON HE_RULE_GROUP
(RULE_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHE_SESSION ON HE_SESSION
(SESSION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHE_SESSION_CONSEQUENT ON HE_SESSION_CONSEQUENT
(SESSION_CONSEQUENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHLA_AB_SCREEN_BATCH ON HLA_AB_SCREEN_BATCH
(BATCH_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHLA_AB_SCREEN_TRAY_MAP ON HLA_AB_SCREEN_TRAY_MAP
(LOT_NUMBER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHLA_AB_SCRN_WELL ON HLA_AB_SCRN_WELL
(LOT_NUMBER_ID, TRAY_NUMBER, X_POS, Y_POS)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHLA_DISPLAY_PRECEDENCE ON HLA_DISPLAY_PRECEDENCE
(HLA_DISPLAY_PRECEDENCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHLA_DTA_EVENT_MAPPING ON HLA_DTA_EVENT_MAPPING
(DTA_CD, EVENT_MNEMONIC)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHLA_SERA_QUERY_QUERIES ON HLA_SERA_QUERY_QUERIES
(SERA_QUERY_QUERIES_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHLA_TYP_TRAY_MAP ON HLA_TYP_TRAY_MAP
(LOT_NUMBER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHLA_TYP_TRAY_WELL ON HLA_TYP_TRAY_WELL
(LOT_NUMBER_ID, X_POS, Y_POS)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHLA_XM_TRAY_MAP ON HLA_XM_TRAY_MAP
(LOT_NUMBER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHM_EXPECT ON HM_EXPECT
(EXPECT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHM_EXPECT_STEP ON HM_EXPECT_STEP
(EXPECT_STEP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKIM_IMAGE ON IM_IMAGE
(IM_IMAGE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKINFOSCAN_PRODUCT ON INFOSCAN_PRODUCT
(FORMULARY_IDENTIFIER, MULTUM_IDENTIFIER, MULTUM_NAME_CODE, THERAP_CLASS_IDENTIFIER, THERAP_SUB_CLASS_IDENTIFIER, 
NOTE_IDENTIFIER)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKINPUT_FORM_BEHAVIOR ON INPUT_FORM_BEHAVIOR
(BEHAVIOR_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKIO_DEF_ELEMENT_RELTN ON IO_DEF_ELEMENT_RELTN
(IO_DEF_ELEMENT_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKIO_TOTAL_DEFINITION ON IO_TOTAL_DEFINITION
(IO_TOTAL_DEFINITION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKLH_ABS_ANSWER ON LH_ABS_ANSWER
(LH_ABS_ANSWER_ID, HEALTH_SYSTEM_SOURCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKLH_ABS_LAYOUT ON LH_ABS_LAYOUT
(LH_ABS_LAYOUT_ID, HEALTH_SYSTEM_SOURCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKLH_CNT_IC_ANTIBGRM_ORG_DSC ON LH_CNT_IC_ANTIBGRM_ORG_DSC
(LH_CNT_IC_ANTIBGRM_ORG_DSC_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKLH_D_BUILDING ON LH_D_BUILDING
(D_BUILDING_ID, HEALTH_SYSTEM_SOURCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKLH_D_NURSE_UNIT ON LH_D_NURSE_UNIT
(D_NURSE_UNIT_ID, HEALTH_SYSTEM_SOURCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKLH_F_ED_METRICS ON LH_F_ED_METRICS
(F_ED_METRICS_ID, HEALTH_SYSTEM_SOURCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKLH_F_FALLS_METRICS ON LH_F_FALLS_METRICS
(F_FALLS_METRICS_ID, HEALTH_SYSTEM_SOURCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKLH_F_HAPU_METRICS ON LH_F_HAPU_METRICS
(F_HAPU_METRICS_ID, HEALTH_SYSTEM_SOURCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKLH_F_NHIQM_VTE_METRICS ON LH_F_NHIQM_VTE_METRICS
(F_NHIQM_VTE_METRICS_ID, HEALTH_SYSTEM_SOURCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKLH_F_STROKE_METRICS ON LH_F_STROKE_METRICS
(F_STROKE_METRICS_ID, HEALTH_SYSTEM_SOURCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKLH_MU_FX_METRICS ON LH_MU_FX_METRICS
(LH_MU_FX_METRICS_ID, HEALTH_SYSTEM_SOURCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMAMMO_LETTER ON MAMMO_LETTER
(LETTER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMESSAGE_TYPE_TEMPLATE_RELTN ON MESSAGE_TYPE_TEMPLATE_RELTN
(MESSAGE_TYPE_TEMPLATE_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMFA_IDENTITY_TYPE ON MFA_IDENTITY_TYPE
(MFA_IDENTITY_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMFA_METHOD_CHAIN ON MFA_METHOD_CHAIN
(MFA_METHOD_CHAIN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_BIO_BLOCK_PROFILE ON MIC_BIO_BLOCK_PROFILE
(GROUP_BIOCHEMICAL_CD, DETAIL_BIOCHEMICAL_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_BPA_INTERP_PLATE_RESULT ON MIC_BPA_INTERP_PLATE_RESULT
(INTERP_ID, SEQUENCE, ANTIBIOTIC_PLATE_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_INTERP ON MIC_INTERP
(INTERP_RANGE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_INTERP_DATA ON MIC_INTERP_DATA
(INTERP_RANGE_ID, SUS_RESULT_CD, LOW_VALUE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_QC_BIO_TEST_RESULT ON MIC_QC_BIO_TEST_RESULT
(QC_ORGANISM_ID, GROUP_BIOCHEMICAL_CD, DETAIL_BIOCHEMICAL_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_QC_ITEM ON MIC_QC_ITEM
(QC_ITEM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_QC_NODE ON MIC_QC_NODE
(NODE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_QC_NODE_RULE_RELTN ON MIC_QC_NODE_RULE_RELTN
(NODE_RULE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_QC_TASK ON MIC_QC_TASK
(TASK_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_QC_TASK_DETAIL ON MIC_QC_TASK_DETAIL
(TASK_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_QC_TASK_RESULT ON MIC_QC_TASK_RESULT
(TASK_RESULT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_SEQ_PRINTER ON MIC_SEQ_PRINTER
(SEQUENCE_ID, OUTPUT_DEST_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_STAT_SUS_CROSS_REF ON MIC_STAT_SUS_CROSS_REF
(SUS_DC_PARAM_ID, SUS_DETAIL1_CD, SUS_DETAIL2_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_STAT_SUS_DC_AB ON MIC_STAT_SUS_DC_AB
(SUS_DC_VALUE_ID, ANTIBIOTIC_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_STAT_SUS_DC_NUMERIC ON MIC_STAT_SUS_DC_NUMERIC
(SUS_DC_VALUE_ID, ANTIBIOTIC_CD, BEGIN_RANGE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_STAT_SUS_DC_RESULT ON MIC_STAT_SUS_DC_RESULT
(SUS_DC_VALUE_ID, ANTIBIOTIC_CD, RESULT_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_SUS_DELTA_NUMERIC_RESUL ON MIC_SUS_DELTA_NUMERIC_RESULT
(SUS_DELTA_VALUE_ID, ANTIBIOTIC_CD, BEGIN_RANGE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_SUS_DELTA_PARAMETER ON MIC_SUS_DELTA_PARAMETER
(SUS_DELTA_PARAM_ID, ANTIBIOTIC_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_SUS_DELTA_PARAM_XREF ON MIC_SUS_DELTA_XREF
(SUS_DELTA_PARAM_ID, ANTIBIOTIC_CD, SUS_DETAIL1_CD, SUS_DETAIL2_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_SUS_DELTA_RESULT ON MIC_SUS_DELTA_RESULT
(SUS_DELTA_VALUE_ID, ANTIBIOTIC_CD, RESULT_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLLD_BCB_DRC_UNITS ON MLLD_BCB_DRC_UNITS
(GLOBAL_TXT, GLOBAL_TYPE_ID, UNIT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLLD_DMD_NAME_MAP ON MLLD_DMD_NAME_MAP
(DRUG_SYNONYM_ID, FUNCTION_ID, APID, APPID, VPID, 
VPPID, VTMID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLLD_DRUG_NAME_GLOBAL_TYPE ON MLLD_DRUG_NAME_GLOBAL_TYPE
(DRUG_SYNONYM_ID, GLOBAL_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLLD_RXB_DISP_RULE_ORDMAP ON MLLD_RXB_CALC_DISP_RULE_ORDMAP
(DRUG_IDENTIFIER, ORDER_ID, DOSE_DISPENSE_RULE_ID, FREQUENCY_DURATION_RULE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLLD_RXB_DUR_RULE_ORD_MAP ON MLLD_RXB_CALC_DUR_RULE_ORD_MAP
(DRUG_IDENTIFIER, ORDER_ID, DOSE_DISPENSE_RULE_ID, FREQUENCY_DURATION_RULE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_ALR_CATEGORY_CLASS_MAP ON MLTM_ALR_CATEGORY_CLASS_MAP
(CLASS_ID, ALR_CATEGORY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_ALT_DRUG_CAT_NAME ON MLTM_ALT_DRUG_CAT_NAME
(ALTERNATE_DRUG_CAT_NAME_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_BCB_DRC_UNITS ON MLTM_BCB_DRC_UNITS
(GLOBAL_TXT, GLOBAL_TYPE_ID, UNIT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_CATEGORY_SUB_XREF ON MLTM_CATEGORY_SUB_XREF
(MULTUM_CATEGORY_ID, SUB_CATEGORY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_DDI_COND_CATEGORY ON MLTM_DDI_COND_CATEGORY
(CHILD_COND_DDI_ID, PARENT_COND_DDI_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_DMD_NAME_MAP ON MLTM_DMD_NAME_MAP
(DRUG_SYNONYM_ID, FUNCTION_ID, APID, APPID, VPID, 
VPPID, VTMID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_DRUG_ID ON MLTM_DRUG_ID
(DRUG_IDENTIFIER)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_DRUG_MODIFIER_MAP ON MLTM_DRUG_MODIFIER_MAP
(DRUG_IDENTIFIER, MODIFIER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_DRUG_NAME_GLOBAL_TYPE ON MLTM_DRUG_NAME_GLOBAL_TYPE
(DRUG_SYNONYM_ID, GLOBAL_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_DUPLICATION_DRUG_XREF ON MLTM_DUPLICATION_DRUG_XREF
(MULTUM_CATEGORY_ID, DRUG_IDENTIFIER)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_FTD_TEXT ON MLTM_FTD_TEXT
(DRUG_IDENTIFIER, HEADING_ID, SEQUENCE_NUMBER)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_FTD_TEXT_CONDITION ON MLTM_FTD_TEXT_CONDITION
(DRUG_IDENTIFIER, HEADING_ID, SEQUENCE_NUMBER, CONDITION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_INT_DRUG_INTERACTIONS ON MLTM_INT_DRUG_INTERACTIONS
(DRUG_IDENTIFIER_1, DRUG_IDENTIFIER_2)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_INT_HEADER_SEV_MAP ON MLTM_INT_HEADER_SEVERITY_MAP
(HEADER_ID, SEVERITY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_INT_INTERACT_SEV_MAP ON MLTM_INT_INTERACT_SEVERITY_MAP
(INT_ID, HEADER_ID, SEVERITY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_NDC_IMAGE ON MLTM_NDC_IMAGE
(NDC_LEFT_9)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_NDC_MAIN_DRUG_CODE ON MLTM_NDC_MAIN_DRUG_CODE
(MAIN_MULTUM_DRUG_CODE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_RXB_DISP_RULE_ORDMAP ON MLTM_RXB_CALC_DISP_RULE_ORDMAP
(DRUG_IDENTIFIER, ORDER_ID, DOSE_DISPENSE_RULE_ID, FREQUENCY_DURATION_RULE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_RXB_DUR_RULE_ORD_MAP ON MLTM_RXB_CALC_DUR_RULE_ORD_MAP
(DRUG_IDENTIFIER, ORDER_ID, DOSE_DISPENSE_RULE_ID, FREQUENCY_DURATION_RULE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_RXB_ORDER ON MLTM_RXB_ORDER
(DRUG_IDENTIFIER, ORDER_ID_NBR)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_RXB_ORDER_DISPENSE_MAP ON MLTM_RXB_ORDER_DISPENSE_MAP
(DRUG_IDENTIFIER, ORDER_ID_NBR, DISPENSE_AMOUNT, DISPENSE_DICTIONARY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_RXB_ORDER_DURATION_MAP ON MLTM_RXB_ORDER_DURATION_MAP
(DRUG_IDENTIFIER, ORDER_ID_NBR, DURATION_AMOUNT, DURATION_DICTIONARY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_RXB_ORDER_FREQ_MAP ON MLTM_RXB_ORDER_FREQUENCY_MAP
(DRUG_IDENTIFIER, ORDER_ID_NBR, FREQUENCY_DICTIONARY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_RXB_ORDER_INST_MAP ON MLTM_RXB_ORDER_INSTRUCTION_MAP
(DRUG_IDENTIFIER, ORDER_ID_NBR, INSTRUCTION_DICTIONARY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_RXB_ORDER_PRN_MAP ON MLTM_RXB_ORDER_PRN_MAP
(DRUG_IDENTIFIER, ORDER_ID_NBR, PRN_DICTIONARY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_RXB_ORDER_REFILL_MAP ON MLTM_RXB_ORDER_REFILL_MAP
(DRUG_IDENTIFIER, ORDER_ID_NBR, REFILL_AMOUNT)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_RXB_ORD_CLIN_RTE_MAP ON MLTM_RXB_ORD_CLINICAL_RTE_MAP
(DRUG_IDENTIFIER, ORDER_ID_NBR, CLINICAL_ROUTE_DICTIONARY_ID, MOST_COMMON_IND)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_RXB_ORD_DOSE_AMOUNT2 ON MLTM_RXB_ORD_DOSE_AMOUNT
(DRUG_IDENTIFIER, ORDER_ID_NBR, DOSE_AMOUNT, DOSE_UNIT_DICTIONARY_ID, DOSE_QTY_AMOUNT)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_RXB_ORD_DOSE_RATE ON MLTM_RXB_ORD_DOSE_RATE
(DRUG_IDENTIFIER, ORDER_ID_NBR, RATE_AMOUNT)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_XP_CLIN_TEXT_XREF ON MLTM_XP_CLIN_TEXT_XREF
(DRUG_IDENTIFIER, FUNCTION_ID, LEVEL_ID, SYST_ID, TEXT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMMC_ACTIVITY_ST ON MMC_ACTIVITY_ST
(ACTIVITY_ST_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMMR_QUESTION_ITEM ON MMR_QUESTION_ITEM
(QUESTION_ITEM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMODEM_COMMANDS ON MODEM_COMMANDS
(MODEM_TYPE_ID, COMMAND_TYPE_CD, REMOTE_DEV_TYPE_ID, QUALIFIER)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMP_VIEWPOINT_ENCNTR ON MP_VIEWPOINT_ENCNTR
(MP_VIEWPOINT_ENCNTR_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMRU_LOOKUP_FOLLOWUP ON MRU_LOOKUP_FOLLOWUP
(MRU_LOOKUP_FOLLOWUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMSG_CATEGORY ON MSG_CATEGORY
(MSG_CATEGORY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMSG_CFG_CAT_RELTN ON MSG_CFG_CAT_RELTN
(MSG_CFG_CAT_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMSG_FYI_ASSIGNMENT ON MSG_FYI_ASSIGNMENT
(MSG_FYI_ASSIGNMENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMSG_ITM_GRP_CAT_RELTN ON MSG_ITM_GRP_CAT_RELTN
(MSG_ITM_GRP_CAT_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKNMDP_CODE ON NMDP_CODE
(NMDP_CODE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKNMDP_SUBTYPE ON NMDP_SUBTYPE
(NMDP_SUFFIX_ID, SUBTYPE_SEQUENCE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKNOMENCLATURE ON NOMENCLATURE
(NOMENCLATURE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKNOMENCLATURE_OUTBOUND ON NOMENCLATURE_OUTBOUND
(NOMENCLATURE_ID, SOURCE_VOCABULARY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKNOMEN_GROUP_RELTN ON NOMEN_GROUP_RELTN
(NOMEN_GROUP_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKNOTE_TYPE_TEMPLATE_RELTN ON NOTE_TYPE_TEMPLATE_RELTN
(NOTE_TYPE_TEMPLATE_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOEN_ERROR ON OEN_ERROR
(ERROR_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOEN_ERROR_SEQ_R ON OEN_ERROR_SEQ_R
(ERROR_SEQ_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOEN_EXPRESSION ON OEN_EXPRESSION
(RULE_ID, PUBLICATION_ID, SEQUENCE_NBR)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOEN_INTERFACE_ERR_R ON OEN_INTERFACE_ERR_R
(INTERFACE_ID, ERROR_ID, SEQUENCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOEN_INTERFACE_SCR_R ON OEN_INTERFACE_SCR_R
(INTERFACE_ID, SCRIPT_ID, VERSION_NBR)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOEN_SCRIPT_BODY ON OEN_SCRIPT_BODY
(SCRIPT_ID, LINE_NBR, VERSION_NBR)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOEN_SEQ_STEP_R ON OEN_SEQ_STEP_R
(SEQUENCE_ID, STEP_ID, ORDER_NBR)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOE_FORMAT_FIELDS ON OE_FORMAT_FIELDS
(OE_FORMAT_ID, ACTION_TYPE_CD, OE_FIELD_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOMF_ACC_FACT ON OMF_ACC_FACT
(OMF_ACC_FACT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOMF_ACR_FACT ON OMF_ACR_FACT
(OMF_ACR_FACT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOMF_AUDIT_CAT ON OMF_AUDIT_CAT
(AUDIT_CAT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOMF_AUDIT_CAT_GRID_RELTN ON OMF_AUDIT_CAT_GRID_RELTN
(OMF_AUDIT_CAT_GRID_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOMF_AUDIT_CAT_IND_RELTN ON OMF_AUDIT_CAT_IND_RELTN
(OMF_AUDIT_CAT_IND_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOMF_AUTH_ATTR ON OMF_AUTH_ATTR
(OMF_AUTH_ATTR_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOMF_AUTH_LOGON_ATTR_RELTN ON OMF_AUTH_LOGON_ATTR_RELTN
(OMF_AUTH_LOGON_ATTR_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOMF_AUTH_PRSNL_GROUP ON OMF_AUTH_PRSNL_GROUP
(OMF_AUTH_PRSNL_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOMF_BLS_FACT ON OMF_BLS_FACT
(OMF_BLS_FACT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOMF_CFGRN_ITEM ON OMF_CFGRN_ITEM
(CFGRN_ITEM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOMF_CFGRN_ITEM_ACTN ON OMF_CFGRN_ITEM_ACTN
(CFGRN_ITEM_ACTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOMF_CFGRN_ITEM_SETNG ON OMF_CFGRN_ITEM_SETNG
(CFGRN_ITEM_SETNG_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOMF_PVI_FOLDERS ON OMF_PVI_FOLDERS
(FOLDER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOMF_PV_ITEMS ON OMF_PV_ITEMS
(OMF_PV_ITEM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKONC_DOCSET_ELEM_DECORATOR ON ONC_DOCSET_ELEM_DECORATOR
(ONC_DOCSET_ELEM_DECORATOR_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKONC_FS_VIEW_RX_SET_RELTN ON ONC_FS_VIEW_RX_SET_RELTN
(ONC_FS_VIEW_RX_SET_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKONC_NOMEN_DOCSETREF_R ON ONC_NOMEN_DOCSETREF_R
(ONC_NOMEN_DOCSETREF_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKONC_TOKEN_ELEMENT_R ON ONC_TOKEN_ELEMENT_R
(ONC_TOKEN_ELEMENT_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKONLINE_ITEM_DEFINITION ON ONLINE_ITEM_DEFINITION
(TASK_ASSAY_CD, ONLINE_ITEM_VERSION_NBR)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOPS_JOB_VERIFY ON OPS_JOB_VERIFY
(OPS_JOB_VERIFY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOPS_MONTH_OF_YEAR ON OPS_MONTH_OF_YEAR
(OPS_MONTH_OF_YEAR_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOPS_SCHEDULE_PARAM ON OPS_SCHEDULE_PARAM
(OPS_SCHEDULE_PARAM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOPS_SCHEDULE_TASK ON OPS_SCHEDULE_TASK
(OPS_SCHEDULE_TASK_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOPS_WEEK_OF_MONTH ON OPS_WEEK_OF_MONTH
(OPS_WEEK_OF_MONTH_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKORDER_CATALOG ON ORDER_CATALOG
(CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKORDER_CATALOG_REVIEW ON ORDER_CATALOG_REVIEW
(CATALOG_CD, ACTION_TYPE_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKORDER_CATALOG_SYNONYM ON ORDER_CATALOG_SYNONYM
(SYNONYM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKORDER_CATALOG_TEXT ON ORDER_CATALOG_TEXT
(CATALOG_CD, TEXT_TYPE_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKORDER_TASK_XREF ON ORDER_TASK_XREF
(CATALOG_CD, REFERENCE_TASK_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOS_RBLD_MSG ON OS_RBLD_MSG
(OS_RBLD_MSG_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOUTCOME_CATALOG ON OUTCOME_CATALOG
(OUTCOME_CATALOG_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOUTCOME_CAT_CRITERIA ON OUTCOME_CAT_CRITERIA
(OUTCOME_CAT_CRITERIA_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPATHWAY_COMP ON PATHWAY_COMP
(PATHWAY_COMP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPBS_INDICATION ON PBS_INDICATION
(PBS_INDICATION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPBS_ITEM ON PBS_ITEM
(PBS_ITEM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPBS_NOTE_RELTN ON PBS_NOTE_RELTN
(PBS_NOTE_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPCA_OUTCOME ON PCA_OUTCOME
(PCA_OUTCOME_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPCA_QUALITY_MEASURE ON PCA_QUALITY_MEASURE
(PCA_QUALITY_MEASURE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPCA_QUALITY_TOPIC ON PCA_QUALITY_TOPIC
(PCA_QUALITY_TOPIC_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPCA_QUALITY_TOPIC_CONTROL ON PCA_QUALITY_TOPIC_CONTROL
(PCA_QUALITY_TOPIC_CONTROL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPCA_TOPIC_MEASURE_RELTN ON PCA_TOPIC_MEASURE_RELTN
(PCA_TOPIC_MEASURE_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPCA_TOPIC_MEASURE_TARGET ON PCA_TOPIC_MEASURE_TARGET
(PCA_TOPIC_MEASURE_TARGET_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPCS_CRITERIA ON PCS_CRITERIA
(CRITERIA_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPCS_FRMT_VRSN_ELEMENT ON PCS_FRMT_VRSN_ELEMENT
(PCS_FRMT_VRSN_ELEMENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPCS_HIERARCHY_QUEUE_RELTN ON PCS_HIERARCHY_QUEUE_RELTN
(HIERARCHY_QUEUE_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPCS_LAYOUT_GROUP ON PCS_LAYOUT_GROUP
(PCS_LAYOUT_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPCS_LAYOUT_GROUP_EVENT ON PCS_LAYOUT_GROUP_EVENT
(PCS_LAYOUT_GROUP_EVENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPCS_SUB_CRITERIA ON PCS_SUB_CRITERIA
(SUB_CRITERIA_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPC_ATTRIBUTE_VALUE ON PC_ATTRIBUTE_VALUE
(ATTRIBUTE_VALUE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPC_REF_ENC_LOC ON PC_REF_ENC_LOC
(REF_ENC_LOC_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPC_REF_ENC_STATUS ON PC_REF_ENC_STATUS
(REF_ENC_STATUS_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPC_REF_ENC_TYPE ON PC_REF_ENC_TYPE
(REF_ENC_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPFT_REPORT_OPTION ON PFT_REPORT_OPTION
(PFT_REPORT_OPTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPG_QUESTION ON PG_QUESTION
(PG_QUESTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPG_RESULT_STAGE ON PG_RESULT_STAGE
(PG_RESULT_STAGE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPHASE_GROUP ON PHASE_GROUP
(PHASE_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPHA_SWITCH_CONN_R ON PHA_SWITCH_CONN_R
(RX_CONNECTION_ID, SWITCH_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPI_LEAFLET ON PI_LEAFLET
(PI_LEAFLET_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPM_CONV_RELTN ON PM_CONV_RELTN
(PM_CONV_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPM_DOC_DESTINATION ON PM_DOC_DESTINATION
(DESTINATION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPM_INFO ON PM_INFO
(PM_CD, INSTANCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPM_RPT_BATCH_PARAMS ON PM_RPT_BATCH_PARAMS
(BATCH_PARAMS_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPM_RPT_DISPLAY ON PM_RPT_DISPLAY
(DISPLAY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPM_RPT_FILTER ON PM_RPT_FILTER
(FILTER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPM_RPT_FILTER_VALUES ON PM_RPT_FILTER_VALUES
(FILTER_VALUES_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPM_RPT_HEADER ON PM_RPT_HEADER
(HEADER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPM_RPT_ORDER ON PM_RPT_ORDER
(ORDER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPOSITIVE_PROBES ON POSITIVE_PROBES
(LOT_NUMBER_ID, ALLELE_CD, PROBE_NUMBER)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPO_BATCH ON PO_BATCH
(PO_BATCH_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPREFDIR_ACL ON PREFDIR_ACL
(ENTRY_ID, VALUE_UPPER)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPRIMER_KIT_SPECIFICITY ON PRIMER_KIT_SPECIFICITY
(LOT_NUMBER_ID, ALLELE_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPRODUCT_CATEGORY ON PRODUCT_CATEGORY
(PRODUCT_CAT_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPRODUCT_DEFAULT_ADDRESS ON PRODUCT_DEFAULT_ADDRESS
(PRODUCT_DEFAULT_ADDRESS_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPRSNL_ROLE_TYPE ON PRSNL_ROLE_TYPE
(PRSNL_ROLE_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPW_COMP_CAT_RELTN ON PW_COMP_CAT_RELTN
(PW_COMP_CAT_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPW_COMP_GROUP ON PW_COMP_GROUP
(PW_COMP_GROUP_ID, PATHWAY_COMP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPW_COMP_OS_RELTN ON PW_COMP_OS_RELTN
(PATHWAY_COMP_ID, ORDER_SENTENCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPW_COMP_RELTN ON PW_COMP_RELTN
(PATHWAY_COMP_S_ID, PATHWAY_COMP_T_ID, TYPE_MEAN, PATHWAY_CATALOG_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKQC_RULE ON QC_RULE
(RULE_ID, SEQUENCE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKQC_SCHEDULE_CTRL ON QC_SCHEDULE_CTRL
(QC_SCHEDULE_ID, STEP_NBR, CONTROL_ID, ERROR_STEP_IND)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKQC_STAT_PERIOD ON QC_STAT_PERIOD
(QC_STAT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRAD_BILL_CATEGORIES ON RAD_BILL_CATEGORIES
(BILL_CAT_CD, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRAD_ENCNTR_PATH_R ON RAD_ENCNTR_PATH_R
(RAD_ENCNTR_PATH_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRAD_FOLLOW_UP_CONTROL ON RAD_FOLLOW_UP_CONTROL
(FOLLOW_UP_CONTROL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRAD_FOLLOW_UP_RECALL ON RAD_FOLLOW_UP_RECALL
(CATALOG_CD, BEGINNING_AGE_RANGE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRAD_MED_CAT_LIST ON RAD_MED_CAT_LIST
(RAD_MED_CATEGORY_ID, SYNONYM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRAD_OMF_TC_INDICATOR ON RAD_OMF_TC_INDICATOR
(INDICATOR_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRAD_OMF_TC_IND_R ON RAD_OMF_TC_IND_R
(INDICATOR_CD, PARENT_FIELD_ID, FIELD_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRAD_PROCEDURE_ASSOC ON RAD_PROCEDURE_ASSOC
(PROC_GROUP_ID, CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRAD_PROCEDURE_TIMES ON RAD_PROCEDURE_TIMES
(CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRAD_PROC_FIELD_RELTN ON RAD_PROC_FIELD_RELTN
(CATALOG_CD, EXPOSURE_FIELD_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRAD_RELEVANT_PRIOR_RELTN ON RAD_RELEVANT_PRIOR_RELTN
(RAD_RELEVANT_PRIOR_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRAD_TECH_FLD_FMT_R ON RAD_TECH_FLD_FMT_R
(FIELD_FORMAT_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRAD_TECH_FMT_ERPRC_R ON RAD_TECH_FMT_ERPRC_R
(FORMAT_ERPRC_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_ADJUSTMENT ON RC_F_ADJUSTMENT
(RC_F_ADJUSTMENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_CASH ON RC_F_CASH
(RC_F_CASH_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_CLAIM_EVENT ON RC_F_CLAIM_EVENT
(RC_F_CLAIM_EVENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_DAILY_CDM_SMRY ON RC_F_DAILY_CDM_SMRY
(RC_F_DAILY_CDM_SMRY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_DAILY_CENSUS ON RC_F_DAILY_CENSUS
(RC_F_DAILY_CENSUS_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_DAILY_CENSUS_SMRY ON RC_F_DAILY_CENSUS_SMRY
(RC_F_DAILY_CENSUS_SMRY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_DAILY_CLAIM_EVENT_SMRY ON RC_F_DAILY_CLAIM_EVENT_SMRY
(RC_F_DAILY_CLAIM_EVENT_SMRY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_DAILY_TRANS_SMRY ON RC_F_DAILY_TRANS_SMRY
(RC_F_DAILY_TRANS_SMRY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_DENIAL ON RC_F_DENIAL
(RC_F_DENIAL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_DLY_ENCNTR_VISIT_SMRY ON RC_F_DAILY_ENCNTR_VISIT_SMRY
(DAILY_ENCNTR_VISIT_SMRY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_MONTHLY_CDM_SMRY ON RC_F_MONTHLY_CDM_SMRY
(RC_F_MONTHLY_CDM_SMRY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_MONTHLY_CENSUS_SMRY ON RC_F_MONTHLY_CENSUS_SMRY
(RC_F_MONTHLY_CENSUS_SMRY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_MONTHLY_CLAIM_EVENT_S ON RC_F_MONTHLY_CLAIM_EVENT_SMRY
(MONTHLY_CLAIM_EVENT_SMRY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_MONTHLY_DENIAL_SMRY ON RC_F_MONTHLY_DENIAL_SMRY
(RC_F_MONTHLY_DENIAL_SMRY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_MONTHLY_ENCNTR_VISIT_S ON RC_F_MONTHLY_ENCNTR_VISIT_SMRY
(MONTHLY_ENCNTR_VISIT_SMRY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_MONTHLY_TRANS_SMRY ON RC_F_MONTHLY_TRANS_SMRY
(RC_F_MONTHLY_TRANS_SMRY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_PATIENT_AR_BALANCE ON RC_F_PATIENT_AR_BALANCE
(RC_F_PATIENT_AR_BALANCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_PATIENT_AR_BAL_SMRY ON RC_F_PATIENT_AR_BAL_SMRY
(RC_F_PATIENT_AR_BAL_SMRY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRC_F_REVENUE ON RC_F_REVENUE
(RC_F_REVENUE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKREFERENCE_RANGE_FACTOR ON REFERENCE_RANGE_FACTOR
(REFERENCE_RANGE_FACTOR_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKREF_DATAPOINT ON REF_DATAPOINT
(REF_DATAPOINT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKREF_DATAPOINT_HIST ON REF_DATAPOINT_HIST
(REF_DATAPOINT_ID, ACTION_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKREF_RANGE_FACTOR_RULE ON REF_RANGE_FACTOR_RULE
(REF_RANGE_FACTOR_RULE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKREF_RANGE_NOTIFY_TRIG ON REF_RANGE_NOTIFY_TRIG
(REF_RANGE_NOTIFY_TRIG_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKREF_TEXT_FACILITY_R ON REF_TEXT_FACILITY_R
(REF_TEXT_VARIATION_ID, FACILITY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRELATED_ASSAY ON RELATED_ASSAY
(RELATED_ENTITY_ID, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKREPORT_HISTORY_GROUPING_R ON REPORT_HISTORY_GROUPING_R
(GROUPING_CD, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKREQUESTER ON REQUESTER
(REQUESTER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRR_ACCESSION_R ON RR_ACCESSION_R
(ROUND_ROBIN_REF_ID, ACCESSION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRR_RESULT ON RR_RESULT
(RR_RESULT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRXS_WORKLIST ON RXS_WORKLIST
(RXS_WORKLIST_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRXS_WORKLIST_LEGAL_STATUS ON RXS_WORKLIST_LEGAL_STATUS
(RXS_WORKLIST_LEGAL_STATUS_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRX_PRINTER_LOCATION_R ON RX_PRINTER_LOCATION_R
(LOCATION_CD, DISPENSE_CATEGORY_CD, DEVICE_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRX_PRODUCT_ASSIGN_ITEM_AUDI ON RX_PRODUCT_ASSIGN_ITEM_AUDIT
(CATALOG_ITEM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSA_REF_ACTION ON SA_REF_ACTION
(SA_REF_ACTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSA_REF_ACTION_GROUP_R ON SA_REF_ACTION_GROUP_R
(SA_REF_ACTION_GROUP_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSA_REF_ACTION_ITEM_CHILD_GR ON SA_REF_ACTION_ITEM_CHILD_GROUP
(SA_REF_ACTN_ITEM_CHILD_GRP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSA_REF_CATEGORY ON SA_REF_CATEGORY
(SA_REF_CATEGORY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSA_REF_CAT_ACTION ON SA_REF_CAT_ACTION
(SA_REF_CAT_ACTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSA_REF_CAT_ITEM ON SA_REF_CAT_ITEM
(SA_REF_CAT_ITEM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSA_REF_CAT_PARAMETER ON SA_REF_CAT_PARAMETER
(SA_REF_CAT_PARAMETER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSA_REF_CAT_PRSNL ON SA_REF_CAT_PRSNL
(SA_REF_CAT_PRSNL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSA_REF_CAT_PRSNL_POSITION ON SA_REF_CAT_PRSNL_POSITION
(SA_REF_CAT_PRSNL_POSITION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSA_REF_CAT_PRSNL_PROVIDER ON SA_REF_CAT_PRSNL_PROVIDER
(SA_REF_CAT_PRSNL_PROVIDER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSA_REF_EXCLUDE_ACTION ON SA_REF_EXCLUDE_ACTION
(SA_REF_EXCLUDE_ACTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSA_REF_EXCLUDE_ITEM ON SA_REF_EXCLUDE_ITEM
(SA_REF_EXCLUDE_ITEM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSA_REF_EXCLUDE_PARAMETER ON SA_REF_EXCLUDE_PARAMETER
(SA_REF_EXCLUDE_PARAMETER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSA_REF_REQUIRED_ACTION ON SA_REF_REQUIRED_ACTION
(SA_REF_REQUIRED_ACTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSA_REF_REQUIRED_CATEGORY ON SA_REF_REQUIRED_CATEGORY
(SA_REF_REQUIRED_CATEGORY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSCH_ABN_CROSS ON SCH_ABN_CROSS
(ABN_CROSS_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSCH_FREQ ON SCH_FREQ
(FREQUENCY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSCH_NOMEN_LIST ON SCH_NOMEN_LIST
(APPT_TYPE_CD, APPT_NOMEN_CD, SEQ_NBR)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSCR_PARAGRAPH_TYPE ON SCR_PARAGRAPH_TYPE
(SCR_PARAGRAPH_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSELECTED_TASK ON SELECTED_TASK
(SELECTED_TASK_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSEMANTIC_NETWORK ON SEMANTIC_NETWORK
(SEMANTIC_NETWORK_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSERVICE_DESCRIPTION ON SERVICE_DESCRIPTION
(SERVICE_REQUEST_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSERVICE_DIRECTORY ON SERVICE_DIRECTORY
(CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSHX_CATEGORY_DEF ON SHX_CATEGORY_DEF
(SHX_CATEGORY_DEF_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSHX_ELEMENT ON SHX_ELEMENT
(SHX_ELEMENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSIGN_LINE_DTA_R ON SIGN_LINE_DTA_R
(ACTIVITY_SUBTYPE_CD, TASK_ASSAY_CD, STATUS_FLAG)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSI_COMSRV_MSG_MAP_R ON SI_COMSRV_MSG_MAP_R
(MESSAGE_ID, MAP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSI_ENTITY_TEMPLATE_GROUP_R ON SI_ENTITY_TEMPLATE_GROUP_R
(SI_ENTITY_TEMPLATE_GROUP_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSI_ERROR_RELTN ON SI_ERROR_RELTN
(SI_ERROR_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSI_OEN_COMCHANNEL ON SI_OEN_COMCHANNEL
(SI_OEN_COMCHANNEL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSI_OEN_ENDPOINT ON SI_OEN_ENDPOINT
(SI_OEN_ENDPOINT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSI_OEN_SUBSCRIPTION_STEP_R ON SI_OEN_SUBSCRIPTION_STEP_R
(SI_OEN_SUBSCRIPTION_STEP_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSN_CT_DISPLAY_ROW ON SN_CT_DISPLAY_ROW
(SN_CT_DISPLAY_ROW_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSN_PROC_CPT_R ON SN_PROC_CPT_R
(PROC_CPT_ASSOC_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSN_RPT_FIELD ON SN_RPT_FIELD
(RPT_FIELD_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSN_RPT_FIELD_REF ON SN_RPT_FIELD_REF
(RPT_FIELD_REF_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSN_RPT_FIELD_SETTING ON SN_RPT_FIELD_SETTING
(RPT_FIELD_SETTING_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSN_SUP_CAB_PREF_FIELD ON SN_SUP_CAB_PREF_FIELD
(SN_SUP_CAB_PREF_FIELD_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSTANDARDIZED_ORDER_DOSE ON STANDARDIZED_ORDER_DOSE
(STANDARDIZED_ORDER_DOSE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSTORAGE_CONTENT ON STORAGE_CONTENT
(STORAGE_CONTENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSTORAGE_CONTENT_EVENT ON STORAGE_CONTENT_EVENT
(STORAGE_CONTENT_EVENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSTRT_BMDI_MODEL_PARAMETER ON STRT_BMDI_MODEL_PARAMETER
(STRT_MODEL_PARAMETER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSTRT_MFG_MODEL_R ON STRT_MFG_MODEL_R
(STRT_MODEL_ID, STRT_MFG_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSTRT_MODEL_ASSAY_ALPHA_RESP ON STRT_MODEL_ASSAY_ALPHA_RESP
(STRT_ASSAY_CD, RANGE_SEQ, STRT_MODEL_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSURGICAL_PROCEDURE ON SURGICAL_PROCEDURE
(CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSURG_PROC_DETAIL ON SURG_PROC_DETAIL
(SURG_PROC_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTAG_FOUNDATION ON TAG_FOUNDATION
(TAG_GROUP_ID, TAG_SEQUENCE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTASK_DISCRETE_R ON TASK_DISCRETE_R
(REFERENCE_TASK_ID, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTEMPLATE_KEYWORD_RELTN ON TEMPLATE_KEYWORD_RELTN
(TEMPLATE_KEYWORD_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTEXT_DATA ON TEXT_DATA
(TASK_ASSAY_CD, RESULT_TEMPLATE_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTHERAPEUTIC_CAT_ITEM ON THERAPEUTIC_CAT_ITEM
(THERAPEUTIC_CAT_ITEM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTHERMOCYCLER_RACK ON THERMOCYCLER_RACK
(RACK_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTHERMO_RACK_PLACEMENT ON THERMO_RACK_PLACEMENT
(ORDER_ID, GEL_BATCH_ID, RACK_ID, X_POS, Y_POS)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTL_COLUMN_CONTENT ON TL_COLUMN_CONTENT
(TL_TAB_ID, COLUMN_NBR)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTL_ELIGIBLE_TASK_CODE ON TL_ELIGIBLE_TASK_CODE
(TL_TAB_ID, TASK_TYPE_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTL_MASTER_TAB_SET_XREF ON TL_MASTER_TAB_SET_XREF
(TL_TAB_ID, MASTER_TAB_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTL_TF_POSITION_XREF ON TL_TF_POSITION_XREF
(TL_TIME_FRAME_ID, POSITION_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTPL_APPL ON TPL_APPL
(APPL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTPL_APPL_CTX_PARAM ON TPL_APPL_CTX_PARAM
(APPL_CTX_PARAM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTPL_APPL_TASK_RELTN ON TPL_APPL_TASK_RELTN
(APPL_TASK_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTRACK_ACTION_LINK ON TRACK_ACTION_LINK
(TRACK_ACTION_LINK_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTRACK_COMP_PREFS ON TRACK_COMP_PREFS
(TRACK_PREF_COMP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTRACK_FIELD_SPEC ON TRACK_FIELD_SPEC
(TRACK_FIELD_SPEC_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTRACK_FIELD_SPEC_BEHAVIOR ON TRACK_FIELD_SPEC_BEHAVIOR
(TRACK_FIELD_SPEC_BEHAVIOR_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTRACK_FIELD_SPEC_REFINEMENT ON TRACK_FIELD_SPEC_REFINEMENT
(TRACK_FIELD_SPEC_REFINEMENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTRACK_LIST ON TRACK_LIST
(TRACK_LIST_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTRACK_LIST_ASSIGNMENT ON TRACK_LIST_ASSIGNMENT
(TRACK_LIST_ASSIGNMENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTRACK_LIST_FILTER_RELTN ON TRACK_LIST_FILTER_RELTN
(TRACK_LIST_FILTER_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTUBE_INFORMATION ON TUBE_INFORMATION
(LOT_NUMBER_ID, TUBE_NUMBER)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKUCMR_CASE_CHARGE_ORDRBL_R ON UCMR_CASE_CHARGE_ORDRBL_R
(UCMR_CASE_CHARGE_ORDRBL_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKUCMR_CASE_STEP ON UCMR_CASE_STEP
(UCMR_CASE_STEP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKUCMR_CASE_TRIGGER ON UCMR_CASE_TRIGGER
(UCMR_CASE_TRIGGER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKUCMR_EQUIVALENT_STEP ON UCMR_EQUIVALENT_STEP
(UCMR_EQUIVALENT_STEP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKUCMR_KARYOTYPE_CONCEPT ON UCMR_KARYOTYPE_CONCEPT
(UCMR_KARYOTYPE_CONCEPT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKUCMR_LAYOUT_FIELD ON UCMR_LAYOUT_FIELD
(UCMR_LAYOUT_FIELD_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKUCMR_POSITION_MAP ON UCMR_POSITION_MAP
(UCMR_POSITION_MAP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKUCMR_POSITION_MAP_CELL ON UCMR_POSITION_MAP_CELL
(UCMR_POSITION_MAP_CELL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKUCMR_REQUIRED_STEP ON UCMR_REQUIRED_STEP
(UCMR_REQUIRED_STEP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKWORKING_VIEW_ITEM ON WORKING_VIEW_ITEM
(WORKING_VIEW_ITEM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKWORKLIST_POS_ORDER_R ON WORKLIST_POS_ORDER_R
(WORKLIST_POS_ORDER_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKWORKLOAD_CODE ON WORKLOAD_CODE
(WORKLOAD_CODE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKWORKLOAD_GROUP ON WORKLOAD_GROUP
(WORKLOAD_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPK_C00155272 ON CV_XREF_FIELD
(XREF_FIELD_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPK_EKS_NOTIFICATION_BLOB ON EKS_NOTIFICATION_BLOB_R
(NOTIFICATION_ID, LONG_BLOB_ID, DATA_SEQ)
LOGGING
NOPARALLEL;


CREATE TABLE ADVANCED_DELTA
(
  ADVANCED_DELTA_ID          NUMBER             DEFAULT 0                     NOT NULL,
  REFERENCE_RANGE_FACTOR_ID  NUMBER             DEFAULT 0                     NOT NULL,
  DELTA_IND                  NUMBER             DEFAULT 0                     NOT NULL,
  DELTA_LOW                  FLOAT(126),
  DELTA_HIGH                 FLOAT(126),
  DELTA_CHECK_TYPE_CD        NUMBER             DEFAULT 0                     NOT NULL,
  DELTA_MINUTES              NUMBER,
  DELTA_VALUE                NUMBER,
  ACTIVE_IND                 NUMBER,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID     NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  BEG_EFFECTIVE_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALPHA_RESPONSES_CATEGORY
(
  ALPHA_RESPONSES_CATEGORY_ID  NUMBER           DEFAULT 0                     NOT NULL,
  REFERENCE_RANGE_FACTOR_ID    NUMBER           DEFAULT 0                     NOT NULL,
  CATEGORY_NAME                VARCHAR2(100 BYTE) DEFAULT ' ' NOT NULL,
  DISPLAY_SEQ                  NUMBER           DEFAULT 0                     NOT NULL,
  EXPAND_FLAG                  NUMBER           DEFAULT 1                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALT_SEL_CAT
(
  ALT_SEL_CATEGORY_ID             NUMBER        DEFAULT 0                     NOT NULL,
  SHORT_DESCRIPTION               VARCHAR2(500 BYTE),
  LONG_DESCRIPTION                VARCHAR2(1000 BYTE),
  OWNER_ID                        NUMBER        DEFAULT 0                     NOT NULL,
  SECURITY_FLAG                   NUMBER,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  CHILD_CAT_IND                   NUMBER,
  LONG_DESCRIPTION_KEY_CAP        VARCHAR2(1000 BYTE),
  AHFS_IND                        NUMBER,
  ADHOC_IND                       NUMBER,
  SOURCE_COMPONENT_FLAG           NUMBER        DEFAULT 0                     NOT NULL,
  FOLDER_FLAG                     NUMBER,
  LONG_DESCRIPTION_KEY_CAP_A_NLS  VARCHAR2(4000 BYTE),
  LONG_DESCRIPTION_KEY_CAP_NLS    VARCHAR2(2002 BYTE),
  IV_SET_SYNONYM_ID               NUMBER        DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALT_SEL_LIST
(
  ALT_SEL_CATEGORY_ID     NUMBER                DEFAULT 0                     NOT NULL,
  SEQUENCE                NUMBER                DEFAULT 0                     NOT NULL,
  SYNONYM_ID              NUMBER                DEFAULT 0                     NOT NULL,
  LIST_TYPE               NUMBER,
  CHILD_ALT_SEL_CAT_ID    NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  REFERENCE_TASK_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_SENTENCE_ID       NUMBER                DEFAULT 0                     NOT NULL,
  PATHWAY_CATALOG_ID      NUMBER                DEFAULT 0                     NOT NULL,
  REGIMEN_CAT_SYNONYM_ID  NUMBER                DEFAULT 0,
  PW_CAT_SYNONYM_ID       NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_DC_STUDY_RPT_PROC
(
  STUDY_ID       NUMBER                         DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD  NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_DIAG_AUTO_CODE
(
  CATALOG_CD     NUMBER                         DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD  NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_PROCESSING_GRP_R
(
  GROUPER_CD          NUMBER                    DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD       NUMBER                    DEFAULT 0                     NOT NULL,
  BEGIN_SECTION       NUMBER,
  END_SECTION         NUMBER,
  BEGIN_LEVEL         NUMBER,
  END_LEVEL           NUMBER,
  MULTIPLIER          NUMBER,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  NO_CHARGE_IND       NUMBER,
  SEQUENCE            NUMBER                    DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME  VARCHAR2(32 BYTE)         DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID    NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_PROMPT_TEST
(
  ACCESSION_ID   NUMBER                         DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD  NUMBER                         DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID   NUMBER                         DEFAULT 0                     NOT NULL,
  ACTIVE_IND     NUMBER                         DEFAULT 0,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_SYNOPTIC_RPT_SECTION_R
(
  CATALOG_CD      NUMBER                        DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD   NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  CKI_SOURCE      CHAR(12 BYTE)                 DEFAULT ' '                   NOT NULL,
  CKI_IDENTIFIER  VARCHAR2(50 BYTE)             DEFAULT ' '                   NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_TASK_ASSAY_ADDL
(
  TASK_ASSAY_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  HALF_SLIDE_IND         NUMBER,
  STAIN_IND              NUMBER,
  TASK_TYPE_FLAG         NUMBER,
  SLIDE_ORIGIN_FLAG      NUMBER,
  CREATE_INVENTORY_FLAG  NUMBER,
  PRINT_LABEL_IND        NUMBER,
  PRINT_WORKLIST_IND     NUMBER,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  DATE_OF_SERVICE_CD     NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ASSAY_TAT
(
  TASK_ASSAY_CD           NUMBER                DEFAULT 0                     NOT NULL,
  PRIORITY_CD             NUMBER                DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  CATALOG_CD              NUMBER                DEFAULT 0                     NOT NULL,
  TAT_CD                  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' )
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_ACTION
(
  AC_ACTION_ID              NUMBER              DEFAULT 0                     NOT NULL,
  AC_APPLICATION_ID         NUMBER              DEFAULT 0                     NOT NULL,
  AC_DISPLAY                VARCHAR2(50 BYTE),
  AC_MNEM_TYPE_ID           NUMBER              DEFAULT 0                     NOT NULL,
  AC_MNEM_TYPE_PARAM        VARCHAR2(50 BYTE),
  AC_PARAM_TYPE_ID          NUMBER              DEFAULT 0                     NOT NULL,
  AC_DEFAULT_MODEL_NAME     VARCHAR2(100 BYTE),
  AC_DEFAULT_VERIFY_PARAMS  VARCHAR2(255 BYTE),
  AC_PREREQS                VARCHAR2(255 BYTE),
  AC_BEGIN_STATE_ID         NUMBER              DEFAULT 0                     NOT NULL,
  AC_END_STATE_ID           NUMBER              DEFAULT 0                     NOT NULL,
  AC_STATE_FLAG             NUMBER,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  AC_COMPONENT_ID           NUMBER              DEFAULT 0,
  AC_ALT_MNEM_TYPE_ID       NUMBER              DEFAULT 0,
  AC_MNEM_LABEL             VARCHAR2(50 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_ACTIONPARAMETER
(
  ACP_ACTION_PARAM_ID       NUMBER              DEFAULT 0                     NOT NULL,
  ACP_ACTION_ID             NUMBER              DEFAULT 0                     NOT NULL,
  ACP_SEQ                   NUMBER,
  ACP_PARAM_ID              NUMBER              DEFAULT 0                     NOT NULL,
  ACP_DEFAULT               VARCHAR2(50 BYTE),
  ACP_VALUE_TYPE_ID         NUMBER              DEFAULT 0                     NOT NULL,
  ACP_STATE_FLAG            NUMBER,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  ACP_DISPLAY               VARCHAR2(50 BYTE),
  ACP_QUERY_TEXT_ID         NUMBER              DEFAULT 0,
  ACP_OTHER_VALUES_TEXT_ID  NUMBER              DEFAULT 0,
  ACP_LIST_SET              NUMBER,
  ACP_PARENT_ID             NUMBER              DEFAULT 0,
  ACP_PARAMETER_TYPE_FLAG   NUMBER,
  ACP_PARAMETER_OPTIONS     NUMBER              DEFAULT 0,
  ACP_FIELD_TYPE_ID         NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_ACTIONSCREEN
(
  AS_ACTION_SCREEN_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  AS_ACTION_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  AS_SEQ               NUMBER,
  AS_DISPLAY           VARCHAR2(50 BYTE),
  AS_DESCRIPTION_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_ALT_ACTION_NAME
(
  AN_ALT_ACTION_NAME_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  AN_ACTION_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  AN_RELEASE_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  AN_NAME                VARCHAR2(50 BYTE),
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  AN_STATE_FLAG          NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_APPACTION
(
  AA_APPLICATION_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  AA_END_STATE_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  AA_OPEN_STATE      VARCHAR2(255 BYTE),
  AA_CLOSE_STATE     VARCHAR2(255 BYTE),
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_BATCHDETAIL
(
  BD_BATCH_DETAIL_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  BD_BATCH_ID         NUMBER                    DEFAULT 0                     NOT NULL,
  BD_SEQ              NUMBER,
  BD_PLAN_DOMAIN_ID   NUMBER                    DEFAULT 0                     NOT NULL,
  BD_PLAN_ID          NUMBER                    DEFAULT 0                     NOT NULL,
  BD_MIN_SUCC_EXES    NUMBER,
  BD_MAX_EXES         NUMBER,
  BD_SUCCESSES        NUMBER,
  BD_COMPLETIONS      NUMBER,
  BD_STATUS_FLAG      NUMBER                    DEFAULT 0                     NOT NULL,
  BD_DISPLAY          VARCHAR2(50 BYTE),
  BD_DESCRIPTION_ID   NUMBER                    DEFAULT 0                     NOT NULL,
  BD_CATEGORY_ID      NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_BATCHSTEP
(
  BS_STEP_ID              NUMBER                DEFAULT 0                     NOT NULL,
  BS_BATCH_DETAIL_ID      NUMBER                DEFAULT 0                     NOT NULL,
  BS_SEQ                  NUMBER,
  BS_ACTION_ID            NUMBER                DEFAULT 0                     NOT NULL,
  BS_DISPLAY              VARCHAR2(255 BYTE),
  BS_REF_STEP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  BS_SPECIFIED_PARAMS_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BS_VERIFY_PARAMS_ID     NUMBER                DEFAULT 0                     NOT NULL,
  BS_BATCH_OBJECTIVE_ID   NUMBER                DEFAULT 0                     NOT NULL,
  BS_REF_MNEM             VARCHAR2(255 BYTE),
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  BS_ALT_REF_MNEM         VARCHAR2(255 BYTE),
  BS_ALT_REF_STEP_ID      NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_LOG
(
  LG_DEVICE_ID      NUMBER                      DEFAULT 0                     NOT NULL,
  LG_LOG_DT_TM      DATE                        DEFAULT sysdate               NOT NULL,
  LG_SEQ            NUMBER                      DEFAULT 0                     NOT NULL,
  LG_DETAIL_DT_TM   DATE,
  LG_DEFAULT_LEVEL  VARCHAR2(1 BYTE),
  LG_MESSAGE        VARCHAR2(255 BYTE),
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  LG_RUN_ID         NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_OBJECTIVE
(
  OB_OBJECTIVE_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  OB_PLAN_ID         NUMBER                     DEFAULT 0                     NOT NULL,
  OB_SEQ             NUMBER,
  OB_DISPLAY         VARCHAR2(50 BYTE),
  OB_DESCRIPTION_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  OB_STEP_COUNT      NUMBER,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_POSTCONDITION
(
  POS_ACTION_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  POS_KEYWORD_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  POS_DELETE_IND        NUMBER,
  POS_STATE_FLAG        NUMBER,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  POS_ACTIONDETAIL_IND  NUMBER,
  DM2_MIG_SEQ_ID        NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_PRECONDITION
(
  PRE_KEYWORD_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  PRE_ACTION_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  PRE_STATE_FLAG        NUMBER,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  PRE_ACTIONDETAIL_IND  NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_RUNSTEP
(
  RS_RUN_STEP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  RS_RUN_ID               NUMBER                DEFAULT 0                     NOT NULL,
  RS_SEQ                  NUMBER,
  RS_STEP_ID              NUMBER                DEFAULT 0                     NOT NULL,
  RS_ACTION_ID            NUMBER                DEFAULT 0                     NOT NULL,
  RS_DISPLAY              VARCHAR2(255 BYTE),
  RS_ACTION_DETAIL        VARCHAR2(255 BYTE),
  RS_SPECIFIED_PARAMS_ID  NUMBER                DEFAULT 0                     NOT NULL,
  RS_VERIFY_PARAMS_ID     NUMBER                DEFAULT 0                     NOT NULL,
  RS_RUN_DT_TM            DATE,
  RS_STATUS_FLAG          NUMBER,
  RS_ACTUAL_PARAMS_ID     NUMBER                DEFAULT 0                     NOT NULL,
  RS_PROC_ERRORS_ID       NUMBER                DEFAULT 0                     NOT NULL,
  RS_INFO_MESSAGES_ID     NUMBER                DEFAULT 0                     NOT NULL,
  RS_RUN_OBJECTIVE_ID     NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  RS_COMMENT_ID           NUMBER                DEFAULT 0,
  RS_ERROR_REFERENCE      VARCHAR2(25 BYTE)     DEFAULT ' ',
  RS_ERROR_CODE_ID        NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_STEP
(
  ST_STEP_ID              NUMBER                DEFAULT 0                     NOT NULL,
  ST_PLAN_ID              NUMBER                DEFAULT 0                     NOT NULL,
  ST_SEQ                  NUMBER,
  ST_SKIP_IND             NUMBER,
  ST_ACTION_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ST_DISPLAY              VARCHAR2(255 BYTE),
  ST_REF_STEP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ST_REF_MNEM             VARCHAR2(255 BYTE),
  ST_SPECIFIED_PARAMS_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ST_VERIFY_PARAMS_ID     NUMBER                DEFAULT 0                     NOT NULL,
  ST_OBJECTIVE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  ST_ALT_REF_MNEM         VARCHAR2(255 BYTE),
  ST_ALT_REF_STEP_ID      NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_SUBACTION
(
  SA_SUBACTION_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  SA_ACTION_ID     NUMBER                       DEFAULT 0                     NOT NULL,
  SA_SEQ           NUMBER,
  SA_TYPE_ID       NUMBER                       DEFAULT 0                     NOT NULL,
  SA_SUBACTION     VARCHAR2(255 BYTE),
  SA_BATCH_IND     NUMBER,
  SA_STATE_FLAG    NUMBER,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_SYNONYMTYPE
(
  SY_SYNONYM_ID      NUMBER                     DEFAULT 0                     NOT NULL,
  SY_ACTION_ID       NUMBER                     DEFAULT 0                     NOT NULL,
  SY_SYNONYMTYPE_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  SY_MEANING         VARCHAR2(50 BYTE),
  SY_STATE_FLAG      NUMBER,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_TIMER
(
  TM_RUN_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  TM_SEQ             NUMBER                     DEFAULT 0                     NOT NULL,
  TM_EVENT_DT_TM     DATE,
  TM_TYPE            NUMBER,
  TM_NAME            VARCHAR2(255 BYTE),
  TM_APPLICATION_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  TM_ACTION_ID       NUMBER                     DEFAULT 0                     NOT NULL,
  TM_USER            VARCHAR2(50 BYTE),
  TM_PATIENT         VARCHAR2(50 BYTE),
  TM_VALUE           VARCHAR2(50 BYTE),
  TM_PASS_IND        NUMBER,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_GROUP_COMPONENT
(
  BB_GROUP_COMPONENT_ID   NUMBER                DEFAULT 0                     NOT NULL,
  BB_TEST_GROUP_ID        NUMBER                DEFAULT 0                     NOT NULL,
  CATALOG_CD              NUMBER                DEFAULT 0                     NOT NULL,
  SEQUENCE                NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_QC_EXPECTED_RESULT_R
(
  EXPECTED_RESULT_ID         NUMBER             DEFAULT 0                     NOT NULL,
  RELATED_REAGENT_DETAIL_ID  NUMBER             DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID            NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM        DATE               DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  PREV_EXPECTED_RESULT_ID    NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_RH_PHENOTYPE
(
  RH_PHENOTYPE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  FR_NOMENCLATURE_ID      NUMBER                DEFAULT 0                     NOT NULL,
  W_NOMENCLATURE_ID       NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_RH_PHENO_TESTING
(
  RH_PHENO_TESTING_ID     NUMBER                DEFAULT 0                     NOT NULL,
  RH_PHENOTYPE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  SPECIAL_TESTING_CD      NUMBER                DEFAULT 0                     NOT NULL,
  SEQUENCE                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT TO_DATE ( '01/01/190000:00:00' , 'MM/DD/YYYYHH24:MI:SS' ) NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BILL_ONLY_PROC_RELTN
(
  CATALOG_CD    NUMBER                          DEFAULT 0                     NOT NULL,
  ENTITY_NAME   VARCHAR2(40 BYTE)               DEFAULT ' '                   NOT NULL,
  ENTITY_ID     NUMBER                          DEFAULT 0                     NOT NULL,
  STANDARD_QTY  NUMBER                          DEFAULT 0,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_DATAMART_DEFAULT
(
  BR_DATAMART_DEFAULT_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BR_DATAMART_FILTER_ID   NUMBER                DEFAULT 0                     NOT NULL,
  UNIQUE_IDENTIFIER       VARCHAR2(255 BYTE)    DEFAULT ' '                   NOT NULL,
  CV_DISPLAY              VARCHAR2(100 BYTE)    DEFAULT ' '                   NOT NULL,
  CV_DESCRIPTION          VARCHAR2(255 BYTE)    DEFAULT ' '                   NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  CODE_SET                NUMBER,
  RESULT_TYPE_FLAG        NUMBER,
  QUALIFIER_FLAG          NUMBER,
  RESULT_VALUE            VARCHAR2(255 BYTE),
  ORDER_DETAIL_IND        NUMBER,
  GROUP_NAME              VARCHAR2(100 BYTE),
  GROUP_CE_NAME           VARCHAR2(100 BYTE),
  GROUP_CE_CONCEPT_CKI    VARCHAR2(255 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_DATAMART_DEFAULT_DETAIL
(
  BR_DATAMART_DEFAULT_DETAIL_ID  NUMBER         DEFAULT 0                     NOT NULL,
  BR_DATAMART_DEFAULT_ID         NUMBER         DEFAULT 0                     NOT NULL,
  OE_FIELD_MEANING               VARCHAR2(25 BYTE) DEFAULT ' ' NOT NULL,
  DETAIL_VALUE                   VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  DETAIL_CKI                     VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_OF_PARENT_RELTN
(
  BR_CLIENT_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  ALT_SEL_CATEGORY_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  SOURCE_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  SOURCE_NAME          VARCHAR2(32 BYTE)        DEFAULT ' '                   NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CATALOG_EVENT_SETS
(
  CATALOG_CD      NUMBER                        DEFAULT 0                     NOT NULL,
  SEQUENCE        NUMBER                        DEFAULT 0                     NOT NULL,
  EVENT_SET_NAME  VARCHAR2(100 BYTE)            DEFAULT ' '                   NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CATALOG_TAT
(
  CATALOG_CD              NUMBER                DEFAULT 0                     NOT NULL,
  PRIORITY_CD             NUMBER                DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  TAT_CD                  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_STRING_RESULT
(
  EVENT_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  VALID_UNTIL_DT_TM        DATE                 DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  VALID_FROM_DT_TM         DATE                 DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  STRING_RESULT_TEXT       VARCHAR2(255 BYTE)   DEFAULT ' '                   NOT NULL,
  STRING_RESULT_FORMAT_CD  NUMBER               DEFAULT 0                     NOT NULL,
  EQUATION_ID              NUMBER               DEFAULT 0                     NOT NULL,
  LAST_NORM_DT_TM          DATE,
  UNIT_OF_MEASURE_CD       NUMBER               DEFAULT 0                     NOT NULL,
  FEASIBLE_IND             NUMBER,
  NORMAL_HIGH              VARCHAR2(20 BYTE),
  NORMAL_LOW               VARCHAR2(20 BYTE),
  CRITICAL_HIGH            VARCHAR2(20 BYTE),
  CRITICAL_LOW             VARCHAR2(20 BYTE),
  INACCURATE_IND           NUMBER,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  MODIFY_FLAG              NUMBER               DEFAULT 0,
  CALCULATION_EQUATION     VARCHAR2(512 BYTE),
  STRING_LONG_TEXT_ID      NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_ALLERGY_FORMAT
(
  CHART_GROUP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  SUBSTANCE_LBL           VARCHAR2(32 BYTE),
  REACTION_STAT_LBL       VARCHAR2(32 BYTE),
  SEVERITY_LBL            VARCHAR2(32 BYTE),
  ONSET_DT_LBL            VARCHAR2(32 BYTE),
  CREATED_PRSN_LBL        VARCHAR2(32 BYTE),
  SUBSTANCE_ODR           NUMBER,
  REACTION_STAT_ODR       NUMBER                DEFAULT 0                     NOT NULL,
  SEVERITY_ODR            NUMBER                DEFAULT 0                     NOT NULL,
  ONSET_DT_ODR            NUMBER                DEFAULT 0                     NOT NULL,
  CREATED_PRSN_ODR        NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_LBL             VARCHAR2(32 BYTE),
  UPDT_BY_LBL             VARCHAR2(32 BYTE),
  REACTION_LBL            VARCHAR2(32 BYTE),
  SOURCE_LBL              VARCHAR2(32 BYTE),
  TYPE_LBL                VARCHAR2(32 BYTE),
  CANCEL_LBL              VARCHAR2(32 BYTE),
  CATEGORY_LBL            VARCHAR2(32 BYTE),
  COMMENT_LBL             VARCHAR2(32 BYTE),
  REACTION_ODR            NUMBER                DEFAULT 0                     NOT NULL,
  SOURCE_ODR              NUMBER                DEFAULT 0                     NOT NULL,
  TYPE_ODR                NUMBER                DEFAULT 0                     NOT NULL,
  CANCEL_ODR              NUMBER                DEFAULT 0                     NOT NULL,
  CATEGORY_ODR            NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_SEQUENCE_IND     NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_AP_FORMAT
(
  CHART_GROUP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  GROUP_STYLE             VARCHAR2(255 BYTE),
  RESULT_SEQUENCE         NUMBER,
  SNOMED_CODES_IND        NUMBER,
  SNOMED_DESC_IND         NUMBER,
  SNOMED_CODES_LBL        VARCHAR2(100 BYTE),
  SNOMED_CD_LBL_STYLE     VARCHAR2(255 BYTE),
  TCC_CODES_IND           NUMBER,
  TCC_DESC_IND            NUMBER,
  TCC_CODES_LBL           VARCHAR2(100 BYTE),
  TCC_CD_LBL_STYLE        VARCHAR2(255 BYTE),
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  AP_HISTORY_FLAG         NUMBER,
  IMAGE_FLAG              NUMBER,
  AP_CPT_LONG_TEXT_ID     NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_DOC_FORMAT
(
  CHART_GROUP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_SEQ_FLAG         NUMBER,
  PAGE_BRK_IND            NUMBER,
  EXCLUDE_IMG_MDOC_IND    NUMBER                DEFAULT 0,
  INCLUDE_IMG_HEADER_IND  NUMBER                DEFAULT 0,
  INCLUDE_IMG_FOOTER_IND  NUMBER                DEFAULT 0,
  DOC_TYPE_FLAG           NUMBER                DEFAULT 0,
  INCLUDE_ECG_IMG_IND     NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_DYN_ZONE_FORM
(
  CHART_GROUP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ZONE_SEQ                NUMBER                DEFAULT 0                     NOT NULL,
  PROC_LBL                VARCHAR2(32 BYTE),
  UNITS_LBL               VARCHAR2(32 BYTE),
  REF_RANGE_LBL           VARCHAR2(32 BYTE),
  PROC_COL                NUMBER,
  UNITS_COL               NUMBER,
  REF_RANGE_COL           NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_FLEX_FORMAT
(
  CHART_GROUP_ID           NUMBER               DEFAULT 0                     NOT NULL,
  FLEX_TYPE                NUMBER,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  ABO_RH_LBL               VARCHAR2(32 BYTE),
  ABO_RH_ORDER             NUMBER,
  COLLECTED_DT_TM_LBL      VARCHAR2(32 BYTE),
  COLLECTED_DT_TM_ORDER    NUMBER,
  CROSSMATCH_RESULT_LBL    VARCHAR2(32 BYTE),
  CROSSMATCH_RESULT_ORDER  NUMBER,
  DESCRIPTION_LBL          VARCHAR2(32 BYTE),
  DESCRIPTION_ORDER        NUMBER,
  DISPLAY_LBL              VARCHAR2(32 BYTE),
  DISPLAY_ORDER            NUMBER,
  ORDER_SEQ_FLAG           NUMBER,
  PRODUCT_NBR_LBL          VARCHAR2(32 BYTE),
  PRODUCT_NBR_ORDER        NUMBER,
  VERIFIED_DT_TM_LBL       VARCHAR2(32 BYTE),
  VERIFIED_DT_TM_ORDER     NUMBER,
  RECEIVED_DT_TM_LBL       VARCHAR2(32 BYTE),
  RECEIVED_DT_TM_ORDER     NUMBER,
  PRODUCT_STATUS_LBL       VARCHAR2(32 BYTE),
  PRODUCT_STATUS_ORDER     NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_FORMAT_CODES
(
  CF_CODE_ID              NUMBER                DEFAULT 0                     NOT NULL,
  CHART_FORMAT_ID         NUMBER                DEFAULT 0                     NOT NULL,
  CHART_SECTION_ID        NUMBER                DEFAULT 0                     NOT NULL,
  SECTION_TYPE_FLAG       NUMBER,
  AP_HISTORY_FLAG         NUMBER,
  CS_SEQUENCE_NUM         NUMBER,
  CHART_GROUP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  CG_SEQUENCE_NUM         NUMBER,
  ZONE                    NUMBER,
  EVENT_SET_SEQ           NUMBER,
  PROCEDURE_TYPE_FLAG     NUMBER,
  EVENT_SET_NAME          VARCHAR2(40 BYTE),
  EVENT_CD                NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_CATALOG_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  FLEX_TYPE_FLAG          NUMBER,
  HLA_TYPE_FLAG           NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_GENERIC_FORMAT
(
  CHART_GROUP_ID            NUMBER              DEFAULT 0                     NOT NULL,
  PARAM_LONG_TEXT_ID        NUMBER              DEFAULT 0                     NOT NULL,
  INCLUDE_IMG_HEADER_IND    NUMBER              DEFAULT 0                     NOT NULL,
  INCLUDE_IMG_FOOTER_IND    NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  CHART_DISCERN_REQUEST_ID  NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_GL_FORMAT
(
  CHART_GROUP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_SEQ_FLAG         NUMBER,
  GROUP_STYLE             VARCHAR2(255 BYTE),
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_GRP_EVNT_SET
(
  CHART_GROUP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_SET_NAME          VARCHAR2(40 BYTE)     DEFAULT ' '                   NOT NULL,
  ZONE                    NUMBER,
  EVENT_SET_SEQ           NUMBER,
  DISPLAY_NAME            VARCHAR2(32 BYTE),
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  PROCEDURE_TYPE_FLAG     NUMBER,
  ORDER_CATALOG_CD        NUMBER                DEFAULT 0                     NOT NULL,
  SYNONYM_ID              NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_GRP_EVNT_SUPPRESS
(
  CHART_EVNT_SUPPRESS_ID  NUMBER                DEFAULT 0                     NOT NULL,
  CHART_GROUP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_SET_NAME          VARCHAR2(40 BYTE)     DEFAULT ' '                   NOT NULL,
  ORDER_CATALOG_CD        NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_CD                NUMBER                DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD           NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_ZN_RESULT_COL
(
  CHART_GROUP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ZONE_SEQ                NUMBER                DEFAULT 0                     NOT NULL,
  COLUMN_SEQ              NUMBER                DEFAULT 0                     NOT NULL,
  DESCRIPTION             VARCHAR2(32 BYTE),
  COL_INDEX               NUMBER                DEFAULT 0,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_ZN_RESULT_COL_CDS
(
  CHART_GROUP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ZONE_SEQ                NUMBER                DEFAULT 0                     NOT NULL,
  COLUMN_SEQ              NUMBER                DEFAULT 0                     NOT NULL,
  NORMALCY_CD             NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CNT_DCP_INTERP_STATE
(
  CNT_DCP_INTERP_STATE_ID    NUMBER             DEFAULT 0                     NOT NULL,
  CNT_DCP_INTERP_ID          NUMBER             DEFAULT 0                     NOT NULL,
  DCP_INTERP_UID             VARCHAR2(100 BYTE) DEFAULT ' ' NOT NULL,
  FLAGS                      NUMBER             DEFAULT 0                     NOT NULL,
  INPUT_ASSAY_UID            VARCHAR2(100 BYTE) DEFAULT ' ' NOT NULL,
  AR_UID                     VARCHAR2(100 BYTE) DEFAULT ' ' NOT NULL,
  NOMENCLATURE_ID            NUMBER             DEFAULT 0                     NOT NULL,
  NUMERIC_HIGH               NUMBER             DEFAULT 0                     NOT NULL,
  NUMERIC_LOW                NUMBER             DEFAULT 0                     NOT NULL,
  RESULTING_STATE            NUMBER             DEFAULT 0                     NOT NULL,
  RESULT_AR_UID              VARCHAR2(100 BYTE) DEFAULT ' ' NOT NULL,
  RESULT_NOMENCLATURE_ID     NUMBER             DEFAULT 0                     NOT NULL,
  RESULT_VALUE               NUMBER             DEFAULT 0                     NOT NULL,
  INTERP_STATE               NUMBER             DEFAULT 0                     NOT NULL,
  CNT_ALPHA_RESPONSE_KEY_ID  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CNT_DTA_RRF_R
(
  CNT_DTA_RRF_R_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  RRF_UID           VARCHAR2(100 BYTE)          DEFAULT ' '                   NOT NULL,
  TASK_ASSAY_UID    VARCHAR2(100 BYTE)          DEFAULT ' '                   NOT NULL,
  CNT_RRF_ID        NUMBER                      DEFAULT 0                     NOT NULL,
  CNT_DTA_ID        NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CNT_GRID
(
  CNT_GRID_ID         NUMBER                    DEFAULT 0                     NOT NULL,
  ROW_TASK_ASSAY_UID  VARCHAR2(100 BYTE)        DEFAULT ' '                   NOT NULL,
  COL_TASK_ASSAY_UID  VARCHAR2(100 BYTE)        DEFAULT ' '                   NOT NULL,
  INT_EVENT_CDUID     VARCHAR2(100 BYTE)        DEFAULT ' '                   NOT NULL,
  CNT_DTA_KEY_ID      NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  INPUT_DESCRIPTION   VARCHAR2(200 BYTE),
  INPUT_REF_SEQ       NUMBER,
  INT_EVENT_CD        NUMBER                    DEFAULT 0                     NOT NULL,
  CNT_INPUT_KEY_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  SECTION_UID         VARCHAR2(100 BYTE)        DEFAULT ' '                   NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CNT_INPUT
(
  CNT_INPUT_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  SECTION_UID          VARCHAR2(100 BYTE)       DEFAULT ' '                   NOT NULL,
  INPUT_DESCRIPTION    VARCHAR2(200 BYTE)       DEFAULT ' '                   NOT NULL,
  INPUT_REF_SEQ        NUMBER                   DEFAULT 0                     NOT NULL,
  PVC_NAME             VARCHAR2(32 BYTE)        DEFAULT ' '                   NOT NULL,
  NAME_VALUE_PREFS_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  DCP_INPUT_REF_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  PVC_VALUE            VARCHAR2(255 BYTE),
  MERGE_NAME           VARCHAR2(100 BYTE)       DEFAULT ' '                   NOT NULL,
  INPUT_SEQUENCE       NUMBER,
  TASK_ASSAY_UID       VARCHAR2(100 BYTE)       DEFAULT ' '                   NOT NULL,
  DTA_ACT_DISP         VARCHAR2(40 BYTE),
  EVENT_CDUID          VARCHAR2(100 BYTE)       DEFAULT ' '                   NOT NULL,
  EVENT_CD             NUMBER                   DEFAULT 0                     NOT NULL,
  CODE_VALUE_DISP      VARCHAR2(40 BYTE),
  COND_SECT_UID        VARCHAR2(100 BYTE)       DEFAULT ' '                   NOT NULL,
  CNT_SECTION_KEY2_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  CNT_INPUT_KEY_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  MERGE_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  MERGE_UID            VARCHAR2(100 BYTE)       DEFAULT ' '                   NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CODE_SET_DOMAIN
(
  REFERENCE       NUMBER                        DEFAULT 0                     NOT NULL,
  CODE_SET        NUMBER                        DEFAULT 0                     NOT NULL,
  FIELD_SEQUENCE  NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE COMMON_ALPHA_RESPONSES
(
  ACTIVITY_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  DISPLAY_SEQUENCE        NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_PROCESS_CD       NUMBER                DEFAULT 0,
  DISPLAY_TYPE_FLAG       NUMBER,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CONDITIONAL_DTA
(
  CONDITIONAL_DTA_ID       NUMBER               DEFAULT 0                     NOT NULL,
  PREV_CONDITIONAL_DTA_ID  NUMBER               DEFAULT 0                     NOT NULL,
  COND_EXPRESSION_ID       NUMBER               DEFAULT 0                     NOT NULL,
  CONDITIONAL_ASSAY_CD     NUMBER               DEFAULT 0                     NOT NULL,
  POSITION_CD              NUMBER               DEFAULT 0                     NOT NULL,
  LOCATION_CD              NUMBER               DEFAULT 0                     NOT NULL,
  GENDER_CD                NUMBER               DEFAULT 0                     NOT NULL,
  AGE_FROM_UNIT_CD         NUMBER               DEFAULT 0                     NOT NULL,
  AGE_FROM_NBR             NUMBER               DEFAULT 0                     NOT NULL,
  AGE_TO_UNIT_CD           NUMBER               DEFAULT 0                     NOT NULL,
  AGE_TO_NBR               NUMBER               DEFAULT 0                     NOT NULL,
  REQUIRED_IND             NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_IND               NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UNKNOWN_AGE_IND          NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE COND_EXPRESSION_COMP
(
  COND_EXPRESSION_COMP_ID       NUMBER          DEFAULT 0                     NOT NULL,
  PREV_COND_EXPRESSION_COMP_ID  NUMBER          DEFAULT 0                     NOT NULL,
  COND_EXPRESSION_ID            NUMBER          DEFAULT 0                     NOT NULL,
  TRIGGER_ASSAY_CD              NUMBER          DEFAULT 0                     NOT NULL,
  COND_COMP_NAME                VARCHAR2(30 BYTE) DEFAULT ' ' NOT NULL,
  RESULT_VALUE                  NUMBER          DEFAULT 0                     NOT NULL,
  OPERATOR_CD                   NUMBER          DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME            VARCHAR2(60 BYTE) DEFAULT ' ' NOT NULL,
  PARENT_ENTITY_ID              NUMBER          DEFAULT 0                     NOT NULL,
  REQUIRED_IND                  NUMBER          DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM           DATE            DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM           DATE            DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_IND                    NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE COST_ADJ
(
  COST_ADJ_ID           NUMBER                  DEFAULT 0                     NOT NULL,
  COST_ADJ_FLEX_ID      NUMBER                  DEFAULT 0                     NOT NULL,
  LOWER_THRESHOLD       FLOAT(126)              DEFAULT 0                     NOT NULL,
  UPPER_THRESHOLD       FLOAT(126)              DEFAULT 0                     NOT NULL,
  ADJUSTMENT_TYPE_FLAG  NUMBER                  DEFAULT 0                     NOT NULL,
  ADJUSTMENT_AMT        FLOAT(126)              DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CS_COMPONENT
(
  CATALOG_CD                     NUMBER         DEFAULT 0                     NOT NULL,
  COMP_SEQ                       NUMBER         DEFAULT 0                     NOT NULL,
  COMP_TYPE_CD                   NUMBER         DEFAULT 0                     NOT NULL,
  COMP_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID                   NUMBER         DEFAULT 0                     NOT NULL,
  REQUIRED_IND                   NUMBER,
  INCLUDE_EXCLUDE_IND            NUMBER,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  COMP_LABEL                     VARCHAR2(255 BYTE),
  ORDER_SENTENCE_ID              NUMBER         DEFAULT 0                     NOT NULL,
  LINKED_DATE_COMP_SEQ           NUMBER,
  VARIANCE_FORMAT_ID             NUMBER         DEFAULT 0                     NOT NULL,
  PARENT_COMP_SEQ                NUMBER,
  CP_ROW_CAT_CD                  NUMBER         DEFAULT 0                     NOT NULL,
  CP_COL_CAT_CD                  NUMBER         DEFAULT 0                     NOT NULL,
  OUTCOME_PAR_COMP_SEQ           NUMBER,
  COMP_TYPE_MEAN                 VARCHAR2(15 BYTE),
  INDEX_TYPE_CD                  NUMBER         DEFAULT 0,
  ORD_COM_TEMPLATE_LONG_TEXT_ID  NUMBER         DEFAULT 0,
  COMP_MASK                      NUMBER,
  COMP_REFERENCE                 VARCHAR2(255 BYTE),
  LOCKDOWN_DETAILS_FLAG          NUMBER         DEFAULT 0,
  AV_OPTIONAL_INGREDIENT_IND     NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_ORDER_CATEGORY_R
(
  CV_ORDER_CATEGORY_R_ID  NUMBER                DEFAULT 0                     NOT NULL,
  CV_ORDER_CATEGORY_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CATALOG_CD              NUMBER                DEFAULT 0                     NOT NULL,
  DETAIL_TXT              VARCHAR2(255 BYTE),
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_RESPONSE
(
  RESPONSE_ID             NUMBER                DEFAULT 0                     NOT NULL,
  FIELD_TYPE              VARCHAR2(1 BYTE),
  RESPONSE_INTERNAL_NAME  VARCHAR2(255 BYTE),
  A1                      VARCHAR2(100 BYTE),
  A2                      VARCHAR2(50 BYTE),
  A3                      VARCHAR2(50 BYTE),
  A4                      VARCHAR2(50 BYTE),
  A5                      VARCHAR2(50 BYTE),
  XREF_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_REQ                NUMBER,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APP                NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  FIELD_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID         NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_STEP_REF
(
  TASK_ASSAY_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  STEP_LEVEL_FLAG      NUMBER                   DEFAULT 0                     NOT NULL,
  DOC_TYPE_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  DOC_ID_STR           VARCHAR2(255 BYTE),
  ACTIVITY_SUBTYPE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  SCHEDULE_IND         NUMBER,
  PROC_STATUS_CD       NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  STUDY_RELTN_FLAG     NUMBER,
  STEP_TYPE_CD         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_XREF_VALIDATION
(
  XREF_VALIDATION_ID      NUMBER                DEFAULT 0                     NOT NULL,
  XREF_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  RESPONSE_ID             NUMBER                DEFAULT 0                     NOT NULL,
  CHILD_XREF_ID           NUMBER                DEFAULT 0                     NOT NULL,
  RLTNSHIP_FLAG           NUMBER,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  CHILD_RESPONSE_ID       NUMBER                DEFAULT 0                     NOT NULL,
  REQD_FLAG               NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APP                NUMBER,
  UPDT_REQ                NUMBER,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  OFFSET_NBR              FLOAT(126)            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CYTO_REPORT_CONTROL
(
  CATALOG_CD                 NUMBER             DEFAULT 0                     NOT NULL,
  REPORT_TYPE_FLAG           NUMBER,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  ENDOCERV_TASK_ASSAY_CD     NUMBER             DEFAULT 0                     NOT NULL,
  DIAGNOSIS_TASK_ASSAY_CD    NUMBER             DEFAULT 0                     NOT NULL,
  ADEQUACY_TASK_ASSAY_CD     NUMBER             DEFAULT 0                     NOT NULL,
  CLIN_INFO_TASK_ASSAY_CD    NUMBER             DEFAULT 0                     NOT NULL,
  ADEQ_REASON_TASK_ASSAY_CD  NUMBER             DEFAULT 0                     NOT NULL,
  ACTION_TASK_ASSAY_CD       NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CYTO_STANDARD_RPT
(
  STANDARD_RPT_ID   NUMBER                      DEFAULT 0                     NOT NULL,
  CATALOG_CD        NUMBER                      DEFAULT 0                     NOT NULL,
  SHORT_DESC        CHAR(5 BYTE),
  DESCRIPTION       VARCHAR2(40 BYTE),
  HOT_KEY_SEQUENCE  NUMBER,
  ACTIVE_IND        NUMBER,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CYTO_STANDARD_RPT_R
(
  STANDARD_RPT_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD    NUMBER                       DEFAULT 0                     NOT NULL,
  RESULT_CD        NUMBER                       DEFAULT 0                     NOT NULL,
  RESULT_TEXT      LONG,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID  NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DATA_MAP
(
  SERVICE_RESOURCE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD           NUMBER                DEFAULT 0                     NOT NULL,
  DATA_MAP_TYPE_FLAG      NUMBER,
  RESULT_ENTRY_FORMAT     NUMBER,
  MAX_DIGITS              NUMBER,
  MIN_DIGITS              NUMBER,
  MIN_DECIMAL_PLACES      NUMBER,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DM2_MIG_SEQ_ID          NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_BV_LV_ELEM_RELTN
(
  DA_BV_LV_ELEM_RELTN_ID  NUMBER                DEFAULT 0                     NOT NULL,
  DA_BUS_VIEW_ID          NUMBER                DEFAULT 0                     NOT NULL,
  DA_LOGICAL_VIEW_ID      NUMBER                DEFAULT 0                     NOT NULL,
  DA_ELEMENT_ID           NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_CALC_ELEM_RELTN
(
  DA_CALC_ELEM_RELTN_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  PARENT_ELEMENT_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  CHILD_ELEMENT_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DD_REF_EMR_CONTENT
(
  DD_REF_EMR_CONTENT_ID       NUMBER            DEFAULT 0                     NOT NULL,
  DD_REF_FILTER_ID            NUMBER            DEFAULT 0                     NOT NULL,
  DD_REF_FORMAT_ID            NUMBER            DEFAULT 0                     NOT NULL,
  EMR_CONTENT_TYPE_CD         NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  DESCRIPTION_TXT             VARCHAR2(255 BYTE),
  TITLE_TXT                   VARCHAR2(255 BYTE),
  ACTIVE_IND                  NUMBER            DEFAULT 0                     NOT NULL,
  REF_CONTENT_INSTANCE_IDENT  VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  SOURCE_TXT                  VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DEPT_DUP_CHECK
(
  CATALOG_CD              NUMBER                DEFAULT 0                     NOT NULL,
  DUP_CATALOG_CD          NUMBER                DEFAULT 0                     NOT NULL,
  PRIORITY_CD             NUMBER                DEFAULT 0                     NOT NULL,
  MINUTES_AHEAD           NUMBER,
  MINUTES_BEHIND          NUMBER,
  DUP_QUANTITY            NUMBER,
  ACTIVE_IND              NUMBER,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  MNEMONIC_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DIFFERENTIAL_REF
(
  DIF_REF_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  CATALOG_CD             NUMBER                 DEFAULT 0                     NOT NULL,
  OPT                    VARCHAR2(20 BYTE),
  OPT_KEY                VARCHAR2(20 BYTE),
  DEFAULT_COUNT          NUMBER,
  NORMALIZE_IND          NUMBER,
  SUBTRACT_KEY           CHAR(1 BYTE),
  AUTO_CORRECT_IND       NUMBER,
  AUTO_CORRECT_VALUE     NUMBER,
  AUTO_CORRECT_ASSAY_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  COUNT_LABEL            VARCHAR2(30 BYTE),
  MORPH_LABEL            VARCHAR2(30 BYTE),
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  AUTO_CRCT_CMT          VARCHAR2(200 BYTE),
  AUTO_CRCT_CMT_IND      NUMBER,
  AUTO_CORRECT_VERF_IND  NUMBER                 DEFAULT 0                     NOT NULL,
  INSTR_LABEL            VARCHAR2(30 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DIFFERENTIAL_REF_ASSAY
(
  DIF_REF_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  DISPLAY_NAME           VARCHAR2(10 BYTE),
  PROC_TYPE_FLAG         NUMBER,
  COUNT_KEY              CHAR(1 BYTE),
  ZERO_IND               NUMBER,
  NON_TOTAL_IND          NUMBER,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  POSITION_SEQ           NUMBER,
  NON_TOTAL_TRIGGER_IND  NUMBER                 DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DRUG_CLASS_INT_CSTM_ENTITY_R
(
  DRUG_CLASS_INT_CSTM_ENT_R_ID  NUMBER          DEFAULT 0                     NOT NULL,
  DCP_ENTITY_RELTN_ID           NUMBER          DEFAULT 0                     NOT NULL,
  DRUG_CLASS_INT_CUSTOM_ID      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DUP_CHECKING
(
  CATALOG_CD                   NUMBER           DEFAULT 0                     NOT NULL,
  DUP_CHECK_SEQ                NUMBER           DEFAULT 0                     NOT NULL,
  MIN_BEHIND                   NUMBER,
  MIN_BEHIND_ACTION_CD         NUMBER           DEFAULT 0                     NOT NULL,
  MIN_AHEAD                    NUMBER,
  MIN_AHEAD_ACTION_CD          NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  EXACT_HIT_ACTION_CD          NUMBER           DEFAULT 0                     NOT NULL,
  OUTPAT_EXACT_HIT_ACTION_CD   NUMBER           DEFAULT 0,
  OUTPAT_FLEX_IND              NUMBER           DEFAULT 0,
  OUTPAT_MIN_AHEAD             NUMBER           DEFAULT 0,
  OUTPAT_MIN_AHEAD_ACTION_CD   NUMBER           DEFAULT 0,
  OUTPAT_MIN_BEHIND            NUMBER           DEFAULT 0,
  OUTPAT_MIN_BEHIND_ACTION_CD  NUMBER           DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_ABN_DATA
(
  ABN_ATTR_ID             NUMBER                DEFAULT 0                     NOT NULL,
  EEM_FILE_ID             NUMBER                DEFAULT 0                     NOT NULL,
  KEY_FIELD               NUMBER                DEFAULT 0                     NOT NULL,
  ATTR_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  ATTR_TYPE_MEANING       VARCHAR2(12 BYTE),
  SEQ_NBR                 NUMBER                DEFAULT 0                     NOT NULL,
  STRING_VALUE            VARCHAR2(255 BYTE),
  DOUBLE_VALUE            NUMBER                DEFAULT 0,
  DATE_VALUE              DATE,
  UNITS_CD                NUMBER                DEFAULT 0                     NOT NULL,
  UNITS_MEANING           VARCHAR2(12 BYTE),
  PARENT_TABLE            VARCHAR2(30 BYTE),
  PARENT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_MEANING          VARCHAR2(12 BYTE),
  COMP_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  COMP_TYPE_MEANING       VARCHAR2(12 BYTE),
  DATA_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  DATA_TYPE_MEANING       VARCHAR2(12 BYTE),
  VOCABULARY_CD           NUMBER                DEFAULT 0                     NOT NULL,
  VOCABULARY_MEANING      VARCHAR2(12 BYTE),
  BEG_SEQ                 NUMBER                DEFAULT 1                     NOT NULL,
  END_SEQ                 NUMBER                DEFAULT 1                     NOT NULL,
  BEG_IDENTIFIER          VARCHAR2(50 BYTE),
  END_IDENTIFIER          VARCHAR2(50 BYTE),
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_ABN_RULE
(
  ABN_RULE_ID             NUMBER                DEFAULT 0                     NOT NULL,
  EEM_FILE_ID             NUMBER                DEFAULT 0                     NOT NULL,
  PROC_IDENT              VARCHAR2(50 BYTE)     DEFAULT ' '                   NOT NULL,
  DIAG_BEG_IDENT          VARCHAR2(50 BYTE)     DEFAULT ' '                   NOT NULL,
  DIAG_END_IDENT          VARCHAR2(50 BYTE)     DEFAULT ' '                   NOT NULL,
  PROC_VOCABULARY_CD      NUMBER                DEFAULT 0                     NOT NULL,
  DIAG_VOCABULARY_CD      NUMBER                DEFAULT 0                     NOT NULL,
  KEY_FIELD               NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  BEG_SEQ                 NUMBER                DEFAULT 0                     NOT NULL,
  END_SEQ                 NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_BENEFIT_QUAL
(
  BENEFIT_QUAL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  BENEFIT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  QUALIFIER_CD            NUMBER                DEFAULT 0                     NOT NULL,
  SEQ_NBR                 NUMBER                DEFAULT 0                     NOT NULL,
  DATA_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  DOUBLE_VALUE            NUMBER                DEFAULT 0                     NOT NULL,
  STRING_VALUE            VARCHAR2(255 BYTE),
  DATE_VALUE              DATE,
  PARENT_ENTITY_NAME      VARCHAR2(30 BYTE),
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  FROM_UNITS              NUMBER                DEFAULT 0                     NOT NULL,
  FROM_UNITS_CD           NUMBER                DEFAULT 0                     NOT NULL,
  TO_UNITS                NUMBER                DEFAULT 0                     NOT NULL,
  TO_UNITS_CD             NUMBER                DEFAULT 0                     NOT NULL,
  INC_EXC_CD              NUMBER                DEFAULT 0                     NOT NULL,
  INC_EXC_MEANING         VARCHAR2(12 BYTE),
  VOCABULARY_CD           NUMBER                DEFAULT 0                     NOT NULL,
  BEG_IDENT               VARCHAR2(50 BYTE),
  BEG_NOMEN_ID            NUMBER                DEFAULT 0                     NOT NULL,
  END_IDENT               VARCHAR2(50 BYTE),
  END_NOMEN_ID            NUMBER                DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_ENTITY_NTWK_RELTN
(
  ENTITY_NTWK_RELTN_ID    NUMBER                DEFAULT 0                     NOT NULL,
  NETWORK_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(32 BYTE)     DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_ENTITY_PROV_TAX_RELTN
(
  EEM_ENTITY_PROV_TAX_RELTN_ID  NUMBER          DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME            VARCHAR2(32 BYTE),
  PARENT_ENTITY_ID              NUMBER          DEFAULT 0                     NOT NULL,
  EEM_PROV_TAX_RELTN_ID         NUMBER          DEFAULT 0                     NOT NULL,
  SEQ_NBR                       NUMBER          DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM           DATE,
  END_EFFECTIVE_DT_TM           DATE,
  LONG_TEXT_ID                  NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_IND                    NUMBER,
  ACTIVE_STATUS_CD              NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM           DATE,
  ACTIVE_STATUS_PRSNL_ID        NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_SERVICE_LIST
(
  SERVICE_LIST_ID         NUMBER                DEFAULT 0                     NOT NULL,
  SERVICE_TYPE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  SEQ_NBR                 NUMBER                DEFAULT 0                     NOT NULL,
  TYPE_INC_EXC_CD         NUMBER                DEFAULT 0                     NOT NULL,
  TYPE_INC_EXC_MEANING    VARCHAR2(12 BYTE),
  TYPE_VOCAB_CD           NUMBER                DEFAULT 0                     NOT NULL,
  TYPE_BEG_NOMEN_ID       NUMBER                DEFAULT 0                     NOT NULL,
  TYPE_BEG_IDENT          VARCHAR2(50 BYTE),
  TYPE_END_NOMEN_ID       NUMBER                DEFAULT 0                     NOT NULL,
  TYPE_END_IDENT          VARCHAR2(50 BYTE),
  CAUSE_INC_EXC_CD        NUMBER                DEFAULT 0                     NOT NULL,
  CAUSE_INC_EXC_MEANING   VARCHAR2(12 BYTE),
  CAUSE_VOCAB_CD          NUMBER                DEFAULT 0                     NOT NULL,
  CAUSE_BEG_NOMEN_ID      NUMBER                DEFAULT 0                     NOT NULL,
  CAUSE_BEG_IDENT         VARCHAR2(50 BYTE),
  CAUSE_END_NOMEN_ID      NUMBER                DEFAULT 0                     NOT NULL,
  CAUSE_END_IDENT         VARCHAR2(50 BYTE),
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EXAM_REASON
(
  CATALOG_CD      NUMBER                        DEFAULT 0                     NOT NULL,
  EXAM_REASON_ID  NUMBER                        DEFAULT 0                     NOT NULL,
  SEQUENCE        NUMBER                        DEFAULT 0                     NOT NULL,
  ICD9_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FILM_USAGE
(
  CATALOG_CD    NUMBER                          DEFAULT 0                     NOT NULL,
  FILM_TYPE_CD  NUMBER                          DEFAULT 0                     NOT NULL,
  FILM_SIZE_CD  NUMBER                          DEFAULT 0                     NOT NULL,
  STANDARD_QTY  NUMBER,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FORM_ASSOCIATION
(
  FORM_ASSOCIATION_ID    NUMBER                 DEFAULT 0                     NOT NULL,
  SEQUENCE_NBR           NUMBER                 DEFAULT 0                     NOT NULL,
  REFERENCE_TASK_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  CATALOG_CD             NUMBER                 DEFAULT 0                     NOT NULL,
  INPUT_FORM_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  ASSOCIATION_TYPE_FLAG  NUMBER,
  ORDER_TYPE_FLAG        NUMBER,
  LOCATION_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE GROUP_DEFINITION
(
  GROUP_CD                   NUMBER             DEFAULT 0                     NOT NULL,
  GROUP_VERSION_NBR          NUMBER             DEFAULT 0                     NOT NULL,
  GROUP_DEF_SEQ              NUMBER             DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD              NUMBER             DEFAULT 0                     NOT NULL,
  ONLINE_ITEM_VERSION_NBR    NUMBER             DEFAULT 0                     NOT NULL,
  REQUIRED_FLAG              NUMBER,
  FIELD_PROMPT               VARCHAR2(100 BYTE),
  REPEAT_IND                 NUMBER,
  COLUMN_HEADING             VARCHAR2(100 BYTE),
  GROUP_CMPNT_LEFT           NUMBER,
  GROUP_CMPNT_TOP            NUMBER,
  CREATE_DT_TM               DATE,
  CREATE_ID                  NUMBER             DEFAULT 0,
  CREATE_TASK                NUMBER,
  CREATE_APPLCTX             NUMBER,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  ONLINE_ITEM_DEFINITION_ID  NUMBER             DEFAULT 0                     NOT NULL,
  GROUP_REFERENCE_ID         NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HIM_HAC_CRITERIA
(
  HIM_HAC_CRITERIA_ID          NUMBER           DEFAULT 0                     NOT NULL,
  HAC_NOMENCLATURE_ID          NUMBER           DEFAULT 0                     NOT NULL,
  HAC_PRIMARY_ONLY_IND         NUMBER           DEFAULT 0                     NOT NULL,
  COMPARE_PX_PRIMARY_ONLY_IND  NUMBER           DEFAULT 0                     NOT NULL,
  COMPARE_PX_NOMEN_ID          NUMBER           DEFAULT 0                     NOT NULL,
  COMPARE_DX_PRIMARY_ONLY_IND  NUMBER           DEFAULT 0                     NOT NULL,
  COMPARE_DX_NOMEN_ID          NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_AB_SCREEN_HISTORY_MAP
(
  CATALOG_CD          NUMBER                    DEFAULT 0                     NOT NULL,
  SEQ_NUMBER          NUMBER                    DEFAULT 0                     NOT NULL,
  T_CELL_PRA_DTA_CD   NUMBER                    DEFAULT 0                     NOT NULL,
  B_CELL_PRA_DTA_CD   NUMBER                    DEFAULT 0                     NOT NULL,
  METHODOLOGY_DTA_CD  NUMBER                    DEFAULT 0                     NOT NULL,
  DILUTION_DTA_CD     NUMBER                    DEFAULT 0                     NOT NULL,
  METHODOLOGY_NOM_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  DILUTION_NOM_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  REACTION_DTA_CD     NUMBER                    DEFAULT 0                     NOT NULL,
  OD_DTA_CD           NUMBER                    DEFAULT 0                     NOT NULL,
  OD_RATIO_DTA_CD     NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_AB_SPEC_MAP
(
  CATALOG_CD       NUMBER                       DEFAULT 0                     NOT NULL,
  AB_DTA_CD        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  AB_HIST_SEQ_NBR  NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_NOMEN_CODE_R
(
  NOMENCLATURE_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  RELATED_CD       NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_XM_HISTORY_MAP
(
  CATALOG_CD               NUMBER               DEFAULT 0                     NOT NULL,
  XM_TYPE_DTA_CD           NUMBER               DEFAULT 0                     NOT NULL,
  XM_TYPE_NOM_ID           NUMBER               DEFAULT 0                     NOT NULL,
  T_CELL_RESULT_DTA_CD     NUMBER               DEFAULT 0                     NOT NULL,
  B_CELL_RESULT_DTA_CD     NUMBER               DEFAULT 0                     NOT NULL,
  TB_CELL_RESULT_DTA_CD    NUMBER               DEFAULT 0                     NOT NULL,
  MONO_CELL_RESULT_DTA_CD  NUMBER               DEFAULT 0                     NOT NULL,
  INTERPRETATION_DTA_CD    NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HM_EXPECT_SAT
(
  EXPECT_SAT_ID           NUMBER                DEFAULT 0                     NOT NULL,
  EXPECT_SAT_NAME         VARCHAR2(250 BYTE),
  EXPECT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_TYPE_FLAG        NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_NBR              FLOAT(126)            DEFAULT 0                     NOT NULL,
  SEQ_NBR                 NUMBER                DEFAULT 0                     NOT NULL,
  ENTRY_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  ENTRY_NBR               FLOAT(126)            DEFAULT 0                     NOT NULL,
  LAST_ACTION_SEQ         NUMBER                DEFAULT 0                     NOT NULL,
  SATISFIER_MEANING       VARCHAR2(250 BYTE),
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  PENDING_DURATION        NUMBER                DEFAULT 0                     NOT NULL,
  SATISFIED_DURATION      NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_VALUE            VARCHAR2(255 BYTE),
  ENTRY_VALUE             VARCHAR2(255 BYTE),
  NOMENCLATURE_ID         NUMBER                DEFAULT 0,
  ENTRY_ID                NUMBER                DEFAULT 0,
  PARENT_ENTITY_NAME      VARCHAR2(30 BYTE)     DEFAULT ' ',
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0,
  ENTRY_NAME              VARCHAR2(30 BYTE)     DEFAULT ' '
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HM_EXPECT_SAT_HIST
(
  EXPECT_SAT_ID           NUMBER                DEFAULT 0                     NOT NULL,
  ACTION_SEQ              NUMBER                DEFAULT 0                     NOT NULL,
  ACTION_TYPE_FLAG        NUMBER                DEFAULT 1                     NOT NULL,
  ACTION_DT_TM            DATE                  DEFAULT SYSDATE               NOT NULL,
  EXPECT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  EXPECT_SAT_NAME         VARCHAR2(250 BYTE),
  PARENT_TYPE_FLAG        NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_NBR              FLOAT(126)            DEFAULT 0                     NOT NULL,
  SEQ_NBR                 NUMBER                DEFAULT 0                     NOT NULL,
  ENTRY_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  ENTRY_NBR               FLOAT(126)            DEFAULT 0                     NOT NULL,
  SATISFIER_MEANING       VARCHAR2(250 BYTE),
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  PENDING_DURATION        NUMBER                DEFAULT 0                     NOT NULL,
  SATISFIED_DURATION      NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  SAT_STATUS_IND          NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_VALUE            VARCHAR2(255 BYTE),
  ENTRY_VALUE             VARCHAR2(255 BYTE),
  NOMENCLATURE_ID         NUMBER                DEFAULT 0,
  EXPECT_SAT_HIST_ID      NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0,
  ENTRY_NAME              VARCHAR2(30 BYTE)     DEFAULT ' ',
  ENTRY_ID                NUMBER                DEFAULT 0,
  PARENT_ENTITY_NAME      VARCHAR2(30 BYTE)     DEFAULT ' '
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INPUT_FORM_DEFINITION
(
  INPUT_FORM_CD              NUMBER             DEFAULT 0                     NOT NULL,
  INPUT_FORM_VERSION_NBR     NUMBER             DEFAULT 0                     NOT NULL,
  INPUT_FORM_DEF_SEQ         NUMBER             DEFAULT 0                     NOT NULL,
  GROUP_CD                   NUMBER             DEFAULT 0                     NOT NULL,
  GROUP_VERSION_NBR          NUMBER,
  TASK_ASSAY_CD              NUMBER             DEFAULT 0                     NOT NULL,
  ONLINE_ITEM_VERSION_NBR    NUMBER,
  COLUMN_HEADING             VARCHAR2(100 BYTE),
  REQUIRED_FLAG              NUMBER,
  FIELD_PROMPT               VARCHAR2(100 BYTE),
  CMPNT_REPEAT_IND           NUMBER,
  CMPNT_LEFT                 NUMBER,
  CMPNT_TOP                  NUMBER,
  CMPNT_HEIGHT               NUMBER,
  CMPNT_WIDTH                NUMBER,
  CREATE_DT_TM               DATE,
  CREATE_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  CREATE_TASK                NUMBER,
  CREATE_APPLCTX             NUMBER,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  PROMPT_LEFT                NUMBER,
  PROMPT_TOP                 NUMBER,
  ONLINE_ITEM_DEFINITION_ID  NUMBER             DEFAULT 0                     NOT NULL,
  GROUP_REFERENCE_ID         NUMBER             DEFAULT 0                     NOT NULL,
  INPUT_FORM_REFERENCE_ID    NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LH_ABS_ED_METRICS
(
  LH_ABS_ED_METRICS_ID       NUMBER             DEFAULT 0                     NOT NULL,
  HEALTH_SYSTEM_ID           NUMBER             DEFAULT 0                     NOT NULL,
  HEALTH_SYSTEM_SOURCE_ID    NUMBER             DEFAULT 0                     NOT NULL,
  ENCNTR_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  ORG_MRN_TXT                VARCHAR2(50 BYTE),
  COMM_MRN_TXT               VARCHAR2(50 BYTE),
  FINANCIAL_NBR_TXT          VARCHAR2(50 BYTE),
  D_PERSON_ID                NUMBER             DEFAULT 0                     NOT NULL,
  D_ADMIT_FACILITY_ID        NUMBER             DEFAULT 0                     NOT NULL,
  D_ADMIT_BUILDING_ID        NUMBER             DEFAULT 0                     NOT NULL,
  D_ADMIT_NURSE_UNIT_ID      NUMBER             DEFAULT 0                     NOT NULL,
  D_DISCHARGE_FACILITY_ID    NUMBER             DEFAULT 0                     NOT NULL,
  D_DISCHARGE_BUILDING_ID    NUMBER             DEFAULT 0                     NOT NULL,
  D_DISCHARGE_NURSE_UNIT_ID  NUMBER             DEFAULT 0                     NOT NULL,
  D_ENCNTR_TYPE_ID           NUMBER             DEFAULT 0                     NOT NULL,
  D_ADMIT_SRC_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_ADMIT_TYPE_ID            NUMBER             DEFAULT 0                     NOT NULL,
  D_MED_SERVICE_ID           NUMBER             DEFAULT 0                     NOT NULL,
  D_ATTEND_PRSNL_ID          NUMBER             DEFAULT 0                     NOT NULL,
  ADMIT_DT_TM                DATE,
  ADMIT_UTC_DT_TM            DATE,
  DISCHARGE_DT_TM            DATE,
  DISCHARGE_UTC_DT_TM        DATE,
  PARTITION_DT_TM            DATE,
  FIRST_PROCESS_DT_TM        DATE,
  LAST_PROCESS_DT_TM         DATE,
  UPDT_DT_TM                 DATE,
  UPDT_CNT                   NUMBER,
  UPDT_TASK                  VARCHAR2(50 BYTE),
  UPDT_SOURCE                VARCHAR2(50 BYTE),
  EXTRACT_DT_TM              DATE,
  ACTIVE_IND                 NUMBER,
  D_METRIC_1_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_2_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_3_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_4_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_5_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_6_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_7_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_8_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_9_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_10_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_11_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_12_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_13_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_14_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_15_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_16_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_17_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_18_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_19_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_20_ID             NUMBER             DEFAULT 0                     NOT NULL,
  PRIN_DIAGNOSIS             VARCHAR2(10 BYTE),
  PRIN_PROCEDURE             VARCHAR2(10 BYTE),
  PRIN_PROCEDURE_DATE_TXT    VARCHAR2(10 BYTE),
  PRIN_PROCEDURE_DT_TM       DATE,
  PRIN_PROCEDURE_UTC_DT_TM   DATE,
  OTH_DIAGNOSIS_LIST         VARCHAR2(250 BYTE),
  OTH_PROCEDURE_LIST         VARCHAR2(250 BYTE),
  OTH_PROCEDURE_DATES_LIST   VARCHAR2(275 BYTE),
  PAYMENT_SOURCE_FLAG        NUMBER,
  ED_PATIENT_IND             NUMBER,
  ED_OBSERVATION_IND         NUMBER,
  ED_DEPART_DATE_TXT         VARCHAR2(10 BYTE),
  ED_DEPART_TIME_TXT         VARCHAR2(5 BYTE),
  ED_DEPART_DT_TM            DATE,
  ED_DEPART_UTC_DT_TM        DATE,
  SAMPLE_IND                 NUMBER,
  PHYSICIAN_1_TXT            VARCHAR2(50 BYTE),
  PHYSICIAN_2_TXT            VARCHAR2(50 BYTE),
  ARRIVAL_DATE_TXT           VARCHAR2(10 BYTE),
  ARRIVAL_TIME_TXT           VARCHAR2(5 BYTE),
  ARRIVAL_DT_TM              DATE,
  ARRIVAL_UTC_DT_TM          DATE,
  DECISION_ADMIT_DATE_TXT    VARCHAR2(10 BYTE),
  DECISION_ADMIT_TIME_TXT    VARCHAR2(5 BYTE),
  DECISION_ADMIT_DT_TM       DATE,
  DECISION_ADMIT_UTC_DT_TM   DATE,
  MENTAL_DISORDER_IND        NUMBER,
  LOGICAL_DOMAIN_ID          NUMBER             DEFAULT 0                     NOT NULL,
  REJECT_1_IND               NUMBER,
  REJECT_2_IND               NUMBER,
  EXCLUDE_1_IND              NUMBER,
  EXCLUDE_2_IND              NUMBER,
  ED1A_IND                   NUMBER,
  ED1B_IND                   NUMBER,
  ED1C_IND                   NUMBER,
  ED1D_IND                   NUMBER,
  ED2A_IND                   NUMBER,
  ED2B_IND                   NUMBER,
  ED2C_IND                   NUMBER,
  ED1_MEASUREMENT_VALUE      NUMBER,
  ED2_MEASUREMENT_VALUE      NUMBER,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LH_ABS_STROKE_METRICS
(
  LH_ABS_STROKE_METRICS_ID   NUMBER             DEFAULT 0                     NOT NULL,
  HEALTH_SYSTEM_ID           NUMBER             DEFAULT 0                     NOT NULL,
  HEALTH_SYSTEM_SOURCE_ID    NUMBER             DEFAULT 0                     NOT NULL,
  ENCNTR_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  ORG_MRN_TXT                VARCHAR2(50 BYTE),
  COMM_MRN_TXT               VARCHAR2(50 BYTE),
  FINANCIAL_NBR_TXT          VARCHAR2(50 BYTE),
  D_PERSON_ID                NUMBER             DEFAULT 0                     NOT NULL,
  D_ADMIT_FACILITY_ID        NUMBER             DEFAULT 0                     NOT NULL,
  D_ADMIT_BUILDING_ID        NUMBER             DEFAULT 0                     NOT NULL,
  D_ADMIT_NURSE_UNIT_ID      NUMBER             DEFAULT 0                     NOT NULL,
  D_DISCHARGE_FACILITY_ID    NUMBER             DEFAULT 0                     NOT NULL,
  D_DISCHARGE_BUILDING_ID    NUMBER             DEFAULT 0                     NOT NULL,
  D_DISCHARGE_NURSE_UNIT_ID  NUMBER             DEFAULT 0                     NOT NULL,
  D_ENCNTR_TYPE_ID           NUMBER             DEFAULT 0                     NOT NULL,
  D_ADMIT_SRC_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_ADMIT_TYPE_ID            NUMBER             DEFAULT 0                     NOT NULL,
  D_MED_SERVICE_ID           NUMBER             DEFAULT 0                     NOT NULL,
  D_ATTEND_PRSNL_ID          NUMBER             DEFAULT 0                     NOT NULL,
  ADMIT_DT_TM                DATE,
  ADMIT_UTC_DT_TM            DATE,
  DISCHARGE_DT_TM            DATE,
  DISCHARGE_UTC_DT_TM        DATE,
  PARTITION_DT_TM            DATE,
  FIRST_PROCESS_DT_TM        DATE,
  LAST_PROCESS_DT_TM         DATE,
  UPDT_DT_TM                 DATE,
  UPDT_CNT                   NUMBER,
  UPDT_TASK                  VARCHAR2(50 BYTE),
  UPDT_SOURCE                VARCHAR2(50 BYTE),
  EXTRACT_DT_TM              DATE,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_1_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_2_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_3_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_4_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_5_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_6_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_7_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_8_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_9_ID              NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_10_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_11_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_12_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_13_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_14_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_15_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_16_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_17_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_18_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_19_ID             NUMBER             DEFAULT 0                     NOT NULL,
  D_METRIC_20_ID             NUMBER             DEFAULT 0                     NOT NULL,
  PRIN_DIAGNOSIS             VARCHAR2(10 BYTE),
  PRIN_PROCEDURE             VARCHAR2(10 BYTE),
  PRIN_PROCEDURE_DATE_TXT    VARCHAR2(10 BYTE),
  PRIN_PROCEDURE_DT_TM       DATE,
  PRIN_PROCEDURE_UTC_DT_TM   DATE,
  OTH_DIAGNOSIS_LIST         VARCHAR2(250 BYTE),
  OTH_PROCEDURE_LIST         VARCHAR2(250 BYTE),
  OTH_PROCEDURE_DATES_LIST   VARCHAR2(275 BYTE),
  PAYMENT_SOURCE_FLAG        NUMBER,
  CLINICAL_TRIAL_IND         NUMBER,
  CMO_FLAG                   NUMBER,
  ARRIVAL_DATE_TXT           VARCHAR2(10 BYTE),
  ARRIVAL_TIME_TXT           VARCHAR2(5 BYTE),
  ARRIVAL_DT_TM              DATE,
  ARRIVAL_UTC_DT_TM          DATE,
  DISC_DISP_FLAG             NUMBER,
  ELECTIVE_CAROTID_IND       NUMBER,
  SAMPLE_IND                 NUMBER,
  PHYSICIAN_1_TXT            VARCHAR2(50 BYTE),
  PHYSICIAN_2_TXT            VARCHAR2(50 BYTE),
  VTE_PROPHYLAXIS_MASK       NUMBER,
  VTE_PROPHYLAXIS_DATE_TXT   VARCHAR2(10 BYTE),
  VTE_PROPHYLAXIS_DT_TM      DATE,
  VTE_PROPHYLAXIS_UTC_DT_TM  DATE,
  NO_VTE_PROPH_REASON_IND    NUMBER,
  ED_PATIENT_IND             NUMBER,
  LAST_KNOWN_WELL_IND        NUMBER,
  LAST_KNOWN_WELL_DATE_TXT   VARCHAR2(10 BYTE),
  LAST_KNOWN_WELL_TIME_TXT   VARCHAR2(5 BYTE),
  LAST_KNOWN_WELL_DT_TM      DATE,
  LAST_KNOWN_WELL_UTC_DT_TM  DATE,
  IV_THROM_IND               NUMBER,
  IV_THROM_DATE_TXT          VARCHAR2(10 BYTE),
  IV_THROM_TIME_TXT          VARCHAR2(5 BYTE),
  IV_THROM_DT_TM             DATE,
  IV_THROM_UTC_DT_TM         DATE,
  NO_IV_THROM_REASON_IND     NUMBER,
  TPA_ADMIN_IND              NUMBER,
  TPA_EOD2_IND               NUMBER,
  NO_TPA_EOD2_REASON_IND     NUMBER,
  ANTICOAG_DISC_IND          NUMBER,
  ATRIAL_FIB_FLUTTER_IND     NUMBER,
  NO_ANTICOAG_REASON_IND     NUMBER,
  ANTITHR_DISC_IND           NUMBER,
  NO_ANTITHR_REASON_IND      NUMBER,
  LIPID_LOWER_PRE_ARR_IND    NUMBER,
  STATIN_DISC_IND            NUMBER,
  NO_STATIN_REASON_IND       NUMBER,
  LDL_C_MEASURED_IND         NUMBER,
  LDL_C_GTE_100_IND          NUMBER,
  EDU_SIGNS_SYM_IND          NUMBER,
  EDU_RISK_IND               NUMBER,
  EDU_EMS_IND                NUMBER,
  EDU_FOLLOWUP_IND           NUMBER,
  EDU_DISCH_MEDS_IND         NUMBER,
  ASSESS_REHAB_IND           NUMBER,
  REJECT_1_IND               NUMBER,
  REJECT_2_IND               NUMBER,
  REJECT_3_IND               NUMBER,
  REJECT_4_IND               NUMBER,
  REJECT_5_IND               NUMBER,
  REJECT_6_IND               NUMBER,
  REJECT_8_IND               NUMBER,
  REJECT_10_IND              NUMBER,
  EXCLUDE_1_IND              NUMBER,
  EXCLUDE_2_IND              NUMBER,
  EXCLUDE_3_IND              NUMBER,
  EXCLUDE_4_IND              NUMBER,
  EXCLUDE_5_IND              NUMBER,
  EXCLUDE_6_IND              NUMBER,
  EXCLUDE_8_IND              NUMBER,
  EXCLUDE_10_IND             NUMBER,
  NUMERATOR_1_IND            NUMBER,
  NUMERATOR_2_IND            NUMBER,
  NUMERATOR_3_IND            NUMBER,
  NUMERATOR_4_IND            NUMBER,
  NUMERATOR_5_IND            NUMBER,
  NUMERATOR_6_IND            NUMBER,
  NUMERATOR_8_IND            NUMBER,
  NUMERATOR_10_IND           NUMBER,
  LOGICAL_DOMAIN_ID          NUMBER             DEFAULT 0                     NOT NULL,
  NUMERATOR_1_MU_IND         NUMBER,
  NUMERATOR_2_MU_IND         NUMBER,
  NUMERATOR_3_MU_IND         NUMBER,
  NUMERATOR_4_MU_IND         NUMBER,
  NUMERATOR_5_MU_IND         NUMBER,
  NUMERATOR_6_MU_IND         NUMBER,
  NUMERATOR_8_MU_IND         NUMBER,
  NUMERATOR_10_MU_IND        NUMBER,
  EXCLUDE_1_MU_IND           NUMBER,
  EXCLUDE_2_MU_IND           NUMBER,
  EXCLUDE_3_MU_IND           NUMBER,
  EXCLUDE_4_MU_IND           NUMBER,
  EXCLUDE_5_MU_IND           NUMBER,
  EXCLUDE_6_MU_IND           NUMBER,
  EXCLUDE_8_MU_IND           NUMBER,
  EXCLUDE_10_MU_IND          NUMBER,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LH_ABS_VTE_METRICS
(
  LH_ABS_VTE_METRICS_ID          NUMBER         DEFAULT 0                     NOT NULL,
  HEALTH_SYSTEM_ID               NUMBER         DEFAULT 0                     NOT NULL,
  HEALTH_SYSTEM_SOURCE_ID        NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  ORG_MRN_TXT                    VARCHAR2(50 BYTE),
  COMM_MRN_TXT                   VARCHAR2(50 BYTE),
  FINANCIAL_NBR_TXT              VARCHAR2(50 BYTE),
  D_PERSON_ID                    NUMBER         DEFAULT 0                     NOT NULL,
  D_ADMIT_FACILITY_ID            NUMBER         DEFAULT 0                     NOT NULL,
  D_ADMIT_BUILDING_ID            NUMBER         DEFAULT 0                     NOT NULL,
  D_ADMIT_NURSE_UNIT_ID          NUMBER         DEFAULT 0                     NOT NULL,
  D_DISCHARGE_FACILITY_ID        NUMBER         DEFAULT 0                     NOT NULL,
  D_DISCHARGE_BUILDING_ID        NUMBER         DEFAULT 0                     NOT NULL,
  D_DISCHARGE_NURSE_UNIT_ID      NUMBER         DEFAULT 0                     NOT NULL,
  D_ENCNTR_TYPE_ID               NUMBER         DEFAULT 0                     NOT NULL,
  D_ADMIT_SRC_ID                 NUMBER         DEFAULT 0                     NOT NULL,
  D_ADMIT_TYPE_ID                NUMBER         DEFAULT 0                     NOT NULL,
  D_MED_SERVICE_ID               NUMBER         DEFAULT 0                     NOT NULL,
  D_ATTEND_PRSNL_ID              NUMBER         DEFAULT 0                     NOT NULL,
  ADMIT_DT_TM                    DATE,
  ADMIT_UTC_DT_TM                DATE,
  DISCHARGE_DT_TM                DATE,
  DISCHARGE_UTC_DT_TM            DATE,
  PARTITION_DT_TM                DATE,
  FIRST_PROCESS_DT_TM            DATE,
  LAST_PROCESS_DT_TM             DATE,
  UPDT_DT_TM                     DATE,
  UPDT_CNT                       NUMBER,
  UPDT_TASK                      VARCHAR2(50 BYTE),
  UPDT_SOURCE                    VARCHAR2(50 BYTE),
  EXTRACT_DT_TM                  DATE,
  ACTIVE_IND                     NUMBER,
  D_METRIC_1_ID                  NUMBER,
  D_METRIC_2_ID                  NUMBER,
  D_METRIC_3_ID                  NUMBER,
  D_METRIC_4_ID                  NUMBER,
  D_METRIC_5_ID                  NUMBER,
  D_METRIC_6_ID                  NUMBER,
  D_METRIC_7_ID                  NUMBER,
  D_METRIC_8_ID                  NUMBER,
  D_METRIC_9_ID                  NUMBER,
  D_METRIC_10_ID                 NUMBER,
  D_METRIC_11_ID                 NUMBER,
  D_METRIC_12_ID                 NUMBER,
  D_METRIC_13_ID                 NUMBER,
  D_METRIC_14_ID                 NUMBER,
  D_METRIC_15_ID                 NUMBER,
  D_METRIC_16_ID                 NUMBER,
  D_METRIC_17_ID                 NUMBER,
  D_METRIC_18_ID                 NUMBER,
  D_METRIC_19_ID                 NUMBER,
  D_METRIC_20_ID                 NUMBER,
  PRIN_DIAGNOSIS                 VARCHAR2(10 BYTE),
  PRIN_PROCEDURE                 VARCHAR2(10 BYTE),
  PRIN_PROCEDURE_DATE_TXT        VARCHAR2(10 BYTE),
  PRIN_PROCEDURE_DT_TM           DATE,
  PRIN_PROCEDURE_UTC_DT_TM       DATE,
  OTH_DIAGNOSIS_LIST             VARCHAR2(250 BYTE),
  OTH_PROCEDURE_LIST             VARCHAR2(250 BYTE),
  OTH_PROCEDURE_DATES_LIST       VARCHAR2(275 BYTE),
  PAYMENT_SOURCE_FLAG            NUMBER,
  CLINICAL_TRIAL_IND             NUMBER,
  CMO_FLAG                       NUMBER,
  DISC_DISP_FLAG                 NUMBER,
  SAMPLE_IND                     NUMBER,
  ICU_PATIENT_IND                NUMBER,
  INIT_ICU_ADMIT_DATE_TXT        VARCHAR2(10 BYTE),
  INIT_ICU_ADMIT_DT_TM           DATE,
  INIT_ICU_ADMIT_UTC_DT_TM       DATE,
  INIT_ICU_DISC_DATE_TXT         VARCHAR2(10 BYTE),
  INIT_ICU_DISC_DT_TM            DATE,
  INIT_ICU_DISC_UTC_DT_TM        DATE,
  ANES_TYPE_FLAG                 NUMBER,
  VTE_DIAGNOSTIC_IND             NUMBER,
  VTE_CONFIRMED_IND              NUMBER,
  PHYSICIAN_1_TXT                VARCHAR2(50 BYTE),
  PHYSICIAN_2_TXT                VARCHAR2(50 BYTE),
  VTE_PROPHYLAXIS_MASK           NUMBER,
  VTE_PROPHYLAXIS_DATE_TXT       VARCHAR2(10 BYTE),
  VTE_PROPHYLAXIS_DT_TM          DATE,
  VTE_PROPHYLAXIS_UTC_DT_TM      DATE,
  NO_VTE_PROPH_REASON_IND        NUMBER,
  SURGICAL_IND                   NUMBER,
  SURG_END_DATE_TXT              VARCHAR2(10 BYTE),
  SURG_END_DT_TM                 DATE,
  SURG_END_UTC_DT_TM             DATE,
  ICU_SURGICAL_IND               NUMBER,
  ICU_SURG_END_DATE_TXT          VARCHAR2(10 BYTE),
  ICU_SURG_END_DT_TM             DATE,
  ICU_SURG_END_UTC_DT_TM         DATE,
  ANES_START_DATE_TXT            VARCHAR2(10 BYTE),
  ANES_START_DT_TM               DATE,
  ANES_START_UTC_DT_TM           DATE,
  ICU_VTE_PROPHYLAXIS_MASK       NUMBER,
  ICU_VTE_PROPHYLAXIS_DATE_TXT   VARCHAR2(10 BYTE),
  ICU_VTE_PROPHYLAXIS_DT_TM      DATE,
  ICU_VTE_PROPHYLAXIS_UTC_DT_TM  DATE,
  NO_ICU_VTE_PROPH_REASON_IND    NUMBER,
  ANTICOAG_ADMIN_IND             NUMBER,
  ANTICOAG_END_DATE_TXT          VARCHAR2(10 BYTE),
  ANTICOAG_END_DT_TM             DATE,
  ANTICOAG_END_UTC_DT_TM         DATE,
  ANTICOAG_DISC_IND              NUMBER,
  WARFARIN_ADMIN_IND             NUMBER,
  INR_RESULT_IND                 NUMBER,
  OVERLAP_START_DATE_TXT         VARCHAR2(10 BYTE),
  OVERLAP_START_DT_TM            DATE,
  OVERLAP_START_UTC_DT_TM        DATE,
  DISC_OVERLAP_REASON_IND        NUMBER,
  UFH_PLATELET_MONITOR_IND       NUMBER,
  UFH_ADMIN_IND                  NUMBER,
  VTE_POA_IND                    NUMBER,
  VTE_PROPH_STATUS_FLAG          NUMBER,
  WARFARIN_DISC_IND              NUMBER,
  DISCH_INSTR_COMPLIANCE_IND     NUMBER,
  DISCH_INSTR_DIETARY_IND        NUMBER,
  DISCH_INSTR_FOLLOWUP_IND       NUMBER,
  DISCH_INSTR_ADVERSE_REACT_IND  NUMBER,
  REJECT_1_IND                   NUMBER,
  REJECT_2_IND                   NUMBER,
  REJECT_3_IND                   NUMBER,
  REJECT_4_IND                   NUMBER,
  REJECT_5_IND                   NUMBER,
  REJECT_6_IND                   NUMBER,
  EXCLUDE_1_IND                  NUMBER,
  EXCLUDE_2_IND                  NUMBER,
  EXCLUDE_3_IND                  NUMBER,
  EXCLUDE_4_IND                  NUMBER,
  EXCLUDE_5_IND                  NUMBER,
  EXCLUDE_6_IND                  NUMBER,
  NUMERATOR_1_IND                NUMBER,
  NUMERATOR_2_IND                NUMBER,
  NUMERATOR_3_IND                NUMBER,
  NUMERATOR_4_IND                NUMBER,
  NUMERATOR_5_IND                NUMBER,
  NUMERATOR_6_IND                NUMBER,
  LOGICAL_DOMAIN_ID              NUMBER,
  NUMERATOR_1_MU_IND             NUMBER,
  NUMERATOR_2_MU_IND             NUMBER,
  NUMERATOR_3_MU_IND             NUMBER,
  NUMERATOR_4_MU_IND             NUMBER,
  NUMERATOR_5_MU_IND             NUMBER,
  NUMERATOR_6_MU_IND             NUMBER,
  EXCLUDE_1_MU_IND               NUMBER,
  EXCLUDE_2_MU_IND               NUMBER,
  EXCLUDE_3_MU_IND               NUMBER,
  EXCLUDE_4_MU_IND               NUMBER,
  EXCLUDE_5_MU_IND               NUMBER,
  EXCLUDE_6_MU_IND               NUMBER,
  OVERLAY_THERAPY_FLAG           NUMBER,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MED_ADMIN_MED_EVENT_INGRDNT
(
  MED_EVENT_INGREDIENT_ID    NUMBER             DEFAULT 0                     NOT NULL,
  SYNONYM_ID                 NUMBER             DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID           NUMBER             DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME         VARCHAR2(30 BYTE)  DEFAULT ' '                   NOT NULL,
  IDENTIFICATION_PROCESS_CD  NUMBER             DEFAULT 0                     NOT NULL,
  STRENGTH                   FLOAT(126)         DEFAULT 0                     NOT NULL,
  STRENGTH_UNIT_CD           NUMBER             DEFAULT 0                     NOT NULL,
  VOLUME                     FLOAT(126)         DEFAULT 0                     NOT NULL,
  VOLUME_UNIT_CD             NUMBER             DEFAULT 0                     NOT NULL,
  DRUG_FORM_CD               NUMBER             DEFAULT 0                     NOT NULL,
  CATALOG_CD                 NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_QC_NUMERIC_TASK_DETAIL
(
  NUMERIC_TASK_DETAIL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  MEAN_NBR                FLOAT(126)            DEFAULT 0.0                   NOT NULL,
  STD_DEV_NBR             FLOAT(126)            DEFAULT 0.0                   NOT NULL,
  NUM_OF_STD_DEV_NBR      NUMBER                DEFAULT 0                     NOT NULL,
  HIGH_NBR                FLOAT(126)            DEFAULT 0.0                   NOT NULL,
  LOW_NBR                 FLOAT(126)            DEFAULT 0.0                   NOT NULL,
  RANGE_NBR               NUMBER                DEFAULT 0                     NOT NULL,
  TASK_DETAIL_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MLTM_ADDITIONAL_TEXT
(
  DRUG_IDENTIFIER  VARCHAR2(6 BYTE)             DEFAULT ' '                   NOT NULL,
  TEXT_TYPE_ID     NUMBER                       DEFAULT 0                     NOT NULL,
  TEXT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MLTM_ALR_CATEGORY_DRUG_MAP
(
  DRUG_IDENTIFIER  VARCHAR2(6 BYTE)             DEFAULT ' '                   NOT NULL,
  ALR_CATEGORY_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MLTM_CATEGORY_DRUG_XREF
(
  MULTUM_CATEGORY_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  DRUG_IDENTIFIER     VARCHAR2(6 BYTE)          DEFAULT ' '                   NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MLTM_DDM_GROUP_MMDC_MAP
(
  GROUP_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  MAIN_MULTUM_DRUG_CODE  NUMBER                 DEFAULT 0                     NOT NULL,
  MULTUM_CATEGORY_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MLTM_DRC_GROUP_RELTN
(
  GROUPER_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  GROUPER_NAME           VARCHAR2(250 BYTE),
  SYNONYM_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  MAIN_MULTUM_DRUG_CODE  NUMBER                 DEFAULT 0                     NOT NULL,
  VERSION                VARCHAR2(25 BYTE),
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MLTM_MMDC_ATTRIBUTE
(
  MAIN_MULTUM_DRUG_CODE  NUMBER                 DEFAULT 0                     NOT NULL,
  AVAILABLE_IND          NUMBER,
  OTC_STATUS             NUMBER,
  GENERIC_FORM_IND       NUMBER,
  GENERIC_SYNONYM_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MMR_QI_QUESTION_NUM_RSLT
(
  RESULT_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER,
  UPDT_CNT                   NUMBER,
  UPDT_DT_TM                 DATE,
  UPDT_ID                    NUMBER,
  UPDT_TASK                  NUMBER,
  ACTIVE_IND                 NUMBER,
  ACTIVE_STATUS_CD           NUMBER,
  ACTIVE_STATUS_DT_TM        DATE,
  ACTIVE_STATUS_PRSNL_ID     NUMBER,
  BEG_EFFECTIVE_DT_TM        DATE,
  END_EFFECTIVE_DT_TM        DATE,
  QUESTION_GROUP_ID          NUMBER,
  QUALITY_ITEM_ID            NUMBER,
  QUESTION_ID                NUMBER,
  COMMENTS_ID                NUMBER,
  GRID_ID                    NUMBER,
  RESULT_NBR                 FLOAT(126),
  QUALITY_ITEM_DATA_ID       NUMBER             DEFAULT 0                     NOT NULL,
  QUESTION_NUM_RSLT_UPD_IND  NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MRU_LOOKUP_ORDER
(
  MRU_LOOKUP_ORDER_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  SYNONYM_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  ORDER_SENTENCE_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  ORD_AS_FLAG          NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE NMDP_ALLELE_XREF
(
  NMDP_CD       NUMBER                          DEFAULT 0                     NOT NULL,
  ALLELE_CD     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL,
  NMDP_CODE_ID  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OCS_ATTR_XCPTN
(
  OCS_ATTR_XCPTN_ID        NUMBER               DEFAULT 0                     NOT NULL,
  OCS_ATTR_XCPTN_GROUP_ID  NUMBER               DEFAULT 0                     NOT NULL,
  SYNONYM_ID               NUMBER               DEFAULT 0                     NOT NULL,
  OCS_COL_NAME_CD          NUMBER               DEFAULT 0                     NOT NULL,
  FLEX_OBJ_TYPE_CD         NUMBER               DEFAULT 0                     NOT NULL,
  FLEX_OBJ_CD              NUMBER               DEFAULT 0                     NOT NULL,
  FLEX_NBR_VALUE           NUMBER,
  FLEX_STR_VALUE_TXT       VARCHAR2(100 BYTE),
  FACILITY_CD              NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OCS_FACILITY_FORMULARY_R
(
  OCS_FACILITY_FORMULARY_R_ID     NUMBER        DEFAULT 0                     NOT NULL,
  FACILITY_CD                     NUMBER        DEFAULT 0                     NOT NULL,
  SYNONYM_ID                      NUMBER        DEFAULT 0                     NOT NULL,
  INPATIENT_FORMULARY_STATUS_CD   NUMBER        DEFAULT 0                     NOT NULL,
  OUTPATIENT_FORMULARY_STATUS_CD  NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OCS_FACILITY_R
(
  SYNONYM_ID    NUMBER                          DEFAULT 0                     NOT NULL,
  FACILITY_CD   NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OPS_DAY_OF_MONTH
(
  OPS_DAY_OF_MONTH_ID     NUMBER                DEFAULT 0                     NOT NULL,
  OPS_TASK_ID             NUMBER                DEFAULT 0                     NOT NULL,
  DAY_OF_MONTH            NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  OPS_JOB_VERIFY_ID       NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OPS_DAY_OF_WEEK
(
  OPS_DAY_OF_WEEK_ID      NUMBER                DEFAULT 0                     NOT NULL,
  OPS_TASK_ID             NUMBER                DEFAULT 0                     NOT NULL,
  DAY_OF_WEEK             NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  OPS_JOB_VERIFY_ID       NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OPS_SCHEDULE_JOB_STEP
(
  OPS_SCHEDULE_JOB_STEP_ID  NUMBER              DEFAULT 0                     NOT NULL,
  OPS_SCHEDULE_TASK_ID      NUMBER              DEFAULT 0                     NOT NULL,
  OPS_JOB_STEP_ID           NUMBER              DEFAULT 0                     NOT NULL,
  STATUS_CD                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  OPS_EVENT                 VARCHAR2(100 BYTE),
  AVG_FLAG                  NUMBER,
  AVG_DT_TM                 DATE,
  THRESH_DT_TM              DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OPS_SCHED_DEP
(
  OPS_SCHED_DEP_ID        NUMBER                DEFAULT 0                     NOT NULL,
  OPS_JOB_VERIFY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  T_SCHED_TASK_ID         NUMBER                DEFAULT 0                     NOT NULL,
  T_SCHED_STEP_ID         NUMBER                DEFAULT 0                     NOT NULL,
  D_SCHED_TASK_ID         NUMBER                DEFAULT 0                     NOT NULL,
  D_SCHED_STEP_ID         NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORC_CUSTOM_SEL
(
  ORC_CUSTOM_SEL_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  SYNONYM_ID         NUMBER                     DEFAULT 0                     NOT NULL,
  ORDER_SENTENCE_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORC_CUSTOM_SEL_RELTN
(
  ORC_CUSTOM_SEL_RELTN_ID  NUMBER               DEFAULT 0                     NOT NULL,
  ORC_CUSTOM_SEL_TYPE_CD   NUMBER               DEFAULT 0                     NOT NULL,
  CATALOG_CD               NUMBER               DEFAULT 0                     NOT NULL,
  ORC_CUSTOM_SEL_ID        NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORC_RESOURCE_LIST
(
  SERVICE_RESOURCE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  CATALOG_CD              NUMBER                DEFAULT 0                     NOT NULL,
  SEQUENCE                NUMBER,
  PRIMARY_IND             NUMBER,
  SCRIPT_NAME             VARCHAR2(50 BYTE),
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PBS_AUTHORITY
(
  PBS_AUTHORITY_ID   NUMBER                     DEFAULT 0                     NOT NULL,
  PBS_INDICATION_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  AUTHORITY_CD       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PBS_CAUTION_RELTN
(
  PBS_CAUTION_RELTN_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  PBS_CAUTION_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  PBS_ITEM_ID           NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PBS_DRUG
(
  PBS_DRUG_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  BRAND_NAME           VARCHAR2(45 BYTE)        DEFAULT ' '                   NOT NULL,
  BRAND_IDENT          VARCHAR2(45 BYTE)        DEFAULT ' '                   NOT NULL,
  PBS_MANUFACTURER_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  PBS_ITEM_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  PACK_SIZE            NUMBER                   DEFAULT 0                     NOT NULL,
  FORM_STRENGTH        VARCHAR2(400 BYTE)       DEFAULT ' '                   NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  FORM_PACK            VARCHAR2(100 BYTE),
  FORM_LEGAL           VARCHAR2(400 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PBS_OCS_MAPPING
(
  PBS_OCS_MAPPING_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  PBS_DRUG_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  SYNONYM_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PCA_MEASURE_OUTCOME_RELTN
(
  PCA_MEASURE_OUTCOME_RELTN_ID  NUMBER          DEFAULT 0                     NOT NULL,
  PCA_QUALITY_MEASURE_ID        NUMBER          DEFAULT 0                     NOT NULL,
  PCA_OUTCOME_ID                NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_IND                    NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PFT_SEL_TASK_R
(
  PFT_SEL_TASK_R_ID       NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(32 BYTE)     DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  SELECTED_TASK_ID        NUMBER                DEFAULT 0                     NOT NULL,
  TASK_OWNER_AUTH_FLAG    NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PFT_SUB_TYPE_SECURITY
(
  PFT_SUB_TYPE_SECURITY_ID  NUMBER              DEFAULT 0                     NOT NULL,
  PRSNL_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  TRANS_SUB_TYPE_CD         NUMBER              DEFAULT 0                     NOT NULL,
  AMOUNT                    FLOAT(126),
  SELECTED_TASK_ID          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PG_AVAIL_RESPONSE
(
  PG_AVAIL_RESPONSE_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  PG_QUESTION_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME    VARCHAR2(30 BYTE)       DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID      NUMBER                  DEFAULT 0                     NOT NULL,
  DISPLAY_SEQ_NBR       NUMBER                  DEFAULT 0                     NOT NULL,
  ACTIVE_IND            NUMBER                  DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM   DATE                    DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM   DATE                    DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  DISPLAY_TXT           VARCHAR2(255 BYTE)      DEFAULT ' '                   NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PG_AVAIL_RESPONSE_LIST
(
  PG_AVAIL_RESPONSE_LIST_ID  NUMBER             DEFAULT 0                     NOT NULL,
  PG_AVAIL_RESPONSE_ID       NUMBER             DEFAULT 0                     NOT NULL,
  PG_AVAIL_RESPONSE_GRP_ID   NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM        DATE               DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PG_AVAIL_RESPONSE_R
(
  PG_AVAIL_RESPONSE_R_ID     NUMBER             DEFAULT 0                     NOT NULL,
  PG_AVAIL_RESPONSE_ID       NUMBER             DEFAULT 0                     NOT NULL,
  RELATED_AVAIL_RESPONSE_ID  NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM        DATE               DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PG_RESULT_LIST
(
  PG_RESULT_LIST_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  PG_RESULT_STAGE_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  PG_AVAIL_RESPONSE_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID          NUMBER                  DEFAULT 0                     NOT NULL,
  RESPONSE_TYPE_FLAG    NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  PG_QUESTION_ID        NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PM_RPT_GROUP
(
  GROUP_ID                NUMBER                DEFAULT 0                     NOT NULL,
  REPORT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  HEADER_ID               NUMBER                DEFAULT 0                     NOT NULL,
  FIELD_ID                NUMBER                DEFAULT 0                     NOT NULL,
  GROUP_SEQUENCE          NUMBER,
  GROUP_TOTAL_IND         NUMBER,
  DATA_STATUS_CD          NUMBER                DEFAULT 0,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0,
  ACTIVE_STATUS_DT_TM     DATE,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE POSITIVE_TUBES
(
  LOT_NUMBER_ID       NUMBER                    DEFAULT 0                     NOT NULL,
  ALLELE_CD           NUMBER                    DEFAULT 0                     NOT NULL,
  TUBE_NUMBER         NUMBER                    DEFAULT 0                     NOT NULL,
  REACTION_SYMBOL_CD  NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PROFILE_TASK_R
(
  CATALOG_CD              NUMBER                DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD           NUMBER                DEFAULT 0                     NOT NULL,
  VERSION_NBR             NUMBER,
  GROUP_CD                NUMBER                DEFAULT 0                     NOT NULL,
  ITEM_TYPE_FLAG          NUMBER,
  PENDING_IND             NUMBER,
  REPEAT_IND              NUMBER,
  SEQUENCE                NUMBER,
  DUP_CHK_MIN             NUMBER,
  DUP_CHK_ACTION_CD       NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  POST_PROMPT_IND         NUMBER,
  PROMPT_RESOURCE_CD      NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  REFERENCE_TASK_ID       NUMBER                DEFAULT 0                     NOT NULL,
  PROMPT_LONG_TEXT_ID     NUMBER                DEFAULT 0                     NOT NULL,
  RESTRICT_DISPLAY_IND    NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE QC_SCHD_STEP_CTRL_ASSAY
(
  QC_SCHD_STEP_CTRL_ASSAY_ID  NUMBER            DEFAULT 0                     NOT NULL,
  QC_SCHEDULE_ID              NUMBER            DEFAULT 0                     NOT NULL,
  STEP_NBR                    NUMBER            DEFAULT 0                     NOT NULL,
  CONTROL_ID                  NUMBER            DEFAULT 0                     NOT NULL,
  ERROR_STEP_IND              NUMBER            DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD               NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE RAD_TECH_FMT_ERPRC_OVRD
(
  FORMAT_OVRD_ID          NUMBER                DEFAULT 0                     NOT NULL,
  FIELD_FORMAT_RELTN_ID   NUMBER                DEFAULT 0                     NOT NULL,
  FORMAT_ERPRC_RELTN_ID   NUMBER                DEFAULT 0                     NOT NULL,
  CHARTABLE_IND           NUMBER                DEFAULT 0                     NOT NULL,
  REQUIRED_IND            NUMBER                DEFAULT 0                     NOT NULL,
  DEFAULT_NBR             FLOAT(126),
  DEFAULT_TEXT            VARCHAR2(255 BYTE),
  DEFAULT_DT_TM           DATE,
  DEFAULT_CHOICE_IND      NUMBER,
  MIN_NBR                 FLOAT(126),
  MAX_NBR                 FLOAT(126),
  ACTIVE_IND              NUMBER                DEFAULT 1                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE REPLACE_GROUPING
(
  CATALOG_CD          NUMBER                    DEFAULT 0                     NOT NULL,
  REPLACE_CATALOG_CD  NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE REPORT_INPROC_STATUS
(
  CATALOG_CD             NUMBER                 DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  PROCESSING_SEQUENCE    NUMBER,
  TRANSCRIBED_STATUS_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  DICTATED_STATUS_CD     NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  CANCELABLE_IND         NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ROUND_ROBIN_COMMENT
(
  ROUND_ROBIN_REF_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  ACCESSION_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  SEQUENCE             NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 0,
  BEG_EFFECTIVE_DT_TM  DATE,
  END_EFFECTIVE_DT_TM  DATE,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE SCH_APPT_ORD
(
  APPT_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  REQUIRED_IND            NUMBER                DEFAULT 0                     NOT NULL,
  SEQ_NBR                 NUMBER                DEFAULT 0                     NOT NULL,
  VERSION_DT_TM           DATE                  DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  SYNONYM_ID              NUMBER                DEFAULT 0                     NOT NULL,
  ALT_SEL_CATEGORY_ID     NUMBER                DEFAULT 0                     NOT NULL,
  NULL_DT_TM              DATE                  DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  CANDIDATE_ID            NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE SCR_PARAGRAPH
(
  SCR_PATTERN_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  SCR_PARAGRAPH_TYPE_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  SEQUENCE_NUMBER        NUMBER,
  SCR_PARAGRAPH_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE SELECTED_CRITERIA
(
  SELECTED_CRITERIA_ID    NUMBER                DEFAULT 0                     NOT NULL,
  SELECTED_TASK_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PFT_TASK_CRITERIA_ID    NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_SEQ               NUMBER,
  EVALUATOR_TXT           VARCHAR2(250 BYTE),
  EVALUATOR_TYPE          FLOAT(126),
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE SIGN_LINE_LAYOUT_FIELD_R
(
  SIGN_LINE_LAYOUT_FIELD_R_ID  NUMBER           DEFAULT 0                     NOT NULL,
  FORMAT_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  UCMR_LAYOUT_FIELD_ID         NUMBER           DEFAULT 0                     NOT NULL,
  STATUS_FLAG                  NUMBER,
  ACTIVE_IND                   NUMBER,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE SI_OEN_CHANN_ENDPOINT_R
(
  SI_OEN_CHANN_ENDPOINT_R_ID  NUMBER            DEFAULT 0                     NOT NULL,
  SI_OEN_COMCHANNEL_ID        NUMBER            DEFAULT 0                     NOT NULL,
  SI_OEN_ENDPOINT_ID          NUMBER            DEFAULT 0                     NOT NULL,
  RELATION_TYPE               VARCHAR2(31 BYTE) DEFAULT ' ' NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE SN_CT_DISPLAY_FIELD
(
  SN_CT_DISPLAY_FIELD_ID  NUMBER                DEFAULT 0                     NOT NULL,
  SN_CT_DISPLAY_ROW_ID    NUMBER                DEFAULT 0                     NOT NULL,
  FIELD_SEQUENCE          NUMBER                DEFAULT 0                     NOT NULL,
  FIELD_PROMPT            VARCHAR2(50 BYTE),
  PARENT_ENTITY_NAME      VARCHAR2(32 BYTE),
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE STRT_BMDI_MODEL_NOMENCLATURE
(
  STRT_MODEL_NOMENCLATURE_ID  NUMBER            DEFAULT 0                     NOT NULL,
  STRT_MODEL_PARAMETER_ID     NUMBER            DEFAULT 0                     NOT NULL,
  STRT_MODEL_ID               NUMBER            DEFAULT 0                     NOT NULL,
  DEFAULT_VALUE               VARCHAR2(50 BYTE) DEFAULT ' ' NOT NULL,
  ALPHA_TRANSLATION           VARCHAR2(50 BYTE) DEFAULT ' ' NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE TPL_APPL_DETAIL
(
  APPL_DETAIL_ID            NUMBER              DEFAULT 0                     NOT NULL,
  APPL_TASK_RELTN_ID        NUMBER              DEFAULT 0                     NOT NULL,
  TITLE_TXT                 VARCHAR2(255 BYTE)  DEFAULT ' '                   NOT NULL,
  APPL_TYPE_FLAG            NUMBER              DEFAULT 0                     NOT NULL,
  HTTP_POST_IND             NUMBER              DEFAULT 0                     NOT NULL,
  REUSE_PRCS_IND            NUMBER              DEFAULT 0                     NOT NULL,
  CMD_PATH_TXT              VARCHAR2(512 BYTE),
  CTX_PARAM_TXT             VARCHAR2(2048 BYTE),
  FILE_PATH_TXT             VARCHAR2(512 BYTE),
  FILE_TMPLT_LONG_TEXT_ID   NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER              DEFAULT 0                     NOT NULL,
  TEST_MODE_IND             NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  RAD_SEND_LINKED_ACCN_IND  NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE UCMR_CASE_GRP_STEP_R
(
  UCMR_CASE_GRP_STEP_R_ID       NUMBER          DEFAULT 0                     NOT NULL,
  PREV_UCMR_CASE_GRP_STEP_R_ID  NUMBER          DEFAULT 0                     NOT NULL,
  UCMR_CASE_GROUP_ID            NUMBER          DEFAULT 0                     NOT NULL,
  UCMR_CASE_STEP_ID             NUMBER          DEFAULT 0                     NOT NULL,
  REPEAT_CAT_CD                 NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_IND                    NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD              NUMBER          DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM           DATE            DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM           DATE            DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX XAK1ALPHA_RESPONSES_CATEGORY ON ALPHA_RESPONSES_CATEGORY
(REFERENCE_RANGE_FACTOR_ID, CATEGORY_NAME)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1BB_RH_PHENOTYPE ON BB_RH_PHENOTYPE
(FR_NOMENCLATURE_ID, W_NOMENCLATURE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1CNT_DCP_INTERP_STATE ON CNT_DCP_INTERP_STATE
(DCP_INTERP_UID, RESULTING_STATE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1CNT_DTA_RRF_R ON CNT_DTA_RRF_R
(RRF_UID, TASK_ASSAY_UID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1CNT_GRID ON CNT_GRID
(ROW_TASK_ASSAY_UID, COL_TASK_ASSAY_UID, INT_EVENT_CDUID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1CNT_INPUT ON CNT_INPUT
(SECTION_UID, INPUT_DESCRIPTION, PVC_NAME, INPUT_REF_SEQ, INPUT_SEQUENCE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1CV_ORDER_CATEGORY_R ON CV_ORDER_CATEGORY_R
(CV_ORDER_CATEGORY_ID, CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1CYTO_STANDARD_REPORT ON CYTO_STANDARD_RPT
(CATALOG_CD, SHORT_DESC)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1DA_BV_LV_ELEM_RELTN ON DA_BV_LV_ELEM_RELTN
(DA_BUS_VIEW_ID, DA_LOGICAL_VIEW_ID, DA_ELEMENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1DA_CALC_ELEM_RELTN ON DA_CALC_ELEM_RELTN
(CHILD_ELEMENT_ID, PARENT_ELEMENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1DD_REF_EMR_CONTENT ON DD_REF_EMR_CONTENT
(REF_CONTENT_INSTANCE_IDENT)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1DIFFERENTIAL_REF ON DIFFERENTIAL_REF
(OPT_KEY, CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1DRUG_CLASS_INT_CSTM_ENT_R ON DRUG_CLASS_INT_CSTM_ENTITY_R
(DCP_ENTITY_RELTN_ID, DRUG_CLASS_INT_CUSTOM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1HIM_HAC_CRITERIA ON HIM_HAC_CRITERIA
(HAC_NOMENCLATURE_ID, COMPARE_PX_NOMEN_ID, COMPARE_DX_NOMEN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1HLA_AB_SCREEN_HISTORY_M ON HLA_AB_SCREEN_HISTORY_MAP
(CATALOG_CD, REACTION_DTA_CD, T_CELL_PRA_DTA_CD, B_CELL_PRA_DTA_CD, METHODOLOGY_DTA_CD, 
DILUTION_DTA_CD, METHODOLOGY_NOM_ID, DILUTION_NOM_ID, OD_DTA_CD, OD_RATIO_DTA_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1HLA_AB_SPEC_MAP ON HLA_AB_SPEC_MAP
(CATALOG_CD, AB_DTA_CD, AB_HIST_SEQ_NBR)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1HM_EXPECT_SAT ON HM_EXPECT_SAT
(EXPECT_ID, SATISFIER_MEANING)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1HM_EXPECT_SAT_HIST ON HM_EXPECT_SAT_HIST
(EXPECT_SAT_HIST_ID, EXPECT_SAT_ID, ACTION_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1MIC_QC_NUMERIC_TASK_DETAIL ON MIC_QC_NUMERIC_TASK_DETAIL
(MEAN_NBR, STD_DEV_NBR, NUM_OF_STD_DEV_NBR, HIGH_NBR, LOW_NBR, 
RANGE_NBR, TASK_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1MRU_LOOKUP_ORDER ON MRU_LOOKUP_ORDER
(SYNONYM_ID, ORDER_SENTENCE_ID, ORD_AS_FLAG)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1OCS_ATTR_XCPTN ON OCS_ATTR_XCPTN
(SYNONYM_ID, FACILITY_CD, OCS_COL_NAME_CD, FLEX_OBJ_TYPE_CD, FLEX_OBJ_CD, 
OCS_ATTR_XCPTN_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1OCS_FACILITY_FORMULARY_R ON OCS_FACILITY_FORMULARY_R
(SYNONYM_ID, FACILITY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1OPS_SCHEDULE_JOB_STEP ON OPS_SCHEDULE_JOB_STEP
(OPS_SCHEDULE_TASK_ID, OPS_JOB_STEP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1PBS_CAUTION_RELTN ON PBS_CAUTION_RELTN
(PBS_CAUTION_ID, PBS_ITEM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1PBS_OCS_MAPPING ON PBS_OCS_MAPPING
(PBS_DRUG_ID, SYNONYM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1PCA_MEASURE_OUTCOME_RELTN ON PCA_MEASURE_OUTCOME_RELTN
(PCA_QUALITY_MEASURE_ID, PCA_OUTCOME_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1PG_AVAIL_RESPONSE ON PG_AVAIL_RESPONSE
(PG_QUESTION_ID, PARENT_ENTITY_NAME, PARENT_ENTITY_ID, DISPLAY_TXT)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1PG_AVAIL_RESPONSE_LIST ON PG_AVAIL_RESPONSE_LIST
(PG_AVAIL_RESPONSE_ID, PG_AVAIL_RESPONSE_GRP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1PG_AVAIL_RESPONSE_R ON PG_AVAIL_RESPONSE_R
(PG_AVAIL_RESPONSE_ID, RELATED_AVAIL_RESPONSE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1SIGN_LINE_LAYOUT_FIELD_R ON SIGN_LINE_LAYOUT_FIELD_R
(FORMAT_ID, UCMR_LAYOUT_FIELD_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1SI_OEN_CHANN_ENDPOINT_R ON SI_OEN_CHANN_ENDPOINT_R
(SI_OEN_COMCHANNEL_ID, SI_OEN_ENDPOINT_ID, RELATION_TYPE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1SN_CT_DISPLAY_FIELD ON SN_CT_DISPLAY_FIELD
(SN_CT_DISPLAY_ROW_ID, FIELD_SEQUENCE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XAK1TPL_APPL_DETAIL ON TPL_APPL_DETAIL
(APPL_TASK_RELTN_ID, TITLE_TXT)
LOGGING
NOPARALLEL;


CREATE INDEX XFK1CHART_GRP_EVNT_SET ON CHART_GRP_EVNT_SET
(EVENT_SET_NAME)
LOGGING
NOPARALLEL;


CREATE INDEX XIDX2BB_GROUP_COMPONENT ON BB_GROUP_COMPONENT
(CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIDX2BB_RH_PHENOTYPE ON BB_RH_PHENOTYPE
(W_NOMENCLATURE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE01LH_ABS_ED_METRICS ON LH_ABS_ED_METRICS
(ADMIT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE01LH_ABS_STROKE_METRICS ON LH_ABS_STROKE_METRICS
(ADMIT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE01LH_ABS_VTE_METRICS ON LH_ABS_VTE_METRICS
(ADMIT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE02LH_ABS_ED_METRICS ON LH_ABS_ED_METRICS
(DISCHARGE_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE02LH_ABS_STROKE_METRICS ON LH_ABS_STROKE_METRICS
(DISCHARGE_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE02LH_ABS_VTE_METRICS ON LH_ABS_VTE_METRICS
(DISCHARGE_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE03LH_ABS_ED_METRICS ON LH_ABS_ED_METRICS
(PARTITION_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE03LH_ABS_STROKE_METRICS ON LH_ABS_STROKE_METRICS
(PARTITION_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE03LH_ABS_VTE_METRICS ON LH_ABS_VTE_METRICS
(PARTITION_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE04LH_ABS_ED_METRICS ON LH_ABS_ED_METRICS
(EXTRACT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE04LH_ABS_STROKE_METRICS ON LH_ABS_STROKE_METRICS
(EXTRACT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE04LH_ABS_VTE_METRICS ON LH_ABS_VTE_METRICS
(EXTRACT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE05LH_ABS_ED_METRICS ON LH_ABS_ED_METRICS
(UPDT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE05LH_ABS_STROKE_METRICS ON LH_ABS_STROKE_METRICS
(UPDT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE05LH_ABS_VTE_METRICS ON LH_ABS_VTE_METRICS
(UPDT_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE06LH_ABS_ED_METRICS ON LH_ABS_ED_METRICS
(ENCNTR_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE06LH_ABS_STROKE_METRICS ON LH_ABS_STROKE_METRICS
(ENCNTR_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE06LH_ABS_VTE_METRICS ON LH_ABS_VTE_METRICS
(ENCNTR_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE07LH_ABS_ED_METRICS ON LH_ABS_ED_METRICS
(ADMIT_UTC_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE07LH_ABS_STROKE_METRICS ON LH_ABS_STROKE_METRICS
(ADMIT_UTC_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE07LH_ABS_VTE_METRICS ON LH_ABS_VTE_METRICS
(ADMIT_UTC_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE08LH_ABS_ED_METRICS ON LH_ABS_ED_METRICS
(DISCHARGE_UTC_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE08LH_ABS_STROKE_METRICS ON LH_ABS_STROKE_METRICS
(DISCHARGE_UTC_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE08LH_ABS_VTE_METRICS ON LH_ABS_VTE_METRICS
(DISCHARGE_UTC_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1ADVANCED_DELTA ON ADVANCED_DELTA
(REFERENCE_RANGE_FACTOR_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1ALT_SEL_CAT ON ALT_SEL_CAT
(AHFS_IND)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1ALT_SEL_LIST ON ALT_SEL_LIST
(CHILD_ALT_SEL_CAT_ID, ALT_SEL_CATEGORY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1BB_GROUP_COMPONENT ON BB_GROUP_COMPONENT
(BB_TEST_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1BB_QC_EXPECTED_RESULT_R ON BB_QC_EXPECTED_RESULT_R
(NOMENCLATURE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1BB_RH_PHENO_TESTING ON BB_RH_PHENO_TESTING
(RH_PHENOTYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1BR_DATAMART_DEFAULT ON BR_DATAMART_DEFAULT
(BR_DATAMART_FILTER_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1BR_DATAMART_DEFAULT_DETAIL ON BR_DATAMART_DEFAULT_DETAIL
(BR_DATAMART_DEFAULT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1CATALOG_EVENT_SETS ON CATALOG_EVENT_SETS
(EVENT_SET_NAME)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1CHART_FORMAT_CODES ON CHART_FORMAT_CODES
(CHART_FORMAT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1CHART_GRP_EVNT_SUPPRESS ON CHART_GRP_EVNT_SUPPRESS
(CHART_GROUP_ID, ORDER_CATALOG_CD, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1CONDITIONAL_DTA ON CONDITIONAL_DTA
(CONDITIONAL_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1COND_EXPRESSION_COMP ON COND_EXPRESSION_COMP
(TRIGGER_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1CV_RESPONSE ON CV_RESPONSE
(A1)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1CV_STEP_REF ON CV_STEP_REF
(ACTIVITY_SUBTYPE_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1CV_XREF_VALIDATION ON CV_XREF_VALIDATION
(RLTNSHIP_FLAG)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1DD_REF_EMR_CONTENT ON DD_REF_EMR_CONTENT
(EMR_CONTENT_TYPE_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1EEM_ABN_DATA ON EEM_ABN_DATA
(KEY_FIELD, EEM_FILE_ID, ATTR_TYPE_CD, SEQ_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1EEM_ABN_RULE ON EEM_ABN_RULE
(PROC_IDENT, EEM_FILE_ID, DIAG_BEG_IDENT, DIAG_END_IDENT)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1EEM_BENEFIT_QUAL ON EEM_BENEFIT_QUAL
(BENEFIT_ID, QUALIFIER_CD, BEG_EFFECTIVE_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1EEM_ENTITY_NTWK_RELTN ON EEM_ENTITY_NTWK_RELTN
(NETWORK_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1EEM_ENTITY_PROV_TAX_RELTN ON EEM_ENTITY_PROV_TAX_RELTN
(PARENT_ENTITY_ID, PARENT_ENTITY_NAME, EEM_PROV_TAX_RELTN_ID, BEG_EFFECTIVE_DT_TM)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1EEM_SERVICE_LIST ON EEM_SERVICE_LIST
(SERVICE_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1GROUP_DEFINITION ON GROUP_DEFINITION
(GROUP_REFERENCE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1HLA_AB_SCREEN_HISTORY_M ON HLA_AB_SCREEN_HISTORY_MAP
(CATALOG_CD, REACTION_DTA_CD, T_CELL_PRA_DTA_CD, B_CELL_PRA_DTA_CD, METHODOLOGY_DTA_CD, 
DILUTION_DTA_CD, METHODOLOGY_NOM_ID, DILUTION_NOM_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1INPUT_FORM_DEFINITION ON INPUT_FORM_DEFINITION
(INPUT_FORM_REFERENCE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1MED_ADMIN_MED_EVENT_INGRDT ON MED_ADMIN_MED_EVENT_INGRDNT
(PARENT_ENTITY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1MIC_QC_NUMERIC_TASK_DETAIL ON MIC_QC_NUMERIC_TASK_DETAIL
(TASK_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1MLTM_CATEGORY_DRUG_XREF ON MLTM_CATEGORY_DRUG_XREF
(DRUG_IDENTIFIER)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1MLTM_DRC_GROUP_RELTN ON MLTM_DRC_GROUP_RELTN
(MAIN_MULTUM_DRUG_CODE)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1OCS_ATTR_XCPTN ON OCS_ATTR_XCPTN
(OCS_ATTR_XCPTN_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1OCS_FACILITY_FORMULARY_R ON OCS_FACILITY_FORMULARY_R
(FACILITY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1OPS_DAY_OF_MONTH ON OPS_DAY_OF_MONTH
(OPS_TASK_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1OPS_DAY_OF_WEEK ON OPS_DAY_OF_WEEK
(OPS_TASK_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1OPS_SCHED_DEP ON OPS_SCHED_DEP
(T_SCHED_TASK_ID, T_SCHED_STEP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XIE1ORC_CUSTOM_SEL ON ORC_CUSTOM_SEL
(SYNONYM_ID, ORDER_SENTENCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XIE1ORC_CUSTOM_SEL_RELTN ON ORC_CUSTOM_SEL_RELTN
(CATALOG_CD, ORC_CUSTOM_SEL_TYPE_CD, ORC_CUSTOM_SEL_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1PBS_AUTHORITY ON PBS_AUTHORITY
(PBS_INDICATION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1PBS_DRUG ON PBS_DRUG
(PBS_ITEM_ID, PBS_MANUFACTURER_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1PBS_OCS_MAPPING ON PBS_OCS_MAPPING
(SYNONYM_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1PFT_SEL_TASK_R ON PFT_SEL_TASK_R
(PARENT_ENTITY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1PFT_SUB_TYPE_SECURITY ON PFT_SUB_TYPE_SECURITY
(PRSNL_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1PG_RESULT_LIST ON PG_RESULT_LIST
(PG_RESULT_STAGE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1QC_SCHD_STEP_CTRL_ASSAY ON QC_SCHD_STEP_CTRL_ASSAY
(STEP_NBR, CONTROL_ID, ERROR_STEP_IND, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1RAD_TECH_FMT_ERPRC_OVRD ON RAD_TECH_FMT_ERPRC_OVRD
(FORMAT_ERPRC_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1SCH_APPT_ORD ON SCH_APPT_ORD
(SYNONYM_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1UCMR_CASE_GRP_STEP_R ON UCMR_CASE_GRP_STEP_R
(UCMR_CASE_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1_NMDP_ALLELE_XREF ON NMDP_ALLELE_XREF
(ALLELE_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2ALT_SEL_CAT ON ALT_SEL_CAT
(SHORT_DESCRIPTION)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2ALT_SEL_LIST ON ALT_SEL_LIST
(ALT_SEL_CATEGORY_ID, LIST_TYPE)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2BB_QC_EXPECTED_RESULT_R ON BB_QC_EXPECTED_RESULT_R
(RELATED_REAGENT_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XIE2CATALOG_EVENT_SETS ON CATALOG_EVENT_SETS
(CATALOG_CD, EVENT_SET_NAME)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2CHART_FORMAT_CODES ON CHART_FORMAT_CODES
(EVENT_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2CV_RESPONSE ON CV_RESPONSE
(A2)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2DD_REF_EMR_CONTENT ON DD_REF_EMR_CONTENT
(TITLE_TXT)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2EEM_ENTITY_NTWK_RELTN ON EEM_ENTITY_NTWK_RELTN
(LONG_TEXT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2EEM_ENTITY_PROV_TAX_RELTN ON EEM_ENTITY_PROV_TAX_RELTN
(EEM_PROV_TAX_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2GROUP_DEFINITION ON GROUP_DEFINITION
(ONLINE_ITEM_DEFINITION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2INPUT_FORM_DEFINITION ON INPUT_FORM_DEFINITION
(GROUP_REFERENCE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2MED_ADMIN_MED_EVENT_INGRDT ON MED_ADMIN_MED_EVENT_INGRDNT
(SYNONYM_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2MLTM_DRC_GROUP_RELTN ON MLTM_DRC_GROUP_RELTN
(SYNONYM_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2OPS_SCHEDULE_JOB_STEP ON OPS_SCHEDULE_JOB_STEP
(OPS_JOB_STEP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2OPS_SCHED_DEP ON OPS_SCHED_DEP
(D_SCHED_TASK_ID, D_SCHED_STEP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2PBS_DRUG ON PBS_DRUG
(BRAND_IDENT)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2PFT_SEL_TASK_R ON PFT_SEL_TASK_R
(SELECTED_TASK_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2PFT_SUB_TYPE_SECURITY ON PFT_SUB_TYPE_SECURITY
(SELECTED_TASK_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2QC_SCHD_STEP_CTRL_ASSAY ON QC_SCHD_STEP_CTRL_ASSAY
(QC_SCHEDULE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2SCH_APPT_ORD ON SCH_APPT_ORD
(ALT_SEL_CATEGORY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2UCMR_CASE_GRP_STEP_R ON UCMR_CASE_GRP_STEP_R
(UCMR_CASE_STEP_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3ALT_SEL_CAT ON ALT_SEL_CAT
(LONG_DESCRIPTION_KEY_CAP)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3ALT_SEL_LIST ON ALT_SEL_LIST
(PATHWAY_CATALOG_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3CHART_FORMAT_CODES ON CHART_FORMAT_CODES
(ORDER_CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3CV_RESPONSE ON CV_RESPONSE
(A3)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3EEM_ENTITY_NTWK_RELTN ON EEM_ENTITY_NTWK_RELTN
(PARENT_ENTITY_ID, PARENT_ENTITY_NAME)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3INPUT_FORM_DEFINITION ON INPUT_FORM_DEFINITION
(ONLINE_ITEM_DEFINITION_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3MED_ADMIN_MED_EVENT_INGRDT ON MED_ADMIN_MED_EVENT_INGRDNT
(IDENTIFICATION_PROCESS_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE3OPS_SCHEDULE_JOB_STEP ON OPS_SCHEDULE_JOB_STEP
(STATUS_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4ALT_SEL_CAT ON ALT_SEL_CAT
(OWNER_ID, LONG_DESCRIPTION_KEY_CAP)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4CV_RESPONSE ON CV_RESPONSE
(A4)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4MED_ADMIN_MED_EVENT_INGRDT ON MED_ADMIN_MED_EVENT_INGRDNT
(CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE4OPS_SCHEDULE_JOB_STEP ON OPS_SCHEDULE_JOB_STEP
(ACTIVE_STATUS_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIE50SCH_APPT_ORD ON SCH_APPT_ORD
(CANDIDATE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE5CV_RESPONSE ON CV_RESPONSE
(A5)
LOGGING
NOPARALLEL;


CREATE INDEX XIE6CV_RESPONSE ON CV_RESPONSE
(XREF_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE7CV_RESPONSE ON CV_RESPONSE
(RESPONSE_INTERNAL_NAME)
LOGGING
NOPARALLEL;


CREATE INDEX XIF002SELECTED_CRITERIA ON SELECTED_CRITERIA
(SELECTED_TASK_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF003SELECTED_CRITERIA ON SELECTED_CRITERIA
(PFT_TASK_CRITERIA_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF18PM_RPT_GROUP ON PM_RPT_GROUP
(FIELD_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF214ALT_SEL_LIST ON ALT_SEL_LIST
(SYNONYM_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF23PM_RPT_GROUP ON PM_RPT_GROUP
(HEADER_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF246ASSAY_TAT ON ASSAY_TAT
(SERVICE_RESOURCE_CD, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF247CATALOG_TAT ON CATALOG_TAT
(SERVICE_RESOURCE_CD, CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF251REPLACE_GROUPING ON REPLACE_GROUPING
(REPLACE_CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF260DATA_MAP ON DATA_MAP
(TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF28PM_RPT_GROUP ON PM_RPT_GROUP
(REPORT_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF346PROFILE_TASK_R ON PROFILE_TASK_R
(TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF431PROFILE_TASK_R ON PROFILE_TASK_R
(GROUP_CD, VERSION_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIF460GROUP_DEFINITION ON GROUP_DEFINITION
(TASK_ASSAY_CD, ONLINE_ITEM_VERSION_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIF461INPUT_FORM_DEFINITION ON INPUT_FORM_DEFINITION
(TASK_ASSAY_CD, ONLINE_ITEM_VERSION_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIF462INPUT_FORM_DEFINITION ON INPUT_FORM_DEFINITION
(GROUP_CD, GROUP_VERSION_NBR)
LOGGING
NOPARALLEL;


CREATE INDEX XIF560ORC_RESOURCE_LIST ON ORC_RESOURCE_LIST
(CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF58AP_PROCESSING_GRP_R ON AP_PROCESSING_GRP_R
(TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF628DATA_MAP ON DATA_MAP
(SERVICE_RESOURCE_CD, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF69CYTO_STANDARD_REPORT_R ON CYTO_STANDARD_RPT_R
(TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF725DIFFERENTIAL_REF_ASSAY ON DIFFERENTIAL_REF_ASSAY
(TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF76PROFILE_TASK_R ON PROFILE_TASK_R
(VERSION_NBR, GROUP_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKADVANCED_DELTA ON ADVANCED_DELTA
(ADVANCED_DELTA_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKALPHA_RESPONSES_CATEGORY ON ALPHA_RESPONSES_CATEGORY
(ALPHA_RESPONSES_CATEGORY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKALT_SEL_CAT ON ALT_SEL_CAT
(ALT_SEL_CATEGORY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKALT_SEL_LIST ON ALT_SEL_LIST
(ALT_SEL_CATEGORY_ID, SEQUENCE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAP_DC_STUDY_RPT_PROC ON AP_DC_STUDY_RPT_PROC
(STUDY_ID, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAP_DIAG_AUTO_CODE ON AP_DIAG_AUTO_CODE
(CATALOG_CD, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAP_PROCESSING_GRP_R ON AP_PROCESSING_GRP_R
(PARENT_ENTITY_NAME, PARENT_ENTITY_ID, SEQUENCE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAP_PROMPT_TEST ON AP_PROMPT_TEST
(ACCESSION_ID, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAP_SYNOPTIC_RPT_SECTION_R ON AP_SYNOPTIC_RPT_SECTION_R
(CKI_SOURCE, CKI_IDENTIFIER, CATALOG_CD, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAP_TASK_ASSAY_ADDL ON AP_TASK_ASSAY_ADDL
(TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKASSAY_TAT ON ASSAY_TAT
(TASK_ASSAY_CD, PRIORITY_CD, SERVICE_RESOURCE_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_ACTION ON AT_ACTION
(AC_ACTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_ACTIONPARAMETER ON AT_ACTIONPARAMETER
(ACP_ACTION_PARAM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_ACTIONSCREEN ON AT_ACTIONSCREEN
(AS_ACTION_SCREEN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_ALT_ACTION_NAME ON AT_ALT_ACTION_NAME
(AN_ALT_ACTION_NAME_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_APPACTION ON AT_APPACTION
(AA_APPLICATION_ID, AA_END_STATE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_BATCHDETAIL ON AT_BATCHDETAIL
(BD_BATCH_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_BATCHSTEP ON AT_BATCHSTEP
(BS_STEP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_LOG ON AT_LOG
(LG_DEVICE_ID, LG_LOG_DT_TM, LG_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_OBJECTIVE ON AT_OBJECTIVE
(OB_OBJECTIVE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_PRECONDITION ON AT_PRECONDITION
(PRE_KEYWORD_ID, PRE_ACTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_RUNSTEP ON AT_RUNSTEP
(RS_RUN_STEP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_STEP ON AT_STEP
(ST_STEP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_SUBACTION ON AT_SUBACTION
(SA_SUBACTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_SYNONYMTYPE ON AT_SYNONYMTYPE
(SY_SYNONYM_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_TIMER ON AT_TIMER
(TM_RUN_ID, TM_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBB_GROUP_COMPONENT ON BB_GROUP_COMPONENT
(BB_GROUP_COMPONENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBB_QC_EXPECTED_RESULT_R ON BB_QC_EXPECTED_RESULT_R
(EXPECTED_RESULT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBB_RH_PHENOTYPE ON BB_RH_PHENOTYPE
(RH_PHENOTYPE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBB_RH_PHENO_TESTING ON BB_RH_PHENO_TESTING
(RH_PHENO_TESTING_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBILL_ONLY_PROC_RELTN ON BILL_ONLY_PROC_RELTN
(CATALOG_CD, ENTITY_NAME, ENTITY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_DATAMART_DEFAULT ON BR_DATAMART_DEFAULT
(BR_DATAMART_DEFAULT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_DATAMART_DEFAULT_DETAIL ON BR_DATAMART_DEFAULT_DETAIL
(BR_DATAMART_DEFAULT_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKBR_OF_PARENT_RELTN ON BR_OF_PARENT_RELTN
(BR_CLIENT_ID, ALT_SEL_CATEGORY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCATALOG_EVENT_SETS ON CATALOG_EVENT_SETS
(CATALOG_CD, SEQUENCE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCATALOG_TAT ON CATALOG_TAT
(CATALOG_CD, PRIORITY_CD, SERVICE_RESOURCE_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCE_STRING_RESULT ON CE_STRING_RESULT
(EVENT_ID, VALID_UNTIL_DT_TM)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_ALLERGY_FORMAT ON CHART_ALLERGY_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_AP_FORMAT ON CHART_AP_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_DOC_FORMAT ON CHART_DOC_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_DYN_ZONE_FORM ON CHART_DYN_ZONE_FORM
(CHART_GROUP_ID, ZONE_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_FLEX_FORMAT ON CHART_FLEX_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_FORMAT_CODES ON CHART_FORMAT_CODES
(CF_CODE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_GENERIC_FORMAT ON CHART_GENERIC_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_GL_FORMAT ON CHART_GL_FORMAT
(CHART_GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_GRP_EVNT_SET ON CHART_GRP_EVNT_SET
(CHART_GROUP_ID, EVENT_SET_NAME, ORDER_CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_GRP_EVNT_SUPPRESS ON CHART_GRP_EVNT_SUPPRESS
(CHART_EVNT_SUPPRESS_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_ZN_RESULT_COL ON CHART_ZN_RESULT_COL
(COLUMN_SEQ, CHART_GROUP_ID, ZONE_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCHART_ZN_RESULT_COL_CDS ON CHART_ZN_RESULT_COL_CDS
(NORMALCY_CD, COLUMN_SEQ, CHART_GROUP_ID, ZONE_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCNT_DCP_INTERP_STATE ON CNT_DCP_INTERP_STATE
(CNT_DCP_INTERP_STATE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCNT_DTA_RRF_R ON CNT_DTA_RRF_R
(CNT_DTA_RRF_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCNT_GRID ON CNT_GRID
(CNT_GRID_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCNT_INPUT ON CNT_INPUT
(CNT_INPUT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCODE_SET_DOMAIN ON CODE_SET_DOMAIN
(REFERENCE, CODE_SET, FIELD_SEQUENCE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCOMMON_ALPHA_RESPONSES ON COMMON_ALPHA_RESPONSES
(ACTIVITY_TYPE_CD, NOMENCLATURE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCONDITIONAL_DTA ON CONDITIONAL_DTA
(CONDITIONAL_DTA_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCOND_EXPRESSION_COMP ON COND_EXPRESSION_COMP
(COND_EXPRESSION_COMP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCOST_ADJ ON COST_ADJ
(COST_ADJ_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCS_COMPONENT ON CS_COMPONENT
(CATALOG_CD, COMP_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCV_ORDER_CATEGORY_R ON CV_ORDER_CATEGORY_R
(CV_ORDER_CATEGORY_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCV_RESPONSE ON CV_RESPONSE
(RESPONSE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCV_STEP_REF ON CV_STEP_REF
(TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCV_XREF_VALIDATION ON CV_XREF_VALIDATION
(XREF_VALIDATION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCYTO_REPORT_CONTROL ON CYTO_REPORT_CONTROL
(CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCYTO_STANDARD_RPT ON CYTO_STANDARD_RPT
(STANDARD_RPT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCYTO_STANDARD_RPT_R ON CYTO_STANDARD_RPT_R
(STANDARD_RPT_ID, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDA_BV_LV_ELEM_RELTN ON DA_BV_LV_ELEM_RELTN
(DA_BV_LV_ELEM_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDA_CALC_ELEM_RELTN ON DA_CALC_ELEM_RELTN
(DA_CALC_ELEM_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDD_REF_EMR_CONTENT ON DD_REF_EMR_CONTENT
(DD_REF_EMR_CONTENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDEPT_DUP_CHECK ON DEPT_DUP_CHECK
(CATALOG_CD, DUP_CATALOG_CD, PRIORITY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDIFFERENTIAL_REF ON DIFFERENTIAL_REF
(DIF_REF_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDIFFERENTIAL_REF_ASSAY ON DIFFERENTIAL_REF_ASSAY
(DIF_REF_ID, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDRUG_CLASS_INT_CSTM_ENT_R ON DRUG_CLASS_INT_CSTM_ENTITY_R
(DRUG_CLASS_INT_CSTM_ENT_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKDUP_CHECKING ON DUP_CHECKING
(CATALOG_CD, DUP_CHECK_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_ABN_DATA ON EEM_ABN_DATA
(ABN_ATTR_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_ABN_RULE ON EEM_ABN_RULE
(ABN_RULE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_BENEFIT_QUAL ON EEM_BENEFIT_QUAL
(BENEFIT_QUAL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_ENTITY_NTWK_RELTN ON EEM_ENTITY_NTWK_RELTN
(ENTITY_NTWK_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_ENTITY_PROV_TAX_RELTN ON EEM_ENTITY_PROV_TAX_RELTN
(EEM_ENTITY_PROV_TAX_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEEM_SERVICE_LIST ON EEM_SERVICE_LIST
(SERVICE_LIST_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKEXAM_REASON ON EXAM_REASON
(CATALOG_CD, EXAM_REASON_ID, SEQUENCE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFILM_USAGE ON FILM_USAGE
(CATALOG_CD, FILM_TYPE_CD, FILM_SIZE_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKFORM_ASSOCIATION ON FORM_ASSOCIATION
(FORM_ASSOCIATION_ID, SEQUENCE_NBR)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKGROUP_DEFINITION ON GROUP_DEFINITION
(GROUP_CD, GROUP_VERSION_NBR, GROUP_DEF_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHIM_HAC_CRITERIA ON HIM_HAC_CRITERIA
(HIM_HAC_CRITERIA_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHLA_AB_SCREEN_HISTORY_MAP ON HLA_AB_SCREEN_HISTORY_MAP
(CATALOG_CD, SEQ_NUMBER)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHLA_NOMEN_CODE_R ON HLA_NOMEN_CODE_R
(NOMENCLATURE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHLA_XM_HISTORY_MAP ON HLA_XM_HISTORY_MAP
(CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKHM_EXPECT_SAT ON HM_EXPECT_SAT
(EXPECT_SAT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKINPUT_FORM_DEFINITION ON INPUT_FORM_DEFINITION
(INPUT_FORM_CD, INPUT_FORM_VERSION_NBR, INPUT_FORM_DEF_SEQ)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKLH_ABS_ED_METRICS ON LH_ABS_ED_METRICS
(LH_ABS_ED_METRICS_ID, HEALTH_SYSTEM_SOURCE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKLH_ABS_STROKE_METRICS ON LH_ABS_STROKE_METRICS
(LH_ABS_STROKE_METRICS_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKLH_ABS_VTE_METRICS ON LH_ABS_VTE_METRICS
(LH_ABS_VTE_METRICS_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMED_ADMIN_MED_EVENT_INGRDNT ON MED_ADMIN_MED_EVENT_INGRDNT
(MED_EVENT_INGREDIENT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMIC_QC_NUMERIC_TASK_DETAIL ON MIC_QC_NUMERIC_TASK_DETAIL
(NUMERIC_TASK_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_ADDITIONAL_TEXT ON MLTM_ADDITIONAL_TEXT
(DRUG_IDENTIFIER, TEXT_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_ALR_CATEGORY_DRUG_MAP ON MLTM_ALR_CATEGORY_DRUG_MAP
(DRUG_IDENTIFIER, ALR_CATEGORY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_CATEGORY_DRUG_XREF ON MLTM_CATEGORY_DRUG_XREF
(MULTUM_CATEGORY_ID, DRUG_IDENTIFIER)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_DDM_GROUP_MMDC_MAP ON MLTM_DDM_GROUP_MMDC_MAP
(GROUP_ID, MAIN_MULTUM_DRUG_CODE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_DRC_GROUP_RELTN ON MLTM_DRC_GROUP_RELTN
(GROUPER_ID, SYNONYM_ID, MAIN_MULTUM_DRUG_CODE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMLTM_MMDC_ATTRIBUTE ON MLTM_MMDC_ATTRIBUTE
(MAIN_MULTUM_DRUG_CODE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMMR_QI_QUESTION_NUM_RSLT ON MMR_QI_QUESTION_NUM_RSLT
(RESULT_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKMRU_LOOKUP_ORDER ON MRU_LOOKUP_ORDER
(MRU_LOOKUP_ORDER_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKNMDP_ALLELE_XREF ON NMDP_ALLELE_XREF
(NMDP_CODE_ID, ALLELE_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOCS_ATTR_XCPTN ON OCS_ATTR_XCPTN
(OCS_ATTR_XCPTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOCS_FACILITY_FORMULARY_R ON OCS_FACILITY_FORMULARY_R
(OCS_FACILITY_FORMULARY_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOCS_FACILITY_R ON OCS_FACILITY_R
(SYNONYM_ID, FACILITY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOPS_DAY_OF_MONTH ON OPS_DAY_OF_MONTH
(OPS_DAY_OF_MONTH_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOPS_DAY_OF_WEEK ON OPS_DAY_OF_WEEK
(OPS_DAY_OF_WEEK_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOPS_SCHEDULE_JOB_STEP ON OPS_SCHEDULE_JOB_STEP
(OPS_SCHEDULE_JOB_STEP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKOPS_SCHED_DEP ON OPS_SCHED_DEP
(OPS_SCHED_DEP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKORC_CUSTOM_SEL ON ORC_CUSTOM_SEL
(ORC_CUSTOM_SEL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKORC_CUSTOM_SEL_RELTN ON ORC_CUSTOM_SEL_RELTN
(ORC_CUSTOM_SEL_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKORC_RESOURCE_LIST ON ORC_RESOURCE_LIST
(SERVICE_RESOURCE_CD, CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPBS_AUTHORITY ON PBS_AUTHORITY
(PBS_AUTHORITY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPBS_CAUTION_RELTN ON PBS_CAUTION_RELTN
(PBS_CAUTION_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPBS_DRUG ON PBS_DRUG
(PBS_DRUG_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPBS_OCS_MAPPING ON PBS_OCS_MAPPING
(PBS_OCS_MAPPING_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPCA_MEASURE_OUTCOME_RELTN ON PCA_MEASURE_OUTCOME_RELTN
(PCA_MEASURE_OUTCOME_RELTN_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPFT_SEL_TASK_R ON PFT_SEL_TASK_R
(PFT_SEL_TASK_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPFT_SUB_TYPE_SECURITY ON PFT_SUB_TYPE_SECURITY
(PFT_SUB_TYPE_SECURITY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPG_AVAIL_RESPONSE ON PG_AVAIL_RESPONSE
(PG_AVAIL_RESPONSE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPG_AVAIL_RESPONSE_LIST ON PG_AVAIL_RESPONSE_LIST
(PG_AVAIL_RESPONSE_LIST_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPG_AVAIL_RESPONSE_R ON PG_AVAIL_RESPONSE_R
(PG_AVAIL_RESPONSE_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPG_RESULT_LIST ON PG_RESULT_LIST
(PG_RESULT_LIST_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPM_RPT_GROUP ON PM_RPT_GROUP
(GROUP_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPOSITIVE_TUBES ON POSITIVE_TUBES
(LOT_NUMBER_ID, ALLELE_CD, TUBE_NUMBER)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKPROFILE_TASK_R ON PROFILE_TASK_R
(CATALOG_CD, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKQC_SCHD_STEP_CTRL_ASSAY ON QC_SCHD_STEP_CTRL_ASSAY
(QC_SCHD_STEP_CTRL_ASSAY_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKRAD_TECH_FMT_ERPRC_OVRD ON RAD_TECH_FMT_ERPRC_OVRD
(FORMAT_OVRD_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKREPLACE_GROUPING ON REPLACE_GROUPING
(CATALOG_CD, REPLACE_CATALOG_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKREPORT_INPROC_STATUS ON REPORT_INPROC_STATUS
(CATALOG_CD, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKROUND_ROBIN_COMMENT ON ROUND_ROBIN_COMMENT
(ROUND_ROBIN_REF_ID, ACCESSION_ID, SERVICE_RESOURCE_CD, SEQUENCE)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSCH_APPT_ORD ON SCH_APPT_ORD
(APPT_TYPE_CD, REQUIRED_IND, SEQ_NBR)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSCR_PARAGRAPH ON SCR_PARAGRAPH
(SCR_PATTERN_ID, SCR_PARAGRAPH_TYPE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSELECTED_CRITERIA ON SELECTED_CRITERIA
(SELECTED_CRITERIA_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSIGN_LINE_LAYOUT_FIELD_R ON SIGN_LINE_LAYOUT_FIELD_R
(SIGN_LINE_LAYOUT_FIELD_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSI_OEN_CHANN_ENDPOINT_R ON SI_OEN_CHANN_ENDPOINT_R
(SI_OEN_CHANN_ENDPOINT_R_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSN_CT_DISPLAY_FIELD ON SN_CT_DISPLAY_FIELD
(SN_CT_DISPLAY_FIELD_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKSTRT_BMDI_MODEL_NOMENCLA ON STRT_BMDI_MODEL_NOMENCLATURE
(STRT_MODEL_NOMENCLATURE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKTPL_APPL_DETAIL ON TPL_APPL_DETAIL
(APPL_DETAIL_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKUCMR_CASE_GRP_STEP_R ON UCMR_CASE_GRP_STEP_R
(UCMR_CASE_GRP_STEP_R_ID)
LOGGING
NOPARALLEL;


CREATE TABLE ALPHA_RESPONSES
(
  REFERENCE_RANGE_FACTOR_ID    NUMBER           DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID              NUMBER           DEFAULT 0                     NOT NULL,
  SEQUENCE                     NUMBER           DEFAULT 0                     NOT NULL,
  USE_UNITS_IND                NUMBER,
  RESULT_PROCESS_CD            NUMBER           DEFAULT 0                     NOT NULL,
  DEFAULT_IND                  NUMBER,
  DESCRIPTION                  VARCHAR2(100 BYTE),
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  RESULT_VALUE                 NUMBER,
  REFERENCE_IND                NUMBER,
  MULTI_ALPHA_SORT_ORDER       NUMBER,
  ALPHA_RESPONSES_CATEGORY_ID  NUMBER           DEFAULT 0                     NOT NULL,
  CONCEPT_CKI                  VARCHAR2(255 BYTE) DEFAULT ' ',
  TRUTH_STATE_CD               NUMBER           DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALPHA_RESPONSE_RULE
(
  ALPHA_RESPONSE_RULE_ID     NUMBER             DEFAULT 0                     NOT NULL,
  REF_RANGE_FACTOR_RULE_ID   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID     NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM        DATE,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID            NUMBER             DEFAULT 0                     NOT NULL,
  REFERENCE_RANGE_FACTOR_ID  NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_POPUPACTIVITY
(
  PA_WINDOW_ID     NUMBER                       DEFAULT 0                     NOT NULL,
  PA_ACTION_ID     NUMBER                       DEFAULT 0                     NOT NULL,
  PA_NUM_MATCHS    NUMBER,
  PA_NUM_SUCCESS   NUMBER,
  PA_LAST_RUN_ID   NUMBER                       DEFAULT 0                     NOT NULL,
  PA_LAST_STEP_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CYTO_ADEQUACY_ALPHA_R
(
  TASK_ASSAY_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  ADEQUACY_FLAG        NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  REASON_REQUIRED_IND  NUMBER,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CYTO_DIAG_DISCREPANCY
(
  REFERENCE_RANGE_FACTOR_ID  NUMBER             DEFAULT 0                     NOT NULL,
  NOMENCLATURE_X_ID          NUMBER             DEFAULT 0                     NOT NULL,
  NOMENCLATURE_Y_ID          NUMBER             DEFAULT 0                     NOT NULL,
  HCFA_FLAG                  NUMBER,
  INTERNAL_FLAG              NUMBER,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CYTO_ENDOCERV_ALPHA_R
(
  TASK_ASSAY_CD    NUMBER                       DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  ENDOCERV_IND     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  CATALOG_CD       NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_TASK_PROFILE_XREF
(
  CATALOG_CD         NUMBER                     DEFAULT 0                     NOT NULL,
  REFERENCE_TASK_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD      NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE INDEX XIE1ALPHA_RESPONSES ON ALPHA_RESPONSES
(NOMENCLATURE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE1ALPHA_RESPONSE_RULE ON ALPHA_RESPONSE_RULE
(REF_RANGE_FACTOR_RULE_ID, REFERENCE_RANGE_FACTOR_ID, NOMENCLATURE_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIE2ALPHA_RESPONSES ON ALPHA_RESPONSES
(ALPHA_RESPONSES_CATEGORY_ID)
LOGGING
NOPARALLEL;


CREATE INDEX XIF29ORDER_TASK_PROFILE_XREF ON ORDER_TASK_PROFILE_XREF
(CATALOG_CD, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF74CYTO_ENDOCERV_ALPHA_R ON CYTO_ENDOCERV_ALPHA_R
(TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE INDEX XIF75CYTO_ADEQUACY_ALPHA_R ON CYTO_ADEQUACY_ALPHA_R
(TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKALPHA_RESPONSES ON ALPHA_RESPONSES
(REFERENCE_RANGE_FACTOR_ID, NOMENCLATURE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKALPHA_RESPONSE_RULE ON ALPHA_RESPONSE_RULE
(ALPHA_RESPONSE_RULE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKAT_POPUPACTIVITY ON AT_POPUPACTIVITY
(PA_WINDOW_ID, PA_ACTION_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCYTO_ADEQUACY_ALPHA_R ON CYTO_ADEQUACY_ALPHA_R
(CATALOG_CD, TASK_ASSAY_CD, NOMENCLATURE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCYTO_DIAG_DISCREPANCY ON CYTO_DIAG_DISCREPANCY
(REFERENCE_RANGE_FACTOR_ID, NOMENCLATURE_X_ID, NOMENCLATURE_Y_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKCYTO_ENDOCERV_ALPHA_R ON CYTO_ENDOCERV_ALPHA_R
(CATALOG_CD, TASK_ASSAY_CD, NOMENCLATURE_ID)
LOGGING
NOPARALLEL;


CREATE UNIQUE INDEX XPKORDER_TASK_PROFILE_XREF ON ORDER_TASK_PROFILE_XREF
(CATALOG_CD, REFERENCE_TASK_ID, TASK_ASSAY_CD)
LOGGING
NOPARALLEL;


CREATE TABLE ABN_RULE
(
  ABN_RULE_ID             NUMBER                DEFAULT 0                     NOT NULL,
  FIN_CLASS_CD            NUMBER                DEFAULT 0                     NOT NULL,
  CARRIER_ID              NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CD          NUMBER                DEFAULT 0                     NOT NULL,
  CPT_NOMEN_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ICD9_NOMEN_ID           NUMBER                DEFAULT 0                     NOT NULL,
  VALID_DIAG_FLG          NUMBER                DEFAULT 0,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  URL                     VARCHAR2(100 BYTE),
  AGE_RESTRICTION_CODE    VARCHAR2(50 BYTE),
  SEX_RESTRICTION_CODE    VARCHAR2(10 BYTE),
  ACTION_CD               NUMBER                DEFAULT 0                     NOT NULL,
  ACTION_CD_DT_TM         DATE,
  HEALTH_PLAN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  POLICY_NUMBER           NUMBER,
  POLICY_NAME             VARCHAR2(100 BYTE),
  POLICY_DISCRIPTION      VARCHAR2(200 BYTE),
  TYPE_CD                 NUMBER                DEFAULT 0                     NOT NULL,
  PARAMETER_CD            NUMBER                DEFAULT 0                     NOT NULL,
  FREQUENCY_REST_CODE     VARCHAR2(50 BYTE),
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  INFOX_POLICY_NUMBER     VARCHAR2(100 BYTE),
  MEDICARE_POLICY_NUMBER  VARCHAR2(100 BYTE),
  FIN_GROUP_CD            NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_GROUP_CD         NUMBER                DEFAULT 0                     NOT NULL,
  ACTION_CODE             VARCHAR2(200 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ABO_TESTING
(
  ABO_TESTING_ID          NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ABO_GROUP_CD            NUMBER                DEFAULT 0                     NOT NULL,
  RH_TYPE_CD              NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_EVENT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  CURRENT_UPDATED_IND     NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ABSTRACTING
(
  ABSTRACTING_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  COMPLETED_DT_TM         DATE,
  CREATE_DT_TM            DATE,
  CREATE_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  SVC_CAT_HIST_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_ID         NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ABSTRACT_DATA
(
  ABSTRACT_DATA_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ABSTRACT_FIELD_DEF_CD   NUMBER                DEFAULT 0                     NOT NULL,
  ABSTRACT_FIELD_TYPE_CD  NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_FREE_TEXT         VARCHAR2(255 BYTE),
  VALUE_CD                NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_DT_TM             DATE,
  VALUE_NUMBER            NUMBER,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  SVC_CAT_HIST_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_ID         NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ABST_CODING_RELTN
(
  ABST_CODING_RELTN_ID    NUMBER                DEFAULT 0                     NOT NULL,
  ABSTRACT_FIELD_DEF_CD   NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(255 BYTE),
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  SVC_CAT_HIST_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_ID         NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACCEPT_QUAR_PROD_R
(
  ACCEPT_QUAR_PROD_ID     NUMBER                DEFAULT 0                     NOT NULL,
  ACCEPT_QUAR_REASON_ID   NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_CD              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACCEPT_QUAR_REASON
(
  ACCEPT_QUAR_REASON_ID   NUMBER                DEFAULT 0                     NOT NULL,
  ORG_SHIPMENT_ID         NUMBER                DEFAULT 0                     NOT NULL,
  QUAR_REASON_CD          NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACCESSION_ORDER_R
(
  ACCESSION_ID      NUMBER                      DEFAULT 0                     NOT NULL,
  ORDER_ID          NUMBER                      DEFAULT 0                     NOT NULL,
  ACCESSION         VARCHAR2(20 BYTE),
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  PRIMARY_IND       NUMBER,
  ACTIVITY_TYPE_CD  NUMBER                      DEFAULT 0                     NOT NULL,
  PRIMARY_FLAG      NUMBER                      DEFAULT 0                     NOT NULL,
  RESTRICT_AV_IND   NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACCOUNT
(
  ACCT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  ACCT_TEMPL_ID              NUMBER             DEFAULT 0                     NOT NULL,
  ACCT_TYPE_CD               NUMBER             DEFAULT 0                     NOT NULL,
  EXT_ACCT_ID_TXT            CHAR(50 BYTE),
  ACCT_DESC                  VARCHAR2(250 BYTE),
  ACCT_STATUS_CD             NUMBER             DEFAULT 0                     NOT NULL,
  ACCT_BALANCE               FLOAT(126),
  HI_ACCT_BALANCE            FLOAT(126),
  CONSOLIDATION_IND          NUMBER,
  STATUS_REASON_CD           NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_IND                 NUMBER,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM        DATE,
  ACTIVE_STATUS_PRSNL_ID     NUMBER             DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM        DATE               DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM        DATE               DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  DR_CR_FLAG                 NUMBER,
  COL_LETTER_IND             NUMBER,
  DUNNING_IND                NUMBER,
  EXT_ACCT_ID_TXT_KEY        VARCHAR2(250 BYTE),
  PENDING_ACCT_BAL           FLOAT(126),
  PEND_DR_CR_FLAG            NUMBER,
  PRSNL_SEC_IND              NUMBER,
  SEND_COL_IND               NUMBER,
  ACCT_SUB_TYPE_CD           NUMBER             DEFAULT 0                     NOT NULL,
  ADJUSTMENT_BALANCE         FLOAT(126),
  ADJ_BAL_DR_CR_FLAG         NUMBER,
  APPLIED_PAYMENT_BALANCE    FLOAT(126),
  CHARGE_BALANCE             FLOAT(126),
  CHRG_BAL_DR_CR_FLAG        NUMBER,
  UNAPPLIED_PAYMENT_BALANCE  FLOAT(126),
  CREATED_DT_TM              DATE               DEFAULT SYSDATE,
  CREATED_PRSNL_ID           NUMBER             DEFAULT 0                     NOT NULL,
  LAST_CHARGE_DT_TM          DATE,
  LAST_PAYMENT_DT_TM         DATE,
  PAYMENT_PLAN_IND           NUMBER,
  BAD_DEBT_BALANCE           FLOAT(126)         DEFAULT 0.0                   NOT NULL,
  BAD_DEBT_BAL_DR_CR_FLAG    NUMBER             DEFAULT 0                     NOT NULL,
  SUPPRESS_FLAG              NUMBER             DEFAULT 0                     NOT NULL,
  GLOBAL_OVERRIDE_IND        NUMBER             DEFAULT 0                     NOT NULL,
  SUPPRESS_IND               NUMBER             DEFAULT 0                     NOT NULL,
  LAST_ADJUSTMENT_DT_TM      DATE,
  LAST_CLAIM_DT_TM           DATE,
  LAST_STMT_DT_TM            DATE,
  LAST_PATIENT_PAY_DT_TM     DATE,
  BILLING_ENTITY_ID          NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACCRED_SYSTEM
(
  ACCRED_SYSTEM_ID          NUMBER              DEFAULT 0                     NOT NULL,
  ACCRED_SYSTEM_IDENT       VARCHAR2(250 BYTE)  DEFAULT ' '                   NOT NULL,
  ORGANIZATION_ID           NUMBER              DEFAULT 0                     NOT NULL,
  SERVICE_NAME              VARCHAR2(250 BYTE)  DEFAULT ' '                   NOT NULL,
  INTERACTION_NAME          VARCHAR2(250 BYTE)  DEFAULT ' '                   NOT NULL,
  INTERACTION_VERSION_TEXT  VARCHAR2(250 BYTE)  DEFAULT ' '                   NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  PARTY_KEY_TXT             VARCHAR2(250 BYTE)  DEFAULT ' '                   NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACCT_BALANCE
(
  ACCOUNT_SUB_TYPE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  ACCOUNT_TYPE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  ACCT_BALANCE            FLOAT(126),
  ACCT_BALANCE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ACCT_BAL_DR_CR_FLAG     NUMBER,
  ACCT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ADJUSTMENTS             FLOAT(126),
  ADJ_DR_CR_FLAG          NUMBER,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  CHARGES                 FLOAT(126),
  CHRG_DR_CR_FLAG         NUMBER,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  EXT_ACCT_ID_TXT         CHAR(50 BYTE),
  PAYMENTS                FLOAT(126),
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PMTS_DR_CR_FLAG         NUMBER,
  PREVIOUS_BALANCE        FLOAT(126),
  PREVIOUS_DR_CR_FLAG     NUMBER,
  RAW_ACCT_BALANCE        FLOAT(126),
  RAW_ACCT_BALANCE_FLAG   NUMBER,
  UPDATE_IND              NUMBER,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  TRANSFER_AMOUNT         FLOAT(126),
  TRANSFER_DR_CR_FLAG     NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACCT_GROUP_RELTN
(
  ACCT_GROUP_R_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ACCT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  BT_COND_CRIT_R_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACCT_PRSNL_GROUP_R
(
  ACCT_PRSNL_GROUP_R_ID   NUMBER                DEFAULT 0                     NOT NULL,
  PFT_PRSNL_GROUP_ID      NUMBER                DEFAULT 0                     NOT NULL,
  ACCT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACCT_TYPE_GL_ALIAS_RELTN
(
  ACCT_TYPE_GL_ALIAS_RELTN_ID  NUMBER           DEFAULT 0                     NOT NULL,
  ACCT_TYPE_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  GL_ALIAS_ID                  NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE ( '12/31/210000:00:00' , 'MM/DD/YYYYHH24:MI:SS' ),
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACQUIREMENT_INFO
(
  LOCATION_CD               NUMBER              DEFAULT 0                     NOT NULL,
  ITEM_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  PRIMARY_VENDOR_ITEM_ID    NUMBER              DEFAULT 0                     NOT NULL,
  REORDER_PACKAGE_TYPE_ID   NUMBER              DEFAULT 0                     NOT NULL,
  FILL_LOCATION_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ECONOMIC_ORDER_QTY        NUMBER,
  AVERAGE_LEAD_TIME         NUMBER,
  AVERAGE_LEAD_TIME_UOM_CD  NUMBER              DEFAULT 0                     NOT NULL,
  PRODUCT_ORIGIN_CD         NUMBER              DEFAULT 0                     NOT NULL,
  SYSCALC_EOQ_IND           NUMBER,
  PRIMARY_VENDOR_CD         NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  VENDOR_SITE_ID            NUMBER              DEFAULT 0                     NOT NULL,
  CONSIGNMENT_IND           NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACTIVITY_DATA_RELTN
(
  ACTIVITY_DATA_RELTN_ID   NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVITY_ENTITY_NAME     VARCHAR2(30 BYTE)    DEFAULT ' '                   NOT NULL,
  ACTIVITY_ENTITY_ID       NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVITY_ENTITY_INST_ID  NUMBER               DEFAULT 0                     NOT NULL,
  RELTN_ENTITY_NAME        VARCHAR2(30 BYTE)    DEFAULT ' '                   NOT NULL,
  RELTN_ENTITY_ID          NUMBER               DEFAULT 0                     NOT NULL,
  RELTN_ENTITY_ALL_IND     NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACTIVITY_LOG
(
  ACTIVITY_ID             NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVITY_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVITY_DT_TM          DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  CREATED_DT_TM           DATE                  DEFAULT SYSDATE,
  CREATED_PRSNL_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ACTION_CODE             VARCHAR2(20 BYTE),
  EVENT_CD                NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCTIVITY_FLAG       NUMBER,
  PRODUCTIVITY_WEIGHT     FLOAT(126)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACTIVITY_PRIVILEGE_RELTN
(
  ACTIVITY_PRIVILEGE_RELTN_ID  NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVITY_PRIVILEGE_DEF_ID    NUMBER           DEFAULT 0                     NOT NULL,
  PRIVILEGE_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACT_CARE_CAT
(
  ACT_CARE_CAT_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  CARE_CATEGORY_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  CARE_CATEGORY_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  PATHWAY_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  SEQUENCE               NUMBER                 DEFAULT 0                     NOT NULL,
  DESCRIPTION            VARCHAR2(100 BYTE)     DEFAULT ' '                   NOT NULL,
  ACTIVE_IND             NUMBER,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  RESTRICT_COMP_ADD_IND  NUMBER,
  COMP_ADD_VARIANCE_IND  NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACT_PW_COMP
(
  ACT_PW_COMP_ID                  NUMBER        DEFAULT 0                     NOT NULL,
  ACT_TIME_FRAME_ID               NUMBER        DEFAULT 0                     NOT NULL,
  ACT_CARE_CAT_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  SEQUENCE                        NUMBER        DEFAULT 0                     NOT NULL,
  PATHWAY_ID                      NUMBER        DEFAULT 0                     NOT NULL,
  PATHWAY_COMP_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  COMP_TYPE_CD                    NUMBER        DEFAULT 0                     NOT NULL,
  REF_PRNT_ENT_NAME               VARCHAR2(32 BYTE),
  REF_PRNT_ENT_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  REPEAT_IND                      NUMBER,
  REQUIRED_IND                    NUMBER,
  COMP_STATUS_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  ENCNTR_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  PERSON_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME              VARCHAR2(32 BYTE),
  PARENT_ENTITY_ID                NUMBER        DEFAULT 0                     NOT NULL,
  ORIG_PRNT_ENT_ID                NUMBER        DEFAULT 0                     NOT NULL,
  EXISTING_IND                    NUMBER,
  COMP_LABEL                      VARCHAR2(255 BYTE),
  RELATED_COMP_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  AFTER_QTY                       NUMBER,
  AGE_UNITS_CD                    NUMBER        DEFAULT 0                     NOT NULL,
  CREATED_DT_TM                   DATE,
  INCLUDED_IND                    NUMBER,
  INCLUDED_DT_TM                  DATE,
  CANCELED_IND                    NUMBER,
  CANCELED_DT_TM                  DATE,
  ACTIVATED_IND                   NUMBER,
  ACTIVATED_PRSNL_ID              NUMBER        DEFAULT 0                     NOT NULL,
  ACTIVATED_DT_TM                 DATE,
  ACTIVE_IND                      NUMBER,
  LAST_ACTION_SEQ                 NUMBER,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  DURATION_QTY                    NUMBER,
  DURATION_UNIT_CD                NUMBER        DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD                   NUMBER        DEFAULT 0                     NOT NULL,
  EVENT_CD                        NUMBER        DEFAULT 0                     NOT NULL,
  RESULT_TYPE_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  OUTCOME_OPERATOR_CD             NUMBER        DEFAULT 0                     NOT NULL,
  RESULT_VALUE                    FLOAT(126),
  RESULT_UNITS_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  CAPTURE_VARIANCE_IND            NUMBER,
  VARIANCE_REQUIRED_IND           NUMBER,
  DCP_FORMS_REF_ID                NUMBER        DEFAULT 0                     NOT NULL,
  START_DT_TM                     DATE,
  END_DT_TM                       DATE,
  COND_IND                        NUMBER,
  COND_DESC                       VARCHAR2(100 BYTE),
  COND_NOTE_ID                    NUMBER        DEFAULT 0                     NOT NULL,
  COND_MODULE_NAME                VARCHAR2(30 BYTE),
  COND_FALSE_IND                  NUMBER,
  COND_EVAL_DT_TM                 DATE,
  COND_EVAL_IND                   NUMBER,
  COND_EVAL_RESULT_IND            NUMBER,
  RRF_AGE_QTY                     NUMBER,
  RRF_AGE_UNITS_CD                NUMBER        DEFAULT 0                     NOT NULL,
  RRF_SEX_CD                      NUMBER        DEFAULT 0                     NOT NULL,
  COND_SYS_EVAL_IND               NUMBER,
  COND_EVAL_PRSNL_ID              NUMBER        DEFAULT 0                     NOT NULL,
  REFERENCE_TASK_ID               NUMBER        DEFAULT 0                     NOT NULL,
  LINKED_TO_TF_IND                NUMBER,
  OUTCOME_FORMS_REF_ID            NUMBER        DEFAULT 0                     NOT NULL,
  DCP_CLIN_CAT_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  DCP_CLIN_SUB_CAT_CD             NUMBER        DEFAULT 0                     NOT NULL,
  PERSISTENT_IND                  NUMBER,
  ORDER_SENTENCE_ID               NUMBER        DEFAULT 0                     NOT NULL,
  OFFSET_QUANTITY                 FLOAT(126),
  OFFSET_UNIT_CD                  NUMBER,
  DEFAULT_ORD_SENT_DISP           VARCHAR2(255 BYTE),
  CHEMO_RELATED_IND               NUMBER        DEFAULT 0,
  CHEMO_IND                       NUMBER        DEFAULT 0,
  CROSS_PHASE_GROUP_IND           NUMBER        DEFAULT 0,
  CROSS_PHASE_GROUP_NBR           FLOAT(126)    DEFAULT 0,
  LONG_BLOB_ID                    NUMBER        DEFAULT 0,
  CREATED_TZ                      NUMBER,
  ACTIVATED_TZ                    NUMBER,
  INCLUDED_TZ                     NUMBER,
  DOSE_INFO_HIST_BLOB_ID          NUMBER        DEFAULT 0,
  DEFAULT_OS_IND                  NUMBER        DEFAULT 1,
  MISSING_REQUIRED_IND            NUMBER        DEFAULT 0,
  ACT_PW_COMP_GROUP_NBR           FLOAT(126)    DEFAULT 0,
  REJECT_PROTOCOL_REVIEW_IND      NUMBER        DEFAULT 0,
  MIN_TOLERANCE_INTERVAL_UNIT_CD  NUMBER        DEFAULT 0,
  MIN_TOLERANCE_INTERVAL          NUMBER        DEFAULT 0,
  DISPLAY_FORMAT_XML              VARCHAR2(1000 BYTE) DEFAULT ' ',
  UNLINK_START_DT_TM_IND          NUMBER        DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACT_PW_COMP_FOCUS_R
(
  ACT_PW_COMP_FOCUS_R_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACT_PW_COMP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PRIMARY_IND             NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACT_PW_COMP_G
(
  ACT_PW_COMP_G_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  PATHWAY_ID        NUMBER                      DEFAULT 0                     NOT NULL,
  ACT_PW_COMP_ID    NUMBER                      DEFAULT 0                     NOT NULL,
  TYPE_MEAN         VARCHAR2(12 BYTE)           DEFAULT ' '                   NOT NULL,
  PW_COMP_SEQ       NUMBER,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  INCLUDED_IND      NUMBER                      DEFAULT 0,
  DESCRIPTION       VARCHAR2(99 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACT_PW_COMP_R
(
  ACT_PW_COMP_S_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ACT_PW_COMP_T_ID        NUMBER                DEFAULT 0                     NOT NULL,
  TYPE_MEAN               VARCHAR2(12 BYTE)     DEFAULT ' '                   NOT NULL,
  OFFSET_QTY              NUMBER,
  OFFSET_UNIT_CD          NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  OFFSET_QUANTITY         FLOAT(126),
  PATHWAY_ID              NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACT_PW_FOCUS
(
  ACT_PW_FOCUS_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  PATHWAY_ID         NUMBER                     DEFAULT 0                     NOT NULL,
  PATHWAY_LEVEL_IND  NUMBER                     DEFAULT 0                     NOT NULL,
  STATUS_CD          NUMBER                     DEFAULT 0                     NOT NULL,
  STATUS_DT_TM       DATE                       DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  STATUS_PRSNL_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  LAST_ACTION_SEQ    NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  ACTIVE_IND         NUMBER                     DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  SEQUENCE           NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACT_PW_FOCUS_ACTION
(
  ACT_PW_FOCUS_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  ACTION_SEQ       NUMBER                       DEFAULT 0                     NOT NULL,
  STATUS_CD        NUMBER                       DEFAULT 0                     NOT NULL,
  ACTION_DT_TM     DATE                         DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ACTION_PRSNL_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ACUTE_CARE_AUDIT_INFO
(
  ACUTE_CARE_AUDIT_INFO_ID  NUMBER              DEFAULT 0                     NOT NULL,
  AUDIT_PATIENT_ID          NUMBER              DEFAULT 0                     NOT NULL,
  AUDIT_PRSNL_ID            NUMBER              DEFAULT 0                     NOT NULL,
  POSITION_CD               NUMBER              DEFAULT 0                     NOT NULL,
  AUDIT_SOLUTION_CD         NUMBER              DEFAULT 0                     NOT NULL,
  AUDIT_EVENT_TYPE_CD       NUMBER              DEFAULT 0                     NOT NULL,
  AUDIT_EVENT_DT_TM         DATE                DEFAULT SYSDATE               NOT NULL,
  AUDIT_FACILITY_CD         NUMBER              DEFAULT 0                     NOT NULL,
  AUDIT_INFORMATION_TEXT    VARCHAR2(255 BYTE),
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AC_CLASS_DEF
(
  AC_CLASS_DEF_ID               NUMBER          DEFAULT 0                     NOT NULL,
  LOGICAL_DOMAIN_ID             NUMBER          DEFAULT 0                     NOT NULL,
  CLASS_TYPE_FLAG               NUMBER          DEFAULT 0                     NOT NULL,
  CLASS_DISPLAY_NAME            VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  CLASS_DISPLAY_NAME_KEY        VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  BEGIN_EFFECTIVE_DT_TM         DATE            DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM           DATE            DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_IND                    NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  CLASS_DISPLAY_NAME_KEY_A_NLS  VARCHAR2(1020 BYTE) DEFAULT ' ' NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AC_CLASS_HE_RULE
(
  AC_CLASS_HE_RULE_ID     NUMBER                DEFAULT 0                     NOT NULL,
  AC_CLASS_DEF_ID         NUMBER                DEFAULT 0                     NOT NULL,
  HEALTH_EXPERT_RULE_TXT  VARCHAR2(255 BYTE)    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AC_CLASS_PERSON_RELTN
(
  AC_CLASS_PERSON_RELTN_ID      NUMBER          DEFAULT 0                     NOT NULL,
  PARENT_CLASS_PERSON_RELTN_ID  NUMBER          DEFAULT 0                     NOT NULL,
  PERSON_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  AC_CLASS_DEF_ID               NUMBER          DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID               NUMBER          DEFAULT 0                     NOT NULL,
  LOCATION_CD                   NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_IND                    NUMBER          DEFAULT 0                     NOT NULL,
  BEGIN_EFFECTIVE_DT_TM         DATE            DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM           DATE            DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  INDEPENDENT_PARENT_IND        NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ADDITIONAL_AMOUNT_DEF
(
  ADDITIONAL_AMOUNT_DEF_ID  NUMBER              DEFAULT 0                     NOT NULL,
  ITEM_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  LOCATION_CD               NUMBER              DEFAULT 0                     NOT NULL,
  ADDITIONAL_AMOUNT_CD      NUMBER              DEFAULT 0                     NOT NULL,
  INCLUDE_EXCLUDE_IND       NUMBER              DEFAULT 0                     NOT NULL,
  COST_CENTER_CD            NUMBER              DEFAULT 0                     NOT NULL,
  SUB_ACCOUNT_CD            NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID           NUMBER              DEFAULT 0                     NOT NULL,
  TAX_TYPE_CD               NUMBER              DEFAULT 0,
  TAX_OVERRIDE_IND          NUMBER              DEFAULT 0,
  TAX_VALUE                 FLOAT(126)          DEFAULT 0,
  TAX_VALUE_FLAG            NUMBER              DEFAULT 0,
  LOGICAL_DOMAIN_ID         NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ADDRESS_HIST
(
  ADDRESS_HIST_ID             NUMBER            DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID         NUMBER            DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM           DATE,
  CHANGE_BIT                  NUMBER            DEFAULT 0                     NOT NULL,
  TRACKING_BIT                NUMBER            DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID            NUMBER            DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME          VARCHAR2(30 BYTE),
  ADDRESS_ID                  NUMBER            DEFAULT 0                     NOT NULL,
  ADDRESS_TYPE_CD             NUMBER            DEFAULT 0                     NOT NULL,
  RESIDENCE_TYPE_CD           NUMBER            DEFAULT 0                     NOT NULL,
  COMMENT_TXT                 VARCHAR2(200 BYTE),
  STREET_ADDR                 VARCHAR2(100 BYTE),
  STREET_ADDR2                VARCHAR2(100 BYTE),
  STREET_ADDR3                VARCHAR2(100 BYTE),
  STREET_ADDR4                VARCHAR2(100 BYTE),
  CITY                        VARCHAR2(100 BYTE),
  STATE                       VARCHAR2(100 BYTE),
  STATE_CD                    NUMBER            DEFAULT 0                     NOT NULL,
  ZIPCODE                     VARCHAR2(25 BYTE),
  COUNTY                      VARCHAR2(100 BYTE),
  COUNTY_CD                   NUMBER            DEFAULT 0                     NOT NULL,
  COUNTRY                     VARCHAR2(100 BYTE),
  COUNTRY_CD                  NUMBER            DEFAULT 0                     NOT NULL,
  RESIDENCE_CD                NUMBER            DEFAULT 0                     NOT NULL,
  MAIL_STOP                   VARCHAR2(100 BYTE),
  ADDRESS_INFO_STATUS_CD      NUMBER            DEFAULT 0                     NOT NULL,
  CONTACT_NAME                VARCHAR2(200 BYTE),
  ACTIVE_IND                  NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE              DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  OPERATION_HOURS             VARCHAR2(255 BYTE),
  POSTAL_IDENTIFIER           VARCHAR2(100 BYTE),
  PARENT_BEG_EFFECTIVE_DT_TM  DATE              DEFAULT SYSDATE,
  PARENT_END_EFFECTIVE_DT_TM  DATE              DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  CITY_CD                     NUMBER            DEFAULT 0,
  VALIDATION_EXPIRE_DT_TM     DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AGS_BENEFIT_LEVEL_DATA
(
  AGS_BENEFIT_LEVEL_DATA_ID  NUMBER             DEFAULT 0                     NOT NULL,
  AGS_JOB_ID                 NUMBER             DEFAULT 0                     NOT NULL,
  RUN_NBR                    NUMBER,
  RUN_DT_TM                  DATE,
  FILE_ROW_NBR               NUMBER,
  SENDING_FACILITY           VARCHAR2(40 BYTE),
  CONTRIBUTOR_SYSTEM_CD      NUMBER             DEFAULT 0                     NOT NULL,
  PERSON_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  EXT_ALIAS                  VARCHAR2(100 BYTE),
  SSN_ALIAS                  VARCHAR2(100 BYTE),
  NAME_LAST                  VARCHAR2(100 BYTE),
  NAME_FIRST                 VARCHAR2(100 BYTE),
  BIRTH_DATE                 VARCHAR2(20 BYTE),
  GENDER                     VARCHAR2(20 BYTE),
  BENEFIT_LEVEL              VARCHAR2(20 BYTE),
  BENEFIT_START_DATE_TXT     VARCHAR2(20 BYTE),
  INPATIENT_HOSP_COUNT_TXT   VARCHAR2(20 BYTE),
  OUTPATIENT_COUNT_TXT       VARCHAR2(20 BYTE),
  PHYSICIAN_COUNT_TXT        VARCHAR2(20 BYTE),
  INPATIENT_PHYS_COUNT_TXT   VARCHAR2(20 BYTE),
  LAB_XRAY_COUNT_TXT         VARCHAR2(20 BYTE),
  HEALTH_COUNT_TXT           VARCHAR2(20 BYTE),
  STATUS                     VARCHAR2(12 BYTE),
  STATUS_DT_TM               DATE,
  STAT_MSG                   VARCHAR2(40 BYTE),
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  BENEFIT_END_DATE_TXT       VARCHAR2(20 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AGS_CLAIM_DATA
(
  AGS_CLAIM_DATA_ID       NUMBER                DEFAULT 0                     NOT NULL,
  AGS_JOB_ID              NUMBER                DEFAULT 0                     NOT NULL,
  RUN_NBR                 NUMBER,
  RUN_DT_TM               DATE,
  FILE_ROW_NBR            NUMBER,
  SENDING_FACILITY        VARCHAR2(40 BYTE),
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  HEA_CLAIM_VISIT_ID      NUMBER                DEFAULT 0                     NOT NULL,
  CLAIM_IDENTIFIER        VARCHAR2(100 BYTE),
  PREV_CLAIM_IDENTIFIER   VARCHAR2(100 BYTE),
  ACTION                  VARCHAR2(20 BYTE),
  EXT_ALIAS               VARCHAR2(100 BYTE),
  SSN_ALIAS               VARCHAR2(100 BYTE),
  NAME_LAST               VARCHAR2(100 BYTE),
  NAME_FIRST              VARCHAR2(100 BYTE),
  BIRTH_DATE              VARCHAR2(20 BYTE),
  GENDER                  VARCHAR2(20 BYTE),
  START_SERVICE_DATE      VARCHAR2(20 BYTE),
  END_SERVICE_DATE        VARCHAR2(20 BYTE),
  VISIT_TYPE              VARCHAR2(20 BYTE),
  BILLING_EXT_ALIAS       VARCHAR2(100 BYTE),
  ADMITTING_EXT_ALIAS     VARCHAR2(100 BYTE),
  ATTENDING_EXT_ALIAS     VARCHAR2(100 BYTE),
  PROCEDURE1              VARCHAR2(50 BYTE),
  PROCEDURE2              VARCHAR2(50 BYTE),
  PROCEDURE3              VARCHAR2(50 BYTE),
  PROCEDURE4              VARCHAR2(50 BYTE),
  PROCEDURE5              VARCHAR2(50 BYTE),
  PROCEDURE6              VARCHAR2(50 BYTE),
  PROCEDURE7              VARCHAR2(50 BYTE),
  PROCEDURE8              VARCHAR2(50 BYTE),
  PROCEDURE9              VARCHAR2(50 BYTE),
  PROCEDURE10             VARCHAR2(50 BYTE),
  DIAGNOSIS1              VARCHAR2(50 BYTE),
  DIAGNOSIS2              VARCHAR2(50 BYTE),
  DIAGNOSIS3              VARCHAR2(50 BYTE),
  DIAGNOSIS4              VARCHAR2(50 BYTE),
  DIAGNOSIS5              VARCHAR2(50 BYTE),
  DIAGNOSIS6              VARCHAR2(50 BYTE),
  DIAGNOSIS7              VARCHAR2(50 BYTE),
  DIAGNOSIS8              VARCHAR2(50 BYTE),
  DIAGNOSIS9              VARCHAR2(50 BYTE),
  DIAGNOSIS10             VARCHAR2(50 BYTE),
  DIAGNOSIS11             VARCHAR2(50 BYTE),
  DIAGNOSIS12             VARCHAR2(50 BYTE),
  DIAGNOSIS13             VARCHAR2(50 BYTE),
  DIAGNOSIS14             VARCHAR2(50 BYTE),
  DIAGNOSIS15             VARCHAR2(50 BYTE),
  STATUS                  VARCHAR2(12 BYTE),
  STATUS_DT_TM            DATE,
  STAT_MSG                VARCHAR2(40 BYTE),
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  ACCESS_IDENTIFIER_TYPE  VARCHAR2(20 BYTE),
  ACCESS_IDENTIFIER       VARCHAR2(100 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AGS_CLAIM_DETAIL_DATA
(
  AGS_CLAIM_DETAIL_DATA_ID   NUMBER             DEFAULT 0                     NOT NULL,
  AGS_JOB_ID                 NUMBER             DEFAULT 0                     NOT NULL,
  RUN_NBR                    NUMBER,
  RUN_DT_TM                  DATE,
  FILE_ROW_NBR               NUMBER,
  SENDING_FACILITY           VARCHAR2(40 BYTE),
  CONTRIBUTOR_SYSTEM_CD      NUMBER             DEFAULT 0                     NOT NULL,
  PERSON_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  HEA_CLAIM_VISIT_ID         NUMBER             DEFAULT 0                     NOT NULL,
  HEA_CLAIM_VISIT_DETAIL_ID  NUMBER             DEFAULT 0                     NOT NULL,
  CLAIM_IDENTIFIER           VARCHAR2(100 BYTE),
  CLAIM_ACTION               VARCHAR2(20 BYTE),
  NAME_LAST                  VARCHAR2(100 BYTE),
  NAME_FIRST                 VARCHAR2(100 BYTE),
  SERVICE_DATE               VARCHAR2(20 BYTE),
  SEQ_NUM_TXT                VARCHAR2(20 BYTE),
  REVENUE_CODE               VARCHAR2(4 BYTE),
  HCPCS_CPT                  VARCHAR2(50 BYTE),
  STATUS                     VARCHAR2(12 BYTE),
  STATUS_DT_TM               DATE,
  STAT_MSG                   VARCHAR2(40 BYTE),
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AGS_IMMUN_DATA
(
  AGS_IMMUN_DATA_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  AGS_JOB_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  RUN_NBR                NUMBER,
  RUN_DT_TM              DATE,
  FILE_ROW_NBR           NUMBER,
  SENDING_FACILITY       VARCHAR2(40 BYTE),
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  EVENT_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  EVENT_CD               NUMBER                 DEFAULT 0                     NOT NULL,
  EXT_ALIAS              VARCHAR2(100 BYTE),
  SSN_ALIAS              VARCHAR2(100 BYTE),
  NAME_LAST              VARCHAR2(100 BYTE),
  NAME_FIRST             VARCHAR2(100 BYTE),
  BIRTH_DATE             VARCHAR2(20 BYTE),
  GENDER                 VARCHAR2(20 BYTE),
  CLAIM_IDENTIFIER       VARCHAR2(100 BYTE),
  PREV_CLAIM_IDENTIFIER  VARCHAR2(100 BYTE),
  LINE_ITEM_NUMBER_TXT   VARCHAR2(20 BYTE),
  ACTION                 VARCHAR2(20 BYTE),
  SERVICE_DATE           VARCHAR2(20 BYTE),
  EVENT_CODE             VARCHAR2(20 BYTE),
  STATUS                 VARCHAR2(12 BYTE),
  STATUS_DT_TM           DATE,
  STAT_MSG               VARCHAR2(40 BYTE),
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AGS_MEDS_DATA
(
  AGS_MEDS_DATA_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  AGS_JOB_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  RUN_NBR                NUMBER,
  RUN_DT_TM              DATE,
  FILE_ROW_NBR           NUMBER,
  SENDING_FACILITY       VARCHAR2(40 BYTE),
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  ACTION                 VARCHAR2(20 BYTE),
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  GS_MED_CLAIM_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  CATALOG_CD             NUMBER                 DEFAULT 0                     NOT NULL,
  PRODUCT_SYNONYM_CKI    VARCHAR2(250 BYTE),
  PRESCRIBER_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  CLAIM_IDENTIFIER       VARCHAR2(100 BYTE),
  PREV_CLAIM_IDENTIFIER  VARCHAR2(100 BYTE),
  EXT_ALIAS              VARCHAR2(100 BYTE),
  SSN_ALIAS              VARCHAR2(100 BYTE),
  NAME_LAST              VARCHAR2(100 BYTE),
  NAME_FIRST             VARCHAR2(100 BYTE),
  BIRTH_DATE             VARCHAR2(20 BYTE),
  GENDER                 VARCHAR2(20 BYTE),
  DRUG_CODE              VARCHAR2(100 BYTE),
  PRODUCT_DESCRIPTION    VARCHAR2(250 BYTE),
  SERVICE_DATE           VARCHAR2(20 BYTE),
  DISPENSE_QTY_TXT       VARCHAR2(20 BYTE),
  STRENGTH_QTY_TXT       VARCHAR2(20 BYTE),
  REFILL_NBR_TXT         VARCHAR2(20 BYTE),
  PRESCRIBER_EXT_ALIAS   VARCHAR2(100 BYTE),
  PHARMACY_EXT_ALIAS     VARCHAR2(100 BYTE),
  STATUS                 VARCHAR2(12 BYTE),
  STATUS_DT_TM           DATE,
  STAT_MSG               VARCHAR2(40 BYTE),
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  PAYER_ALIAS            VARCHAR2(100 BYTE),
  HEALTH_PLAN_ALIAS      VARCHAR2(100 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AGS_MRG_DATA
(
  AGS_MRG_DATA_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  AGS_JOB_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  RUN_NBR                NUMBER,
  RUN_DT_TM              DATE                   DEFAULT SYSDATE               NOT NULL,
  FILE_ROW_NBR           NUMBER,
  SENDING_FACILITY       VARCHAR2(40 BYTE),
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  HIST_PERSON_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  ACTION                 VARCHAR2(20 BYTE),
  ACTION_PERFORMED       VARCHAR2(20 BYTE),
  EXT_ALIAS              VARCHAR2(100 BYTE),
  SSN_ALIAS              VARCHAR2(100 BYTE),
  NAME_LAST              VARCHAR2(100 BYTE),
  NAME_FIRST             VARCHAR2(100 BYTE),
  NAME_MIDDLE            VARCHAR2(100 BYTE),
  BIRTH_DATE             VARCHAR2(20 BYTE),
  GENDER                 VARCHAR2(20 BYTE),
  HIST_EXT_ALIAS         VARCHAR2(100 BYTE),
  HIST_SSN_ALIAS         VARCHAR2(100 BYTE),
  HIST_NAME_LAST         VARCHAR2(100 BYTE),
  HIST_NAME_FIRST        VARCHAR2(100 BYTE),
  HIST_NAME_MIDDLE       VARCHAR2(100 BYTE),
  HIST_BIRTH_DATE        VARCHAR2(20 BYTE),
  HIST_GENDER            VARCHAR2(20 BYTE),
  STATUS                 VARCHAR2(12 BYTE),
  STATUS_DT_TM           DATE                   DEFAULT SYSDATE               NOT NULL,
  STAT_MSG               VARCHAR2(40 BYTE),
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  END_DATE_TXT           VARCHAR2(20 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AGS_ORG_DATA
(
  AGS_ORG_DATA_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  AGS_JOB_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  RUN_NBR                NUMBER,
  RUN_DT_TM              DATE,
  FILE_ROW_NBR           NUMBER,
  SENDING_FACILITY       VARCHAR2(40 BYTE),
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  LOCATION_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  EXT_ALIAS              VARCHAR2(100 BYTE),
  NAME                   VARCHAR2(100 BYTE),
  STREET_ADDR            VARCHAR2(100 BYTE),
  STREET_ADDR2           VARCHAR2(100 BYTE),
  CITY                   VARCHAR2(100 BYTE),
  COUNTY                 VARCHAR2(100 BYTE),
  STATE                  VARCHAR2(100 BYTE),
  COUNTRY                VARCHAR2(100 BYTE),
  ZIPCODE                VARCHAR2(25 BYTE),
  PHONE1                 VARCHAR2(100 BYTE),
  PHONE_FAX              VARCHAR2(100 BYTE),
  ALT_ALIAS1             VARCHAR2(100 BYTE),
  ALT_ALIAS1_TYPE        VARCHAR2(20 BYTE),
  ALT_ALIAS2             VARCHAR2(100 BYTE),
  ALT_ALIAS2_TYPE        VARCHAR2(20 BYTE),
  ALT_ALIAS3             VARCHAR2(100 BYTE),
  ALT_ALIAS3_TYPE        VARCHAR2(20 BYTE),
  SPECIALTY_CODE         VARCHAR2(20 BYTE),
  SPECIALTY_DESC         VARCHAR2(100 BYTE),
  STATUS                 VARCHAR2(12 BYTE),
  STATUS_DT_TM           DATE,
  STAT_MSG               VARCHAR2(40 BYTE),
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  PROVDIR_LINK_ALIAS     VARCHAR2(100 BYTE),
  PROVDIR_ALIAS          VARCHAR2(100 BYTE),
  ADDRESS_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  BUS_PHONE_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  FAX_PHONE_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  PRIMARY_IND            NUMBER                 DEFAULT 0                     NOT NULL,
  EXT_LINK_ALIAS         VARCHAR2(100 BYTE)     DEFAULT ' '                   NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AGS_PERSON_DATA
(
  AGS_PERSON_DATA_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  AGS_JOB_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  RUN_NBR                NUMBER,
  RUN_DT_TM              DATE,
  FILE_ROW_NBR           NUMBER,
  SENDING_FACILITY       VARCHAR2(40 BYTE),
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  PCP_PERSON_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  EXT_ALIAS              VARCHAR2(100 BYTE),
  SSN_ALIAS              VARCHAR2(100 BYTE),
  NAME_LAST              VARCHAR2(100 BYTE),
  NAME_FIRST             VARCHAR2(100 BYTE),
  NAME_MIDDLE            VARCHAR2(100 BYTE),
  BIRTH_DATE             VARCHAR2(20 BYTE),
  GENDER                 VARCHAR2(20 BYTE),
  STREET_ADDR            VARCHAR2(100 BYTE),
  STREET_ADDR2           VARCHAR2(100 BYTE),
  CITY                   VARCHAR2(100 BYTE),
  COUNTY                 VARCHAR2(100 BYTE),
  STATE                  VARCHAR2(100 BYTE),
  COUNTRY                VARCHAR2(100 BYTE),
  ZIPCODE                VARCHAR2(25 BYTE),
  PHONE_HOME             VARCHAR2(100 BYTE),
  PHONE_ALT              VARCHAR2(100 BYTE),
  PCP_EXT_ALIAS          VARCHAR2(100 BYTE),
  ELIG_START_DATE        VARCHAR2(20 BYTE),
  ELIG_END_DATE          VARCHAR2(20 BYTE),
  CMRN_ALIAS             VARCHAR2(100 BYTE),
  STATUS                 VARCHAR2(12 BYTE),
  STATUS_DT_TM           DATE,
  STAT_MSG               VARCHAR2(40 BYTE),
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  LANG_CODE              VARCHAR2(20 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AGS_PLAN_DATA
(
  AGS_PLAN_DATA_ID         NUMBER               DEFAULT 0                     NOT NULL,
  AGS_JOB_ID               NUMBER               DEFAULT 0                     NOT NULL,
  RUN_NBR                  NUMBER               DEFAULT 0                     NOT NULL,
  RUN_DT_TM                DATE                 DEFAULT SYSDATE               NOT NULL,
  FILE_ROW_NBR             NUMBER               DEFAULT 0                     NOT NULL,
  SENDING_FACILITY         VARCHAR2(40 BYTE),
  CONTRIBUTOR_SYSTEM_CD    NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID           NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_RX_PLAN_RELTN_ID  NUMBER               DEFAULT 0                     NOT NULL,
  EXT_ALIAS                VARCHAR2(100 BYTE),
  SSN_ALIAS                VARCHAR2(100 BYTE),
  NAME_LAST                VARCHAR2(100 BYTE),
  NAME_FIRST               VARCHAR2(100 BYTE),
  GENDER                   VARCHAR2(20 BYTE),
  BIRTH_DATE               VARCHAR2(20 BYTE),
  PLAN_TYPE                VARCHAR2(100 BYTE),
  PLAN_ALIAS               VARCHAR2(100 BYTE),
  ELIG_START_DATE          VARCHAR2(20 BYTE),
  ELIG_END_DATE            VARCHAR2(20 BYTE),
  STATUS                   VARCHAR2(12 BYTE),
  STATUS_DT_TM             DATE,
  STAT_MSG                 VARCHAR2(40 BYTE),
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AGS_PRSNL_DATA
(
  AGS_PRSNL_DATA_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  AGS_JOB_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  RUN_NBR                NUMBER,
  RUN_DT_TM              DATE,
  FILE_ROW_NBR           NUMBER,
  SENDING_FACILITY       VARCHAR2(40 BYTE),
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  EXT_ALIAS              VARCHAR2(100 BYTE),
  BEG_DATE               VARCHAR2(20 BYTE),
  END_DATE               VARCHAR2(20 BYTE),
  DEA_ALIAS              VARCHAR2(100 BYTE),
  UPIN_ALIAS             VARCHAR2(100 BYTE),
  MED_ALIAS              VARCHAR2(100 BYTE),
  EXT_LINK_ALIAS         VARCHAR2(100 BYTE),
  SSN_ALIAS              VARCHAR2(100 BYTE),
  NAME_RAW               VARCHAR2(100 BYTE),
  NAME_LAST              VARCHAR2(100 BYTE),
  NAME_FIRST             VARCHAR2(100 BYTE),
  NAME_MIDDLE            VARCHAR2(100 BYTE),
  NAME_FULL              VARCHAR2(100 BYTE),
  NAME_DEGREE            VARCHAR2(100 BYTE),
  NAME_TITLE             VARCHAR2(100 BYTE),
  BIRTH_DATE             VARCHAR2(20 BYTE),
  GENDER                 VARCHAR2(20 BYTE),
  STREET_ADDR            VARCHAR2(100 BYTE),
  STREET_ADDR2           VARCHAR2(100 BYTE),
  CITY                   VARCHAR2(100 BYTE),
  COUNTY                 VARCHAR2(100 BYTE),
  STATE                  VARCHAR2(100 BYTE),
  COUNTRY                VARCHAR2(100 BYTE),
  ZIPCODE                VARCHAR2(25 BYTE),
  PHONE_BUSINESS         VARCHAR2(100 BYTE),
  PHONE_FAX              VARCHAR2(100 BYTE),
  ALT_ALIAS1             VARCHAR2(100 BYTE),
  ALT_ALIAS1_TYPE        VARCHAR2(20 BYTE),
  ALT_ALIAS2             VARCHAR2(100 BYTE),
  ALT_ALIAS2_TYPE        VARCHAR2(20 BYTE),
  EXT_ORG_ALIAS          VARCHAR2(100 BYTE),
  SPECIALTY_CODE         VARCHAR2(20 BYTE),
  SPECIALTY_DESC         VARCHAR2(100 BYTE),
  STATUS                 VARCHAR2(12 BYTE),
  STATUS_DT_TM           DATE,
  STAT_MSG               VARCHAR2(40 BYTE),
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  PROVDIR_LINK_ALIAS     VARCHAR2(100 BYTE),
  PROVDIR_ALIAS          VARCHAR2(100 BYTE),
  ADDRESS_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  BUS_PHONE_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  FAX_PHONE_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  PRIMARY_IND            NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AGS_RESULT_DATA
(
  AGS_RESULT_DATA_ID       NUMBER               DEFAULT 0                     NOT NULL,
  AGS_JOB_ID               NUMBER               DEFAULT 0                     NOT NULL,
  RUN_NBR                  NUMBER,
  RUN_DT_TM                DATE,
  FILE_ROW_NBR             NUMBER,
  SENDING_FACILITY         VARCHAR2(40 BYTE),
  CONTRIBUTOR_SYSTEM_CD    NUMBER               DEFAULT 0                     NOT NULL,
  ACTION                   VARCHAR2(20 BYTE),
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  CLINICAL_EVENT_ID        NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_CD                 NUMBER               DEFAULT 0                     NOT NULL,
  ORDERING_PERSON_ID       NUMBER               DEFAULT 0                     NOT NULL,
  EXT_ALIAS                VARCHAR2(100 BYTE),
  SSN_ALIAS                VARCHAR2(100 BYTE),
  NAME_LAST                VARCHAR2(100 BYTE),
  NAME_FIRST               VARCHAR2(100 BYTE),
  BIRTH_DATE               VARCHAR2(20 BYTE),
  GENDER                   VARCHAR2(20 BYTE),
  EVENT_DATE               VARCHAR2(20 BYTE),
  EVENT_CODE               VARCHAR2(20 BYTE),
  EVENT_TITLE_TEXT         VARCHAR2(255 BYTE),
  RESULT_VAL               VARCHAR2(255 BYTE),
  RESULT_REMARK_DESC       VARCHAR2(255 BYTE),
  RESULT_IDENTIFIER        VARCHAR2(100 BYTE),
  PERFORMING_NAME          VARCHAR2(100 BYTE),
  PERFORMING_EXT_ALIAS     VARCHAR2(100 BYTE),
  ORDERING_EXT_ALIAS       VARCHAR2(100 BYTE),
  REF_RANGE                VARCHAR2(50 BYTE),
  NORMAL_HIGH              VARCHAR2(20 BYTE),
  NORMAL_LOW               VARCHAR2(20 BYTE),
  NORMALCY                 VARCHAR2(100 BYTE),
  UNIT_OF_MEAS             VARCHAR2(20 BYTE),
  STATUS                   VARCHAR2(12 BYTE),
  STATUS_DT_TM             DATE,
  STAT_MSG                 VARCHAR2(40 BYTE),
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  RESULT_FORMAT            VARCHAR2(20 BYTE),
  PERFORMING_ENTITY_ALIAS  VARCHAR2(100 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALERT_AUDIT_ALLERGY
(
  ALERT_AUDIT_ALLERGY_ID      NUMBER            DEFAULT 0                     NOT NULL,
  ALERT_AUDIT_TRANSACTION_ID  NUMBER            DEFAULT 0                     NOT NULL,
  DRUG_ALLERGY_IND            NUMBER            DEFAULT 0                     NOT NULL,
  DRUG_IDENTIFIER             VARCHAR2(6 BYTE)  DEFAULT ' '                   NOT NULL,
  DRUG_ALR_CATEGORY_ID        NUMBER            DEFAULT 0                     NOT NULL,
  ALLERGY_IDENTIFIER          VARCHAR2(6 BYTE)  DEFAULT ' '                   NOT NULL,
  ALLERGY_ALR_CATEGORY_ID     NUMBER            DEFAULT 0                     NOT NULL,
  CLASS_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  INTERACTION_LEVEL_FLAG      NUMBER            DEFAULT 0                     NOT NULL,
  INTERACTION_TYPE_ID         NUMBER            DEFAULT 0                     NOT NULL,
  DESC_LONG_TEXT_ID           NUMBER            DEFAULT 0                     NOT NULL,
  DCP_ENTITY_RELTN_ID         NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALERT_AUDIT_ALLERGY_DOM
(
  ALERT_AUDIT_ALLERGY_DOM_ID    NUMBER          DEFAULT 0                     NOT NULL,
  ALERT_AUDIT_ALLERGY_ID        NUMBER          DEFAULT 0                     NOT NULL,
  ENCNTR_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_ID                      NUMBER          DEFAULT 0                     NOT NULL,
  CATALOG_CD                    NUMBER          DEFAULT 0                     NOT NULL,
  ALLERGY_ID                    NUMBER          DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID               NUMBER          DEFAULT 0                     NOT NULL,
  NO_OVERRIDE_REASON_IND        NUMBER          DEFAULT 0                     NOT NULL,
  FREETEXT_OVERRIDE_REASON_IND  NUMBER          DEFAULT 0                     NOT NULL,
  OVERRIDE_REASON_CD            NUMBER          DEFAULT 0                     NOT NULL,
  OVERRIDE_REASON_LONG_TEXT_ID  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  DRUG_ALLERGY_IND              NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALERT_AUDIT_DRUG
(
  ALERT_AUDIT_DRUG_ID            NUMBER         DEFAULT 0                     NOT NULL,
  ALERT_AUDIT_TRANSACTION_ID     NUMBER         DEFAULT 0                     NOT NULL,
  DRUG_IDENTIFIER_1              VARCHAR2(6 BYTE) DEFAULT ' ' NOT NULL,
  DRUG_IDENTIFIER_2              VARCHAR2(6 BYTE) DEFAULT ' ' NOT NULL,
  DRUG_IDENTIFIER_1_SUBJECT_IND  NUMBER         DEFAULT 0                     NOT NULL,
  SEVERITY_FLAG                  NUMBER         DEFAULT 0                     NOT NULL,
  SEVERITY_DETAILS_BIT           NUMBER         DEFAULT 0                     NOT NULL,
  DESC_LONG_TEXT_ID              NUMBER         DEFAULT 0                     NOT NULL,
  DCP_ENTITY_RELTN_ID            NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALERT_AUDIT_DRUG_DOM
(
  ALERT_AUDIT_DRUG_DOM_ID       NUMBER          DEFAULT 0                     NOT NULL,
  ALERT_AUDIT_DRUG_ID           NUMBER          DEFAULT 0                     NOT NULL,
  ENCNTR_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  SUBJECT_ORDER_ID              NUMBER          DEFAULT 0                     NOT NULL,
  SUBJECT_CATALOG_CD            NUMBER          DEFAULT 0                     NOT NULL,
  CAUSING_ORDER_ID              NUMBER          DEFAULT 0                     NOT NULL,
  CAUSING_CATALOG_CD            NUMBER          DEFAULT 0                     NOT NULL,
  NO_OVERRIDE_REASON_IND        NUMBER          DEFAULT 0                     NOT NULL,
  FREETEXT_OVERRIDE_REASON_IND  NUMBER          DEFAULT 0                     NOT NULL,
  OVERRIDE_REASON_CD            NUMBER          DEFAULT 0                     NOT NULL,
  OVERRIDE_REASON_LONG_TEXT_ID  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  SEVERITY_FLAG                 NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALERT_AUDIT_DUP
(
  ALERT_AUDIT_DUP_ID          NUMBER            DEFAULT 0                     NOT NULL,
  ALERT_AUDIT_TRANSACTION_ID  NUMBER            DEFAULT 0                     NOT NULL,
  DRUG_IDENTIFIER             VARCHAR2(6 BYTE)  DEFAULT ' '                   NOT NULL,
  CATEGORY_DUPLICATION_IND    NUMBER            DEFAULT 0                     NOT NULL,
  MULTUM_CATEGORY_ID          NUMBER            DEFAULT 0                     NOT NULL,
  CATEGORY_LEVEL_FLAG         NUMBER            DEFAULT 0                     NOT NULL,
  MAXIMUM_OCCURRENCES_NBR     NUMBER            DEFAULT 0                     NOT NULL,
  OBSERVED_OCCURRENCES_NBR    NUMBER            DEFAULT 0                     NOT NULL,
  DCP_ENTITY_RELTN_ID         NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALERT_AUDIT_DUP_CAT_CAUSE
(
  ALERT_AUDIT_DUP_CAT_CAUSE_ID  NUMBER          DEFAULT 0                     NOT NULL,
  ALERT_AUDIT_DUP_ID            NUMBER          DEFAULT 0                     NOT NULL,
  DRUG_IDENTIFIER               VARCHAR2(6 BYTE) DEFAULT ' ' NOT NULL,
  OBSERVED_OCCURRENCES_NBR      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALERT_AUDIT_DUP_DOM
(
  ALERT_AUDIT_DUP_DOM_ID        NUMBER          DEFAULT 0                     NOT NULL,
  ALERT_AUDIT_DUP_ID            NUMBER          DEFAULT 0                     NOT NULL,
  ENCNTR_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  SUBJECT_ORDER_ID              NUMBER          DEFAULT 0                     NOT NULL,
  SUBJECT_CATALOG_CD            NUMBER          DEFAULT 0                     NOT NULL,
  CAUSING_ORDER_ID              NUMBER          DEFAULT 0                     NOT NULL,
  CAUSING_CATALOG_CD            NUMBER          DEFAULT 0                     NOT NULL,
  NO_OVERRIDE_REASON_IND        NUMBER          DEFAULT 0                     NOT NULL,
  FREETEXT_OVERRIDE_REASON_IND  NUMBER          DEFAULT 0                     NOT NULL,
  OVERRIDE_REASON_CD            NUMBER          DEFAULT 0                     NOT NULL,
  OVERRIDE_REASON_LONG_TEXT_ID  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALERT_AUDIT_FOOD
(
  ALERT_AUDIT_FOOD_ID         NUMBER            DEFAULT 0                     NOT NULL,
  ALERT_AUDIT_TRANSACTION_ID  NUMBER            DEFAULT 0                     NOT NULL,
  DRUG_IDENTIFIER             VARCHAR2(6 BYTE)  DEFAULT ' '                   NOT NULL,
  SEVERITY_FLAG               NUMBER            DEFAULT 0                     NOT NULL,
  SEVERITY_DETAILS_BIT        NUMBER            DEFAULT 0                     NOT NULL,
  DESC_LONG_TEXT_ID           NUMBER            DEFAULT 0                     NOT NULL,
  DCP_ENTITY_RELTN_ID         NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALERT_AUDIT_FOOD_DOM
(
  ALERT_AUDIT_FOOD_DOM_ID       NUMBER          DEFAULT 0                     NOT NULL,
  ALERT_AUDIT_FOOD_ID           NUMBER          DEFAULT 0                     NOT NULL,
  ENCNTR_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_ID                      NUMBER          DEFAULT 0                     NOT NULL,
  CATALOG_CD                    NUMBER          DEFAULT 0                     NOT NULL,
  NO_OVERRIDE_REASON_IND        NUMBER          DEFAULT 0                     NOT NULL,
  FREETEXT_OVERRIDE_REASON_IND  NUMBER          DEFAULT 0                     NOT NULL,
  OVERRIDE_REASON_CD            NUMBER          DEFAULT 0                     NOT NULL,
  OVERRIDE_REASON_LONG_TEXT_ID  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  SEVERITY_FLAG                 NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALERT_AUDIT_TRANSACTION
(
  ALERT_AUDIT_TRANSACTION_ID  NUMBER            DEFAULT 0                     NOT NULL,
  PRSNL_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  PERSON_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM           DATE              DEFAULT SYSDATE               NOT NULL,
  DOMAIN_DATA_IND             NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALIAS_POOL
(
  ALIAS_POOL_CD           NUMBER                DEFAULT 0                     NOT NULL,
  DESCRIPTION             VARCHAR2(200 BYTE)    DEFAULT ' '                   NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UNIQUE_IND              NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  FORMAT_MASK             VARCHAR2(100 BYTE),
  CHECK_DIGIT_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DUP_ALLOWED_FLAG        NUMBER,
  SYS_ASSIGN_FLAG         NUMBER,
  CMB_INACTIVE_IND        NUMBER,
  ALIAS_METHOD_CD         NUMBER                DEFAULT 0,
  ALIAS_POOL_EXT_CD       NUMBER                DEFAULT 0,
  EFFECTIVE_ALIAS_IND     NUMBER                DEFAULT 0                     NOT NULL,
  LOGICAL_DOMAIN_ID       NUMBER                DEFAULT 0,
  UNSECURED_CHAR_COUNT    NUMBER                DEFAULT 0,
  SECURITY_CHAR           VARCHAR2(1 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALIAS_POOL_SEQ
(
  ALIAS_POOL_CD   NUMBER                        DEFAULT 0                     NOT NULL,
  AP_SEQ_TYPE_CD  NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL,
  START_NBR       FLOAT(126)                    DEFAULT 0                     NOT NULL,
  MAX_NBR         FLOAT(126)                    DEFAULT 0                     NOT NULL,
  NEXT_NBR        FLOAT(126)                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALLELE_PATTERN_MATCH
(
  ORDER_ID      NUMBER                          DEFAULT 0                     NOT NULL,
  GEL_NUMBER    NUMBER                          DEFAULT 0                     NOT NULL,
  LOCI_SEQ      NUMBER                          DEFAULT 0                     NOT NULL,
  LOCI_CD       NUMBER                          DEFAULT 0                     NOT NULL,
  ALLELE_CD     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL,
  GEL_BATCH_ID  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALLERGY
(
  ALLERGY_INSTANCE_ID     NUMBER                DEFAULT 0                     NOT NULL,
  ALLERGY_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  SUBSTANCE_NOM_ID        NUMBER                DEFAULT 0                     NOT NULL,
  SUBSTANCE_FTDESC        VARCHAR2(255 BYTE),
  SUBSTANCE_TYPE_CD       NUMBER                DEFAULT 0                     NOT NULL,
  REACTION_CLASS_CD       NUMBER                DEFAULT 0                     NOT NULL,
  SEVERITY_CD             NUMBER                DEFAULT 0                     NOT NULL,
  SOURCE_OF_INFO_CD       NUMBER                DEFAULT 0                     NOT NULL,
  SOURCE_OF_INFO_FT       VARCHAR2(50 BYTE),
  ONSET_DT_TM             DATE,
  REACTION_STATUS_CD      NUMBER                DEFAULT 0                     NOT NULL,
  CREATED_DT_TM           DATE,
  CREATED_PRSNL_ID        NUMBER                DEFAULT 0                     NOT NULL,
  CANCEL_REASON_CD        NUMBER                DEFAULT 0                     NOT NULL,
  CANCEL_DT_TM            DATE,
  CANCEL_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  VERIFIED_STATUS_FLAG    NUMBER,
  REC_SRC_VOCAB_CD        NUMBER                DEFAULT 0                     NOT NULL,
  REC_SRC_IDENTIFER       VARCHAR2(50 BYTE),
  REC_SRC_STRING          VARCHAR2(255 BYTE),
  ONSET_PRECISION_CD      NUMBER                DEFAULT 0                     NOT NULL,
  ONSET_PRECISION_FLAG    NUMBER                DEFAULT 0,
  REVIEWED_DT_TM          DATE,
  REVIEWED_PRSNL_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ORIG_PRSNL_ID           NUMBER                DEFAULT 0                     NOT NULL,
  REACTION_STATUS_DT_TM   DATE,
  ONSET_TZ                NUMBER                DEFAULT 0,
  BEG_EFFECTIVE_TZ        NUMBER                DEFAULT 0,
  REVIEWED_TZ             NUMBER                DEFAULT 0,
  CMB_INSTANCE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  CMB_FLAG                NUMBER                DEFAULT 0                     NOT NULL,
  CMB_PRSNL_ID            NUMBER                DEFAULT 0                     NOT NULL,
  CMB_PERSON_ID           NUMBER                DEFAULT 0                     NOT NULL,
  CMB_DT_TM               DATE,
  CMB_TZ                  NUMBER                DEFAULT 0,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALLERGY_COMMENT
(
  ALLERGY_COMMENT_ID      NUMBER                DEFAULT 0                     NOT NULL,
  ALLERGY_INSTANCE_ID     NUMBER                DEFAULT 0                     NOT NULL,
  ALLERGY_ID              NUMBER                DEFAULT 0                     NOT NULL,
  COMMENT_DT_TM           DATE,
  COMMENT_PRSNL_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ALLERGY_COMMENT         LONG,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  COMMENT_TZ              NUMBER                DEFAULT 0,
  BEG_EFFECTIVE_TZ        NUMBER                DEFAULT 0,
  CMB_COMMENT_ID          NUMBER                DEFAULT 0                     NOT NULL,
  CMB_PRSNL_ID            NUMBER                DEFAULT 0                     NOT NULL,
  CMB_PERSON_ID           NUMBER                DEFAULT 0                     NOT NULL,
  CMB_DT_TM               DATE,
  CMB_TZ                  NUMBER                DEFAULT 0,
  CMB_FLAG                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ALLERGY_REVIEW_HIST
(
  ALLERGY_REVIEW_HIST_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ALLERGY_INSTANCE_ID     NUMBER                DEFAULT 0                     NOT NULL,
  REVIEWED_DT_TM          DATE                  DEFAULT SYSDATE               NOT NULL,
  REVIEWED_TZ             NUMBER,
  REVIEWED_PRSNL_ID       NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AMENDMENT_REASON
(
  AMENDMENT_REASON_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  PROT_AMENDMENT_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  AMENDMENT_REASON_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE APPLICATION_GROUP
(
  APPLICATION_GROUP_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  POSITION_CD           NUMBER                  DEFAULT 0                     NOT NULL,
  PERSON_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  APP_GROUP_CD          NUMBER                  DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM   DATE                    DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM   DATE                    DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE APPL_DISEASE
(
  APPL_DISEASE_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  DISEASE_TYPE_CD        NUMBER                 DEFAULT 0                     NOT NULL,
  DISEASE_SUB_TYPE_CD    NUMBER                 DEFAULT 0                     NOT NULL,
  PROT_AMENDMENT_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  APPL_DISEASE_DESC_OTR  VARCHAR2(255 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_APP_FOLDERS
(
  APP_FOLDER_ID       NUMBER                    DEFAULT 0                     NOT NULL,
  APPLICATION_NUMBER  NUMBER                    DEFAULT 0                     NOT NULL,
  USER_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_APP_FOLDER_DETAILS
(
  APP_FOLDER_ID  NUMBER                         DEFAULT 0                     NOT NULL,
  FOLDER_ID      NUMBER                         DEFAULT 0                     NOT NULL,
  ACCESS_CNT     NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_CASE_QUERY
(
  CASE_QUERY_ID      NUMBER                     DEFAULT 0                     NOT NULL,
  OUTPUT_DEST_ID     NUMBER                     DEFAULT 0                     NOT NULL,
  NBR_COPIES         NUMBER                     DEFAULT 0,
  REPORT_TYPE_FLAG   NUMBER                     DEFAULT 0,
  SEARCH_TYPE_FLAG   NUMBER                     DEFAULT 0,
  REPORT_HISTORY_CD  NUMBER                     DEFAULT 0                     NOT NULL,
  QUERY_START_DT_TM  DATE,
  STARTED_PRSNL_ID   NUMBER                     DEFAULT 0                     NOT NULL,
  STATUS_FLAG        NUMBER                     DEFAULT 0,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  RESULT_NAME        VARCHAR2(100 BYTE),
  RESULT_NAME_KEY    VARCHAR2(100 BYTE),
  ACTIVITY_TYPE_CD   NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_CASE_QUERY_DETAILS
(
  CASE_QUERY_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  SEQUENCE               NUMBER                 DEFAULT 0                     NOT NULL,
  PARAM_NAME             VARCHAR2(20 BYTE),
  CRITERIA_TYPE_FLAG     NUMBER,
  DATE_TYPE_FLAG         NUMBER                 DEFAULT 0,
  BEG_VALUE_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  BEG_VALUE_DT_TM        DATE,
  BEG_VALUE_DISP         VARCHAR2(40 BYTE),
  END_VALUE_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  END_VALUE_DT_TM        DATE,
  END_VALUE_DISP         VARCHAR2(40 BYTE),
  NEGATION_IND           NUMBER                 DEFAULT 0,
  SOURCE_VOCABULARY_CD   NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  FREETEXT_LONG_TEXT_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  FREETEXT_QUERY_FLAG    NUMBER                 DEFAULT 0,
  QUERY_DETAIL_ID        NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_CASE_SYNOPTIC_WS
(
  CASE_WORKSHEET_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  CASE_SPECIMEN_ID   NUMBER                     DEFAULT 0                     NOT NULL,
  SEQUENCE           NUMBER                     DEFAULT 0                     NOT NULL,
  SCR_PATTERN_ID     NUMBER                     DEFAULT 0                     NOT NULL,
  SCD_STORY_ID       NUMBER                     DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD      NUMBER                     DEFAULT 0                     NOT NULL,
  REPORT_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  STATUS_FLAG        NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  CAP_CHECKLIST_CKI  VARCHAR2(255 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_DC_EVENT
(
  EVENT_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  STUDY_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  CASE_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  CORRELATE_CASE_ID          NUMBER             DEFAULT 0                     NOT NULL,
  INIT_EVAL_TERM_ID          NUMBER             DEFAULT 0                     NOT NULL,
  INIT_DISCREP_TERM_ID       NUMBER             DEFAULT 0                     NOT NULL,
  DISAGREE_REASON_CD         NUMBER             DEFAULT 0                     NOT NULL,
  INVESTIGATION_CD           NUMBER             DEFAULT 0                     NOT NULL,
  RESOLUTION_CD              NUMBER             DEFAULT 0                     NOT NULL,
  FINAL_EVAL_TERM_ID         NUMBER             DEFAULT 0                     NOT NULL,
  FINAL_DISCREP_TERM_ID      NUMBER             DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID               NUMBER             DEFAULT 0                     NOT NULL,
  PRSNL_GROUP_ID             NUMBER             DEFAULT 0                     NOT NULL,
  INITIATED_PRSNL_ID         NUMBER             DEFAULT 0                     NOT NULL,
  INITIATED_DT_TM            DATE,
  CANCEL_PRSNL_ID            NUMBER             DEFAULT 0                     NOT NULL,
  CANCEL_DT_TM               DATE,
  COMPLETE_PRSNL_ID          NUMBER             DEFAULT 0                     NOT NULL,
  COMPLETE_DT_TM             DATE,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  SYS_CORR_ID                NUMBER             DEFAULT 0                     NOT NULL,
  REPORT_ISSUED_BY_PRSNL_ID  NUMBER             DEFAULT 0                     NOT NULL,
  ASSIGN_TO_GROUP_IND        NUMBER             DEFAULT 0,
  SLIDE_COUNTS               FLOAT(126)         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_DC_EVENT_PRSNL
(
  EVENT_ID        NUMBER                        DEFAULT 0                     NOT NULL,
  PRSNL_GROUP_ID  NUMBER                        DEFAULT 0                     NOT NULL,
  PRSNL_ID        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_DIAG_RPT_REVIEW
(
  EVENT_ID           NUMBER                     DEFAULT 0                     NOT NULL,
  PREFIX_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  VERIFIED_PRSNL_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  VERIFIED_DT_TM     DATE                       DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_FOLDER
(
  FOLDER_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  FOLDER_NAME            VARCHAR2(100 BYTE),
  FOLDER_NAME_KEY        VARCHAR2(100 BYTE)     DEFAULT ' '                   NOT NULL,
  FOLDER_NAME_KEY_NLS    VARCHAR2(202 BYTE),
  PARENT_FOLDER_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  CREATE_PRSNL_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  COMMENT_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  PUBLIC_IND             NUMBER                 DEFAULT 0,
  DEFAULT_BITMAP         NUMBER                 DEFAULT 0,
  ANONYMOUS_BITMAP       NUMBER                 DEFAULT 0,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  FOLDER_NAME_KEY_A_NLS  VARCHAR2(400 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_FOLDER_ENTITY
(
  ENTITY_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME  VARCHAR2(32 BYTE)         DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  FOLDER_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  ENTITY_TYPE_FLAG    NUMBER                    DEFAULT 0,
  DISPLAY             VARCHAR2(255 BYTE),
  COMMENT_ID          NUMBER                    DEFAULT 0                     NOT NULL,
  ACCESSION_NBR       CHAR(21 BYTE),
  SEQUENCE            NUMBER                    DEFAULT 0,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  CREATE_PRSNL_ID     NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_FT_EVENT
(
  FOLLOWUP_EVENT_ID         NUMBER              DEFAULT 0                     NOT NULL,
  CASE_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  FOLLOWUP_TYPE_CD          NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  ORIGIN_FLAG               NUMBER,
  ORIGIN_DT_TM              DATE,
  ORIGIN_PRSNL_ID           NUMBER              DEFAULT 0                     NOT NULL,
  EXPECTED_TERM_DT          DATE,
  INITIAL_NOTIF_DT_TM       DATE,
  INITIAL_NOTIF_PRINT_FLAG  NUMBER,
  FIRST_OVERDUE_DT_TM       DATE,
  FIRST_OVERDUE_PRINT_FLAG  NUMBER,
  FINAL_OVERDUE_DT_TM       DATE,
  FINAL_OVERDUE_PRINT_FLAG  NUMBER,
  TERM_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  TERM_DT_TM                DATE,
  TERM_REASON_CD            NUMBER              DEFAULT 0                     NOT NULL,
  TERM_ACCESSION_NBR        CHAR(21 BYTE),
  TERM_COMMENT              VARCHAR2(100 BYTE),
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  TERM_LONG_TEXT_ID         NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_FT_REPORT_PROC
(
  FOLLOWUP_TRACKING_TYPE_CD  NUMBER             DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD              NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_FT_TERM_PROC
(
  FOLLOWUP_TRACKING_TYPE_CD   NUMBER            DEFAULT 0                     NOT NULL,
  CATALOG_CD                  NUMBER            DEFAULT 0                     NOT NULL,
  AUTO_TERMINATION_IND        NUMBER,
  AUTO_TERMINATION_REASON_CD  NUMBER            DEFAULT 0                     NOT NULL,
  LOOK_BACK_DAYS              NUMBER,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_FT_TYPE
(
  FOLLOWUP_TRACKING_TYPE_CD  NUMBER             DEFAULT 0                     NOT NULL,
  PATIENT_NOTIFICATION_IND   NUMBER,
  SHORT_DESC                 VARCHAR2(25 BYTE),
  DESCRIPTION                VARCHAR2(60 BYTE),
  ACTIVE_IND                 NUMBER,
  PATIENT_NOTIF_TEMPLATE_ID  NUMBER             DEFAULT 0                     NOT NULL,
  PATIENT_FIRST_OVERDUE_IND  NUMBER,
  PATIENT_FIRST_TEMPLATE_ID  NUMBER             DEFAULT 0                     NOT NULL,
  PATIENT_FINAL_OVERDUE_IND  NUMBER,
  PATIENT_FINAL_TEMPLATE_ID  NUMBER             DEFAULT 0                     NOT NULL,
  DOCTOR_NOTIFICATION_IND    NUMBER,
  DOCTOR_NOTIF_TEMPLATE_ID   NUMBER             DEFAULT 0                     NOT NULL,
  DOCTOR_FIRST_OVERDUE_IND   NUMBER,
  DOCTOR_FIRST_TEMPLATE_ID   NUMBER             DEFAULT 0                     NOT NULL,
  DOCTOR_FINAL_OVERDUE_IND   NUMBER,
  DOCTOR_FINAL_TEMPLATE_ID   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_IMAGE_GROUP_INI
(
  PERSON_ID     NUMBER                          DEFAULT 0                     NOT NULL,
  NAME          VARCHAR2(255 BYTE)              DEFAULT ' '                   NOT NULL,
  SEQUENCE      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_IMAGE_ITEM_INI
(
  PERSON_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  PARENT_SEQUENCE     NUMBER                    DEFAULT 0                     NOT NULL,
  SEQUENCE            NUMBER                    DEFAULT 0                     NOT NULL,
  NAME                VARCHAR2(255 BYTE)        DEFAULT ' '                   NOT NULL,
  TYPE_FLAG           NUMBER                    DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME  VARCHAR2(32 BYTE)         DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_IMAGE_MIGRATED
(
  AP_IMAGE_MIGRATED_ID     NUMBER               DEFAULT 0                     NOT NULL,
  DICOM_BLOB_HANDLE_IDENT  VARCHAR2(255 BYTE)   DEFAULT ' '                   NOT NULL,
  MMF_BLOB_HANDLE_IDENT    VARCHAR2(255 BYTE)   DEFAULT ' '                   NOT NULL,
  CASE_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  ENTITY_ID                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_INV_RETENTION
(
  AP_INV_RETENTION_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  PREFIX_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  INVENTORY_TYPE_CD    NUMBER                   DEFAULT 0                     NOT NULL,
  NORMALCY_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  RETENTION_TM_VALUE   NUMBER                   DEFAULT 0                     NOT NULL,
  RETENTION_UNITS_CD   NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_LOGIN_ORDER_LIST
(
  ORDER_ID      NUMBER                          DEFAULT 0                     NOT NULL,
  ACCESSION_ID  NUMBER                          DEFAULT 0                     NOT NULL,
  ENCNTR_ID     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_PREFIX
(
  PREFIX_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  SITE_CD                    NUMBER             DEFAULT 0                     NOT NULL,
  ACCESSION_FORMAT_CD        NUMBER             DEFAULT 0                     NOT NULL,
  PREFIX_NAME                CHAR(2 BYTE),
  PREFIX_DESC                VARCHAR2(40 BYTE),
  CASE_TYPE_CD               NUMBER             DEFAULT 0                     NOT NULL,
  GROUP_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  ORDER_CATALOG_CD           NUMBER             DEFAULT 0                     NOT NULL,
  GROSS_TASK_ASSAY_CD        NUMBER             DEFAULT 0                     NOT NULL,
  DEFAULT_PROC_CATALOG_CD    NUMBER             DEFAULT 0                     NOT NULL,
  SPECIMEN_GROUPING_CD       NUMBER             DEFAULT 0                     NOT NULL,
  WORKSHEET_TEMPLATE_ID      NUMBER             DEFAULT 0                     NOT NULL,
  DIAG_CODING_VOCABULARY_CD  NUMBER             DEFAULT 0                     NOT NULL,
  INITIATE_PROTOCOL_IND      NUMBER,
  CONSULT_IND                NUMBER,
  ACTIVE_IND                 NUMBER,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD        NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_PREFIX_ACCN_TEMPLATE_R
(
  PREFIX_ID     NUMBER                          DEFAULT 0                     NOT NULL,
  TEMPLATE_CD   NUMBER                          DEFAULT 0                     NOT NULL,
  DEFAULT_IND   NUMBER,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_PREFIX_AUTO_TASK
(
  PREFIX_ID     NUMBER                          DEFAULT 0                     NOT NULL,
  CATALOG_CD    NUMBER                          DEFAULT 0                     NOT NULL,
  SPECIMEN_IND  NUMBER,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_PREFIX_DIAG_AXIS
(
  PREFIX_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  EXCLUDE_AXIS_CD  NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_PREFIX_DIAG_SMRY
(
  PREFIX_DIAG_SMRY_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  PREFIX_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  COMMENT_LENGTH_QTY   NUMBER                   DEFAULT 0                     NOT NULL,
  REQUIRED_IND         NUMBER                   DEFAULT 0                     NOT NULL,
  COMMENT_IND          NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_PREFIX_STATION_R
(
  STATION_ID     NUMBER                         DEFAULT 0                     NOT NULL,
  PREFIX_ID      NUMBER                         DEFAULT 0                     NOT NULL,
  CATALOG_CD     NUMBER                         DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD  NUMBER                         DEFAULT 0                     NOT NULL,
  PUBLISH_FLAG   NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_PREFIX_TAG_GROUP_R
(
  PREFIX_ID      NUMBER                         DEFAULT 0                     NOT NULL,
  TAG_TYPE_FLAG  NUMBER                         DEFAULT 0                     NOT NULL,
  TAG_GROUP_ID   NUMBER                         DEFAULT 0                     NOT NULL,
  PRIMARY_IND    NUMBER,
  TAG_SEPARATOR  CHAR(1 BYTE),
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_PREFIX_TASK_R
(
  AP_PREFIX_TASK_R_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  PREFIX_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_PRSNL_PRIV
(
  PRIVILEGE_ID  NUMBER                          DEFAULT 0                     NOT NULL,
  PRSNL_ID      NUMBER                          DEFAULT 0                     NOT NULL,
  PRIVILEGE_CD  NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_QA_INFO
(
  QA_FLAG_ID       NUMBER                       DEFAULT 0                     NOT NULL,
  CASE_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  FLAG_TYPE_CD     NUMBER                       DEFAULT 0                     NOT NULL,
  ACTIVATED_ID     NUMBER                       DEFAULT 0                     NOT NULL,
  ACTIVATED_DT_TM  DATE,
  PERSON_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  COMPLETE_ID      NUMBER                       DEFAULT 0                     NOT NULL,
  COMPLETE_DT_TM   DATE,
  SUSPEND_ID       NUMBER                       DEFAULT 0                     NOT NULL,
  SUSPEND_DT_TM    DATE,
  CANCEL_CD        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  ACTIVE_IND       NUMBER                       DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_QUERY_RESULT
(
  QUERY_RESULT_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  CASE_QUERY_ID    NUMBER                       DEFAULT 0                     NOT NULL,
  ACCESSION_NBR    CHAR(21 BYTE),
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  EVENT_ID         NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_QUERY_RESULT_OFFSET
(
  QUERY_RESULT_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  SEQUENCE         NUMBER                       DEFAULT 0                     NOT NULL,
  EVENT_ID         NUMBER                       DEFAULT 0                     NOT NULL,
  OFFSET           NUMBER                       DEFAULT 0,
  LENGTH           NUMBER                       DEFAULT 0,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_SPECIMEN_PROTOCOL
(
  PROTOCOL_ID     NUMBER                        DEFAULT 0                     NOT NULL,
  SPECIMEN_CD     NUMBER                        DEFAULT 0                     NOT NULL,
  PREFIX_ID       NUMBER                        DEFAULT 0                     NOT NULL,
  PATHOLOGIST_ID  NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_SYNOPTIC_SPEC_PREFIX_R
(
  SPECIMEN_CD     NUMBER                        DEFAULT 0                     NOT NULL,
  PREFIX_ID       NUMBER                        DEFAULT 0                     NOT NULL,
  SEQUENCE        NUMBER                        DEFAULT 0                     NOT NULL,
  SUGGESTED_FLAG  NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  CKI_SOURCE      CHAR(12 BYTE)                 DEFAULT ' '                   NOT NULL,
  CKI_IDENTIFIER  VARCHAR2(50 BYTE)             DEFAULT ' '                   NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_SYS_CORR
(
  SYS_CORR_ID              NUMBER               DEFAULT 0                     NOT NULL,
  STUDY_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  CASE_PERCENTAGE          NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER               DEFAULT 0                     NOT NULL,
  EXECUTE_ON_RESCREEN_IND  NUMBER               DEFAULT 0                     NOT NULL,
  LOOKBACK_CASE_TYPE_CD    NUMBER               DEFAULT 0                     NOT NULL,
  LOOKBACK_MONTHS          NUMBER               DEFAULT 0                     NOT NULL,
  LOOKBACK_ALL_CASES_IND   NUMBER               DEFAULT 0                     NOT NULL,
  NOTIFY_USER_ONLINE_IND   NUMBER               DEFAULT 0                     NOT NULL,
  ASSIGN_TO_GROUP_IND      NUMBER               DEFAULT 0                     NOT NULL,
  ASSIGN_TO_PRSNL_ID       NUMBER               DEFAULT 0                     NOT NULL,
  ASSIGN_TO_GROUP_ID       NUMBER               DEFAULT 0                     NOT NULL,
  ASSIGN_TO_VERIFYING_IND  NUMBER               DEFAULT 0,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  STUDY_SEQUENCE           NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_SYS_CORR_COUNTS
(
  SYS_CORR_ID      NUMBER                       DEFAULT 0                     NOT NULL,
  TOTAL_CASES      NUMBER                       DEFAULT 0                     NOT NULL,
  QUALIFIED_CASES  NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_SYS_CORR_DETAIL
(
  SYS_CORR_DETAIL_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  SYS_CORR_ID         NUMBER                    DEFAULT 0                     NOT NULL,
  PARAM_NAME          VARCHAR2(20 BYTE)         DEFAULT ' '                   NOT NULL,
  PARAM_SEQUENCE      NUMBER                    DEFAULT 0                     NOT NULL,
  LOOKBACK_IND        NUMBER                    DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME  VARCHAR2(32 BYTE)         DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AP_TRANS_STAT
(
  AP_TRANS_STAT_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  REPORT_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  CASE_TYPE_CD         NUMBER                   DEFAULT 0                     NOT NULL,
  PATHOLOGIST_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  TRANSCRIPTIONIST_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  TRANSCRIBED_DT_TM    DATE,
  NBR_WORDS            NUMBER,
  NBR_CHARACTERS       NUMBER,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ASSAY_PROCESSING_R
(
  TASK_ASSAY_CD               NUMBER            DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD         NUMBER            DEFAULT 0                     NOT NULL,
  UPLD_ASSAY_ALIAS            VARCHAR2(25 BYTE),
  PROCESS_SEQUENCE            NUMBER,
  ACTIVE_IND                  NUMBER,
  DEFAULT_RESULT_TYPE_CD      NUMBER            DEFAULT 0                     NOT NULL,
  DEFAULT_RESULT_TEMPLATE_ID  NUMBER            DEFAULT 0                     NOT NULL,
  QC_RESULT_TYPE_CD           NUMBER            DEFAULT 0                     NOT NULL,
  QC_SEQUENCE                 NUMBER,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  DOWNLD_IND                  NUMBER,
  POST_ZERO_RESULT_IND        NUMBER,
  DISPLAY_SEQUENCE            NUMBER,
  DNLD_ASSAY_ALIAS            VARCHAR2(100 BYTE),
  CODE_SET                    NUMBER,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  LOADED_SERVICE_RESOURCE_CD  NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ASSAY_RESOURCE_LIST
(
  SERVICE_RESOURCE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD           NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  RESOURCE_GROUP_CD       NUMBER                DEFAULT 0                     NOT NULL,
  RESOURCE_ROUTE_FLAG     NUMBER,
  PRIMARY_IND             NUMBER,
  SEQUENCE                NUMBER,
  SCRIPT_NAME             VARCHAR2(50 BYTE),
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ASSAY_RESOURCE_LOT
(
  LOT_ID               NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  MEAN                 FLOAT(126),
  CLINICAL_STD_DEV     FLOAT(126),
  STATISTICAL_STD_DEV  FLOAT(126),
  ABS_LOW              FLOAT(126),
  ABS_HIGH             FLOAT(126),
  RULE_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_IND           NUMBER,
  BEG_EFFECTIVE_DT_TM  DATE,
  END_EFFECTIVE_DT_TM  DATE,
  ARL_ID               NUMBER                   DEFAULT 0                     NOT NULL,
  MANF_LOW             FLOAT(126)               DEFAULT 0,
  MANF_HIGH            FLOAT(126)               DEFAULT 0,
  MANF_STD_DEV         FLOAT(126),
  MANF_MEAN            FLOAT(126)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ASSAY_RESOURCE_TRANSLATION
(
  TASK_ASSAY_CD               NUMBER            DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD         NUMBER            DEFAULT 0                     NOT NULL,
  UPLD_ASSAY_ALIAS            VARCHAR2(25 BYTE) DEFAULT ' ' NOT NULL,
  ACTIVE_IND                  NUMBER,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  POST_ZERO_RESULT_IND        NUMBER,
  PROCESS_SEQUENCE            NUMBER,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  LOADED_SERVICE_RESOURCE_CD  NUMBER            DEFAULT 0                     NOT NULL,
  DECIMAL_MOVEMENT_NBR        NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ASSIGN
(
  PRODUCT_EVENT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ASSIGN_REASON_CD        NUMBER                DEFAULT 0                     NOT NULL,
  PROV_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ORIG_ASSIGN_QTY         NUMBER,
  CUR_ASSIGN_QTY          NUMBER,
  ORIG_ASSIGN_INTL_UNITS  NUMBER                DEFAULT 0,
  CUR_ASSIGN_INTL_UNITS   NUMBER                DEFAULT 0,
  BB_ID_NBR               VARCHAR2(20 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ASSIGN_ELIG_RELTN
(
  ASSIGN_ELIG_RELTN_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  COHORT_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  PT_ELIG_TRACKING_ID   NUMBER                  DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM   DATE                    DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM   DATE                    DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ASSIGN_REG_RELTN
(
  ASSIGN_REG_RELTN_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  COHORT_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  REG_ID               NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ASSIGN_RELEASE
(
  ASSIGN_RELEASE_ID       NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_EVENT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  RELEASE_DT_TM           DATE,
  RELEASE_PRSNL_ID        NUMBER                DEFAULT 0                     NOT NULL,
  RELEASE_REASON_CD       NUMBER                DEFAULT 0                     NOT NULL,
  RELEASE_QTY             NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  RELEASE_INTL_UNITS      NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AT_ACCT_RELTN
(
  AT_ACCT_RELTN_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ACCT_TEMPL_ID           NUMBER                DEFAULT 0                     NOT NULL,
  ACCT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  CREATED_DT_TM           DATE                  DEFAULT SYSDATE,
  CREATED_PRSNL_ID        NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AUTH
(
  AUTH_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(100 BYTE),
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ACCIDENT_DT_TM          DATE,
  LAST_PERIOD_DATE        DATE,
  ESTIMATED_DOB           DATE,
  ILLNESS_DT_TM           DATE,
  AUTH_NUMBER             NUMBER,
  AUTH_ISSUE_DT_TM        DATE,
  CLAIM_NUMBER            NUMBER,
  STATUS_CD               NUMBER                DEFAULT 0                     NOT NULL,
  STATUS_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  STATUS_DT_TM            DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AUTHORIZATION
(
  AUTHORIZATION_ID         NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID           NUMBER               DEFAULT 0                     NOT NULL,
  CERT_NBR                 VARCHAR2(50 BYTE),
  AUTH_NBR                 VARCHAR2(50 BYTE),
  CERT_PRSNL_ID            NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_TYPE_CD             NUMBER               DEFAULT 0                     NOT NULL,
  DESCRIPTION              VARCHAR2(200 BYTE),
  CERT_STATUS_CD           NUMBER               DEFAULT 0                     NOT NULL,
  APPEAL_REASON            VARCHAR2(100 BYTE),
  TOTAL_SERVICE_NBR        NUMBER,
  SERVICE_TYPE_CD          NUMBER               DEFAULT 0                     NOT NULL,
  CERT_COMPANY             VARCHAR2(100 BYTE),
  BNFT_TYPE_CD             NUMBER               DEFAULT 0                     NOT NULL,
  LAST_UPDATE_DT_TM        DATE,
  BEG_EFFECTIVE_DT_TM      DATE,
  END_EFFECTIVE_DT_TM      DATE,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD    NUMBER               DEFAULT 0                     NOT NULL,
  DATA_STATUS_CD           NUMBER               DEFAULT 0                     NOT NULL,
  DATA_STATUS_PRSNL_ID     NUMBER               DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM        DATE,
  AUTH_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_REMAIN_CNT          NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_QUAL_CD             NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_REQUIRED_CD         NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_OBTAINED_DT_TM      DATE,
  COMMENT_ID               NUMBER               DEFAULT 0                     NOT NULL,
  INTERCHANGE_ID           NUMBER               DEFAULT 0                     NOT NULL,
  CERT_TYPE_CD             NUMBER               DEFAULT 0                     NOT NULL,
  DELAY_REASON_CD          NUMBER               DEFAULT 0                     NOT NULL,
  REJECT_REASON_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ADMISSION_BEG_DT_TM      DATE,
  ADMISSION_END_DT_TM      DATE,
  SERVICE_BEG_DT_TM        DATE,
  SERVICE_END_DT_TM        DATE,
  AUTH_CNT_UNIT_CD         NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_CNT_TIME_CD         NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_TRANS_STATE_FLAG    NUMBER               DEFAULT 0                     NOT NULL,
  DISCHARGE_DT_TM          DATE,
  SURGICAL_DT_TM           DATE,
  TAXONOMY_ID              NUMBER               DEFAULT 0                     NOT NULL,
  PROVIDER_PRSNL_ID        NUMBER               DEFAULT 0                     NOT NULL,
  X12SERVICE_TYPE_CD       NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_CNT_TIME            FLOAT(126)           DEFAULT 0                     NOT NULL,
  AUTH_CNT_UNIT            FLOAT(126)           DEFAULT 0                     NOT NULL,
  AUTH_EXPIRE_DT_TM        DATE,
  FACILITY_CD              NUMBER               DEFAULT 0                     NOT NULL,
  X12PROVIDER_CD           NUMBER               DEFAULT 0                     NOT NULL,
  REFERENCE_NBR_TXT        VARCHAR2(100 BYTE),
  DELAY_REASON_COMMENT_ID  NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AUTHORIZATION_HIST
(
  AUTHORIZATION_HIST_ID    NUMBER               DEFAULT 0                     NOT NULL,
  AUTHORIZATION_ID         NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID           NUMBER               DEFAULT 0                     NOT NULL,
  CERT_NBR                 VARCHAR2(50 BYTE),
  AUTH_NBR                 VARCHAR2(50 BYTE),
  CERT_PRSNL_ID            NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_TYPE_CD             NUMBER               DEFAULT 0                     NOT NULL,
  DESCRIPTION              VARCHAR2(200 BYTE),
  CERT_STATUS_CD           NUMBER               DEFAULT 0                     NOT NULL,
  APPEAL_REASON            VARCHAR2(100 BYTE),
  TOTAL_SERVICE_NBR        NUMBER,
  SERVICE_TYPE_CD          NUMBER               DEFAULT 0                     NOT NULL,
  CERT_COMPANY             VARCHAR2(100 BYTE),
  BNFT_TYPE_CD             NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD    NUMBER               DEFAULT 0                     NOT NULL,
  DATA_STATUS_CD           NUMBER               DEFAULT 0                     NOT NULL,
  DATA_STATUS_PRSNL_ID     NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_REMAIN_CNT          NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_QUAL_CD             NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_REQUIRED_CD         NUMBER               DEFAULT 0                     NOT NULL,
  COMMENT_ID               NUMBER               DEFAULT 0                     NOT NULL,
  INTERCHANGE_ID           NUMBER               DEFAULT 0                     NOT NULL,
  CERT_TYPE_CD             NUMBER               DEFAULT 0                     NOT NULL,
  DELAY_REASON_CD          NUMBER               DEFAULT 0                     NOT NULL,
  REJECT_REASON_CD         NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_CNT_UNIT_CD         NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_CNT_TIME_CD         NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_TRANS_STATE_FLAG    NUMBER               DEFAULT 0                     NOT NULL,
  TAXONOMY_ID              NUMBER               DEFAULT 0                     NOT NULL,
  PROVIDER_PRSNL_ID        NUMBER               DEFAULT 0                     NOT NULL,
  X12SERVICE_TYPE_CD       NUMBER               DEFAULT 0                     NOT NULL,
  AUTH_CNT_TIME            FLOAT(126)           DEFAULT 0                     NOT NULL,
  AUTH_CNT_UNIT            FLOAT(126)           DEFAULT 0                     NOT NULL,
  FACILITY_CD              NUMBER               DEFAULT 0                     NOT NULL,
  X12PROVIDER_CD           NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  AUTH_EXPIRE_DT_TM        DATE,
  AUTH_OBTAINED_DT_TM      DATE,
  BEG_EFFECTIVE_DT_TM      DATE,
  DATA_STATUS_DT_TM        DATE,
  DISCHARGE_DT_TM          DATE,
  LAST_UPDATE_DT_TM        DATE,
  SERVICE_END_DT_TM        DATE,
  SURGICAL_DT_TM           DATE,
  ADMISSION_BEG_DT_TM      DATE,
  ADMISSION_END_DT_TM      DATE,
  END_EFFECTIVE_DT_TM      DATE,
  SERVICE_BEG_DT_TM        DATE,
  REFERENCE_NBR_TXT        VARCHAR2(100 BYTE),
  TRANSACTION_DT_TM        DATE,
  DELAY_REASON_COMMENT_ID  NUMBER               DEFAULT 0                     NOT NULL,
  CHANGE_BIT               NUMBER               DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID      NUMBER               DEFAULT 0                     NOT NULL,
  TRACKING_BIT             NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AUTHORIZATION_PROFILE
(
  AUTHORIZATION_PROFILE_ID  NUMBER              DEFAULT 0                     NOT NULL,
  PROFILE_PRSNL_ID          NUMBER              DEFAULT 0                     NOT NULL,
  PROFILE_TYPE_CD           NUMBER              DEFAULT 0                     NOT NULL,
  LOGICAL_DOMAIN_ID         NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AUTH_DETAIL
(
  AUTH_DETAIL_ID          NUMBER                DEFAULT 0                     NOT NULL,
  AUTHORIZATION_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  AUTH_COMPANY            VARCHAR2(100 BYTE),
  AUTH_PHONE_NUM          VARCHAR2(100 BYTE),
  AUTH_CONTACT            VARCHAR2(100 BYTE),
  AUTH_DT_TM              DATE,
  PLAN_CONTACT_ID         NUMBER                DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AUTH_DETAIL_HIST
(
  AUTH_DETAIL_HIST_ID     NUMBER                DEFAULT 0                     NOT NULL,
  AUTH_DETAIL_ID          NUMBER                DEFAULT 0                     NOT NULL,
  AUTHORIZATION_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  AUTH_COMPANY            VARCHAR2(100 BYTE),
  AUTH_PHONE_NUM          VARCHAR2(100 BYTE),
  AUTH_CONTACT            VARCHAR2(100 BYTE),
  AUTH_DT_TM              DATE,
  PLAN_CONTACT_ID         NUMBER                DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM       DATE,
  CHANGE_BIT              NUMBER                DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID     NUMBER                DEFAULT 0                     NOT NULL,
  TRACKING_BIT            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AUTH_ERROR
(
  AUTH_ERROR_ID       NUMBER                    DEFAULT 0                     NOT NULL,
  APPLICATION_NUMBER  NUMBER                    DEFAULT 0                     NOT NULL,
  TASK_NUMBER         NUMBER                    DEFAULT 0                     NOT NULL,
  PERSON_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  ERROR_DT_TM         DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AUTH_ERROR_DETAIL
(
  AUTH_ERROR_ID  NUMBER                         DEFAULT 0                     NOT NULL,
  SEQUENCE       NUMBER                         DEFAULT 0                     NOT NULL,
  DISPLAY_LABEL  VARCHAR2(20 BYTE),
  DISPLAY_VALUE  VARCHAR2(40 BYTE),
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AUTO_DIRECTED
(
  PRODUCT_EVENT_ID         NUMBER               DEFAULT 0                     NOT NULL,
  PRODUCT_ID               NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ASSOCIATED_DT_TM         DATE,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  EXPECTED_USAGE_DT_TM     DATE,
  DONATED_BY_RELATIVE_IND  NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AUTO_MATCH_DEFINITION
(
  AUTO_MATCH_DEF_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVITY_SUBTYPE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  IM_DEVICE_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  RIS_TAG              VARCHAR2(11 BYTE)        DEFAULT ' '                   NOT NULL,
  IMAGE_TAG            VARCHAR2(11 BYTE)        DEFAULT ' '                   NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  HISTORICAL_IND       NUMBER,
  DISCIPLINE_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  VALUE_TYPE           VARCHAR2(16 BYTE)        DEFAULT ' '
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AUTO_VERIFY
(
  AV_REF_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD       NUMBER              DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD             NUMBER              DEFAULT 0                     NOT NULL,
  PREV_VERF_IND             NUMBER              DEFAULT 0                     NOT NULL,
  DELTA_CHK_IND             NUMBER              DEFAULT 0                     NOT NULL,
  DUP_ASSAY_IND             NUMBER              DEFAULT 0                     NOT NULL,
  PREV_RSLT_IND             NUMBER              DEFAULT 0                     NOT NULL,
  UNVERF_PREV_RSLT_IND      NUMBER              DEFAULT 0                     NOT NULL,
  REF_RANGE_IND             NUMBER              DEFAULT 0                     NOT NULL,
  REV_RANGE_IND             NUMBER              DEFAULT 0                     NOT NULL,
  CRIT_RANGE_IND            NUMBER              DEFAULT 0                     NOT NULL,
  FEAS_RANGE_IND            NUMBER              DEFAULT 0                     NOT NULL,
  LIN_RANGE_IND             NUMBER              DEFAULT 0                     NOT NULL,
  REPEAT_FLAG               NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  SCRIPT                    CHAR(20 BYTE),
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  CONSISTENT_MAP            CHAR(50 BYTE),
  REPEAT_MAP                CHAR(50 BYTE),
  CONS_NBR_HRS              NUMBER,
  DEST_CODES                VARCHAR2(50 BYTE),
  DELTA_CHK_FLAG            NUMBER              DEFAULT 0                     NOT NULL,
  AV_STATUS_FLAG            NUMBER              DEFAULT 0                     NOT NULL,
  INSTR_ERROR_CODE_IND      NUMBER              DEFAULT 0                     NOT NULL,
  VALIDATE_QC_SCHEDULE_IND  NUMBER              DEFAULT 0                     NOT NULL,
  QC_INSTR_ERROR_CODE_IND   NUMBER              DEFAULT 0                     NOT NULL,
  NOTIFY_RANGE_IND          NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AV_CONSISTENCY
(
  AV_REF_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  AV_CONSISTENCY_FLAG    NUMBER                 DEFAULT 0                     NOT NULL,
  CONSISTENCY_IND        NUMBER                 DEFAULT 0                     NOT NULL,
  CONSISTENCY_MINUTES    NUMBER                 DEFAULT 0                     NOT NULL,
  CONSISTENCY_UNITS_CD   NUMBER                 DEFAULT 0                     NOT NULL,
  CONSISTENCY_TYPE_FLAG  NUMBER                 DEFAULT 0                     NOT NULL,
  CONSISTENCY_VARIANCE   FLOAT(126)             DEFAULT 0.0                   NOT NULL,
  ACTIVE_IND             NUMBER                 DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM    DATE                   DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM    DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AV_RES_CAT
(
  AV_RES_CAT_ID        NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  AV_RES_CAT_FLAG      NUMBER,
  ASSOC_CATALOG_CD     NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_IND           NUMBER,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE AV_STATUS_EVENT
(
  AV_EVENT_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  ACCESSION_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  AV_IND               NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD        NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BATCH_DENIAL_FILE_DETAIL_R
(
  BATCH_DENIAL_FILE_DETAIL_R_ID  NUMBER         DEFAULT 0                     NOT NULL,
  BATCH_DENIAL_FILE_R_ID         NUMBER         DEFAULT 0                     NOT NULL,
  REMARK_CODE_ATTRIB_CD          NUMBER         DEFAULT 0                     NOT NULL,
  REMARK_CODE_ATTRIB_VALUE       VARCHAR2(50 BYTE),
  ACTIVE_IND                     NUMBER,
  ACTIVE_STATUS_CD               NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM            DATE,
  ACTIVE_STATUS_PRSNL_ID         NUMBER         DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM            DATE           DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM            DATE           DEFAULT TO_DATE ( '12/31/210000:00:00' , 'MM/DD/YYYYHH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BATCH_DENIAL_FILE_R
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BATCH_DENIAL_FILE_R_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BATCH_TRANS_FILE_ID     NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  DENIAL_CD               NUMBER                DEFAULT 0                     NOT NULL,
  DENIAL_TEXT             VARCHAR2(255 BYTE)    DEFAULT ' '                   NOT NULL,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  DENIAL_CODE_TXT         VARCHAR2(50 BYTE),
  DENIAL_TYPE_CD          NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BATCH_LABEL
(
  BATCH_LABEL_ID          NUMBER                DEFAULT 0                     NOT NULL,
  MEDIA_MASTER_ID         NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_DT_TM             DATE,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ALIAS_SORT_STRING       VARCHAR2(40 BYTE),
  HIM_PRINTER_FORMATS_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BATCH_TRANS
(
  BATCH_TRANS_ID              NUMBER            DEFAULT 0                     NOT NULL,
  PFT_EVENT_OCCUR_LOG_ID      NUMBER            DEFAULT 0                     NOT NULL,
  EXT_BATCH_ID_TXT            VARCHAR2(100 BYTE),
  BATCH_STATUS_CD             NUMBER            DEFAULT 0                     NOT NULL,
  SESSION_ID                  NUMBER            DEFAULT 0                     NOT NULL,
  PAY_STATED_TOTAL            FLOAT(126),
  DR_CR_PAY_STATED_FLAG       NUMBER,
  ADJ_STATED_TOTAL            FLOAT(126),
  DR_CR_ADJ_STATED_FLAG       NUMBER,
  FC_STATED_TOTAL             FLOAT(126),
  DR_CR_FC_STATED_FLAG        NUMBER,
  PAY_RESTATED_TOTAL          FLOAT(126),
  DR_CR_PAY_RESTATED_FLAG     NUMBER,
  ADJ_RESTATED_TOTAL          FLOAT(126),
  DR_CR_ADJ_RESTATED_FLAG     NUMBER,
  FC_RESTATED_TOTAL           FLOAT(126),
  DR_CR_FC_RESTATED_FLAG      NUMBER,
  PAY_COMPUTED_TOTAL          FLOAT(126),
  DR_CR_PAY_COMPUTED_FLAG     NUMBER,
  ADJ_COMPUTED_TOTAL          FLOAT(126),
  DR_CR_ADJ_COMPUTED_FLAG     NUMBER,
  FC_COMPUTED_TOTAL           FLOAT(126),
  DR_CR_FC_COMPUTED_FLAG      NUMBER,
  BATCHJOB_IND                NUMBER,
  SUBMITTED_IND               NUMBER,
  SUBMITTED_DT_TM             DATE,
  DEPOSIT_RECORD_ID           NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM         DATE              DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM         DATE              DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  PURGED_IND                  NUMBER,
  ONEPAYMENT_IND              NUMBER            DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID           NUMBER            DEFAULT 0                     NOT NULL,
  POST_DT_TM                  DATE,
  BATCH_TYPE_FLAG             NUMBER,
  CREATED_DT_TM               DATE              DEFAULT SYSDATE,
  CREATED_PRSNL_ID            NUMBER            DEFAULT 0                     NOT NULL,
  BATCH_CONTROL_NBR           VARCHAR2(20 BYTE),
  EXT_BATCH_ID_TXT_KEY        VARCHAR2(100 BYTE),
  EXT_BATCH_ID_TXT_KEY_NLS    VARCHAR2(100 BYTE),
  BATCH_ALIAS                 VARCHAR2(25 BYTE),
  BATCH_ALIAS_KEY             VARCHAR2(25 BYTE),
  BATCH_ALIAS_KEY_NLS         VARCHAR2(52 BYTE),
  RAW_BATCH_TRANS_ID          NUMBER            DEFAULT 0,
  EXT_BATCH_ID_TXT_KEY_A_NLS  VARCHAR2(400 BYTE),
  BATCH_ALIAS_KEY_A_NLS       VARCHAR2(100 BYTE),
  LOGICAL_DOMAIN_ID           NUMBER            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BATCH_TRANS_EXT
(
  BATCH_TRANS_EXT_ID       NUMBER               DEFAULT 0                     NOT NULL,
  BATCH_TRANS_ID           NUMBER               DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME       VARCHAR2(20 BYTE),
  PARENT_ENTITY_ID         NUMBER               DEFAULT 0                     NOT NULL,
  EDI_ADJ_REASON_CD        NUMBER               DEFAULT 0                     NOT NULL,
  EDI_ADJ_QUANTITY         NUMBER               DEFAULT 0                     NOT NULL,
  EDI_ADJ_AMOUNT           FLOAT(126)           DEFAULT 0.0                   NOT NULL,
  EDI_ADJ_DR_CR_FLAG       NUMBER               DEFAULT 0                     NOT NULL,
  INPAT_PROF_COMP_AMT      FLOAT(126)           DEFAULT 0.0                   NOT NULL,
  NON_INPAT_PROF_COMP_AMT  FLOAT(126)           DEFAULT 0.0                   NOT NULL,
  ESRD_PAYMENT_AMOUNT      FLOAT(126)           DEFAULT 0.0                   NOT NULL,
  POSTED_IND               NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVITY_ID              NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  SEQUENCE_NBR             NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BATCH_TRANS_FILE
(
  BATCH_TRANS_FILE_ID       NUMBER              DEFAULT 0                     NOT NULL,
  BATCH_TRANS_ID            NUMBER              DEFAULT 0                     NOT NULL,
  SEQUENCE_NBR              NUMBER,
  TRANS_TYPE_CD             NUMBER              DEFAULT 0                     NOT NULL,
  TRANS_SUBTYPE_CD          NUMBER              DEFAULT 0                     NOT NULL,
  TRANS_REASON_CD           NUMBER              DEFAULT 0                     NOT NULL,
  DR_CR_AR_FLAG             NUMBER,
  TRANS_TOTAL_AMOUNT        FLOAT(126),
  AR_ACCOUNT_ID             NUMBER              DEFAULT 0                     NOT NULL,
  FINANCE_CHRG_ID           NUMBER              DEFAULT 0                     NOT NULL,
  PAYMENT_METHOD_CD         NUMBER              DEFAULT 0                     NOT NULL,
  PAYMENT_NUM_DESC          VARCHAR2(250 BYTE),
  POST_DT_TM                DATE,
  CC_BEG_EFF_DT_TM          DATE,
  CC_END_EFF_DT_TM          DATE,
  CURRENT_CUR_CD            NUMBER              DEFAULT 0                     NOT NULL,
  ORIG_CUR_CD               NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  PURGED_IND                NUMBER,
  BENEFIT_ORDER_ID          NUMBER              DEFAULT 0                     NOT NULL,
  BILL_NBR_DISP             VARCHAR2(50 BYTE),
  BILL_VRSN_NBR             NUMBER,
  CC_AUTH_NBR               VARCHAR2(50 BYTE),
  CHECK_DATE                DATE,
  CHRG_ACTIVITY_ID          NUMBER              DEFAULT 0                     NOT NULL,
  CORSP_ACTIVITY_ID         NUMBER              DEFAULT 0                     NOT NULL,
  DR_CR_FLAG                NUMBER,
  ENCNTR_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  ERROR_IND                 NUMBER,
  ERROR_STATUS_CD           NUMBER              DEFAULT 0                     NOT NULL,
  NONTRANS_FLAG             NUMBER,
  PARENT_ENTITY_ID          NUMBER              DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME        VARCHAR2(255 BYTE),
  PAYOR_CNTRL_NBR_TXT       VARCHAR2(255 BYTE),
  PAYOR_NAME                VARCHAR2(60 BYTE),
  PFT_ENCNTR_ID             NUMBER              DEFAULT 0                     NOT NULL,
  POSTING_METHOD_CD         NUMBER              DEFAULT 0                     NOT NULL,
  RELATED_SEQ_NBR           NUMBER,
  ROLL_BO_IND               NUMBER,
  CREATED_DT_TM             DATE                DEFAULT SYSDATE,
  CREATED_PRSNL_ID          NUMBER              DEFAULT 0                     NOT NULL,
  TRANS_ALIAS_ID            NUMBER              DEFAULT 0                     NOT NULL,
  PATIENT_RESPONSIBILITY    FLOAT(126),
  CLAIM_STATUS_CD           NUMBER              DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID            NUMBER              DEFAULT 0                     NOT NULL,
  EDI_ADJ_GROUP_CD          NUMBER              DEFAULT 0                     NOT NULL,
  EDI_ADJ_QUANTITY          NUMBER              DEFAULT 0                     NOT NULL,
  INPAT_PROF_COMP_AMT       FLOAT(126)          DEFAULT 0.0                   NOT NULL,
  NON_INPAT_PROF_COMP_AMT   FLOAT(126)          DEFAULT 0.0                   NOT NULL,
  ESRD_PAYMENT_AMOUNT       FLOAT(126)          DEFAULT 0.0                   NOT NULL,
  CLAIM_FILE_CD             NUMBER              DEFAULT 0                     NOT NULL,
  POST_CLAIM_DEFAULT_IND    NUMBER              DEFAULT 0                     NOT NULL,
  TENDERED_AMOUNT           FLOAT(126),
  PFT_LINE_ITEM_ID          NUMBER              DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID              NUMBER              DEFAULT 0                     NOT NULL,
  CHANGE_DUE_AMT            FLOAT(126)          DEFAULT 0                     NOT NULL,
  RAW_BATCH_TRANS_FILE_ID   NUMBER              DEFAULT 0,
  TRANS_GROUP_NBR           NUMBER              DEFAULT 0,
  ERROR_STATUS_REASON_DESC  VARCHAR2(250 BYTE),
  EXTERNAL_IDENT            VARCHAR2(250 BYTE),
  GUARANTOR_PERSON_ID       NUMBER              DEFAULT 0,
  CC_TOKEN_TXT              VARCHAR2(250 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BATCH_TRANS_RELTN
(
  BATCH_TRANS_RELTN_ID    NUMBER                DEFAULT 0                     NOT NULL,
  BATCH_TRANS_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVITY_ID             NUMBER                DEFAULT 0                     NOT NULL,
  SEQUENCE_NBR            NUMBER,
  DISABLED_IND            NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BBHIST_PRODUCT
(
  PRODUCT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_NBR             VARCHAR2(20 BYTE)     DEFAULT ' '                   NOT NULL,
  PRODUCT_SUB_NBR         CHAR(5 BYTE),
  ALTERNATE_NBR           VARCHAR2(20 BYTE),
  PRODUCT_CD              NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_CLASS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  SUPPLIER_ID             NUMBER                DEFAULT 0                     NOT NULL,
  SUPPLIER_PREFIX         CHAR(5 BYTE),
  ABO_CD                  NUMBER                DEFAULT 0                     NOT NULL,
  RH_CD                   NUMBER                DEFAULT 0                     NOT NULL,
  EXPIRE_DT_TM            DATE                  DEFAULT SYSDATE               NOT NULL,
  VOLUME                  NUMBER                DEFAULT 0,
  UNIT_MEAS_CD            NUMBER                DEFAULT 0                     NOT NULL,
  OWNER_AREA_CD           NUMBER                DEFAULT 0                     NOT NULL,
  INV_AREA_CD             NUMBER                DEFAULT 0                     NOT NULL,
  POOLED_PRODUCT_ID       NUMBER                DEFAULT 0                     NOT NULL,
  MODIFIED_PRODUCT_ID     NUMBER                DEFAULT 0                     NOT NULL,
  POOLED_PRODUCT_IND      NUMBER,
  MODIFIED_PRODUCT_IND    NUMBER,
  CROSS_REFERENCE         VARCHAR2(40 BYTE),
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPLOAD_DT_TM            DATE                  DEFAULT SYSDATE               NOT NULL,
  FLAG_CHARS              CHAR(2 BYTE),
  PRODUCT_NBR_FORMAT_CD   NUMBER                DEFAULT 0                     NOT NULL,
  DONOR_XREF_TXT          VARCHAR2(40 BYTE)     DEFAULT ' '
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BBHIST_PRODUCT_EVENT
(
  PRODUCT_EVENT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_DT_TM             DATE                  DEFAULT SYSDATE               NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  REASON_CD               NUMBER                DEFAULT 0                     NOT NULL,
  VOLUME                  NUMBER                DEFAULT 0,
  BAG_RETURNED_IND        NUMBER                DEFAULT 0,
  TAG_RETURNED_IND        NUMBER                DEFAULT 0,
  QTY                     NUMBER                DEFAULT 0,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  INTERNATIONAL_UNIT      NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_AUTODIR_EXCEPTION
(
  BB_AUTODIR_EXC_ID       NUMBER                DEFAULT 0                     NOT NULL,
  BB_EXCEPTION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_DEVICE_TRANSFER
(
  PRODUCT_EVENT_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  PRODUCT_ID        NUMBER                      DEFAULT 0                     NOT NULL,
  FROM_DEVICE_ID    NUMBER                      DEFAULT 0                     NOT NULL,
  TO_DEVICE_ID      NUMBER                      DEFAULT 0                     NOT NULL,
  REASON_CD         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_DSPNS_BLOCK
(
  DISPENSE_BLOCK_ID       NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_CD              NUMBER                DEFAULT 0                     NOT NULL,
  ALLOW_OVERRIDE_IND      NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_DSPNS_BLOCK_PRODUCT
(
  BLOCK_PRODUCT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  DISPENSE_BLOCK_ID       NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_CD              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_EDN_ADMIN
(
  BB_EDN_ADMIN_ID          NUMBER               DEFAULT 0                     NOT NULL,
  ORDER_NBR_IDENT          VARCHAR2(12 BYTE)    DEFAULT ' '                   NOT NULL,
  DISPATCH_NBR_TXT         VARCHAR2(12 BYTE)    DEFAULT ' '                   NOT NULL,
  ADMIN_DT_TM              DATE                 DEFAULT SYSDATE               NOT NULL,
  SOURCE_ORG_ID            NUMBER               DEFAULT 0                     NOT NULL,
  DESTINATION_LOC_CD       NUMBER               DEFAULT 0                     NOT NULL,
  PROTOCOL_NBR             NUMBER               DEFAULT 0                     NOT NULL,
  EDN_COMPLETE_IND         NUMBER               DEFAULT 0                     NOT NULL,
  LONG_BLOB_ID             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  DESTINATION_INV_AREA_CD  NUMBER               DEFAULT 0,
  CONTRIBUTOR_SYSTEM_CD    NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_EDN_DSCRPNCY_OVRD
(
  BB_EDN_DSCRPNCY_OVRD_ID  NUMBER               DEFAULT 0                     NOT NULL,
  BB_EDN_ADMIN_ID          NUMBER               DEFAULT 0                     NOT NULL,
  BB_EDN_PRODUCT_ID        NUMBER               DEFAULT 0                     NOT NULL,
  PRODUCT_ID               NUMBER               DEFAULT 0                     NOT NULL,
  EXCEPTION_ID             NUMBER               DEFAULT 0                     NOT NULL,
  EDN_PRODUCT_NBR_IDENT    VARCHAR2(20 BYTE)    DEFAULT ' '                   NOT NULL,
  PRODUCT_CD               NUMBER               DEFAULT 0                     NOT NULL,
  OVRD_REASON_CD           NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_EDN_PROBLEM
(
  BB_EDN_PROBLEM_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  BB_EDN_PRODUCT_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  PROBLEM_TYPE_CD    NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_EDN_PRODUCT
(
  BB_EDN_PRODUCT_ID            NUMBER           DEFAULT 0                     NOT NULL,
  BB_EDN_ADMIN_ID              NUMBER           DEFAULT 0                     NOT NULL,
  EDN_PRODUCT_NBR_IDENT        VARCHAR2(20 BYTE) DEFAULT ' ' NOT NULL,
  PRODUCT_TYPE_TXT             VARCHAR2(50 BYTE) DEFAULT ' ' NOT NULL,
  ABO_CD                       NUMBER           DEFAULT 0                     NOT NULL,
  RH_CD                        NUMBER           DEFAULT 0                     NOT NULL,
  DONATION_DT_TM               DATE,
  EXPIRATION_DT_TM             DATE             DEFAULT SYSDATE,
  VOLUME_CNT                   NUMBER           DEFAULT 0                     NOT NULL,
  PRODUCT_COMMENT_TXT          VARCHAR2(30 BYTE) DEFAULT ' ' NOT NULL,
  DELIVERY_TYPE_CD             NUMBER           DEFAULT 0                     NOT NULL,
  CLINICAL_USE_IND             NUMBER           DEFAULT 0                     NOT NULL,
  PRODUCT_ID                   NUMBER           DEFAULT 0                     NOT NULL,
  PRODUCT_COMPLETE_IND         NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  FLAG_CHAR_TXT                VARCHAR2(2 BYTE),
  PRODUCT_CD                   NUMBER           DEFAULT 0,
  ISBT_BLOOD_TYPE_BARCODE      VARCHAR2(200 BYTE),
  SUPPLIER_PRODUCT_ALIAS_NAME  VARCHAR2(40 BYTE),
  LONG_TEXT_ID                 NUMBER           DEFAULT 0,
  PRODUCT_SUB_NBR_TXT          VARCHAR2(5 BYTE),
  EVENT_DT_TM                  DATE,
  EVENT_PRSNL_ID               NUMBER           DEFAULT 0,
  PERSON_ID                    NUMBER           DEFAULT 0,
  ALIAS                        VARCHAR2(100 BYTE),
  STATUS_CD                    NUMBER           DEFAULT 0,
  UNIT_CONDITION_CD            NUMBER           DEFAULT 0,
  DEVICE_TXT                   VARCHAR2(40 BYTE),
  SUB_STATUS_CD                NUMBER           DEFAULT 0,
  ALIAS_POOL_CD                NUMBER           DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_EDN_SPCL_TESTING
(
  BB_EDN_SPCL_TESTING_ID          NUMBER        DEFAULT 0                     NOT NULL,
  BB_EDN_PRODUCT_ID               NUMBER        DEFAULT 0                     NOT NULL,
  SPCL_TESTING_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  CONFIRMED_IND                   NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  ISBT_SPCL_TEST_BARCODE          VARCHAR2(200 BYTE),
  ISBT_SPCL_TEST_BARCODE_TYP_TXT  VARCHAR2(2 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_EXCEPTION
(
  EXCEPTION_ID            NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_EVENT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  EXCEPTION_TYPE_CD       NUMBER                DEFAULT 0                     NOT NULL,
  OVERRIDE_REASON_CD      NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  FROM_ABO_CD             NUMBER                DEFAULT 0                     NOT NULL,
  FROM_RH_CD              NUMBER                DEFAULT 0                     NOT NULL,
  TO_ABO_CD               NUMBER                DEFAULT 0                     NOT NULL,
  TO_RH_CD                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  PERFORM_RESULT_ID       NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  DONOR_CONTACT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  DONOR_CONTACT_TYPE_CD   NUMBER                DEFAULT 0                     NOT NULL,
  REVIEW_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  REVIEW_BY_PRSNL_ID      NUMBER                DEFAULT 0                     NOT NULL,
  REVIEW_DT_TM            DATE,
  REVIEW_DOC_ID           NUMBER                DEFAULT 0                     NOT NULL,
  EXCEPTION_DT_TM         DATE,
  EXCEPTION_PRSNL_ID      NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ABO_CD           NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_RH_CD            NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_ABO_CD          NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_RH_CD           NUMBER                DEFAULT 0                     NOT NULL,
  DEFAULT_EXPIRE_DT_TM    DATE,
  DONATION_IDENT          VARCHAR2(20 BYTE),
  PROCEDURE_CD            NUMBER                DEFAULT 0,
  INELIGIBLE_UNTIL_DT_TM  DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_EXCEPT_CXM
(
  BB_EXCEPT_CXM_ID        NUMBER                DEFAULT 0                     NOT NULL,
  BB_EXCEPTION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  MESSAGE_CD              NUMBER                DEFAULT 0                     NOT NULL,
  OVERRIDE_REASON_CD      NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_EXC_CXM_PRODUCT
(
  BB_EXC_CXM_PRODUCT_ID    NUMBER               DEFAULT 0                     NOT NULL,
  BB_EXCEPTION_ID          NUMBER               DEFAULT 0                     NOT NULL,
  PRODUCT_ID               NUMBER               DEFAULT 0                     NOT NULL,
  PRODUCT_CD               NUMBER               DEFAULT 0                     NOT NULL,
  ABO_CD                   NUMBER               DEFAULT 0                     NOT NULL,
  RH_CD                    NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_DT_TM              DATE,
  CROSSMATCH_EXPIRE_DT_TM  DATE,
  PRODUCT_EVENT_ID         NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_FACILITY_PRINTER_R
(
  BB_FACILITY_PRINTER_R_ID  NUMBER              DEFAULT 0                     NOT NULL,
  BB_ORGANIZATION_ID        NUMBER              DEFAULT 0                     NOT NULL,
  BB_PRINTER_ID             NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_INVENTORY_AREA
(
  SERVICE_RESOURCE_CD   NUMBER                  DEFAULT 0                     NOT NULL,
  BB_DEVICE_TYPE_CD     NUMBER                  DEFAULT 0                     NOT NULL,
  BB_PROD_IND           NUMBER,
  BB_MONITORED_TEMP_HI  FLOAT(126),
  BB_MONITORED_TEMP_LO  FLOAT(126),
  BB_BARCODE_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_INVENTORY_TRANSFER
(
  PRODUCT_EVENT_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  FROM_OWNER_AREA_CD     NUMBER                 DEFAULT 0                     NOT NULL,
  FROM_INV_AREA_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  TRANSFER_REASON_CD     NUMBER                 DEFAULT 0                     NOT NULL,
  TO_OWNER_AREA_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  TO_INV_AREA_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  TRANSFERRED_QTY        NUMBER,
  TRANSFERRED_INTL_UNIT  NUMBER,
  TO_PRODUCT_EVENT_ID    NUMBER                 DEFAULT 0,
  EVENT_TYPE_CD          NUMBER                 DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_ISBT_SUPPLIER
(
  BB_ISBT_SUPPLIER_ID     NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ISBT_SUPPLIER_FIN       VARCHAR2(5 BYTE),
  INVENTORY_AREA_CD       NUMBER                DEFAULT 0                     NOT NULL,
  LICENSE_NBR_TXT         VARCHAR2(15 BYTE),
  REGISTRATION_NBR_TXT    VARCHAR2(15 BYTE),
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_LABEL_VERIFY
(
  BB_LABEL_VERIFY_ID      NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  LABEL_VERF_DT_TM        DATE                  DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  PERSONNEL_ID            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_MOD_NEW_PRODUCT
(
  MOD_NEW_PROD_ID          NUMBER               DEFAULT 0                     NOT NULL,
  OPTION_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ORIG_PRODUCT_CD          NUMBER               DEFAULT 0                     NOT NULL,
  NEW_PRODUCT_CD           NUMBER               DEFAULT 0                     NOT NULL,
  QUANTITY                 FLOAT(126),
  DEFAULT_SUB_ID_FLAG      NUMBER,
  MAX_PREP_HRS             FLOAT(126),
  DEFAULT_ORIG_EXP_IND     NUMBER,
  CALC_EXP_DRAWN_IND       NUMBER,
  DEFAULT_EXP_DAYS         FLOAT(126),
  DEFAULT_EXP_HRS          FLOAT(126),
  ALLOW_EXTEND_EXP_IND     NUMBER,
  DEFAULT_ORIG_VOL_IND     NUMBER,
  DEFAULT_VOLUME           FLOAT(126),
  CALC_VOL_IND             NUMBER,
  PROMPT_VOL_IND           NUMBER,
  VALIDATE_VOL_IND         NUMBER,
  DEFAULT_UNIT_OF_MEAS_CD  NUMBER               DEFAULT 0                     NOT NULL,
  SYNONYM_ID               NUMBER               DEFAULT 0                     NOT NULL,
  REQUIRE_ASSIGN_IND       NUMBER,
  BAG_TYPE_CD              NUMBER               DEFAULT 0                     NOT NULL,
  CROSSOVER_REASON_CD      NUMBER               DEFAULT 0                     NOT NULL,
  ALLOW_NO_ABORH_IND       NUMBER,
  DEFAULT_SUPPLIER_ID      NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  ORIG_PLASMA_PROD_CD      NUMBER               DEFAULT 0,
  ISBT_BARCODE             VARCHAR2(20 BYTE),
  CODABAR_BARCODE          VARCHAR2(20 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_MOD_POOL_NBR
(
  MOD_POOL_NBR_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  OPTION_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  PREFIX             VARCHAR2(10 BYTE)          DEFAULT ' '                   NOT NULL,
  YEAR               NUMBER                     DEFAULT 0                     NOT NULL,
  SEQ_NBR            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  ORGANIZATION_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  ISBT_SUPPLIER_FIN  VARCHAR2(5 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_MOD_SPECIAL_TESTING
(
  MOD_NEW_PROD_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  SPECIAL_TESTING_CD  NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_ORDER_CELL
(
  ORDER_ID        NUMBER                        DEFAULT 0                     NOT NULL,
  ORDER_CELL_ID   NUMBER                        DEFAULT 0                     NOT NULL,
  CELL_CD         NUMBER                        DEFAULT 0                     NOT NULL,
  PRODUCT_ID      NUMBER                        DEFAULT 0                     NOT NULL,
  PHASE_GROUP_CD  NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL,
  BB_RESULT_ID    NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_ORDER_PHASE
(
  ORDER_ID        NUMBER                        DEFAULT 0                     NOT NULL,
  ORDER_PHASE_ID  NUMBER                        DEFAULT 0                     NOT NULL,
  PHASE_GRP_CD    NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_QC_GROUP_ACTIVITY
(
  GROUP_ACTIVITY_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  GROUP_ID           NUMBER                     DEFAULT 0                     NOT NULL,
  RELATED_GROUP_ID   NUMBER                     DEFAULT 0                     NOT NULL,
  LOCK_PRSNL_ID      NUMBER                     DEFAULT 0                     NOT NULL,
  SCHEDULED_DT_TM    DATE                       DEFAULT SYSDATE               NOT NULL,
  LOCK_DT_TM         DATE                       DEFAULT SYSDATE,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_QC_GRP_REAGENT_ACTIVITY
(
  GROUP_REAGENT_ACTIVITY_ID  NUMBER             DEFAULT 0                     NOT NULL,
  GROUP_REAGENT_LOT_ID       NUMBER             DEFAULT 0                     NOT NULL,
  GROUP_ACTIVITY_ID          NUMBER             DEFAULT 0                     NOT NULL,
  VISUAL_INSPECTION_CD       NUMBER             DEFAULT 0                     NOT NULL,
  INTERPRETATION_CD          NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVITY_DT_TM             DATE               DEFAULT SYSDATE               NOT NULL,
  ACTIVITY_PRSNL_ID          NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_QC_GRP_REAGENT_LOT
(
  GROUP_REAGENT_LOT_ID       NUMBER             DEFAULT 0                     NOT NULL,
  PREV_GROUP_REAGENT_LOT_ID  NUMBER             DEFAULT 0                     NOT NULL,
  GROUP_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  LOT_INFORMATION_ID         NUMBER             DEFAULT 0                     NOT NULL,
  RELATED_REAGENT_ID         NUMBER             DEFAULT 0                     NOT NULL,
  CURRENT_IND                NUMBER             DEFAULT 0                     NOT NULL,
  DISPLAY_ORDER_SEQ          NUMBER             DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM        DATE               DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_QC_RESULT
(
  QC_RESULT_ID               NUMBER             DEFAULT 0                     NOT NULL,
  GROUP_REAGENT_ACTIVITY_ID  NUMBER             DEFAULT 0                     NOT NULL,
  ENHANCEMENT_ACTIVITY_ID    NUMBER             DEFAULT 0                     NOT NULL,
  CONTROL_ACTIVITY_ID        NUMBER             DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID            NUMBER             DEFAULT 0                     NOT NULL,
  RESULT_DT_TM               DATE               DEFAULT SYSDATE               NOT NULL,
  RESULT_PRSNL_ID            NUMBER             DEFAULT 0                     NOT NULL,
  ABNORMAL_IND               NUMBER             DEFAULT 0                     NOT NULL,
  REASON_CD                  NUMBER             DEFAULT 0                     NOT NULL,
  STATUS_CD                  NUMBER             DEFAULT 0                     NOT NULL,
  PHASE_CD                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  PRIMARY_REVIEW_DT_TM       DATE               DEFAULT SYSDATE               NOT NULL,
  PRIMARY_REVIEW_PRSNL_ID    NUMBER             DEFAULT 0                     NOT NULL,
  SECONDARY_REVIEW_DT_TM     DATE               DEFAULT SYSDATE               NOT NULL,
  SECONDARY_REVIEW_PRSNL_ID  NUMBER             DEFAULT 0                     NOT NULL,
  COMMENT_TEXT_ID            NUMBER             DEFAULT 0                     NOT NULL,
  ACTION_PRSNL_ID            NUMBER             DEFAULT 0                     NOT NULL,
  ACTION_DT_TM               DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_QC_RESULT_TROUBLESHOOTING_R
(
  RESULT_TROUBLESHOOTING_ID  NUMBER             DEFAULT 0                     NOT NULL,
  QC_RESULT_ID               NUMBER             DEFAULT 0                     NOT NULL,
  TROUBLESHOOTING_ID         NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_REQS_EXCEPTION
(
  REQS_EXCEPTION_ID       NUMBER                DEFAULT 0                     NOT NULL,
  EXCEPTION_ID            NUMBER                DEFAULT 0                     NOT NULL,
  SPECIAL_TESTING_CD      NUMBER                DEFAULT 0                     NOT NULL,
  REQUIREMENT_CD          NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_REVIEW_QUEUE
(
  BB_REVIEW_QUEUE_ID      NUMBER                DEFAULT 0                     NOT NULL,
  FROM_PERSON_ID          NUMBER                DEFAULT 0                     NOT NULL,
  TO_PERSON_ID            NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(32 BYTE),
  FROM_PARENT_ENTITY_ID   NUMBER                DEFAULT 0                     NOT NULL,
  TO_PARENT_ENTITY_ID     NUMBER                DEFAULT 0                     NOT NULL,
  REVIEW_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  REVIEW_OUTCOME_CD       NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UNCOMBINE_IND           NUMBER,
  FROM_ENCNTR_ID          NUMBER                DEFAULT 0                     NOT NULL,
  REVIEW_DOC_ID           NUMBER                DEFAULT 0                     NOT NULL,
  REVIEW_DT_TM            DATE,
  TO_ENCNTR_ID            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_SHIPMENT
(
  SHIPMENT_ID             NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  SHIPMENT_NBR            NUMBER                DEFAULT 0                     NOT NULL,
  SHIPMENT_DT_TM          DATE,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  SHIPMENT_STATUS_FLAG    NUMBER                DEFAULT 0                     NOT NULL,
  NEEDED_DT_TM            DATE,
  COURIER_CD              NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_PLACED_BY         VARCHAR2(100 BYTE),
  RECORDED_BY_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  OWNER_AREA_CD           NUMBER                DEFAULT 0                     NOT NULL,
  INVENTORY_AREA_CD       NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_DT_TM             DATE,
  ORDER_PRIORITY_CD       NUMBER                DEFAULT 0,
  FROM_FACILITY_CD        NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_SHIP_CONTAINER
(
  CONTAINER_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  CONTAINER_NBR           NUMBER                DEFAULT 0                     NOT NULL,
  SHIPMENT_ID             NUMBER                DEFAULT 0                     NOT NULL,
  CONTAINER_TYPE_CD       NUMBER                DEFAULT 0                     NOT NULL,
  CONTAINER_CONDITION_CD  NUMBER                DEFAULT 0                     NOT NULL,
  TOTAL_WEIGHT            NUMBER                DEFAULT 0                     NOT NULL,
  UNIT_OF_MEAS_CD         NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  TEMPERATURE_DEGREE_CD   NUMBER                DEFAULT 0,
  TEMPERATURE_VALUE       NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_SHIP_EVENT
(
  PRODUCT_EVENT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  CONTAINER_ID            NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  SHIPMENT_ID             NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  RETURN_VIS_INSP_CD      NUMBER                DEFAULT 0                     NOT NULL,
  RETURN_DT_TM            DATE,
  RETURN_CONDITION_CD     NUMBER                DEFAULT 0                     NOT NULL,
  FROM_OWNER_AREA_CD      NUMBER                DEFAULT 0                     NOT NULL,
  FROM_INVENTORY_AREA_CD  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  VIS_INSP_CD             NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_SPEC_EXPIRE_OVRD
(
  BB_SPEC_EXPIRE_OVRD_ID  NUMBER                DEFAULT 0                     NOT NULL,
  EXCEPTION_ID            NUMBER                DEFAULT 0                     NOT NULL,
  SPECIMEN_ID             NUMBER                DEFAULT 0                     NOT NULL,
  OVERRIDE_REASON_CD      NUMBER                DEFAULT 0                     NOT NULL,
  NEW_SPEC_EXPIRE_DT_TM   DATE,
  PREV_SPEC_EXPIRE_DT_TM  DATE,
  OVERRIDE_DT_TM          DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_SPEC_EXP_OVRD_PROD
(
  BB_SPEC_EXP_OVRD_PROD_ID  NUMBER              DEFAULT 0                     NOT NULL,
  BB_SPEC_EXPIRE_OVRD_ID    NUMBER              DEFAULT 0                     NOT NULL,
  PRODUCT_ID                NUMBER              DEFAULT 0                     NOT NULL,
  NEW_XM_EXPIRE_DT_TM       DATE,
  PREV_XM_EXPIRE_DT_TM      DATE,
  PRODUCT_EVENT_ID          NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_SUPPLIER
(
  BB_SUPPLIER_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  BARCODE_VALUE           CHAR(20 BYTE),
  PREFIX_IND              NUMBER,
  PREFIX_VALUE            CHAR(5 BYTE),
  DEFAULT_PREFIX_IND      NUMBER,
  ALPHA_TRANSLATION_IND   NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ISBT_BARCODE            VARCHAR2(15 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_UPLOAD_LONG_TEXT_R
(
  BB_UPLOAD_LONG_TEXT_R_ID  NUMBER              DEFAULT 0                     NOT NULL,
  BB_UPLOAD_REVIEW_ID       NUMBER              DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID              NUMBER              DEFAULT 0                     NOT NULL,
  ACTION_CD                 NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_UPLOAD_PERSON_ABORH_R
(
  BB_UPLOAD_PERSON_ABORH_R_ID  NUMBER           DEFAULT 0                     NOT NULL,
  BB_UPLOAD_REVIEW_ID          NUMBER           DEFAULT 0                     NOT NULL,
  PERSON_ABORH_ID              NUMBER           DEFAULT 0                     NOT NULL,
  DEMOG_ABORH_DT_TM            DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_UPLOAD_REVIEW
(
  BB_UPLOAD_REVIEW_ID     NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  UPLOAD_PERSON_ABORH_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPLOAD_DT_TM            DATE                  DEFAULT SYSDATE               NOT NULL,
  DEMOG_PERSON_ABORH_ID   NUMBER                DEFAULT 0                     NOT NULL,
  DEMOG_ABORH_DT_TM       DATE,
  REVIEWED_IND            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_WORKLIST
(
  WORKLIST_ID              NUMBER               DEFAULT 0                     NOT NULL,
  WORKLIST_NAME            VARCHAR2(40 BYTE)    DEFAULT ' '                   NOT NULL,
  WORKLIST_NAME_KEY        VARCHAR2(40 BYTE)    DEFAULT ' '                   NOT NULL,
  WORKLIST_NAME_KEY_NLS    VARCHAR2(82 BYTE)    DEFAULT ' '                   NOT NULL,
  CREATE_PRSNL_ID          NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_DT_TM             DATE                 DEFAULT SYSDATE               NOT NULL,
  QC_GROUP_ID              NUMBER               DEFAULT 0                     NOT NULL,
  TEST_GROUP_ID            NUMBER               DEFAULT 0                     NOT NULL,
  DOWNLOAD_IND             NUMBER               DEFAULT 0                     NOT NULL,
  LAST_DOWNLOAD_DT_TM      DATE,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  WORKLIST_NAME_KEY_A_NLS  VARCHAR2(160 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BB_WORKLIST_DETAIL
(
  WORKLIST_DETAIL_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  WORKLIST_ID         NUMBER                    DEFAULT 0                     NOT NULL,
  ORDER_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BCE_EVENT_BILL_MOD_RELTN
(
  BCE_EVENT_BILL_MOD_RELTN_ID  NUMBER           DEFAULT 0                     NOT NULL,
  BCE_EVENT_LOG_ID             NUMBER           DEFAULT 0                     NOT NULL,
  BILL_ITEM_MOD_ID             NUMBER           DEFAULT 0                     NOT NULL,
  PROMPT_VALUE                 VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BCE_EVENT_LOG
(
  BCE_EVENT_LOG_ID        NUMBER                DEFAULT 0                     NOT NULL,
  BATCH_NUM               FLOAT(126),
  EXT_MASTER_EVENT_ID     NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PERF_LOC_CD             NUMBER                DEFAULT 0                     NOT NULL,
  REN_PHYS_ID             NUMBER                DEFAULT 0                     NOT NULL,
  ORD_PHYS_ID             NUMBER                DEFAULT 0                     NOT NULL,
  REF_PHYS_ID             NUMBER                DEFAULT 0                     NOT NULL,
  ACCESSION               VARCHAR2(200 BYTE),
  BILL_ITEM_ID            NUMBER                DEFAULT 0                     NOT NULL,
  CHARGE_DESCRIPTION      VARCHAR2(200 BYTE),
  SERVICE_DT_TM           DATE,
  QUANTITY                FLOAT(126),
  DIAG_CODE1              VARCHAR2(200 BYTE),
  DIAG_CODE1_DESC         VARCHAR2(200 BYTE),
  DIAG_CODE2              VARCHAR2(200 BYTE),
  DIAG_CODE2_DESC         VARCHAR2(200 BYTE),
  DIAG_CODE3              VARCHAR2(200 BYTE),
  DIAG_CODE3_DESC         VARCHAR2(200 BYTE),
  DIAG_CODE4              VARCHAR2(200 BYTE),
  DIAG_CODE4_DESC         VARCHAR2(200 BYTE),
  DIAG_CODE5              VARCHAR2(200 BYTE),
  DIAG_CODE5_DESC         VARCHAR2(200 BYTE),
  DIAG_CODE6              VARCHAR2(200 BYTE),
  DIAG_CODE6_DESC         VARCHAR2(200 BYTE),
  DIAG_CODE7              VARCHAR2(200 BYTE),
  DIAG_CODE7_DESC         VARCHAR2(200 BYTE),
  ABN_STATUS_CD           NUMBER                DEFAULT 0                     NOT NULL,
  PRICE                   FLOAT(126),
  EPSDT_IND               NUMBER,
  CODE_MODIFIER1_CD       NUMBER                DEFAULT 0                     NOT NULL,
  CODE_MODIFIER2_CD       NUMBER                DEFAULT 0                     NOT NULL,
  CODE_MODIFIER3_CD       NUMBER                DEFAULT 0                     NOT NULL,
  CODE_MODIFIER4_CD       NUMBER                DEFAULT 0                     NOT NULL,
  REASON_COMMENT          VARCHAR2(200 BYTE),
  REASON_CD               NUMBER                DEFAULT 0                     NOT NULL,
  CHARGE_TYPE_CD          NUMBER                DEFAULT 0                     NOT NULL,
  INSTITUTION_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DEPARTMENT_CD           NUMBER                DEFAULT 0                     NOT NULL,
  SECTION_CD              NUMBER                DEFAULT 0                     NOT NULL,
  SUBSECTION_CD           NUMBER                DEFAULT 0                     NOT NULL,
  LEVEL5_CD               NUMBER                DEFAULT 0                     NOT NULL,
  SUBMIT_IND              NUMBER,
  MISC_IND                NUMBER,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  MODE_IND                NUMBER,
  BILL_CODE_TXT           VARCHAR2(200 BYTE),
  BATCH_ALIAS             VARCHAR2(200 BYTE)    DEFAULT ' '                   NOT NULL,
  BATCH_DESCRIPTION       VARCHAR2(200 BYTE)    DEFAULT ' '                   NOT NULL,
  BATCH_DT_TM             DATE                  DEFAULT SYSDATE               NOT NULL,
  PAYMENT_AMT             FLOAT(126)            DEFAULT 0.0                   NOT NULL,
  ADJUSTMENT_AMT          FLOAT(126)            DEFAULT 0.0                   NOT NULL,
  BATCH_ALIAS_KEY         VARCHAR2(200 BYTE)    DEFAULT ' '                   NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BED
(
  LOCATION_CD             NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  LOC_ROOM_CD             NUMBER                DEFAULT 0                     NOT NULL,
  BED_STATUS_CD           NUMBER                DEFAULT 0,
  DUP_BED_IND             NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BENEFIT_ORDER
(
  BENEFIT_ORDER_ID             NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_PLAN_RELTN_ID         NUMBER           DEFAULT 0                     NOT NULL,
  EPR_UPT_CNT                  NUMBER,
  HEALTH_PLAN_ID               NUMBER           DEFAULT 0                     NOT NULL,
  PARENT_BO_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  FIN_CLASS_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ                 NUMBER,
  PRI_CONCURRENT_IND           NUMBER,
  SEC_CONCURRENT_IND           NUMBER,
  PAT_CONCURRENT_IND           NUMBER,
  CROSS_OVER_IND               NUMBER,
  DISP_NONCOVERED_IND          NUMBER,
  MAN_EDIT_IND                 NUMBER,
  ACTIVE_IND                   NUMBER,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE,
  END_EFFECTIVE_DT_TM          DATE,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  PAT_BILL_PREF_FLAG           NUMBER,
  BO_STATUS_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  BO_STATUS_REASON_CD          NUMBER           DEFAULT 0                     NOT NULL,
  SUBSCRIBER_ID                NUMBER           DEFAULT 0                     NOT NULL,
  CONS_BO_SCHED_ID             NUMBER           DEFAULT 0                     NOT NULL,
  ORIG_BILL_DT_TM              DATE,
  ORIG_DUE_DT_TM               DATE,
  UB_BILL_CLASS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  UB_BILL_FREQ_CD              NUMBER           DEFAULT 0                     NOT NULL,
  UB_FACILITY_TYPE_CD          NUMBER           DEFAULT 0                     NOT NULL,
  PFT_ENCNTR_ID                NUMBER           DEFAULT 0                     NOT NULL,
  BT_CONDITION_ID              NUMBER           DEFAULT 0                     NOT NULL,
  TOTAL_CHARGE_AMT             FLOAT(126)       DEFAULT 0.0                   NOT NULL,
  TOTAL_CHARGE_AMT_DR_CR_FLAG  NUMBER,
  EOP_DT_TM                    DATE,
  PRORATION_FLAG               NUMBER           DEFAULT 0,
  PREVIOUS_PFT_ENCNTR_ID       NUMBER           DEFAULT 0                     NOT NULL,
  END_SERVICE_DT_TM            DATE,
  BEG_SERVICE_DT_TM            DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BE_AT_RELTN
(
  BE_AT_RELTN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ACCT_TEMPL_ID           NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ACCESS_CD               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BE_CUSTOM_OBJ_RELTN
(
  BE_CUSTOM_OBJ_RELTN_ID       NUMBER           DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID            NUMBER           DEFAULT 0                     NOT NULL,
  BILL_TYPE_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  MEDIA_TYPE_CD                NUMBER           DEFAULT 0                     NOT NULL,
  CUSTOM_OBJ_NAME              VARCHAR2(32 BYTE),
  ACTIVE_IND                   NUMBER,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  CUSTOM_IMAGE1                VARCHAR2(250 BYTE),
  CUSTOM_IMAGE2                VARCHAR2(250 BYTE),
  TRANSFORMATION_OBJ_NAME_TXT  VARCHAR2(30 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BE_DOMAIN
(
  BE_DOMAIN_ID            NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  DOMAIN_TYPE_CD          NUMBER                DEFAULT 0                     NOT NULL,
  LIFETIME_ENCNTR_IND     NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BE_GL_ALIAS_RELTN
(
  BE_GL_ALIAS_RELTN_ID    NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  GL_ALIAS_ID             NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  LOCATION_CD             NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BE_GROUP_RELTN
(
  BE_GROUP_RELTN_ID       NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  BT_COND_CRIT_R_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BE_HISTORY
(
  BE_HISTORY_ID             NUMBER              DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID           NUMBER              DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID         NUMBER              DEFAULT 0                     NOT NULL,
  BE_NAME                   VARCHAR2(50 BYTE),
  BE_DESC                   VARCHAR2(250 BYTE),
  BE_VRSN_NBR               NUMBER              DEFAULT 0                     NOT NULL,
  PARENT_BE_ID              NUMBER              DEFAULT 0                     NOT NULL,
  DEF_POST_METHOD_CD        NUMBER              DEFAULT 0                     NOT NULL,
  CURRENCY_TYPE_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE,
  END_EFFECTIVE_DT_TM       DATE,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  BE_NAME_KEY               VARCHAR2(250 BYTE),
  STD_DELAY                 NUMBER,
  PLACE_OF_SERVICE          VARCHAR2(2 BYTE),
  RECUR_BILL_OPT_FLAG       NUMBER,
  RECUR_BILL_WHAT_DAY       NUMBER,
  RECUR_WAIT_CODE_FLAG      NUMBER,
  RECUR_GEN_DELAY_IND       NUMBER,
  RECUR_GEN_DELAY           NUMBER,
  RUG_CD_ORDER_FLAG         NUMBER,
  QCF_ROUNDING_FLAG         NUMBER              DEFAULT 0                     NOT NULL,
  HCFA_1500_DX_FLAG         NUMBER,
  RECLASS_RECEIVE_IND       NUMBER              DEFAULT 0                     NOT NULL,
  PROC_CODE_IND             NUMBER              DEFAULT 0                     NOT NULL,
  PROGRAM_CD                NUMBER              DEFAULT 0                     NOT NULL,
  SEQ_START_NBR             FLOAT(126)          DEFAULT 0                     NOT NULL,
  CURRENT_SEQ_NBR           FLOAT(126)          DEFAULT 0                     NOT NULL,
  DAYS_TO_EVAL              NUMBER              DEFAULT 0                     NOT NULL,
  ZERO_BALANCE_WAIT         NUMBER              DEFAULT 0                     NOT NULL,
  BAD_DEBT_CHECK_IND        NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_LIFE_IND           NUMBER              DEFAULT 0                     NOT NULL,
  CALCULATED_BALANCE_IND    NUMBER              DEFAULT 0                     NOT NULL,
  SUPPRESS_OFFSET_DRCR_IND  NUMBER              DEFAULT 0                     NOT NULL,
  FEE_SCHED_FLAG            NUMBER,
  AR_ACCT_ID                NUMBER              DEFAULT 0                     NOT NULL,
  DEFAULT_SELFPAY_HP_ID     NUMBER              DEFAULT 0                     NOT NULL,
  POST_CD                   NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BE_ORG_RELTN
(
  BE_ORG_RELTN_ID         NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BE_PRSNL_GROUP_R
(
  BE_PRSNL_GROUP_R_ID     NUMBER                DEFAULT 0                     NOT NULL,
  PFT_PRSNL_GROUP_ID      NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BE_SECURITY_RELTN
(
  BE_SECURITY_RELTN_ID    NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(32 BYTE)     DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BE_SUPPRESS_RELTN
(
  BE_SUPPRESS_RELTN_ID    NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(32 BYTE),
  PARENT_ENTITY_VALUE     NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BILLING_ENTITY
(
  BILLING_ENTITY_ID         NUMBER              DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID           NUMBER              DEFAULT 0                     NOT NULL,
  DEF_PAT_TEMPL_ID          NUMBER              DEFAULT 0                     NOT NULL,
  PARENT_BE_ID              NUMBER              DEFAULT 0                     NOT NULL,
  DEF_POST_METHOD_CD        NUMBER              DEFAULT 0                     NOT NULL,
  CURRENCY_TYPE_CD          NUMBER              DEFAULT 0                     NOT NULL,
  BE_NAME                   VARCHAR2(50 BYTE),
  BE_DESC                   VARCHAR2(250 BYTE),
  COST_CENTER_CD            NUMBER              DEFAULT 0                     NOT NULL,
  BILLING_START_CD          NUMBER              DEFAULT 0                     NOT NULL,
  PRODUCE_BILL_CD           NUMBER              DEFAULT 0                     NOT NULL,
  FREQ_DUR_ID               NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE,
  END_EFFECTIVE_DT_TM       DATE,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  BE_NAME_KEY               VARCHAR2(250 BYTE),
  STD_DELAY                 NUMBER,
  PLACE_OF_SERVICE          VARCHAR2(2 BYTE),
  RECUR_BILL_OPT_FLAG       NUMBER,
  RECUR_BILL_WHAT_DAY       NUMBER,
  RECUR_WAIT_CODE_FLAG      NUMBER,
  RECUR_GEN_DELAY_IND       NUMBER,
  RECUR_GEN_DELAY           NUMBER,
  RUG_CD_ORDER_FLAG         NUMBER,
  POST_CD                   NUMBER              DEFAULT 0                     NOT NULL,
  AR_ACCT_ID                NUMBER              DEFAULT 0                     NOT NULL,
  DEFAULT_SELFPAY_HP_ID     NUMBER              DEFAULT 0                     NOT NULL,
  QCF_ROUNDING_FLAG         NUMBER              DEFAULT 0                     NOT NULL,
  HCFA_1500_DX_FLAG         NUMBER,
  PROC_CODE_IND             NUMBER,
  RECLASS_RECEIVE_IND       NUMBER              DEFAULT 0                     NOT NULL,
  DAYS_TO_EVAL              NUMBER              DEFAULT 0                     NOT NULL,
  PROGRAM_CD                NUMBER              DEFAULT 0                     NOT NULL,
  SEQ_START_NBR             FLOAT(126)          DEFAULT 0                     NOT NULL,
  CURRENT_SEQ_NBR           FLOAT(126)          DEFAULT 0                     NOT NULL,
  ZERO_BALANCE_WAIT         NUMBER              DEFAULT 0                     NOT NULL,
  BAD_DEBT_CHECK_IND        NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_LIFE_IND           NUMBER              DEFAULT 0                     NOT NULL,
  CALCULATED_BALANCE_IND    NUMBER              DEFAULT 0                     NOT NULL,
  SUPPRESS_OFFSET_DRCR_IND  NUMBER              DEFAULT 0                     NOT NULL,
  FEE_SCHED_FLAG            NUMBER,
  FISCAL_REPORTING_FLAG     NUMBER              DEFAULT 0                     NOT NULL,
  BE_NAME_KEY_NLS           VARCHAR2(502 BYTE),
  BE_NAME_KEY_A_NLS         VARCHAR2(1000 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BILL_ITEM
(
  BILL_ITEM_ID                NUMBER            DEFAULT 0                     NOT NULL,
  EXT_PARENT_REFERENCE_ID     NUMBER            DEFAULT 0                     NOT NULL,
  EXT_PARENT_CONTRIBUTOR_CD   NUMBER            DEFAULT 0                     NOT NULL,
  EXT_CHILD_REFERENCE_ID      NUMBER            DEFAULT 0                     NOT NULL,
  EXT_CHILD_CONTRIBUTOR_CD    NUMBER            DEFAULT 0                     NOT NULL,
  EXT_DESCRIPTION             VARCHAR2(200 BYTE),
  EXT_OWNER_CD                NUMBER            DEFAULT 0                     NOT NULL,
  PARENT_QUAL_CD              NUMBER            DEFAULT 0                     NOT NULL,
  CHARGE_POINT_CD             NUMBER            DEFAULT 0                     NOT NULL,
  PHYSICIAN_QUAL_CD           NUMBER            DEFAULT 0                     NOT NULL,
  CALC_TYPE_CD                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER            DEFAULT 0,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM         DATE              DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM         DATE              DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  EXT_SHORT_DESC              VARCHAR2(50 BYTE),
  EXT_PARENT_ENTITY_NAME      VARCHAR2(32 BYTE),
  EXT_CHILD_ENTITY_NAME       VARCHAR2(32 BYTE),
  CARESET_IND                 NUMBER            DEFAULT 0,
  WORKLOAD_ONLY_IND           NUMBER            DEFAULT 0,
  CHILD_SEQ                   NUMBER            DEFAULT 0,
  MISC_IND                    NUMBER            DEFAULT 0,
  PARENT_QUAL_IND             NUMBER            DEFAULT 0,
  STATS_ONLY_IND              NUMBER            DEFAULT 0,
  NUM_HITS                    FLOAT(126)        DEFAULT 0,
  LATE_CHRG_EXCL_IND          NUMBER            DEFAULT 0,
  COST_BASIS_AMT              FLOAT(126)        DEFAULT 0                     NOT NULL,
  TAX_IND                     NUMBER            DEFAULT 0,
  LOGICAL_DOMAIN_ID           NUMBER            DEFAULT 0,
  LOGICAL_DOMAIN_ENABLED_IND  NUMBER            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BILL_ITEM_GROUP_RELTN
(
  BILL_ITEM_GROUP_RELTN_ID  NUMBER              DEFAULT 0                     NOT NULL,
  BILL_ITEM_GROUP_ID        NUMBER              DEFAULT 0                     NOT NULL,
  BILL_ITEM_ID              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER              DEFAULT 0,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BILL_ITEM_MODIFIER
(
  BILL_ITEM_MOD_ID        NUMBER                DEFAULT 0                     NOT NULL,
  BILL_ITEM_ID            NUMBER                DEFAULT 0                     NOT NULL,
  BILL_ITEM_TYPE_CD       NUMBER                DEFAULT 0                     NOT NULL,
  KEY1                    VARCHAR2(200 BYTE),
  KEY2                    VARCHAR2(200 BYTE),
  KEY3                    VARCHAR2(200 BYTE),
  KEY4                    VARCHAR2(200 BYTE),
  KEY5                    VARCHAR2(200 BYTE),
  KEY6                    VARCHAR2(200 BYTE),
  KEY7                    VARCHAR2(200 BYTE),
  KEY8                    VARCHAR2(200 BYTE),
  KEY9                    VARCHAR2(200 BYTE),
  KEY10                   VARCHAR2(200 BYTE),
  KEY11                   VARCHAR2(200 BYTE),
  KEY12                   VARCHAR2(200 BYTE),
  KEY13                   VARCHAR2(200 BYTE),
  KEY14                   VARCHAR2(200 BYTE),
  KEY15                   VARCHAR2(200 BYTE),
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  KEY2_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  KEY3_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  KEY4_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  KEY5_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  KEY1_ENTITY_NAME        VARCHAR2(32 BYTE),
  KEY2_ENTITY_NAME        VARCHAR2(32 BYTE),
  KEY3_ENTITY_NAME        VARCHAR2(32 BYTE),
  KEY4_ENTITY_NAME        VARCHAR2(32 BYTE),
  KEY5_ENTITY_NAME        VARCHAR2(32 BYTE),
  KEY1_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  KEY11_ID                NUMBER                DEFAULT 0                     NOT NULL,
  KEY12_ID                NUMBER                DEFAULT 0                     NOT NULL,
  KEY13_ID                NUMBER                DEFAULT 0                     NOT NULL,
  KEY14_ID                NUMBER                DEFAULT 0                     NOT NULL,
  KEY15_ID                NUMBER                DEFAULT 0                     NOT NULL,
  BIM1_IND                NUMBER                DEFAULT 0,
  BIM1_INT                FLOAT(126)            DEFAULT 0,
  BIM1_NBR                FLOAT(126)            DEFAULT 0,
  BIM2_INT                FLOAT(126)            DEFAULT 0,
  BIM_IND                 NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BILL_ONLY_SUBSECT_RELTN
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  ENTITY_NAME          VARCHAR2(40 BYTE)        DEFAULT ' '                   NOT NULL,
  ENTITY_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  STANDARD_QTY         NUMBER                   DEFAULT 0,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BILL_REC
(
  CORSP_ACTIVITY_ID           NUMBER            DEFAULT 0                     NOT NULL,
  BILL_VRSN_NBR               NUMBER            DEFAULT 0                     NOT NULL,
  BILL_TEMPL_ID               NUMBER            DEFAULT 0                     NOT NULL,
  BILL_SUBMIT_SCHED_ID        NUMBER            DEFAULT 0                     NOT NULL,
  PARENT_BILL_REC_ID          NUMBER            DEFAULT 0                     NOT NULL,
  PARENT_BILL_VRSN_NBR        NUMBER,
  BILL_NBR_DISP               VARCHAR2(40 BYTE),
  BILL_STATUS_CD              NUMBER            DEFAULT 0                     NOT NULL,
  BILL_STATUS_REASON_CD       NUMBER            DEFAULT 0                     NOT NULL,
  MEDIA_TYPE_CD               NUMBER            DEFAULT 0                     NOT NULL,
  MEDIA_SUB_TYPE_CD           NUMBER            DEFAULT 0                     NOT NULL,
  GEN_REASON_CD               NUMBER            DEFAULT 0                     NOT NULL,
  MAN_REVIEW_IND              NUMBER,
  AUTO_SUBMIT_IND             NUMBER,
  AUTO_SUBMIT_CD              NUMBER            DEFAULT 0                     NOT NULL,
  AUTO_SUBMIT_VALUE           NUMBER,
  ACTIVE_IND                  NUMBER,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM         DATE,
  END_EFFECTIVE_DT_TM         DATE,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  BILL_NBR_DISP_KEY           VARCHAR2(250 BYTE),
  BALANCE                     FLOAT(126),
  BILLING_ENTITY_ID           NUMBER            DEFAULT 0                     NOT NULL,
  BILL_CLASS_CD               NUMBER            DEFAULT 0                     NOT NULL,
  BT_COND_RESULT_ID           NUMBER            DEFAULT 0                     NOT NULL,
  GEN_DT_TM                   DATE,
  PAYOR_CTRL_NBR_TXT          VARCHAR2(40 BYTE),
  PAGE_CNT                    NUMBER,
  SORT_FIELD_1                VARCHAR2(250 BYTE),
  SORT_FIELD_1_CD             NUMBER            DEFAULT 0                     NOT NULL,
  SORT_FIELD_2                VARCHAR2(250 BYTE),
  SORT_FIELD_2_CD             NUMBER            DEFAULT 0                     NOT NULL,
  SORT_FIELD_3                VARCHAR2(250 BYTE),
  SORT_FIELD_3_CD             NUMBER            DEFAULT 0                     NOT NULL,
  ZIP_CODE_KEY                VARCHAR2(40 BYTE),
  DUNNING_LEVEL_CD            NUMBER            DEFAULT 0                     NOT NULL,
  BILL_TYPE_CD                NUMBER            DEFAULT 0                     NOT NULL,
  RA_CLAIM_STATUS_CD          NUMBER            DEFAULT 0                     NOT NULL,
  RA_CLAIM_FIELD_CD           NUMBER            DEFAULT 0                     NOT NULL,
  BALANCE_DR_CR_FLAG          NUMBER            DEFAULT 0                     NOT NULL,
  BALANCE_FWD                 FLOAT(126)        DEFAULT 0.0                   NOT NULL,
  BALANCE_FWD_DR_CR_FLAG      NUMBER            DEFAULT 0                     NOT NULL,
  BALANCE_DUE                 FLOAT(126)        DEFAULT 0.0                   NOT NULL,
  BALANCE_DUE_DR_CR_FLAG      NUMBER            DEFAULT 0                     NOT NULL,
  NEW_AMOUNT                  FLOAT(126)        DEFAULT 0.0                   NOT NULL,
  NEW_AMOUNT_DR_CR_FLAG       NUMBER            DEFAULT 0                     NOT NULL,
  INTERIM_BILL_FLAG           NUMBER            DEFAULT 0                     NOT NULL,
  DUNNING_LEVEL_CNT           NUMBER            DEFAULT 0                     NOT NULL,
  CLAIM_STATUS_CD             NUMBER            DEFAULT 0                     NOT NULL,
  CLAIM_FILE_CD               NUMBER            DEFAULT 0                     NOT NULL,
  CM_STATUS_CD                NUMBER            DEFAULT 0                     NOT NULL,
  PAY_ADJ_TO_CM_DT_TM         DATE,
  SUBMISSION_ROUTE_CD         NUMBER            DEFAULT 0                     NOT NULL,
  ROUTE_USER_NAME             VARCHAR2(40 BYTE),
  BATCH_EVENT_ID              NUMBER            DEFAULT 0                     NOT NULL,
  DEMAND_IND                  NUMBER            DEFAULT 0                     NOT NULL,
  E_SORT_FIELD_1              VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  E_SORT_FIELD_1_CD           NUMBER            DEFAULT 0                     NOT NULL,
  E_SORT_FIELD_2              VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  E_SORT_FIELD_2_CD           NUMBER            DEFAULT 0                     NOT NULL,
  E_SORT_FIELD_3              VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  E_SORT_FIELD_3_CD           NUMBER            DEFAULT 0                     NOT NULL,
  SUBMIT_DT_TM                DATE,
  LAST_PAYMENT_DT_TM          DATE,
  LAST_ADJUSTMENT_DT_TM       DATE,
  CLAIM_SERIAL_NBR            FLOAT(126)        DEFAULT 0                     NOT NULL,
  TRANSMISSION_DT_TM          DATE,
  IMAGE_FLAG                  NUMBER            DEFAULT 0                     NOT NULL,
  FROM_SERVICE_DT_TM          DATE,
  TO_SERVICE_DT_TM            DATE,
  CLAIM_STATUS_CONTROL_DT_TM  DATE,
  RESPONSIBILITY_CD           NUMBER            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BILL_RELTN
(
  BILL_RELTN_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      CHAR(32 BYTE)         DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  CORSP_ACTIVITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  BILL_VRSN_NBR           NUMBER                DEFAULT 0                     NOT NULL,
  RELTN_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BILL_STRUCT
(
  BILL_STRUCT_ID          NUMBER                DEFAULT 0                     NOT NULL,
  CORSP_ACTIVITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  BILL_VRSN_NBR           NUMBER                DEFAULT 0                     NOT NULL,
  BR_SEQ                  NUMBER,
  BR_STRING               LONG RAW,
  BR_SIZE                 NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  ORIG_SIZE               NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BLOB_REFERENCE
(
  BLOB_REF_ID            NUMBER                 DEFAULT 0                     NOT NULL,
  VALID_UNTIL_DT_TM      DATE                   DEFAULT SYSDATE               NOT NULL,
  VALID_FROM_DT_TM       DATE                   DEFAULT SYSDATE               NOT NULL,
  PARENT_ENTITY_NAME     VARCHAR2(32 BYTE),
  PARENT_ENTITY_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  SEQUENCE_NBR           NUMBER                 DEFAULT 0                     NOT NULL,
  OWNER_CD               NUMBER                 DEFAULT 0                     NOT NULL,
  STORAGE_CD             NUMBER                 DEFAULT 0                     NOT NULL,
  FORMAT_CD              NUMBER                 DEFAULT 0                     NOT NULL,
  BLOB_HANDLE            VARCHAR2(255 BYTE),
  BLOB_TITLE             VARCHAR2(60 BYTE),
  CREATE_PRSNL_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  SOURCE_DEVICE_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  CHARTABLE_NOTE_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  NON_CHARTABLE_NOTE_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  PUBLISH_FLAG           NUMBER                 DEFAULT 0                     NOT NULL,
  BLOB_TYPE_CD           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  BLOB_DT_TM             DATE,
  DOCUMENT_ID            NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BLOOD_BANK_COMMENT
(
  BB_COMMENT_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BLOOD_PRODUCT
(
  PRODUCT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_CD              NUMBER                DEFAULT 0                     NOT NULL,
  SUPPLIER_PREFIX         CHAR(5 BYTE),
  CUR_VOLUME              NUMBER,
  ORIG_LABEL_ABO_CD       NUMBER                DEFAULT 0                     NOT NULL,
  ORIG_LABEL_RH_CD        NUMBER                DEFAULT 0                     NOT NULL,
  CUR_ABO_CD              NUMBER                DEFAULT 0                     NOT NULL,
  CUR_RH_CD               NUMBER                DEFAULT 0                     NOT NULL,
  SEGMENT_NBR             VARCHAR2(25 BYTE),
  ORIG_EXPIRE_DT_TM       DATE,
  ORIG_VOLUME             NUMBER,
  LOT_NBR                 VARCHAR2(25 BYTE),
  AUTOLOGOUS_IND          NUMBER,
  DIRECTED_IND            NUMBER,
  DRAWN_DT_TM             DATE,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  DONOR_PERSON_ID         NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BLOT_ALLELE_PATTERN_MATCH
(
  ORDER_ID       NUMBER                         DEFAULT 0                     NOT NULL,
  BLOT_BATCH_ID  NUMBER                         DEFAULT 0                     NOT NULL,
  X_POS          NUMBER                         DEFAULT 0                     NOT NULL,
  Y_POS          NUMBER                         DEFAULT 0                     NOT NULL,
  ALLELE_CD      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BLOT_BATCH_RESULT
(
  ORDER_ID           NUMBER                     DEFAULT 0                     NOT NULL,
  BLOT_BATCH_ID      NUMBER                     DEFAULT 0                     NOT NULL,
  X_POS              NUMBER                     DEFAULT 0                     NOT NULL,
  Y_POS              NUMBER                     DEFAULT 0                     NOT NULL,
  AMPLIFICATION_GEL  VARCHAR2(20 BYTE),
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BLOT_POSITIVE_PROBE
(
  ORDER_ID       NUMBER                         DEFAULT 0                     NOT NULL,
  BLOT_BATCH_ID  NUMBER                         DEFAULT 0                     NOT NULL,
  X_POS          NUMBER                         DEFAULT 0                     NOT NULL,
  Y_POS          NUMBER                         DEFAULT 0                     NOT NULL,
  PROBE_NUMBER   NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BLOT_SPEC_PATTERN_MATCH
(
  ORDER_ID        NUMBER                        DEFAULT 0                     NOT NULL,
  BLOT_BATCH_ID   NUMBER                        DEFAULT 0                     NOT NULL,
  X_POS           NUMBER                        DEFAULT 0                     NOT NULL,
  Y_POS           NUMBER                        DEFAULT 0                     NOT NULL,
  SPECIFICITY_CD  NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BMDI_ACQUIRED_DATA_TRACK
(
  ASSOCIATION_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  DEVICE_CD              NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  LOCATION_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  ACTIVE_IND             NUMBER                 DEFAULT 0                     NOT NULL,
  ASSOCIATION_DT_TM      DATE                   DEFAULT SYSDATE               NOT NULL,
  DIS_ASSOCIATION_DT_TM  DATE,
  PARENT_ENTITY_NAME     VARCHAR2(32 BYTE)      DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  ASSOC_PRSNL_ID         NUMBER                 DEFAULT 0,
  HINT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  RESOURCE_LOC_CD        NUMBER                 DEFAULT 0                     NOT NULL,
  UPD_STATUS_CD          NUMBER                 DEFAULT 0,
  DISSOC_PRSNL_ID        NUMBER                 DEFAULT 0,
  MONITORED_DEVICE_ID    NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BMDI_ACQUIRED_RESULTS
(
  RESULT_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  DEVICE_PARAMETER_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  DEVICE_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  RESULT_VAL           VARCHAR2(50 BYTE),
  ACQUIRED_DT_TM       DATE                     DEFAULT SYSDATE               NOT NULL,
  NOMENCLATURE_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  VERIFIED_DT_TM       DATE,
  VERIFIED_IND         NUMBER                   DEFAULT 0                     NOT NULL,
  CLINICAL_DT_TM       DATE                     DEFAULT SYSDATE               NOT NULL,
  LAB_TYPE_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  RESULT_FORMAT_CD     NUMBER                   DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME   VARCHAR2(32 BYTE)        DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  MONITORED_DEVICE_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  EVENT_ID             NUMBER                   DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BMDI_ADT_PERSON_R
(
  BMDI_ADT_PERSON_R_ID      NUMBER              DEFAULT 0                     NOT NULL,
  ASSOCIATION_ID            NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ALIAS_TYPE_CD      NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ALIAS              VARCHAR2(200 BYTE),
  PERSON_NAME               VARCHAR2(100 BYTE)  DEFAULT ' '                   NOT NULL,
  ENCNTR_ALIAS_TYPE_CD      NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_ALIAS              VARCHAR2(200 BYTE),
  ENCNTR_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_WEIGHT             VARCHAR2(255 BYTE),
  WEIGHT_UNITS_CD           NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_HEIGHT             VARCHAR2(255 BYTE),
  HEIGHT_UNITS_CD           NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_GENDER_CD          NUMBER              DEFAULT 0                     NOT NULL,
  STATUS_FLAG               NUMBER              DEFAULT 0                     NOT NULL,
  STATUS_MESSAGE            VARCHAR2(255 BYTE),
  ASSOCIATION_PRSNL_ID      NUMBER              DEFAULT 0                     NOT NULL,
  DIS_ASSOCIATION_PRSNL_ID  NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_BIRTH_DT_TM        DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BMDI_ASSOCIATION_HINTS
(
  HINT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  LOCATION_CD         NUMBER                    DEFAULT 0                     NOT NULL,
  PERSON_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  HINT_PROCESSING_CD  NUMBER                    DEFAULT 0                     NOT NULL,
  HINT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  HINT_TYPE_CD        NUMBER                    DEFAULT 0                     NOT NULL,
  UPD_PRSNL_ID        NUMBER                    DEFAULT 0                     NOT NULL,
  ACTIVE_IND          NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BMDI_DEVICE_NOMENCLATURE
(
  DEVICE_NOMENCLATURE_ID  NUMBER                DEFAULT 0                     NOT NULL,
  DEVICE_CD               NUMBER                DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  DEVICE_PARAMETER_ID     NUMBER                DEFAULT 0                     NOT NULL,
  DEVICE_VALUE            VARCHAR2(50 BYTE)     DEFAULT ' '                   NOT NULL,
  ALPHA_TRANSLATION       VARCHAR2(50 BYTE)     DEFAULT ' '                   NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BMDI_DEVICE_PARAMETER
(
  DEVICE_PARAMETER_ID      NUMBER               DEFAULT 0                     NOT NULL,
  DEVICE_CD                NUMBER               DEFAULT 0                     NOT NULL,
  STRT_MODEL_PARAMETER_ID  NUMBER               DEFAULT 0                     NOT NULL,
  RESULT_TYPE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  PARAMETER_ALIAS          VARCHAR2(50 BYTE)    DEFAULT ' '                   NOT NULL,
  UNITS_CD                 NUMBER               DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD            NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_CD                 NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER               DEFAULT 0                     NOT NULL,
  DECIMAL_PRECISION        NUMBER,
  ALARM_HIGH               VARCHAR2(20 BYTE),
  ALARM_LOW                VARCHAR2(20 BYTE),
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  SEQUENCE_NBR             NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BMDI_MONITORED_DEVICE
(
  MONITORED_DEVICE_ID    NUMBER                 DEFAULT 0                     NOT NULL,
  DEVICE_CD              NUMBER                 DEFAULT 0                     NOT NULL,
  STRT_MODEL_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  DEVICE_ALIAS           VARCHAR2(40 BYTE)      DEFAULT ' '                   NOT NULL,
  MOBILE_IND             NUMBER                 DEFAULT 0                     NOT NULL,
  LOCATION_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  DEVICE_IND             NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  STRT_MODEL_CHILD_ID    NUMBER                 DEFAULT 0                     NOT NULL,
  ASSOCIATION_LIMIT_CNT  NUMBER                 DEFAULT 1                     NOT NULL,
  ALTERNATE_DEVICE_CD    NUMBER                 DEFAULT 0                     NOT NULL,
  RESOURCE_LOC_CD        NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BO_HISTORY
(
  BO_HISTORY_ID           NUMBER                DEFAULT 0                     NOT NULL,
  BENEFIT_ORDER_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_PLAN_RELTN_ID    NUMBER                DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  EPR_UPT_CNT             NUMBER,
  PRIORITY_SEQ            NUMBER,
  FIN_CLASS_CD            NUMBER                DEFAULT 0                     NOT NULL,
  PRI_CONCURRENT_IND      NUMBER,
  SEC_CONCURRENT_IND      NUMBER,
  PAT_BILL_PREF_FLAG      NUMBER,
  CROSS_OVER_IND          NUMBER,
  DISP_NONCOVD_IND        NUMBER,
  MAN_EDIT_IND            NUMBER,
  BO_STATUS_CD            NUMBER                DEFAULT 0                     NOT NULL,
  BO_STATUS_REASON_CD     NUMBER                DEFAULT 0                     NOT NULL,
  SUBSCRIBER_ID           NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  CONS_BO_SCHED_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ORIG_BILL_DT_TM         DATE,
  ORIG_DUE_DT_TM          DATE,
  PARENT_BO_ID            NUMBER                DEFAULT 0                     NOT NULL,
  PAT_CONCURRENT_IND      NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BO_HP_RELTN
(
  BO_HP_RELTN_ID            NUMBER              DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID            NUMBER              DEFAULT 0                     NOT NULL,
  BENEFIT_ORDER_ID          NUMBER              DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ              NUMBER              DEFAULT 0                     NOT NULL,
  TOTAL_BILLED_AMOUNT       FLOAT(126)          DEFAULT 0                     NOT NULL,
  TOTAL_BILLED_DR_CR_FLAG   NUMBER              DEFAULT 0                     NOT NULL,
  TOTAL_PAID_AMOUNT         FLOAT(126)          DEFAULT 0                     NOT NULL,
  TOTAL_PAID_DR_CR_FLAG     NUMBER              DEFAULT 0                     NOT NULL,
  ROLL_DT_TM                DATE,
  BO_HP_STATUS_CD           NUMBER              DEFAULT 0                     NOT NULL,
  ROLL_USER_ID              NUMBER              DEFAULT 0                     NOT NULL,
  ROLL_TASK_ID              NUMBER              DEFAULT 0                     NOT NULL,
  LAST_BILLED_DT_TM         DATE,
  TOTAL_ADJ_AMOUNT          FLOAT(126)          DEFAULT 0                     NOT NULL,
  TOTAL_ADJ_DR_CR_FLAG      NUMBER              DEFAULT 0                     NOT NULL,
  ROLL_REASON_CD            NUMBER              DEFAULT 0                     NOT NULL,
  RESUBMISSION_CNT          NUMBER              DEFAULT 0                     NOT NULL,
  STMT_STATUS_CD            NUMBER              DEFAULT 0                     NOT NULL,
  LAST_PAYMENT_DT_TM        DATE,
  LAST_ADJUST_DT_TM         DATE,
  FIN_CLASS_CD              NUMBER              DEFAULT 0                     NOT NULL,
  PAYOR_ORG_ID              NUMBER              DEFAULT 0                     NOT NULL,
  BILL_TEMPL_ID             NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_PLAN_RELTN_ID      NUMBER              DEFAULT 0                     NOT NULL,
  ORIG_BILL_DT_TM           DATE,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  AMOUNT_OWED               FLOAT(126)          DEFAULT 0                     NOT NULL,
  AMOUNT_OWED_DR_CR_FLAG    NUMBER,
  ROLL_REVIEW_IND           NUMBER              DEFAULT 0                     NOT NULL,
  ORIG_BILL_SUBMIT_DT_TM    DATE,
  ORIG_BILL_TRANSMIT_DT_TM  DATE,
  RELTN_TYPE_CD             NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_ADO_DETAIL
(
  BR_ADO_DETAIL_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  FACILITY_CD         NUMBER                    DEFAULT 0                     NOT NULL,
  BR_ADO_CATEGORY_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  SCENARIO_MEAN       VARCHAR2(50 BYTE)         DEFAULT 0                     NOT NULL,
  SELECT_IND          NUMBER                    DEFAULT 0                     NOT NULL,
  NOTE_TXT            VARCHAR2(255 BYTE),
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_ADO_OPTION
(
  BR_ADO_OPTION_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  BR_ADO_DETAIL_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  OPTION_SEQ        NUMBER                      DEFAULT 0                     NOT NULL,
  PRESELECT_IND     NUMBER                      DEFAULT 0                     NOT NULL,
  NOTE_TXT          VARCHAR2(255 BYTE),
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_ADO_ORD_LIST
(
  BR_ADO_ORD_LIST_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  BR_ADO_OPTION_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  SYNONYM_ID          NUMBER                    DEFAULT 0                     NOT NULL,
  SENTENCE_ID         NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  BR_ADO_DETAIL_ID    NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_CAT_EVENT_NORMALCY
(
  BR_CAT_EVENT_NORMALCY_ID  NUMBER              DEFAULT 0                     NOT NULL,
  BR_MDRO_CAT_EVENT_ID      NUMBER              DEFAULT 0                     NOT NULL,
  NORMALCY_CD               NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_CCN
(
  BR_CCN_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  CCN_NBR            FLOAT(126)                 DEFAULT 0                     NOT NULL,
  CCN_NAME           VARCHAR2(150 BYTE)         DEFAULT ' '                   NOT NULL,
  TAX_ID_NBR_TXT     VARCHAR2(50 BYTE)          DEFAULT ' '                   NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  LOGICAL_DOMAIN_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  CCN_NBR_TXT        VARCHAR2(150 BYTE)         DEFAULT ' '                   NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_CCN_LOC_PTSVC_RELTN
(
  BR_CCN_LOC_PTSVC_RELTN_ID  NUMBER             DEFAULT 0                     NOT NULL,
  BR_CCN_LOC_RELTN_ID        NUMBER             DEFAULT 0                     NOT NULL,
  PTSVC_CODE_NBR             NUMBER             DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CD             NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_CCN_LOC_RELTN
(
  BR_CCN_LOC_RELTN_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  BR_CCN_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  LOCATION_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_DRUG_GROUP_ORGANISM
(
  BR_DRUG_GROUP_ORGANISM_ID  NUMBER             DEFAULT 0                     NOT NULL,
  BR_DRUG_GROUP_ID           NUMBER             DEFAULT 0                     NOT NULL,
  DRUG_RESISTANT_CNT         NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  BR_MDRO_CAT_ORGANISM_ID    NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_ELIGIBLE_PROVIDER
(
  BR_ELIGIBLE_PROVIDER_ID    NUMBER             DEFAULT 0                     NOT NULL,
  PROVIDER_ID                NUMBER             DEFAULT 0                     NOT NULL,
  NATIONAL_PROVIDER_NBR_TXT  VARCHAR2(200 BYTE) DEFAULT ' ' NOT NULL,
  TAX_ID_NBR_TXT             VARCHAR2(50 BYTE)  DEFAULT ' '                   NOT NULL,
  HEALTH_PLAN_TXT            VARCHAR2(20 BYTE)  DEFAULT ' '                   NOT NULL,
  HEALTH_PLAN_TXT_DT_TM      DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  SPECIALTY_ID               NUMBER             DEFAULT 0                     NOT NULL,
  LOGICAL_DOMAIN_ID          NUMBER             DEFAULT 0                     NOT NULL,
  ERX_SUBMISSION_IND         NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_ELIG_PROV_MEAS_RELTN
(
  BR_ELIG_PROV_MEAS_RELTN_ID  NUMBER            DEFAULT 0                     NOT NULL,
  BR_ELIGIBLE_PROVIDER_ID     NUMBER            DEFAULT 0                     NOT NULL,
  PCA_QUALITY_MEASURE_ID      NUMBER            DEFAULT 0                     NOT NULL,
  MEASURE_SEQ                 NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_FIELD_ERRORS
(
  BR_FIELD_ERRORS_ID      NUMBER                DEFAULT 0                     NOT NULL,
  CORSP_ACTIVITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  BILL_VRSN_NBR           NUMBER                DEFAULT 0                     NOT NULL,
  FIELD_CATALOG_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ELEMENT_NAME            VARCHAR2(40 BYTE),
  LIST_NAME               VARCHAR2(40 BYTE),
  LIST_INDEX              NUMBER                DEFAULT 0                     NOT NULL,
  ERROR_CD                NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_GEN_EVENT_LOG
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  BENEFIT_ORDER_ID        NUMBER                DEFAULT 0                     NOT NULL,
  BILL_REC_ID             NUMBER                DEFAULT 0                     NOT NULL,
  BR_GEN_EVENT_ID         NUMBER                DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM     DATE,
  LOG_LEVEL_CD            NUMBER                DEFAULT 0                     NOT NULL,
  LOG_MESSAGE             VARCHAR2(250 BYTE),
  PFT_EVENT_OCCUR_LOG_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_HCO_LOC_RELTN
(
  BR_HCO_LOC_RELTN_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  BR_HCO_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  LOCATION_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_LONG_BLOB_RELTN
(
  BR_LONG_BLOB_RELTN_ID   NUMBER                DEFAULT 0                     NOT NULL,
  CORSP_ACTIVITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  BILL_VRSN_NBR           NUMBER,
  LONG_BLOB_ID            NUMBER                DEFAULT 0                     NOT NULL,
  SEQUENCE                NUMBER,
  BILL_SIZE               NUMBER,
  ORIG_SIZE               NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  DATA_TYPE_FLAG          NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_MDRO_CAT_EVENT
(
  BR_MDRO_CAT_EVENT_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  BR_MDRO_CAT_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  EVENT_CD              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  LOCATION_CD           NUMBER                  DEFAULT 0,
  BR_MDRO_ID            NUMBER                  DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_MDRO_CAT_ORGANISM
(
  BR_MDRO_CAT_ORGANISM_ID  NUMBER               DEFAULT 0                     NOT NULL,
  BR_MDRO_CAT_ID           NUMBER               DEFAULT 0                     NOT NULL,
  ORGANISM_CD              NUMBER               DEFAULT 0                     NOT NULL,
  GROUP_RESISTANT_CNT      NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  LOCATION_CD              NUMBER               DEFAULT 0,
  BR_MDRO_ID               NUMBER               DEFAULT 0,
  ANTIBIOTICS_TXT          VARCHAR2(500 BYTE)   DEFAULT ' '
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_MDRO_OUTBREAK
(
  BR_MDRO_OUTBREAK_ID         NUMBER            DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME          VARCHAR2(32 BYTE) DEFAULT ' ' NOT NULL,
  PARENT_ENTITY_ID            NUMBER            DEFAULT 0                     NOT NULL,
  FACILITY_OCCURRENCE_CNT     NUMBER            DEFAULT 0                     NOT NULL,
  FACILITY_TIME_SPAN_NBR      NUMBER            DEFAULT 0                     NOT NULL,
  FACILITY_TIME_SPAN_UNIT_CD  NUMBER            DEFAULT 0                     NOT NULL,
  UNIT_OCCURRENCE_CNT         NUMBER            DEFAULT 0                     NOT NULL,
  UNIT_TIME_SPAN_NBR          NUMBER            DEFAULT 0                     NOT NULL,
  UNIT_TIME_SPAN_UNIT_CD      NUMBER            DEFAULT 0                     NOT NULL,
  LOCATION_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_ORGANISM_DRUG_RESULT
(
  BR_ORGANISM_DRUG_RESULT_ID   NUMBER           DEFAULT 0                     NOT NULL,
  BR_DRUG_GROUP_ORGANISM_ID    NUMBER           DEFAULT 0                     NOT NULL,
  BR_DRUG_GROUP_ANTIBIOTIC_ID  NUMBER           DEFAULT 0                     NOT NULL,
  RESULT_CD                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_PQRS_MEAS_PROVIDER_RELTN
(
  BR_PQRS_MEAS_PROVIDER_RELTN_ID  NUMBER        DEFAULT 0                     NOT NULL,
  BR_ELIGIBLE_PROVIDER_ID         NUMBER        DEFAULT 0                     NOT NULL,
  BR_PQRS_MEAS_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  PILOT_ELIGIBLE_IND              NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT sysdate               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_SCH_TEMP_SLOT_RELEASE_R
(
  BR_SCH_TEMP_SLOT_RELEASE_R_ID  NUMBER         DEFAULT 0                     NOT NULL,
  BR_SCH_TEMP_SLOT_R_ID          NUMBER         DEFAULT 0                     NOT NULL,
  RELEASE_TYPE_ID                NUMBER         DEFAULT 0                     NOT NULL,
  RELEASE_NAME                   VARCHAR2(100 BYTE) DEFAULT ' ' NOT NULL,
  RELEASE_START_TIME_STR         VARCHAR2(40 BYTE) DEFAULT ' ' NOT NULL,
  RELEASE_END_TIME_STR           VARCHAR2(40 BYTE) DEFAULT ' ' NOT NULL,
  RELEASE_UNIT                   VARCHAR2(10 BYTE) DEFAULT ' ' NOT NULL,
  RELEASE_UNIT_VALUE_STR         VARCHAR2(10 BYTE) DEFAULT ' ' NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BR_WIZARD_HIST
(
  BR_WIZARD_HIST_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  SOLUTION_MEAN      VARCHAR2(100 BYTE),
  WIZARD_MEAN        VARCHAR2(100 BYTE),
  PRSNL_ID           NUMBER                     DEFAULT 0                     NOT NULL,
  LOG_DT_TM          DATE,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BT_HP_RELTN
(
  BT_HP_RELTN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  BILL_TEMPL_ID           NUMBER                DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  MAN_REVIEW_IND          NUMBER                DEFAULT 0                     NOT NULL,
  BILL_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BT_PRSNL_GRP_RELTN
(
  BT_PRSNL_GRP_RELTN_ID   NUMBER                DEFAULT 0                     NOT NULL,
  BT_COND_CRIT_R_ID       NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  CODE_VALUE              NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BUSINESS_SERVICE
(
  BUSINESS_SERVICE_ID     NUMBER                DEFAULT 0                     NOT NULL,
  SERVICE_IDENT           VARCHAR2(250 BYTE)    DEFAULT ' ',
  SERVICE_NAME            VARCHAR2(250 BYTE)    DEFAULT ' '                   NOT NULL,
  PARTY_IDENT             VARCHAR2(250 BYTE)    DEFAULT ' '                   NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CALENDAR_EXCEPTION
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  EXCEPTION_SEQ        NUMBER                   DEFAULT 0                     NOT NULL,
  EXC_DATE             DATE                     DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  OPEN_TIME            NUMBER,
  CLOSE_TIME           NUMBER,
  AVAIL_IND            NUMBER,
  TEXT_DESCRIPTION     VARCHAR2(200 BYTE),
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CASE_ATTENDANCE
(
  CASE_ATTENDANCE_ID       NUMBER               DEFAULT 0                     NOT NULL,
  CASE_ATTEND_STATIC_ID    NUMBER               DEFAULT 0                     NOT NULL,
  SEGMENT_HEADER_ID        NUMBER               DEFAULT 0                     NOT NULL,
  SURG_AREA_CD             NUMBER               DEFAULT 0                     NOT NULL,
  CASE_ATTENDEE_ID         NUMBER               DEFAULT 0                     NOT NULL,
  ATTENDEE_FREE_TEXT_NAME  VARCHAR2(100 BYTE),
  ROLE_PERF_CD             NUMBER               DEFAULT 0                     NOT NULL,
  RESULT_STATUS_FLAG       NUMBER,
  DISPLAY_SEQ              NUMBER,
  SIGNING_ATTENDEE_IND     NUMBER,
  REASON_FOR_RELIEF_CD     NUMBER               DEFAULT 0                     NOT NULL,
  PROC_SPECIFIED_IND       NUMBER,
  SURG_START_DT_TM         DATE,
  DEF_IND                  NUMBER,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE,
  END_EFFECTIVE_DT_TM      DATE,
  CREATE_DT_TM             DATE,
  CREATE_PRSNL_ID          NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_TASK              NUMBER,
  CREATE_APPLCTX           NUMBER,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  IN_DT_TM                 DATE,
  OUT_DT_TM                DATE,
  SURG_CASE_ID             NUMBER               DEFAULT 0                     NOT NULL,
  IN_TZ                    NUMBER               DEFAULT 0,
  OUT_TZ                   NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CASE_CART
(
  CASE_CART_ID            NUMBER                DEFAULT 0                     NOT NULL,
  SURG_CASE_ID            NUMBER                DEFAULT 0                     NOT NULL,
  PREF_CARD_TYPE_FLAG     NUMBER,
  SURG_AREA_CD            NUMBER                DEFAULT 0                     NOT NULL,
  REQUISITION_ID          NUMBER                DEFAULT 0                     NOT NULL,
  FINALIZE_DT_TM          DATE,
  MODIFIED_IND            NUMBER,
  VERIFIED_DT_TM          DATE,
  VERIFIED_BY_ID          NUMBER                DEFAULT 0                     NOT NULL,
  PRINT_DT_TM             DATE,
  COMMENT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  CREATE_DT_TM            DATE,
  CREATE_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_TASK             NUMBER,
  CREATE_APPLCTX          NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  LOCKED_APPLCTX          NUMBER                DEFAULT 0,
  DOC_TYPE_CD             NUMBER                DEFAULT 0                     NOT NULL,
  TOT_SUPPLY_COST_AVG     FLOAT(126)            DEFAULT 0,
  TOT_SUPPLY_COST_LAST    FLOAT(126)            DEFAULT 0,
  TOT_EQUIP_COST_AVG      FLOAT(126)            DEFAULT 0,
  TOT_EQUIP_COST_LAST     FLOAT(126)            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CASE_CART_PICK_LIST
(
  CASE_CART_PICK_LIST_ID  NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(32 BYTE),
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  SURG_PROC_GRP_ID        NUMBER                DEFAULT 0                     NOT NULL,
  SURG_PROC_GRP_DET_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CASE_CART_ID            NUMBER                DEFAULT 0                     NOT NULL,
  SURG_CASE_ID            NUMBER                DEFAULT 0                     NOT NULL,
  PREF_CARD_TYPE_FLAG     NUMBER,
  CURRENT_IND             NUMBER,
  DUP_IND                 NUMBER,
  MERGED_ITEM_FLAG        NUMBER,
  FILL_LOCN_CD            NUMBER                DEFAULT 0                     NOT NULL,
  FILL_QTY                FLOAT(126),
  REQUEST_QTY             FLOAT(126),
  HOLD_QTY                FLOAT(126),
  OPEN_QTY                FLOAT(126),
  RETURN_LOCN_CD          NUMBER                DEFAULT 0                     NOT NULL,
  RETURN_QTY              FLOAT(126),
  QTY_USED                FLOAT(126),
  WASTED_QTY              FLOAT(126),
  WASTED_REASON_CD        NUMBER                DEFAULT 0                     NOT NULL,
  CHARGE_UNITS            NUMBER,
  CHARGE_DUR              NUMBER,
  LINE_ITEM_ID            NUMBER                DEFAULT 0                     NOT NULL,
  STATUS_FLAG             NUMBER,
  CREATE_DT_TM            DATE,
  CREATE_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_TASK             NUMBER,
  CREATE_APPLCTX          NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  FREE_TEXT_ITEM_DESC     VARCHAR2(200 BYTE),
  OBJECT_TYPE_FLAG        NUMBER,
  PARENT_PACK_ID          NUMBER                DEFAULT 0                     NOT NULL,
  CHARGE_QTY              NUMBER                DEFAULT 0,
  COST                    NUMBER                DEFAULT 0,
  COST_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  ITEM_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  SURG_CASE_PROC_ID       NUMBER                DEFAULT 0                     NOT NULL,
  AVG_COST                FLOAT(126),
  LAST_COST               FLOAT(126)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CASE_PROVIDER
(
  CASE_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  PHYSICIAN_ID  NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CASE_REPORT
(
  REPORT_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  CASE_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  EVENT_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  CATALOG_CD            NUMBER                  DEFAULT 0                     NOT NULL,
  REPORT_SEQUENCE       NUMBER                  DEFAULT 0                     NOT NULL,
  REQUEST_DT_TM         DATE,
  REQUEST_PRSNL_ID      NUMBER                  DEFAULT 0                     NOT NULL,
  STATUS_CD             NUMBER                  DEFAULT 0                     NOT NULL,
  STATUS_PRSNL_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  STATUS_DT_TM          DATE,
  CANCEL_CD             NUMBER                  DEFAULT 0                     NOT NULL,
  CANCEL_PRSNL_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  CANCEL_DT_TM          DATE,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  BLOB_BITMAP           NUMBER                  DEFAULT 0,
  SYNOPTIC_STALE_DT_TM  DATE,
  SIGNING_LOCATION_CD   NUMBER                  DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CASE_SPECIMEN
(
  CASE_SPECIMEN_ID            NUMBER            DEFAULT 0                     NOT NULL,
  CASE_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  SPECIMEN_TAG_ID             NUMBER            DEFAULT 0                     NOT NULL,
  FIXATIVE_ADDED_CD           NUMBER            DEFAULT 0                     NOT NULL,
  STORAGE_LOCN_CD             NUMBER            DEFAULT 0                     NOT NULL,
  ON_LOAN_LOCN_CD             NUMBER            DEFAULT 0                     NOT NULL,
  DISCARD_DT_TM               DATE,
  FROZEN_REPORT_ID            NUMBER            DEFAULT 0                     NOT NULL,
  COLLECT_DT_TM               DATE,
  CANCEL_CD                   NUMBER            DEFAULT 0                     NOT NULL,
  SPECIMEN_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID             NUMBER            DEFAULT 0                     NOT NULL,
  SPECIMEN_DESCRIPTION        VARCHAR2(100 BYTE),
  SPECIAL_COMMENTS            VARCHAR2(200 BYTE),
  ADEQUACY_IND                NUMBER,
  INADEQUACY_REASON_CD        NUMBER            DEFAULT 0                     NOT NULL,
  RECEIVED_DT_TM              DATE,
  RECEIVED_ID                 NUMBER            DEFAULT 0                     NOT NULL,
  RECEIVED_FIXATIVE_CD        NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  SPEC_COMMENTS_LONG_TEXT_ID  NUMBER            DEFAULT 0                     NOT NULL,
  ORIGINAL_STORAGE_DT_TM      DATE              DEFAULT NULL,
  DISCARD_REASON_CD           NUMBER            DEFAULT 0,
  LABEL_CREATE_DT_TM          DATE,
  LABEL_CREATE_TYPE_FLAG      NUMBER            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CASE_TIMES
(
  CASE_TIMES_ID           NUMBER                DEFAULT 0                     NOT NULL,
  CASE_TIMES_STATIC_ID    NUMBER                DEFAULT 0                     NOT NULL,
  SEGMENT_HEADER_ID       NUMBER                DEFAULT 0                     NOT NULL,
  CASE_TIME_MEANING       CHAR(12 BYTE),
  CASE_TIME_DT_TM         DATE,
  RESULT_STATUS_FLAG      NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  CREATE_DT_TM            DATE,
  CREATE_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_TASK             NUMBER,
  CREATE_APPLCTX          NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  SURG_CASE_ID            NUMBER                DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD           NUMBER                DEFAULT 0                     NOT NULL,
  STAGE_CD                NUMBER                DEFAULT 0                     NOT NULL,
  CASE_TIME_TZ            NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CASSETTE
(
  CASSETTE_ID             NUMBER                DEFAULT 0                     NOT NULL,
  CASE_SPECIMEN_ID        NUMBER                DEFAULT 0                     NOT NULL,
  OWNER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  CASSETTE_TAG_ID         NUMBER                DEFAULT 0                     NOT NULL,
  SUPPLEMENTAL_TAG        CHAR(2 BYTE),
  TASK_ASSAY_CD           NUMBER                DEFAULT 0                     NOT NULL,
  ON_LOAN_LOCN_CD         NUMBER                DEFAULT 0                     NOT NULL,
  FIXATIVE_CD             NUMBER                DEFAULT 0                     NOT NULL,
  ORIGIN_MODIFIER         CHAR(7 BYTE),
  PIECES                  CHAR(3 BYTE),
  SECTIONABLE_IND         NUMBER,
  DISCARD_DT_TM           DATE,
  STORAGE_LOCATION_CD     NUMBER                DEFAULT 0                     NOT NULL,
  FROZEN_IND              NUMBER,
  EMBEDDING_MEDIA_CD      NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ORIGINAL_STORAGE_DT_TM  DATE                  DEFAULT NULL,
  DISCARD_REASON_CD       NUMBER                DEFAULT 0,
  LABEL_CREATE_DT_TM      DATE,
  LABEL_CREATE_TYPE_FLAG  NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CCO_ENCOUNTER
(
  CCO_ENCOUNTER_ID              NUMBER          DEFAULT 0                     NOT NULL,
  ADM_DOC_ID                    NUMBER          DEFAULT 0                     NOT NULL,
  ADMIT_AGE                     NUMBER,
  ADMIT_DIAGNOSIS               NUMBER,
  ADMIT_ICU_CD                  NUMBER          DEFAULT 0                     NOT NULL,
  ADMIT_SOURCE                  NUMBER,
  ADMITSOURCE_FLAG              NUMBER,
  AIDS_IND                      NUMBER,
  AMI_LOCATION                  NUMBER,
  BED_COUNT                     NUMBER,
  BODY_SYSTEM                   NUMBER,
  CC_DURING_STAY_IND            NUMBER,
  CHRONIC_HEALTH_NONE_IND       NUMBER,
  CHRONIC_HEALTH_UNAVAIL_IND    NUMBER,
  CIRRHOSIS_IND                 NUMBER,
  COPD_FLAG                     NUMBER,
  COPD_IND                      NUMBER,
  DIABETES_IND                  NUMBER,
  DIALYSIS_IND                  NUMBER,
  DIEDINHOSPITAL_IND            NUMBER,
  DIEDINICU_IND                 NUMBER,
  DISEASE_CATEGORY_CD           NUMBER          DEFAULT 0                     NOT NULL,
  EJECTFX_FRACTION              NUMBER,
  ELECTIVESURGERY_IND           NUMBER,
  GENDER_FLAG                   NUMBER,
  HEPATICFAILURE_IND            NUMBER,
  HOSP_ADMIT_DT_TM              DATE,
  HRS_AT_SOURCE                 NUMBER,
  ICU_ADMIT_DT_TM               DATE,
  ICU_DISCH_DT_TM               DATE,
  IMA_IND                       NUMBER,
  IMMUNOSUPPRESSION_IND         NUMBER,
  LEUKEMIA_IND                  NUMBER,
  LYMPHOMA_IND                  NUMBER,
  MED_SERVICE_CD                NUMBER          DEFAULT 0                     NOT NULL,
  METASTATICCANCER_IND          NUMBER,
  MI_WITHIN_6MO_IND             NUMBER,
  MIDUR_IND                     NUMBER,
  NBR_GRAFTS_PERFORMED          NUMBER,
  PERSON_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  PTCA_DEVICE                   NUMBER,
  READMIT_IND                   NUMBER,
  READMIT_WITHIN_24HR_IND       NUMBER,
  REGION_FLAG                   NUMBER,
  SV_GRAFT_IND                  NUMBER,
  TEACH_TYPE_FLAG               NUMBER,
  THERAPY_LEVEL                 NUMBER,
  THROMBOLYTICS_IND             NUMBER,
  VALID_FROM_DT_TM              DATE,
  VALID_UNTIL_DT_TM             DATE,
  VAR03HSPXLOS_VALUE            NUMBER,
  XFER_WITHIN_48HR_IND          NUMBER,
  DIEDINDELROOM_IND             NUMBER,
  PATIENT_IDENTIFIER            FLOAT(126),
  MOTHERS_NAME                  VARCHAR2(50 BYTE),
  MOTHERS_ETHNICITY             NUMBER,
  MOTHERS_RACE                  NUMBER,
  ACTIVE_IND                    NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM           DATE            DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID        NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD              NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  ENCNTR_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  RISK_ADJUSTMENT_IDENT         FLOAT(126)      DEFAULT 0                     NOT NULL,
  INITIAL_DISCH_DT_TM           DATE,
  FINAL_DISCH_DT_TM             DATE,
  CCO_SOURCE_APP_CD             NUMBER          DEFAULT 0                     NOT NULL,
  VON_TRANSFER_FLAG             NUMBER,
  READMISSION_DISPOSITION_FLAG  NUMBER,
  FINAL_DISPOSITION_FLAG        NUMBER,
  RECORD_STATUS_FLAG            NUMBER          DEFAULT 0                     NOT NULL,
  EXTRACT_FLAG                  NUMBER          DEFAULT 0                     NOT NULL,
  EXTRACT_DT_TM                 DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CCO_EVENT
(
  CCO_EVENT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CLINICAL_EVENT_ID       NUMBER                DEFAULT 0                     NOT NULL,
  CLINICAL_SEQ            NUMBER,
  EVENT_CD                NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_END_DT_TM         DATE,
  EVENT_END_TZ            NUMBER,
  EVENT_ID                NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_START_DT_TM       DATE,
  EVENT_START_TZ          NUMBER,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PUBLISH_FLAG            NUMBER,
  RESULT_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  VALID_FROM_DT_TM        DATE,
  VALID_UNTIL_DT_TM       DATE,
  VIEW_LEVEL              NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_TAG               VARCHAR2(255 BYTE)    DEFAULT ' '                   NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  CRITICAL_LOW            VARCHAR2(20 BYTE),
  CRITICAL_HIGH           VARCHAR2(20 BYTE),
  NORMAL_LOW              VARCHAR2(20 BYTE),
  NORMAL_HIGH             VARCHAR2(20 BYTE),
  EVENT_CLASS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  NORMALCY_CD             NUMBER                DEFAULT 0                     NOT NULL,
  PERFORMED_DT_TM         DATE,
  PERFORMED_TZ            NUMBER                DEFAULT 0,
  REFERENCE_NBR           VARCHAR2(100 BYTE)    DEFAULT ' '                   NOT NULL,
  RESULT_UNITS_CD         NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_TIME_UNITS_CD    NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_VAL              VARCHAR2(255 BYTE),
  SOURCE_CD               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CCR_USER_FILTER
(
  CONTENT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  CONTENT_VIEW_FILTER_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_AC_BATCHCLASS
(
  CDI_AC_BATCHCLASS_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  BATCHCLASS_NAME       VARCHAR2(32 BYTE)       DEFAULT ' '                   NOT NULL,
  SINGLE_ENCNTR         NUMBER                  DEFAULT 0                     NOT NULL,
  AUTO_COMP_NOTIFY      NUMBER                  DEFAULT 0                     NOT NULL,
  AUTO_CLOSE            NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  AUDITING_IND          NUMBER                  DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  ALIAS_CONTRIB_SRC_CD  NUMBER                  DEFAULT 0,
  CPDI_BATCH_CLASS_IND  NUMBER                  DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_AC_USER
(
  CDI_AC_USER_ID   NUMBER                       DEFAULT 0                     NOT NULL,
  AC_USERNAME      VARCHAR2(32 BYTE)            DEFAULT ' '                   NOT NULL,
  AUDITING_IND     NUMBER                       DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_CLIPBOARD
(
  CDI_CLIPBOARD_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  OBJECT_FILE       VARCHAR2(255 BYTE)          DEFAULT ' '                   NOT NULL,
  ANNO_FILE         VARCHAR2(255 BYTE)          DEFAULT ' '                   NOT NULL,
  COPY_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  COPY_USER_ID      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_CM_LOGIN
(
  CDI_CM_LOGIN_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  CM_USERNAME      VARCHAR2(64 BYTE)            DEFAULT ' '                   NOT NULL,
  CM_PASSWORD      VARCHAR2(64 BYTE)            DEFAULT ' '                   NOT NULL,
  ORGANIZATION_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  ORG_DEFAULT_IND  NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_CM_LOGIN_POSITION
(
  CDI_CM_LOGIN_POSITION_ID  NUMBER              DEFAULT 0                     NOT NULL,
  CDI_CM_LOGIN_ID           NUMBER              DEFAULT 0                     NOT NULL,
  POSITION_CD               NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_DOCUMENT_SUBTYPE
(
  CDI_DOCUMENT_SUBTYPE_ID       NUMBER          DEFAULT 0                     NOT NULL,
  CDI_DOCUMENT_TYPE_ID          NUMBER          DEFAULT 0                     NOT NULL,
  DOCUMENT_TYPE_ALIAS           VARCHAR2(255 BYTE),
  SUBJECT                       VARCHAR2(255 BYTE),
  COMBINE_IND                   NUMBER          DEFAULT 0                     NOT NULL,
  COMBINE_ALL_IND               NUMBER          DEFAULT 0                     NOT NULL,
  MAX_PAGE_CNT                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  DEFAULT_DATE_OF_SERVICE_FLAG  NUMBER          DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SOURCE_CD         NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_DOCUMENT_TYPE
(
  CDI_DOCUMENT_TYPE_ID          NUMBER          DEFAULT 0                     NOT NULL,
  EVENT_CD                      NUMBER          DEFAULT 0                     NOT NULL,
  CDI_AC_BATCHCLASS_ID          NUMBER          DEFAULT 0                     NOT NULL,
  COMBINE_IND                   NUMBER          DEFAULT 0                     NOT NULL,
  MAX_PAGE_CNT                  NUMBER          DEFAULT 0                     NOT NULL,
  DELETE_FIRST_IND              NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  COMBINE_ALL_IND               NUMBER          DEFAULT 0,
  DEFAULT_DATE_OF_SERVICE_FLAG  NUMBER          DEFAULT 0,
  CODE_SET                      NUMBER          DEFAULT 0,
  CATEGORY_CD                   NUMBER          DEFAULT 0,
  SEND_TO_MANUAL_IND            NUMBER          DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_DOC_DYN_METADATA
(
  CDI_DOC_DYN_METADATA_ID  NUMBER               DEFAULT 0                     NOT NULL,
  CDI_PENDING_DOCUMENT_ID  NUMBER               DEFAULT 0                     NOT NULL,
  ALIAS_TYPE_CD            NUMBER               DEFAULT 0                     NOT NULL,
  ALIAS_TYPE_CODESET       NUMBER               DEFAULT 0                     NOT NULL,
  FIELD_VALUE              VARCHAR2(200 BYTE),
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_FORM
(
  CDI_FORM_ID              NUMBER               DEFAULT 0                     NOT NULL,
  FORM_NAME                VARCHAR2(255 BYTE)   DEFAULT ' '                   NOT NULL,
  SOURCE_FORM_IDENT        VARCHAR2(255 BYTE)   DEFAULT ' '                   NOT NULL,
  EVENT_CODE_SET           NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_CD                 NUMBER               DEFAULT 0                     NOT NULL,
  CDI_DOCUMENT_SUBTYPE_ID  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  LOGICAL_DOMAIN_ID        NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_FORM_CRITERIA
(
  CDI_FORM_CRITERIA_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  CDI_FORM_RULE_ID      NUMBER                  DEFAULT 0                     NOT NULL,
  VARIABLE_CD           NUMBER                  DEFAULT 0                     NOT NULL,
  COMPARISON_FLAG       NUMBER                  DEFAULT 0                     NOT NULL,
  VALUE_CD              NUMBER,
  VALUE_NBR             NUMBER,
  VALUE_DT_TM           DATE,
  VALUE_TEXT            VARCHAR2(30 BYTE),
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_FORM_FIELD
(
  CDI_FORM_FIELD_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  CDI_FORM_ID           NUMBER                  DEFAULT 0                     NOT NULL,
  PAGE_NBR              NUMBER                  DEFAULT 0                     NOT NULL,
  X_COORD               NUMBER                  DEFAULT 0                     NOT NULL,
  Y_COORD               NUMBER                  DEFAULT 0                     NOT NULL,
  FIELD_WIDTH           NUMBER                  DEFAULT 0                     NOT NULL,
  FIELD_HEIGHT          NUMBER                  DEFAULT 0                     NOT NULL,
  FIELD_TYPE_FLAG       NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  FIELD_NAME            VARCHAR2(40 BYTE)       DEFAULT ' '                   NOT NULL,
  VALUE_FORMAT_TEXT     VARCHAR2(150 BYTE),
  PARENT_FORM_FIELD_ID  NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_FORM_RULE
(
  CDI_FORM_RULE_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  CDI_FORM_ID       NUMBER                      DEFAULT 0                     NOT NULL,
  REQUIRED_IND      NUMBER                      DEFAULT 0                     NOT NULL,
  CRITERIA_CNT      NUMBER                      DEFAULT 0                     NOT NULL,
  RULE_NAME         VARCHAR2(40 BYTE)           DEFAULT ' '                   NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_PENDING_BATCH
(
  CDI_PENDING_BATCH_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  BATCH_NAME            VARCHAR2(255 BYTE)      DEFAULT ' '                   NOT NULL,
  BATCH_CREATE_DT_TM    DATE                    DEFAULT SYSDATE               NOT NULL,
  CDI_AC_BATCHCLASS_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  EXTERNAL_BATCH_IDENT  NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_PENDING_DOCUMENT
(
  CDI_PENDING_DOCUMENT_ID    NUMBER             DEFAULT 0                     NOT NULL,
  BLOB_HANDLE                VARCHAR2(128 BYTE) DEFAULT ' ' NOT NULL,
  AX_APP_IDENT               FLOAT(126)         DEFAULT 0                     NOT NULL,
  AX_DOC_IDENT               FLOAT(126)         DEFAULT 0                     NOT NULL,
  ENCNTR_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  PERSON_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  EVENT_CD                   NUMBER             DEFAULT 0                     NOT NULL,
  EVENT_CODESET              NUMBER             DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID           NUMBER             DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME         VARCHAR2(30 BYTE)  DEFAULT ' '                   NOT NULL,
  PATIENT_NAME               VARCHAR2(100 BYTE),
  DOC_TYPE_NAME              VARCHAR2(50 BYTE),
  SUBJECT_TEXT               VARCHAR2(255 BYTE),
  DOC_TYPE_ALIAS             VARCHAR2(255 BYTE),
  SERVICE_DT_TM              DATE,
  SCAN_DT_TM                 DATE,
  BIRTH_DT_TM                DATE,
  TRACKING_NBR_TEXT          VARCHAR2(50 BYTE),
  PERFORMING_PROVIDER_ALIAS  VARCHAR2(200 BYTE),
  RX_PRIORITY_TEXT           VARCHAR2(40 BYTE),
  CAPTURE_LOC_NAME           VARCHAR2(50 BYTE),
  REFERENCE_NBR_TEXT         VARCHAR2(100 BYTE),
  CONTRIBUTOR_SYSTEM_ALIAS   VARCHAR2(50 BYTE),
  RESULT_STATUS_ALIAS        VARCHAR2(50 BYTE),
  DOC_UPDT_DT_TM             DATE,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  CDI_PENDING_BATCH_ID       NUMBER             DEFAULT 0                     NOT NULL,
  PROCESS_LOCATION_FLAG      NUMBER             DEFAULT 0                     NOT NULL,
  SUBMIT_DT_TM               DATE               DEFAULT SYSDATE,
  PAGE_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  STATUS_FLAG                NUMBER             DEFAULT 0                     NOT NULL,
  RESULT_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  PERFORMING_PROVIDER_ID     NUMBER             DEFAULT 0                     NOT NULL,
  PARENT_LEVEL_FLAG          NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_REJECT_LOG
(
  CDI_REJECT_LOG_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  REFERENCE_NBR          VARCHAR2(100 BYTE),
  REJECT_USER_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  REJECT_DT_TM           DATE,
  MATCH_EVENT_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  MATCH_UPDT_DT_TM       DATE,
  MATCH_STATUS_CD        NUMBER                 DEFAULT 0                     NOT NULL,
  REJECT_FIN             VARCHAR2(200 BYTE),
  REJECT_PATIENT_NAME    VARCHAR2(100 BYTE),
  REJECT_BIRTH_DT_TM     DATE,
  REJECT_MRN             VARCHAR2(200 BYTE),
  REJECT_DOC_TYPE        VARCHAR2(50 BYTE),
  REJECT_SUBJECT         VARCHAR2(255 BYTE),
  REJECT_UPDT_DT_TM      DATE,
  REJECT_STATUS          VARCHAR2(255 BYTE),
  REJECT_SERVICE_DT_TM   DATE,
  REJECT_PROVIDER        VARCHAR2(200 BYTE),
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_TRANS_LOG
(
  CDI_TRANS_LOG_ID         NUMBER               DEFAULT 0                     NOT NULL,
  PATIENT_NAME             VARCHAR2(255 BYTE),
  MRN                      VARCHAR2(200 BYTE),
  FINANCIAL_NBR            VARCHAR2(200 BYTE),
  BLOB_HANDLE              VARCHAR2(255 BYTE),
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_CD                 NUMBER               DEFAULT 0                     NOT NULL,
  BATCH_NAME               VARCHAR2(255 BYTE)   DEFAULT ' '                   NOT NULL,
  ACTION_TYPE_FLAG         NUMBER               DEFAULT 0                     NOT NULL,
  ACTION_DT_TM             DATE                 DEFAULT SYSDATE               NOT NULL,
  PAGE_DELETED_CNT         NUMBER               DEFAULT 0                     NOT NULL,
  PAGE_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  PERF_PRSNL_ID            NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  BLOB_REF_ID              NUMBER               DEFAULT 0                     NOT NULL,
  BLOB_TYPE_FLAG           NUMBER               DEFAULT 0                     NOT NULL,
  AX_DOCID                 NUMBER               DEFAULT 0                     NOT NULL,
  AX_APPID                 NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_DT_TM             DATE                 DEFAULT SYSDATE               NOT NULL,
  EXTERNAL_BATCH_IDENT     NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER               DEFAULT 0                     NOT NULL,
  SUBJECT                  VARCHAR2(255 BYTE),
  DOC_TYPE                 VARCHAR2(40 BYTE),
  REASON_CD                NUMBER               DEFAULT 0,
  CDI_QUEUE_CD             NUMBER               DEFAULT 0,
  PARENT_ENTITY_ID         NUMBER               DEFAULT 0,
  PARENT_ENTITY_NAME       VARCHAR2(32 BYTE)    DEFAULT ' ',
  PARENT_ENTITY_ALIAS      VARCHAR2(200 BYTE)   DEFAULT ' ',
  DOCUMENT_TYPE_ALIAS      VARCHAR2(255 BYTE),
  CDI_PENDING_DOCUMENT_ID  NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_TRANS_MOD_DETAIL
(
  CDI_TRANS_MOD_DETAIL_ID  NUMBER               DEFAULT 0                     NOT NULL,
  CDI_TRANS_LOG_ID         NUMBER               DEFAULT 0                     NOT NULL,
  ACTION_TYPE_FLAG         NUMBER               DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE          NUMBER               DEFAULT 0                     NOT NULL,
  START_PAGE               NUMBER               DEFAULT 0                     NOT NULL,
  END_PAGE                 NUMBER               DEFAULT 0                     NOT NULL,
  POSITION                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_USER_FILTER
(
  CDI_USER_FILTER_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  FILTER_NAME         VARCHAR2(100 BYTE)        DEFAULT ' '                   NOT NULL,
  PERSON_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  BEGIN_DT_TM         DATE                      DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  END_DT_TM           DATE                      DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  DOCUMENT_COUNT      NUMBER                    DEFAULT 0                     NOT NULL,
  DATE_RANGE_MONTHS   NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_WORK_ITEM
(
  CDI_WORK_ITEM_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  CLARIFY_REASON_CD      NUMBER                 DEFAULT 0                     NOT NULL,
  COMMENT_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  CREATE_DT_TM           DATE                   DEFAULT SYSDATE               NOT NULL,
  OWNER_PRSNL_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  PRIORITY_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  STATUS_CD              NUMBER                 DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME     VARCHAR2(30 BYTE)      DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  PREV_CDI_WORK_ITEM_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM    DATE,
  END_EFFECTIVE_DT_TM    DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_WORK_QUEUE_ITEM_RELTN
(
  CDI_WORK_QUEUE_ITEM_RELTN_ID  NUMBER          DEFAULT 0                     NOT NULL,
  CDI_WORK_ITEM_ID              NUMBER          DEFAULT 0                     NOT NULL,
  CDI_WORK_QUEUE_ID             NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CDI_WORK_QUEUE_PRSNL_RELTN
(
  CDI_WORK_QUEUE_PRSNL_RELTN_ID  NUMBER         DEFAULT 0                     NOT NULL,
  CDI_WORK_QUEUE_ID              NUMBER         DEFAULT 0                     NOT NULL,
  PERSON_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  EXCEPTION_IND                  NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_AUDIT_LOG
(
  CE_AUDIT_LOG_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  EVENT_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  OPERATION_TYPE_CD    NUMBER                   DEFAULT 0                     NOT NULL,
  OPERATION_DT_TM      DATE                     DEFAULT SYSDATE               NOT NULL,
  OPERATION_PRSNL_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  ERROR_MSG_TXT        VARCHAR2(255 BYTE),
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  OPERATION_STATUS_CD  NUMBER                   DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_DYNAMIC_LABEL
(
  CE_DYNAMIC_LABEL_ID    NUMBER                 DEFAULT 0                     NOT NULL,
  PREV_DYNAMIC_LABEL_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  LABEL_TEMPLATE_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  LABEL_NAME             VARCHAR2(100 BYTE),
  LABEL_PRSNL_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  LABEL_STATUS_CD        NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  RESULT_SET_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  VALID_FROM_DT_TM       DATE,
  VALID_UNTIL_DT_TM      DATE,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  LABEL_SEQ_NBR          NUMBER                 DEFAULT 0                     NOT NULL,
  CREATE_DT_TM           DATE                   DEFAULT SYSDATE               NOT NULL,
  LONG_TEXT_ID           NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_EVENT_ACTION
(
  CE_EVENT_ACTION_ID          NUMBER            DEFAULT 0                     NOT NULL,
  EVENT_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  ACTION_TYPE_CD              NUMBER            DEFAULT 0                     NOT NULL,
  ACTION_PRSNL_ID             NUMBER            DEFAULT 0                     NOT NULL,
  ACTION_DT_TM                DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  ASSIGN_PRSNL_ID             NUMBER            DEFAULT 0                     NOT NULL,
  ACTION_PRSNL_GROUP_ID       NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  PARENT_EVENT_CLASS_CD       NUMBER            DEFAULT 0,
  EVENT_TAG                   VARCHAR2(255 BYTE) DEFAULT ' ',
  PERSON_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  EVENT_CLASS_CD              NUMBER            DEFAULT 0,
  RESULT_STATUS_CD            NUMBER            DEFAULT 0,
  PARENT_EVENT_ID             NUMBER            DEFAULT 0                     NOT NULL,
  EVENT_TITLE_TEXT            VARCHAR2(255 BYTE),
  NORMALCY_CD                 NUMBER            DEFAULT 0,
  EVENT_CD                    NUMBER            DEFAULT 0,
  CLINSIG_UPDT_DT_TM          DATE,
  ENDORSE_STATUS_CD           NUMBER            DEFAULT 0,
  LAST_COMMENT_TXT            VARCHAR2(255 BYTE),
  MULTIPLE_COMMENT_IND        NUMBER            DEFAULT 0,
  MULTIPLE_COMMENT_PRSNL_IND  NUMBER            DEFAULT 0,
  LAST_SAVED_PRSNL_ID         NUMBER            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_EVENT_MODIFIER
(
  EVENT_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  MODIFIER_CD               NUMBER              DEFAULT 0                     NOT NULL,
  VALID_FROM_DT_TM          DATE                DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  VALID_UNTIL_DT_TM         DATE                DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  MODIFIER_VALUE_CD         NUMBER              DEFAULT 0                     NOT NULL,
  MODIFIER_VALUE_FT         NUMBER,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  MODIFIER_VAL_FT           VARCHAR2(100 BYTE),
  MODIFIER_VALUE_PERSON_ID  NUMBER              DEFAULT 0                     NOT NULL,
  GROUP_SEQUENCE            NUMBER,
  ITEM_SEQUENCE             NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_EVENT_NOTE
(
  CE_EVENT_NOTE_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  VALID_UNTIL_DT_TM   DATE                      DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  EVENT_NOTE_ID       NUMBER                    DEFAULT 0                     NOT NULL,
  EVENT_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  NOTE_TYPE_CD        NUMBER                    DEFAULT 0                     NOT NULL,
  NOTE_FORMAT_CD      NUMBER                    DEFAULT 0                     NOT NULL,
  VALID_FROM_DT_TM    DATE                      DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ENTRY_METHOD_CD     NUMBER                    DEFAULT 0                     NOT NULL,
  NOTE_PRSNL_ID       NUMBER                    DEFAULT 0                     NOT NULL,
  NOTE_DT_TM          DATE                      DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  RECORD_STATUS_CD    NUMBER                    DEFAULT 0                     NOT NULL,
  COMPRESSION_CD      NUMBER                    DEFAULT 0                     NOT NULL,
  CHECKSUM            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID        NUMBER                    DEFAULT 0,
  NON_CHARTABLE_FLAG  NUMBER                    DEFAULT 0,
  IMPORTANCE_FLAG     NUMBER                    DEFAULT 0,
  NOTE_TZ             NUMBER                    DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_EVENT_ORDER_LINK
(
  EVENT_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_ACTION_SEQUENCE   NUMBER,
  VALID_UNTIL_DT_TM       DATE                  DEFAULT SYSDATE               NOT NULL,
  VALID_FROM_DT_TM        DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_END_DT_TM         DATE                  DEFAULT SYSDATE               NOT NULL,
  PARENT_ORDER_IDENT      FLOAT(126)            DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CATALOG_TYPE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  CE_EVENT_ORDER_LINK_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_EVENT_PRSNL
(
  CE_EVENT_PRSNL_ID         NUMBER              DEFAULT 0                     NOT NULL,
  EVENT_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  VALID_UNTIL_DT_TM         DATE                DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  EVENT_PRSNL_ID            NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  VALID_FROM_DT_TM          DATE                DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ACTION_TYPE_CD            NUMBER              DEFAULT 0                     NOT NULL,
  REQUEST_DT_TM             DATE,
  REQUEST_PRSNL_ID          NUMBER              DEFAULT 0                     NOT NULL,
  REQUEST_PRSNL_FT          VARCHAR2(100 BYTE),
  REQUEST_COMMENT           VARCHAR2(255 BYTE),
  ACTION_DT_TM              DATE,
  ACTION_PRSNL_ID           NUMBER              DEFAULT 0                     NOT NULL,
  ACTION_PRSNL_FT           VARCHAR2(100 BYTE),
  PROXY_PRSNL_ID            NUMBER              DEFAULT 0                     NOT NULL,
  PROXY_PRSNL_FT            VARCHAR2(100 BYTE),
  ACTION_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTION_COMMENT            VARCHAR2(255 BYTE),
  CHANGE_SINCE_ACTION_FLAG  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID              NUMBER              DEFAULT 0                     NOT NULL,
  ACTION_TZ                 NUMBER              DEFAULT 0,
  REQUEST_TZ                NUMBER              DEFAULT 0,
  LINKED_EVENT_ID           NUMBER              DEFAULT 0,
  SYSTEM_COMMENT            VARCHAR2(255 BYTE),
  DIGITAL_SIGNATURE_IDENT   VARCHAR2(60 BYTE),
  ACTION_PRSNL_GROUP_ID     NUMBER              DEFAULT 0,
  REQUEST_PRSNL_GROUP_ID    NUMBER              DEFAULT 0,
  RECEIVING_PERSON_FT       VARCHAR2(100 BYTE),
  RECEIVING_PERSON_ID       NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_FLAGGED_RESULT
(
  CE_FLAGGED_RESULT_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  EVENT_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  ENCNTR_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  PERSON_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  EVENT_CD              NUMBER                  DEFAULT 0                     NOT NULL,
  EVENT_END_DT_TM       DATE,
  FLAGGED_DT_TM         DATE,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_FLAGGED_RESULT_ROLE
(
  CE_FLAGGED_RESULT_ROLE_ID  NUMBER             DEFAULT 0                     NOT NULL,
  EVENT_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  CE_FLAGGED_RESULT_ID       NUMBER             DEFAULT 0                     NOT NULL,
  ROLE_TYPE_CD               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_INTAKE_OUTPUT_RESULT
(
  CE_IO_RESULT_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  EVENT_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  PERSON_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  IO_TYPE_FLAG        NUMBER                    DEFAULT 0                     NOT NULL,
  IO_VOLUME           FLOAT(126),
  IO_STATUS_CD        NUMBER                    DEFAULT 0                     NOT NULL,
  IO_RESULT_ID        NUMBER                    DEFAULT 0                     NOT NULL,
  REFERENCE_EVENT_CD  NUMBER                    DEFAULT 0                     NOT NULL,
  REFERENCE_EVENT_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  ENCNTR_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  IO_END_DT_TM        DATE,
  IO_START_DT_TM      DATE                      DEFAULT SYSDATE               NOT NULL,
  VALID_FROM_DT_TM    DATE                      DEFAULT SYSDATE               NOT NULL,
  VALID_UNTIL_DT_TM   DATE                      DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_INVENTORY_RESULT
(
  EVENT_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  ITEM_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  SERIAL_NBR             VARCHAR2(30 BYTE),
  SERIAL_MNEMONIC        VARCHAR2(30 BYTE),
  DESCRIPTION            VARCHAR2(255 BYTE),
  ITEM_NBR               VARCHAR2(30 BYTE),
  QUANTITY               FLOAT(126),
  BODY_SITE              VARCHAR2(50 BYTE),
  REFERENCE_ENTITY_ID    NUMBER                 DEFAULT 0                     NOT NULL,
  REFERENCE_ENTITY_NAME  VARCHAR2(32 BYTE),
  VALID_FROM_DT_TM       DATE                   DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  VALID_UNTIL_DT_TM      DATE                   DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_IO_TOTAL_RESULT
(
  CE_IO_TOTAL_RESULT_ID         NUMBER          DEFAULT 0                     NOT NULL,
  IO_TOTAL_DEFINITION_ID        NUMBER          DEFAULT 0                     NOT NULL,
  EVENT_ID                      NUMBER          DEFAULT 0                     NOT NULL,
  ENCNTR_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  ENCNTR_FOCUSED_IND            NUMBER          DEFAULT 0                     NOT NULL,
  PERSON_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  IO_TOTAL_START_DT_TM          DATE,
  IO_TOTAL_END_DT_TM            DATE,
  IO_TOTAL_VALUE                FLOAT(126)      DEFAULT 0                     NOT NULL,
  IO_TOTAL_UNIT_CD              NUMBER          DEFAULT 0                     NOT NULL,
  SUSPECT_FLAG                  NUMBER          DEFAULT 0                     NOT NULL,
  LAST_IO_RESULT_CLINSIG_DT_TM  DATE,
  VALID_FROM_DT_TM              DATE,
  VALID_UNTIL_DT_TM             DATE,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  IO_TOTAL_RESULT_VAL           VARCHAR2(255 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_LINKED_RESULT
(
  EVENT_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  LINKED_EVENT_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  VALID_UNTIL_DT_TM      DATE                   DEFAULT SYSDATE               NOT NULL,
  VALID_FROM_DT_TM       DATE                   DEFAULT SYSDATE               NOT NULL,
  ORDER_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  ENCNTR_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  ACCESSION_NBR          VARCHAR2(20 BYTE),
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  REFERENCE_NBR          VARCHAR2(100 BYTE)     DEFAULT ' '                   NOT NULL,
  EVENT_CLASS_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  SERIES_REF_NBR         VARCHAR2(100 BYTE),
  SUB_SERIES_REF_NBR     VARCHAR2(60 BYTE),
  SUCCESSION_TYPE_CD     NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_MED_ADMIN_IDENT
(
  CE_MED_ADMIN_IDENT_ID       NUMBER            DEFAULT 0                     NOT NULL,
  PREV_CE_MED_ADMIN_IDENT_ID  NUMBER            DEFAULT 0                     NOT NULL,
  DISPENSE_HX_ID              NUMBER            DEFAULT 0                     NOT NULL,
  MED_ADMIN_BARCODE           VARCHAR2(200 BYTE) DEFAULT ' ' NOT NULL,
  BARCODE_SOURCE_CD           NUMBER            DEFAULT 0                     NOT NULL,
  ITEM_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  MED_PRODUCT_ID              NUMBER            DEFAULT 0                     NOT NULL,
  SCAN_QTY                    FLOAT(126)        DEFAULT 0                     NOT NULL,
  VALID_FROM_DT_TM            DATE              DEFAULT SYSDATE               NOT NULL,
  VALID_UNTIL_DT_TM           DATE              DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_MED_ADMIN_IDENT_RELTN
(
  CE_MED_IDENT_RELTN_ID       NUMBER            DEFAULT 0                     NOT NULL,
  PREV_CE_MED_IDENT_RELTN_ID  NUMBER            DEFAULT 0                     NOT NULL,
  EVENT_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  CE_MED_ADMIN_IDENT_ID       NUMBER            DEFAULT 0                     NOT NULL,
  VALID_FROM_DT_TM            DATE              DEFAULT SYSDATE               NOT NULL,
  VALID_UNTIL_DT_TM           DATE              DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_MED_RESULT
(
  EVENT_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  VALID_UNTIL_DT_TM          DATE               DEFAULT SYSDATE               NOT NULL,
  ADMIN_START_DT_TM          DATE               DEFAULT SYSDATE               NOT NULL,
  VALID_FROM_DT_TM           DATE               DEFAULT SYSDATE               NOT NULL,
  ADMIN_NOTE                 VARCHAR2(120 BYTE),
  ADMIN_PROV_ID              NUMBER             DEFAULT 0                     NOT NULL,
  ADMIN_END_DT_TM            DATE,
  ADMIN_ROUTE_CD             NUMBER             DEFAULT 0                     NOT NULL,
  ADMIN_SITE_CD              NUMBER             DEFAULT 0                     NOT NULL,
  ADMIN_METHOD_CD            NUMBER             DEFAULT 0                     NOT NULL,
  ADMIN_PT_LOC_CD            NUMBER             DEFAULT 0                     NOT NULL,
  INITIAL_DOSAGE             FLOAT(126)         DEFAULT 0                     NOT NULL,
  ADMIN_DOSAGE               FLOAT(126)         DEFAULT 0                     NOT NULL,
  DOSAGE_UNIT_CD             NUMBER             DEFAULT 0                     NOT NULL,
  INITIAL_VOLUME             FLOAT(126),
  TOTAL_INTAKE_VOLUME        FLOAT(126),
  DILUENT_TYPE_CD            NUMBER             DEFAULT 0                     NOT NULL,
  PH_DISPENSE_ID             NUMBER             DEFAULT 0                     NOT NULL,
  INFUSION_RATE              FLOAT(126),
  INFUSION_UNIT_CD           NUMBER             DEFAULT 0                     NOT NULL,
  INFUSION_TIME_CD           NUMBER             DEFAULT 0                     NOT NULL,
  MEDICATION_FORM_CD         NUMBER             DEFAULT 0                     NOT NULL,
  REASON_REQUIRED_FLAG       NUMBER,
  RESPONSE_REQUIRED_FLAG     NUMBER,
  ADMIN_STRENGTH             NUMBER,
  ADMIN_STRENGTH_UNIT_CD     NUMBER             DEFAULT 0                     NOT NULL,
  SUBSTANCE_LOT_NUMBER       VARCHAR2(20 BYTE),
  SUBSTANCE_EXP_DT_TM        DATE,
  SUBSTANCE_MANUFACTURER_CD  NUMBER             DEFAULT 0                     NOT NULL,
  REFUSAL_CD                 NUMBER             DEFAULT 0                     NOT NULL,
  SYSTEM_ENTRY_DT_TM         DATE,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  IV_EVENT_CD                NUMBER             DEFAULT 0                     NOT NULL,
  INFUSED_VOLUME             FLOAT(126),
  INFUSED_VOLUME_UNIT_CD     NUMBER             DEFAULT 0                     NOT NULL,
  REMAINING_VOLUME           FLOAT(126),
  REMAINING_VOLUME_UNIT_CD   NUMBER             DEFAULT 0                     NOT NULL,
  SYNONYM_ID                 NUMBER             DEFAULT 0                     NOT NULL,
  IMMUNIZATION_TYPE_CD       NUMBER             DEFAULT 0                     NOT NULL,
  ADMIN_END_TZ               NUMBER             DEFAULT 0,
  ADMIN_START_TZ             NUMBER             DEFAULT 0,
  WEIGHT_UNIT_CD             NUMBER             DEFAULT 0,
  WEIGHT_VALUE               FLOAT(126)         DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_PRCS_QUEUE
(
  CE_PRCS_QUEUE_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  CE_EVENT_ACTION_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  EVENT_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  QUEUE_TYPE_CD       NUMBER                    DEFAULT 0                     NOT NULL,
  CREATE_DT_TM        DATE,
  PRCS_DT_TM          DATE,
  QUEUE_STATUS_CD     NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_PRODUCT
(
  EVENT_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  VALID_UNTIL_DT_TM         DATE                DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  VALID_FROM_DT_TM          DATE                DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  PRODUCT_ID                NUMBER              DEFAULT 0                     NOT NULL,
  PRODUCT_NBR               VARCHAR2(40 BYTE)   DEFAULT ' '                   NOT NULL,
  PRODUCT_CD                NUMBER              DEFAULT 0                     NOT NULL,
  PRODUCT_STATUS_CD         NUMBER              DEFAULT 0                     NOT NULL,
  ABO_CD                    NUMBER              DEFAULT 0                     NOT NULL,
  RH_CD                     NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  PRODUCT_VOLUME            FLOAT(126),
  PRODUCT_VOLUME_UNIT_CD    NUMBER              DEFAULT 0,
  PRODUCT_QUANTITY          FLOAT(126),
  PRODUCT_QUANTITY_UNIT_CD  NUMBER              DEFAULT 0,
  PRODUCT_STRENGTH_UNIT_CD  NUMBER              DEFAULT 0,
  PRODUCT_STRENGTH          FLOAT(126)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_SPECIMEN_COLL
(
  EVENT_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  VALID_UNTIL_DT_TM    DATE                     DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  VALID_FROM_DT_TM     DATE                     DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  SPECIMEN_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  CONTAINER_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  CONTAINER_TYPE_CD    NUMBER                   DEFAULT 0                     NOT NULL,
  SPECIMEN_STATUS_CD   NUMBER                   DEFAULT 0                     NOT NULL,
  COLLECT_DT_TM        DATE                     DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  COLLECT_METHOD_CD    NUMBER                   DEFAULT 0                     NOT NULL,
  COLLECT_LOC_CD       NUMBER                   DEFAULT 0                     NOT NULL,
  COLLECT_PRSNL_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  COLLECT_VOLUME       FLOAT(126)               DEFAULT 0                     NOT NULL,
  COLLECT_UNIT_CD      NUMBER                   DEFAULT 0                     NOT NULL,
  COLLECT_PRIORITY_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  SOURCE_TYPE_CD       NUMBER                   DEFAULT 0                     NOT NULL,
  SOURCE_TEXT          VARCHAR2(255 BYTE),
  BODY_SITE_CD         NUMBER                   DEFAULT 0                     NOT NULL,
  DANGER_CD            NUMBER                   DEFAULT 0                     NOT NULL,
  POSITIVE_IND         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  COLLECT_TZ           NUMBER                   DEFAULT 0,
  RECVD_DT_TM          DATE,
  RECVD_TZ             NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CE_SUSCEPTIBILITY
(
  EVENT_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  VALID_UNTIL_DT_TM         DATE                DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  MICRO_SEQ_NBR             NUMBER              DEFAULT 0                     NOT NULL,
  SUSCEP_SEQ_NBR            NUMBER              DEFAULT 0                     NOT NULL,
  VALID_FROM_DT_TM          DATE                DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  SUSCEPTIBILITY_TEST_CD    NUMBER              DEFAULT 0                     NOT NULL,
  DETAIL_SUSCEPTIBILITY_CD  NUMBER              DEFAULT 0                     NOT NULL,
  PANEL_ANTIBIOTIC_CD       NUMBER              DEFAULT 0                     NOT NULL,
  ANTIBIOTIC_CD             NUMBER              DEFAULT 0                     NOT NULL,
  DILUENT_VOLUME            FLOAT(126)          DEFAULT 0                     NOT NULL,
  RESULT_CD                 NUMBER              DEFAULT 0                     NOT NULL,
  RESULT_TEXT_VALUE         VARCHAR2(100 BYTE),
  RESULT_NUMERIC_VALUE      FLOAT(126),
  RESULT_UNIT_CD            NUMBER              DEFAULT 0                     NOT NULL,
  RESULT_DT_TM              DATE                DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  RESULT_PRSNL_ID           NUMBER              DEFAULT 0                     NOT NULL,
  SUSCEPTIBILITY_STATUS_CD  NUMBER              DEFAULT 0                     NOT NULL,
  ABNORMAL_FLAG             NUMBER              DEFAULT 0                     NOT NULL,
  CHARTABLE_FLAG            NUMBER              DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID           NUMBER              DEFAULT 0                     NOT NULL,
  ANTIBIOTIC_NOTE           VARCHAR2(255 BYTE),
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  RESULT_TZ                 NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHARGE
(
  CHARGE_ITEM_ID               NUMBER           DEFAULT 0                     NOT NULL,
  CHARGE_EVENT_ID              NUMBER           DEFAULT 0                     NOT NULL,
  BILL_ITEM_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  PAYOR_ID                     NUMBER           DEFAULT 0                     NOT NULL,
  CHARGE_DESCRIPTION           VARCHAR2(200 BYTE),
  PRICE_SCHED_ID               NUMBER           DEFAULT 0                     NOT NULL,
  ITEM_QUANTITY                FLOAT(126),
  ITEM_PRICE                   FLOAT(126),
  ITEM_EXTENDED_PRICE          FLOAT(126),
  PARENT_CHARGE_ITEM_ID        NUMBER           DEFAULT 0                     NOT NULL,
  CHARGE_TYPE_CD               NUMBER           DEFAULT 0                     NOT NULL,
  SUSPENSE_RSN_CD              NUMBER           DEFAULT 0                     NOT NULL,
  REASON_COMMENT               VARCHAR2(200 BYTE),
  POSTED_CD                    NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVITY_DT_TM               DATE,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE,
  END_EFFECTIVE_DT_TM          DATE,
  CHARGE_EVENT_ACT_ID          NUMBER           DEFAULT 0                     NOT NULL,
  ORDER_ID                     NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  PERSON_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  ORD_LOC_CD                   NUMBER           DEFAULT 0                     NOT NULL,
  PERF_LOC_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  ORD_PHYS_ID                  NUMBER           DEFAULT 0                     NOT NULL,
  PERF_PHYS_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  ITEM_ALLOWABLE               FLOAT(126),
  ITEM_COPAY                   FLOAT(126),
  RESEARCH_ACCT_ID             NUMBER           DEFAULT 0                     NOT NULL,
  POSTED_DT_TM                 DATE,
  PROCESS_FLG                  NUMBER,
  SERVICE_DT_TM                DATE,
  CREDITED_DT_TM               DATE,
  ADJUSTED_DT_TM               DATE,
  INTERFACE_FILE_ID            NUMBER           DEFAULT 0                     NOT NULL,
  TIER_GROUP_CD                NUMBER           DEFAULT 0                     NOT NULL,
  DEF_BILL_ITEM_ID             NUMBER           DEFAULT 0                     NOT NULL,
  DISCOUNT_AMOUNT              FLOAT(126),
  VERIFY_PHYS_ID               NUMBER           DEFAULT 0                     NOT NULL,
  GROSS_PRICE                  FLOAT(126),
  MANUAL_IND                   NUMBER           DEFAULT 0,
  COMBINE_IND                  NUMBER,
  ABN_STATUS_CD                NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVITY_TYPE_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ADMIT_TYPE_CD                NUMBER           DEFAULT 0                     NOT NULL,
  BUNDLE_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  COST_CENTER_CD               NUMBER           DEFAULT 0                     NOT NULL,
  DEPARTMENT_CD                NUMBER           DEFAULT 0                     NOT NULL,
  INSTITUTION_CD               NUMBER           DEFAULT 0                     NOT NULL,
  INST_FIN_NBR                 VARCHAR2(50 BYTE),
  LEVEL5_CD                    NUMBER           DEFAULT 0                     NOT NULL,
  MED_SERVICE_CD               NUMBER           DEFAULT 0                     NOT NULL,
  SECTION_CD                   NUMBER           DEFAULT 0                     NOT NULL,
  SUBSECTION_CD                NUMBER           DEFAULT 0                     NOT NULL,
  FIN_CLASS_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID               NUMBER           DEFAULT 0                     NOT NULL,
  ITEM_INTERVAL_ID             NUMBER           DEFAULT 0                     NOT NULL,
  ITEM_LIST_PRICE              FLOAT(126)       DEFAULT 0,
  ITEM_REIMBURSEMENT           FLOAT(126)       DEFAULT 0,
  LIST_PRICE_SCHED_ID          NUMBER           DEFAULT 0                     NOT NULL,
  PAYOR_TYPE_CD                NUMBER           DEFAULT 0                     NOT NULL,
  EPSDT_IND                    NUMBER,
  REF_PHYS_ID                  NUMBER           DEFAULT 0                     NOT NULL,
  START_DT_TM                  DATE,
  STOP_DT_TM                   DATE,
  ALPHA_NOMEN_ID               NUMBER           DEFAULT 0                     NOT NULL,
  SERVER_PROCESS_FLAG          NUMBER,
  OFFSET_CHARGE_ITEM_ID        NUMBER           DEFAULT 0                     NOT NULL,
  ITEM_DEDUCTIBLE_AMT          FLOAT(126),
  PATIENT_RESPONSIBILITY_FLAG  NUMBER           DEFAULT 0                     NOT NULL,
  CS_CPP_UNDO_ID               NUMBER           DEFAULT 0                     NOT NULL,
  CS_CPP_UNDO_QUAL_ID          NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHARGE_BATCH
(
  CHARGE_BATCH_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  CREATED_PRSNL_ID   NUMBER                     DEFAULT 0                     NOT NULL,
  ASSIGNED_PRSNL_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  USER_DEFINED_IND   NUMBER                     DEFAULT 0                     NOT NULL,
  ACTIVE_IND         NUMBER                     DEFAULT 0                     NOT NULL,
  STATUS_CD          NUMBER                     DEFAULT 0                     NOT NULL,
  STATUS_DT_TM       DATE,
  CREATED_DT_TM      DATE,
  ACCESSED_DT_TM     DATE,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  BATCH_ALIAS        VARCHAR2(50 BYTE)          DEFAULT ' '                   NOT NULL,
  BATCH_DT_TM        DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHARGE_BATCH_DETAIL
(
  CHARGE_BATCH_DETAIL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  CHARGE_BATCH_ID              NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  ORDERING_PHYS_ID             NUMBER           DEFAULT 0                     NOT NULL,
  BILL_ITEM_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  SERVICE_ITEM_IDENT           VARCHAR2(50 BYTE) DEFAULT ' ' NOT NULL,
  SERVICE_ITEM_IDENT_TYPE_CD   NUMBER           DEFAULT 0                     NOT NULL,
  SERVICE_ITEM_QTY             FLOAT(126)       DEFAULT 0                     NOT NULL,
  SERVICE_ITEM_PRICE_AMT       FLOAT(126)       DEFAULT 0                     NOT NULL,
  SERVICE_ITEM_DESC            VARCHAR2(200 BYTE) DEFAULT ' ' NOT NULL,
  SERVICE_DT_TM                DATE,
  PERF_LOC_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  STATUS_CD                    NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  DIAGNOSIS_POINTER_NBR        NUMBER           DEFAULT 0                     NOT NULL,
  RENDERING_PHYS_ID            NUMBER           DEFAULT 0                     NOT NULL,
  CREATED_DT_TM                DATE             DEFAULT SYSDATE,
  PATIENT_RESPONSIBILITY_FLAG  NUMBER           DEFAULT 0,
  ITEM_COPAY_AMT               FLOAT(126)       DEFAULT 0,
  ITEM_DEDUCTIBLE_AMT          FLOAT(126)       DEFAULT 0,
  DIAGNOSIS_POINTER_TXT        VARCHAR2(50 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHARGE_BATCH_DETAIL_CODE
(
  CHARGE_BATCH_DETAIL_CODE_ID  NUMBER           DEFAULT 0                     NOT NULL,
  CHARGE_BATCH_DETAIL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME           VARCHAR2(30 BYTE) DEFAULT ' ' NOT NULL,
  PARENT_ENTITY_ID             NUMBER           DEFAULT 0                     NOT NULL,
  TYPE_IDENT                   VARCHAR2(50 BYTE) DEFAULT ' ' NOT NULL,
  PRIORITY_SEQ                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  TYPE_CD                      NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHARGE_BATCH_DETAIL_FIELD
(
  CHARGE_BATCH_DETAIL_FIELD_ID  NUMBER          DEFAULT 0                     NOT NULL,
  CHARGE_BATCH_DETAIL_ID        NUMBER          DEFAULT 0                     NOT NULL,
  FIELD_TYPE_CD                 NUMBER          DEFAULT 0                     NOT NULL,
  FIELD_VALUE_DT_TM             DATE,
  FIELD_VALUE_CHAR              VARCHAR2(200 BYTE) DEFAULT ' ' NOT NULL,
  FIELD_VALUE_NBR               FLOAT(126)      DEFAULT 0                     NOT NULL,
  FIELD_VALUE_IND               NUMBER          DEFAULT 0                     NOT NULL,
  FIELD_VALUE_CD                NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_IND                    NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHARGE_EVENT
(
  CHARGE_EVENT_ID          NUMBER               DEFAULT 0                     NOT NULL,
  EXT_M_EVENT_ID           NUMBER               DEFAULT 0                     NOT NULL,
  EXT_M_EVENT_CONT_CD      NUMBER               DEFAULT 0                     NOT NULL,
  EXT_M_REFERENCE_ID       NUMBER               DEFAULT 0                     NOT NULL,
  EXT_M_REFERENCE_CONT_CD  NUMBER               DEFAULT 0                     NOT NULL,
  EXT_P_EVENT_ID           NUMBER               DEFAULT 0                     NOT NULL,
  EXT_P_EVENT_CONT_CD      NUMBER               DEFAULT 0                     NOT NULL,
  EXT_P_REFERENCE_ID       NUMBER               DEFAULT 0                     NOT NULL,
  EXT_P_REFERENCE_CONT_CD  NUMBER               DEFAULT 0                     NOT NULL,
  EXT_I_EVENT_ID           NUMBER               DEFAULT 0                     NOT NULL,
  EXT_I_EVENT_CONT_CD      NUMBER               DEFAULT 0                     NOT NULL,
  EXT_I_REFERENCE_ID       NUMBER               DEFAULT 0                     NOT NULL,
  EXT_I_REFERENCE_CONT_CD  NUMBER               DEFAULT 0                     NOT NULL,
  BILL_ITEM_ID             NUMBER               DEFAULT 0                     NOT NULL,
  P_BILL_ITEM_ID           NUMBER               DEFAULT 0                     NOT NULL,
  M_BILL_ITEM_ID           NUMBER               DEFAULT 0                     NOT NULL,
  P_CHARGE_EVENT_ID        NUMBER               DEFAULT 0                     NOT NULL,
  M_CHARGE_EVENT_ID        NUMBER               DEFAULT 0                     NOT NULL,
  ORDER_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD    NUMBER               DEFAULT 0                     NOT NULL,
  REFERENCE_NBR            VARCHAR2(60 BYTE),
  CANCELLED_IND            NUMBER,
  CANCELLED_DT_TM          DATE,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  COLLECTION_PRIORITY_CD   NUMBER               DEFAULT 0                     NOT NULL,
  REPORT_PRIORITY_CD       NUMBER               DEFAULT 0                     NOT NULL,
  ACCESSION                VARCHAR2(50 BYTE),
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_DT_TM      DATE,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  RESEARCH_ACCOUNT_ID      NUMBER               DEFAULT 0                     NOT NULL,
  ABN_STATUS_CD            NUMBER               DEFAULT 0                     NOT NULL,
  PERF_LOC_CD              NUMBER               DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID           NUMBER               DEFAULT 0                     NOT NULL,
  EPSDT_IND                NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHARGE_EVENT_ACT
(
  CHARGE_EVENT_ACT_ID          NUMBER           DEFAULT 0                     NOT NULL,
  CHARGE_EVENT_ID              NUMBER           DEFAULT 0                     NOT NULL,
  CEA_TYPE_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  CEA_PRSNL_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD          NUMBER           DEFAULT 0                     NOT NULL,
  SERVICE_DT_TM                DATE,
  CHARGE_DT_TM                 DATE,
  CHARGE_TYPE_CD               NUMBER           DEFAULT 0                     NOT NULL,
  REFERENCE_RANGE_FACTOR_ID    NUMBER           DEFAULT 0                     NOT NULL,
  ALPHA_NOMEN_ID               NUMBER           DEFAULT 0                     NOT NULL,
  QUANTITY                     FLOAT(126)       DEFAULT 0                     NOT NULL,
  UNITS                        NUMBER           DEFAULT 0                     NOT NULL,
  UNIT_TYPE_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  PATIENT_LOC_CD               NUMBER           DEFAULT 0                     NOT NULL,
  SERVICE_LOC_CD               NUMBER           DEFAULT 0                     NOT NULL,
  REASON_CD                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER,
  INSERT_DT_TM                 DATE,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  IN_LAB_DT_TM                 DATE,
  ACCESSION_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  REPEAT_IND                   NUMBER           DEFAULT 0,
  RESULT                       VARCHAR2(200 BYTE),
  CEA_MISC1                    VARCHAR2(200 BYTE),
  CEA_MISC1_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  CEA_MISC2                    VARCHAR2(200 BYTE),
  CEA_MISC2_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  CEA_MISC3                    VARCHAR2(200 BYTE),
  CEA_MISC3_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  CEA_MISC4_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  SRV_DIAG1_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  SRV_DIAG2_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  SRV_DIAG3_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  SRV_DIAG4_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  SRV_DIAG_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  MISC_IND                     NUMBER           DEFAULT 0,
  CEA_MISC5_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  CEA_MISC6_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  CEA_MISC7_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVITY_DT_TM               DATE,
  PRIORITY_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  ITEM_PRICE                   FLOAT(126)       DEFAULT 0                     NOT NULL,
  ITEM_EXT_PRICE               FLOAT(126)       DEFAULT 0                     NOT NULL,
  ITEM_COPAY                   FLOAT(126)       DEFAULT 0                     NOT NULL,
  DISCOUNT_AMOUNT              FLOAT(126)       DEFAULT 0                     NOT NULL,
  ITEM_REIMBURSEMENT           FLOAT(126)       DEFAULT 0                     NOT NULL,
  ITEM_DEDUCTIBLE_AMT          FLOAT(126),
  PATIENT_RESPONSIBILITY_FLAG  NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHARGE_EVENT_ACT_PRSNL
(
  CHARGE_EVENT_ACT_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_TYPE_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_IND           NUMBER,
  DM2_MIG_SEQ_ID       NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHARGE_EVENT_MOD
(
  CHARGE_EVENT_MOD_ID       NUMBER              DEFAULT 0                     NOT NULL,
  CHARGE_EVENT_ID           NUMBER              DEFAULT 0                     NOT NULL,
  CHARGE_EVENT_MOD_TYPE_CD  NUMBER              DEFAULT 0                     NOT NULL,
  FIELD1                    VARCHAR2(200 BYTE),
  FIELD2                    VARCHAR2(200 BYTE),
  FIELD3                    VARCHAR2(200 BYTE),
  FIELD4                    VARCHAR2(200 BYTE),
  FIELD5                    VARCHAR2(200 BYTE),
  FIELD6                    VARCHAR2(200 BYTE),
  FIELD7                    VARCHAR2(200 BYTE),
  FIELD8                    VARCHAR2(200 BYTE),
  FIELD9                    VARCHAR2(200 BYTE),
  FIELD10                   VARCHAR2(200 BYTE),
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  CODE1_CD                  NUMBER              DEFAULT 0                     NOT NULL,
  NOMEN_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  FIELD1_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  FIELD2_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  FIELD3_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  FIELD4_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  FIELD5_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  CM1_NBR                   FLOAT(126)          DEFAULT 0                     NOT NULL,
  ACTIVITY_DT_TM            DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHARGE_MOD
(
  CHARGE_MOD_ID           NUMBER                DEFAULT 0                     NOT NULL,
  CHARGE_ITEM_ID          NUMBER                DEFAULT 0                     NOT NULL,
  CHARGE_MOD_TYPE_CD      NUMBER                DEFAULT 0                     NOT NULL,
  FIELD1                  VARCHAR2(200 BYTE),
  FIELD2                  VARCHAR2(200 BYTE),
  FIELD3                  VARCHAR2(200 BYTE),
  FIELD4                  VARCHAR2(200 BYTE),
  FIELD5                  VARCHAR2(200 BYTE),
  FIELD6                  VARCHAR2(200 BYTE),
  FIELD7                  VARCHAR2(200 BYTE),
  FIELD8                  VARCHAR2(200 BYTE),
  FIELD9                  VARCHAR2(200 BYTE),
  FIELD10                 VARCHAR2(200 BYTE),
  ACTIVITY_DT_TM          DATE,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  CODE1_CD                NUMBER                DEFAULT 0                     NOT NULL,
  NOMEN_ID                NUMBER                DEFAULT 0                     NOT NULL,
  FIELD1_ID               NUMBER                DEFAULT 0                     NOT NULL,
  FIELD2_ID               NUMBER                DEFAULT 0                     NOT NULL,
  FIELD3_ID               NUMBER                DEFAULT 0                     NOT NULL,
  FIELD4_ID               NUMBER                DEFAULT 0                     NOT NULL,
  FIELD5_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CM1_NBR                 FLOAT(126)            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHARTING_OPERATIONS_PRSNL
(
  CHARTING_OPERATIONS_PRSNL_ID  NUMBER          DEFAULT 0                     NOT NULL,
  CHARTING_OPERATIONS_ID        NUMBER          DEFAULT 0                     NOT NULL,
  PRSNL_ID                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_DEFINED_SEQUENCE
(
  DEFINED_SEQ_ID          NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  SEQUENCE_NBR            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_ENCNTR_DISCHARGE
(
  CHART_ENCNTR_DISCHARGE_ID  NUMBER             DEFAULT 0                     NOT NULL,
  ENCNTR_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  TRANSACT_DT_TM             DATE               DEFAULT SYSDATE               NOT NULL,
  PERSON_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  DISCHARGE_DT_TM            DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_OF_ACCOUNT
(
  ORGANIZATION_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  COST_CENTER_CD   NUMBER                       DEFAULT 0                     NOT NULL,
  SUB_ACCOUNT_CD   NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_PRINTED_SECTIONS
(
  PRINTED_SECTION_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  CHART_REQUEST_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  RESUBMIT_NBR        NUMBER                    DEFAULT 0                     NOT NULL,
  RESUBMIT_DT_TM      DATE                      DEFAULT SYSDATE,
  CHART_SECTION_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_PRINT_QUEUE
(
  CHART_QUEUE_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  BATCH_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  REQUEST_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  QUEUE_STATUS_CD      NUMBER                   DEFAULT 0                     NOT NULL,
  CHART_PATH           VARCHAR2(150 BYTE)       DEFAULT ' '                   NOT NULL,
  NUM_COPIES           NUMBER                   DEFAULT 0,
  BEGIN_PAGE           NUMBER,
  END_PAGE             NUMBER,
  PRINT_PATH           VARCHAR2(75 BYTE)        DEFAULT ' '                   NOT NULL,
  DISTRIBUTION_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  DIST_RUN_DT_TM       DATE,
  DIST_TERMINATOR_IND  NUMBER                   DEFAULT 0,
  QUEUED_DT_TM         DATE,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_PROCESS
(
  CHART_PROCESS_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ALLOCATION_DT_TM        DATE,
  ENCNTR_ID               NUMBER                DEFAULT 0,
  PERSON_ID               NUMBER                DEFAULT 0,
  CHART_STATUS_CD         NUMBER                DEFAULT 0,
  CHART_STATUS_DT_TM      DATE,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0,
  ABSTRACT_COMPLETE_IND   NUMBER,
  ALLOCATION_DT_FLAG      NUMBER,
  ALLOCATION_DT_MODIFIER  NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_REQUEST
(
  CHART_REQUEST_ID        NUMBER                DEFAULT 0                     NOT NULL,
  REQUEST_PRSNL_ID        NUMBER                DEFAULT 0                     NOT NULL,
  REQUEST_TYPE            NUMBER,
  SCOPE_FLAG              NUMBER,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ACCESSION_NBR           VARCHAR2(20 BYTE),
  CHART_FORMAT_ID         NUMBER                DEFAULT 0                     NOT NULL,
  DISTRIBUTION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  DIST_RUN_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  DIST_RUN_DT_TM          DATE,
  DIST_INITIATOR_IND      NUMBER,
  DIST_TERMINATOR_IND     NUMBER,
  DATE_RANGE_IND          NUMBER,
  BEGIN_DT_TM             DATE,
  END_DT_TM               DATE,
  PAGE_RANGE_IND          NUMBER,
  BEGIN_PAGE              NUMBER,
  END_PAGE                NUMBER,
  PRINT_COMPLETE_FLAG     NUMBER,
  CHART_PENDING_FLAG      NUMBER,
  ADDL_COPIES             NUMBER,
  OUTPUT_DEST_CD          NUMBER                DEFAULT 0                     NOT NULL,
  OUTPUT_DEVICE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  HANDLE_ID               NUMBER                DEFAULT 0                     NOT NULL,
  RRD_DELIVER_DT_TM       DATE,
  RRD_COUNTRY_ACCESS      VARCHAR2(3 BYTE),
  RRD_AREA_CODE           VARCHAR2(10 BYTE),
  RRD_EXCHANGE            VARCHAR2(10 BYTE),
  RRD_PHONE_SUFFIX        VARCHAR2(50 BYTE),
  STATUS_FLAG             NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  READER_GROUP            VARCHAR2(15 BYTE),
  RESUBMIT_DT_TM          DATE,
  RESUBMIT_CNT            NUMBER,
  REQUEST_DT_TM           DATE,
  MCIS_IND                NUMBER,
  CHART_STATUS_CD         NUMBER                DEFAULT 0                     NOT NULL,
  TRIGGER_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PROCESS_TIME            FLOAT(126),
  PRSNL_PERSON_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_PERSON_R_CD       NUMBER                DEFAULT 0                     NOT NULL,
  RECOVER_CNT             NUMBER,
  RECOVER_DT_TM           DATE,
  SERVER_NAME             VARCHAR2(20 BYTE),
  TOTAL_PAGES             NUMBER,
  TRIGGER_TYPE            VARCHAR2(15 BYTE),
  EVENT_IND               NUMBER,
  FILE_STORAGE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  FILE_STORAGE_LOCATION   VARCHAR2(100 BYTE),
  TRIGGER_NAME            VARCHAR2(100 BYTE),
  PRSNL_RELTN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  SUPPRESS_MRPNODATA_IND  NUMBER                DEFAULT 0,
  CHART_BATCH_ID          NUMBER                DEFAULT 0                     NOT NULL,
  SEQUENCE_GROUP_ID       NUMBER                DEFAULT 0                     NOT NULL,
  CHART_ROUTE_ID          NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_LOOKUP_IND       NUMBER                DEFAULT 0,
  GROUP_ORDER_ID          NUMBER                DEFAULT 0,
  ORDER_GROUP_FLAG        NUMBER                DEFAULT 0,
  CR_MASK_ID              NUMBER                DEFAULT 0,
  USER_ROLE_PROFILE       VARCHAR2(255 BYTE),
  CHART_TRIGGER_ID        NUMBER                DEFAULT 0                     NOT NULL,
  NON_CE_BEGIN_DT_TM      DATE,
  NON_CE_END_DT_TM        DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_REQUEST_ENCNTR
(
  CHART_REQUEST_ENCNTR_ID  NUMBER               DEFAULT 0                     NOT NULL,
  CHART_REQUEST_ID         NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  CR_ENCNTR_SEQ            NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_REQUEST_EVENT
(
  CR_EVENT_ID       NUMBER                      DEFAULT 0                     NOT NULL,
  CHART_REQUEST_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  EVENT_ID          NUMBER                      DEFAULT 0                     NOT NULL,
  CR_EVENT_SEQ      NUMBER,
  RESULT_STATUS_CD  NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_REQUEST_ORDER
(
  CHART_REQUEST_ORDER_ID  NUMBER                DEFAULT 0                     NOT NULL,
  CHART_REQUEST_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_REQUEST_SECTION
(
  CHART_REQUEST_ID        NUMBER                DEFAULT 0                     NOT NULL,
  CHART_SECTION_ID        NUMBER                DEFAULT 0                     NOT NULL,
  CR_SECT_SEQ             NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_REQ_INERR_EVENT
(
  CHART_REQ_INERR_EVENT_ID  NUMBER              DEFAULT 0                     NOT NULL,
  CHART_REQUEST_ID          NUMBER              DEFAULT 0                     NOT NULL,
  EVENT_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_SEQ_GROUP_RELTN
(
  GROUP_RELTN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  SEQUENCE_GROUP_ID       NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  SEQUENCE_NBR            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  LOCATION_CD             NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_SERV_LOG
(
  CHART_LOG_NUM     NUMBER                      DEFAULT 0                     NOT NULL,
  LOG_DT_TM         DATE,
  LOG_LEVEL         NUMBER,
  CHART_REQUEST_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  MESSAGE_TEXT      VARCHAR2(150 BYTE),
  SERVER_NAME       VARCHAR2(30 BYTE),
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_TEMP
(
  CREATE_DT_TM        DATE,
  DISTRIBUTION_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  ENCNTR_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CD      NUMBER                    DEFAULT 0                     NOT NULL,
  LOC_BED_CD          NUMBER                    DEFAULT 0                     NOT NULL,
  LOC_BUILDING_CD     NUMBER                    DEFAULT 0                     NOT NULL,
  LOC_FACILITY_CD     NUMBER                    DEFAULT 0                     NOT NULL,
  LOC_NURSE_UNIT_CD   NUMBER                    DEFAULT 0                     NOT NULL,
  LOC_ROOM_CD         NUMBER                    DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  PERSON_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  USE_IND             NUMBER,
  DONT_USE_IND        NUMBER,
  BEGIN_DT_TM         DATE,
  LOOKBACK_DT_TM      DATE,
  DM2_MIG_SEQ_ID      NUMBER,
  NON_CE_BEGIN_DT_TM  DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_TRIGGER
(
  CHART_TRIGGER_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PREV_CHART_TRIGGER_ID   NUMBER                DEFAULT 0                     NOT NULL,
  TRIGGER_TYPE_FLAG       NUMBER                DEFAULT 0                     NOT NULL,
  TRIGGER_NAME            VARCHAR2(150 BYTE)    DEFAULT ' '                   NOT NULL,
  TRIGGER_NAME_KEY        VARCHAR2(150 BYTE)    DEFAULT ' '                   NOT NULL,
  COMPLETE_FLAG           NUMBER                DEFAULT 0                     NOT NULL,
  DISCHARGE_TYPE_FLAG     NUMBER                DEFAULT 0                     NOT NULL,
  SCOPE_FLAG              NUMBER                DEFAULT 0                     NOT NULL,
  PENDING_FLAG            NUMBER                DEFAULT 0                     NOT NULL,
  REPORT_TEMPLATE_ID      NUMBER                DEFAULT 0                     NOT NULL,
  CHART_FORMAT_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PRINT_RANGE_FLAG        NUMBER                DEFAULT 0                     NOT NULL,
  ROUTE_LOCATION_BIT_MAP  NUMBER                DEFAULT 0                     NOT NULL,
  DEFAULT_OUTPUT_DEST_CD  NUMBER                DEFAULT 0                     NOT NULL,
  EXPIRED_RELTN_IND       NUMBER                DEFAULT 0                     NOT NULL,
  FILE_STORAGE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  FILE_STORAGE_LOCATION   VARCHAR2(225 BYTE),
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  NAME_IDENT              VARCHAR2(167 BYTE)    DEFAULT ' '                   NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  DAYS_NBR                NUMBER                DEFAULT 0                     NOT NULL,
  DMS_SERVICE_NAME        VARCHAR2(64 BYTE),
  DATE_DT_TM              DATE,
  ADDITIONAL_COPY_NBR     NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHART_TRIGGER_PARAM
(
  CHART_TRIGGER_PARAM_ID  NUMBER                DEFAULT 0                     NOT NULL,
  CHART_TRIGGER_ID        NUMBER                DEFAULT 0                     NOT NULL,
  INCLUDE_IND             NUMBER                DEFAULT 0                     NOT NULL,
  PARAM_TYPE_FLAG         NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(30 BYTE)     DEFAULT ' '                   NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CHRG_GRP_EXCEPTION
(
  CHRG_GRP_EXCEPTION_ID   NUMBER                DEFAULT 0                     NOT NULL,
  PRIMARY_HP_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PRIMARY_INS_ORG_ID      NUMBER                DEFAULT 0                     NOT NULL,
  SECONDARY_HP_ID         NUMBER                DEFAULT 0                     NOT NULL,
  SECONDARY_INS_ORG_ID    NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CLASS_GROUP
(
  CLASS_GROUP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_CLASS_NODE_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CHILD_CLASS_NODE_ID     NUMBER                DEFAULT 0                     NOT NULL,
  CLASS_INSTANCE_CD       NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX          NUMBER,
  CREATE_DT_TM            DATE,
  CREATE_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_TASK             NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CLASS_NODE
(
  CLASS_NODE_ID           NUMBER                DEFAULT 0                     NOT NULL,
  CLASS_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  CLASS_INSTANCE_CD       NUMBER                DEFAULT 0                     NOT NULL,
  DESCRIPTION             VARCHAR2(60 BYTE),
  SHORT_DESCRIPTION       VARCHAR2(40 BYTE),
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX          NUMBER,
  CREATE_DT_TM            DATE,
  CREATE_ID               NUMBER                DEFAULT 0,
  CREATE_TASK             NUMBER,
  LOGICAL_DOMAIN_ID       NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CLINICAL_EVENT
(
  CLINICAL_EVENT_ID        NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_START_DT_TM        DATE,
  ENCNTR_FINANCIAL_ID      NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  VALID_UNTIL_DT_TM        DATE                 DEFAULT SYSDATE               NOT NULL,
  EVENT_TITLE_TEXT         VARCHAR2(255 BYTE),
  VIEW_LEVEL               NUMBER               DEFAULT 0                     NOT NULL,
  ORDER_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  CATALOG_CD               NUMBER               DEFAULT 0                     NOT NULL,
  SERIES_REF_NBR           VARCHAR2(100 BYTE),
  ACCESSION_NBR            VARCHAR2(20 BYTE),
  CONTRIBUTOR_SYSTEM_CD    NUMBER               DEFAULT 0                     NOT NULL,
  REFERENCE_NBR            VARCHAR2(100 BYTE)   DEFAULT ' '                   NOT NULL,
  PARENT_EVENT_ID          NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_RELTN_CD           NUMBER               DEFAULT 0                     NOT NULL,
  VALID_FROM_DT_TM         DATE                 DEFAULT SYSDATE               NOT NULL,
  EVENT_CLASS_CD           NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_CD                 NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_TAG                VARCHAR2(255 BYTE)   DEFAULT ' '                   NOT NULL,
  EVENT_END_DT_TM          DATE                 DEFAULT SYSDATE               NOT NULL,
  EVENT_END_DT_TM_OS       FLOAT(126),
  RESULT_VAL               VARCHAR2(255 BYTE),
  RESULT_UNITS_CD          NUMBER               DEFAULT 0                     NOT NULL,
  RESULT_TIME_UNITS_CD     NUMBER               DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD            NUMBER               DEFAULT 0                     NOT NULL,
  RECORD_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  RESULT_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  AUTHENTIC_FLAG           NUMBER               DEFAULT 0                     NOT NULL,
  PUBLISH_FLAG             NUMBER               DEFAULT 0                     NOT NULL,
  QC_REVIEW_CD             NUMBER               DEFAULT 0                     NOT NULL,
  NORMALCY_CD              NUMBER               DEFAULT 0                     NOT NULL,
  NORMALCY_METHOD_CD       NUMBER               DEFAULT 0                     NOT NULL,
  INQUIRE_SECURITY_CD      NUMBER               DEFAULT 0                     NOT NULL,
  RESOURCE_GROUP_CD        NUMBER               DEFAULT 0                     NOT NULL,
  RESOURCE_CD              NUMBER               DEFAULT 0                     NOT NULL,
  SUBTABLE_BIT_MAP         NUMBER,
  COLLATING_SEQ            VARCHAR2(40 BYTE),
  VERIFIED_DT_TM           DATE,
  VERIFIED_PRSNL_ID        NUMBER               DEFAULT 0                     NOT NULL,
  PERFORMED_DT_TM          DATE,
  PERFORMED_PRSNL_ID       NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  NORMAL_LOW               VARCHAR2(20 BYTE),
  NORMAL_HIGH              VARCHAR2(20 BYTE),
  CRITICAL_LOW             VARCHAR2(20 BYTE),
  CRITICAL_HIGH            VARCHAR2(20 BYTE),
  EXPIRATION_DT_TM         DATE,
  NOTE_IMPORTANCE_BIT_MAP  NUMBER               DEFAULT 0,
  EVENT_TAG_SET_FLAG       NUMBER,
  CLINSIG_UPDT_DT_TM       DATE,
  ORDER_ACTION_SEQUENCE    NUMBER               DEFAULT 0                     NOT NULL,
  ENTRY_MODE_CD            NUMBER               DEFAULT 0                     NOT NULL,
  SOURCE_CD                NUMBER               DEFAULT 0                     NOT NULL,
  CLINICAL_SEQ             VARCHAR2(40 BYTE),
  EVENT_END_TZ             NUMBER               DEFAULT 0,
  EVENT_START_TZ           NUMBER               DEFAULT 0,
  PERFORMED_TZ             NUMBER               DEFAULT 0,
  VERIFIED_TZ              NUMBER               DEFAULT 0,
  TASK_ASSAY_VERSION_NBR   FLOAT(126),
  MODIFIER_LONG_TEXT_ID    NUMBER               DEFAULT 0                     NOT NULL,
  NOMEN_STRING_FLAG        NUMBER               DEFAULT 0,
  SRC_CLINSIG_UPDT_DT_TM   DATE,
  SRC_EVENT_ID             NUMBER               DEFAULT 0                     NOT NULL,
  CE_DYNAMIC_LABEL_ID      NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CMS_CRITICAL_CATEGORY
(
  CMS_CRITICAL_CATEGORY_ID  NUMBER              DEFAULT 0                     NOT NULL,
  MULTUM_CATEGORY_ID        NUMBER              DEFAULT 0                     NOT NULL,
  CMS_CRITICAL_LOCATION_ID  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CMS_CRITICAL_LOCATION
(
  CMS_CRITICAL_LOCATION_ID  NUMBER              DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID           NUMBER              DEFAULT 0                     NOT NULL,
  LOCATION_CD               NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CN_DCP_SHIFT_ASSIGNMENT_ST
(
  CN_DCP_SHIFT_ASSIGNMENT_ST_ID  NUMBER         DEFAULT 0                     NOT NULL,
  CARETEAM_NAME                  VARCHAR2(100 BYTE),
  PRSNL_ID                       NUMBER         DEFAULT 0                     NOT NULL,
  PRSNL_POS_CD                   NUMBER         DEFAULT 0                     NOT NULL,
  ASSIGNMENT_GROUP_CD            NUMBER         DEFAULT 0                     NOT NULL,
  LOC_BUILDING_CD                NUMBER         DEFAULT 0                     NOT NULL,
  LOC_FACILITY_CD                NUMBER         DEFAULT 0                     NOT NULL,
  LOC_UNIT_CD                    NUMBER         DEFAULT 0                     NOT NULL,
  LOC_ROOM_CD                    NUMBER         DEFAULT 0                     NOT NULL,
  LOC_BED_CD                     NUMBER         DEFAULT 0                     NOT NULL,
  PERSON_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM            DATE,
  END_EFFECTIVE_DT_TM            DATE,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_ID                      NUMBER         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CN_OUTCOME_ST
(
  OUTCOME_ACTIVITY_ID      NUMBER               DEFAULT 0                     NOT NULL,
  OUTCOME_CATALOG_ID       NUMBER               DEFAULT 0                     NOT NULL,
  OUTCOME_CLASS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  OUTCOME_TYPE_CD          NUMBER               DEFAULT 0                     NOT NULL,
  OUTCOME_STATUS_CD        NUMBER               DEFAULT 0                     NOT NULL,
  OUTCOME_STATUS_DT_TM     DATE                 DEFAULT SYSDATE               NOT NULL,
  OUTCOME_STATUS_DT_NBR    NUMBER               DEFAULT 0                     NOT NULL,
  OUTCOME_STATUS_MIN_NBR   NUMBER               DEFAULT 0                     NOT NULL,
  OUTCOME_STATUS_PRSNL_ID  NUMBER               DEFAULT 0                     NOT NULL,
  DESCRIPTION              VARCHAR2(310 BYTE)   DEFAULT ' '                   NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_CD                 NUMBER               DEFAULT 0                     NOT NULL,
  OUTCOME_IND              NUMBER               DEFAULT 0                     NOT NULL,
  START_DT_TM              DATE,
  START_DT_NBR             NUMBER               DEFAULT 0                     NOT NULL,
  START_MIN_NBR            NUMBER               DEFAULT 0                     NOT NULL,
  END_DT_TM                DATE,
  END_DT_NBR               NUMBER               DEFAULT 0                     NOT NULL,
  END_MIN_NBR              NUMBER               DEFAULT 0                     NOT NULL,
  RESULT_SEARCH_END_DT_TM  DATE,
  TARGET_DURATION_QTY      NUMBER               DEFAULT 0,
  TARGET_DURATION_UNIT_CD  NUMBER               DEFAULT 0                     NOT NULL,
  TARGET_TYPE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  TARGET_DURATION_MIN_NBR  NUMBER               DEFAULT 0                     NOT NULL,
  ACTUAL_DURATION_MIN_NBR  NUMBER               DEFAULT 0                     NOT NULL,
  PLANNED_IND              NUMBER               DEFAULT 0                     NOT NULL,
  PLANNED_DT_TM            DATE,
  PLANNED_DT_NBR           NUMBER               DEFAULT 0                     NOT NULL,
  PLANNED_MIN_NBR          NUMBER               DEFAULT 0                     NOT NULL,
  PLANNED_PRSNL_ID         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVATED_IND            NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVATED_DT_TM          DATE,
  ACTIVATED_DT_NBR         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVATED_MIN_NBR        NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVATED_PRSNL_ID       NUMBER               DEFAULT 0                     NOT NULL,
  STOPPED_IND              NUMBER               DEFAULT 0                     NOT NULL,
  STOPPED_DT_TM            DATE,
  STOPPED_DT_NBR           NUMBER               DEFAULT 0                     NOT NULL,
  STOPPED_MIN_NBR          NUMBER               DEFAULT 0                     NOT NULL,
  STOPPED_PRSNL_ID         NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CN_PATHWAY_ST
(
  PATHWAY_ID               NUMBER               DEFAULT 0                     NOT NULL,
  PATHWAY_CATALOG_ID       NUMBER               DEFAULT 0                     NOT NULL,
  VERSION                  NUMBER,
  DESCRIPTION              VARCHAR2(100 BYTE)   DEFAULT ' '                   NOT NULL,
  PW_STATUS_CD             NUMBER               DEFAULT 0                     NOT NULL,
  PATHWAY_IND              NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  STATUS_DT_TM             DATE                 DEFAULT SYSDATE               NOT NULL,
  STATUS_DT_NBR            NUMBER,
  STATUS_MIN_NBR           NUMBER,
  STATUS_PRSNL_ID          NUMBER               DEFAULT 0                     NOT NULL,
  STATUS_LOC_FAC_CD        NUMBER               DEFAULT 0                     NOT NULL,
  STATUS_LOC_BLD_CD        NUMBER               DEFAULT 0                     NOT NULL,
  STATUS_LOC_NU_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ORDERED_IND              NUMBER               DEFAULT 0                     NOT NULL,
  ORDER_DT_TM              DATE                 DEFAULT SYSDATE               NOT NULL,
  ORDER_DT_NBR             NUMBER,
  ORDER_MIN_NBR            NUMBER,
  ORDER_PRSNL_ID           NUMBER               DEFAULT 0                     NOT NULL,
  ORDER_LOC_FAC_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ORDER_LOC_BLD_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ORDER_LOC_NU_CD          NUMBER               DEFAULT 0                     NOT NULL,
  STARTED_IND              NUMBER,
  START_DT_TM              DATE,
  START_DT_NBR             NUMBER,
  START_MIN_NBR            NUMBER,
  START_PRSNL_ID           NUMBER               DEFAULT 0                     NOT NULL,
  START_LOC_FAC_CD         NUMBER               DEFAULT 0                     NOT NULL,
  START_LOC_BLD_CD         NUMBER               DEFAULT 0                     NOT NULL,
  START_LOC_NU_CD          NUMBER               DEFAULT 0                     NOT NULL,
  COMPLETE_IND             NUMBER,
  DISCONTINUED_IND         NUMBER,
  DISCONTINUED_DT_TM       DATE,
  DISCONTINUED_DT_NBR      NUMBER,
  DISCONTINUED_MIN_NBR     NUMBER,
  DC_PRSNL_ID              NUMBER               DEFAULT 0                     NOT NULL,
  DC_LOC_FAC_CD            NUMBER               DEFAULT 0                     NOT NULL,
  DC_LOC_BLD_CD            NUMBER               DEFAULT 0                     NOT NULL,
  DC_LOC_NU_CD             NUMBER               DEFAULT 0                     NOT NULL,
  DC_REASON_CD             NUMBER               DEFAULT 0                     NOT NULL,
  DC_TEXT_ID               NUMBER               DEFAULT 0                     NOT NULL,
  PW_DURATION_MIN_NBR      NUMBER,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  PW_PHASE_DESC            VARCHAR2(200 BYTE),
  TYPE_MEAN                VARCHAR2(12 BYTE),
  DURATION_QTY             NUMBER,
  DURATION_UNIT_CD         NUMBER               DEFAULT 0                     NOT NULL,
  PW_GROUP_NBR             FLOAT(126)           DEFAULT 0                     NOT NULL,
  PW_CAT_GROUP_ID          NUMBER               DEFAULT 0                     NOT NULL,
  PW_GROUP_DESC            VARCHAR2(100 BYTE),
  TF_DESC                  VARCHAR2(100 BYTE),
  ACT_TIME_FRAME_ID        NUMBER               DEFAULT 0                     NOT NULL,
  CALC_END_DT_TM           DATE,
  CALC_END_MIN_NBR         NUMBER,
  ACTUAL_DURATION_MIN_NBR  NUMBER,
  DURATION_DELTA_MIN_NBR   NUMBER,
  CALC_END_DT_NBR          NUMBER,
  PATHWAY_TYPE_CD          NUMBER               DEFAULT 0                     NOT NULL,
  PATHWAY_CLASS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  REF_OWNER_PERSON_ID      NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CN_PW_FOCUS_ST
(
  FOCUS_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  PATHWAY_ID          NUMBER                    DEFAULT 0                     NOT NULL,
  PATHWAY_LEVEL_IND   NUMBER                    DEFAULT 0                     NOT NULL,
  DESCRIPTION         VARCHAR2(255 BYTE)        DEFAULT ' '                   NOT NULL,
  SEQUENCE            NUMBER                    DEFAULT 0                     NOT NULL,
  STATUS_CD           NUMBER                    DEFAULT 0                     NOT NULL,
  STATUS_DT_TM        DATE                      DEFAULT SYSDATE               NOT NULL,
  STATUS_DT_NBR       NUMBER                    DEFAULT 0                     NOT NULL,
  STATUS_MIN_NBR      NUMBER                    DEFAULT 0                     NOT NULL,
  STATUS_PRSNL_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  POTENTIAL_DT_TM     DATE,
  POTENTIAL_DT_NBR    NUMBER,
  POTENTIAL_MIN_NBR   NUMBER,
  POTENTIAL_CNT       NUMBER                    DEFAULT 0                     NOT NULL,
  POTENTIAL_PRSNL_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  PRESENT_DT_TM       DATE,
  PRESENT_DT_NBR      NUMBER,
  PRESENT_MIN_NBR     NUMBER,
  PRESENT_CNT         NUMBER                    DEFAULT 0                     NOT NULL,
  PRESENT_PRSNL_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  RESOLVED_DT_TM      DATE,
  RESOLVED_DT_NBR     NUMBER,
  RESOLVED_MIN_NBR    NUMBER,
  RESOLVED_CNT        NUMBER                    DEFAULT 0                     NOT NULL,
  RESOLVED_PRSNL_ID   NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CN_PW_ORDER_ST
(
  PW_ORD_COMP_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  PATHWAY_COMP_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  ORD_COMP_DESCRIPTION  VARCHAR2(100 BYTE)      DEFAULT ' '                   NOT NULL,
  PW_ORD_COMP_IND       NUMBER                  DEFAULT 0                     NOT NULL,
  PATHWAY_ID            NUMBER                  DEFAULT 0                     NOT NULL,
  PATHWAY_CATALOG_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  VERSION               NUMBER                  DEFAULT 0                     NOT NULL,
  PW_DESCRIPTION        VARCHAR2(100 BYTE)      DEFAULT ' '                   NOT NULL,
  ACT_TIME_FRAME_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  TIME_FRAME_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  TF_DESCRIPTION        VARCHAR2(100 BYTE)      DEFAULT ' '                   NOT NULL,
  ACT_CARE_CAT_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  CARE_CATEGORY_ID      NUMBER                  DEFAULT 0                     NOT NULL,
  CC_DESCRIPTION        VARCHAR2(100 BYTE)      DEFAULT ' '                   NOT NULL,
  FOCUS_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  F_DESCRIPTION         VARCHAR2(255 BYTE)      DEFAULT ' '                   NOT NULL,
  ENCNTR_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  PERSON_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  ORDER_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  ORDER_CATALOG_CD      NUMBER                  DEFAULT 0                     NOT NULL,
  ORDER_SYNONYM_ID      NUMBER                  DEFAULT 0                     NOT NULL,
  ORDER_SEQUENCE        NUMBER                  DEFAULT 0                     NOT NULL,
  STATUS_CD             NUMBER                  DEFAULT 0                     NOT NULL,
  STATUS_DT_TM          DATE                    DEFAULT SYSDATE               NOT NULL,
  STATUS_DT_NBR         NUMBER                  DEFAULT 0                     NOT NULL,
  STATUS_MIN_NBR        NUMBER                  DEFAULT 0                     NOT NULL,
  STATUS_PRSNL_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  INCLUDED_IND          NUMBER                  DEFAULT 0                     NOT NULL,
  INCLUDED_DT_TM        DATE,
  INCLUDED_DT_NBR       NUMBER,
  INCLUDED_MIN_NBR      NUMBER,
  INCLUDED_PRSNL_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  EXCLUDED_IND          NUMBER                  DEFAULT 0                     NOT NULL,
  EXCLUDED_DT_TM        DATE,
  EXCLUDED_DT_NBR       NUMBER,
  EXCLUDED_MIN_NBR      NUMBER,
  EXCLUDED_PRSNL_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  CANCELED_IND          NUMBER                  DEFAULT 0                     NOT NULL,
  CANCELED_DT_TM        DATE,
  CANCELED_DT_NBR       NUMBER,
  CANCELED_MIN_NBR      NUMBER,
  CANCELED_PRSNL_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  ACTIVATED_IND         NUMBER                  DEFAULT 0                     NOT NULL,
  ACTIVATED_DT_TM       DATE,
  ACTIVATED_DT_NBR      NUMBER,
  ACTIVATED_MIN_NBR     NUMBER,
  ACTIVATED_PRSNL_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  REQUIRED_IND          NUMBER                  DEFAULT 0                     NOT NULL,
  COND_IND              NUMBER                  DEFAULT 0                     NOT NULL,
  COND_EVAL_IND         NUMBER                  DEFAULT 0                     NOT NULL,
  COND_SYS_EVAL_IND     NUMBER                  DEFAULT 0                     NOT NULL,
  COND_EVAL_PRSNL_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  COND_FALSE_IND        NUMBER                  DEFAULT 0                     NOT NULL,
  COND_EVAL_DT_TM       DATE,
  COND_EVAL_DT_NBR      NUMBER,
  COND_EVAL_MIN_NBR     NUMBER,
  ADDED_IND             NUMBER                  DEFAULT 0                     NOT NULL,
  REMOVED_IND           NUMBER                  DEFAULT 0                     NOT NULL,
  DEFAULT_INCL_IND      NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  PW_PHASE_DESC         VARCHAR2(200 BYTE),
  TYPE_MEAN             VARCHAR2(12 BYTE),
  PW_GROUP_NBR          FLOAT(126)              DEFAULT 0                     NOT NULL,
  PW_CAT_GROUP_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  PW_GROUP_DESC         VARCHAR2(100 BYTE),
  CATEGORY_DISPLAY      VARCHAR2(100 BYTE),
  CATEGORY_CD           NUMBER                  DEFAULT 0                     NOT NULL,
  SUB_CATEGORY_DISPLAY  VARCHAR2(100 BYTE),
  SUB_CATEGORY_CD       NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CN_PW_OUTCOME_ST
(
  PW_OUT_COMP_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  PATHWAY_COMP_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  OUT_COMP_DESCRIPTION  VARCHAR2(310 BYTE)      DEFAULT ' '                   NOT NULL,
  PW_OUT_COMP_IND       NUMBER                  DEFAULT 0                     NOT NULL,
  PATHWAY_ID            NUMBER                  DEFAULT 0                     NOT NULL,
  PATHWAY_CATALOG_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  VERSION               NUMBER                  DEFAULT 0                     NOT NULL,
  PW_DESCRIPTION        VARCHAR2(100 BYTE)      DEFAULT ' '                   NOT NULL,
  ACT_TIME_FRAME_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  TIME_FRAME_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  TF_DESCRIPTION        VARCHAR2(100 BYTE)      DEFAULT ' '                   NOT NULL,
  ACT_CARE_CAT_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  CARE_CATEGORY_ID      NUMBER                  DEFAULT 0                     NOT NULL,
  CC_DESCRIPTION        VARCHAR2(100 BYTE)      DEFAULT ' '                   NOT NULL,
  FOCUS_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  F_DESCRIPTION         VARCHAR2(255 BYTE)      DEFAULT ' '                   NOT NULL,
  ENCNTR_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  PERSON_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  EVENT_CD              NUMBER                  DEFAULT 0                     NOT NULL,
  STATUS_CD             NUMBER                  DEFAULT 0                     NOT NULL,
  STATUS_DT_TM          DATE                    DEFAULT SYSDATE               NOT NULL,
  STATUS_DT_NBR         NUMBER                  DEFAULT 0                     NOT NULL,
  STATUS_MIN_NBR        NUMBER                  DEFAULT 0                     NOT NULL,
  STATUS_PRSNL_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  INCLUDED_IND          NUMBER                  DEFAULT 0                     NOT NULL,
  INCLUDED_DT_TM        DATE,
  INCLUDED_DT_NBR       NUMBER,
  INCLUDED_MIN_NBR      NUMBER,
  INCLUDED_PRSNL_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  EXCLUDED_IND          NUMBER                  DEFAULT 0                     NOT NULL,
  EXCLUDED_DT_TM        DATE,
  EXCLUDED_DT_NBR       NUMBER,
  EXCLUDED_MIN_NBR      NUMBER,
  EXCLUDED_PRSNL_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  CANCELED_IND          NUMBER                  DEFAULT 0                     NOT NULL,
  CANCELED_DT_TM        DATE,
  CANCELED_DT_NBR       NUMBER,
  CANCELED_MIN_NBR      NUMBER,
  CANCELED_PRSNL_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  ACTIVATED_IND         NUMBER                  DEFAULT 0                     NOT NULL,
  ACTIVATED_DT_TM       DATE,
  ACTIVATED_DT_NBR      NUMBER,
  ACTIVATED_MIN_NBR     NUMBER,
  ACTIVATED_PRSNL_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  REQUIRED_IND          NUMBER                  DEFAULT 0                     NOT NULL,
  START_DT_TM           DATE,
  START_DT_NBR          NUMBER,
  START_MIN_NBR         NUMBER,
  END_DT_TM             DATE,
  END_DT_NBR            NUMBER,
  END_MIN_NBR           NUMBER,
  COND_IND              NUMBER                  DEFAULT 0                     NOT NULL,
  COND_EVAL_IND         NUMBER                  DEFAULT 0                     NOT NULL,
  COND_SYS_EVAL_IND     NUMBER                  DEFAULT 0                     NOT NULL,
  COND_EVAL_PRSNL_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  COND_FALSE_IND        NUMBER                  DEFAULT 0                     NOT NULL,
  COND_EVAL_DT_TM       DATE,
  COND_EVAL_DT_NBR      NUMBER,
  COND_EVAL_MIN_NBR     NUMBER,
  ADDED_IND             NUMBER                  DEFAULT 0                     NOT NULL,
  REMOVED_IND           NUMBER                  DEFAULT 0                     NOT NULL,
  DEFAULT_INCL_IND      NUMBER                  DEFAULT 0                     NOT NULL,
  LAST_MET_IND          NUMBER                  DEFAULT 0                     NOT NULL,
  LAST_NOT_MET_IND      NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  PW_PHASE_DESC         VARCHAR2(200 BYTE),
  TYPE_MEAN             VARCHAR2(12 BYTE),
  PW_GROUP_NBR          FLOAT(126)              DEFAULT 0                     NOT NULL,
  PW_CAT_GROUP_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  PW_GROUP_DESC         VARCHAR2(100 BYTE),
  CATEGORY_DISPLAY      VARCHAR2(100 BYTE),
  CATEGORY_CD           NUMBER                  DEFAULT 0                     NOT NULL,
  SUB_CATEGORY_DISPLAY  VARCHAR2(100 BYTE),
  SUB_CATEGORY_CD       NUMBER                  DEFAULT 0                     NOT NULL,
  OUTCOME_ACTIVITY_ID   NUMBER                  DEFAULT 0                     NOT NULL,
  OUTCOME_CATALOG_ID    NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CN_PW_VARIANCE_ST
(
  PW_VARIANCE_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  PATHWAY_ID            NUMBER                  DEFAULT 0                     NOT NULL,
  PATHWAY_CATALOG_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  VERSION               NUMBER                  DEFAULT 0                     NOT NULL,
  PW_DESCRIPTION        VARCHAR2(100 BYTE)      DEFAULT ' '                   NOT NULL,
  PW_ORD_COMP_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  ORD_COMP_REF_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  ORD_COMP_DESCRIPTION  VARCHAR2(100 BYTE),
  ACT_TIME_FRAME_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  TIME_FRAME_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  TF_DESCRIPTION        VARCHAR2(100 BYTE),
  ACT_CARE_CAT_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  CARE_CATEGORY_ID      NUMBER                  DEFAULT 0                     NOT NULL,
  CC_DESCRIPTION        VARCHAR2(100 BYTE),
  PW_OUTCOME_COMP_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  OUT_COMP_REF_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  OUT_COMP_DESCRIPTION  VARCHAR2(100 BYTE),
  VARIANCE_TYPE_CD      NUMBER                  DEFAULT 0                     NOT NULL,
  VARIANCE_DT_TM        DATE                    DEFAULT SYSDATE               NOT NULL,
  VARIANCE_DT_NBR       NUMBER                  DEFAULT 0                     NOT NULL,
  VARIANCE_MIN_NBR      NUMBER                  DEFAULT 0                     NOT NULL,
  VARIANCE_IND          NUMBER                  DEFAULT 0                     NOT NULL,
  REASON_CD             NUMBER                  DEFAULT 0                     NOT NULL,
  REASON_TEXT_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  ACTION_CD             NUMBER                  DEFAULT 0                     NOT NULL,
  ACTION_TEXT_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  VARIANCE_PRSNL_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CODE_VALUE_LOG_DOMAIN_R
(
  CODE_VALUE_LOG_DOMAIN_R_ID  NUMBER            DEFAULT 0                     NOT NULL,
  CODE_VALUE                  NUMBER            DEFAULT 0                     NOT NULL,
  LOGICAL_DOMAIN_ID           NUMBER            DEFAULT 0                     NOT NULL,
  DISPLAY                     VARCHAR2(40 BYTE),
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CODING
(
  CODING_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  LENGTH_OF_STAY          NUMBER,
  BIRTH_WEIGHT            NUMBER,
  ASCPAY                  NUMBER,
  COMPLETED_DT_TM         DATE,
  CREATE_DT_TM            DATE,
  CREATE_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  MERGED_ENCNTR_ID        NUMBER                DEFAULT 0                     NOT NULL,
  SVC_CAT_HIST_ID         NUMBER                DEFAULT 0                     NOT NULL,
  CODING_DT_TM            DATE,
  CODING_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  CANCER_CODE_CNT         NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_ID                NUMBER                DEFAULT 0,
  ENCNTR_SLICE_ID         NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CODING_AUDIT
(
  CODING_AUDIT_ID          NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  SVC_CAT_HIST_ID          NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_ID          NUMBER               DEFAULT 0                     NOT NULL,
  CODING_PRSNL_ID          NUMBER               DEFAULT 0                     NOT NULL,
  AUDIT_PRSNL_ID           NUMBER               DEFAULT 0                     NOT NULL,
  CODING_AUDIT_TRIGGER_ID  NUMBER               DEFAULT 0                     NOT NULL,
  TASK_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  OUTCOME_CD               NUMBER               DEFAULT 0                     NOT NULL,
  EXTERNAL_AUDIT_MSG       VARCHAR2(500 BYTE)   DEFAULT ' '                   NOT NULL,
  ACTIVE_IND               NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE,
  END_EFFECTIVE_DT_TM      DATE,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CODING_FLEX_SUMMARY
(
  CODING_FLEX_SUMMARY_ID   NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  FINANCIAL_CLASS_CD       NUMBER               DEFAULT 0                     NOT NULL,
  CODING_REPORT_NAME       VARCHAR2(255 BYTE),
  BEG_EFFECTIVE_DT_TM      DATE,
  END_EFFECTIVE_DT_TM      DATE,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  DEFNCY_REPORT_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ELECTRONIC_DOC_IND       NUMBER,
  GROUP_PRINCIPLE_TYPE_CD  NUMBER               DEFAULT 0                     NOT NULL,
  REQUEST_SIGN_IND         NUMBER,
  ORGANIZATION_ID          NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CODING_HIST
(
  CODING_HIST_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  ENCNTR_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  LENGTH_OF_STAY         NUMBER,
  BIRTH_WEIGHT           NUMBER,
  ASCPAY                 NUMBER,
  COMPLETED_DT_TM        DATE,
  CREATE_DT_TM           DATE,
  CREATE_PRSNL_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM    DATE,
  END_EFFECTIVE_DT_TM    DATE,
  MERGED_ENCNTR_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  SVC_CAT_HIST_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  CODING_DT_TM           DATE,
  CODING_PRSNL_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  CANCER_CODE_CNT        NUMBER                 DEFAULT 0                     NOT NULL,
  EVENT_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  ACTIVE_IND             NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE COLLECTION_LETTER
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  COLLECTION_GEN_DT_TM    DATE,
  COLLECTION_LETTER_ID    NUMBER                DEFAULT 0                     NOT NULL,
  DUNNING_LEVEL_CD        NUMBER                DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM     DATE,
  LETTER_LINE1            VARCHAR2(80 BYTE),
  LETTER_LINE10           VARCHAR2(80 BYTE),
  LETTER_LINE11           VARCHAR2(80 BYTE),
  LETTER_LINE12           VARCHAR2(80 BYTE),
  LETTER_LINE13           VARCHAR2(80 BYTE),
  LETTER_LINE14           VARCHAR2(80 BYTE),
  LETTER_LINE15           VARCHAR2(80 BYTE),
  LETTER_LINE2            VARCHAR2(80 BYTE),
  LETTER_LINE3            VARCHAR2(80 BYTE),
  LETTER_LINE4            VARCHAR2(80 BYTE),
  LETTER_LINE5            VARCHAR2(80 BYTE),
  LETTER_LINE6            VARCHAR2(80 BYTE),
  LETTER_LINE7            VARCHAR2(80 BYTE),
  LETTER_LINE8            VARCHAR2(80 BYTE),
  LETTER_LINE9            VARCHAR2(80 BYTE),
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE COMMITTEE
(
  COMMITTEE_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  SPONSORING_ORG_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  COMMITTEE_NAME       VARCHAR2(255 BYTE)       DEFAULT ' '                   NOT NULL,
  EMAIL_ADDRESS        VARCHAR2(255 BYTE),
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  COMMITTEE_TYPE_CD    NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE COMMITTEE_MEMBER
(
  COMMITTEE_MEMBER_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  COMMITTEE_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  ROLE_CD              NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE COMPLETION_HOLD
(
  COMPLETION_HOLD_ID      NUMBER                DEFAULT 0                     NOT NULL,
  HOLD_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_ID                NUMBER                DEFAULT 0                     NOT NULL,
  PROVIDER_ID             NUMBER                DEFAULT 0                     NOT NULL,
  REQUEST_ID              NUMBER                DEFAULT 0                     NOT NULL,
  HOLD_START_DT_TM        DATE,
  HOLD_STOP_DT_TM         DATE,
  HOLD_REASON_CD          NUMBER                DEFAULT 0                     NOT NULL,
  MEDIA_MASTER_ID         NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE COMPONENT
(
  OPTION_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_CD              NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE COMP_FILTER_GROUP
(
  COMP_FILTER_GROUP_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  PERSON_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  FILTER_NAME           VARCHAR2(100 BYTE)      DEFAULT ' '                   NOT NULL,
  COMPONENT_CD          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE COMP_FILTER_GROUP_ITEM
(
  COMP_FILTER_GROUP_ITEM_ID  NUMBER             DEFAULT 0                     NOT NULL,
  COMP_FILTER_GROUP_ID       NUMBER             DEFAULT 0                     NOT NULL,
  COMPONENT_FILTER_TYPE_CD   NUMBER             DEFAULT 0                     NOT NULL,
  FILTER_ITEM_VALUE_TXT      VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CONCEPT_IDENTIFIER_DTA
(
  CONCEPT_IDENTIFIER_DTA_ID  NUMBER             DEFAULT 0                     NOT NULL,
  CONCEPT_CKI                VARCHAR2(255 BYTE),
  TASK_ASSAY_CD              NUMBER             DEFAULT 0                     NOT NULL,
  SPECIMEN_TYPE_CD           NUMBER             DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD        NUMBER             DEFAULT 0                     NOT NULL,
  CONCEPT_TYPE_FLAG          NUMBER             DEFAULT 0                     NOT NULL,
  IGNORE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM        DATE               DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID     NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CONCEPT_PRSNL_CROSSMAP
(
  CONCEPT_PRSNL_CROSSMAP_ID  NUMBER             DEFAULT 0                     NOT NULL,
  PRSNL_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  MAP_TYPE_MEAN              VARCHAR2(12 BYTE),
  MAP_SCOPE_MEAN             VARCHAR2(12 BYTE),
  SOURCE_CONCEPT_CKI         VARCHAR2(255 BYTE),
  SOURCE_NOMEN_ID            NUMBER             DEFAULT 0                     NOT NULL,
  SOURCE_VOCAB_CD            NUMBER             DEFAULT 0                     NOT NULL,
  TARGET_CONCEPT_CKI         VARCHAR2(255 BYTE),
  TARGET_NOMEN_ID            NUMBER             DEFAULT 0                     NOT NULL,
  TARGET_VOCAB_CD            NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  PERSON_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM        DATE,
  END_EFFECTIVE_DT_TM        DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CONS_BO_SCHED
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  CONS_BO_SCHED_ID        NUMBER                DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM     DATE,
  NEXT_BILL_DT_TM         DATE,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  LAST_BILL_DT_TM         DATE,
  PROC_IND                NUMBER,
  STATEMENT_CYCLE_ID      NUMBER                DEFAULT 0                     NOT NULL,
  GUARANTOR_ACCESS_CODE   VARCHAR2(250 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CONTACT_TEXT
(
  CONTACT_TEXT_ID         NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  CONTACT_TYPE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  CONTACT_TEXT            VARCHAR2(250 BYTE)    DEFAULT ' '                   NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CONTAINER
(
  CONTAINER_ID               NUMBER             DEFAULT 0                     NOT NULL,
  PARENT_CONTAINER_ID        NUMBER             DEFAULT 0                     NOT NULL,
  ADDITIONAL_LABELS          NUMBER,
  LABEL_DT_TM                DATE,
  SPECIMEN_ID                NUMBER             DEFAULT 0                     NOT NULL,
  STORAGE_RACK_CELL_ID       NUMBER             DEFAULT 0                     NOT NULL,
  COLLECTION_LIST_ID         NUMBER             DEFAULT 0                     NOT NULL,
  TRANSFER_LIST_ID           NUMBER             DEFAULT 0                     NOT NULL,
  SPECIMEN_TYPE_CD           NUMBER             DEFAULT 0                     NOT NULL,
  SPEC_CNTNR_CD              NUMBER             DEFAULT 0                     NOT NULL,
  COLL_CLASS_CD              NUMBER             DEFAULT 0                     NOT NULL,
  SPEC_HNDL_CD               NUMBER             DEFAULT 0                     NOT NULL,
  CURRENT_LOCATION_CD        NUMBER             DEFAULT 0                     NOT NULL,
  REMAINING_VOLUME           FLOAT(126),
  VOLUME                     FLOAT(126),
  VOLUME_UNIT                CHAR(15 BYTE),
  DRAWN_DT_TM                DATE,
  DRAWN_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  FIXATIVE_CD                NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  RECEIVED_DT_TM             DATE,
  RECEIVED_ID                NUMBER             DEFAULT 0                     NOT NULL,
  COLLECTION_METHOD_CD       NUMBER             DEFAULT 0                     NOT NULL,
  UNITS_CD                   NUMBER             DEFAULT 0                     NOT NULL,
  ORIGINAL_STORAGE_DT_TM     DATE,
  SUGGESTED_DISCARD_DT_TM    DATE,
  DISCARD_DT_TM              DATE,
  TASK_LOG_ID                NUMBER             DEFAULT 0                     NOT NULL,
  COLL_COMMENT_ID            NUMBER             DEFAULT 0                     NOT NULL,
  ON_ROBOTICS_LINE_FLAG      NUMBER             DEFAULT 0                     NOT NULL,
  INSTR_LOGIN_IND            NUMBER,
  AUTO_PRINT_ALIQUOT_IND     NUMBER,
  STORAGE_STATUS_CD          NUMBER             DEFAULT 0                     NOT NULL,
  DISCARD_REASON_CD          NUMBER             DEFAULT 0,
  COLLECTION_TASK_ELIG_FLAG  NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CONTAINER_EVENT
(
  CONTAINER_ID               NUMBER             DEFAULT 0                     NOT NULL,
  EVENT_SEQUENCE             NUMBER             DEFAULT 0                     NOT NULL,
  EVENT_TYPE_CD              NUMBER             DEFAULT 0                     NOT NULL,
  SPECIMEN_TYPE_CD           NUMBER             DEFAULT 0                     NOT NULL,
  SPEC_CNTNTR_CD             NUMBER             DEFAULT 0                     NOT NULL,
  COLL_CLASS_CD              NUMBER             DEFAULT 0                     NOT NULL,
  SPEC_HNDL_CD               NUMBER             DEFAULT 0                     NOT NULL,
  CURRENT_LOCATION_CD        NUMBER             DEFAULT 0                     NOT NULL,
  REMAINING_VOLUME           NUMBER,
  VOLUME                     NUMBER,
  VOLUME_UNITS               CHAR(15 BYTE),
  DRAWN_DT_TM                DATE,
  DRAWN_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  LABEL_DT_TM                DATE,
  COLLECTION_LIST_ID         NUMBER             DEFAULT 0                     NOT NULL,
  RECEIVED_DT_TM             DATE,
  RECEIVED_ID                NUMBER             DEFAULT 0                     NOT NULL,
  FIXATIVE_CD                NUMBER             DEFAULT 0                     NOT NULL,
  ADDITIONAL_LABELS          NUMBER,
  PARENT_CONTAINER_ID        NUMBER             DEFAULT 0                     NOT NULL,
  COLLECTION_METHOD_CD       NUMBER             DEFAULT 0                     NOT NULL,
  SPECIMEN_ID                NUMBER             DEFAULT 0                     NOT NULL,
  STORAGE_RACK_CELL_ID       NUMBER             DEFAULT 0                     NOT NULL,
  TRANSFER_LIST_ID           NUMBER             DEFAULT 0                     NOT NULL,
  UNITS_CD                   NUMBER             DEFAULT 0                     NOT NULL,
  TASK_LOG_ID                NUMBER             DEFAULT 0                     NOT NULL,
  ORIGINAL_STORAGE_DT_TM     DATE,
  SUGGESTED_DISCARD_DT_TM    DATE,
  DISCARD_DT_TM              DATE,
  REASON_MISSED_CD           NUMBER             DEFAULT 0                     NOT NULL,
  REASON_MISSED_ID           NUMBER             DEFAULT 0                     NOT NULL,
  REASON_MISSED_DT_TM        DATE,
  COLL_COMMENT_ID            NUMBER             DEFAULT 0                     NOT NULL,
  REMAINING_VOLUME_NBR       FLOAT(126)         DEFAULT 0                     NOT NULL,
  VOLUME_NBR                 FLOAT(126)         DEFAULT 0                     NOT NULL,
  DISCARD_REASON_CD          NUMBER             DEFAULT 0,
  CONVERSATION_ID            NUMBER             DEFAULT 0                     NOT NULL,
  PROCESSING_FLAG            NUMBER             DEFAULT 0                     NOT NULL,
  COLLECTION_TASK_ELIG_FLAG  NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CONTAINER_ORG_R
(
  CONTAINER_ORG_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  CONTAINER_TYPE_CD       NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  INVENTORY_AREA_CD       NUMBER                DEFAULT 0                     NOT NULL,
  OWNER_AREA_CD           NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CONTRACT_PROPERTY
(
  CONTRACT_PROPERTY_ID        NUMBER            DEFAULT 0                     NOT NULL,
  CPA_IDENT                   VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  ACTION_NAME                 VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  ACTION_VERSION_TXT          VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  AUTHENTICATION_FLAG         NUMBER            DEFAULT 0                     NOT NULL,
  SERVICE_NAME                VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  PERSIST_DURATION_NBR        NUMBER            DEFAULT 0                     NOT NULL,
  RETRIES_NBR                 NUMBER            DEFAULT 0                     NOT NULL,
  RETRY_INTERVAL_NBR          NUMBER            DEFAULT 0                     NOT NULL,
  SYNC_REPLY_MODE_FLAG        NUMBER            DEFAULT 0                     NOT NULL,
  ACK_REQUESTED_FLAG          NUMBER            DEFAULT 0                     NOT NULL,
  DUPLICATE_ELIMINATION_IND   NUMBER            DEFAULT 0                     NOT NULL,
  ACK_ACTOR1_NAME             VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  ACK_ACTOR2_NAME             VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  SEND_URL                    VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  SLA_IND                     NUMBER            DEFAULT 0                     NOT NULL,
  SCHEMA_LOCATION_TXT         VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE              DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM         DATE              DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM         DATE              DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER            DEFAULT 0                     NOT NULL,
  TIMEOUT_NBR                 NUMBER            DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID             NUMBER            DEFAULT 0                     NOT NULL,
  PARTY_KEY_TXT               VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  DUPLICATE_ELIMINATION_FLAG  NUMBER            DEFAULT 0,
  PAYLOAD_VER_TXT             VARCHAR2(250 BYTE),
  PAYLOAD_ENCODING_TXT        VARCHAR2(250 BYTE),
  PAYLOAD_STYLE_TXT           VARCHAR2(250 BYTE),
  XLINK_HREF_TXT              VARCHAR2(250 BYTE),
  TO_PARTYID_TXT              VARCHAR2(250 BYTE),
  FROM_PARTYID_TXT            VARCHAR2(250 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CONTRIBUTING_DEPT
(
  CONTRIBUTING_DEPT_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  PROT_MASTER_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM   DATE                    DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM   DATE                    DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  DEPT_CD               NUMBER                  DEFAULT 0                     NOT NULL,
  DEPT_DESC             VARCHAR2(255 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CONTRIBUTOR_SYSTEM
(
  CONTRIBUTOR_SYSTEM_CD      NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_IND                 NUMBER,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM        DATE,
  ACTIVE_STATUS_PRSNL_ID     NUMBER             DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM        DATE               DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ORGANIZATION_ID            NUMBER             DEFAULT 0                     NOT NULL,
  LOC_FACILITY_CD            NUMBER             DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SOURCE_CD      NUMBER             DEFAULT 0                     NOT NULL,
  CONTR_SYS_TYPE_CD          NUMBER             DEFAULT 0                     NOT NULL,
  ACT_CONTRIBUTOR_SYSTEM_CD  NUMBER             DEFAULT 0                     NOT NULL,
  AUTO_COMBINE_IND           NUMBER,
  DISPLAY                    VARCHAR2(40 BYTE),
  ESI_ORG_ALIAS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  PRSNL_PERSON_ID            NUMBER             DEFAULT 0                     NOT NULL,
  SYS_DIRECTION_CD           NUMBER             DEFAULT 0                     NOT NULL,
  ALT_CONTRIB_SRC_CD         NUMBER             DEFAULT 0                     NOT NULL,
  RESULT_ALIAS_IND           NUMBER,
  EVENT_CLASS_SOURCE_FLAG    NUMBER,
  DOC_EVENT_CLASS_CD         NUMBER             DEFAULT 0                     NOT NULL,
  OPF_MATCH_THRESHOLD        VARCHAR2(3 BYTE),
  OPF_REPORT_THRESHOLD       VARCHAR2(3 BYTE),
  MICRO_LIST_REPLACE_FLAG    NUMBER             DEFAULT 0,
  MICRO_MULTI_INTERP_IND     NUMBER             DEFAULT 0,
  TIME_ZONE_FLAG             NUMBER             DEFAULT 0,
  TIME_ZONE                  VARCHAR2(100 BYTE),
  MESSAGE_FORMAT_CD          NUMBER             DEFAULT 0                     NOT NULL,
  GROUPER_HOLD_TIME          NUMBER             DEFAULT 0                     NOT NULL,
  MAX_GROUPER_ORDERS         NUMBER             DEFAULT 0                     NOT NULL,
  GROUPER_MULTI_ORDS_IND     NUMBER             DEFAULT 0                     NOT NULL,
  ESO_SPECIAL_SOURCE_FLAG    NUMBER             DEFAULT 0,
  ESI_SPECIAL_SOURCE_FLAG    NUMBER             DEFAULT 0,
  AOF_ENABLED_IND            NUMBER             DEFAULT 0,
  ESI_LOG_BITMAP             NUMBER             DEFAULT 0,
  LISTENER_ALIAS             VARCHAR2(48 BYTE)  DEFAULT ' ',
  AUTHORIZATION_TYPE_CD      NUMBER             DEFAULT 0,
  AUTHORIZATION_URL          VARCHAR2(255 BYTE) DEFAULT ' ',
  ENHANCED_PROCESSING_CD     NUMBER             DEFAULT 0,
  IO_RESULT_IND              NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CONVERT_AUDIT_BEST_MATCH
(
  CONVERT_AUDIT_BEST_MATCH_ID  NUMBER           DEFAULT 0                     NOT NULL,
  CONVERT_AUDIT_SYNONYM_ID     NUMBER           DEFAULT 0                     NOT NULL,
  SYNONYM_ID                   NUMBER           DEFAULT 0                     NOT NULL,
  FORM_CD                      NUMBER           DEFAULT 0                     NOT NULL,
  PER_UNIT_STRENGTH            VARCHAR2(255 BYTE),
  PER_UNIT_STRENGTH_UNIT_CKI   VARCHAR2(255 BYTE),
  TOTAL_VOLUME_DOSE            VARCHAR2(255 BYTE),
  TOTAL_VOLUME_DOSE_UNIT_CKI   VARCHAR2(255 BYTE),
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CONVERT_AUDIT_SYNONYM
(
  CONVERT_AUDIT_SYNONYM_ID      NUMBER          DEFAULT 0                     NOT NULL,
  CONVERT_AUDIT_TRANSACTION_ID  NUMBER          DEFAULT 0                     NOT NULL,
  SYNONYM_ID                    NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_ID                      NUMBER          DEFAULT 0                     NOT NULL,
  SUPPLIED_FORM_CD              NUMBER          DEFAULT 0                     NOT NULL,
  INFERRED_FORM_CD              NUMBER          DEFAULT 0                     NOT NULL,
  ROUTE_CD                      NUMBER          DEFAULT 0                     NOT NULL,
  TOTAL_STRENGTH_DOSE           VARCHAR2(255 BYTE),
  TOTAL_STRENGTH_DOSE_UNIT_CKI  VARCHAR2(255 BYTE),
  TOTAL_VOLUME_DOSE             VARCHAR2(255 BYTE),
  TOTAL_VOLUME_DOSE_UNIT_CKI    VARCHAR2(255 BYTE),
  FREETEXT_DOSE_IND             NUMBER          DEFAULT 0                     NOT NULL,
  DOSE_VALIDATION_ERROR_IND     NUMBER          DEFAULT 0                     NOT NULL,
  FORM_VALIDATION_ERROR_IND     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CONVERT_AUDIT_TRANSACTION
(
  CONVERT_AUDIT_TRANSACTION_ID  NUMBER          DEFAULT 0                     NOT NULL,
  PRSNL_ID                      NUMBER          DEFAULT 0                     NOT NULL,
  PPR_CD                        NUMBER          DEFAULT 0                     NOT NULL,
  FACILITY_CD                   NUMBER          DEFAULT 0                     NOT NULL,
  VENUE_FLAG                    NUMBER          DEFAULT 1                     NOT NULL,
  PHARMACY_TYPE_BIT             NUMBER          DEFAULT 0                     NOT NULL,
  RETRIEVE_NO_RX_MASK_IND       NUMBER          DEFAULT 0                     NOT NULL,
  RETRIEVE_PRODUCTS_ONLY_IND    NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE COOP_HP_RELTN
(
  COOP_HP_RELTN_ID        NUMBER                DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  SEC_HEALTH_PLAN_ID      NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CORRECTED_PRODUCT
(
  CORRECTION_ID                NUMBER           DEFAULT 0                     NOT NULL,
  PRODUCT_ID                   NUMBER           DEFAULT 0                     NOT NULL,
  CORRECTION_TYPE_CD           NUMBER           DEFAULT 0                     NOT NULL,
  CORRECTION_REASON_CD         NUMBER           DEFAULT 0                     NOT NULL,
  PRODUCT_NBR                  VARCHAR2(20 BYTE),
  PRODUCT_SUB_NBR              CHAR(5 BYTE),
  ALTERNATE_NBR                VARCHAR2(20 BYTE),
  PRODUCT_CD                   NUMBER           DEFAULT 0                     NOT NULL,
  PRODUCT_CAT_CD               NUMBER           DEFAULT 0                     NOT NULL,
  PRODUCT_CLASS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  SUPPLIER_ID                  NUMBER           DEFAULT 0                     NOT NULL,
  RECV_DT_TM                   DATE,
  VOLUME                       NUMBER,
  UNIT_MEAS_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  EXPIRE_DT_TM                 DATE,
  ABO_CD                       NUMBER           DEFAULT 0                     NOT NULL,
  RH_CD                        NUMBER           DEFAULT 0                     NOT NULL,
  SEGMENT_NBR                  VARCHAR2(25 BYTE),
  ORIG_UPDT_CNT                NUMBER,
  ORIG_UPDT_DT_TM              DATE,
  ORIG_UPDT_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  ORIG_UPDT_TASK               NUMBER,
  ORIG_UPDT_APPLCTX            NUMBER,
  CORRECTION_NOTE              VARCHAR2(255 BYTE),
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UNKNOWN_PATIENT_TEXT         VARCHAR2(50 BYTE),
  PRODUCT_EVENT_ID             NUMBER           DEFAULT 0                     NOT NULL,
  EVENT_DT_TM                  DATE,
  REASON_CD                    NUMBER           DEFAULT 0                     NOT NULL,
  AUTOCLAVE_IND                NUMBER,
  DESTRUCTION_METHOD_CD        NUMBER           DEFAULT 0                     NOT NULL,
  DESTRUCTION_ORG_ID           NUMBER           DEFAULT 0                     NOT NULL,
  MANIFEST_NBR                 VARCHAR2(50 BYTE),
  PERSON_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  EXPECTED_USAGE_DT_TM         DATE,
  POOLED_PRODUCT_ID            NUMBER           DEFAULT 0                     NOT NULL,
  CUR_OWNER_AREA_CD            NUMBER           DEFAULT 0                     NOT NULL,
  CUR_INV_AREA_CD              NUMBER           DEFAULT 0                     NOT NULL,
  CORRECTION_FLAG              NUMBER,
  RELATED_CORRECTION_ID        NUMBER           DEFAULT 0                     NOT NULL,
  SUPPLIER_PREFIX              CHAR(5 BYTE),
  BARCODE_NBR                  CHAR(20 BYTE),
  MANUFACTURER_ID              NUMBER           DEFAULT 0                     NOT NULL,
  CUR_AVAIL_QTY                NUMBER           DEFAULT 0,
  CUR_INTL_UNITS               NUMBER           DEFAULT 0,
  DRAWN_DT_TM                  DATE,
  SHIP_COND_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  VIS_INSP_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  FLAG_CHARS                   CHAR(2 BYTE),
  ORIG_LOT_NBR                 VARCHAR2(25 BYTE) DEFAULT ' ',
  DISEASE_CD                   NUMBER           DEFAULT 0,
  DONATION_TYPE_CD             NUMBER           DEFAULT 0,
  DONATED_BY_RELATIVE_IND      NUMBER,
  INTENDED_USE_PRINT_PARM_TXT  VARCHAR2(1 BYTE),
  PRODUCT_TYPE_BARCODE         VARCHAR2(15 BYTE),
  UNITS_PER_VIAL_CNT           NUMBER           DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CORRECTED_SPECIAL_TESTS
(
  CORRECT_SPEC_TESTS_ID    NUMBER               DEFAULT 0                     NOT NULL,
  CORRECTION_ID            NUMBER               DEFAULT 0                     NOT NULL,
  ORIG_SPECIAL_TESTING_ID  NUMBER               DEFAULT 0                     NOT NULL,
  SPECIAL_TESTING_CD       NUMBER               DEFAULT 0                     NOT NULL,
  NEW_SPEC_TEST_IND        NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CORSP_BR_RELTN
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVITY_ID             NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  BILL_REC_ID             NUMBER                DEFAULT 0                     NOT NULL,
  BILL_VRSN_NBR           NUMBER                DEFAULT 0                     NOT NULL,
  CORSP_BR_RELTN_ID       NUMBER                DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CORSP_KEYWORD_RELTN
(
  CORSP_KEYWORD_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVITY_ID             NUMBER                DEFAULT 0                     NOT NULL,
  KEYWORD_TXT             VARCHAR2(50 BYTE),
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CORSP_LOG
(
  ACTIVITY_ID             NUMBER                DEFAULT 0                     NOT NULL,
  CORSP_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  CORSP_SUB_TYPE_CD       NUMBER                DEFAULT 0                     NOT NULL,
  CORSP_SUBJECT           VARCHAR2(100 BYTE),
  CORSP_DESC              VARCHAR2(250 BYTE),
  STORAGE_TYPE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  STORAGE_LOC             VARCHAR2(100 BYTE),
  ACCT_IND                NUMBER,
  PERSON_IND              NUMBER,
  PRSNL_IND               NUMBER,
  ORGANIZATION_IND        NUMBER,
  HEALTH_PLAN_IND         NUMBER,
  ENCNTR_IND              NUMBER,
  ACTIVITY_IND            NUMBER,
  ACTIVE_IND              NUMBER,
  BILLING_ENTITY_IND      NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  CORSP_IND               NUMBER,
  CORSP_SUBJECT_KEY       VARCHAR2(250 BYTE),
  SESSION_IND             NUMBER,
  TRANS_IND               NUMBER,
  BATCH_IND               NUMBER,
  BILL_REC_IND            NUMBER,
  CREATED_DT_TM           DATE                  DEFAULT SYSDATE,
  CREATED_PRSNL_ID        NUMBER                DEFAULT 0                     NOT NULL,
  IMPORTANCE_FLAG         NUMBER,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  SUBMITTED_DT_TM         DATE,
  CORSP_STATUS_CD         NUMBER                DEFAULT 0,
  DELIVERED_DT_TM         DATE,
  EXTERNAL_IDENT          VARCHAR2(250 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CORSP_LOG_RELTN
(
  ACCT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVITY_ID             NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  BILL_VRSN_NBR           NUMBER,
  END_EFFECTIVE_DT_TM     DATE,
  KEYWORD_TXT             VARCHAR2(50 BYTE),
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(32 BYTE)     DEFAULT ' '                   NOT NULL,
  PFT_ENCNTR_ID           NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  CORSP_LOG_RELTN_ID      NUMBER                DEFAULT 0                     NOT NULL,
  RECIPIENT_TYPE_CD       NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE COST_CENTER_TRANS_ACCOUNT
(
  COST_CENTER_TRANS_ACCOUNT_ID  NUMBER          DEFAULT 0                     NOT NULL,
  LOCATION_CD                   NUMBER          DEFAULT 0                     NOT NULL,
  TRANS_TYPE_CD                 NUMBER          DEFAULT 0                     NOT NULL,
  TRANS_SUB_TYPE_CD             NUMBER          DEFAULT 0                     NOT NULL,
  TRANS_COST_CENTER_CD          NUMBER          DEFAULT 0                     NOT NULL,
  TRANS_SUB_ACCOUNT_CD          NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  LOGICAL_DOMAIN_ID             NUMBER          DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CREDENTIAL
(
  CREDENTIAL_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(30 BYTE),
  NOTIFY_TYPE_CD          NUMBER                DEFAULT 0                     NOT NULL,
  NOTIFY_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  DISPLAY_SEQ             NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT sysdate               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT sysdate               NOT NULL,
  CREDENTIAL_CD           NUMBER                DEFAULT 0                     NOT NULL,
  CREDENTIAL_TYPE_CD      NUMBER                DEFAULT 0                     NOT NULL,
  STATE_CD                NUMBER                DEFAULT 0                     NOT NULL,
  ID_NUMBER               VARCHAR2(50 BYTE),
  RENEWAL_DT_TM           DATE                  DEFAULT sysdate               NOT NULL,
  VALID_FOR_CD            NUMBER                DEFAULT 0                     NOT NULL,
  NOTIFIED_DT_TM          DATE,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT sysdate               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 1                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT sysdate               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CRIMINAL_CHARGES_DISP_R
(
  CRIMINAL_CHARGES_DISP_R_ID  NUMBER            DEFAULT 0                     NOT NULL,
  OUTSTANDING_CHARGES_R_ID    NUMBER            DEFAULT 0                     NOT NULL,
  COURT_DISPOSITION_CD        NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE              DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CRIMINAL_CHRGS_DISP_HIST
(
  CRIMINAL_CHRGS_DISP_HIST_ID  NUMBER           DEFAULT 0                     NOT NULL,
  CRIMINAL_CHARGES_DISP_R_ID   NUMBER           DEFAULT 0                     NOT NULL,
  COURT_DISPOSITION_CD         NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CRITIQUE_CODE_ASSIGNMENTS
(
  CRITIQUE_INFO_ID   NUMBER                     DEFAULT 0                     NOT NULL,
  CRITIQUE_TYPE_CD   NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  CRITIQUE_PRSNL_ID  NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CRITIQUE_PRSNL
(
  CRITIQUE_INFO_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  CRITIQUED_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  COMMENTS             VARCHAR2(255 BYTE),
  CRITIQUE_PRSNL_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  CRITIQUE_RELTN_FLAG  NUMBER,
  READ_IND             NUMBER                   DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CROSSMATCH
(
  PRODUCT_EVENT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CROSSMATCH_QTY          NUMBER,
  RELEASE_DT_TM           DATE,
  RELEASE_PRSNL_ID        NUMBER                DEFAULT 0                     NOT NULL,
  RELEASE_REASON_CD       NUMBER                DEFAULT 0                     NOT NULL,
  RELEASE_QTY             NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  CROSSMATCH_EXP_DT_TM    DATE,
  REINSTATE_REASON_CD     NUMBER                DEFAULT 0                     NOT NULL,
  BB_ID_NBR               VARCHAR2(20 BYTE),
  XM_REASON_CD            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CR_OUTPUT_DESTINATION
(
  CR_OUTPUT_DESTINATION_ID  NUMBER              DEFAULT 0                     NOT NULL,
  REPORT_REQUEST_ID         NUMBER              DEFAULT 0                     NOT NULL,
  OUTPUT_DEST_CD            NUMBER              DEFAULT 0                     NOT NULL,
  DMS_SERVICE_IDENT         VARCHAR2(110 BYTE),
  DMS_FAX_DISTRIBUTE_DT_TM  DATE,
  DMS_ADHOC_FAX_NUMBER_TXT  VARCHAR2(40 BYTE),
  DISK_LABEL                VARCHAR2(128 BYTE),
  COPIES_NBR                NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  DISTRIBUTED_STATUS_IND    NUMBER              DEFAULT 0                     NOT NULL,
  DISK_TYPE_FLAG            NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CR_PRINTED_SECTIONS
(
  PRINTED_SECTION_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  REPORT_REQUEST_ID   NUMBER                    DEFAULT 0                     NOT NULL,
  SECTION_ID          NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  CONTENT_TYPE_CD     NUMBER                    DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CR_REPORT_REQUEST
(
  REPORT_REQUEST_ID             NUMBER          DEFAULT 0                     NOT NULL,
  REQUEST_XML_ID                NUMBER          DEFAULT 0                     NOT NULL,
  SUMMARY_REPORT_XML_ID         NUMBER          DEFAULT 0                     NOT NULL,
  PARENT_REQUEST_ID             NUMBER          DEFAULT 0                     NOT NULL,
  PERSON_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  ENCNTR_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  ACCESSION_NBR                 VARCHAR2(20 BYTE),
  REQUEST_PRSNL_ID              NUMBER          DEFAULT 0                     NOT NULL,
  PROVIDER_PRSNL_ID             NUMBER          DEFAULT 0                     NOT NULL,
  PROVIDER_RELTN_CD             NUMBER          DEFAULT 0                     NOT NULL,
  REQUEST_DT_TM                 DATE            DEFAULT SYSDATE               NOT NULL,
  REQUEST_TYPE_FLAG             NUMBER          DEFAULT 0                     NOT NULL,
  SCOPE_FLAG                    NUMBER          DEFAULT 0                     NOT NULL,
  REPORT_STATUS_CD              NUMBER          DEFAULT 0                     NOT NULL,
  TOTAL_PAGES_NBR               FLOAT(126),
  PROCESSING_TIME               FLOAT(126),
  DISTRIBUTION_ID               NUMBER          DEFAULT 0                     NOT NULL,
  DIST_RUN_TYPE_CD              NUMBER          DEFAULT 0                     NOT NULL,
  DIST_RUN_DT_TM                DATE,
  READER_GROUP                  VARCHAR2(15 BYTE),
  TRIGGER_ID                    NUMBER          DEFAULT 0                     NOT NULL,
  TRIGGER_TYPE                  VARCHAR2(15 BYTE),
  TRIGGER_NAME                  VARCHAR2(100 BYTE),
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_ID                      NUMBER          DEFAULT 0                     NOT NULL,
  TEMPLATE_ID                   NUMBER          DEFAULT 0                     NOT NULL,
  DEBUG_ZIP_ID                  NUMBER          DEFAULT 0                     NOT NULL,
  CHART_TRIGGER_ID              NUMBER          DEFAULT 0                     NOT NULL,
  USE_POSTING_DATE_IND          NUMBER          DEFAULT 0,
  SEQUENCE_NBR                  NUMBER,
  COPIES_NBR                    NUMBER,
  ROUTE_STOP_ID                 NUMBER          DEFAULT 0,
  ROUTE_ID                      NUMBER          DEFAULT 0,
  RESULT_STATUS_FLAG            NUMBER          DEFAULT 0,
  END_DT_TM                     DATE,
  BEGIN_DT_TM                   DATE,
  REQUESTING_ROLE_PROFILE       VARCHAR2(255 BYTE),
  DMS_SERVICE_NAME              VARCHAR2(64 BYTE),
  OUTPUT_DEST_CD                NUMBER          DEFAULT 0,
  DESTINATION_VALUE_TXT         VARCHAR2(255 BYTE),
  DESTINATION_TYPE_FLAG         NUMBER          DEFAULT 0,
  REQUESTOR_VALUE_TXT           VARCHAR2(255 BYTE),
  REQUESTOR_TYPE_FLAG           NUMBER          DEFAULT 0,
  RELEASE_COMMENT               VARCHAR2(1000 BYTE),
  RELEASE_REASON_CD             NUMBER          DEFAULT 0,
  PATIENT_CONSENT_RECEIVED_IND  NUMBER          DEFAULT 0,
  DMS_SERVICE_IDENT             VARCHAR2(110 BYTE),
  DMS_FAX_DISTRIBUTE_DT_TM      DATE,
  DMS_ADHOC_FAX_NUMBER_TXT      VARCHAR2(40 BYTE),
  OUTPUT_CONTENT_TYPE_STR       VARCHAR2(255 BYTE),
  DISK_LABEL                    VARCHAR2(128 BYTE),
  DISK_TYPE_FLAG                NUMBER          DEFAULT 0,
  TEMPLATE_VERSION_MODE_FLAG    NUMBER,
  TEMPLATE_VERSION_DT_TM        DATE,
  FILE_NAME                     VARCHAR2(255 BYTE),
  PRSNL_RELTN_ID                NUMBER          DEFAULT 0                     NOT NULL,
  PATIENT_REQUEST_IND           NUMBER          DEFAULT 0,
  OUTPUT_CONTENT_TYPE_CD        NUMBER          DEFAULT 0,
  FILE_MASK                     VARCHAR2(255 BYTE),
  DISK_IDENTIFIER               FLOAT(126)      DEFAULT 0,
  CUSTODIAL_ORG_ID              NUMBER          DEFAULT 0,
  NON_CE_BEGIN_DT_TM            DATE,
  NON_CE_END_DT_TM              DATE,
  SERVER_FULL_NAME              VARCHAR2(250 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CR_REPORT_REQUEST_ARCHIVE
(
  REPORT_REQUEST_ARCHIVE_ID  NUMBER             DEFAULT 0                     NOT NULL,
  ARCHIVED_DT_TM             DATE,
  ARCHIVED_REPORT_NBR        NUMBER             DEFAULT 0                     NOT NULL,
  LONG_BLOB_ID               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  MIN_REQUEST_DT_TM          DATE               DEFAULT SYSDATE               NOT NULL,
  MAX_REQUEST_DT_TM          DATE               DEFAULT SYSDATE               NOT NULL,
  LOGICAL_DOMAIN_ID          NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CR_REPORT_REQUEST_ENCNTR
(
  REPORT_REQUEST_ENCNTR_ID  NUMBER              DEFAULT 0                     NOT NULL,
  REPORT_REQUEST_ID         NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_SEQ                NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CR_REPORT_REQUEST_EVENT
(
  REPORT_REQUEST_EVENT_ID  NUMBER               DEFAULT 0                     NOT NULL,
  REPORT_REQUEST_ID        NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CR_REPORT_REQUEST_SECTION
(
  REPORT_REQUEST_SECTION_ID  NUMBER             DEFAULT 0                     NOT NULL,
  REPORT_REQUEST_ID          NUMBER             DEFAULT 0                     NOT NULL,
  SECTION_ID                 NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CR_REPORT_TEMPLATE
(
  REPORT_TEMPLATE_ID       NUMBER               DEFAULT 0                     NOT NULL,
  TEMPLATE_ID              NUMBER               DEFAULT 0                     NOT NULL,
  TEMPLATE_NAME            VARCHAR2(150 BYTE)   DEFAULT ' '                   NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM      DATE,
  LONG_TEXT_ID             NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER               DEFAULT 0                     NOT NULL,
  TEMPLATE_NAME_KEY        VARCHAR2(150 BYTE),
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  NAME_IDENT               VARCHAR2(167 BYTE)   DEFAULT ' '                   NOT NULL,
  REPORT_STYLE_PROFILE_ID  NUMBER               DEFAULT 0                     NOT NULL,
  FACESHEET_ID             NUMBER               DEFAULT 0,
  PORTRAIT_WATERMARK_ID    NUMBER               DEFAULT 0,
  LANDSCAPE_WATERMARK_ID   NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CR_STATIC_REGION_LOC_RELTN
(
  CR_STATIC_REGION_LOC_RELTN_ID  NUMBER         DEFAULT 0                     NOT NULL,
  STATIC_REGION_ID               NUMBER         DEFAULT 0                     NOT NULL,
  LOCATION_CD                    NUMBER         DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM            DATE           DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM            DATE           DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_IND                     NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CR_STATIC_REGION_ORG_RELTN
(
  CR_STATIC_REGION_ORG_RELTN_ID  NUMBER         DEFAULT 0                     NOT NULL,
  STATIC_REGION_ID               NUMBER         DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID                NUMBER         DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM            DATE           DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM            DATE           DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_IND                     NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CR_TEMPLATE_PUBLISH
(
  TEMPLATE_PUBLISH_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  TEMPLATE_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  PUBLISH_DT_TM        DATE                     DEFAULT SYSDATE               NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE,
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CR_TEMPLATE_SNAPSHOT
(
  TEMPLATE_SNAPSHOT_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  TEMPLATE_ID           NUMBER                  DEFAULT 0                     NOT NULL,
  SECTION_ID            NUMBER                  DEFAULT 0                     NOT NULL,
  STATIC_REGION_ID      NUMBER                  DEFAULT 0                     NOT NULL,
  SEQUENCE_NBR          NUMBER                  DEFAULT 0                     NOT NULL,
  ACTIVE_IND            NUMBER                  DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM   DATE                    DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM   DATE,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  PAGE_BREAK_AFTER_IND  NUMBER                  DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CR_XML_DOC_REQUEST
(
  CR_XML_DOC_REQUEST_ID   NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  TRIGGER_DT_TM           DATE                  DEFAULT SYSDATE               NOT NULL,
  SUCCESS_IND             NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CSA_USER_AGREEMENT
(
  USER_AGREEMENT_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  POSITION_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  INTERVAL_TYPE_TXT    VARCHAR2(20 BYTE),
  INTERVAL_NBR         NUMBER                   DEFAULT 0                     NOT NULL,
  AGREEMENT_TEXT_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CSA_USER_AGREEMENT_ACK
(
  USER_AGREEMENT_ACK_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  USER_AGREEMENT_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  LOGINS_CNT             NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM    DATE                   DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM    DATE                   DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CSI_ERROR_LOG
(
  EXLOG_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  INTERFACE_ID             NUMBER               DEFAULT 0                     NOT NULL,
  PFT_CHARGE_ID            NUMBER               DEFAULT 0                     NOT NULL,
  CHARGE_ITEM_ID           NUMBER               DEFAULT 0                     NOT NULL,
  CSI_INTERFACE_CD         NUMBER               DEFAULT 0                     NOT NULL,
  CSI_INTERFACE_REASON_CD  NUMBER               DEFAULT 0                     NOT NULL,
  ERROR_DT_TM              DATE,
  CR_ACCT_ID               NUMBER               DEFAULT 0                     NOT NULL,
  DR_ACCT_ID               NUMBER               DEFAULT 0                     NOT NULL,
  CR_GL_ACCT_ID            NUMBER               DEFAULT 0                     NOT NULL,
  DR_GL_ACCT_ID            NUMBER               DEFAULT 0                     NOT NULL,
  DEPOSIT_ACCT_ID          NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVITY_ID              NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CSM_CAT_SUB_XREF
(
  CSM_CAT_ID        NUMBER                      DEFAULT 0                     NOT NULL,
  CSM_SUB_CAT_ID    NUMBER                      DEFAULT 0                     NOT NULL,
  REQ_TEMPL_ID      NUMBER                      DEFAULT 0                     NOT NULL,
  RESL_TEMPL_ID     NUMBER                      DEFAULT 0                     NOT NULL,
  REQ_SECURITY      NUMBER,
  REQ_AV_FLAG       NUMBER,
  REQ_PURGE_DAYS    NUMBER,
  ACTIVE_IND        NUMBER,
  REQ_MNEMONIC      CHAR(10 BYTE),
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  CSM_CALLBACK_IND  NUMBER,
  REQ_PHONE_FLAG    NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CSM_LST_CONTACT
(
  CSM_LST_REC_ID     NUMBER                     DEFAULT 0                     NOT NULL,
  PHONE_ID           NUMBER                     DEFAULT 0                     NOT NULL,
  CSM_PHONE_STAT_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  CSM_LST_DT_TM      DATE                       DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  CSM_CONTACT_ID     NUMBER                     DEFAULT 0                     NOT NULL,
  PERSON_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  ACTIVE_IND         NUMBER,
  CONTACT            VARCHAR2(100 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CSM_QUEUE_PERS_XREF
(
  CSM_QUEUE_ID  NUMBER                          DEFAULT 0                     NOT NULL,
  PERSON_ID     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CSM_Q_ORG_XREF
(
  CSM_QUEUE_ID       NUMBER                     DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  CSM_ORG_INCL_FLAG  NUMBER,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CSM_REQUESTS
(
  CSM_REQ_ID              NUMBER                DEFAULT 0                     NOT NULL,
  CSM_CAT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  CSM_SUB_CAT_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  LOCATION_CD             NUMBER                DEFAULT 0                     NOT NULL,
  STATUS_CD               NUMBER                DEFAULT 0                     NOT NULL,
  CSM_PRIOR_ID            NUMBER                DEFAULT 0                     NOT NULL,
  CSM_ORD_DT_TM           DATE,
  CSM_COMPL_DT_TM         DATE,
  CSM_DUE_DT_TM           DATE,
  CSM_CURRENT_USER        CHAR(50 BYTE),
  CSM_REQ_COM_ID          NUMBER                DEFAULT 0                     NOT NULL,
  CSM_RSLT_COM_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PHONE_ID                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  PROBLEM_REQ_COMMENT_ID  NUMBER                DEFAULT 0                     NOT NULL,
  SELECTED_PHONE_ID       NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CSM_REQUESTS_ARCHIVE
(
  CSM_REQ_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  CSM_CAT_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  CSM_SUB_CAT_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  LOCATION_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  PHONE_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME   CHAR(32 BYTE),
  PARENT_ENTITY_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  COMPL_PRSNL_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  CSM_PRIOR_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  CONTACT              VARCHAR2(100 BYTE),
  CSM_PHONE_STAT_DESC  CHAR(40 BYTE),
  CSM_ORD_DT_TM        DATE,
  CSM_COMPL_DT_TM      DATE,
  CSM_DUE_DT_TM        DATE,
  PURGED_DT_TM         DATE,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  CSM_AD_HOC_PHONE     CHAR(100 BYTE),
  CSM_AD_HOC_EXT       CHAR(100 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CS_CPP_ERROR_LOG
(
  CS_CPP_ERROR_LOG_ID     NUMBER                DEFAULT 0                     NOT NULL,
  CS_CPP_RULESET_ID       NUMBER                DEFAULT 0                     NOT NULL,
  CS_CPP_RULE_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ERROR_TEXT              VARCHAR2(200 BYTE)    DEFAULT ' '                   NOT NULL,
  ERROR_DT_TM             DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CS_CPP_UNDO
(
  CS_CPP_UNDO_ID          NUMBER                DEFAULT 0                     NOT NULL,
  CS_CPP_RULE_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 1                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CS_CPP_UNDO_DETAIL
(
  CS_CPP_UNDO_DETAIL_ID   NUMBER                DEFAULT 0                     NOT NULL,
  CS_CPP_UNDO_ID          NUMBER                DEFAULT 0                     NOT NULL,
  CHARGE_ITEM_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ORIGINAL_IND            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 1                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CS_ORG_RELTN
(
  CS_ORG_RELTN_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  CS_ORG_RELTN_TYPE_CD    NUMBER                DEFAULT 0                     NOT NULL,
  KEY1_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  KEY1_ENTITY_NAME        VARCHAR2(200 BYTE),
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_DEFAULT_MILESTONES
(
  CT_DEFAULT_MILESTONES_ID  NUMBER              DEFAULT 0                     NOT NULL,
  DEFAULT_LIST_TYPE_CD      NUMBER              DEFAULT 0                     NOT NULL,
  COMMITTEE_ID              NUMBER              DEFAULT 0                     NOT NULL,
  SEQUENCE_NBR              NUMBER              DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID           NUMBER              DEFAULT 0                     NOT NULL,
  ENTITY_TYPE_FLAG          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVITY_CD               NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  PROT_ROLE_CD              NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_DOCUMENT
(
  CT_DOCUMENT_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  PROT_AMENDMENT_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  TITLE                  VARCHAR2(40 BYTE)      DEFAULT ' '                   NOT NULL,
  DESCRIPTION            VARCHAR2(255 BYTE),
  DOCUMENT_TYPE_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  BEGIN_EFFECTIVE_DT_TM  DATE                   DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  END_EFFECTIVE_DT_TM    DATE                   DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  PREV_CT_DOCUMENT_ID    NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_DOCUMENT_BLOB
(
  CT_DOCUMENT_BLOB_ID     NUMBER                DEFAULT 0                     NOT NULL,
  CT_DOCUMENT_VERSION_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BLOB_LENGTH             NUMBER                DEFAULT 0                     NOT NULL,
  LONG_BLOB               BLOB,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOB (LONG_BLOB) STORE AS (
  TABLESPACE  D_R_MEDIUM
  ENABLE      STORAGE IN ROW
  CHUNK       8192
  PCTVERSION  5
  CACHE
  LOGGING)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_DOCUMENT_VERSION
(
  CT_DOCUMENT_VERSION_ID       NUMBER           DEFAULT 0                     NOT NULL,
  CT_DOCUMENT_ID               NUMBER           DEFAULT 0                     NOT NULL,
  VERSION_DESCRIPTION          VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  FILE_NAME                    VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  VERSION_NBR                  NUMBER           DEFAULT 0                     NOT NULL,
  BEGIN_EFFECTIVE_DT_TM        DATE             DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  REVISION_ID                  NUMBER           DEFAULT 0                     NOT NULL,
  LONG_BLOB_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  DISPLAY_IND                  NUMBER           DEFAULT 0,
  PRINT_WITH_CONSENT_IND       NUMBER           DEFAULT 0,
  ACTIVE_IND                   NUMBER           DEFAULT 0,
  PREV_CT_DOCUMENT_VERSION_ID  NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_EXCLUDED_CLIENTS
(
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_MILESTONES
(
  CT_MILESTONES_ID   NUMBER                     DEFAULT 0                     NOT NULL,
  SEQUENCE_NBR       NUMBER                     DEFAULT 0                     NOT NULL,
  COMMITTEE_ID       NUMBER                     DEFAULT 0                     NOT NULL,
  ENTITY_TYPE_FLAG   NUMBER                     DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  ACTIVITY_CD        NUMBER                     DEFAULT 0                     NOT NULL,
  PERFORMED_DT_TM    DATE                       DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  PROT_ROLE_CD       NUMBER                     DEFAULT 0                     NOT NULL,
  PROT_AMENDMENT_ID  NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_PRESCREEN_JOB
(
  CT_PRESCREEN_JOB_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  JOB_TYPE_FLAG        NUMBER                   DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  JOB_START_DT_TM      DATE                     DEFAULT SYSDATE               NOT NULL,
  JOB_END_DT_TM        DATE                     DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  JOB_STATUS_CD        NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_PROT_AMD_CUSTOM_FLD_VAL
(
  CT_PROT_AMD_CUSTOM_FLD_ID       NUMBER        DEFAULT 0                     NOT NULL,
  PREV_CT_PROT_AMD_CUSTOM_FLD_ID  NUMBER        DEFAULT 0                     NOT NULL,
  PROT_AMENDMENT_ID               NUMBER        DEFAULT 0                     NOT NULL,
  CT_CUSTOM_FIELD_ID              NUMBER        DEFAULT 0                     NOT NULL,
  VALUE_CD                        NUMBER        DEFAULT 0                     NOT NULL,
  VALUE_TEXT                      VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  VALUE_DT_TM                     DATE          DEFAULT SYSDATE               NOT NULL,
  BEG_EFFECTIVE_DT_TM             DATE          DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM             DATE          DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  FIELD_POSITION                  NUMBER        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_PROT_CONFIG_VALUE
(
  CT_PROT_CONFIG_VALUE_ID       NUMBER          DEFAULT 0                     NOT NULL,
  PREV_CT_PROT_CONFIG_VALUE_ID  NUMBER          DEFAULT 0                     NOT NULL,
  PROT_MASTER_ID                NUMBER          DEFAULT 0                     NOT NULL,
  ITEM_CD                       NUMBER          DEFAULT 0                     NOT NULL,
  CONFIG_VALUE_CD               NUMBER          DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM           DATE            DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM           DATE            DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_PROT_MILESTONES
(
  CT_PROT_MILESTONES_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  PROT_MASTER_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  COMMITTEE_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  SEQUENCE_NBR           NUMBER                 DEFAULT 0                     NOT NULL,
  ENTITY_TYPE_FLAG       NUMBER                 DEFAULT 0                     NOT NULL,
  ACTIVITY_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  PERFORMED_DT_TM        DATE                   DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  PROT_ROLE_CD           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_PROT_PRESCREEN_JOB_INFO
(
  CT_PROT_PRESCREEN_JOB_INFO_ID  NUMBER         DEFAULT 0                     NOT NULL,
  CT_PRESCREEN_JOB_ID            NUMBER         DEFAULT 0                     NOT NULL,
  PROT_MASTER_ID                 NUMBER         DEFAULT 0                     NOT NULL,
  PT_QUALIFIED_NBR               NUMBER         DEFAULT 0                     NOT NULL,
  COMPLETED_FLAG                 NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_PT_AMD_ASSIGNMENT
(
  CT_PT_AMD_ASSIGNMENT_ID        NUMBER         DEFAULT 0                     NOT NULL,
  REG_ID                         NUMBER         DEFAULT 0                     NOT NULL,
  PROT_AMENDMENT_ID              NUMBER         DEFAULT 0                     NOT NULL,
  TRANSFER_CHECKED_AMENDMENT_ID  NUMBER         DEFAULT 0                     NOT NULL,
  ASSIGN_START_DT_TM             DATE           DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ASSIGN_END_DT_TM               DATE           DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  BEG_EFFECTIVE_DT_TM            DATE           DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM            DATE           DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_PT_PROT_BATCH_LIST
(
  CT_PT_PROT_BATCH_LIST_ID  NUMBER              DEFAULT 0                     NOT NULL,
  PROT_MASTER_ID            NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_PT_SETTINGS
(
  CT_PT_SETTINGS_ID        NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  NOT_INTERESTED_IND       NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  NOT_INTERESTED_DT_TM     DATE,
  NOT_INTERESTED_PRSNL_ID  NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER               DEFAULT 1
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_REASON_DELETED
(
  CT_REASON_DEL_ID        NUMBER                DEFAULT 0                     NOT NULL,
  REG_ID                  NUMBER                DEFAULT 0                     NOT NULL,
  DELETION_DT_TM          DATE                  DEFAULT SYSDATE               NOT NULL,
  DELETION_PRSNL_ID       NUMBER                DEFAULT 0                     NOT NULL,
  DELETION_REASON         VARCHAR2(2000 BYTE)   DEFAULT ' '                   NOT NULL,
  PT_ELIG_TRACKING_ID     NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  CONSENT_ID              NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_RN_PROT_CONFIG
(
  CT_RN_PROT_CONFIG_ID       NUMBER             DEFAULT 0                     NOT NULL,
  PREV_CT_RN_PROT_CONFIG_ID  NUMBER             DEFAULT 0                     NOT NULL,
  PROT_MASTER_ID             NUMBER             DEFAULT 0                     NOT NULL,
  SOURCE_FILENAME            VARCHAR2(255 BYTE),
  LONG_TEXT_ID               NUMBER             DEFAULT 0                     NOT NULL,
  CONFIG_INFO                VARCHAR2(4000 BYTE),
  BEG_EFFECTIVE_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM        DATE               DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  RN_PROTOCOL_CD             NUMBER             DEFAULT 0                     NOT NULL,
  STOP_DT_TM                 DATE,
  CONFIG_VERSION_NBR         NUMBER             DEFAULT 0                     NOT NULL,
  DATA_EXTRACT_CAP_FLAG      NUMBER             DEFAULT 0                     NOT NULL,
  PROT_PASSWORD              VARCHAR2(100 BYTE) DEFAULT ' ' NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_RN_PROT_RUN
(
  CT_RN_PROT_RUN_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  PROT_MASTER_ID     NUMBER                     DEFAULT 0                     NOT NULL,
  RUN_GROUP_ID       NUMBER                     DEFAULT 0                     NOT NULL,
  NEXT_RUN_DT_TM     DATE,
  PT_SENT_NBR        NUMBER                     DEFAULT 0                     NOT NULL,
  COMPLETED_FLAG     NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_RN_RUN_ACTIVITY
(
  CT_RN_RUN_ACTIVITY_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  CT_RN_PROT_RUN_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  STATUS_FLAG            NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_RULESET_TIER
(
  CT_RULESET_TIER_ID      NUMBER                DEFAULT 0                     NOT NULL,
  PRIORITY                NUMBER                DEFAULT 0,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  FIN_CLASS_CD            NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CD          NUMBER                DEFAULT 0                     NOT NULL,
  CT_RULESET_CD           NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  INS_ORG_ID              NUMBER                DEFAULT 0                     NOT NULL,
  EXCLUDE_ENCNTR_TYPE_CD  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_TYPE_COMMITTEE_RELTN
(
  CT_TYPE_COMMITTEE_ID   NUMBER                 DEFAULT 0                     NOT NULL,
  PARTICIPATION_TYPE_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  COMMITTEE_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  EDIT_IND               NUMBER                 DEFAULT 0                     NOT NULL,
  ACTIVE_IND             NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  REV_VALIDATE_IND       NUMBER                 DEFAULT 0                     NOT NULL,
  AMD_VALIDATE_IND       NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CT_USER_DOMAIN_INFO
(
  CT_USER_DOMAIN_INFO_ID  NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CT_DOMAIN_INFO_ID       NUMBER                DEFAULT 0                     NOT NULL,
  USER_TOKEN_TXT          VARCHAR2(255 BYTE)    DEFAULT ' '                   NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CUSTOM_PT_LIST
(
  CUSTOM_PT_LIST_ID       NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  LIST_NAME               VARCHAR2(100 BYTE),
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CUSTOM_PT_LIST_ENTRY
(
  CUST_PTL_ENTRY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  CUSTOM_PT_LIST_ID       NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  COMMENT_TEXT            VARCHAR2(200 BYTE),
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_ACRONYM
(
  CV_ACRONYM_ID    NUMBER                       DEFAULT 0                     NOT NULL,
  PROVIDER_ID      NUMBER                       DEFAULT 0                     NOT NULL,
  ACRONYM_STR      VARCHAR2(8 BYTE)             DEFAULT ' '                   NOT NULL,
  REPLACEMENT_STR  VARCHAR2(200 BYTE)           DEFAULT ' '                   NOT NULL,
  COLLATION_SEQ    NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_CASE
(
  CV_CASE_ID              NUMBER                DEFAULT 0                     NOT NULL,
  CV_CASE_NBR             NUMBER,
  SOURCE_CD               NUMBER                DEFAULT 0                     NOT NULL,
  SEX_CD                  NUMBER                DEFAULT 0                     NOT NULL,
  PATIENT_TYPE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  AGE                     NUMBER,
  AGE_GROUP_CD            NUMBER                DEFAULT 0                     NOT NULL,
  HOSPITAL_CD             NUMBER                DEFAULT 0                     NOT NULL,
  PAT_ADM_DT_TM           DATE,
  PAT_DISCH_DT_TM         DATE,
  LOS_ADM_DISCH           NUMBER,
  PAT_DISCH_IND           NUMBER,
  PAT_ADM_IND             NUMBER,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  DEATH_IND               NUMBER,
  NUM_RFACTOR             NUMBER,
  NUM_PROC                NUMBER,
  NUM_PRESENTN            NUMBER,
  NUM_HISTORY             NUMBER,
  NUM_OOLAB_COMPL         NUMBER,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APP                NUMBER,
  UPDT_REQ                NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ADMT_DT_NBR             NUMBER                DEFAULT 0,
  DISCH_DT_NBR            NUMBER                DEFAULT 0,
  PROC_DT_NBR             NUMBER                DEFAULT 0,
  LOS_ADM_PROC            NUMBER                DEFAULT 0,
  LOS_PROC_DISCH          NUMBER                DEFAULT 0,
  FORM_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  CHART_DT_TM             DATE,
  CASE_DT_TM              DATE,
  FORM_TYPE_CD            NUMBER                DEFAULT 0,
  FORM_EVENT_ID           NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_CASE_ABSTR_DATA
(
  CASE_ABSTR_DATA_ID      NUMBER                DEFAULT 0                     NOT NULL,
  CV_CASE_ID              NUMBER                DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_CD                NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_VAL              VARCHAR2(255 BYTE),
  RESULT_DT_TM            DATE,
  RESULT_CD               NUMBER                DEFAULT 0                     NOT NULL,
  GROUP_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APP                NUMBER,
  UPDT_REQ                NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  RESULT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_SOURCE           VARCHAR2(32 BYTE),
  EVENT_ID                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_CASE_DATASET_R
(
  CASE_DATASET_R_ID       NUMBER                DEFAULT 0                     NOT NULL,
  DATASET_ID              NUMBER                DEFAULT 0                     NOT NULL,
  CV_CASE_ID              NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APP                NUMBER,
  UPDT_REQ                NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  PARTICIPANT_NBR         VARCHAR2(50 BYTE),
  STATUS_CD               NUMBER                DEFAULT 0                     NOT NULL,
  ERROR_MSG               VARCHAR2(255 BYTE),
  REGISTRY_NBR            FLOAT(126)            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_CASE_FIELD
(
  CASE_FIELD_ID           NUMBER                DEFAULT 0                     NOT NULL,
  CASE_DATASET_R_ID       NUMBER                DEFAULT 0                     NOT NULL,
  STATUS_CD               NUMBER                DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  PROCEDURE_ID            NUMBER                DEFAULT 0                     NOT NULL,
  LESION_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ABSTR_DATA_ID           NUMBER                DEFAULT 0                     NOT NULL,
  ABSTR_DATA_NAME         VARCHAR2(20 BYTE),
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  UPDT_APP                NUMBER,
  UPDT_REQ                NUMBER,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  XREF_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_VAL              VARCHAR2(100 BYTE),
  TRANSLATED_VAL          VARCHAR2(100 BYTE),
  LESION_IDX              NUMBER,
  DEV_IDX                 NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_CASE_FILE_ROW
(
  CV_CASE_FILE_ROW_ID     NUMBER                DEFAULT 0                     NOT NULL,
  FILE_ID                 FLOAT(126)            DEFAULT 0                     NOT NULL,
  CASE_DATASET_R_ID       NUMBER                DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  SEQ                     NUMBER,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APP                NUMBER,
  UPDT_REQ                NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_DEVICE
(
  DEVICE_ID               NUMBER                DEFAULT 0                     NOT NULL,
  LESION_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CV_CASE_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_EVENT_ID         NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_DEV_ABSTR_DATA
(
  DEV_ABSTR_DATA_ID       NUMBER                DEFAULT 0                     NOT NULL,
  DEVICE_ID               NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_VAL              VARCHAR2(255 BYTE),
  RESULT_DT_TM            DATE,
  RESULT_CD               NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_SOURCE           VARCHAR2(32 BYTE),
  NOMENCLATURE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_ID                NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_CD                NUMBER                DEFAULT 0                     NOT NULL,
  GROUP_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_ED_REVIEW
(
  CV_ED_REVIEW_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  ORDER_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  REQUESTOR_PRSNL_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  REQUEST_DT_TM       DATE,
  REVIEWER_PRSNL_ID   NUMBER                    DEFAULT 0                     NOT NULL,
  REVIEW_DT_TM        DATE,
  VALID_UNTIL_DT_TM   DATE,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  REVIEW_STATUS_CD    NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_LESION
(
  LESION_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PROCEDURE_ID            NUMBER                DEFAULT 0                     NOT NULL,
  NUM_LES_COMPL           NUMBER,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APP                NUMBER,
  UPDT_REQ                NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 1,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  PARENT_EVENT_ID         NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_LES_ABSTR_DATA
(
  LES_ABSTR_DATA_ID       NUMBER                DEFAULT 0                     NOT NULL,
  LESION_ID               NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_CD                NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_VAL              VARCHAR2(255 BYTE),
  RESULT_DT_TM            DATE,
  RESULT_CD               NUMBER                DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  GROUP_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APP                NUMBER,
  UPDT_REQ                NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 1,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  RESULT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_SOURCE           VARCHAR2(32 BYTE),
  EVENT_ID                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_PROC
(
  CV_PROC_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  ORDER_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  ACCESSION_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  ACCESSION            VARCHAR2(20 BYTE)        DEFAULT ' '                   NOT NULL,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  ORDER_PHYSICIAN_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  REFER_PHYSICIAN_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  PRIM_PHYSICIAN_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  ENCNTR_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  PROC_STATUS_CD       NUMBER                   DEFAULT 0                     NOT NULL,
  PRIORITY_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  REASON_FOR_PROC      VARCHAR2(255 BYTE),
  GROUP_EVENT_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  SEQUENCE             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  PHYS_GROUP_ID        NUMBER                   DEFAULT 0                     NOT NULL,
  ACTION_DT_TM         DATE,
  REQUEST_DT_TM        DATE,
  ACTIVITY_SUBTYPE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  ED_REVIEW_IND        NUMBER                   DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_PROCEDURE
(
  PROCEDURE_ID            NUMBER                DEFAULT 0                     NOT NULL,
  CV_CASE_ID              NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  PROC_PHYSIC_ID          NUMBER                DEFAULT 0                     NOT NULL,
  PROC_START_DT_TM        DATE,
  PROC_END_DT_TM          DATE,
  PROC_DUR_MIN            NUMBER,
  PROC_START_MNTH         NUMBER,
  PROC_START_DAY          NUMBER,
  PROC_START_HOUR         NUMBER,
  PROC_COMPLETE_IND       NUMBER,
  LOS_ADM_PROC            NUMBER,
  LOS_PROC_DISCH          NUMBER,
  DEPT_CD                 NUMBER                DEFAULT 0                     NOT NULL,
  DOC_INLAB_DT_TM         DATE,
  DOC_PREP_MIN            NUMBER,
  PAT_DISCH_DT_TM         DATE,
  PAT_DISCH_IND           NUMBER,
  PAT_DEATH_IND           NUMBER,
  PAT_INLAB_MIN           NUMBER,
  PAT_ADM_DT_TM           DATE,
  PAT_ADM_IND             NUMBER,
  NURSE_ID                NUMBER                DEFAULT 0                     NOT NULL,
  PAT_INLAB_DT_TM         DATE,
  PAT_WAIT_MIN            NUMBER,
  PROC_NAME_CD            NUMBER                DEFAULT 0                     NOT NULL,
  NUM_PROC_IND            NUMBER,
  NUM_PROC_COMPL          NUMBER,
  NUM_LESION              NUMBER,
  TOTAL_PROC_COMPL        NUMBER,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APP                NUMBER,
  UPDT_REQ                NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_PROC_ABSTR_DATA
(
  PROC_ABSTR_DATA_ID      NUMBER                DEFAULT 0                     NOT NULL,
  PROCEDURE_ID            NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_CD                NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_VAL              VARCHAR2(255 BYTE),
  RESULT_DT_TM            DATE,
  RESULT_CD               NUMBER                DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  GROUP_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APP                NUMBER,
  UPDT_REQ                NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  RESULT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_SOURCE           VARCHAR2(32 BYTE),
  EVENT_ID                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_STEP
(
  CV_STEP_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  CV_PROC_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  EVENT_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  STEP_STATUS_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  SEQUENCE               NUMBER                 DEFAULT 0                     NOT NULL,
  PERF_PROVIDER_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  PERF_LOC_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  PERF_START_DT_TM       DATE,
  PERF_STOP_DT_TM        DATE,
  LOCK_PRSNL_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  PRELIMINARY_AUTHOR_ID  NUMBER                 DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_STEP_PRSNL
(
  CV_STEP_PRSNL_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  CV_STEP_ID        NUMBER                      DEFAULT 0                     NOT NULL,
  STEP_PRSNL_ID     NUMBER                      DEFAULT 0                     NOT NULL,
  STEP_RELATION_CD  NUMBER                      DEFAULT 0                     NOT NULL,
  ACTION_TYPE_CD    NUMBER                      DEFAULT 0                     NOT NULL,
  ACTION_DT_TM      DATE,
  ACTION_SEQUENCE   NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CV_STEP_SCHED
(
  CV_STEP_SCHED_ID   NUMBER                     DEFAULT 0                     NOT NULL,
  CV_STEP_ID         NUMBER                     DEFAULT 0                     NOT NULL,
  CV_PROC_ID         NUMBER                     DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD      NUMBER                     DEFAULT 0                     NOT NULL,
  ARRIVE_DT_TM       DATE,
  ARRIVE_IND         NUMBER                     DEFAULT 0                     NOT NULL,
  SCHED_LOC_CD       NUMBER                     DEFAULT 0                     NOT NULL,
  SCHED_PHYS_ID      NUMBER                     DEFAULT 0                     NOT NULL,
  SCHED_START_DT_TM  DATE,
  SCHED_STOP_DT_TM   DATE,
  PERF_LOC_CD        NUMBER                     DEFAULT 0                     NOT NULL,
  PERF_PHYS_ID       NUMBER                     DEFAULT 0                     NOT NULL,
  PERF_START_DT_TM   DATE,
  PERF_STOP_DT_TM    DATE,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CYTO_ALPHA_SECURITY
(
  REFERENCE_RANGE_FACTOR_ID      NUMBER         DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID                NUMBER         DEFAULT 0                     NOT NULL,
  DIAGNOSTIC_CATEGORY_CD         NUMBER         DEFAULT 0                     NOT NULL,
  DEGREES_FROM_NORMAL            NUMBER,
  WORKLOAD_CD                    NUMBER         DEFAULT 0                     NOT NULL,
  REQUEUE_FLAG                   NUMBER,
  REQUEUE_SERVICE_RESOURCE_CD    NUMBER         DEFAULT 0                     NOT NULL,
  VERIFY_LEVEL_IS                NUMBER,
  VERIFY_LEVEL_RS                NUMBER,
  QA_FLAG_TYPE_CD                NUMBER         DEFAULT 0                     NOT NULL,
  FOLLOWUP_TRACKING_TYPE_CD      NUMBER         DEFAULT 0                     NOT NULL,
  FOLLOWUP_INITIAL_INTERVAL      NUMBER,
  FOLLOWUP_FIRST_INTERVAL        NUMBER,
  FOLLOWUP_FINAL_INTERVAL        NUMBER,
  FOLLOWUP_TERMINATION_INTERVAL  NUMBER,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD            NUMBER         DEFAULT 0,
  DEFINITION_IND                 NUMBER         DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CYTO_SCREENING_EVENT
(
  CASE_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  SEQUENCE                   NUMBER             DEFAULT 0                     NOT NULL,
  SCREENER_ID                NUMBER             DEFAULT 0                     NOT NULL,
  SCREEN_DT_TM               DATE,
  INITIAL_SCREENER_IND       NUMBER,
  REFERENCE_RANGE_FACTOR_ID  NUMBER             DEFAULT 0                     NOT NULL,
  ENDOCERV_IND               NUMBER,
  ADEQUACY_FLAG              NUMBER,
  STANDARD_RPT_ID            NUMBER             DEFAULT 0                     NOT NULL,
  EVENT_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  VALID_FROM_DT_TM           DATE,
  NOMENCLATURE_ID            NUMBER             DEFAULT 0                     NOT NULL,
  VERIFY_IND                 NUMBER,
  REVIEW_REASON_FLAG         NUMBER,
  ACTIVE_IND                 NUMBER,
  DIAGNOSTIC_CATEGORY_CD     NUMBER             DEFAULT 0                     NOT NULL,
  ACTION_FLAG                NUMBER,
  SPLIT_IND                  NUMBER,
  SPECIMEN_GROUPING_CD       NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD        NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CYTO_SCREENING_LIMITS
(
  PRSNL_ID         NUMBER                       DEFAULT 0                     NOT NULL,
  SEQUENCE         NUMBER                       DEFAULT 0                     NOT NULL,
  SLIDE_LIMIT      NUMBER                       DEFAULT 0,
  SCREENING_HOURS  NUMBER                       DEFAULT 0,
  REVIEWER_ID      NUMBER                       DEFAULT 0                     NOT NULL,
  REVIEWED_DT_TM   DATE,
  COMMENTS         VARCHAR2(200 BYTE),
  ACTIVE_IND       NUMBER                       DEFAULT 0,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE CYTO_SCREENING_SECURITY
(
  PRSNL_ID                      NUMBER          DEFAULT 0                     NOT NULL,
  SEQUENCE                      NUMBER          DEFAULT 0                     NOT NULL,
  NORMAL_PERCENTAGE             NUMBER,
  ABNORMAL_PERCENTAGE           NUMBER,
  CHR_PERCENTAGE                NUMBER,
  ATYPICAL_PERCENTAGE           NUMBER,
  VERIFY_LEVEL                  NUMBER,
  REVIEWER_ID                   NUMBER          DEFAULT 0                     NOT NULL,
  REVIEWED_DT_TM                DATE,
  COMMENTS                      VARCHAR2(200 BYTE),
  ACTIVE_IND                    NUMBER,
  AUTO_OVERSCREENER_IND         NUMBER,
  OVER_REQUEUE_FLAG             NUMBER,
  OVER_SERVICE_RESOURCE_CD      NUMBER          DEFAULT 0                     NOT NULL,
  NORMAL_REQUEUE_FLAG           NUMBER,
  NORMAL_SERVICE_RESOURCE_CD    NUMBER          DEFAULT 0                     NOT NULL,
  CHR_REQUEUE_FLAG              NUMBER,
  CHR_SERVICE_RESOURCE_CD       NUMBER          DEFAULT 0                     NOT NULL,
  ATYPICAL_REQUEUE_FLAG         NUMBER,
  ATYPICAL_SERVICE_RESOURCE_CD  NUMBER          DEFAULT 0                     NOT NULL,
  ABNORMAL_REQUEUE_FLAG         NUMBER,
  ABNORMAL_SERVICE_RESOURCE_CD  NUMBER          DEFAULT 0                     NOT NULL,
  UNSAT_PERCENTAGE              NUMBER,
  UNSAT_REQUEUE_FLAG            NUMBER,
  UNSAT_SERVICE_RESOURCE_CD     NUMBER          DEFAULT 0                     NOT NULL,
  NORMAL_REQUEUE_RANK           NUMBER,
  ABNORMAL_REQUEUE_RANK         NUMBER,
  ATYPICAL_REQUEUE_RANK         NUMBER,
  CHR_REQUEUE_RANK              NUMBER,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DAILY_ACCT_BAL
(
  ACCT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVITY_DT_TM          DATE,
  ADJUSTMENT_AMOUNT       FLOAT(126),
  ADJ_DR_CR_FLAG          NUMBER,
  BEG_BALANCE             FLOAT(126),
  BEG_DR_CR_FLAG          NUMBER,
  BEG_EFFECTIVE_DT_TM     DATE,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  CALCULATED_END_BAL      FLOAT(126),
  CALC_DR_CR_FLAG         NUMBER,
  CHARGE_AMOUNT           FLOAT(126),
  CHRG_DR_CR_FLAG         NUMBER,
  DAILY_ACCT_BAL_ID       NUMBER                DEFAULT 0                     NOT NULL,
  END_BALANCE             FLOAT(126),
  END_DR_CR_FLAG          NUMBER,
  END_EFFECTIVE_DT_TM     DATE,
  FINCHRG_AMOUNT          FLOAT(126),
  FINCHRG_DR_CR_FLAG      NUMBER,
  PAYMENT_AMOUNT          FLOAT(126),
  PAY_DR_CR_FLAG          NUMBER,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  TRANSFER_AMOUNT         FLOAT(126),
  TRANSFER_DR_CR_FLAG     NUMBER,
  TOTAL_CHARGE_AMT        FLOAT(126),
  TOTAL_PAYMENT_AMT       FLOAT(126),
  TOTAL_ADJUSTMENT_AMT    FLOAT(126),
  LAST_PAYMENT_DT_TM      DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DAILY_CYTOLOGY_COUNTS
(
  PRSNL_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  RECORD_DT_TM               DATE               DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  NORMAL_CASES               NUMBER,
  PREV_ATYPICAL_CASES        NUMBER,
  PREV_ABNORMAL_CASES        NUMBER,
  OUTSIDE_HOURS              FLOAT(126),
  QA_SLIDES                  FLOAT(126),
  PROFICIENCY_SLIDES         FLOAT(126),
  SCREEN_HOURS               FLOAT(126),
  GYN_SLIDES_IS              FLOAT(126),
  GYN_SLIDES_RS              FLOAT(126),
  NGYN_SLIDES_IS             FLOAT(126),
  NGYN_SLIDES_RS             FLOAT(126),
  GYN_CASES_IS               NUMBER,
  GYN_CASES_RS               NUMBER,
  NGYN_CASES_IS              NUMBER,
  NGYN_CASES_RS              NUMBER,
  CHR_CASES                  NUMBER,
  EXCEEDED_LIMIT_CASES       NUMBER,
  USER_PREFERENCE_CASES      NUMBER,
  GYN_INSTRUMENT_SCREENING   FLOAT(126),
  OUTSIDE_GYN_IS             FLOAT(126),
  OUTSIDE_GYN_RS             FLOAT(126),
  OUTSIDE_NGYN_IS            FLOAT(126),
  OUTSIDE_NGYN_RS            FLOAT(126),
  NORMAL_SLIDES              FLOAT(126),
  PREV_ATYPICAL_SLIDES       FLOAT(126),
  PREV_ABNORMAL_SLIDES       FLOAT(126),
  CHR_SLIDES                 FLOAT(126),
  EXCEEDED_LIMIT_SLIDES      FLOAT(126),
  USER_PREFERENCE_SLIDES     FLOAT(126),
  NORMAL_SLIDES_REQUEUED     FLOAT(126),
  PREV_ATYP_SLIDES_REQUEUED  FLOAT(126),
  PREV_ABN_SLIDES_REQUEUED   FLOAT(126),
  CHR_SLIDES_REQUEUED        FLOAT(126),
  UNSAT_CASES                NUMBER,
  UNSAT_SLIDES               FLOAT(126),
  UNSAT_SLIDES_REQUEUED      FLOAT(126),
  COMMENTS                   VARCHAR2(100 BYTE),
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DAILY_ENCNTR_BAL
(
  DAILY_ENCNTR_BAL_ID     NUMBER                DEFAULT 0                     NOT NULL,
  PFT_ENCNTR_ID           NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVITY_DT_TM          DATE,
  BEG_BALANCE             FLOAT(126)            DEFAULT 0.0                   NOT NULL,
  BEG_DR_CR_FLAG          NUMBER,
  CHARGE_AMOUNT           FLOAT(126)            DEFAULT 0.0                   NOT NULL,
  CHRG_DR_CR_FLAG         NUMBER,
  PAYMENT_AMOUNT          FLOAT(126)            DEFAULT 0.0                   NOT NULL,
  PAY_DR_CR_FLAG          NUMBER,
  ADJUSTMENT_AMOUNT       FLOAT(126)            DEFAULT 0.0                   NOT NULL,
  ADJ_DR_CR_FLAG          NUMBER,
  END_BALANCE             FLOAT(126)            DEFAULT 0.0                   NOT NULL,
  END_DR_CR_FLAG          NUMBER,
  CALCULATED_END_BAL      FLOAT(126)            DEFAULT 0.0                   NOT NULL,
  CALC_DR_CR_FLAG         NUMBER,
  TRANSFER_AMOUNT         FLOAT(126)            DEFAULT 0.0                   NOT NULL,
  TRANSFER_DR_CR_FLAG     NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  TOTAL_CHARGE_AMT        FLOAT(126),
  TOTAL_PAYMENT_AMT       FLOAT(126),
  TOTAL_ADJUSTMENT_AMT    FLOAT(126),
  LAST_PAYMENT_DT_TM      DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DATA_SUBMISSION
(
  DATA_SUBMISSION_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  PROT_AMENDMENT_ID   NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  REPORTING_CLASS_CD  NUMBER                    DEFAULT 0                     NOT NULL,
  SUBMITTED_TO_CD     NUMBER                    DEFAULT 0                     NOT NULL,
  SUBMITTED_TO_DESC   VARCHAR2(255 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_BATCH_REPORT
(
  DA_BATCH_REPORT_ID           NUMBER           DEFAULT 0                     NOT NULL,
  DA_BATCH_SCHED_ID            NUMBER           DEFAULT 0                     NOT NULL,
  DA_REPORT_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  PROCESS_SEQ                  NUMBER           DEFAULT 0                     NOT NULL,
  DA_BATCH_REPORT_DESC         VARCHAR2(100 BYTE),
  ASSIGNED_DOCUMENT_NAME       VARCHAR2(100 BYTE),
  DOC_TYPE_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  RUNTIME_PROMPT_TXT_ID        NUMBER           DEFAULT 0                     NOT NULL,
  REPORT_PARAMETER_TXT_ID      NUMBER           DEFAULT 0                     NOT NULL,
  ADDITIONAL_PARAMETER_TXT_ID  NUMBER           DEFAULT 0                     NOT NULL,
  CREATED_BY_PRSNL_ID          NUMBER           DEFAULT 0                     NOT NULL,
  BEGIN_EFFECTIVE_DT_TM        DATE             DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_IND                   NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_BATCH_REPORT_LOG
(
  DA_BATCH_REPORT_LOG_ID    NUMBER              DEFAULT 0                     NOT NULL,
  DA_BATCH_REPORT_ID        NUMBER              DEFAULT 0                     NOT NULL,
  BATCH_REPORT_START_DT_TM  DATE                DEFAULT SYSDATE               NOT NULL,
  BATCH_REPORT_END_DT_TM    DATE,
  ERROR_TXT_ID              NUMBER              DEFAULT 0                     NOT NULL,
  CREATED_DOCUMENT_ID       NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  DA_BATCH_SCHED_LOG_ID     NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_BATCH_SCHED
(
  DA_BATCH_SCHED_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  DA_BATCH_SCHED_DESC    VARCHAR2(100 BYTE),
  RECURRENCE_FLAG        NUMBER                 DEFAULT 0                     NOT NULL,
  DAY_OF_MONTH           NUMBER,
  DAYS_OF_WEEK           VARCHAR2(8 BYTE),
  TIME_OF_DAY_TXT        VARCHAR2(10 BYTE)      DEFAULT ' '                   NOT NULL,
  FREQ_NBR               NUMBER                 DEFAULT 0                     NOT NULL,
  CREATED_BY_PRSNL_ID    NUMBER                 DEFAULT 0                     NOT NULL,
  BEGIN_EFFECTIVE_DT_TM  DATE                   DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM    DATE                   DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_IND             NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_BATCH_SCHED_LOG
(
  DA_BATCH_SCHED_LOG_ID        NUMBER           DEFAULT 0                     NOT NULL,
  DA_BATCH_SCHED_ID            NUMBER           DEFAULT 0                     NOT NULL,
  BATCH_SCHED_START_DT_TM      DATE             DEFAULT SYSDATE               NOT NULL,
  BATCH_SCHED_END_DT_TM        DATE,
  ERROR_TXT_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  BATCH_SCHED_EXP_START_DT_TM  DATE             DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_DOCUMENT
(
  DA_DOCUMENT_ID           NUMBER               DEFAULT 0                     NOT NULL,
  DA_REPORT_ID             NUMBER               DEFAULT 0                     NOT NULL,
  CREATED_BY_PRSNL_ID      NUMBER               DEFAULT 0                     NOT NULL,
  DOC_TYPE_CD              NUMBER               DEFAULT 0                     NOT NULL,
  REPORT_PARMS_ID          NUMBER               DEFAULT 0                     NOT NULL,
  GENERATED_DOC_ID         NUMBER               DEFAULT 0                     NOT NULL,
  VALID_UNTIL_DT_TM        DATE,
  GENERATED_DT_TM          DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  GENERATED_DATA_ID        NUMBER               DEFAULT 0                     NOT NULL,
  SECURITY_GROUP_CD        NUMBER               DEFAULT 0                     NOT NULL,
  DOCUMENT_NAME_KEY        VARCHAR2(100 BYTE),
  DOCUMENT_NAME_KEY_A_NLS  VARCHAR2(400 BYTE),
  DOCUMENT_NAME            VARCHAR2(100 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_DOCUMENT_ORG_RELTN
(
  DA_DOCUMENT_ORG_RELTN_ID  NUMBER              DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID           NUMBER              DEFAULT 0                     NOT NULL,
  DA_DOCUMENT_ID            NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_FOLDER
(
  DA_FOLDER_ID              NUMBER              DEFAULT 0                     NOT NULL,
  PARENT_FOLDER_ID          NUMBER              DEFAULT 0                     NOT NULL,
  DA_FOLDER_NAME            VARCHAR2(255 BYTE)  DEFAULT ' '                   NOT NULL,
  DA_FOLDER_NAME_KEY        VARCHAR2(255 BYTE)  DEFAULT ' '                   NOT NULL,
  PUBLIC_IND                NUMBER              DEFAULT 0                     NOT NULL,
  CREATE_DT_TM              DATE                DEFAULT SYSDATE               NOT NULL,
  LAST_UPDT_DT_TM           DATE                DEFAULT SYSDATE               NOT NULL,
  LAST_UPDT_USER_ID         NUMBER              DEFAULT 0                     NOT NULL,
  CORE_IND                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  CREATE_PRSNL_ID           NUMBER              DEFAULT 0                     NOT NULL,
  DA_FOLDER_NAME_KEY_A_NLS  VARCHAR2(1020 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_FOLDER_REPORT_RELTN
(
  DA_FOLDER_REPORT_RELTN_ID  NUMBER             DEFAULT 0                     NOT NULL,
  DA_FOLDER_ID               NUMBER             DEFAULT 0                     NOT NULL,
  DA_REPORT_ID               NUMBER             DEFAULT 0                     NOT NULL,
  REPORT_ALIAS_NAME          VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_GROUP_USER_RELTN
(
  DA_GROUP_USER_RELTN_ID  NUMBER                DEFAULT 0                     NOT NULL,
  GROUP_CD                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_QUERY
(
  DA_QUERY_ID             NUMBER                DEFAULT 0                     NOT NULL,
  QUERY_NAME              VARCHAR2(255 BYTE)    DEFAULT ' '                   NOT NULL,
  QUERY_NAME_KEY          VARCHAR2(255 BYTE)    DEFAULT ' '                   NOT NULL,
  QUERY_NAME_KEY_A_NLS    VARCHAR2(1020 BYTE),
  OWNER_PRSNL_ID          NUMBER                DEFAULT 0                     NOT NULL,
  DA_DOMAIN_ID            NUMBER                DEFAULT 0                     NOT NULL,
  OWNER_GROUP_CD          NUMBER                DEFAULT 0                     NOT NULL,
  QUERY_UUID              VARCHAR2(100 BYTE)    DEFAULT ' '                   NOT NULL,
  CREATE_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  FILTER_PROMPT_IND       NUMBER                DEFAULT 0                     NOT NULL,
  QUERY_DESC              VARCHAR2(2000 BYTE)   DEFAULT ' '                   NOT NULL,
  QUERY_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_DT_TM            DATE                  DEFAULT SYSDATE               NOT NULL,
  LAST_UPDT_DT_TM         DATE                  DEFAULT SYSDATE               NOT NULL,
  LAST_UPDT_USER_ID       NUMBER                DEFAULT 0                     NOT NULL,
  CORE_IND                NUMBER                DEFAULT 0                     NOT NULL,
  VERSION_TXT             VARCHAR2(50 BYTE)     DEFAULT ' '                   NOT NULL,
  DEPRECATED_IND          NUMBER                DEFAULT 0                     NOT NULL,
  EXTENDED_IND            NUMBER                DEFAULT 0                     NOT NULL,
  QUERY_TEXT_ID           NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  PUBLIC_IND              NUMBER                DEFAULT 1
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_QUERY_DEFAULT_PROMPTS
(
  DA_QUERY_DEFAULT_PROMPTS_ID  NUMBER           DEFAULT 0                     NOT NULL,
  DA_QUERY_ID                  NUMBER           DEFAULT 0                     NOT NULL,
  USER_PRSNL_ID                NUMBER           DEFAULT 0                     NOT NULL,
  DEFAULT_PROMPTS_TEXT_ID      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_REPORT
(
  DA_REPORT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  DA_DOMAIN_ID            NUMBER                DEFAULT 0                     NOT NULL,
  REPORT_NAME             VARCHAR2(255 BYTE)    DEFAULT ' '                   NOT NULL,
  REPORT_NAME_KEY         VARCHAR2(255 BYTE)    DEFAULT ' '                   NOT NULL,
  OWNER_GROUP_CD          NUMBER                DEFAULT 0                     NOT NULL,
  FILTER_PROMPT_IND       NUMBER                DEFAULT 0                     NOT NULL,
  SHORT_DESC              VARCHAR2(2000 BYTE)   DEFAULT ' '                   NOT NULL,
  REPORT_TYPE_CD          NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_DT_TM            DATE                  DEFAULT SYSDATE               NOT NULL,
  LAST_UPDT_DT_TM         DATE                  DEFAULT SYSDATE               NOT NULL,
  LAST_UPDT_USER_ID       NUMBER                DEFAULT 0                     NOT NULL,
  CORE_IND                NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  BEGIN_EFFECTIVE_DT_TM   DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  OWNER_PRSNL_ID          NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  REPORT_NAME_KEY_A_NLS   VARCHAR2(1020 BYTE),
  REPORT_UUID             VARCHAR2(100 BYTE)    DEFAULT ' '                   NOT NULL,
  VERSION_TXT             VARCHAR2(50 BYTE)     DEFAULT ' '                   NOT NULL,
  DEPRECATED_IND          NUMBER                DEFAULT 0                     NOT NULL,
  EXTENDED_IND            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_REPORT_QUERY_RELTN
(
  DA_REPORT_QUERY_RELTN_ID  NUMBER              DEFAULT 0                     NOT NULL,
  DA_REPORT_ID              NUMBER              DEFAULT 0                     NOT NULL,
  DA_QUERY_ID               NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DA_USER_SECURITY
(
  DA_USER_SECURITY_ID     NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  BEGIN_EFFECTIVE_DT_TM   DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  SECURITY_ASSIGNMENT_CD  NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(30 BYTE),
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ELEMENT_FILTER_TXT_ID   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_ACTIVITY_LOG
(
  ACTIVITY_LOG_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVITY_TYPE_CD     NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVITY_DT_TM       DATE                     DEFAULT SYSDATE               NOT NULL,
  PARENT_ENTITY_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME   VARCHAR2(100 BYTE),
  PARENT_ENTITY_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_CARE_TEAM_PRSNL
(
  CARETEAM_PRSNL_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  CARETEAM_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE ( '12/31/210000:00:00' , 'MM/DD/YYYYHH24:MI:SS' ) NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_CUSTOM_COLS_SORT
(
  COLUMN_SORT_ID      NUMBER                    DEFAULT 0                     NOT NULL,
  SPREAD_TYPE_CD      NUMBER                    DEFAULT 0                     NOT NULL,
  POSITION_CD         NUMBER                    DEFAULT 0                     NOT NULL,
  PRSNL_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  SORT_DIRECTION_IND  NUMBER                    DEFAULT 0,
  COLUMN_DESCRIPTION  VARCHAR2(12 BYTE),
  COLUMN_CD           NUMBER                    DEFAULT 0                     NOT NULL,
  SORT_LEVEL_FLAG     NUMBER,
  SORT_TYPE_FLAG      NUMBER,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_CUSTOM_COLUMNS
(
  SPREAD_COLUMN_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  SPREAD_TYPE_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  CUSTOM_COLUMN_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  CUSTOM_COLUMN_MEANING  VARCHAR2(12 BYTE)      DEFAULT ' '                   NOT NULL,
  POSITION_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  PRSNL_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  CAPTION                VARCHAR2(40 BYTE)      DEFAULT ' '                   NOT NULL,
  SEQUENCE_IND           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_FORMS_ACTIVITY
(
  DCP_FORMS_ACTIVITY_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  DCP_FORMS_REF_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  ENCNTR_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  TASK_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  FORM_DT_TM             DATE,
  BEG_ACTIVITY_DT_TM     DATE,
  LAST_ACTIVITY_DT_TM    DATE,
  ACTIVE_IND             NUMBER                 DEFAULT 1                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  VERSION_DT_TM          DATE,
  DESCRIPTION            VARCHAR2(255 BYTE),
  FLAGS                  NUMBER                 DEFAULT 0,
  FORM_STATUS_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  FORM_TZ                NUMBER                 DEFAULT 0,
  LOCK_PRSNL_ID          NUMBER                 DEFAULT 0,
  LOCK_CREATE_DT_TM      DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_FORMS_ACTIVITY_COMP
(
  DCP_FORMS_ACTIVITY_COMP_ID  NUMBER            DEFAULT 0                     NOT NULL,
  DCP_FORMS_ACTIVITY_ID       NUMBER            DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME          VARCHAR2(32 BYTE),
  PARENT_ENTITY_ID            NUMBER            DEFAULT 0                     NOT NULL,
  DESCRIPTION                 VARCHAR2(100 BYTE),
  COMPONENT_CD                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_FORMS_ACTIVITY_PRSNL
(
  DCP_FORMS_ACTIVITY_PRSNL_ID  NUMBER           DEFAULT 0                     NOT NULL,
  DCP_FORMS_ACTIVITY_ID        NUMBER           DEFAULT 0                     NOT NULL,
  PRSNL_ID                     NUMBER           DEFAULT 0                     NOT NULL,
  PRSNL_FT                     VARCHAR2(100 BYTE),
  PROXY_ID                     NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVITY_DT_TM               DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVITY_TZ                  NUMBER           DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_PATIENT_LIST
(
  PATIENT_LIST_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  NAME                  VARCHAR2(50 BYTE)       DEFAULT ' '                   NOT NULL,
  OWNER_PRSNL_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  DESCRIPTION           VARCHAR2(100 BYTE),
  PATIENT_LIST_TYPE_CD  NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_PL_ARGUMENT
(
  ARGUMENT_ID         NUMBER                    DEFAULT 0                     NOT NULL,
  PATIENT_LIST_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  ARGUMENT_NAME       VARCHAR2(50 BYTE),
  ARGUMENT_VALUE      VARCHAR2(50 BYTE),
  PARENT_ENTITY_NAME  VARCHAR2(100 BYTE),
  PARENT_ENTITY_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  SEQUENCE            NUMBER,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_PL_CUSTOM_ENTRY
(
  CUSTOM_ENTRY_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  PATIENT_LIST_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  ENCNTR_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  PERSON_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  PRSNL_GROUP_ID   NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_PL_ENCNTR_FILTER
(
  ENCNTR_FILTER_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  PATIENT_LIST_ID   NUMBER                      DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CD    NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  ENCNTR_CLASS_CD   NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_PL_PRIORITIZATION
(
  PRIORITY_ID      NUMBER                       DEFAULT 0                     NOT NULL,
  PERSON_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  PATIENT_LIST_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  PRIORITY         NUMBER,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  ENCNTR_ID        NUMBER                       DEFAULT 0,
  REMOVE_IND       NUMBER                       DEFAULT 0,
  REMOVE_DT_TM     DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_PL_QUERY_TEMP_ACCESS
(
  TEMPLATE_ACCESS_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  TEMPLATE_ID         NUMBER                    DEFAULT 0                     NOT NULL,
  POSITION_CD         NUMBER                    DEFAULT 0                     NOT NULL,
  PROVIDER_GROUP_ID   NUMBER                    DEFAULT 0                     NOT NULL,
  PROVIDER_ID         NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_PL_RELTN
(
  RELTN_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  PATIENT_LIST_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_GROUP_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  LIST_ACCESS_CD       NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_PL_STATISTICS
(
  PATIENT_LIST_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  PATIENT_LIST_TYPE  VARCHAR2(12 BYTE)          DEFAULT ' '                   NOT NULL,
  QUAL               NUMBER                     DEFAULT 0                     NOT NULL,
  RESPONSE           FLOAT(126)                 DEFAULT 0                     NOT NULL,
  SECURITY_IND       NUMBER                     DEFAULT 0                     NOT NULL,
  CONFID_IND         NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_PRSNL_LOC_R
(
  PERSON_ID     NUMBER                          DEFAULT 0                     NOT NULL,
  LOCATION_CD   NUMBER                          DEFAULT 0                     NOT NULL,
  ACTIVE_IND    NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  NOTE          VARCHAR2(255 BYTE),
  START_TIME    DATE,
  END_TIME      DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DCP_SHIFT_ASSIGNMENT
(
  ASSIGNMENT_ID        NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  CARETEAM_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  ASSIGNMENT_GROUP_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  ASSIGNMENT_POS_CD    NUMBER                   DEFAULT 0                     NOT NULL,
  LOC_FACILITY_CD      NUMBER                   DEFAULT 0                     NOT NULL,
  LOC_BUILDING_CD      NUMBER                   DEFAULT 0                     NOT NULL,
  LOC_UNIT_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  LOC_ROOM_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  LOC_BED_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  ENCNTR_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  PURGE_IND            NUMBER                   DEFAULT 0,
  ASSIGN_TYPE_CD       NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DD_CONTRIBUTION
(
  DD_CONTRIBUTION_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  AUTHOR_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  DOC_EVENT_ID        NUMBER                    DEFAULT 0                     NOT NULL,
  MDOC_EVENT_ID       NUMBER                    DEFAULT 0                     NOT NULL,
  PERSON_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  ENCNTR_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DD_REF_TEMPLATE
(
  DD_REF_TEMPLATE_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  AUTHOR_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  DESCRIPTION_TXT     VARCHAR2(255 BYTE),
  TITLE_TXT           VARCHAR2(255 BYTE),
  ACTIVE_IND          NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  LONG_BLOB_REF_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  SOURCE_TXT          VARCHAR2(255 BYTE)        DEFAULT ' '                   NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DD_REF_TEMPLATE_CONTENT_R
(
  DD_REF_TEMPLATE_CONTENT_R_ID  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  DD_REF_EMR_CONTENT_ID         NUMBER          DEFAULT 0                     NOT NULL,
  DD_REF_TEMPLATE_ID            NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DD_REF_TMPLT_CN_TMPLT_R
(
  DD_REF_TMPLT_CN_TMPLT_R_ID  NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  CLINICAL_NOTE_TEMPLATE_ID   NUMBER            DEFAULT 0                     NOT NULL,
  DD_REF_TEMPLATE_ID          NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DD_SESSION
(
  DD_SESSION_ID       NUMBER                    DEFAULT 0                     NOT NULL,
  SESSION_USER_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  SESSION_DT_TM       DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME  VARCHAR2(30 BYTE)         DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID    NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DD_SESSION_DATA
(
  DD_SESSION_DATA_ID      NUMBER                DEFAULT 0                     NOT NULL,
  LONG_BLOB_ID            NUMBER                DEFAULT 0                     NOT NULL,
  DD_SESSION_ID           NUMBER                DEFAULT 0                     NOT NULL,
  SESSION_DATA_KEY        VARCHAR2(80 BYTE)     DEFAULT ' '                   NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  CONTENT_INSTANCE_IDENT  VARCHAR2(255 BYTE),
  SHORT_TXT               VARCHAR2(255 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DELIVERY_SYSTEM
(
  DELIVERY_SYSTEM_ID      NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DEM_XTRCT_NSTNC
(
  DEM_XTRCT_NSTNC_ID      NUMBER                DEFAULT 0                     NOT NULL,
  DEM_XTRCT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVITY_DT_TM          DATE,
  QLFCTN_CMPLTN_DT_TM     DATE,
  SLICE_CNT               NUMBER                DEFAULT 0                     NOT NULL,
  SLICE_ITEM_CNT          NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  MILL_LOGICAL_DOMAIN_ID  NUMBER                DEFAULT 0,
  ACTIVITY_TZ             NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DEM_XTRCT_NSTNC_SLC
(
  DEM_XTRCT_NSTNC_SLC_ID  NUMBER                DEFAULT 0                     NOT NULL,
  DEM_XTRCT_NSTNC_ID      NUMBER                DEFAULT 0                     NOT NULL,
  NSTNCE_SLC_STATUS_FLAG  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DEM_XTRCT_NSTNC_SLC_ITEM
(
  DEM_XTRCT_NSTNC_SLC_ITEM_ID  NUMBER           DEFAULT 0                     NOT NULL,
  DEM_XTRCT_NSTNC_SLC_ID       NUMBER           DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID             NUMBER           DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME           VARCHAR2(30 BYTE) DEFAULT ' ' NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DENIAL
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  BILL_VRSN_NBR           NUMBER,
  CORSP_ACTIVITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  DENIAL_ID               NUMBER                DEFAULT 0                     NOT NULL,
  DENIAL_REASON_CD        NUMBER                DEFAULT 0                     NOT NULL,
  DENIAL_TXT              VARCHAR2(255 BYTE),
  END_EFFECTIVE_DT_TM     DATE,
  JOURNAL_BO_RELTN_ID     NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  DENIAL_CODE_TXT         VARCHAR2(25 BYTE),
  BATCH_TRANS_FILE_ID     NUMBER                DEFAULT 0                     NOT NULL,
  DENIAL_TYPE_CD          NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DENIAL_DETAIL
(
  DENIAL_DETAIL_ID          NUMBER              DEFAULT 0                     NOT NULL,
  DENIAL_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  REMARK_CODE_ATTRIB_CD     NUMBER              DEFAULT 0                     NOT NULL,
  REMARK_CODE_ATTRIB_VALUE  VARCHAR2(40 BYTE),
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DEPARTMENT
(
  SERVICE_RESOURCE_CD       NUMBER              DEFAULT 0                     NOT NULL,
  CHARGE_COST_RATIO         NUMBER,
  REIMBURSEMENT_COST_RATIO  NUMBER,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  EXAMONLY_HOLD_TIME_HRS    NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DEPOSIT_ACCT
(
  DEPOSIT_ACCT_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  DEPOSIT_ACCT_DESC       VARCHAR2(200 BYTE),
  DEPOSIT_ACCT_CUR_CD     NUMBER                DEFAULT 0                     NOT NULL,
  EXT_ACCT_ID_TXT         VARCHAR2(50 BYTE),
  GLOBAL_IND              NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  EXT_ACCT_ID_TXT_KEY     VARCHAR2(250 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DEPOSIT_RECORD
(
  DEPOSIT_RECORD_ID       NUMBER                DEFAULT 0                     NOT NULL,
  DEPOSIT_ACCT_ID         NUMBER                DEFAULT 0                     NOT NULL,
  DEPOSIT_AMOUNT          FLOAT(126),
  ACTIVITY_ID             NUMBER                DEFAULT 0                     NOT NULL,
  ITEM_CNT                NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  DEPOSIT_DT_TM           DATE,
  EXT_DEPOSIT_NBR_TXT     VARCHAR2(40 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DEP_REC_BATCH_TRANS_RELTN
(
  ACTIVE_IND                    NUMBER,
  ACTIVE_STATUS_CD              NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM           DATE,
  ACTIVE_STATUS_PRSNL_ID        NUMBER          DEFAULT 0                     NOT NULL,
  BATCH_TRANS_ID                NUMBER          DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM           DATE            DEFAULT SYSDATE,
  DEPOSIT_RECORD_ID             NUMBER          DEFAULT 0                     NOT NULL,
  DEP_REC_BATCH_TRANS_RELTN_ID  NUMBER          DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM           DATE            DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DERIVATIVE
(
  PRODUCT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_CD              NUMBER                DEFAULT 0                     NOT NULL,
  ITEM_VOLUME             NUMBER,
  ITEM_UNIT_MEAS_CD       NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  MANUFACTURER_ID         NUMBER                DEFAULT 0                     NOT NULL,
  CUR_AVAIL_QTY           NUMBER,
  CUR_INTL_UNITS          NUMBER,
  UNITS_PER_VIAL          NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DESTRUCTION
(
  PRODUCT_EVENT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  METHOD_CD               NUMBER                DEFAULT 0                     NOT NULL,
  BOX_NBR                 VARCHAR2(50 BYTE),
  MANIFEST_NBR            VARCHAR2(50 BYTE),
  DESTROYED_QTY           NUMBER,
  AUTOCLAVE_IND           NUMBER,
  DESTRUCTION_ORG_ID      NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DEVICE_HL7_MAP
(
  DEVICE_HL7_MAP_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  DEVICE_CD             NUMBER                  DEFAULT 0                     NOT NULL,
  SEGMENT_CD            NUMBER                  DEFAULT 0                     NOT NULL,
  FIELD_POSITION        NUMBER                  DEFAULT 0                     NOT NULL,
  COMPONENT_POSITION    NUMBER                  DEFAULT 0                     NOT NULL,
  COMPONENT_FORMAT_CD   NUMBER                  DEFAULT 0                     NOT NULL,
  MAX_LENGTH            NUMBER                  DEFAULT 0                     NOT NULL,
  RESULT_SET_POSITION   NUMBER                  DEFAULT 0                     NOT NULL,
  REQUIRED_IND          NUMBER                  DEFAULT 0                     NOT NULL,
  COMMON_IND            NUMBER                  DEFAULT 0                     NOT NULL,
  COMPONENT_CD          NUMBER                  DEFAULT 0                     NOT NULL,
  ACTIVE_IND            NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  STRT_MODEL_FORMAT_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  COMPONENT_ORDER       NUMBER                  DEFAULT 0                     NOT NULL,
  STRT_HL7_MAP_ID       NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DEVICE_OUTPUT_RELTN
(
  DEVICE_OUTPUT_RELTN_ID  NUMBER                DEFAULT 0                     NOT NULL,
  DEVICE_CD               NUMBER                DEFAULT 0                     NOT NULL,
  OUTPUT_CONTENT_TYPE_CD  NUMBER                DEFAULT 0                     NOT NULL,
  DEFAULT_IND             NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  ENVELOPE_PROCESS_CD     NUMBER                DEFAULT 0,
  TEMPLATE_ID             NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DEVICE_OUTPUT_RELTN_R
(
  DEVICE_OUTPUT_RELTN_R_ID  NUMBER              DEFAULT 0                     NOT NULL,
  DEVICE_OUTPUT_RELTN_ID    NUMBER              DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID           NUMBER              DEFAULT 0                     NOT NULL,
  EVENT_SET_CD              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DIAGNOSIS
(
  DIAGNOSIS_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  CONTRIBUTOR_SYSTEM_CD        NUMBER           DEFAULT 0                     NOT NULL,
  PERSON_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID              NUMBER           DEFAULT 0                     NOT NULL,
  DIAG_DT_TM                   DATE,
  DIAG_TYPE_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  DIAGNOSTIC_CATEGORY_CD       NUMBER           DEFAULT 0                     NOT NULL,
  DIAG_PRIORITY                NUMBER,
  DIAG_PRSNL_ID                NUMBER           DEFAULT 0                     NOT NULL,
  DIAG_PRSNL_NAME              VARCHAR2(100 BYTE),
  DIAG_CLASS_CD                NUMBER           DEFAULT 0                     NOT NULL,
  CONFID_LEVEL_CD              NUMBER           DEFAULT 0                     NOT NULL,
  ATTESTATION_DT_TM            DATE,
  REFERENCE_NBR                VARCHAR2(100 BYTE),
  SEG_UNIQUE_KEY               VARCHAR2(100 BYTE),
  DIAG_FTDESC                  VARCHAR2(255 BYTE),
  MOD_NOMENCLATURE_ID          NUMBER           DEFAULT 0                     NOT NULL,
  SVC_CAT_HIST_ID              NUMBER           DEFAULT 0                     NOT NULL,
  DIAG_NOTE                    VARCHAR2(255 BYTE),
  CONDITIONAL_QUAL_CD          NUMBER           DEFAULT 0                     NOT NULL,
  CLINICAL_SERVICE_CD          NUMBER           DEFAULT 0                     NOT NULL,
  CONFIRMATION_STATUS_CD       NUMBER           DEFAULT 0                     NOT NULL,
  CLASSIFICATION_CD            NUMBER           DEFAULT 0                     NOT NULL,
  SEVERITY_CLASS_CD            NUMBER           DEFAULT 0                     NOT NULL,
  CERTAINTY_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  PROBABILITY                  NUMBER,
  DIAGNOSIS_DISPLAY            VARCHAR2(255 BYTE),
  SEVERITY_FTDESC              VARCHAR2(40 BYTE),
  LONG_BLOB_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  RANKING_CD                   NUMBER           DEFAULT 0                     NOT NULL,
  SEVERITY_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  DIAGNOSIS_GROUP              FLOAT(126)       DEFAULT 0                     NOT NULL,
  CLINICAL_DIAG_PRIORITY       NUMBER,
  ENCNTR_SLICE_ID              NUMBER           DEFAULT 0,
  PRESENT_ON_ADMIT_CD          NUMBER           DEFAULT 0,
  LATERALITY_CD                NUMBER           DEFAULT 0,
  ORIGINATING_NOMENCLATURE_ID  NUMBER           DEFAULT 0,
  HAC_IND                      NUMBER           DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DIAGNOSIS_ACTION
(
  DIAGNOSIS_ACTION_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  DIAGNOSIS_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  DIAGNOSIS_GROUP      FLOAT(126)               DEFAULT 0                     NOT NULL,
  PRSNL_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  ACTION_TYPE_MEAN     VARCHAR2(12 BYTE)        DEFAULT ' '                   NOT NULL,
  ACTION_DT_TM         DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DIAGNOSIS_HIST
(
  DIAGNOSIS_HIST_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  DIAGNOSIS_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  ENCNTR_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  SVC_CAT_HIST_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  DIAG_DT_TM             DATE,
  DIAG_PRIORITY          NUMBER                 DEFAULT 0                     NOT NULL,
  DIAG_TYPE_CD           NUMBER                 DEFAULT 0                     NOT NULL,
  HAC_IND                NUMBER                 DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  PRESENT_ON_ADMIT_CD    NUMBER                 DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM    DATE,
  END_EFFECTIVE_DT_TM    DATE,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  ACTIVE_IND             NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DISPENSE_CATEGORY
(
  DISPENSE_CATEGORY_CD           NUMBER         DEFAULT 0                     NOT NULL,
  DISP_FILL_QTY_IND              NUMBER,
  INTERIM_DISP_QTY_IND           NUMBER,
  ROUND_DISP_QTY_IND             NUMBER,
  DISP_FROM_PHLOCN_IND           NUMBER,
  CHARGE_PT_SCH_IND              NUMBER,
  CHARGE_PT_PRN_IND              NUMBER,
  DISP_QTY_RATIO_IND             NUMBER,
  LAST_RESORT_FILL_HRS           NUMBER,
  LAST_RESORT_FILL_TIME          NUMBER,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  PRICE_SCHED_ID                 NUMBER         DEFAULT 0                     NOT NULL,
  ORDER_TYPE_FLAG                NUMBER,
  LABEL_FORMAT_CD                NUMBER         DEFAULT 0                     NOT NULL,
  FILL_LIST_FORMAT_CD            NUMBER         DEFAULT 0                     NOT NULL,
  REPLACE_EVERY                  NUMBER         DEFAULT 0,
  LBL_PER_DOSE                   NUMBER         DEFAULT 0,
  LEAFLET_FORMAT_CD              FLOAT(126)     DEFAULT 0                     NOT NULL,
  PHARM_TYPE_CD                  FLOAT(126)     DEFAULT 0                     NOT NULL,
  VALIDATION_FORMAT_CD           FLOAT(126)     DEFAULT 0                     NOT NULL,
  PREVIEW_FORMAT_CD              NUMBER,
  REPORT_FORMAT_CD               NUMBER         DEFAULT 0,
  TPN_IND                        NUMBER,
  INTERIM_DAYS_SUP_PKG_IND       NUMBER         DEFAULT 0,
  REFILL_NOTIFY_FORMAT_CD        NUMBER         DEFAULT 0,
  INTERIM_DAYS_SUPPLY_IND        NUMBER         DEFAULT 0,
  UNSUPPORTED_LBL_PRINTING_FLAG  NUMBER         DEFAULT 0,
  UNSUPPORTED_PROD_PKG_IND       NUMBER         DEFAULT 0,
  UNSUPPORTED_DAYS_SUPPLY_AMT    NUMBER         DEFAULT 0,
  UNSUPPORTED_DAYS_SUPPLY_IND    NUMBER         DEFAULT 0,
  UNSUPPORTED_DOSES_AMT          NUMBER         DEFAULT 0,
  UNSUPPORTED_DOSES_IND          NUMBER         DEFAULT 0,
  DISP_FILL_LBL_PRINTING_FLAG    NUMBER         DEFAULT 0,
  DISP_FILL_PROD_PKG_IND         NUMBER         DEFAULT 0,
  DISP_FILL_DAYS_SUPPLY_AMT      NUMBER         DEFAULT 0,
  DISP_FILL_DAYS_SUPPLY_IND      NUMBER         DEFAULT 0,
  INTERIM_LBL_PRINTING_FLAG      NUMBER         DEFAULT 0,
  INTERIM_PROD_PKG_IND           NUMBER         DEFAULT 0,
  INTERIM_DAYS_SUPPLY_AMT        NUMBER         DEFAULT 0,
  UNSUPPORTED_DAYS_SUP_PKG_IND   NUMBER         DEFAULT 0,
  DISP_FILL_DAYS_SUP_PKG_IND     NUMBER         DEFAULT 0,
  TEMP_STOCK_IND                 NUMBER         DEFAULT 0,
  CHARGE_ON_SCHED_ADMIN_IND      NUMBER         DEFAULT 0,
  AUTO_CREDIT_IND                NUMBER         DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DISPENSE_CATEGORY_FORM_R
(
  DISPENSE_CATEGORY_CD  NUMBER                  DEFAULT 0                     NOT NULL,
  FORM_CD               NUMBER                  DEFAULT 0                     NOT NULL,
  USAGE_FLAG            NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DISPENSE_HX
(
  DISPENSE_HX_ID              NUMBER            DEFAULT 0                     NOT NULL,
  ORDER_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE             NUMBER            DEFAULT 0                     NOT NULL,
  DISP_EVENT_TYPE_CD          NUMBER            DEFAULT 0                     NOT NULL,
  REASON_CD                   NUMBER            DEFAULT 0                     NOT NULL,
  FILL_HX_ID                  NUMBER            DEFAULT 0                     NOT NULL,
  DOSES                       FLOAT(126)        DEFAULT 0,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  EVENT_TOTAL_PRICE           FLOAT(126)        DEFAULT 0,
  FIRST_DOSE_TIME             DATE,
  RUN_USER_ID                 NUMBER            DEFAULT 0                     NOT NULL,
  CHARGE_IND                  NUMBER,
  CHRG_DISPENSE_HX_ID         NUMBER            DEFAULT 0                     NOT NULL,
  DISPENSE_DT_TM              DATE,
  FIRST_IV_SEQ                NUMBER            DEFAULT 0,
  NEXT_DISPENSE_DT_TM         DATE,
  PREV_DISPENSE_DT_TM         DATE,
  EVENT_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  DISP_PRIORITY_CD            NUMBER            DEFAULT 0                     NOT NULL,
  REIMBURSEMENT               FLOAT(126),
  COPAY                       FLOAT(126),
  DISCOUNT_AMOUNT             FLOAT(126),
  DISP_PRIORITY_DT_TM         DATE,
  DISP_QTY                    FLOAT(126),
  DISP_SR_CD                  NUMBER            DEFAULT 0                     NOT NULL,
  FILL_NBR                    NUMBER,
  PHARM_TYPE_CD               NUMBER            DEFAULT 0                     NOT NULL,
  TRACK_NBR                   FLOAT(126),
  TRACK_NBR_CD                NUMBER            DEFAULT 0                     NOT NULL,
  UC_PRICE                    FLOAT(126),
  DISP_QTY_UNIT_CD            FLOAT(126)        DEFAULT 0                     NOT NULL,
  EXTRA_REASON_CD             FLOAT(126)        DEFAULT 0                     NOT NULL,
  EARLY_REASON_CD             FLOAT(126)        DEFAULT 0                     NOT NULL,
  LATE_REASON_CD              FLOAT(126)        DEFAULT 0                     NOT NULL,
  COST                        FLOAT(126),
  HEALTH_PLAN_ID              NUMBER            DEFAULT 0                     NOT NULL,
  CRDT_DISPENSE_HX_ID         NUMBER            DEFAULT 0                     NOT NULL,
  ORG_ACTION_SEQUENCE         NUMBER,
  REFILLS_REMAINING           FLOAT(126),
  QTY_REMAINING               FLOAT(126),
  SALES_TAX                   FLOAT(126),
  DISPENSE_FEE                FLOAT(126),
  INCENTIVE_AMT               FLOAT(126),
  LEVEL5_CD                   NUMBER            DEFAULT 0                     NOT NULL,
  PF_REASON_CD                NUMBER            DEFAULT 0                     NOT NULL,
  PF_DISPENSE_HX_ID           NUMBER            DEFAULT 0                     NOT NULL,
  BILL_QTY                    FLOAT(126),
  AUTHORIZATION_NBR           VARCHAR2(50 BYTE),
  CHARGE_DT_TM                DATE,
  DISP_LOC_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  NEXT_DISPENSE_TZ            NUMBER            DEFAULT 0,
  PREV_DISPENSE_TZ            NUMBER            DEFAULT 0,
  DISPENSE_TZ                 NUMBER            DEFAULT 0,
  DISP_PRIORITY_TZ            NUMBER            DEFAULT 0,
  CHARGE_TZ                   NUMBER            DEFAULT 0,
  FIRST_DOSE_TZ               NUMBER            DEFAULT 0,
  FUTURE_CHARGE_IND           NUMBER            DEFAULT 0,
  RESIDUAL_PRICE              FLOAT(126)        DEFAULT 0,
  RESIDUAL_DOSES              FLOAT(126)        DEFAULT 0,
  REVERSE_IND                 NUMBER            DEFAULT 0,
  REV_DISPENSE_HX_ID          NUMBER            DEFAULT 0                     NOT NULL,
  DISPENSE_PRSNL_ID           NUMBER            DEFAULT 0                     NOT NULL,
  WITNS_PRSNL_ID              NUMBER            DEFAULT 0                     NOT NULL,
  REFR_DISPENSE_HX_ID         NUMBER            DEFAULT 0                     NOT NULL,
  TRANSFER_TO_LOC_CD          NUMBER            DEFAULT 0,
  RESIDUAL_DISP_QTY           FLOAT(126),
  RESIDUAL_COST_AMT           FLOAT(126),
  RESIDUAL_INCENTIVE_FEE_AMT  FLOAT(126),
  RESIDUAL_DISPENSE_FEE_AMT   FLOAT(126),
  RESIDUAL_DISCOUNT_AMT       FLOAT(126),
  RESIDUAL_SALES_TAX_AMT      FLOAT(126),
  RESIDUAL_COPAY_AMT          FLOAT(126),
  RESIDUAL_UC_PRICE           FLOAT(126),
  RESIDUAL_REIMBURSEMENT_AMT  FLOAT(126),
  REBILL_DISPENSE_HX_ID       NUMBER            DEFAULT 0,
  REBILL_FLAG                 NUMBER            DEFAULT 0,
  CHARGE_ON_SCHED_ADMIN_IND   NUMBER            DEFAULT 0,
  AUTO_CREDIT_IND             NUMBER            DEFAULT 0,
  FIRST_SCHEDULE_SEQ          NUMBER            DEFAULT 0,
  UNIQUE_SCHEDULE_SEQ_NBR     NUMBER            DEFAULT 0,
  SKIPPED_SCHEDULE_SEQ        NUMBER            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DISPENSE_HX_ALIAS
(
  DISPENSE_HX_ALIAS_ID       NUMBER             DEFAULT 0                     NOT NULL,
  DISPENSE_HX_ID             NUMBER             DEFAULT 0                     NOT NULL,
  QUEUE_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  ALIAS                      VARCHAR2(200 BYTE) DEFAULT ' ' NOT NULL,
  ALIAS_POOL_CD              NUMBER             DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD      NUMBER             DEFAULT 0                     NOT NULL,
  DISPENSE_HX_ALIAS_TYPE_CD  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID     NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DISPENSE_RETURN
(
  PRODUCT_EVENT_ID              NUMBER          DEFAULT 0                     NOT NULL,
  DISPENSE_RETURN_ID            NUMBER          DEFAULT 0                     NOT NULL,
  PRODUCT_ID                    NUMBER          DEFAULT 0                     NOT NULL,
  RETURN_DT_TM                  DATE,
  RETURN_PRSNL_ID               NUMBER          DEFAULT 0                     NOT NULL,
  RETURN_REASON_CD              NUMBER          DEFAULT 0                     NOT NULL,
  RETURN_VIS_INSP_CD            NUMBER          DEFAULT 0                     NOT NULL,
  RETURN_COURIER_ID             NUMBER          DEFAULT 0                     NOT NULL,
  RETURN_QTY                    NUMBER,
  RETURN_INTL_UNITS             NUMBER,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_IND                    NUMBER,
  ACTIVE_STATUS_CD              NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM           DATE,
  ACTIVE_STATUS_PRSNL_ID        NUMBER          DEFAULT 0                     NOT NULL,
  RETURN_COURIER_TEXT           VARCHAR2(100 BYTE),
  RETURN_TEMPERATURE_DEGREE_CD  NUMBER          DEFAULT 0,
  RETURN_TEMPERATURE_VALUE      NUMBER,
  RETURN_TEMPERATURE_TXT        VARCHAR2(15 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DISPENSE_STATUS
(
  DISPENSE_STATUS_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  DISPENSE_HX_ID      NUMBER                    DEFAULT 0                     NOT NULL,
  DISPENSE_STATUS_CD  NUMBER                    DEFAULT 0                     NOT NULL,
  SUBSECTION_CD       NUMBER                    DEFAULT 0                     NOT NULL,
  LEVEL5_CD           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DISPENSE_STATUS_ERR
(
  DISPENSE_STATUS_ERR_ID  NUMBER                DEFAULT 0                     NOT NULL,
  DISPENSE_HX_ID          NUMBER                DEFAULT 0                     NOT NULL,
  COMPLETED_DT_TM         DATE                  DEFAULT SYSDATE               NOT NULL,
  COMPLETED_USER_ID       NUMBER                DEFAULT 0                     NOT NULL,
  DISPENSE_STATUS_CD      NUMBER                DEFAULT 0                     NOT NULL,
  DISPENSE_QTY            FLOAT(126)            DEFAULT 0                     NOT NULL,
  DISPENSE_ERR_CD         NUMBER                DEFAULT 0                     NOT NULL,
  POSTED_DT_TM            DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  COMPLETED_TZ            NUMBER                DEFAULT 0,
  POSTED_TZ               NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DISPENSE_STATUS_HX
(
  DISPENSE_STATUS_HX_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  DISPENSE_HX_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  DISPENSE_STATUS_CD     NUMBER                 DEFAULT 0                     NOT NULL,
  COMPLETED_DT_TM        DATE,
  COMPLETED_USER_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  SUBSECTION_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  LEVEL5_CD              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  COMPLETED_TZ           NUMBER                 DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DISPOSITION
(
  PRODUCT_EVENT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  REASON_CD               NUMBER                DEFAULT 0                     NOT NULL,
  DISPOSED_QTY            NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  DISPOSED_INTL_UNITS     NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DIST_LINE_DETAIL
(
  DIST_LINE_DETAIL_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  DISTRIBUTION_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  LINE_ITEM_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  ACTUAL_ITEM_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  ACTUAL_FILL_LOC_CD   NUMBER                   DEFAULT 0                     NOT NULL,
  CREATE_DT_TM         DATE                     DEFAULT SYSDATE               NOT NULL,
  CREATE_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  CREATE_TASK          NUMBER                   DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX       NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DIST_LINE_ITEM_R
(
  DISTRIBUTION_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  LINE_ITEM_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  FROM_COST_CENTER_CD  NUMBER                   DEFAULT 0,
  FROM_SUB_ACCOUNT_CD  NUMBER                   DEFAULT 0,
  TO_COST_CENTER_CD    NUMBER                   DEFAULT 0,
  TO_SUB_ACCOUNT_CD    NUMBER                   DEFAULT 0,
  CREATE_DT_TM         DATE                     DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  CREATE_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  CREATE_TASK          NUMBER                   DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX       NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  BACKORDER_IND        NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DIST_REQ_R
(
  DISTRIBUTION_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  REQUISITION_ID   NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DI_CLIENT_CONFIG
(
  DI_CLIENT_CONFIG_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  DEVICE_NAME          VARCHAR2(256 BYTE)       DEFAULT ' '                   NOT NULL,
  SUBSCRIPTION_NAME    VARCHAR2(256 BYTE)       DEFAULT ' '                   NOT NULL,
  EDC_SERVICE_TYPE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  EDC_ENVIRONMENT      VARCHAR2(255 BYTE),
  SAMPLE_PERIOD        NUMBER                   DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DMS_DISTLIST
(
  DMS_DISTLIST_ID   NUMBER                      DEFAULT 0                     NOT NULL,
  NAME              VARCHAR2(32 BYTE)           DEFAULT ' '                   NOT NULL,
  DESCRIPTION       VARCHAR2(255 BYTE)          DEFAULT ' '                   NOT NULL,
  OWNER_USERNAME    VARCHAR2(32 BYTE)           DEFAULT ' '                   NOT NULL,
  PRIVATE_IND       NUMBER                      DEFAULT 0                     NOT NULL,
  CREATOR_USERNAME  VARCHAR2(32 BYTE)           DEFAULT ' '                   NOT NULL,
  CREATED_DT_TM     DATE                        DEFAULT sysdate               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  CREATED_BY_ID     NUMBER                      DEFAULT 0                     NOT NULL,
  OWNER_ID          NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DMS_DISTLIST_MEMBER
(
  DMS_DISTLIST_MEMBER_ID  NUMBER                DEFAULT 0                     NOT NULL,
  DMS_DISTLIST_ID         NUMBER                DEFAULT 0                     NOT NULL,
  SERVICE_NAME            VARCHAR2(128 BYTE)    DEFAULT ' '                   NOT NULL,
  SERVICE_TYPE_FLAG       NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DMS_EVENT
(
  DMS_EVENT_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  DMS_MEDIA_INSTANCE_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  DMS_EVENT_REF_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  CREATED_BY_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  EVENT_DT_TM            DATE                   DEFAULT sysdate               NOT NULL,
  EVENT_DETAIL           VARCHAR2(255 BYTE),
  LONG_TEXT_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  DMS_REASON_REF_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  EVENT_COMMENT          VARCHAR2(255 BYTE),
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DMS_MEDIA_GROUP
(
  DMS_MEDIA_GROUP_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  DMS_MEDIA_PARENT_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  DMS_MEDIA_CHILD_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  DMS_MEDIA_SEQUENCE   NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DMS_MEDIA_INSTANCE
(
  DMS_MEDIA_INSTANCE_ID          NUMBER         DEFAULT 0                     NOT NULL,
  IDENTIFIER                     VARCHAR2(64 BYTE) DEFAULT ' ' NOT NULL,
  VERSION                        NUMBER         DEFAULT 0                     NOT NULL,
  CONTENT_TYPE                   VARCHAR2(32 BYTE) DEFAULT ' ' NOT NULL,
  CONTENT_UID                    VARCHAR2(64 BYTE) DEFAULT ' ' NOT NULL,
  CONTENT_SIZE                   NUMBER         DEFAULT 0                     NOT NULL,
  MEDIA_TYPE                     VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  THUMBNAIL_UID                  VARCHAR2(64 BYTE),
  CREATED_BY_ID                  NUMBER         DEFAULT 0                     NOT NULL,
  CREATED_DT_TM                  DATE           DEFAULT sysdate               NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  DMS_CONTENT_TYPE_ID            NUMBER         DEFAULT 0                     NOT NULL,
  NAME                           VARCHAR2(255 BYTE),
  METADATA_VERSION               NUMBER,
  LONG_TEXT_ID                   NUMBER         DEFAULT 0                     NOT NULL,
  CHECKSUM                       NUMBER         DEFAULT 0,
  DMS_MEDIA_IDENTIFIER_ID        NUMBER         DEFAULT 0                     NOT NULL,
  ENCRYPTION_IND                 NUMBER         DEFAULT 0,
  DMS_REPOSITORY_ID              NUMBER         DEFAULT 0,
  DMS_MEDIA_IDENTIFIER_GROUP_ID  NUMBER         DEFAULT 0,
  LONG_BLOB_ID                   NUMBER         DEFAULT 0,
  STATUS_FLAG                    NUMBER         DEFAULT 1                     NOT NULL,
  CONTRIBUTION_DT_TM             DATE,
  SERVICESTOP_TZ                 NUMBER         DEFAULT 0,
  SERVICESTOP_PREC_FLAG          NUMBER         DEFAULT 0,
  CONSUMERCREATED_DT_TM          DATE,
  CONTRIBUTOR_ID                 NUMBER         DEFAULT 0                     NOT NULL,
  APP_CTX                        VARCHAR2(128 BYTE),
  STORED_AS_DICOM_IND            NUMBER         DEFAULT 0,
  DMS_XML_METADATA_ID            NUMBER         DEFAULT 0                     NOT NULL,
  CONSUMERCREATED_TZ             NUMBER         DEFAULT 0,
  CONSUMERCREATED_PREC_FLAG      NUMBER         DEFAULT 0,
  SERVICESTART_DT_TM             DATE           DEFAULT SYSDATE,
  SERVICESTART_TZ                NUMBER         DEFAULT 0,
  SERVICESTART_PREC_FLAG         NUMBER         DEFAULT 0,
  SERVICESTOP_DT_TM              DATE           DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS')
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DMS_MEDIA_METADATA
(
  DMS_MEDIA_METADATA_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  DMS_MEDIA_INSTANCE_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  TAG_NAME               VARCHAR2(40 BYTE)      DEFAULT ' '                   NOT NULL,
  TAG_PATH               VARCHAR2(255 BYTE)     DEFAULT ' '                   NOT NULL,
  TAG_VALUE              VARCHAR2(255 BYTE)     DEFAULT ' '                   NOT NULL,
  TAG_SEQ                NUMBER,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DMS_MEDIA_SIGNATURE
(
  DMS_MEDIA_SIGNATURE_ID  NUMBER                DEFAULT 0                     NOT NULL,
  DMS_MEDIA_INSTANCE_ID   NUMBER                DEFAULT 0                     NOT NULL,
  SIGNATURE_BLOB_ID       NUMBER                DEFAULT 0                     NOT NULL,
  SIGNER                  VARCHAR2(100 BYTE)    DEFAULT ' '                   NOT NULL,
  SIGN_DT_TM              DATE                  DEFAULT sysdate               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DMS_PROFILE_DETAIL
(
  DMS_PROFILE_DETAIL_ID   NUMBER                DEFAULT 0                     NOT NULL,
  DMS_PROFILE_SERVICE_ID  NUMBER                DEFAULT 0                     NOT NULL,
  DETAIL_NAME             VARCHAR2(32 BYTE)     DEFAULT ' '                   NOT NULL,
  DETAIL_VALUE            VARCHAR2(255 BYTE)    DEFAULT ' '                   NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DMS_PROFILE_SERVICE
(
  DMS_PROFILE_SERVICE_ID  NUMBER                DEFAULT 0                     NOT NULL,
  DMS_PROFILE_ID          NUMBER                DEFAULT 0                     NOT NULL,
  DMS_CONTENT_TYPE_ID     NUMBER                DEFAULT 0                     NOT NULL,
  SERVICE_NAME            VARCHAR2(64 BYTE)     DEFAULT ' '                   NOT NULL,
  SERVICE_TYPE_FLAG       NUMBER                DEFAULT 0                     NOT NULL,
  FROM_POSITION_CD        NUMBER                DEFAULT 0                     NOT NULL,
  FROM_PRSNL_ID           NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DMS_VIEWER
(
  DMS_VIEWER_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  CONTENT_TYPE_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  MIME_TYPE_NAME         VARCHAR2(255 BYTE),
  EXTENSION_TXT          VARCHAR2(32 BYTE),
  VIEWER_NAME            VARCHAR2(255 BYTE)     DEFAULT ' '                   NOT NULL,
  VIEWER_TYPE_FLAG       NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  INSTANCE_LIMIT_NBR     NUMBER                 DEFAULT 1                     NOT NULL,
  VIEWER_AUXILIARY_TXT   VARCHAR2(255 BYTE),
  DMS_MEDIA_INSTANCE_ID  NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DM_COMBINE_ERROR
(
  COMBINE_ERROR_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  CALLING_SCRIPT    VARCHAR2(30 BYTE),
  OPERATION_TYPE    VARCHAR2(20 BYTE)           DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY     VARCHAR2(32 BYTE)           DEFAULT ' '                   NOT NULL,
  COMBINE_ID        NUMBER                      DEFAULT 0                     NOT NULL,
  FROM_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  TO_ID             NUMBER                      DEFAULT 0                     NOT NULL,
  ENCNTR_ID         NUMBER                      DEFAULT 0                     NOT NULL,
  ERROR_TABLE       VARCHAR2(32 BYTE),
  ERROR_TYPE        VARCHAR2(50 BYTE),
  ERROR_MSG         VARCHAR2(132 BYTE),
  RESOLVED_IND      NUMBER                      DEFAULT 0,
  CREATE_DT_TM      DATE,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  COMBINE_MODE      VARCHAR2(20 BYTE),
  APPLICATION_FLAG  NUMBER,
  TRANSACTION_TYPE  VARCHAR2(8 BYTE),
  DM2_MIG_SEQ_ID    NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DM_COMBINE_QUEUE
(
  QUEUE_ID       NUMBER                         DEFAULT 0                     NOT NULL,
  PARENT_TABLE   VARCHAR2(30 BYTE)              DEFAULT ' '                   NOT NULL,
  FROM_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  TO_ID          NUMBER                         DEFAULT 0                     NOT NULL,
  ENCNTR_ID      NUMBER                         DEFAULT 0                     NOT NULL,
  COMBINED_FLAG  NUMBER                         DEFAULT 0,
  CREATE_DT_TM   DATE,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  BATCH_ERR_MSG  VARCHAR2(100 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DM_INFO
(
  INFO_DOMAIN     VARCHAR2(80 BYTE)             DEFAULT 'DATA MANAGEMENT'     NOT NULL,
  INFO_NAME       VARCHAR2(255 BYTE)            DEFAULT ' '                   NOT NULL,
  INFO_DATE       DATE,
  INFO_CHAR       VARCHAR2(4000 BYTE),
  INFO_NUMBER     FLOAT(126),
  INFO_LONG_ID    NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  INFO_DOMAIN_ID  NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DM_PREFS
(
  PREF_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  APPLICATION_NBR     NUMBER                    DEFAULT 0                     NOT NULL,
  PERSON_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  PREF_DOMAIN         VARCHAR2(255 BYTE)        DEFAULT ' '                   NOT NULL,
  PREF_SECTION        VARCHAR2(255 BYTE)        DEFAULT ' '                   NOT NULL,
  PREF_NAME           VARCHAR2(255 BYTE)        DEFAULT ' '                   NOT NULL,
  PREF_NBR            NUMBER                    DEFAULT 0,
  PREF_CD             NUMBER                    DEFAULT 0                     NOT NULL,
  PREF_DT_TM          DATE,
  PREF_STR            VARCHAR2(255 BYTE),
  PARENT_ENTITY_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME  VARCHAR2(32 BYTE),
  REFERENCE_IND       NUMBER                    DEFAULT 0,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DM_REFCHG_PRSNL_CTX_R
(
  DM_REFCHG_PRSNL_CTX_R_ID  NUMBER              DEFAULT 0                     NOT NULL,
  PRSNL_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  CONTEXT_NAME              VARCHAR2(255 BYTE)  DEFAULT ' '                   NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_IND                NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DM_XNTR_DETAIL
(
  DM_XNTR_DETAIL_ID   NUMBER                    DEFAULT 0                     NOT NULL,
  DM_XNTR_EXTRACT_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  STATUS              VARCHAR2(20 BYTE),
  STATUS_MSG          VARCHAR2(250 BYTE),
  START_DT_TM         DATE,
  END_DT_TM           DATE,
  TASK_ENTITY_ID      NUMBER                    DEFAULT 0                     NOT NULL,
  TASK_ENTITY_NAME    VARCHAR2(30 BYTE),
  INSTANCE_NBR        NUMBER                    DEFAULT 0                     NOT NULL,
  SEQUENCE_NBR        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DM_XNTR_EXTRACT
(
  DM_XNTR_EXTRACT_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  DM_XNTR_JOB_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  STATUS               VARCHAR2(20 BYTE),
  STATUS_MSG           VARCHAR2(250 BYTE),
  EXTRACT_UUID         VARCHAR2(200 BYTE),
  EXTRACT_NAME         VARCHAR2(100 BYTE),
  EXTRACT_VERSION      NUMBER,
  EXTRACT_PERSON_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  EXTRACT_START_DT_TM  DATE,
  EXTRACT_STOP_DT_TM   DATE,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  XNT_START_DT_TM      DATE,
  XNT_END_DT_TM        DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DM_XNTR_EXTRACT_CNT
(
  DM_XNTR_EXTRACT_CNT_ID  NUMBER                DEFAULT 0                     NOT NULL,
  DM_XNTR_EXTRACT_ID      NUMBER                DEFAULT 0                     NOT NULL,
  TABLE_NAME              VARCHAR2(30 BYTE),
  RETRIEVED_ROW_CNT       NUMBER,
  DELETED_ROW_CNT         NUMBER,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DM_XNTR_JOB
(
  DM_XNTR_JOB_ID   NUMBER                       DEFAULT 0                     NOT NULL,
  PERSON_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  STATUS           VARCHAR2(20 BYTE)            DEFAULT ' '                   NOT NULL,
  STATUS_MSG       VARCHAR2(250 BYTE),
  JOB_START_DT_TM  DATE,
  JOB_END_DT_TM    DATE,
  FILE_NAME        VARCHAR2(30 BYTE),
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  AUDIT_SID        VARCHAR2(255 BYTE),
  LOG_FILE         VARCHAR2(40 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DM_XNT_JOB_LOG_CNT
(
  DM_XNT_JOB_LOG_CNT_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  DM_XNT_JOB_LOG_DTL_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  TABLE_NAME             VARCHAR2(30 BYTE)      DEFAULT ' '                   NOT NULL,
  PARENT_TABLE_NAME      VARCHAR2(30 BYTE)      DEFAULT ' '                   NOT NULL,
  ROWS_EXTRACTED         FLOAT(126)             DEFAULT 0                     NOT NULL,
  EXTRACT_DT_TM          DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  ROWS_DELETED           FLOAT(126)             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DM_XNT_JOB_LOG_DTL
(
  DM_XNT_JOB_LOG_DTL_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  DM_XNT_JOB_LOG_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  JOB_ID                 NUMBER                 DEFAULT 0                     NOT NULL,
  EXTRACT_START_DT_TM    DATE                   DEFAULT SYSDATE               NOT NULL,
  EXTRACT_END_DT_TM      DATE,
  START_UPDT_DT_TM       DATE,
  END_UPDT_DT_TM         DATE,
  FILE_LABEL             VARCHAR2(100 BYTE),
  FILE_UUID              VARCHAR2(200 BYTE),
  EXTRACT_STATUS         VARCHAR2(30 BYTE)      DEFAULT 'RUNNING'             NOT NULL,
  ERROR_MSG              VARCHAR2(1000 BYTE),
  AUDIT_SID              VARCHAR2(255 BYTE),
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DOC_TRANSCRIPTION_QUEUE
(
  DOC_TRANSCRIPTION_QUEUE_ID  NUMBER            DEFAULT 0                     NOT NULL,
  PERSON_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  EVENT_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  DOCUMENTATION_TYPE_CD       NUMBER            DEFAULT 0                     NOT NULL,
  PRIORITY_IND                NUMBER            DEFAULT 0                     NOT NULL,
  FACILITY_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  AUTHOR_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  TOTAL_DICTATION_LENGTH      FLOAT(126)        DEFAULT 0                     NOT NULL,
  PURGE_IND                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DOSING_WEIGHT
(
  DOSING_WEIGHT_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  EVENT_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DRG
(
  DRG_ID                      NUMBER            DEFAULT 0                     NOT NULL,
  PERSON_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID             NUMBER            DEFAULT 0                     NOT NULL,
  DRG_PAYMENT                 NUMBER,
  OUTLIER_DAYS                NUMBER,
  OUTLIER_COST                NUMBER,
  OUTLIER_REIMBURSEMENT_COST  NUMBER,
  DRG_PRIORITY                NUMBER,
  GROUPER_CD                  NUMBER            DEFAULT 0                     NOT NULL,
  DRG_PAYOR_CD                NUMBER            DEFAULT 0                     NOT NULL,
  CREATE_DT_TM                DATE,
  CREATE_PRSNL_ID             NUMBER            DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD       NUMBER            DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM         DATE,
  END_EFFECTIVE_DT_TM         DATE,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  SVC_CAT_HIST_ID             NUMBER            DEFAULT 0                     NOT NULL,
  MDC_CD                      NUMBER            DEFAULT 0                     NOT NULL,
  RISK_OF_MORTALITY_CD        NUMBER            DEFAULT 0                     NOT NULL,
  SEVERITY_OF_ILLNESS_CD      NUMBER            DEFAULT 0                     NOT NULL,
  SOURCE_VOCABULARY_CD        NUMBER            DEFAULT 0                     NOT NULL,
  MDC_APR_CD                  NUMBER            DEFAULT 0                     NOT NULL,
  COMORBIDITY_CD              NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_ID             NUMBER            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DRG_ENCNTR_EXTENSION
(
  DRG_ENCNTR_EXTENSION_ID  NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  SOURCE_VOCABULARY_CD     NUMBER               DEFAULT 0                     NOT NULL,
  SOURCE_IDENTIFIER        VARCHAR2(50 BYTE)    DEFAULT ' '                   NOT NULL,
  COMPLEXITY_OVERLAY       NUMBER,
  COMPLEXITY_OVERLAY_TEXT  VARCHAR2(255 BYTE),
  MCC                      NUMBER,
  MCC_TEXT                 VARCHAR2(255 BYTE),
  PATIENT_STATUS_CD        NUMBER               DEFAULT 0                     NOT NULL,
  CASE_RESOURCE_WEIGHT     FLOAT(126),
  ONTARIO_CASE_WEIGHT      FLOAT(126),
  PERDIEM                  FLOAT(126),
  ELOS                     FLOAT(126),
  ALOS                     FLOAT(126),
  DAY_THRESHOLD            NUMBER,
  BEG_EFFECTIVE_DT_TM      DATE,
  END_EFFECTIVE_DT_TM      DATE,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  HOSPITAL_BASE_RATE       NUMBER,
  SVC_CAT_HIST_ID          NUMBER               DEFAULT 0                     NOT NULL,
  TOTAL_EST_REIMB_VALUE    NUMBER,
  TOTAL_REIMB_VALUE        NUMBER,
  TOTAL_EST_REIMB          NUMBER,
  HRS_MECH_VENT_VALUE      NUMBER,
  WIES_FUNDING_AMT         FLOAT(126),
  WIES_WEIGHT_VALUE        NUMBER,
  HIGH_TRIM_VALUE          NUMBER,
  LOW_TRIM_VALUE           NUMBER,
  ENCNTR_SLICE_ID          NUMBER               DEFAULT 0,
  DRG_WEIGHT               FLOAT(126)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DRG_SPECIALTY
(
  DRG_SPECIALTY_ID            NUMBER            DEFAULT 0                     NOT NULL,
  PERSON_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID             NUMBER            DEFAULT 0                     NOT NULL,
  DRG_PAYMENT                 NUMBER,
  OUTLIER_DAYS                NUMBER,
  OUTLIER_COST                NUMBER,
  OUTLIER_REIMBURSEMENT_COST  NUMBER,
  DRG_PRIORITY                NUMBER,
  GROUPER_CD                  NUMBER            DEFAULT 0                     NOT NULL,
  DRG_PAYOR_CD                NUMBER            DEFAULT 0                     NOT NULL,
  CREATE_PRSNL_ID             NUMBER            DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD       NUMBER            DEFAULT 0                     NOT NULL,
  SVC_CAT_HIST_ID             NUMBER            DEFAULT 0                     NOT NULL,
  MDC_CD                      NUMBER            DEFAULT 0                     NOT NULL,
  RISK_OF_MORTALITY_CD        NUMBER            DEFAULT 0                     NOT NULL,
  SEVERITY_OF_ILLNESS_CD      NUMBER            DEFAULT 0                     NOT NULL,
  SOURCE_VOCABULARY_CD        NUMBER            DEFAULT 0                     NOT NULL,
  MDC_APR_CD                  NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_ID             NUMBER            DEFAULT 0                     NOT NULL,
  CREATE_DT_TM                DATE,
  HAC_IND                     NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER            DEFAULT 1                     NOT NULL,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE,
  BEG_EFFECTIVE_DT_TM         DATE,
  END_EFFECTIVE_DT_TM         DATE,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  COMORBIDITY_CD              NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DSM_ASSESSMENT
(
  DSM_ASSESSMENT_ID       NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  DIAG_PRSNL_ID           NUMBER                DEFAULT 0                     NOT NULL,
  DIAG_DT_TM              DATE,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  CGI1_CD                 NUMBER                DEFAULT 0                     NOT NULL,
  CGI2_CD                 NUMBER                DEFAULT 0                     NOT NULL,
  ASSESSMENT_TYPE_CD      NUMBER                DEFAULT 0                     NOT NULL,
  ASSESSMENT_DT_TM        DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DSM_COMPONENT
(
  DSM_COMPONENT_ID   NUMBER                     DEFAULT 0                     NOT NULL,
  DSM_ASSESSMENT_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  AXIS_FLAG          NUMBER,
  COMPONENT_DESC1    VARCHAR2(255 BYTE),
  COMPONENT_DESC2    VARCHAR2(255 BYTE),
  COMPONENT_SEQ      NUMBER,
  PRIMARY_DIAG_IND   NUMBER,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DTS_RECIPIENT
(
  DTS_RECIPIENT_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  EVENT_PRSNL_ID    NUMBER                      DEFAULT 0                     NOT NULL,
  ADDRESS_HIST_ID   NUMBER                      DEFAULT 0                     NOT NULL,
  PRIMARY_IND       NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT sysdate               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE DTS_TRANS_STATS
(
  DTS_TRANS_STATS_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  EVENT_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  TRANS_PRSNL_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  AUTHOR_PRSNL_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD     NUMBER                   DEFAULT 0                     NOT NULL,
  CHAR_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  CHAR_WO_CNT          NUMBER                   DEFAULT 0                     NOT NULL,
  WORD_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  LINE_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  PAGE_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  BYTES_CNT            NUMBER                   DEFAULT 0                     NOT NULL,
  ORIG_CHAR_CNT        NUMBER                   DEFAULT 0                     NOT NULL,
  ORIG_CHAR_WO_CNT     NUMBER                   DEFAULT 0                     NOT NULL,
  ORIG_WORD_CNT        NUMBER                   DEFAULT 0                     NOT NULL,
  ORIG_LINE_CNT        NUMBER                   DEFAULT 0                     NOT NULL,
  ORIG_PAGE_CNT        NUMBER                   DEFAULT 0                     NOT NULL,
  ORIG_BYTES_CNT       NUMBER                   DEFAULT 0                     NOT NULL,
  CHAR_PER_WORD        NUMBER                   DEFAULT 0                     NOT NULL,
  WORDS_PER_SENTENCE   NUMBER                   DEFAULT 0                     NOT NULL,
  SENTENCES_PER_PARA   NUMBER                   DEFAULT 0                     NOT NULL,
  START_TRANS_DT_TM    DATE                     DEFAULT SYSDATE               NOT NULL,
  END_TRANS_DT_TM      DATE                     DEFAULT SYSDATE               NOT NULL,
  RESULT_STATUS_CD     NUMBER                   DEFAULT 0                     NOT NULL,
  DOC_NAME             VARCHAR2(255 BYTE),
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  EDIT_TRANS_TM        NUMBER                   DEFAULT 0                     NOT NULL,
  EVENT_CD             NUMBER                   DEFAULT 0                     NOT NULL,
  PATIENT_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  ENCNTR_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  SUBJECT_LINE         VARCHAR2(255 BYTE),
  APPLICATION_MODE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  TRANSACTION_TYPE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  DICTATION_DT_TM      DATE,
  DICTATION_TZ         NUMBER                   DEFAULT 0,
  START_TRANS_TZ       NUMBER                   DEFAULT 0,
  END_TRANS_TZ         NUMBER                   DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EC_PROFILER_RESULT
(
  EC_PROFILER_RESULT_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  EC_MEASUREMENT_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  EC_PROFILER_EVENT_ID   NUMBER                 DEFAULT 0                     NOT NULL,
  CAPABILITY_IN_USE_IND  NUMBER                 DEFAULT 0                     NOT NULL,
  RESULT_DT_TM           DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  FACILITY_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  POSITION_CD            NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EC_PROFILER_RESULT_DETAIL
(
  EC_PROFILER_RESULT_DETAIL_ID  NUMBER          DEFAULT 0                     NOT NULL,
  EC_PROFILER_RESULT_ID         NUMBER          DEFAULT 0                     NOT NULL,
  DETAIL_NAME                   VARCHAR2(200 BYTE) DEFAULT ' ' NOT NULL,
  DETAIL_VALUE_TXT              VARCHAR2(200 BYTE) DEFAULT ' ' NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_ABN_ACTION
(
  ABN_ACTION_ID           NUMBER                DEFAULT 0                     NOT NULL,
  ABN_CHECK_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ABN_ACTION_CD           NUMBER                DEFAULT 0                     NOT NULL,
  ACTION_MEANING          VARCHAR2(12 BYTE)     DEFAULT ' '                   NOT NULL,
  ACTION_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ACTION_DT_TM            DATE                  DEFAULT SYSDATE               NOT NULL,
  ABN_STATE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  STATE_MEANING           VARCHAR2(12 BYTE)     DEFAULT ' '                   NOT NULL,
  CONVERSATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ABN_FORM_ID             NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  FORM_ACTION_ID          NUMBER                DEFAULT 0                     NOT NULL,
  APPLICATION_NUMBER      NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_ABN_CHECK
(
  ABN_CHECK_ID              NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  GENDER_CD                 NUMBER              DEFAULT 0                     NOT NULL,
  GENDER_MEANING            VARCHAR2(12 BYTE),
  BIRTH_DT_TM               DATE,
  INPATIENT_IND             NUMBER              DEFAULT 0                     NOT NULL,
  DUP_CHECK_IND             NUMBER              DEFAULT 0                     NOT NULL,
  PARENT1_ID                NUMBER              DEFAULT 0                     NOT NULL,
  PARENT1_TABLE             VARCHAR2(30 BYTE),
  PARENT2_ID                NUMBER              DEFAULT 0                     NOT NULL,
  PARENT2_TABLE             VARCHAR2(30 BYTE),
  PARENT3_ID                NUMBER              DEFAULT 0                     NOT NULL,
  PARENT3_TABLE             VARCHAR2(30 BYTE),
  PROC_NOMEN_ID             NUMBER              DEFAULT 0                     NOT NULL,
  PROC_SOURCE_IDENT         VARCHAR2(50 BYTE)   DEFAULT ' '                   NOT NULL,
  PROC_VOCAB_CD             NUMBER              DEFAULT 0                     NOT NULL,
  PROC_VOCAB_MEANING        VARCHAR2(12 BYTE),
  SERVICE_DT_TM             DATE,
  EST_SERVICE_IND           NUMBER              DEFAULT 0                     NOT NULL,
  DIAG_NOMEN_ID             NUMBER              DEFAULT 0                     NOT NULL,
  DIAG_SOURCE_IDENT         VARCHAR2(50 BYTE)   DEFAULT ' '                   NOT NULL,
  DIAG_VOCAB_CD             NUMBER              DEFAULT 0                     NOT NULL,
  DIAG_VOCAB_MEANING        VARCHAR2(12 BYTE),
  PAYER_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID            NUMBER              DEFAULT 0                     NOT NULL,
  SPONSOR_ID                NUMBER              DEFAULT 0                     NOT NULL,
  EEM_FILE_ID               NUMBER              DEFAULT 0                     NOT NULL,
  USE_SERVICE_IND           NUMBER              DEFAULT 0                     NOT NULL,
  CHECK_SEQ                 NUMBER              DEFAULT 0                     NOT NULL,
  HIGH_STATUS_CD            NUMBER              DEFAULT 0                     NOT NULL,
  HIGH_STATUS_MEANING       VARCHAR2(12 BYTE),
  MED_STATUS_CD             NUMBER              DEFAULT 0                     NOT NULL,
  MED_STATUS_MEANING        VARCHAR2(12 BYTE),
  ABN_STATE_CD              NUMBER              DEFAULT 0                     NOT NULL,
  ABN_STATE_MEANING         VARCHAR2(12 BYTE),
  ABN_TRACKING_ID           NUMBER              DEFAULT 0                     NOT NULL,
  DUP_KEY                   VARCHAR2(255 BYTE),
  BEG_EFFECTIVE_DT_TM       DATE,
  END_EFFECTIVE_DT_TM       DATE,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  PARENT_MNEMONIC           VARCHAR2(100 BYTE),
  PROC_PARENT_TABLE         VARCHAR2(30 BYTE),
  PROC_PARENT_ID            NUMBER              DEFAULT 0                     NOT NULL,
  PROC_DISPLAY_TABLE        VARCHAR2(30 BYTE),
  PROC_DISPLAY_ID           NUMBER              DEFAULT 0                     NOT NULL,
  PROC_GROUP_PARENT_ID      NUMBER              DEFAULT 0                     NOT NULL,
  PROC_GROUP_DISPLAY_ID     NUMBER              DEFAULT 0                     NOT NULL,
  PROC_GROUP_DISPLAY_TABLE  VARCHAR2(30 BYTE),
  PROC_GROUP_PARENT_TABLE   VARCHAR2(30 BYTE),
  BIRTH_TZ                  NUMBER              DEFAULT 0,
  LOCATION_CD               NUMBER              DEFAULT 0,
  FINANCIAL_CLASS_CD        NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_ABN_DIAG
(
  ABN_CHECK_ID            NUMBER                DEFAULT 0                     NOT NULL,
  DIAG_SEQ_NBR            NUMBER                DEFAULT 0                     NOT NULL,
  DIAG_NOMEN_ID           NUMBER                DEFAULT 0                     NOT NULL,
  DIAG_SOURCE_IDENT       VARCHAR2(50 BYTE)     DEFAULT ' '                   NOT NULL,
  DIAG_VOCAB_CD           NUMBER                DEFAULT 0                     NOT NULL,
  DIAG_VOCAB_MEANING      VARCHAR2(12 BYTE),
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_ABN_FORM
(
  ABN_FORM_ID             NUMBER                DEFAULT 0                     NOT NULL,
  EEM_REPORT_ID           NUMBER                DEFAULT 0                     NOT NULL,
  OUTPUT_DEST_ID          NUMBER                DEFAULT 0                     NOT NULL,
  TO_PRSNL_ID             NUMBER                DEFAULT 0                     NOT NULL,
  SUFFIX                  VARCHAR2(50 BYTE),
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  NBR_COPIES              NUMBER                DEFAULT 0                     NOT NULL,
  FILE_NAME               VARCHAR2(255 BYTE),
  OFFLINE_FORM_IND        NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_ABN_INDEX
(
  ABN_CHECK_ID            NUMBER                DEFAULT 0                     NOT NULL,
  INDEX_SEQ_NBR           NUMBER                DEFAULT 0                     NOT NULL,
  KEY_FIELD               NUMBER                DEFAULT 0                     NOT NULL,
  HIGH_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  HIGH_STATUS_MEANING     VARCHAR2(12 BYTE),
  MED_STATUS_CD           NUMBER                DEFAULT 0                     NOT NULL,
  MED_STATUS_MEANING      VARCHAR2(12 BYTE),
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_ABN_LOW
(
  ABN_CHECK_ID            NUMBER                DEFAULT 0                     NOT NULL,
  INDEX_SEQ_NBR           NUMBER                DEFAULT 0                     NOT NULL,
  LOW_SEQ_NBR             NUMBER                DEFAULT 0                     NOT NULL,
  LOW_STATUS_CD           NUMBER                DEFAULT 0                     NOT NULL,
  LOW_STATUS_MEANING      VARCHAR2(12 BYTE),
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  LOW_STATUS_DETAIL_TXT   VARCHAR2(255 BYTE)    DEFAULT ' '
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_ABN_MOD
(
  ABN_CHECK_ID            NUMBER                DEFAULT 0                     NOT NULL,
  MOD_SEQ_NBR             NUMBER                DEFAULT 0                     NOT NULL,
  MOD_NOMEN_ID            NUMBER                DEFAULT 0                     NOT NULL,
  MOD_SOURCE_IDENT        VARCHAR2(50 BYTE)     DEFAULT ' '                   NOT NULL,
  MOD_VOCAB_CD            NUMBER                DEFAULT 0                     NOT NULL,
  MOD_VOCAB_MEANING       VARCHAR2(12 BYTE),
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_ACTION
(
  EEM_ACTION_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PARENT1_TABLE           VARCHAR2(32 BYTE),
  PARENT1_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PARENT2_TABLE           VARCHAR2(32 BYTE),
  PARENT2_ID              NUMBER                DEFAULT 0                     NOT NULL,
  EEM_ACTION_CD           NUMBER                DEFAULT 0                     NOT NULL,
  ACTION_MEANING          VARCHAR2(12 BYTE)     DEFAULT ' '                   NOT NULL,
  ACTION_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ACTION_DT_TM            DATE                  DEFAULT SYSDATE               NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_ADDRESS_DETAIL
(
  INTERCHANGE_ID     NUMBER                     DEFAULT 0                     NOT NULL,
  PERSON_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  PAYER_ID           NUMBER                     DEFAULT 0                     NOT NULL,
  PROFILE_ID         NUMBER                     DEFAULT 0                     NOT NULL,
  SENT_DT_TM         DATE                       NOT NULL,
  REPLY_DT_TM        DATE,
  SENDER_PRSNL_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  PHN                VARCHAR2(200 BYTE),
  VALID_ADDRESS_IND  NUMBER                     DEFAULT 0                     NOT NULL,
  ADDRESS_GUESS_IND  NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_AUTH_DETAIL
(
  INTERCHANGE_ID   NUMBER                       DEFAULT 0                     NOT NULL,
  ENCOUNTER_ID     NUMBER                       DEFAULT 0                     NOT NULL,
  SUB_PERSON_ID    NUMBER                       DEFAULT 0                     NOT NULL,
  SENDER_PRSNL_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  PAYER_ID         NUMBER                       DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID   NUMBER                       DEFAULT 0                     NOT NULL,
  PROFILE_ID       NUMBER                       DEFAULT 0                     NOT NULL,
  SENT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  REPLY_DT_TM      DATE,
  SUB_NAME_LAST    VARCHAR2(60 BYTE),
  SUB_NAME_FIRST   VARCHAR2(35 BYTE),
  SUB_MEMBER_IDEN  VARCHAR2(80 BYTE),
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  DEP_PERSON_ID    NUMBER                       DEFAULT 0                     NOT NULL,
  DEP_NAME_LAST    VARCHAR2(60 BYTE),
  DEP_NAME_FIRST   VARCHAR2(35 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_BATCH
(
  EEM_BATCH_ID    NUMBER                        DEFAULT 0                     NOT NULL,
  TRANSACTION_CD  NUMBER                        DEFAULT 0                     NOT NULL,
  PAYER_ID        NUMBER                        DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID  NUMBER                        DEFAULT 0                     NOT NULL,
  SUBMIT_DT_TM    DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_BATCH_JOB
(
  EEM_BATCH_JOB_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  EEM_BATCH_ID      NUMBER                      DEFAULT 0                     NOT NULL,
  EEM_JOB_ID        NUMBER                      DEFAULT 0                     NOT NULL,
  INTERCHANGE_ID    NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  SEQUENCE          NUMBER                      DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_BENEFIT_ALLOC
(
  BENEFIT_ALLOC_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  SVC_CAT_HIST_ID         NUMBER                DEFAULT 0                     NOT NULL,
  EEM_BENEFIT_ID          NUMBER                DEFAULT 0                     NOT NULL,
  MADE_BY_ID              NUMBER                DEFAULT 0                     NOT NULL,
  STATE_CD                NUMBER                DEFAULT 0                     NOT NULL,
  FINALIZED_DT_TM         DATE,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  MAN_ALLOC_REQ_IND       NUMBER                DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID          NUMBER                DEFAULT 0,
  ENCNTR_SLICE_ID         NUMBER                DEFAULT 0,
  NCA_IND                 NUMBER                DEFAULT 0,
  ORGANIZATION_ID         NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_BENEFIT_PROTO
(
  BENEFIT_PROTO_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  ENCNTR_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  DEDUCTIBLE           NUMBER                   DEFAULT 0                     NOT NULL,
  DEDUCTIBLE_MET       NUMBER                   DEFAULT 0                     NOT NULL,
  COPAY                NUMBER                   DEFAULT 0                     NOT NULL,
  OUT_OF_POCKET        NUMBER                   DEFAULT 0                     NOT NULL,
  LIFE_TIME_MAX        NUMBER                   DEFAULT 0                     NOT NULL,
  COINSURANCE_IND      NUMBER                   DEFAULT 0                     NOT NULL,
  LENGTH_OF_STAY       NUMBER                   DEFAULT 0                     NOT NULL,
  PRE_EXIST_IND        NUMBER                   DEFAULT 0                     NOT NULL,
  AUTH_IND             NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_AUTH             VARCHAR2(255 BYTE),
  END_AUTH             VARCHAR2(255 BYTE),
  AUTH_BEG_EFF_DT_TM   DATE,
  AUTH_END_EFF_DT_TM   DATE,
  REFER_IND            NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_REFER            VARCHAR2(255 BYTE),
  END_REFER            VARCHAR2(255 BYTE),
  REFER_BEG_EFF_DT_TM  DATE,
  REFER_END_EFF_DT_TM  DATE,
  CONTACT_NAME         VARCHAR2(255 BYTE),
  CONTACT_PHONE        VARCHAR2(255 BYTE),
  LONG_TEXT_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_COVERAGE_DETAIL
(
  INTERCHANGE_ID   NUMBER                       DEFAULT 0                     NOT NULL,
  PERSON_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  PAYER_ID         NUMBER                       DEFAULT 0                     NOT NULL,
  PROFILE_ID       NUMBER                       DEFAULT 0                     NOT NULL,
  SENT_DT_TM       DATE                         NOT NULL,
  REPLY_DT_TM      DATE,
  SENDER_PRSNL_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  PHN              VARCHAR2(200 BYTE),
  TERM_DT_TM       DATE,
  LAST_NAME        VARCHAR2(200 BYTE),
  FIRST_NAME       VARCHAR2(200 BYTE),
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  ELIGIBLE_FLAG    NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_DEMOG_DETAIL
(
  INTERCHANGE_ID   NUMBER                       DEFAULT 0                     NOT NULL,
  PERSON_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  PAYER_ID         NUMBER                       DEFAULT 0                     NOT NULL,
  PROFILE_ID       NUMBER                       DEFAULT 0                     NOT NULL,
  SENT_DT_TM       DATE                         NOT NULL,
  REPLY_DT_TM      DATE,
  SENDER_PRSNL_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  PHN              VARCHAR2(200 BYTE),
  GENDER_CD        NUMBER                       DEFAULT 0                     NOT NULL,
  BIRTH_DT_TM      DATE,
  LAST_NAME        VARCHAR2(200 BYTE),
  FIRST_NAME       VARCHAR2(200 BYTE),
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  BIRTH_TZ         NUMBER                       DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_ELIG_DETAIL
(
  INTERCHANGE_ID              NUMBER            DEFAULT 0                     NOT NULL,
  SUB_PERSON_ID               NUMBER            DEFAULT 0                     NOT NULL,
  PAT_PERSON_ID               NUMBER            DEFAULT 0                     NOT NULL,
  DATA_FLAG                   NUMBER            DEFAULT 0                     NOT NULL,
  PAYOR_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID              NUMBER            DEFAULT 0                     NOT NULL,
  PROFILE_ID                  NUMBER            DEFAULT 0                     NOT NULL,
  SENT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  REPLY_DT_TM                 DATE,
  SENDER_PRSNL_ID             NUMBER            DEFAULT 0                     NOT NULL,
  INFO_SRC_PRIMARY_IDEN       VARCHAR2(80 BYTE),
  OB_SUB_LAST_NAME            VARCHAR2(60 BYTE),
  OB_SUB_FIRST_NAME           VARCHAR2(35 BYTE),
  OB_SUB_MEMBER_ID            VARCHAR2(80 BYTE),
  OB_SUB_SSN                  VARCHAR2(30 BYTE),
  OB_SUB_BIRTH_DT_TM          VARCHAR2(35 BYTE),
  OB_SUB_GROUP_NUM            VARCHAR2(50 BYTE),
  OB_SUB_POLICY_NUM           VARCHAR2(50 BYTE),
  OB_PAT_LAST_NAME            VARCHAR2(60 BYTE),
  OB_PAT_FIRST_NAME           VARCHAR2(35 BYTE),
  OB_PAT_SSN                  VARCHAR2(30 BYTE),
  OB_PAT_BIRTH_DT_TM          VARCHAR2(35 BYTE),
  IB_SUB_LAST_NAME            VARCHAR2(60 BYTE),
  IB_SUB_FIRST_NAME           VARCHAR2(35 BYTE),
  IB_SUB_MEMBER_ID            VARCHAR2(80 BYTE),
  IB_SUB_SSN                  VARCHAR2(30 BYTE),
  IB_SUB_BIRTH_DT_TM          VARCHAR2(35 BYTE),
  IB_SUB_GROUP_NUM            VARCHAR2(50 BYTE),
  IB_SUB_POLICY_NUM           VARCHAR2(50 BYTE),
  IB_PAT_LAST_NAME            VARCHAR2(60 BYTE),
  IB_PAT_FIRST_NAME           VARCHAR2(35 BYTE),
  IB_PAT_SSN                  VARCHAR2(30 BYTE),
  IB_PAT_BIRTH_DT_TM          VARCHAR2(35 BYTE),
  IB_EMPLOYEE_ID_NUM          VARCHAR2(30 BYTE),
  IB_MED_REC_ID_NUM           VARCHAR2(50 BYTE),
  IB_IDEN_CARD_NUM            VARCHAR2(50 BYTE),
  IB_ISSUE_NUM                VARCHAR2(50 BYTE),
  IB_INS_POL_NUM              VARCHAR2(50 BYTE),
  IB_PLAN_NETWK_ID_NUM        VARCHAR2(50 BYTE),
  IB_MEDICAID_RECPNT_ID_NUM   VARCHAR2(50 BYTE),
  IB_PRIOR_ID_NUM             VARCHAR2(50 BYTE),
  ACTIVE_IND                  NUMBER,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM         DATE,
  END_EFFECTIVE_DT_TM         DATE,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  OB_SUB_GROUP_OR_POLICY_NUM  VARCHAR2(50 BYTE),
  IB_SUB_GROUP_OR_POLICY_NUM  VARCHAR2(50 BYTE),
  OB_END_SERVICE_DATE         VARCHAR2(12 BYTE) DEFAULT ' ',
  OB_BEG_SERVICE_DATE         VARCHAR2(12 BYTE) DEFAULT ' '
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_ELIG_SVC_DETAIL
(
  EEM_ELIG_SVC_DETAIL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  EEM_RX_ELIG_DETAIL_ID   NUMBER                DEFAULT 0                     NOT NULL,
  INTERCHANGE_ID          NUMBER                DEFAULT 0                     NOT NULL,
  SERVICE_TYPE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  ELIGIBILITY_STATUS_CD   NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_FILE_ACTION
(
  FILE_ACTION_ID          NUMBER                DEFAULT 0                     NOT NULL,
  EEM_FILE_ID             NUMBER                DEFAULT 0                     NOT NULL,
  IMPORT_SEQ              NUMBER                DEFAULT 0                     NOT NULL,
  FILE_ACTION_CD          NUMBER                DEFAULT 0                     NOT NULL,
  FILE_ACTION_MEANING     VARCHAR2(12 BYTE)     DEFAULT ' '                   NOT NULL,
  ACTION_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ACTION_DT_TM            DATE                  DEFAULT SYSDATE               NOT NULL,
  LAST_DT_TM              DATE,
  FILE_STATE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  FILE_STATE_MEANING      VARCHAR2(12 BYTE)     DEFAULT ' '                   NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_IMPORT_DATA
(
  IMPORT_DATA_ID          NUMBER                DEFAULT 0                     NOT NULL,
  EEM_FILE_ID             NUMBER                DEFAULT 0                     NOT NULL,
  FILE_ACTION_ID          NUMBER                DEFAULT 0                     NOT NULL,
  FILE_SEQ                NUMBER                DEFAULT 0                     NOT NULL,
  FILE_NAME               VARCHAR2(255 BYTE)    DEFAULT ' '                   NOT NULL,
  SLICE_SIZE              NUMBER                DEFAULT 0                     NOT NULL,
  ITERATION               NUMBER                DEFAULT 0                     NOT NULL,
  FIRST_DT_TM             DATE,
  LAST_DT_TM              DATE,
  TIMER_SECONDS           NUMBER                DEFAULT 0                     NOT NULL,
  RECORDS_TOTAL           NUMBER                DEFAULT 0                     NOT NULL,
  RECORDS_ADDED           NUMBER                DEFAULT 0                     NOT NULL,
  RECORDS_UPDATED         NUMBER                DEFAULT 0                     NOT NULL,
  RECORDS_ERROR           NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_IMPORT_ERROR
(
  IMPORT_ERROR_ID         NUMBER                DEFAULT 0                     NOT NULL,
  IMPORT_DATA_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ITERATION               NUMBER                DEFAULT 0                     NOT NULL,
  SEQ_NBR                 NUMBER                DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_JOB
(
  EEM_JOB_ID               NUMBER               DEFAULT 0                     NOT NULL,
  TEMPLATE_INTERCHANGE_ID  NUMBER               DEFAULT 0                     NOT NULL,
  TRANSACTION_CD           NUMBER               DEFAULT 0                     NOT NULL,
  PAYER_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID           NUMBER               DEFAULT 0                     NOT NULL,
  JOB_STATE_CD             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD    NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_LOG
(
  LOG_ID                NUMBER                  DEFAULT 0                     NOT NULL,
  INTERCHANGE_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  PROFILE_ID            NUMBER                  DEFAULT 0                     NOT NULL,
  USER_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  DATA_FLAG             NUMBER                  DEFAULT 0                     NOT NULL,
  DATA_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  POLL_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  PROXY_FLAG            NUMBER                  DEFAULT 0                     NOT NULL,
  ACTIVE_IND            NUMBER                  DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM   DATE                    DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM   DATE                    DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  ACTION_CD             NUMBER                  DEFAULT 0                     NOT NULL,
  ACTION_MEANING        VARCHAR2(12 BYTE),
  POLL_RESPONSE_IND     NUMBER                  DEFAULT 0                     NOT NULL,
  CACHED_IND            NUMBER                  DEFAULT 0                     NOT NULL,
  REPLY_STATUS_CD       NUMBER                  DEFAULT 0                     NOT NULL,
  REPLY_STATUS_MEANING  VARCHAR2(12 BYTE),
  MODIFY_REASON_CD      NUMBER                  DEFAULT 0,
  LONG_TEXT_ID          NUMBER                  DEFAULT 0,
  TRANS_DATA_MOD_CD     NUMBER                  DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_LOG_BLOB
(
  EEM_LOG_ID              NUMBER                DEFAULT 0                     NOT NULL,
  SEQ_NBR                 NUMBER                DEFAULT 0                     NOT NULL,
  LONG_BLOB_ID            NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  ORIG_SIZE               NUMBER                DEFAULT 0                     NOT NULL,
  COMP_SIZE               NUMBER                DEFAULT 0                     NOT NULL,
  LOG_FLAG                NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_MOH_DETAIL
(
  INTERCHANGE_ID          NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  DATA_FLAG               NUMBER                DEFAULT 0                     NOT NULL,
  PAYER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  PROFILE_ID              NUMBER                DEFAULT 0                     NOT NULL,
  SENT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  REPLY_DT_TM             DATE,
  SENDER_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  TRACK1                  VARCHAR2(79 BYTE),
  TRACK2                  VARCHAR2(40 BYTE),
  HEALTH_CARD             VARCHAR2(10 BYTE),
  VERSION_CODE            VARCHAR2(2 BYTE),
  RESPONSE_CD             NUMBER                DEFAULT 0                     NOT NULL,
  GENDER_CD               NUMBER                DEFAULT 0                     NOT NULL,
  BIRTH_DT_TM             DATE,
  EXPIRY_DT_TM            DATE,
  LAST_NAME               VARCHAR2(30 BYTE),
  FIRST_NAME              VARCHAR2(20 BYTE),
  SECOND_NAME             VARCHAR2(20 BYTE),
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  BIRTH_TZ                NUMBER                DEFAULT 0,
  LOCATION_CD             NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_NEWBORN_DETAIL
(
  INTERCHANGE_ID   NUMBER                       DEFAULT 0                     NOT NULL,
  PERSON_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  PAYER_ID         NUMBER                       DEFAULT 0                     NOT NULL,
  PROFILE_ID       NUMBER                       DEFAULT 0                     NOT NULL,
  SENT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  REPLY_DT_TM      DATE,
  SENDER_PRSNL_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  PHN              VARCHAR2(200 BYTE),
  NOK_PHN          VARCHAR2(200 BYTE),
  NOK_RELTN_CD     NUMBER                       DEFAULT 0                     NOT NULL,
  GENDER_CD        NUMBER                       DEFAULT 0                     NOT NULL,
  BIRTH_DT_TM      DATE,
  LAST_NAME        VARCHAR2(100 BYTE),
  FIRST_NAME       VARCHAR2(100 BYTE),
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  BIRTH_TZ         NUMBER                       DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_NOTIFICATION_DETAIL
(
  EEM_NOTIFICATION_DETAIL_ID  NUMBER            DEFAULT 0                     NOT NULL,
  INTERCHANGE_ID              NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  PAYER_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID              NUMBER            DEFAULT 0                     NOT NULL,
  SENT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  REPLY_DT_TM                 DATE,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_NTWK_PRSNL_RELTN
(
  NTWK_PRSNL_RELTN_ID     NUMBER                DEFAULT 0                     NOT NULL,
  NETWORK_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_PROFILE
(
  PROFILE_ID                      NUMBER        DEFAULT 0                     NOT NULL,
  PAYOR_ID                        NUMBER        DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID                  NUMBER        DEFAULT 0                     NOT NULL,
  TRANSACTION_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  DESCRIPTION                     VARCHAR2(100 BYTE),
  PROXY_FLAG                      NUMBER        DEFAULT 0                     NOT NULL,
  POLL_DURATION                   NUMBER        DEFAULT 0                     NOT NULL,
  DATA_DURATION                   NUMBER        DEFAULT 0                     NOT NULL,
  INITIAL_DELAY                   NUMBER        DEFAULT 0                     NOT NULL,
  POLL_DELAY                      NUMBER        DEFAULT 0                     NOT NULL,
  MAX_DELAY                       NUMBER        DEFAULT 0                     NOT NULL,
  CONTACT                         VARCHAR2(100 BYTE),
  USERNAME                        VARCHAR2(40 BYTE),
  PASSWORD                        VARCHAR2(40 BYTE),
  ISA_AUTHOR_INFO_QUAL_CD         NUMBER        DEFAULT 0                     NOT NULL,
  ISA_AUTHOR_INFORMATION          VARCHAR2(10 BYTE),
  ISA_SECURITY_INFO_QUAL_CD       NUMBER        DEFAULT 0                     NOT NULL,
  ISA_SECURITY_INFORMATION        VARCHAR2(10 BYTE),
  ISA_INTERCHG_SENDER_ID_QUAL_CD  NUMBER        DEFAULT 0                     NOT NULL,
  ISA_INTERCHG_SENDER_IDEN        VARCHAR2(15 BYTE),
  ISA_INTERCHG_REC_ID_QUAL_CD     NUMBER        DEFAULT 0                     NOT NULL,
  ISA_INTERCHG_REC_IDEN           VARCHAR2(15 BYTE),
  ISA_ACK_REQUESTED_CD            NUMBER        DEFAULT 0                     NOT NULL,
  GS_APP_SENDERS_CODE             VARCHAR2(15 BYTE),
  GS_APP_RECEIVERS_CODE           VARCHAR2(15 BYTE),
  INFOSOURCE_ENTITY_ID_CD         NUMBER        DEFAULT 0                     NOT NULL,
  INFOSOURCE_ENTITY_TYPE_CD       NUMBER        DEFAULT 0                     NOT NULL,
  INFOSOURCE_NAME_LAST_ORG        VARCHAR2(60 BYTE),
  INFOSOURCE_NAME_FIRST           VARCHAR2(35 BYTE),
  INFOSOURCE_NAME_MIDDLE          VARCHAR2(25 BYTE),
  INFOSOURCE_NAME_SUFFIX          VARCHAR2(10 BYTE),
  INFOSOURCE_ID_CD                NUMBER        DEFAULT 0                     NOT NULL,
  INFOSOURCE_PRIMARY_IDEN         VARCHAR2(80 BYTE),
  DEP_UNIQ_ID_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  ACTIVE_IND                      NUMBER        DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM             DATE          DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM             DATE          DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  DEFAULT_SVC_TYPE_CD             NUMBER        DEFAULT 0                     NOT NULL,
  ALLOW_FUTURE_IND                NUMBER        DEFAULT 0                     NOT NULL,
  ALLOW_HISTORIC_IND              NUMBER        DEFAULT 0                     NOT NULL,
  ALLOW_PROCEDURE_LVL_IND         NUMBER        DEFAULT 0                     NOT NULL,
  ALLOW_SERVICE_TYPE_LVL_IND      NUMBER        DEFAULT 0                     NOT NULL,
  RP_NM1_ENTITY_ID_CD             NUMBER        DEFAULT 0                     NOT NULL,
  RP_NM1_ENTITY_TYPE_QUAL_CD      NUMBER        DEFAULT 0                     NOT NULL,
  RP_NM1_NAME_LAST_ORG            VARCHAR2(60 BYTE),
  RP_NM1_NAME_FIRST               VARCHAR2(35 BYTE),
  RP_NM1_NAME_MIDDLE              VARCHAR2(25 BYTE),
  RP_NM1_NAME_SUFFIX              VARCHAR2(10 BYTE),
  RP_NM1_IDEN_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  RP_NM1_IDEN                     VARCHAR2(80 BYTE),
  RP_REF_STATE_LIC_NUM            VARCHAR2(50 BYTE),
  RP_REF_STATE_LIC_NUM_DESC       VARCHAR2(80 BYTE),
  RP_REF_MEDICAID_PRV_NUM         VARCHAR2(50 BYTE),
  RP_REF_MEDICAID_PRV_NUM_DESC    VARCHAR2(80 BYTE),
  RP_REF_MEDICARE_PRV_NUM         VARCHAR2(50 BYTE),
  RP_REF_MEDICARE_PRV_NUM_DESC    VARCHAR2(80 BYTE),
  RP_REF_FACILITY_ID_NUM          VARCHAR2(50 BYTE),
  RP_REF_FACILITY_ID_NUM_DESC     VARCHAR2(80 BYTE),
  RP_REF_PERS_ID_NUM              VARCHAR2(50 BYTE),
  RP_REF_PERS_ID_NUM_DESC         VARCHAR2(80 BYTE),
  RP_REF_CONTRACT_NUM             VARCHAR2(50 BYTE),
  RP_REF_CONTRACT_NUM_DESC        VARCHAR2(80 BYTE),
  RP_REF_ELECT_DEV_PIN_NUM        VARCHAR2(50 BYTE),
  RP_REF_ELECT_DEV_PIN_NUM_DESC   VARCHAR2(80 BYTE),
  RP_REF_SUBMITTER_ID_NUM         VARCHAR2(50 BYTE),
  RP_REF_SUBMITTER_ID_NUM_DESC    VARCHAR2(80 BYTE),
  RP_REF_HCFA_NAT_PROV_NUM        VARCHAR2(50 BYTE),
  RP_REF_HCFA_NAT_PROV_NUM_DESC   VARCHAR2(80 BYTE),
  RP_REF_USER_ID                  VARCHAR2(50 BYTE),
  RP_REF_USER_ID_DESC             VARCHAR2(80 BYTE),
  RP_REF_PRV_PLN_NW_ID_NUM        VARCHAR2(50 BYTE),
  RP_REF_PRV_PLN_NW_ID_NUM_DESC   VARCHAR2(80 BYTE),
  RP_REF_FAC_NETWK_ID_NUM         VARCHAR2(50 BYTE),
  RP_REF_FAC_NETWK_ID_NUM_DESC    VARCHAR2(80 BYTE),
  RP_REF_PRIOR_ID_NUM             VARCHAR2(50 BYTE),
  RP_REF_PRIOR_ID_NUM_DESC        VARCHAR2(80 BYTE),
  RP_REF_SSN                      VARCHAR2(50 BYTE),
  RP_REF_SSN_DESC                 VARCHAR2(80 BYTE),
  RP_REF_FED_TAXPAYER_NUM         VARCHAR2(50 BYTE),
  RP_REF_FED_TAXPAYER_NUM_DESC    VARCHAR2(80 BYTE),
  RP_N3_ADDR1                     VARCHAR2(55 BYTE),
  RP_N3_ADDR2                     VARCHAR2(55 BYTE),
  RP_N4_CITY                      VARCHAR2(30 BYTE),
  RP_N4_STATE_PROV_CD             NUMBER        DEFAULT 0                     NOT NULL,
  RP_N4_POSTAL_CODE               VARCHAR2(15 BYTE),
  RP_N4_COUNTRY_CODE              VARCHAR2(3 BYTE),
  RP_PRV_PROV_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  RP_PRV_REF_ID_QUAL_CD           NUMBER        DEFAULT 0                     NOT NULL,
  RP_PRV_REF_ID                   VARCHAR2(50 BYTE),
  MOH_TRANSACTION                 VARCHAR2(30 BYTE),
  MOH_FACILITY                    VARCHAR2(30 BYTE),
  MOH_PROVIDER                    VARCHAR2(30 BYTE),
  MOH_LOCAL_DEVICE                VARCHAR2(30 BYTE),
  MOH_USER                        VARCHAR2(30 BYTE),
  MOH_LOCAL_USER                  VARCHAR2(30 BYTE),
  RP_REF_PRV_UPIN_NUM             VARCHAR2(50 BYTE),
  RP_COMM_NUM1_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  RP_COMM_NUM2_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  RP_COMM_NUM3_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  DATA_DURATION_FLAG              NUMBER        DEFAULT 0                     NOT NULL,
  INFOSOURCE_COMM_NUM1_CD         NUMBER        DEFAULT 0                     NOT NULL,
  TRANS_TYPE_FLAG                 NUMBER        DEFAULT 0                     NOT NULL,
  INFOSOURCE_COMM_NUM3            VARCHAR2(80 BYTE),
  INFOSOURCE_COMM_NUM3_CD         NUMBER        DEFAULT 0                     NOT NULL,
  INFOSOURCE_COMM_NUM2            VARCHAR2(80 BYTE),
  INFOSOURCE_COMM_NUM2_CD         NUMBER        DEFAULT 0                     NOT NULL,
  INFOSOURCE_COMM_NUM1            VARCHAR2(80 BYTE),
  INFOSOURCE_CONTACT_NAME         VARCHAR2(60 BYTE),
  RP_COMM_NUM3                    VARCHAR2(256 BYTE),
  RP_COMM_NUM2                    VARCHAR2(256 BYTE),
  RP_COMM_NUM1                    VARCHAR2(256 BYTE),
  RP_CONTACT_NAME                 VARCHAR2(60 BYTE),
  RP_REF_CARRIER_REF_NUM          VARCHAR2(50 BYTE),
  RP_REF_EMPLOYER_ID_NUM          VARCHAR2(50 BYTE),
  AUTOMATION_FLAG                 NUMBER        DEFAULT 0,
  CONTRIBUTOR_SYSTEM_CD           NUMBER        DEFAULT 0                     NOT NULL,
  TRANS_VERSION_CD                NUMBER        DEFAULT 0,
  MAX_RESUBMIT_DURATION           NUMBER        DEFAULT 0,
  RP_REF_PRV_SITE_NUM             VARCHAR2(50 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_PROFILE_INPUT
(
  INPUT_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  PROFILE_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  SEQUENCE             NUMBER                   DEFAULT 0                     NOT NULL,
  ELEMENT_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  SEARCH_CRITERIA_CD   NUMBER                   DEFAULT 0                     NOT NULL,
  LENGTH               NUMBER,
  MASK                 VARCHAR2(100 BYTE),
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  SCENARIO             NUMBER                   DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_PROFILE_LOCATION
(
  EEM_PROFILE_LOCATION_ID  NUMBER               DEFAULT 0                     NOT NULL,
  FACILITY_IDENT           VARCHAR2(15 BYTE),
  USER_IDENT               VARCHAR2(15 BYTE),
  LOCATION_CD              NUMBER               DEFAULT 0                     NOT NULL,
  PROFILE_ID               NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_PROFILE_OUTPUT
(
  OUTPUT_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  PROFILE_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  SEQUENCE             NUMBER                   DEFAULT 0                     NOT NULL,
  ELEMENT_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  ENSURE_FLAG          NUMBER                   DEFAULT 0                     NOT NULL,
  VIEW_FLAG            NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_PROFILE_POPULATE
(
  EEM_PROFILE_POPULATE_ID  NUMBER               DEFAULT 0                     NOT NULL,
  PROFILE_ID               NUMBER               DEFAULT 0                     NOT NULL,
  POPULATE_ELEMENT_CD      NUMBER               DEFAULT 0                     NOT NULL,
  FIELD                    VARCHAR2(255 BYTE)   DEFAULT ' '                   NOT NULL,
  BLANK_OVERRIDE_IND       NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS'),
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_PROFILE_PRSNL
(
  PROFILE_PRSNL_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  PROFILE_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  MOH_USER             VARCHAR2(30 BYTE)        DEFAULT ' '                   NOT NULL,
  MOH_LOCAL_USER       VARCHAR2(30 BYTE)        DEFAULT ' '                   NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE,
  END_EFFECTIVE_DT_TM  DATE,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_PROFILE_REPORT
(
  PROFILE_ID              NUMBER                DEFAULT 0                     NOT NULL,
  SEQ_NBR                 NUMBER                DEFAULT 0                     NOT NULL,
  SCH_REPORT_ID           NUMBER                DEFAULT 0                     NOT NULL,
  DEFAULT_IND             NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_PROFILE_SCENARIO
(
  INPUT_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  PROFILE_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  SEQUENCE             NUMBER                   DEFAULT 0                     NOT NULL,
  ELEMENT_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  SEARCH_CRITERIA_CD   NUMBER                   DEFAULT 0                     NOT NULL,
  LENGTH               NUMBER,
  MASK                 VARCHAR2(100 BYTE),
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  SCENARIO             NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_PRSNL_LOC_RELTN
(
  PRSNL_LOC_RELTN_ID      NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  LOCATION_CD             NUMBER                DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  NETWORK_ID              NUMBER                DEFAULT 0                     NOT NULL,
  NTWK_PRSNL_RELTN_ID     NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_REVIEW_RELTN
(
  REVIEW_RELTN_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(30 BYTE),
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  SPECIALTY_CD            NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  SEQ_NBR                 NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_RX_ELIG_DETAIL
(
  EEM_RX_ELIG_DETAIL_ID    NUMBER               DEFAULT 0                     NOT NULL,
  INTERCHANGE_ID           NUMBER               DEFAULT 0                     NOT NULL,
  SEQUENCE                 NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  SENT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  REPLY_DT_TM              DATE,
  DATA_EXPIRE_DT_TM        DATE,
  CONTRIBUTOR_SYSTEM_CD    NUMBER               DEFAULT 0                     NOT NULL,
  PLAN_ADMIN_IDENT         VARCHAR2(80 BYTE),
  SENDER_PRSNL_ID          NUMBER               DEFAULT 0                     NOT NULL,
  TRANS_DATA_CD            NUMBER               DEFAULT 0                     NOT NULL,
  OB_FIRST_NAME            VARCHAR2(35 BYTE),
  OB_MIDDLE_NAME           VARCHAR2(25 BYTE),
  OB_LAST_NAME             VARCHAR2(60 BYTE),
  OB_BIRTH_DT_TM_TXT       VARCHAR2(35 BYTE),
  OB_GENDER_CD             NUMBER               DEFAULT 0                     NOT NULL,
  OB_POSTAL_CODE           VARCHAR2(15 BYTE),
  CARDHOLDER_IDENT         VARCHAR2(50 BYTE),
  CARDHOLDER_NAME          VARCHAR2(80 BYTE),
  PATIENT_UNIT_NUMBER      VARCHAR2(50 BYTE),
  PRESCRIPTION_PLAN_NAME   VARCHAR2(80 BYTE),
  PRESCRIPTION_PLAN_IDENT  VARCHAR2(50 BYTE),
  GROUP_NAME               VARCHAR2(80 BYTE),
  GROUP_IDENT              VARCHAR2(50 BYTE),
  BIN                      VARCHAR2(50 BYTE),
  FORMULARY_LIST_KEY       VARCHAR2(50 BYTE),
  FORMULARY_ALT_LIST_KEY   VARCHAR2(50 BYTE),
  COVERAGE_LIST_KEY        VARCHAR2(50 BYTE),
  COPAY_LIST_KEY           VARCHAR2(50 BYTE),
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  IB_FIRST_NAME            VARCHAR2(35 BYTE),
  IB_MIDDLE_NAME           VARCHAR2(25 BYTE),
  IB_LAST_NAME             VARCHAR2(60 BYTE),
  IB_NAME_SUFFIX           VARCHAR2(10 BYTE),
  IB_BIRTH_DT_TM_TXT       VARCHAR2(10 BYTE),
  IB_GENDER_CD             NUMBER               DEFAULT 0                     NOT NULL,
  IB_ADDRESS_LINE_1        VARCHAR2(55 BYTE),
  IB_ADDRESS_LINE_2        VARCHAR2(55 BYTE),
  IB_CITY                  VARCHAR2(30 BYTE),
  IB_STATE                 VARCHAR2(2 BYTE),
  IB_POSTAL_CODE           VARCHAR2(15 BYTE),
  IB_SSN                   VARCHAR2(30 BYTE),
  ORGANIZATION_ID          NUMBER               DEFAULT 0                     NOT NULL,
  PRESCRIBER_PRSNL_ID      NUMBER               DEFAULT 0                     NOT NULL,
  PBM_ORGANIZATION_ID      NUMBER               DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID           NUMBER               DEFAULT 0                     NOT NULL,
  IB_PAT_CHANGE_IND        NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_RX_MED_HIST_DETAIL
(
  EEM_RX_MED_HIST_DETAIL_ID  NUMBER             DEFAULT 0                     NOT NULL,
  INTERCHANGE_ID             NUMBER             DEFAULT 0                     NOT NULL,
  EEM_RX_ELIG_DETAIL_ID      NUMBER             DEFAULT 0                     NOT NULL,
  PERSON_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID             NUMBER             DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID            NUMBER             DEFAULT 0                     NOT NULL,
  SENT_DT_TM                 DATE,
  REPLY_DT_TM                DATE,
  DATA_EXPIRE_DT_TM          DATE,
  TRANS_DATA_CD              NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  RESPONSE_CD                NUMBER             DEFAULT 0                     NOT NULL,
  ORIGIN_INTERCHANGE_ID      NUMBER             DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD      NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_TRANSACTION
(
  TRANSACTION_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  INTERCHANGE_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  HASH_KEY             VARCHAR2(60 BYTE)        DEFAULT ' '                   NOT NULL,
  PARENT_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  PARENT_TABLE         VARCHAR2(32 BYTE)        DEFAULT ' '                   NOT NULL,
  PROFILE_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  DATA_FLAG            NUMBER                   DEFAULT 0                     NOT NULL,
  DATA_EXPIRE_DT_TM    DATE                     DEFAULT SYSDATE               NOT NULL,
  DATA_SIZE            NUMBER                   DEFAULT 0                     NOT NULL,
  POLL_EXPIRE_DT_TM    DATE                     DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  TRANSACTION_CD       NUMBER                   DEFAULT 0                     NOT NULL,
  TRANSACTION_MEANING  VARCHAR2(12 BYTE),
  TRANS_STATUS_CD      NUMBER                   DEFAULT 0                     NOT NULL,
  INTERCHANGE_UUID     VARCHAR2(40 BYTE),
  RECV_TIME            FLOAT(126),
  SENT_TIME            FLOAT(126),
  EEM_JOB_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  EEM_BATCH_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  TRANS_DATA_MOD_CD    NUMBER                   DEFAULT 0,
  TRANS_DATA_CD        NUMBER                   DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EEM_UBRN_DETAIL
(
  INTERCHANGE_ID   NUMBER                       DEFAULT 0                     NOT NULL,
  PERSON_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  ENCNTR_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  SENT_DT_TM       DATE                         DEFAULT sysdate               NOT NULL,
  REPLY_DT_TM      DATE,
  SENDER_PRSNL_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  EVENT_ALIAS      VARCHAR2(200 BYTE),
  PRIORITY_CD      NUMBER                       DEFAULT 0                     NOT NULL,
  REQ_DT_TM        DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EKS_ADVSR_EVENT
(
  EKS_ADVSR_EVENT_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  ENCNTR_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  ADVSR_TYPE_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  ADVSR_STATUS_CD      NUMBER                   DEFAULT 0                     NOT NULL,
  ADVSR_GROUP_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  ADVSR_EVENT_DESC     VARCHAR2(100 BYTE)       DEFAULT ' '                   NOT NULL,
  LONG_TEXT_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EKS_ALERT_ESCALATION
(
  ALERT_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  PARENT_ALERT_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  ENCNTR_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  ORDER_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  MSG_LONG_TEXT_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  SUBJECT_TEXT         VARCHAR2(200 BYTE),
  SUBJECT_PREFIX_TEXT  VARCHAR2(100 BYTE),
  SEND_DT_TM           DATE,
  ACK_BY_DT_TM         DATE,
  PRIORITY             NUMBER,
  ESCALATION_LEVEL     NUMBER,
  PROCESS_FLAG         NUMBER,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  ALERT_SOURCE         VARCHAR2(100 BYTE),
  TIMER_IND            NUMBER                   DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EKS_ALERT_ESC_HIST
(
  EKS_ALERT_ESC_HIST_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  ALERT_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  ALERT_SEQ              NUMBER                 DEFAULT 0                     NOT NULL,
  PARENT_ALERT_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  ACK_BY_DT_TM           DATE,
  ACK_BY_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  ACK_DT_TM              DATE,
  MSG_TYPE_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  ENCNTR_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  MSG_LONG_TEXT_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  SUBJECT_TEXT           VARCHAR2(200 BYTE),
  SUBJECT_PREFIX_TEXT    VARCHAR2(100 BYTE),
  ESCALATION_LEVEL       NUMBER,
  PRIORITY               NUMBER,
  ACK_COMMENT            VARCHAR2(2000 BYTE),
  SEND_DT_TM             DATE,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  ALERT_SOURCE           VARCHAR2(100 BYTE),
  PARENT_ENTITY_NAME     VARCHAR2(30 BYTE)      DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  FAILURE_REASON         VARCHAR2(100 BYTE),
  PARENT_ENTITY2_NAME    VARCHAR2(30 BYTE)      DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY2_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  CLOSED_IND             NUMBER,
  RECIPIENT_NAME         VARCHAR2(100 BYTE),
  EXPECTATION_FLAG       NUMBER,
  TIMER_IND              NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EKS_ALERT_RECIPIENT
(
  EKS_ALERT_RECIPIENT_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ALERT_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ALERT_SEQ               NUMBER                DEFAULT 0                     NOT NULL,
  MSG_TYPE_CD             NUMBER                DEFAULT 0                     NOT NULL,
  UNACK_COMMENT           VARCHAR2(2000 BYTE),
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(30 BYTE)     DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  FAILURE_REASON          VARCHAR2(100 BYTE),
  PARENT_ENTITY2_NAME     VARCHAR2(30 BYTE)     DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY2_ID       NUMBER                DEFAULT 0                     NOT NULL,
  RECIPIENT_NAME          VARCHAR2(100 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EKS_DLG_EVENT
(
  DLG_EVENT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  DLG_NAME                VARCHAR2(255 BYTE),
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  DLG_PRSNL_ID            NUMBER                DEFAULT 0                     NOT NULL,
  DLG_DT_TM               DATE,
  OVERRIDE_DEFAULT_IND    NUMBER,
  OVERRIDE_REASON_CD      NUMBER                DEFAULT 0                     NOT NULL,
  TRIGGER_ENTITY_NAME     CHAR(32 BYTE),
  TRIGGER_ENTITY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  TRIGGER_ORDER_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ALERT_LONG_TEXT_ID      NUMBER                DEFAULT 0                     NOT NULL,
  MODIFY_DLG_NAME         VARCHAR2(255 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EKS_DLG_EVENT_ATTR
(
  DLG_EVENT_ATTR_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  DLG_EVENT_ID       NUMBER                     DEFAULT 0                     NOT NULL,
  ATTR_NAME          CHAR(32 BYTE),
  ATTR_VALUE         VARCHAR2(255 BYTE),
  ACTIVE_IND         NUMBER,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  ATTR_ID            NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EKS_DLG_EVT_ACTION_R
(
  DLG_EVENT_ID        NUMBER                    DEFAULT 0                     NOT NULL,
  ACTION_NAME         VARCHAR2(255 BYTE)        DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_NAME  CHAR(32 BYTE),
  PARENT_ENTITY_ID    NUMBER                    DEFAULT 0,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EKS_DLG_EVT_ANSWER_R
(
  DLG_EVENT_ID  NUMBER                          DEFAULT 0                     NOT NULL,
  ANSWER_NAME   VARCHAR2(255 BYTE)              DEFAULT ' '                   NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EKS_MODULE_AUDIT
(
  REC_ID           NUMBER                       DEFAULT 0                     NOT NULL,
  SERVER_CLASS     CHAR(40 BYTE),
  SERVER_NUMBER    NUMBER,
  SERVER_INSTANCE  NUMBER,
  REQUEST_NUMBER   NUMBER,
  EVENT_NUMBER     NUMBER,
  MODULE_NAME      CHAR(30 BYTE),
  PERSONNEL_ID     NUMBER                       DEFAULT 0                     NOT NULL,
  CONCLUDE         NUMBER,
  BEGIN_DT_TM      DATE,
  END_DT_TM        DATE,
  LOGIC_COUNT      NUMBER,
  LOGIC_RETURN     CHAR(100 BYTE),
  ACTION_COUNT     NUMBER,
  ACTION_RETURN    CHAR(100 BYTE),
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EKS_MODULE_AUDIT_DET
(
  MODULE_AUDIT_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  TEMPLATE_NUMBER  NUMBER                       DEFAULT 0                     NOT NULL,
  TEMPLATE_TYPE    CHAR(1 BYTE),
  TEMPLATE_RETURN  NUMBER,
  ACCESSION_ID     NUMBER                       DEFAULT 0                     NOT NULL,
  ORDER_ID         NUMBER                       DEFAULT 0                     NOT NULL,
  ENCNTR_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  PERSON_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  LOGGING          VARCHAR2(2000 BYTE),
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD    NUMBER                       DEFAULT 0                     NOT NULL,
  TEMPLATE_NAME    CHAR(30 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EKS_NOTIFY_PERSN_R
(
  NOTIFICATION_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  PERSON_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  READ_IND         NUMBER,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EMPI_CACHE_UPDATE_QUEUE
(
  EMPI_CACHE_UPDATE_QUEUE_ID  NUMBER            DEFAULT 0                     NOT NULL,
  PERSON_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  ACTION_FLAG                 NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EMPI_PROCESS_LOG
(
  EMPI_PROCESS_LOG_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  CREATE_DT_TM         DATE                     DEFAULT SYSDATE               NOT NULL,
  EMPI_PROCESS         NUMBER                   DEFAULT 0                     NOT NULL,
  MATCHES_CNT          NUMBER,
  AUTO_RECONCILES_CNT  NUMBER,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_ACCIDENT
(
  ENCNTR_ACCIDENT_ID      NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ACCIDENT_DT_TM          DATE,
  ACCIDENT_CD             NUMBER                DEFAULT 0                     NOT NULL,
  ACCIDENT_LOCTN          VARCHAR2(100 BYTE),
  ACCIDENT_TEXT           VARCHAR2(255 BYTE),
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  ACC_STATE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  ACC_JOB_RELATED_CD      NUMBER                DEFAULT 0                     NOT NULL,
  ACC_DEATH_CD            NUMBER                DEFAULT 0                     NOT NULL,
  POLICE_INVOLVE_CD       NUMBER                DEFAULT 0,
  POLICE_FORCE_CD         NUMBER                DEFAULT 0,
  POLICE_BADGE_NBR        CHAR(20 BYTE),
  AMBULANCE_ARRIVE_CD     NUMBER                DEFAULT 0,
  AMBULANCE_GEO_CD        NUMBER                DEFAULT 0,
  AMBULANCE_SERV_NBR      CHAR(20 BYTE),
  ACC_EMPL_ORG_ID         NUMBER                DEFAULT 0,
  PLACE_CD                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_ACP_HIST
(
  ENCNTR_ACP_HIST_ID            NUMBER          DEFAULT 0                     NOT NULL,
  ENCNTR_AUGM_CARE_PERIOD_ID    NUMBER          DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID           NUMBER          DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM             DATE,
  CHANGE_BIT                    NUMBER          DEFAULT 0                     NOT NULL,
  TRACKING_BIT                  NUMBER          DEFAULT 0                     NOT NULL,
  PERSON_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  ENCNTR_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  AUGM_CARE_PERIOD_PLAN_CD      NUMBER          DEFAULT 0                     NOT NULL,
  NUM_ORGAN_SYS_SUPPORT_NBR     NUMBER,
  HIGH_DEPEND_CARE_LVL_DAYS     NUMBER,
  INTENSIVE_CARE_LVL_DAYS       NUMBER,
  AUGM_MEDICAL_SERVICE_CD       NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_IND                    NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM           DATE            DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID        NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD              NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  AUGM_CARE_PERIOD_SOURCE_CD    NUMBER          DEFAULT 0                     NOT NULL,
  AUGM_CARE_PERIOD_DISPOSAL_CD  NUMBER          DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_ALIAS_HIST
(
  ENCNTR_ALIAS_HIST_ID    NUMBER                DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID     NUMBER                DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM       DATE,
  CHANGE_BIT              NUMBER                DEFAULT 0                     NOT NULL,
  TRACKING_BIT            NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ALIAS_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ALIAS                   VARCHAR2(200 BYTE),
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_APPEAL
(
  ENCNTR_APPEAL_ID              NUMBER          DEFAULT 0                     NOT NULL,
  ENCNTR_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  PAYER_ORG_ID                  NUMBER          DEFAULT 0                     NOT NULL,
  APPEAL_LEVEL_CD               NUMBER          DEFAULT 0                     NOT NULL,
  APPEAL_STATUS_CD              NUMBER          DEFAULT 0                     NOT NULL,
  COMMENT_LONG_TEXT_ID          NUMBER          DEFAULT 0                     NOT NULL,
  EXT_APPEAL_AGENCY_CD          NUMBER          DEFAULT 0                     NOT NULL,
  PROVIDED_LEVEL_OF_CARE_CD     NUMBER          DEFAULT 0                     NOT NULL,
  PRE_APPEAL_LEVEL_OF_CARE_CD   NUMBER          DEFAULT 0                     NOT NULL,
  POST_APPEAL_LEVEL_OF_CARE_CD  NUMBER          DEFAULT 0                     NOT NULL,
  APPEAL_OUTCOME_CD             NUMBER          DEFAULT 0                     NOT NULL,
  APPEAL_SENT_DT_TM             DATE,
  APPEAL_VERIFIED_DT_TM         DATE,
  APPEAL_EXPECT_RESP_DT_TM      DATE,
  APPEAL_OUTCOME_DT_TM          DATE,
  APPEAL_PRSNL_ID               NUMBER          DEFAULT 0                     NOT NULL,
  APPEAL_COMM_TYPE_CD           NUMBER          DEFAULT 0                     NOT NULL,
  TRACKING_NBR_TEXT             VARCHAR2(255 BYTE),
  ACTIVE_IND                    NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM           DATE            DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID        NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD              NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  ADVISOR_PRSNL_ID              NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_AUGM_CARE_PERIOD
(
  ENCNTR_AUGM_CARE_PERIOD_ID    NUMBER          DEFAULT 0                     NOT NULL,
  PERSON_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  ENCNTR_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  AUGM_CARE_PERIOD_PLAN_CD      NUMBER          DEFAULT 0                     NOT NULL,
  NUM_ORGAN_SYS_SUPPORT_NBR     NUMBER,
  HIGH_DEPEND_CARE_LVL_DAYS     NUMBER,
  INTENSIVE_CARE_LVL_DAYS       NUMBER,
  AUGM_MEDICAL_SERVICE_CD       NUMBER          DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM           DATE,
  END_EFFECTIVE_DT_TM           DATE,
  ACTIVE_IND                    NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM           DATE            DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID        NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD              NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  AUGM_CARE_PERIOD_SOURCE_CD    NUMBER          DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_ID               NUMBER          DEFAULT 0                     NOT NULL,
  AUGM_CARE_PERIOD_DISPOSAL_CD  NUMBER          DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_AVOIDABLE_DAYS
(
  ENCNTR_AVOIDABLE_DAYS_ID    NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  BEG_DT_TM                   DATE,
  END_DT_TM                   DATE,
  REASON_TYPE_CD              NUMBER            DEFAULT 0                     NOT NULL,
  REASON_CD                   NUMBER            DEFAULT 0                     NOT NULL,
  COMMENT_LONG_TEXT_ID        NUMBER            DEFAULT 0                     NOT NULL,
  RESP_PARTY_SELF_IND         NUMBER            DEFAULT 0                     NOT NULL,
  RESP_PARTY_PAYER_ORG_ID     NUMBER            DEFAULT 0                     NOT NULL,
  RESP_PARTY_PRSNL_ID         NUMBER            DEFAULT 0                     NOT NULL,
  RESP_PARTY_SERVICE_TYPE_CD  NUMBER            DEFAULT 0                     NOT NULL,
  RESP_PARTY_BUSINESS_ORG_ID  NUMBER            DEFAULT 0                     NOT NULL,
  RESP_PARTY_OTHER_CD         NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE              DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  RESP_PARTY_NURSE_UNIT_CD    NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_BENEFIT_R
(
  ENCNTR_BENEFIT_R_ID          NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_PLAN_RELTN_ID         NUMBER           DEFAULT 0                     NOT NULL,
  BENEFIT_PLAN_CD              NUMBER           DEFAULT 0                     NOT NULL,
  SERVICE_TYPE_CD              NUMBER           DEFAULT 0                     NOT NULL,
  COVERAGE_DAYS                NUMBER           DEFAULT 0                     NOT NULL,
  COVERAGE_REMAIN_DAYS         NUMBER           DEFAULT 0                     NOT NULL,
  NON_COVERAGE_DAYS            NUMBER           DEFAULT 0                     NOT NULL,
  COINSURANCE_DAYS             NUMBER           DEFAULT 0                     NOT NULL,
  COINSURANCE_REMAIN_DAYS      NUMBER           DEFAULT 0                     NOT NULL,
  COINSURANCE_PCT              FLOAT(126)       DEFAULT 0                     NOT NULL,
  COPAY_AMT                    FLOAT(126)       DEFAULT 0                     NOT NULL,
  DEDUCT_PCT                   FLOAT(126)       DEFAULT 0                     NOT NULL,
  DEDUCT_AMT                   FLOAT(126)       DEFAULT 0                     NOT NULL,
  DEDUCT_MET_AMT               FLOAT(126)       DEFAULT 0                     NOT NULL,
  DEDUCT_MET_DT_TM             DATE,
  DEDUCT_REMAIN_AMT            FLOAT(126)       DEFAULT 0                     NOT NULL,
  ROOM_COVERAGE_AMT            FLOAT(126)       DEFAULT 0                     NOT NULL,
  ROOM_COVERAGE_AMT_QUAL_CD    NUMBER           DEFAULT 0                     NOT NULL,
  ROOM_COVERAGE_TYPE_CD        NUMBER           DEFAULT 0                     NOT NULL,
  ROOM_COVERAGE_BOARD_INCL_CD  NUMBER           DEFAULT 0                     NOT NULL,
  COMMENT_ID                   NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DATA_STATUS_CD               NUMBER           DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM            DATE,
  DATA_STATUS_PRSNL_ID         NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_BENEFIT_SCH_R
(
  ENCNTR_BENEFIT_SCH_R_ID  NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_BENEFIT_R_ID      NUMBER               DEFAULT 0                     NOT NULL,
  MEMBER_RESP_TYPE_CD      NUMBER               DEFAULT 0                     NOT NULL,
  RESP_RANGE_START_NBR     NUMBER               DEFAULT 0                     NOT NULL,
  RESP_RANGE_END_NBR       NUMBER               DEFAULT 0                     NOT NULL,
  RESP_TYPE_QUAL_CD        NUMBER               DEFAULT 0                     NOT NULL,
  RESP_RANGE_AMT           FLOAT(126)           DEFAULT 0                     NOT NULL,
  RESP_RANGE_QUAL_CD       NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE ( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DATA_STATUS_CD           NUMBER               DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM        DATE,
  DATA_STATUS_PRSNL_ID     NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_CARE_MGMT
(
  ENCNTR_CARE_MGMT_ID        NUMBER             DEFAULT 0                     NOT NULL,
  ENCNTR_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  CLINICAL_REVIEW_DUE_DT_TM  DATE,
  UTLZTN_MGMT_STATUS_CD      NUMBER             DEFAULT 0                     NOT NULL,
  DISCH_PLAN_DUE_DT_TM       DATE,
  DISCH_PLAN_STATUS_CD       NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID     NUMBER             DEFAULT 0                     NOT NULL,
  DOCUMENT_REVIEW_STATUS_CD  NUMBER             DEFAULT 0,
  DOCUMENT_REVIEW_DUE_DT_TM  DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_CARE_MGMT_COMM
(
  ENCNTR_CARE_MGMT_COMM_ID   NUMBER             DEFAULT 0                     NOT NULL,
  SENDER_PRSNL_ID            NUMBER             DEFAULT 0                     NOT NULL,
  SENT_DT_TM                 DATE,
  FT_FORMATTED_PHONE_NUMBER  VARCHAR2(100 BYTE),
  ORGANIZATION_ID            NUMBER             DEFAULT 0                     NOT NULL,
  DOCUMENT_TYPE_CD           NUMBER             DEFAULT 0                     NOT NULL,
  CORRESPONDENCE_CD          NUMBER             DEFAULT 0                     NOT NULL,
  RECIPIENT_NAME             VARCHAR2(100 BYTE),
  COMMENT_ID                 NUMBER             DEFAULT 0                     NOT NULL,
  REPORT_REQUEST_ID          NUMBER             DEFAULT 0                     NOT NULL,
  TRANSMISSION_STATUS_CD     NUMBER             DEFAULT 0                     NOT NULL,
  COMMUNICATION_STATUS_CD    NUMBER             DEFAULT 0                     NOT NULL,
  PHONE_SUFFIX               VARCHAR2(50 BYTE),
  AUTH_NUMBER                VARCHAR2(50 BYTE),
  COMMUNICATION_TYPE_CD      NUMBER             DEFAULT 0                     NOT NULL,
  NUMBER_OF_PAGES            NUMBER             DEFAULT 0                     NOT NULL,
  ENCNTR_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  OUTPUT_DEST_ID             NUMBER             DEFAULT 0                     NOT NULL,
  HANDLE_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  FT_CONTACT_NAME            VARCHAR2(100 BYTE),
  FT_CONTACT_PHONE           VARCHAR2(50 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_CARE_MGMT_COMM_RLTN
(
  ENCNTR_CARE_MGMT_COMM_RLTN_ID  NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_CARE_MGMT_COMM_ID       NUMBER         DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID               NUMBER         DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME             VARCHAR2(30 BYTE) DEFAULT ' ' NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_CLASS_GROUP
(
  ENCNTR_CLASS_GROUP_ID   NUMBER                DEFAULT 0                     NOT NULL,
  BE_DOMAIN_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CLASS_CD    NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_CLIN_REVIEW
(
  ENCNTR_CLIN_REVIEW_ID    NUMBER               DEFAULT 0                     NOT NULL,
  CLINICAL_REVIEW_ID       NUMBER               DEFAULT 0                     NOT NULL,
  REVIEW_TYPE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  CONTENT_SOURCE_CD        NUMBER               DEFAULT 0                     NOT NULL,
  REVIEW_SUB_TYPE          VARCHAR2(255 BYTE),
  REVIEW_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  REVIEW_COMMENT_ID        NUMBER               DEFAULT 0                     NOT NULL,
  REVIEWED_DT_TM           DATE,
  TRANSMITTED_DT_TM        DATE,
  VERSION_DT_TM            DATE,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  REVIEW_RESULT_CD         NUMBER               DEFAULT 0                     NOT NULL,
  REVIEW_SUB_TYPE_ID       NUMBER               DEFAULT 0                     NOT NULL,
  CONTENT_VERSION_CD       NUMBER               DEFAULT 0                     NOT NULL,
  RESULT_XML_LONG_TEXT_ID  NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_CLIN_REVIEW_RESULT
(
  ENCNTR_CLIN_REVIEW_RESULT_ID  NUMBER          DEFAULT 0                     NOT NULL,
  CLINICAL_REVIEW_ID            NUMBER          DEFAULT 0                     NOT NULL,
  RESULT_TYPE_CD                NUMBER          DEFAULT 0                     NOT NULL,
  RESULT_LONG_BLOB_ID           NUMBER          DEFAULT 0                     NOT NULL,
  RESULT_COMMENT_ID             NUMBER          DEFAULT 0                     NOT NULL,
  RESULT_CD                     NUMBER          DEFAULT 0                     NOT NULL,
  VERSION_DT_TM                 DATE,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  RESULT_LONG_TEXT_ID           NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_CLIN_SEC_REVIEW
(
  ENCNTR_CLIN_SEC_REVIEW_ID  NUMBER             DEFAULT 0                     NOT NULL,
  CLINICAL_REVIEW_ID         NUMBER             DEFAULT 0                     NOT NULL,
  SEC_REVIEW_REASON_CD       NUMBER             DEFAULT 0                     NOT NULL,
  SEC_REVIEW_RESP_PARTY_TXT  VARCHAR2(100 BYTE),
  SEC_REVIEW_OUTCOME_CD      NUMBER             DEFAULT 0                     NOT NULL,
  SEC_REVIEW_COMMENT_ID      NUMBER             DEFAULT 0                     NOT NULL,
  VERSION_DT_TM              DATE,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  EXTERNAL_REVIEW_IND        NUMBER             DEFAULT 0                     NOT NULL,
  COMMUNICATION_TYPE_CD      NUMBER             DEFAULT 0                     NOT NULL,
  SEC_REVIEW_RESP_PARTY_ID   NUMBER             DEFAULT 0                     NOT NULL,
  CLIN_SEC_REVIEW_ID         NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_CODE_VALUE_R
(
  ENCNTR_CODE_VALUE_R_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CODE_SET                NUMBER                DEFAULT 0                     NOT NULL,
  CODE_VALUE              NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 1,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' )
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_CODE_VALUE_R_HIST
(
  ENCNTR_CODE_VALUE_R_HIST_ID  NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID          NUMBER           DEFAULT 0                     NOT NULL,
  CODE_SET                     NUMBER           DEFAULT 0                     NOT NULL,
  CODE_VALUE                   NUMBER           DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM            DATE,
  BEG_EFFECTIVE_DT_TM          DATE,
  END_EFFECTIVE_DT_TM          DATE,
  ACTIVE_IND                   NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_COMBINE
(
  ENCNTR_COMBINE_ID       NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  FROM_ENCNTR_ID          NUMBER                DEFAULT 0                     NOT NULL,
  TO_ENCNTR_ID            NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  COMBINE_ACTION_CD       NUMBER                DEFAULT 0                     NOT NULL,
  PREV_ACTIVE_IND         NUMBER,
  PREV_ACTIVE_STATUS_CD   NUMBER                DEFAULT 0                     NOT NULL,
  PREV_CONFID_LEVEL_CD    NUMBER                DEFAULT 0                     NOT NULL,
  APPLICATION_FLAG        NUMBER,
  TRANSACTION_TYPE        VARCHAR2(8 BYTE),
  CMB_UPDT_ID             NUMBER,
  CMB_DT_TM               DATE,
  UCB_UPDT_ID             NUMBER,
  UCB_DT_TM               DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_COMBINE_DET
(
  ENCNTR_COMBINE_DET_ID   NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_COMBINE_ID       NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ENTITY_NAME             VARCHAR2(32 BYTE)     DEFAULT ' '                   NOT NULL,
  ENTITY_ID               NUMBER                DEFAULT 0                     NOT NULL,
  COMBINE_ACTION_CD       NUMBER                DEFAULT 0                     NOT NULL,
  ATTRIBUTE_NAME          VARCHAR2(32 BYTE),
  PREV_ACTIVE_IND         NUMBER,
  PREV_ACTIVE_STATUS_CD   NUMBER                DEFAULT 0                     NOT NULL,
  PREV_END_EFF_DT_TM      DATE,
  COMBINE_DESC_CD         NUMBER                DEFAULT 0                     NOT NULL,
  TO_RECORD_IND           NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_CONDITION_CODE
(
  CONDITION_CODE_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CONDITION_CD            NUMBER                DEFAULT 0                     NOT NULL,
  SEQUENCE                NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_CRIMINAL_CHARGES_R
(
  OUTSTANDING_CHARGES_R_ID    NUMBER            DEFAULT 0                     NOT NULL,
  OUTSTANDING_CHARGE_CD       NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  COURT_DT_TM                 DATE,
  COURT_FILE_NUM              VARCHAR2(40 BYTE),
  COURT_LOCATION_CD           NUMBER            DEFAULT 0                     NOT NULL,
  CRIMINAL_CHRG_INACTIVE_IND  NUMBER,
  ACTIVE_IND                  NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE              DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_DENIAL_APPEAL_RELTN
(
  ENCNTR_DENIAL_APPEAL_RELTN_ID  NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_DENIED_DAYS_ID          NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_APPEAL_ID               NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVE_IND                     NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM            DATE           DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID         NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD               NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_DENIED_DAYS
(
  ENCNTR_DENIED_DAYS_ID       NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  PAYER_ORG_ID                NUMBER            DEFAULT 0                     NOT NULL,
  DENIAL_PRSNL_ID             NUMBER            DEFAULT 0                     NOT NULL,
  DENIAL_TYPE_CD              NUMBER            DEFAULT 0                     NOT NULL,
  DENIAL_REASON_CD            NUMBER            DEFAULT 0                     NOT NULL,
  COMMENT_LONG_TEXT_ID        NUMBER            DEFAULT 0                     NOT NULL,
  BEG_DT_TM                   DATE,
  END_DT_TM                   DATE,
  NOTICE_RECEIVED_DT_TM       DATE,
  LETTER_DT_TM                DATE,
  CLOSED_DT_TM                DATE,
  RESP_PARTY_SELF_IND         NUMBER            DEFAULT 0                     NOT NULL,
  RESP_PARTY_PRSNL_ID         NUMBER            DEFAULT 0                     NOT NULL,
  RESP_PARTY_SERVICE_TYPE_CD  NUMBER            DEFAULT 0                     NOT NULL,
  RESP_PARTY_NURSE_UNIT_CD    NUMBER            DEFAULT 0                     NOT NULL,
  RESP_PARTY_OTHER_CD         NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE              DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  APPEAL_BY_DT_TM             DATE,
  DENIAL_RISK_AMOUNT          FLOAT(126)        DEFAULT 0                     NOT NULL,
  DENIAL_CATEGORY_CD          NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_DOMAIN
(
  ENCNTR_DOMAIN_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_DOMAIN_TYPE_CD   NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  LOC_FACILITY_CD         NUMBER                DEFAULT 0                     NOT NULL,
  LOC_BUILDING_CD         NUMBER                DEFAULT 0                     NOT NULL,
  LOC_NURSE_UNIT_CD       NUMBER                DEFAULT 0                     NOT NULL,
  LOC_ROOM_CD             NUMBER                DEFAULT 0                     NOT NULL,
  LOC_BED_CD              NUMBER                DEFAULT 0                     NOT NULL,
  MED_SERVICE_CD          NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_ENCNTR_RELTN
(
  ENCNTR_ENCNTR_RELTN_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  RELATED_ENCNTR_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_RELTN_TYPE_CD    NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_EVENT_SET_IO
(
  ENCNTR_EVENT_SET_IO_ID  NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_SET_NAME          VARCHAR2(40 BYTE)     DEFAULT ' '                   NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_FINANCIAL
(
  ENCNTR_FINANCIAL_ID     NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  RESEARCH_ACCOUNT        VARCHAR2(100 BYTE),
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  BILL_TYPE_CD            NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_FINANCIAL_ALIAS
(
  ENCNTR_FIN_ALIAS_ID     NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_FINANCIAL_ID     NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ALIAS_POOL_CD           NUMBER                DEFAULT 0                     NOT NULL,
  FIN_ALIAS_TYPE_CD       NUMBER                DEFAULT 0                     NOT NULL,
  ALIAS                   VARCHAR2(200 BYTE),
  FIN_ALIAS_SUB_TYPE_CD   NUMBER                DEFAULT 0                     NOT NULL,
  CHECK_DIGIT             NUMBER,
  CHECK_DIGIT_METHOD_CD   NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE ( '12/31/210000:00:00' , 'MM/DD/YYYYHH24:MI:SS' ),
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_FIN_CMB
(
  ENCNTR_FIN_CMB_ID       NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  TO_ENCNTR_FIN_ID        NUMBER                DEFAULT 0                     NOT NULL,
  FROM_ENCNTR_FIN_ID      NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  COMBINE_ACTION_CD       NUMBER                DEFAULT 0                     NOT NULL,
  PREV_ACTIVE_IND         NUMBER,
  PREV_ACTIVE_STATUS_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_FIN_CMB_DET
(
  ENCNTR_FIN_CMB_DET_ID   NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_FIN_CMB_ID       NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ENTITY_NAME             VARCHAR2(32 BYTE)     DEFAULT ' '                   NOT NULL,
  ENTITY_ID               NUMBER                DEFAULT 0                     NOT NULL,
  COMBINE_ACTION_CD       NUMBER                DEFAULT 0                     NOT NULL,
  ATTRIBUTE_NAME          VARCHAR2(32 BYTE),
  PREV_ACTIVE_IND         NUMBER,
  PREV_ACTIVE_STATUS_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_FLEX_HIST
(
  ENCNTR_FLEX_HIST_ID          NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  CHANGE_BIT                   NUMBER           DEFAULT 0                     NOT NULL,
  TRACKING_BIT                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVITY_DT_TM               DATE             DEFAULT SYSDATE               NOT NULL,
  TRANSACTION_DT_TM            DATE             DEFAULT SYSDATE               NOT NULL,
  MENTAL_HEALTH_CD             NUMBER           DEFAULT 0                     NOT NULL,
  MENTAL_HEALTH_DT_TM          DATE,
  REG_DT_TM                    DATE,
  ADMIT_TYPE_CD                NUMBER           DEFAULT 0                     NOT NULL,
  TRIAGE_CD                    NUMBER           DEFAULT 0                     NOT NULL,
  DISCH_DISPOSITION_CD         NUMBER           DEFAULT 0                     NOT NULL,
  ADMIT_SRC_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  ACCOMMODATION_REQUEST_CD     NUMBER           DEFAULT 0                     NOT NULL,
  DISCH_DT_TM                  DATE,
  ADMIT_MODE_CD                NUMBER           DEFAULT 0                     NOT NULL,
  TRIAGE_DT_TM                 DATE,
  PLACEMENT_AUTH_PRSNL_ID      NUMBER           DEFAULT 0                     NOT NULL,
  ALT_LVL_CARE_DT_TM           DATE,
  ALT_LVL_CARE_DECOMP_DT_TM    DATE,
  ACCOMMODATION_CD             NUMBER           DEFAULT 0                     NOT NULL,
  REGION_CD                    NUMBER           DEFAULT 0                     NOT NULL,
  ISOLATION_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID              NUMBER           DEFAULT 0                     NOT NULL,
  LOC_FACILITY_CD              NUMBER           DEFAULT 0                     NOT NULL,
  LOC_BUILDING_CD              NUMBER           DEFAULT 0                     NOT NULL,
  LOC_NURSE_UNIT_CD            NUMBER           DEFAULT 0                     NOT NULL,
  LOC_ROOM_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  LOC_BED_CD                   NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CD               NUMBER           DEFAULT 0                     NOT NULL,
  MED_SERVICE_CD               NUMBER           DEFAULT 0                     NOT NULL,
  TRANSFER_REASON_CD           NUMBER           DEFAULT 0                     NOT NULL,
  ALT_LVL_CARE_CD              NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID          NUMBER           DEFAULT 0                     NOT NULL,
  PERSON_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  DISCH_TO_LOCTN_CD            NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  TRAUMA_CD                    NUMBER           DEFAULT 0                     NOT NULL,
  TRAUMA_DT_TM                 DATE,
  PATIENT_CLASSIFICATION_CD    NUMBER           DEFAULT 0                     NOT NULL,
  MENTAL_CATEGORY_CD           NUMBER           DEFAULT 0                     NOT NULL,
  PSYCHIATRIC_STATUS_CD        NUMBER           DEFAULT 0                     NOT NULL,
  INPATIENT_ADMIT_DT_TM        DATE,
  LOC_TEMP_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  ACCOMMODATION_REASON_CD      NUMBER           DEFAULT 0,
  ALC_DECOMP_DT_TM             DATE,
  ALC_REASON_CD                NUMBER           DEFAULT 0,
  ARRIVE_DT_TM                 DATE,
  ARRIVE_PRSNL_ID              NUMBER           DEFAULT 0,
  DEPART_DT_TM                 DATE,
  DEPART_PRSNL_ID              NUMBER           DEFAULT 0,
  ENCNTR_TYPE_CLASS_CD         NUMBER           DEFAULT 0,
  SECURITY_ACCESS_CD           NUMBER           DEFAULT 0,
  SERVICE_CATEGORY_CD          NUMBER           DEFAULT 0,
  PREGNANCY_STATUS_CD          NUMBER           DEFAULT 0,
  INITIAL_CONTACT_DT_TM        DATE,
  LAST_MENSTRUAL_PERIOD_DT_TM  DATE,
  ONSET_DT_TM                  DATE,
  EXPECTED_DELIVERY_DT_TM      DATE,
  LEVEL_OF_SERVICE_CD          NUMBER           DEFAULT 0,
  PREADMIT_TESTING_CD          NUMBER           DEFAULT 0,
  READMIT_CD                   NUMBER           DEFAULT 0,
  ALT_RESULT_DEST_CD           NUMBER           DEFAULT 0,
  AMBULATORY_COND_CD           NUMBER           DEFAULT 0,
  COURTESY_CD                  NUMBER           DEFAULT 0,
  DIET_TYPE_CD                 NUMBER           DEFAULT 0,
  RESULT_DEST_CD               NUMBER           DEFAULT 0,
  CONFID_LEVEL_CD              NUMBER           DEFAULT 0,
  VIP_CD                       NUMBER           DEFAULT 0,
  NAME_LAST_KEY                VARCHAR2(200 BYTE),
  NAME_FIRST_KEY               VARCHAR2(200 BYTE),
  NAME_FULL_FORMATTED          VARCHAR2(200 BYTE),
  NAME_LAST                    VARCHAR2(200 BYTE),
  NAME_FIRST                   VARCHAR2(200 BYTE),
  NAME_PHONETIC                VARCHAR2(200 BYTE),
  SEX_CD                       NUMBER           DEFAULT 0,
  BIRTH_DT_CD                  NUMBER           DEFAULT 0,
  BIRTH_DT_TM                  DATE,
  SPECIES_CD                   NUMBER           DEFAULT 0,
  DATA_STATUS_CD               NUMBER           DEFAULT 0,
  DATA_STATUS_DT_TM            DATE,
  DATA_STATUS_PRSNL_ID         NUMBER           DEFAULT 0,
  CONTRIBUTOR_SYSTEM_CD        NUMBER           DEFAULT 0,
  GUARANTOR_TYPE_CD            NUMBER           DEFAULT 0,
  REASON_FOR_VISIT             VARCHAR2(255 BYTE),
  ENCNTR_FINANCIAL_ID          NUMBER           DEFAULT 0,
  NAME_FIRST_SYNONYM_ID        NUMBER           DEFAULT 0,
  FINANCIAL_CLASS_CD           NUMBER           DEFAULT 0,
  BBD_PROCEDURE_CD             NUMBER           DEFAULT 0,
  INFO_GIVEN_BY                CHAR(100 BYTE),
  SAFEKEEPING_CD               NUMBER           DEFAULT 0,
  VISITOR_STATUS_CD            NUMBER           DEFAULT 0,
  VALUABLES_CD                 NUMBER           DEFAULT 0,
  REFER_FACILITY_CD            NUMBER           DEFAULT 0,
  ACCOMP_BY_CD                 NUMBER           DEFAULT 0,
  CHART_COMPLETE_DT_TM         DATE,
  LOCATION_CD                  NUMBER           DEFAULT 0,
  ZERO_BALANCE_DT_TM           DATE,
  ARCHIVE_DT_TM_EST            DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  ARCHIVE_DT_TM_ACT            DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  PURGE_DT_TM_EST              DATE,
  PURGE_DT_TM_ACT              DATE,
  ENCNTR_COMPLETE_DT_TM        DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  PA_CURRENT_STATUS_CD         NUMBER           DEFAULT 0,
  PA_CURRENT_STATUS_DT_TM      DATE,
  PARENT_RET_CRITERIA_ID       NUMBER           DEFAULT 0,
  CONTRACT_STATUS_CD           NUMBER           DEFAULT 0,
  EST_LENGTH_OF_STAY           NUMBER,
  ASSIGN_TO_LOC_DT_TM          DATE,
  PROGRAM_SERVICE_CD           NUMBER           DEFAULT 0,
  SPECIALTY_UNIT_CD            NUMBER           DEFAULT 0,
  DOC_RCVD_DT_TM               DATE,
  REFERRAL_RCVD_DT_TM          DATE,
  SITTER_REQUIRED_CD           NUMBER           DEFAULT 0,
  RESULT_ACCUMULATION_DT_TM    DATE,
  ABN_STATUS_CD                NUMBER           DEFAULT 0,
  CREATE_DT_TM                 DATE,
  CREATE_PRSNL_ID              NUMBER           DEFAULT 0,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  ENCNTR_CLASS_CD              NUMBER           DEFAULT 0,
  PRE_REG_DT_TM                DATE,
  PRE_REG_PRSNL_ID             NUMBER           DEFAULT 0,
  REG_PRSNL_ID                 NUMBER           DEFAULT 0,
  EST_ARRIVE_DT_TM             DATE,
  EST_DEPART_DT_TM             DATE,
  ADMIT_WITH_MEDICATION_CD     NUMBER           DEFAULT 0,
  REFERRING_COMMENT            VARCHAR2(100 BYTE),
  PREADMIT_NBR                 VARCHAR2(100 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_INFO
(
  ENCNTR_INFO_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  INFO_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  INFO_SUB_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_NUMERIC           NUMBER,
  VALUE_DT_TM             DATE,
  CHARTABLE_IND           NUMBER,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ            NUMBER,
  INTERNAL_SEQ            NUMBER,
  VALUE_CD                NUMBER                DEFAULT 0,
  VALUE_NUMERIC_IND       NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_INFO_HIST
(
  ENCNTR_INFO_HIST_ID     NUMBER                DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID     NUMBER                DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM       DATE,
  CHANGE_BIT              NUMBER                DEFAULT 0                     NOT NULL,
  TRACKING_BIT            NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_INFO_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  INFO_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  INFO_SUB_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_DT_TM             DATE,
  VALUE_TYPE              NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_LONG_TEXT_ID      NUMBER                DEFAULT 0                     NOT NULL,
  CHARTABLE_IND           NUMBER,
  PRIORITY_SEQ            NUMBER,
  INTERNAL_SEQ            NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_NUMERIC           NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_CD                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_LEAVE
(
  ENCNTR_LEAVE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  LEAVE_COMMENT           VARCHAR2(255 BYTE),
  LEAVE_DT_TM             DATE,
  LEAVE_IND               NUMBER,
  LEAVE_LOCATION          VARCHAR2(100 BYTE),
  LEAVE_REASON_CD         NUMBER                DEFAULT 0                     NOT NULL,
  LEAVE_USER_ID           NUMBER                DEFAULT 0                     NOT NULL,
  EST_RETURN_DT_TM        DATE,
  RETURN_COMMENT          VARCHAR2(255 BYTE),
  RETURN_DT_TM            DATE,
  RETURN_LOCATION_CD      NUMBER                DEFAULT 0                     NOT NULL,
  RETURN_REASON_CD        NUMBER                DEFAULT 0                     NOT NULL,
  RETURN_USER_ID          NUMBER                DEFAULT 0                     NOT NULL,
  CANCEL_COMMENT          VARCHAR2(255 BYTE),
  CANCEL_DT_TM            DATE,
  CANCEL_REASON_CD        NUMBER                DEFAULT 0                     NOT NULL,
  CANCEL_USER_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  LEAVE_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  HOLD_RMVL_DT_TM         DATE,
  AUTO_DISCH_DT_TM        DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_LEAVE_HIST
(
  ENCNTR_LEAVE_HIST_ID     NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  LEAVE_DT_TM              DATE,
  RETURN_DT_TM             DATE,
  LEAVE_REASON_CD          NUMBER               DEFAULT 0                     NOT NULL,
  LEAVE_AUTHORIZED_BY_ID   NUMBER               DEFAULT 0                     NOT NULL,
  RETURN_AUTHORIZED_BY_ID  NUMBER               DEFAULT 0                     NOT NULL,
  RESERVE_ROOM_CD          NUMBER               DEFAULT 0                     NOT NULL,
  LEAVE_LOCATION           VARCHAR2(100 BYTE),
  DATA_STATUS_CD           NUMBER               DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM        DATE,
  DATA_STATUS_PRSNL_ID     NUMBER               DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD    NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_LEAVE_HISTORY
(
  ENCNTR_LEAVE_HISTORY_ID  NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_LEAVE_ID          NUMBER               DEFAULT 0                     NOT NULL,
  HISTORY_DT_TM            DATE                 DEFAULT SYSDATE               NOT NULL,
  LEAVE_COMMENT            VARCHAR2(255 BYTE),
  LEAVE_DT_TM              DATE,
  LEAVE_IND                NUMBER,
  LEAVE_LOCATION           VARCHAR2(100 BYTE),
  LEAVE_REASON_CD          NUMBER               DEFAULT 0                     NOT NULL,
  LEAVE_USER_ID            NUMBER               DEFAULT 0                     NOT NULL,
  EST_RETURN_DT_TM         DATE,
  RETURN_COMMENT           VARCHAR2(255 BYTE),
  RETURN_DT_TM             DATE,
  RETURN_LOCATION_CD       NUMBER               DEFAULT 0                     NOT NULL,
  RETURN_REASON_CD         NUMBER               DEFAULT 0                     NOT NULL,
  RETURN_USER_ID           NUMBER               DEFAULT 0                     NOT NULL,
  CANCEL_COMMENT           VARCHAR2(255 BYTE),
  CANCEL_DT_TM             DATE,
  CANCEL_REASON_CD         NUMBER               DEFAULT 0                     NOT NULL,
  CANCEL_USER_ID           NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  DATA_STATUS_CD           NUMBER               DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM        DATE,
  DATA_STATUS_PRSNL_ID     NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  LEAVE_TYPE_CD            NUMBER               DEFAULT 0                     NOT NULL,
  HOLD_RMVL_DT_TM          DATE,
  AUTO_DISCH_DT_TM         DATE,
  PM_HIST_TRACKING_ID      NUMBER               DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM        DATE,
  CHANGE_BIT               NUMBER               DEFAULT 0                     NOT NULL,
  TRACKING_BIT             NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_LEGAL_REVIEW_R
(
  ENCNTR_LEG_STAT_REV_R_ID  NUMBER              DEFAULT 0                     NOT NULL,
  LEGAL_STATUS_R_ID         NUMBER              DEFAULT 0                     NOT NULL,
  REVIEW_BOARD_CD           NUMBER              DEFAULT 0                     NOT NULL,
  HEARING_DT_TM             DATE,
  LOCATION_CD               NUMBER              DEFAULT 0                     NOT NULL,
  DECISION_CD               NUMBER              DEFAULT 0                     NOT NULL,
  RECOMMENDATION_CD         NUMBER              DEFAULT 0                     NOT NULL,
  LEGAL_RECOMMENDATION_CD   NUMBER              DEFAULT 0                     NOT NULL,
  OTHER_RECOMMENDATION_CD   NUMBER              DEFAULT 0                     NOT NULL,
  DISPOSITION_RECVD_DT_TM   DATE,
  REASON_RECVD_DT_TM        DATE,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_LEGAL_STATUS_R
(
  LEGAL_STATUS_R_ID          NUMBER             DEFAULT 0                     NOT NULL,
  LEGAL_STATUS_CD            NUMBER             DEFAULT 0                     NOT NULL,
  ENCNTR_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  START_DT_TM                DATE,
  END_DT_TM                  DATE,
  COURT_DT_TM                DATE,
  COURT_LOCATION_CD          NUMBER             DEFAULT 0                     NOT NULL,
  COURT_FILE_NUM             VARCHAR2(40 BYTE),
  REQ_EXTENSION_DT_TM        DATE,
  ADJOURNMENT_DT_TM          DATE,
  VERBAL_STAY_DT_TM          DATE,
  STAY_OF_PROCEEDINGS_DT_TM  DATE,
  WRITTEN_STAY_DT_TM         DATE,
  NEXT_REVIEW_DT_TM          DATE,
  PROBABLE_SENTENCE_DT_TM    DATE,
  SENTENCE_DT_TM             DATE,
  LEGAL_STAT_INACTIVE_IND    NUMBER,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID     NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  REFERRAL_DT_TM             DATE,
  REFERRAL_TYPE_CD           NUMBER             DEFAULT 0,
  REGION_CD                  NUMBER             DEFAULT 0,
  REFERRAL_FACILITY_CD       NUMBER             DEFAULT 0,
  REFERRAL_SOURCE_CD         NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_LEGAL_STAT_CRIM_R
(
  LEGAL_STATUS_CRIMINAL_R_ID  NUMBER            DEFAULT 0                     NOT NULL,
  LEGAL_STATUS_R_ID           NUMBER            DEFAULT 0                     NOT NULL,
  CRIMINAL_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  OFFENSE_DT_TM               DATE,
  OCCURRENCES_NBR             NUMBER,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_LEGAL_STAT_HIST
(
  LEGAL_STATUS_HIST_ID       NUMBER             DEFAULT 0                     NOT NULL,
  LEGAL_STATUS_R_ID          NUMBER             DEFAULT 0                     NOT NULL,
  START_DT_TM                DATE,
  END_DT_TM                  DATE,
  COURT_DT_TM                DATE,
  COURT_LOCATION_CD          NUMBER             DEFAULT 0                     NOT NULL,
  COURT_FILE_NUM             VARCHAR2(40 BYTE),
  REQ_EXTENSION_DT_TM        DATE,
  ADJOURNMENT_DT_TM          DATE,
  VERBAL_STAY_DT_TM          DATE,
  STAY_OF_PROCEEDINGS_DT_TM  DATE,
  WRITTEN_STAY_DT_TM         DATE,
  NEXT_REVIEW_DT_TM          DATE,
  PROBABLE_SENTENCE_DT_TM    DATE,
  SENTENCE_DT_TM             DATE,
  BEG_EFFECTIVE_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM        DATE               DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  REFERRAL_DT_TM             DATE,
  REFERRAL_TYPE_CD           NUMBER             DEFAULT 0,
  REGION_CD                  NUMBER             DEFAULT 0,
  REFERRAL_FACILITY_CD       NUMBER             DEFAULT 0,
  REFERRAL_SOURCE_CD         NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_LOC_HIST
(
  ENCNTR_LOC_HIST_ID        NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  LOCATION_CD               NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  LOCATION_STATUS_CD        NUMBER              DEFAULT 0                     NOT NULL,
  ARRIVE_DT_TM              DATE,
  ARRIVE_PRSNL_ID           NUMBER              DEFAULT 0                     NOT NULL,
  DEPART_DT_TM              DATE,
  DEPART_PRSNL_ID           NUMBER              DEFAULT 0                     NOT NULL,
  TRANSFER_REASON_CD        NUMBER              DEFAULT 0                     NOT NULL,
  LOCATION_TEMP_IND         NUMBER,
  CHART_COMMENT_IND         NUMBER,
  COMMENT_TEXT              VARCHAR2(200 BYTE),
  LOC_FACILITY_CD           NUMBER              DEFAULT 0                     NOT NULL,
  LOC_BUILDING_CD           NUMBER              DEFAULT 0                     NOT NULL,
  LOC_NURSE_UNIT_CD         NUMBER              DEFAULT 0                     NOT NULL,
  LOC_ROOM_CD               NUMBER              DEFAULT 0                     NOT NULL,
  LOC_BED_CD                NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CD            NUMBER              DEFAULT 0                     NOT NULL,
  MED_SERVICE_CD            NUMBER              DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM         DATE,
  ALT_LVL_CARE_CD           NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVITY_DT_TM            DATE,
  PROGRAM_SERVICE_CD        NUMBER              DEFAULT 0                     NOT NULL,
  SPECIALTY_UNIT_CD         NUMBER              DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID       NUMBER              DEFAULT 0                     NOT NULL,
  CHANGE_BIT                NUMBER              DEFAULT 0                     NOT NULL,
  TRACKING_BIT              NUMBER              DEFAULT 0                     NOT NULL,
  ACCOMMODATION_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACCOMMODATION_REASON_CD   NUMBER              DEFAULT 0                     NOT NULL,
  ACCOMMODATION_REQUEST_CD  NUMBER              DEFAULT 0                     NOT NULL,
  ADMIT_TYPE_CD             NUMBER              DEFAULT 0                     NOT NULL,
  ALC_DECOMP_DT_TM          DATE,
  ALT_LVL_CARE_DT_TM        DATE,
  ALC_REASON_CD             NUMBER              DEFAULT 0                     NOT NULL,
  ISOLATION_CD              NUMBER              DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID           NUMBER              DEFAULT 0                     NOT NULL,
  PLACEMENT_AUTH_PRSNL_ID   NUMBER              DEFAULT 0                     NOT NULL,
  SECURITY_ACCESS_CD        NUMBER              DEFAULT 0                     NOT NULL,
  SERVICE_CATEGORY_CD       NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CLASS_CD      NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_LR_RELTN
(
  ENCNTR_LR_RELTN_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  ENCNTR_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  LR_ID               NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_OCCURRENCE_CODE
(
  OCCURRENCE_CODE_ID      NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  OCCURRENCE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  OCCURRENCE_DT_TM        DATE,
  SEQUENCE                NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_OCCURRENCE_CODE_HIST
(
  OCCURRENCE_CODE_HIST_ID  NUMBER               DEFAULT 0                     NOT NULL,
  OCCURRENCE_CODE_ID       NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  OCCURRENCE_CD            NUMBER               DEFAULT 0                     NOT NULL,
  CHANGE_BIT               NUMBER               DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID      NUMBER               DEFAULT 0                     NOT NULL,
  OCCURRENCE_DT_TM         DATE,
  SEQUENCE                 NUMBER,
  ACTIVE_IND               NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  DATA_STATUS_CD           NUMBER               DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM        DATE,
  DATA_STATUS_PRSNL_ID     NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM        DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_ORG_RELTN
(
  ENCNTR_ORG_RELTN_ID       NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_ORG_RELTN_TYPE_CD  NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_ORG_RELTN_CD       NUMBER              DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID           NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DATA_STATUS_CD            NUMBER              DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM         DATE,
  DATA_STATUS_PRSNL_ID      NUMBER              DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD     NUMBER              DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ              NUMBER,
  INTERNAL_SEQ              NUMBER,
  ENCNTR_ORG_ALIAS          VARCHAR2(100 BYTE),
  ENCNTR_ORG_NBR            VARCHAR2(100 BYTE),
  FREE_TEXT_IND             NUMBER,
  FT_ORG_NAME               VARCHAR2(100 BYTE),
  RESEARCH_ACCOUNT_ID       NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_ORG_SERVICE_RELTN
(
  ENCNTR_ORG_SERVICE_RELTN_ID  NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID              NUMBER           DEFAULT 0                     NOT NULL,
  SERVICE_CD                   NUMBER           DEFAULT 0                     NOT NULL,
  COMMENT_LONG_TEXT_ID         NUMBER           DEFAULT 0                     NOT NULL,
  SERVICE_BEG_DT_TM            DATE,
  SERVICE_END_DT_TM            DATE,
  SERVICE_FREQUENCY            VARCHAR2(100 BYTE),
  AUTH_NUMBER                  VARCHAR2(100 BYTE),
  REFERRING_PRSNL_ID           NUMBER           DEFAULT 0                     NOT NULL,
  PAYER_ORG_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  FINAL_SELECTION_IND          NUMBER           DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  RESPONSE_REASON_CD           NUMBER           DEFAULT 0                     NOT NULL,
  RESPONSE_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  PATIENT_REASON_CD            NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_PENDING
(
  ENCNTR_PENDING_ID        NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ACCOMMODATION_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACCOMMODATION_REASON_CD  NUMBER               DEFAULT 0                     NOT NULL,
  ALT_LVL_CARE_CD          NUMBER               DEFAULT 0                     NOT NULL,
  DISCH_DISPOSITION_CD     NUMBER               DEFAULT 0                     NOT NULL,
  DISCH_TO_LOCTN_CD        NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  EST_COMPLETE_DT_TM       DATE,
  ISOLATION_CD             NUMBER               DEFAULT 0                     NOT NULL,
  PEND_FACILITY_CD         NUMBER               DEFAULT 0                     NOT NULL,
  PEND_BUILDING_CD         NUMBER               DEFAULT 0                     NOT NULL,
  PEND_NURSE_UNIT_CD       NUMBER               DEFAULT 0                     NOT NULL,
  PEND_ROOM_CD             NUMBER               DEFAULT 0                     NOT NULL,
  PEND_BED_CD              NUMBER               DEFAULT 0                     NOT NULL,
  MED_SERVICE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  PENDING_DT_TM            DATE,
  PENDING_PRIORITY_CD      NUMBER               DEFAULT 0                     NOT NULL,
  PENDING_STATUS_CD        NUMBER               DEFAULT 0                     NOT NULL,
  PENDING_PRSNL_ID         NUMBER               DEFAULT 0                     NOT NULL,
  PROCESS_STATUS_FLAG      NUMBER               DEFAULT 0                     NOT NULL,
  PENDING_TYPE_FLAG        NUMBER               DEFAULT 0                     NOT NULL,
  SERVICE_CATEGORY_CD      NUMBER               DEFAULT 0                     NOT NULL,
  TRANSACTION_REASON_CD    NUMBER               DEFAULT 0                     NOT NULL,
  TRANSACTION_REASON       VARCHAR2(200 BYTE),
  ACTIVE_IND               NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE                 DEFAULT SYSDATE               NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  PREV_EST_DEPART_DT_TM    DATE,
  PROGRAM_SERVICE_CD       NUMBER               DEFAULT 0                     NOT NULL,
  SPECIALTY_UNIT_CD        NUMBER               DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ             NUMBER,
  ALT_LVL_CARE_DT_TM       DATE,
  ALC_DECOMP_DT_TM         DATE,
  ALC_REASON_CD            NUMBER               DEFAULT 0                     NOT NULL,
  PROCESS_STATUS_DT_TM     DATE,
  ATTENDDOC_ID             NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_PENDING_HIST
(
  ENCNTR_PENDING_HIST_ID   NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ACCOMMODATION_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACCOMMODATION_REASON_CD  NUMBER               DEFAULT 0                     NOT NULL,
  ALT_LVL_CARE_CD          NUMBER               DEFAULT 0                     NOT NULL,
  DISCH_DISPOSITION_CD     NUMBER               DEFAULT 0                     NOT NULL,
  DISCH_TO_LOCTN_CD        NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  EST_COMPLETE_DT_TM       DATE,
  ISOLATION_CD             NUMBER               DEFAULT 0                     NOT NULL,
  PEND_FACILITY_CD         NUMBER               DEFAULT 0                     NOT NULL,
  PEND_BUILDING_CD         NUMBER               DEFAULT 0                     NOT NULL,
  PEND_NURSE_UNIT_CD       NUMBER               DEFAULT 0                     NOT NULL,
  PEND_ROOM_CD             NUMBER               DEFAULT 0                     NOT NULL,
  PEND_BED_CD              NUMBER               DEFAULT 0                     NOT NULL,
  MED_SERVICE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  PENDING_DT_TM            DATE,
  PENDING_PRIORITY_CD      NUMBER               DEFAULT 0                     NOT NULL,
  PENDING_STATUS_CD        NUMBER               DEFAULT 0                     NOT NULL,
  PENDING_PRSNL_ID         NUMBER               DEFAULT 0                     NOT NULL,
  PROCESS_STATUS_FLAG      NUMBER               DEFAULT 0                     NOT NULL,
  PENDING_TYPE_FLAG        NUMBER               DEFAULT 0                     NOT NULL,
  SERVICE_CATEGORY_CD      NUMBER               DEFAULT 0                     NOT NULL,
  TRANSACTION_REASON_CD    NUMBER               DEFAULT 0                     NOT NULL,
  TRANSACTION_REASON       VARCHAR2(100 BYTE),
  ACTIVE_IND               NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE                 DEFAULT SYSDATE               NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  PREV_EST_DEPART_DT_TM    DATE,
  SPECIALTY_UNIT_CD        NUMBER               DEFAULT 0                     NOT NULL,
  PROGRAM_SERVICE_CD       NUMBER               DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ             NUMBER,
  ALT_LVL_CARE_DT_TM       DATE,
  ALC_DECOMP_DT_TM         DATE,
  ALC_REASON_CD            NUMBER               DEFAULT 0                     NOT NULL,
  PROCESS_STATUS_DT_TM     DATE,
  ATTENDDOC_ID             NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_PERSON_RELTN
(
  ENCNTR_PERSON_RELTN_ID    NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_RELTN_TYPE_CD      NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_RELTN_CD           NUMBER              DEFAULT 0                     NOT NULL,
  RELATED_PERSON_RELTN_CD   NUMBER              DEFAULT 0                     NOT NULL,
  RELATED_PERSON_ID         NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DATA_STATUS_CD            NUMBER              DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM         DATE,
  DATA_STATUS_PRSNL_ID      NUMBER              DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD     NUMBER              DEFAULT 0                     NOT NULL,
  CONTACT_ROLE_CD           NUMBER              DEFAULT 0                     NOT NULL,
  GENETIC_RELATIONSHIP_IND  NUMBER,
  LIVING_WITH_IND           NUMBER,
  VISITATION_ALLOWED_CD     NUMBER              DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ              NUMBER,
  FREE_TEXT_CD              NUMBER              DEFAULT 0                     NOT NULL,
  FT_REL_PERSON_NAME        VARCHAR2(100 BYTE),
  INTERNAL_SEQ              NUMBER,
  DEFAULT_RELTN_IND         NUMBER              DEFAULT 0,
  FAMILY_RELTN_SUB_TYPE_CD  NUMBER              DEFAULT 0,
  SOURCE_IDENTIFIER         VARCHAR2(255 BYTE),
  COPY_CORRESPONDENCE_CD    NUMBER              DEFAULT 0,
  RELATION_SEQ              NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_PERSON_RELTN_HIST
(
  ENCNTR_PERSON_RELTN_HIST_ID  NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_PERSON_RELTN_ID       NUMBER           DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM            DATE,
  COPY_CORRESPONDENCE_CD       NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  PERSON_RELTN_TYPE_CD         NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  PERSON_RELTN_CD              NUMBER           DEFAULT 0                     NOT NULL,
  RELATED_PERSON_RELTN_CD      NUMBER           DEFAULT 0                     NOT NULL,
  RELATED_PERSON_ID            NUMBER           DEFAULT 0                     NOT NULL,
  CHANGE_BIT                   NUMBER           DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID          NUMBER           DEFAULT 0                     NOT NULL,
  TRACKING_BIT                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DATA_STATUS_CD               NUMBER           DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM            DATE,
  DATA_STATUS_PRSNL_ID         NUMBER           DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD        NUMBER           DEFAULT 0                     NOT NULL,
  CONTACT_ROLE_CD              NUMBER           DEFAULT 0                     NOT NULL,
  GENETIC_RELATIONSHIP_IND     NUMBER,
  LIVING_WITH_IND              NUMBER,
  VISITATION_ALLOWED_CD        NUMBER           DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ                 NUMBER,
  FREE_TEXT_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  FT_REL_PERSON_NAME           VARCHAR2(100 BYTE),
  INTERNAL_SEQ                 NUMBER,
  FAMILY_RELTN_SUB_TYPE_CD     NUMBER           DEFAULT 0                     NOT NULL,
  DEFAULT_RELTN_IND            NUMBER           DEFAULT 0,
  SOURCE_IDENTIFIER            VARCHAR2(255 BYTE),
  RELATION_SEQ                 NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_PLAN_AUTH_R
(
  ENCNTR_PLAN_AUTH_R_ID   NUMBER                DEFAULT 0                     NOT NULL,
  AUTHORIZATION_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_PLAN_RELTN_ID    NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_PLAN_ELIGIBILITY
(
  ENCNTR_PLAN_ELIGIBILITY_ID  NUMBER            DEFAULT 0                     NOT NULL,
  ELIGIBILITY_STATUS_CD       NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_PLAN_RELTN_ID        NUMBER            DEFAULT 0                     NOT NULL,
  SERVICE_TYPE_CD             NUMBER            DEFAULT 0                     NOT NULL,
  COVERAGE_LEVEL_CD           NUMBER            DEFAULT 0                     NOT NULL,
  INSURANCE_TYPE_CD           NUMBER            DEFAULT 0                     NOT NULL,
  IN_PLAN_NETWORK_CD          NUMBER            DEFAULT 0                     NOT NULL,
  AUTH_REQUIRED_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE              DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  PAYER_PROV_PLAN_NAME        VARCHAR2(100 BYTE),
  PROC_NOMEN_ID               NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_PLAN_ELIG_BENEFIT
(
  ENCNTR_PLAN_ELIG_BENEFIT_ID    NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_PLAN_ELIGIBILITY_ID     NUMBER         DEFAULT 0                     NOT NULL,
  BENEFIT_TYPE_CD                NUMBER         DEFAULT 0                     NOT NULL,
  BENEFIT_MONETARY_AMT           FLOAT(126),
  BENEFIT_PCT                    FLOAT(126),
  BENEFIT_TIME_PERIOD_QUAL_CD    NUMBER         DEFAULT 0                     NOT NULL,
  BENEFIT_QTY                    FLOAT(126),
  BENEFIT_QTY_QUAL_CD            NUMBER         DEFAULT 0                     NOT NULL,
  BENEFIT_COMMENTS_LONG_TEXT_ID  NUMBER         DEFAULT 0                     NOT NULL,
  SELECTED_IND                   NUMBER         DEFAULT 0                     NOT NULL,
  INFO_SOURCE_CD                 NUMBER         DEFAULT 0                     NOT NULL,
  TRANSACTION_SOURCE_IDENT       VARCHAR2(50 BYTE),
  ACTIVE_IND                     NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM            DATE           DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID         NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD               NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_PLAN_RELTN
(
  ENCNTR_PLAN_RELTN_ID            NUMBER        DEFAULT 0                     NOT NULL,
  ENCNTR_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  PERSON_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  PERSON_PLAN_RELTN_ID            NUMBER        DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID                  NUMBER        DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  PERSON_ORG_RELTN_ID             NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  ACTIVE_IND                      NUMBER,
  ACTIVE_STATUS_CD                NUMBER        DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM             DATE,
  ACTIVE_STATUS_PRSNL_ID          NUMBER        DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM             DATE          DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM             DATE          DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DATA_STATUS_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM               DATE,
  DATA_STATUS_PRSNL_ID            NUMBER        DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD           NUMBER        DEFAULT 0                     NOT NULL,
  SUBSCRIBER_TYPE_CD              NUMBER        DEFAULT 0                     NOT NULL,
  ORIG_PRIORITY_SEQ               NUMBER,
  PRIORITY_SEQ                    NUMBER,
  MEMBER_NBR                      VARCHAR2(100 BYTE),
  SUBS_MEMBER_NBR                 VARCHAR2(100 BYTE),
  INSUR_SOURCE_INFO_CD            NUMBER        DEFAULT 0                     NOT NULL,
  BALANCE_TYPE_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  DEDUCT_AMT                      FLOAT(126),
  DEDUCT_MET_AMT                  FLOAT(126),
  DEDUCT_MET_DT_TM                DATE,
  ASSIGN_BENEFITS_CD              NUMBER        DEFAULT 0                     NOT NULL,
  COORD_BENEFITS_CD               NUMBER        DEFAULT 0                     NOT NULL,
  PLAN_TYPE_CD                    NUMBER        DEFAULT 0                     NOT NULL,
  PLAN_CLASS_CD                   NUMBER        DEFAULT 0                     NOT NULL,
  HEALTH_CARD_PROVINCE            CHAR(3 BYTE),
  HEALTH_CARD_VER_CODE            CHAR(3 BYTE),
  HEALTH_CARD_NBR                 CHAR(100 BYTE),
  INSURED_CARD_NAME               VARCHAR2(100 BYTE),
  GROUP_NAME                      VARCHAR2(200 BYTE),
  GROUP_NBR                       VARCHAR2(100 BYTE),
  POLICY_NBR                      VARCHAR2(100 BYTE),
  SPONSOR_PERSON_ORG_RELTN_ID     NUMBER        DEFAULT 0                     NOT NULL,
  MILITARY_RANK_CD                NUMBER        DEFAULT 0                     NOT NULL,
  MILITARY_STATUS_CD              NUMBER        DEFAULT 0                     NOT NULL,
  MILITARY_SERVICE_CD             NUMBER        DEFAULT 0                     NOT NULL,
  MILITARY_BASE_LOCATION          VARCHAR2(100 BYTE),
  HEALTH_CARD_TYPE                VARCHAR2(32 BYTE),
  HEALTH_CARD_ISSUE_DT_TM         DATE,
  HEALTH_CARD_EXPIRY_DT_TM        DATE,
  MEMBER_PERSON_CODE              VARCHAR2(100 BYTE),
  INS_CARD_COPIED_CD              NUMBER        DEFAULT 0                     NOT NULL,
  LIFE_RSV_DAYS                   NUMBER        DEFAULT 0                     NOT NULL,
  LIFE_RSV_REMAIN_DAYS            NUMBER        DEFAULT 0                     NOT NULL,
  LIFE_RSV_DAILY_DED_AMT          FLOAT(126)    DEFAULT 0                     NOT NULL,
  LIFE_RSV_DAILY_DED_QUAL_CD      NUMBER        DEFAULT 0                     NOT NULL,
  CARD_ISSUE_NBR                  NUMBER        DEFAULT 0                     NOT NULL,
  CARD_CATEGORY_CD                NUMBER        DEFAULT 0                     NOT NULL,
  PROGRAM_STATUS_CD               NUMBER        DEFAULT 0                     NOT NULL,
  VERIFY_PRSNL_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  VERIFY_DT_TM                    DATE,
  VERIFY_STATUS_CD                NUMBER        DEFAULT 0                     NOT NULL,
  DENIAL_REASON_CD                NUMBER        DEFAULT 0                     NOT NULL,
  COVERAGE_COMMENTS_LONG_TEXT_ID  NUMBER        DEFAULT 0                     NOT NULL,
  SIGNATURE_ON_FILE_CD            NUMBER        DEFAULT 0,
  PRICING_AGENCY_CD               NUMBER        DEFAULT 0,
  RX_PLAN_COB_SEQ                 NUMBER        DEFAULT 0,
  ACCEPT_ASSIGNMENT_CD            NUMBER        DEFAULT 0,
  SIGNATURE_SOURCE_CD             NUMBER        DEFAULT 0,
  SIGNATURE_DT_TM                 DATE,
  INSURED_CARD_NAME_LAST          VARCHAR2(100 BYTE),
  INSURED_CARD_NAME_MIDDLE        VARCHAR2(100 BYTE),
  INSURED_CARD_NAME_FIRST         VARCHAR2(100 BYTE),
  INSURED_CARD_NAME_SUFFIX        VARCHAR2(100 BYTE),
  PROP_CASUALTY_CLAIM_NBR_TXT     VARCHAR2(100 BYTE),
  VERIFY_SOURCE_CD                NUMBER        DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_PLAN_RELTN_HIST
(
  ENCNTR_PLAN_RELTN_HIST_ID       NUMBER        DEFAULT 0                     NOT NULL,
  ENCNTR_PLAN_RELTN_ID            NUMBER        DEFAULT 0                     NOT NULL,
  ENCNTR_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  PERSON_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  PERSON_PLAN_RELTN_ID            NUMBER        DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID                  NUMBER        DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  PERSON_ORG_RELTN_ID             NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  ACTIVE_IND                      NUMBER,
  ACTIVE_STATUS_CD                NUMBER        DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID          NUMBER        DEFAULT 0                     NOT NULL,
  DATA_STATUS_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  DATA_STATUS_PRSNL_ID            NUMBER        DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD           NUMBER        DEFAULT 0                     NOT NULL,
  SUBSCRIBER_TYPE_CD              NUMBER        DEFAULT 0                     NOT NULL,
  ORIG_PRIORITY_SEQ               NUMBER,
  PRIORITY_SEQ                    NUMBER,
  MEMBER_NBR                      VARCHAR2(100 BYTE),
  SUBS_MEMBER_NBR                 VARCHAR2(100 BYTE),
  INSUR_SOURCE_INFO_CD            NUMBER        DEFAULT 0                     NOT NULL,
  BALANCE_TYPE_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  ASSIGN_BENEFITS_CD              NUMBER        DEFAULT 0                     NOT NULL,
  COORD_BENEFITS_CD               NUMBER        DEFAULT 0                     NOT NULL,
  PLAN_TYPE_CD                    NUMBER        DEFAULT 0                     NOT NULL,
  PLAN_CLASS_CD                   NUMBER        DEFAULT 0                     NOT NULL,
  HEALTH_CARD_PROVINCE            CHAR(3 BYTE),
  HEALTH_CARD_VER_CODE            CHAR(3 BYTE),
  HEALTH_CARD_NBR                 CHAR(100 BYTE),
  INSURED_CARD_NAME               VARCHAR2(100 BYTE),
  GROUP_NAME                      VARCHAR2(200 BYTE),
  GROUP_NBR                       VARCHAR2(100 BYTE),
  POLICY_NBR                      VARCHAR2(100 BYTE),
  SPONSOR_PERSON_ORG_RELTN_ID     NUMBER        DEFAULT 0                     NOT NULL,
  MILITARY_RANK_CD                NUMBER        DEFAULT 0                     NOT NULL,
  MILITARY_STATUS_CD              NUMBER        DEFAULT 0                     NOT NULL,
  MILITARY_SERVICE_CD             NUMBER        DEFAULT 0                     NOT NULL,
  MILITARY_BASE_LOCATION          VARCHAR2(100 BYTE),
  HEALTH_CARD_TYPE                VARCHAR2(32 BYTE),
  MEMBER_PERSON_CODE              VARCHAR2(100 BYTE),
  LIFE_RSV_DAYS                   NUMBER        DEFAULT 0                     NOT NULL,
  LIFE_RSV_REMAIN_DAYS            NUMBER        DEFAULT 0                     NOT NULL,
  LIFE_RSV_DAILY_DED_AMT          FLOAT(126)    DEFAULT 0                     NOT NULL,
  LIFE_RSV_DAILY_DED_QUAL_CD      NUMBER        DEFAULT 0                     NOT NULL,
  CARD_ISSUE_NBR                  NUMBER        DEFAULT 0                     NOT NULL,
  CARD_CATEGORY_CD                NUMBER        DEFAULT 0                     NOT NULL,
  PROGRAM_STATUS_CD               NUMBER        DEFAULT 0                     NOT NULL,
  VERIFY_PRSNL_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  VERIFY_STATUS_CD                NUMBER        DEFAULT 0                     NOT NULL,
  DENIAL_REASON_CD                NUMBER        DEFAULT 0                     NOT NULL,
  COVERAGE_COMMENTS_LONG_TEXT_ID  NUMBER        DEFAULT 0                     NOT NULL,
  SIGNATURE_ON_FILE_CD            NUMBER        DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM               DATE,
  END_EFFECTIVE_DT_TM             DATE          DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  HEALTH_CARD_EXPIRY_DT_TM        DATE,
  VERIFY_DT_TM                    DATE,
  HEALTH_CARD_ISSUE_DT_TM         DATE,
  ACTIVE_STATUS_DT_TM             DATE,
  BEG_EFFECTIVE_DT_TM             DATE          DEFAULT SYSDATE               NOT NULL,
  PRICING_AGENCY_CD               NUMBER        DEFAULT 0                     NOT NULL,
  RX_PLAN_COB_SEQ                 NUMBER        DEFAULT 0                     NOT NULL,
  SIGNATURE_SOURCE_CD             NUMBER        DEFAULT 0                     NOT NULL,
  SIGNATURE_DT_TM                 DATE,
  INSURED_CARD_NAME_FIRST         VARCHAR2(100 BYTE),
  INSURED_CARD_NAME_MIDDLE        VARCHAR2(100 BYTE),
  INSURED_CARD_NAME_LAST          VARCHAR2(100 BYTE),
  INSURED_CARD_NAME_SUFFIX        VARCHAR2(100 BYTE),
  INS_CARD_COPIED_CD              NUMBER        DEFAULT 0                     NOT NULL,
  DEDUCT_AMT                      FLOAT(126),
  DEDUCT_MET_AMT                  FLOAT(126),
  ACCEPT_ASSIGNMENT_CD            NUMBER        DEFAULT 0                     NOT NULL,
  DEDUCT_MET_DT_TM                DATE,
  CHANGE_BIT                      NUMBER        DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID             NUMBER        DEFAULT 0                     NOT NULL,
  TRACKING_BIT                    NUMBER        DEFAULT 0                     NOT NULL,
  PROP_CASUALTY_CLAIM_NBR_TXT     VARCHAR2(100 BYTE),
  TRANSACTION_DT_TM               DATE,
  VERIFY_SOURCE_CD                NUMBER        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_POSTACUTE_ORG_RELTN
(
  ENCNTR_POSTACUTE_ORG_RELTN_ID  NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID                NUMBER         DEFAULT 0                     NOT NULL,
  RESPONSE_CD                    NUMBER         DEFAULT 0                     NOT NULL,
  FINAL_PLACEMENT_IND            NUMBER         DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ                   NUMBER         DEFAULT 0                     NOT NULL,
  COMMENT_LONG_TEXT_ID           NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVE_IND                     NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM            DATE           DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID         NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD               NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  RESPONSE_REASON_CD             NUMBER         DEFAULT 0                     NOT NULL,
  PATIENT_REASON_CD              NUMBER         DEFAULT 0                     NOT NULL,
  SELECTED_ORG_TYPE_CD           NUMBER         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_PROCEDURE
(
  ENCNTR_PROCEDURE_ID           NUMBER          DEFAULT 0                     NOT NULL,
  CATALOG_CD                    NUMBER          DEFAULT 0                     NOT NULL,
  SYNONYM_ID                    NUMBER          DEFAULT 0                     NOT NULL,
  ENCNTR_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  SCHED_PRIMARY_IND             NUMBER          DEFAULT 0,
  SCHED_DUR                     NUMBER          DEFAULT 0,
  CONCURRENT_IND                NUMBER          DEFAULT 0,
  SCHED_XRAY_IND                NUMBER          DEFAULT 0,
  SCHED_XRAY_TECH_IND           NUMBER          DEFAULT 0,
  SCHED_SURGICAL_ORDER_COMMENT  VARCHAR2(255 BYTE),
  SCHED_SURGICAL_MOD1_CD        NUMBER          DEFAULT 0,
  SCHED_SURGICAL_MOD2_CD        NUMBER          DEFAULT 0,
  SCHED_SURGICAL_MOD3_CD        NUMBER          DEFAULT 0,
  NCEPOD_CD                     NUMBER          DEFAULT 0,
  PROC_TEXT                     VARCHAR2(255 BYTE),
  PROC_START_DT_TM              DATE,
  SCHED_PRIMARY_SURGEON_ID      NUMBER          DEFAULT 0                     NOT NULL,
  SCHED_ANESTH_TYPE_CD          NUMBER          DEFAULT 0,
  SCHED_PRIORITY_CD             NUMBER          DEFAULT 0,
  SCHED_SURGE_AREA_CD           NUMBER          DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_PRSNL_GRP_RELTN
(
  ENCNTR_PRSNL_GRP_RELTN_ID  NUMBER             DEFAULT 0                     NOT NULL,
  ENCNTR_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  PRSNL_GROUP_ID             NUMBER             DEFAULT 0                     NOT NULL,
  RELTN_TYPE_CD              NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND                 NUMBER,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM        DATE,
  END_EFFECTIVE_DT_TM        DATE,
  BEG_EFFECTIVE_DT_TM        DATE,
  DATA_STATUS_CD             NUMBER             DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM          DATE,
  DATA_STATUS_PRSNL_ID       NUMBER             DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD      NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_PRSNL_RELTN
(
  ENCNTR_PRSNL_RELTN_ID   NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_PERSON_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_PRSNL_R_CD       NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  FREE_TEXT_CD            NUMBER                DEFAULT 0                     NOT NULL,
  FT_PRSNL_NAME           VARCHAR2(100 BYTE),
  MANUAL_CREATE_IND       NUMBER,
  MANUAL_CREATE_BY_ID     NUMBER                DEFAULT 0                     NOT NULL,
  MANUAL_CREATE_DT_TM     DATE,
  MANUAL_INACT_IND        NUMBER,
  MANUAL_INACT_BY_ID      NUMBER                DEFAULT 0                     NOT NULL,
  MANUAL_INACT_DT_TM      DATE,
  PRIORITY_SEQ            NUMBER,
  INTERNAL_SEQ            NUMBER,
  EXPIRATION_IND          NUMBER                DEFAULT 0,
  NOTIFICATION_CD         NUMBER                DEFAULT 0                     NOT NULL,
  EXPIRE_DT_TM            DATE,
  TRANSACTION_DT_TM       DATE,
  ACTIVITY_DT_TM          DATE,
  ENCNTR_TYPE_CD          NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_PRSNL_RELTN_HISTORY
(
  ENCNTR_PRSNL_RELTN_HISTORY_ID  NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_PRSNL_RELTN_ID          NUMBER         DEFAULT 0                     NOT NULL,
  PRSNL_PERSON_ID                NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_PRSNL_R_CD              NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVE_IND                     NUMBER         DEFAULT 0,
  BEG_EFFECTIVE_DT_TM            DATE           DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM            DATE           DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_CD               NUMBER         DEFAULT 0,
  ACTIVE_STATUS_PRSNL_ID         NUMBER         DEFAULT 0,
  DATA_STATUS_CD                 NUMBER         DEFAULT 0,
  DATA_STATUS_PRSNL_ID           NUMBER         DEFAULT 0,
  CONTRIBUTOR_SYSTEM_CD          NUMBER         DEFAULT 0,
  FREE_TEXT_CD                   NUMBER         DEFAULT 0,
  FT_PRSNL_NAME                  VARCHAR2(100 BYTE),
  MANUAL_CREATE_IND              NUMBER,
  MANUAL_CREATE_BY_ID            NUMBER         DEFAULT 0,
  MANUAL_INACT_IND               NUMBER,
  INTERNAL_SEQ                   NUMBER,
  EXPIRATION_IND                 NUMBER         DEFAULT 0,
  NOTIFICATION_CD                NUMBER         DEFAULT 0,
  MANUAL_INACT_BY_ID             NUMBER         DEFAULT 0,
  PRIORITY_SEQ                   NUMBER,
  ACTIVE_STATUS_DT_TM            DATE,
  ACTIVITY_DT_TM                 DATE,
  DATA_STATUS_DT_TM              DATE,
  EXPIRE_DT_TM                   DATE,
  MANUAL_CREATE_DT_TM            DATE,
  ENCNTR_TYPE_CD                 NUMBER         DEFAULT 0,
  CHANGE_BIT                     NUMBER         DEFAULT 0,
  MANUAL_INACT_DT_TM             DATE,
  TRANSACTION_DT_TM              DATE,
  PM_HIST_TRACKING_ID            NUMBER         DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_READMIT_ASSESS
(
  ENCNTR_READMIT_ASSESS_ID   NUMBER             DEFAULT 0                     NOT NULL,
  ENCNTR_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  CLASSIFICATION_CD          NUMBER             DEFAULT 0                     NOT NULL,
  READMISSION_REASON_CD      NUMBER             DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID            NUMBER             DEFAULT 0                     NOT NULL,
  COMMENT_ID                 NUMBER             DEFAULT 0                     NOT NULL,
  AVOIDABLE_READMISSION_IND  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  PREVIOUS_ENCNTR_ID         NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_REIMBURSEMENT
(
  ENCNTR_REIMBURSEMENT_ID  NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_FINANCIAL_ID      NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  AMOUNT                   NUMBER,
  HEALTH_PLAN_ID           NUMBER               DEFAULT 0                     NOT NULL,
  POSTING_DT               DATE,
  REIMBURSEMENT_TYPE_CD    NUMBER               DEFAULT 0                     NOT NULL,
  DATA_STATUS_CD           NUMBER               DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM        DATE,
  DATA_STATUS_PRSNL_ID     NUMBER               DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD    NUMBER               DEFAULT 0                     NOT NULL,
  REFERENCE_NBR            VARCHAR2(40 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_SLICE
(
  ENCNTR_SLICE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_TYPE_CD    NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_FLAG       NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_SLICE_ACT
(
  ENCNTR_SLICE_ACT_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME   VARCHAR2(30 BYTE)        DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  COLUMN_CD            NUMBER                   DEFAULT 0                     NOT NULL,
  COLUMN_VALUE_CD      NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_SLICE_ACT_HIST
(
  ENCNTR_SLICE_ACT_HIST_ID  NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_ACT_ID       NUMBER              DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME        VARCHAR2(30 BYTE)   DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID          NUMBER              DEFAULT 0                     NOT NULL,
  COLUMN_CD                 NUMBER              DEFAULT 0                     NOT NULL,
  COLUMN_VALUE_CD           NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_SLICE_HIST
(
  ENCNTR_SLICE_HIST_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  ACTIVE_IND            NUMBER                  DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM   DATE                    DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM   DATE                    DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  PM_HIST_TRACKING_ID   NUMBER                  DEFAULT 0,
  HIST_ACTION           VARCHAR2(3 BYTE)        DEFAULT ' '
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_SLICE_REFERENCE
(
  ENCNTR_SLICE_REF_ID       NUMBER              DEFAULT 0                     NOT NULL,
  SCH_FLEX_ID               NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_TYPE_CD      NUMBER              DEFAULT 0                     NOT NULL,
  ACP_IND                   NUMBER              DEFAULT 0                     NOT NULL,
  CODING_IND                NUMBER              DEFAULT 0                     NOT NULL,
  COMMISSIONING_IND         NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ACTIVE_IND                NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  START_ENCNTR_COLUMN_NAME  VARCHAR2(30 BYTE)   DEFAULT ' '                   NOT NULL,
  END_ENCNTR_COLUMN_NAME    VARCHAR2(30 BYTE)   DEFAULT ' '                   NOT NULL,
  DATE_RANGE_LOCK_IND       NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_SPAN_CODE
(
  SPAN_CODE_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  SPAN_CD                 NUMBER                DEFAULT 0                     NOT NULL,
  SPAN_FROM_DT_TM         DATE,
  SPAN_TO_DT_TM           DATE,
  SEQUENCE                NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCNTR_VALUE_CODE
(
  VALUE_CODE_ID           NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_CD                NUMBER                DEFAULT 0                     NOT NULL,
  AMOUNT                  FLOAT(126),
  SEQUENCE                NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENCOUNTER
(
  ENCNTR_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  PERSON_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  CREATE_DT_TM                 DATE,
  CREATE_PRSNL_ID              NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ENCNTR_CLASS_CD              NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CD               NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CLASS_CD         NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  PRE_REG_DT_TM                DATE,
  PRE_REG_PRSNL_ID             NUMBER           DEFAULT 0                     NOT NULL,
  REG_DT_TM                    DATE,
  REG_PRSNL_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  EST_ARRIVE_DT_TM             DATE,
  EST_DEPART_DT_TM             DATE,
  ARRIVE_DT_TM                 DATE,
  DEPART_DT_TM                 DATE,
  ADMIT_TYPE_CD                NUMBER           DEFAULT 0                     NOT NULL,
  ADMIT_SRC_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  ADMIT_MODE_CD                NUMBER           DEFAULT 0                     NOT NULL,
  ADMIT_WITH_MEDICATION_CD     NUMBER           DEFAULT 0                     NOT NULL,
  REFERRING_COMMENT            VARCHAR2(100 BYTE),
  DISCH_DISPOSITION_CD         NUMBER           DEFAULT 0                     NOT NULL,
  DISCH_TO_LOCTN_CD            NUMBER           DEFAULT 0                     NOT NULL,
  PREADMIT_NBR                 VARCHAR2(100 BYTE),
  PREADMIT_TESTING_CD          NUMBER           DEFAULT 0                     NOT NULL,
  READMIT_CD                   NUMBER           DEFAULT 0                     NOT NULL,
  ACCOMMODATION_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACCOMMODATION_REQUEST_CD     NUMBER           DEFAULT 0                     NOT NULL,
  ALT_RESULT_DEST_CD           NUMBER           DEFAULT 0                     NOT NULL,
  AMBULATORY_COND_CD           NUMBER           DEFAULT 0                     NOT NULL,
  COURTESY_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  DIET_TYPE_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  ISOLATION_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  MED_SERVICE_CD               NUMBER           DEFAULT 0                     NOT NULL,
  RESULT_DEST_CD               NUMBER           DEFAULT 0                     NOT NULL,
  CONFID_LEVEL_CD              NUMBER           DEFAULT 0                     NOT NULL,
  VIP_CD                       NUMBER           DEFAULT 0                     NOT NULL,
  NAME_LAST_KEY                VARCHAR2(200 BYTE),
  NAME_FIRST_KEY               VARCHAR2(200 BYTE),
  NAME_FULL_FORMATTED          VARCHAR2(200 BYTE),
  NAME_LAST                    VARCHAR2(200 BYTE),
  NAME_FIRST                   VARCHAR2(200 BYTE),
  NAME_PHONETIC                VARCHAR2(200 BYTE),
  SEX_CD                       NUMBER           DEFAULT 0                     NOT NULL,
  BIRTH_DT_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  BIRTH_DT_TM                  DATE,
  SPECIES_CD                   NUMBER           DEFAULT 0                     NOT NULL,
  DATA_STATUS_CD               NUMBER           DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM            DATE,
  DATA_STATUS_PRSNL_ID         NUMBER           DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD        NUMBER           DEFAULT 0                     NOT NULL,
  LOCATION_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  LOC_FACILITY_CD              NUMBER           DEFAULT 0                     NOT NULL,
  LOC_BUILDING_CD              NUMBER           DEFAULT 0                     NOT NULL,
  LOC_NURSE_UNIT_CD            NUMBER           DEFAULT 0                     NOT NULL,
  LOC_ROOM_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  LOC_BED_CD                   NUMBER           DEFAULT 0                     NOT NULL,
  DISCH_DT_TM                  DATE,
  GUARANTOR_TYPE_CD            NUMBER           DEFAULT 0                     NOT NULL,
  LOC_TEMP_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID              NUMBER           DEFAULT 0                     NOT NULL,
  REASON_FOR_VISIT             VARCHAR2(255 BYTE),
  ENCNTR_FINANCIAL_ID          NUMBER           DEFAULT 0                     NOT NULL,
  NAME_FIRST_SYNONYM_ID        NUMBER           DEFAULT 0                     NOT NULL,
  FINANCIAL_CLASS_CD           NUMBER           DEFAULT 0                     NOT NULL,
  BBD_PROCEDURE_CD             NUMBER           DEFAULT 0                     NOT NULL,
  INFO_GIVEN_BY                CHAR(100 BYTE),
  SAFEKEEPING_CD               NUMBER           DEFAULT 0                     NOT NULL,
  TRAUMA_CD                    NUMBER           DEFAULT 0                     NOT NULL,
  TRIAGE_CD                    NUMBER           DEFAULT 0                     NOT NULL,
  TRIAGE_DT_TM                 DATE,
  VISITOR_STATUS_CD            NUMBER           DEFAULT 0                     NOT NULL,
  VALUABLES_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  SECURITY_ACCESS_CD           NUMBER           DEFAULT 0                     NOT NULL,
  REFER_FACILITY_CD            NUMBER           DEFAULT 0                     NOT NULL,
  TRAUMA_DT_TM                 DATE,
  ACCOMP_BY_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  ACCOMMODATION_REASON_CD      NUMBER           DEFAULT 0                     NOT NULL,
  ZERO_BALANCE_DT_TM           DATE,
  ARCHIVE_DT_TM_ACT            DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ARCHIVE_DT_TM_EST            DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  CHART_COMPLETE_DT_TM         DATE,
  CONTRACT_STATUS_CD           NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_COMPLETE_DT_TM        DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  EST_LENGTH_OF_STAY           NUMBER,
  PARENT_RET_CRITERIA_ID       NUMBER           DEFAULT 0                     NOT NULL,
  PA_CURRENT_STATUS_CD         NUMBER           DEFAULT 0                     NOT NULL,
  PA_CURRENT_STATUS_DT_TM      DATE,
  PURGE_DT_TM_ACT              DATE,
  PURGE_DT_TM_EST              DATE,
  SERVICE_CATEGORY_CD          NUMBER           DEFAULT 0                     NOT NULL,
  ALT_LVL_CARE_CD              NUMBER           DEFAULT 0                     NOT NULL,
  ASSIGN_TO_LOC_DT_TM          DATE,
  PROGRAM_SERVICE_CD           NUMBER           DEFAULT 0                     NOT NULL,
  SPECIALTY_UNIT_CD            NUMBER           DEFAULT 0                     NOT NULL,
  MENTAL_HEALTH_DT_TM          DATE,
  MENTAL_HEALTH_CD             NUMBER           DEFAULT 0                     NOT NULL,
  DOC_RCVD_DT_TM               DATE,
  REFERRAL_RCVD_DT_TM          DATE,
  ALT_LVL_CARE_DT_TM           DATE,
  ALC_DECOMP_DT_TM             DATE,
  REGION_CD                    NUMBER           DEFAULT 0                     NOT NULL,
  SITTER_REQUIRED_CD           NUMBER           DEFAULT 0                     NOT NULL,
  ALC_REASON_CD                NUMBER           DEFAULT 0                     NOT NULL,
  PLACEMENT_AUTH_PRSNL_ID      NUMBER           DEFAULT 0                     NOT NULL,
  PATIENT_CLASSIFICATION_CD    NUMBER           DEFAULT 0                     NOT NULL,
  MENTAL_CATEGORY_CD           NUMBER           DEFAULT 0                     NOT NULL,
  PSYCHIATRIC_STATUS_CD        NUMBER           DEFAULT 0                     NOT NULL,
  INPATIENT_ADMIT_DT_TM        DATE,
  RESULT_ACCUMULATION_DT_TM    DATE,
  PREGNANCY_STATUS_CD          NUMBER           DEFAULT 0,
  INITIAL_CONTACT_DT_TM        DATE,
  LAST_MENSTRUAL_PERIOD_DT_TM  DATE,
  ONSET_DT_TM                  DATE,
  EXPECTED_DELIVERY_DT_TM      DATE,
  LEVEL_OF_SERVICE_CD          NUMBER           DEFAULT 0,
  ABN_STATUS_CD                NUMBER           DEFAULT 0,
  PLACE_OF_SVC_ORG_ID          NUMBER           DEFAULT 0,
  PLACE_OF_SVC_TYPE_CD         NUMBER           DEFAULT 0,
  PLACE_OF_SVC_ADMIT_DT_TM     DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ENTITY_ACCESS
(
  ENTITY_ACCESS_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  PROT_AMENDMENT_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  FUNCTIONALITY_CD     NUMBER                   DEFAULT 0                     NOT NULL,
  ACCESS_MASK          CHAR(5 BYTE)             DEFAULT ' '                   NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EPISODE
(
  EPISODE_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  EPISODE_TYPE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_DT_TM            DATE,
  CREATE_PRSNL_ID         NUMBER                DEFAULT 0,
  DISPLAY                 VARCHAR2(100 BYTE),
  EPISODE_BREACH_DT_TM    DATE,
  EPISODE_STATUS_CD       NUMBER                DEFAULT 0,
  EPISODE_START_DT_TM     DATE,
  EPISODE_STOP_DT_TM      DATE,
  EPISODE_PAUSE_DAYS_CNT  NUMBER                DEFAULT 0,
  REFER_FACILITY_CD       NUMBER                DEFAULT 0,
  SERVICE_CATEGORY_CD     NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EPISODE_ACTIVITY
(
  EPISODE_ACTIVITY_ID     NUMBER                DEFAULT 0                     NOT NULL,
  EPISODE_ID              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVITY_DT_TM          DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVITY_CD             NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVITY_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  EPISODE_STATUS_CD       NUMBER                DEFAULT 0                     NOT NULL,
  EPISODE_PAUSE_DAYS_CNT  NUMBER                DEFAULT 0                     NOT NULL,
  CREATED_BY_ENCNTR_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CREATED_BY_SCHEDULE_ID  NUMBER                DEFAULT 0                     NOT NULL,
  CREATED_BY_CE_EVENT_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EPISODE_ACTIVITY_HIST
(
  EPISODE_ACTIVITY_HIST_ID  NUMBER              DEFAULT 0                     NOT NULL,
  CREATE_DT_TM              DATE                DEFAULT SYSDATE               NOT NULL,
  EPISODE_ACTIVITY_ID       NUMBER              DEFAULT 0                     NOT NULL,
  EPISODE_ID                NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVITY_DT_TM            DATE                DEFAULT SYSDATE               NOT NULL,
  ACTIVITY_CD               NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVITY_TYPE_CD          NUMBER              DEFAULT 0                     NOT NULL,
  EPISODE_STATUS_CD         NUMBER              DEFAULT 0                     NOT NULL,
  EPISODE_PAUSE_DAYS_CNT    NUMBER              DEFAULT 0                     NOT NULL,
  CREATED_BY_ENCNTR_ID      NUMBER              DEFAULT 0                     NOT NULL,
  CREATED_BY_SCHEDULE_ID    NUMBER              DEFAULT 0                     NOT NULL,
  CREATED_BY_CE_EVENT_ID    NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EPISODE_ENCNTR_RELTN
(
  EPISODE_ENCNTR_RELTN_ID  NUMBER               DEFAULT 0                     NOT NULL,
  EPISODE_ID               NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  CONTRIBUTOR_SYSTEM_CD    NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_DT_TM             DATE,
  CREATE_PRSNL_ID          NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EPISODE_EVENT_RELTN
(
  EPISODE_EVENT_RELTN_ID  NUMBER                DEFAULT 0                     NOT NULL,
  EPISODE_ID              NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_ID                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EPISODE_ORDER_RELTN
(
  EPISODE_ORDER_RELTN_ID  NUMBER                DEFAULT 0                     NOT NULL,
  EPISODE_ID              NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EPISODE_PRSNL_RELTN
(
  EPISODE_PRSNL_RELTN_ID  NUMBER                DEFAULT 0                     NOT NULL,
  EPISODE_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_PERSON_ID         NUMBER                DEFAULT 0                     NOT NULL,
  EPISODE_PRSNL_R_CD      NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EPISODE_PRSNL_RELTN_HIST
(
  EPISODE_PRSNL_RELTN_HIST_ID  NUMBER           DEFAULT 0                     NOT NULL,
  EPISODE_PRSNL_RELTN_ID       NUMBER           DEFAULT 0                     NOT NULL,
  EPISODE_ID                   NUMBER           DEFAULT 0                     NOT NULL,
  PRSNL_PERSON_ID              NUMBER           DEFAULT 0                     NOT NULL,
  EPISODE_PRSNL_R_CD           NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE,
  END_EFFECTIVE_DT_TM          DATE,
  ACTIVE_IND                   NUMBER,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EPRESCRIBE_DETAIL
(
  EPRESCRIBE_DETAIL_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  PRSNL_RELTN_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  STATUS_CD             NUMBER                  DEFAULT 0                     NOT NULL,
  ERROR_CD              NUMBER                  DEFAULT 0                     NOT NULL,
  ERROR_DESC            VARCHAR2(100 BYTE),
  MESSAGE_IDENT         VARCHAR2(100 BYTE),
  SUBMIT_DT_TM          DATE                    DEFAULT SYSDATE               NOT NULL,
  BEG_EFFECTIVE_DT_TM   DATE                    DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM   DATE                    DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  SERVICE_LEVEL_NBR     NUMBER                  DEFAULT 0                     NOT NULL,
  CS_NOMINATOR_ID       NUMBER                  DEFAULT 0,
  CS_APPROVER_SIG_TXT   VARCHAR2(1000 BYTE)     DEFAULT ' '
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EPSDT
(
  EPSDT_ID           NUMBER                     DEFAULT 0                     NOT NULL,
  EPSDT_INSTANCE_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  PERSON_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_PRSNL_ID      NUMBER                     DEFAULT 0                     NOT NULL,
  LONG_BLOB_ID       NUMBER                     DEFAULT 0                     NOT NULL,
  STATUS_CD          NUMBER                     DEFAULT 0                     NOT NULL,
  FORM_CD            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ESI_ALIAS_TRANS
(
  CONTRIBUTOR_SYSTEM_CD       NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM         DATE              DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM         DATE              DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ALIAS_POOL_CD               NUMBER            DEFAULT 0                     NOT NULL,
  ALIAS_ENTITY_NAME           VARCHAR2(32 BYTE),
  ALIAS_ENTITY_ALIAS_TYPE_CD  NUMBER            DEFAULT 0                     NOT NULL,
  ESI_ALIAS_FIELD_CD          NUMBER            DEFAULT 0                     NOT NULL,
  ESI_ALIAS_TYPE              VARCHAR2(50 BYTE) DEFAULT ' ',
  ESI_ASSIGN_FAC              VARCHAR2(50 BYTE) DEFAULT ' ',
  ESI_ASSIGN_AUTH             VARCHAR2(50 BYTE) DEFAULT ' ',
  ALIAS_FILTER_CD             NUMBER            DEFAULT 0                     NOT NULL,
  TRUNC_SIZE                  NUMBER,
  SKIP_STRING                 VARCHAR2(100 BYTE),
  PRSNL_PROC_OPT_CD           FLOAT(126)        DEFAULT 0                     NOT NULL,
  PRSNL_FT_STRING             VARCHAR2(50 BYTE),
  ESI_SOURCE                  VARCHAR2(50 BYTE) DEFAULT ' ',
  ASSIGN_AUTHORITY_SYS_CD     NUMBER            DEFAULT 0                     NOT NULL,
  ALIAS_ENSURE_PARMS_FLAG     NUMBER            DEFAULT 0                     NOT NULL,
  ESI_ALIAS_TRANS_ID          NUMBER            DEFAULT 0,
  ELIGIBLE_FOR_QUERY_IND      NUMBER            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ESI_ENSURE_PARMS
(
  CONTRIBUTOR_SYSTEM_CD        NUMBER           DEFAULT 0                     NOT NULL,
  ESI_TASK_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  PERSON_ENSURE_TYPE_CD        NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_ENSURE_TYPE_CD        NUMBER           DEFAULT 0                     NOT NULL,
  EVENT_ENSURE_TYPE_CD         NUMBER           DEFAULT 0                     NOT NULL,
  ORDER_ENSURE_TYPE_CD         NUMBER           DEFAULT 0                     NOT NULL,
  ESI_ENSURE_PARMS_ID          NUMBER           DEFAULT 0                     NOT NULL,
  PERSON_ALIAS_ENSURE_TYPE_CD  NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_ALIAS_ENSURE_TYPE_CD  NUMBER           DEFAULT 0                     NOT NULL,
  CODING_SEGMENT_ENS_TYPE_CD   NUMBER           DEFAULT 0                     NOT NULL,
  ALLERGY_SEGMENT_ENS_TYPE_CD  NUMBER           DEFAULT 0                     NOT NULL,
  PROBLEM_SEGMENT_ENS_TYPE_CD  NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ESI_LOG
(
  ESI_LOG_ID              NUMBER                DEFAULT 0                     NOT NULL,
  MSGID                   VARCHAR2(16 BYTE)     DEFAULT '0',
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  ERROR_STAT              VARCHAR2(32 BYTE),
  BINDING                 VARCHAR2(32 BYTE),
  ESI_INSTANCE            NUMBER                DEFAULT 0,
  MSH_MSG_TYPE            VARCHAR2(8 BYTE),
  MSH_MSG_TRIG            VARCHAR2(8 BYTE),
  MSH_CTRL_IDENT          VARCHAR2(100 BYTE)    DEFAULT '0',
  MSH_DATE                VARCHAR2(32 BYTE),
  MSH_SENDING_APP         VARCHAR2(32 BYTE),
  START_DT_TM             DATE,
  START_TIME              VARCHAR2(16 BYTE),
  END_DT_TM               DATE,
  END_TIME                VARCHAR2(16 BYTE),
  ERROR_TEXT              VARCHAR2(500 BYTE),
  NAME_FULL_FORMATTED     VARCHAR2(100 BYTE),
  ORDER_CTRL              VARCHAR2(8 BYTE),
  CARE_SET_FLAG           NUMBER                DEFAULT 0,
  ENTITY_NAME             VARCHAR2(32 BYTE),
  ENTITY_COUNT            NUMBER                DEFAULT 0,
  ENTITY_LIST             VARCHAR2(128 BYTE),
  HL7_ENTITY_CODE         VARCHAR2(128 BYTE),
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_ID                NUMBER                DEFAULT 0                     NOT NULL,
  SCH_EVENT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_DT_TM            DATE,
  HOLD_ALIAS_FLAG         NUMBER                DEFAULT 0,
  HOLD_RELEASE_STAT       NUMBER                DEFAULT 0,
  DOMAIN_ERROR_STAT_CD    NUMBER                DEFAULT 0                     NOT NULL,
  DOMAIN_ERROR_TEXT       VARCHAR2(500 BYTE),
  QUEUE_ID                NUMBER                DEFAULT 0                     NOT NULL,
  BATCH_EVENT_ID          NUMBER                DEFAULT 0                     NOT NULL,
  TASK_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  ESI_LOG_ORIG_ID         NUMBER                DEFAULT 0                     NOT NULL,
  HL7_ENTITY_ALIAS        VARCHAR2(255 BYTE),
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  TX_KEY                  VARCHAR2(27 BYTE),
  ESI_TX_KEY              VARCHAR2(27 BYTE),
  PROCD_RESTORE_FLAG      NUMBER                DEFAULT 0,
  HL7_ACCESSION_NBR       VARCHAR2(20 BYTE),
  ACCESSION_ID            NUMBER                DEFAULT 0,
  MESSAGE_TRIGGER_CD      NUMBER                DEFAULT 0,
  PERSON_ALIAS            VARCHAR2(255 BYTE)    DEFAULT ' ',
  ENCNTR_ALIAS            VARCHAR2(255 BYTE)    DEFAULT ' ',
  CREATE_TIME             FLOAT(126)            DEFAULT 0,
  INTERNAL_MESSAGE_IDENT  VARCHAR2(40 BYTE),
  LONG_BLOB_ID            NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ESI_SCRIPT_USAGE
(
  ESI_SCRIPT_USAGE_ID    NUMBER                 DEFAULT 0                     NOT NULL,
  SCRIPT_NAME            VARCHAR2(40 BYTE)      DEFAULT ' '                   NOT NULL,
  ELAPSED_TIME           NUMBER                 DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  ESI_LOG_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  MESSGE_TRIGGER         VARCHAR2(20 BYTE)      DEFAULT ' '                   NOT NULL,
  MESSAGE_TYPE           VARCHAR2(20 BYTE)      DEFAULT ' '                   NOT NULL,
  CREATE_DT_TM           DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EXAM_CRITIQUE_INFO
(
  CRITIQUE_INFO_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  ORDER_ID          NUMBER                      DEFAULT 0                     NOT NULL,
  CREATED_BY_ID     NUMBER                      DEFAULT 0                     NOT NULL,
  CREATED_DT_TM     DATE,
  COMMENTS          VARCHAR2(255 BYTE),
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EXAM_DATA
(
  SEQ_EXAM_ID            NUMBER                 DEFAULT 0                     NOT NULL,
  ENCNTR_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  CATALOG_CD             NUMBER                 DEFAULT 0                     NOT NULL,
  COMPLETE_DT_TM         DATE,
  COMPLETE_LOCN_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  MEDICAL_LEGAL_IND      NUMBER,
  MED_LEGAL_CMNT         VARCHAR2(255 BYTE),
  REPORT_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  PURGE_IND              NUMBER,
  READ_COMPLETE_IND      NUMBER,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  GROUP_REFERENCE_NBR    VARCHAR2(40 BYTE),
  OUTSIDE_CASE_IND       NUMBER                 DEFAULT 0,
  FLUORO_MINS_USED       FLOAT(126),
  ORDER_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  COMPLETE_TZ            NUMBER                 DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EXAM_FOLDER
(
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  LIB_GROUP_CD         NUMBER                   DEFAULT 0                     NOT NULL,
  IMAGE_CLASS_TYPE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  REQUIRED_IND         NUMBER,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EXAM_ROOM_LIB_GRP_RELTN
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  LIB_GROUP_CD         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EXPEDITE_CODED_RESP
(
  EXPEDITE_TRIGGER_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  CODED_RESPONSE_CD    NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EXPEDITE_COPY
(
  EXPEDITE_PARAMS_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  ENCNTR_PRSNL_R_CD   NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EXPEDITE_FORMAT
(
  EXPEDITE_FORMAT_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  ACTIVITY_TYPE_DISP  VARCHAR2(40 BYTE),
  ACTIVITY_TYPE_MEAN  VARCHAR2(12 BYTE),
  CHART_FORMAT_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  CHART_CONTENT_FLAG  NUMBER                    DEFAULT 0,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  ACTIVITY_TYPE_CD    NUMBER                    DEFAULT 0                     NOT NULL,
  TEMPLATE_ID         NUMBER                    DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EXPEDITE_LOG
(
  LOG_ID        NUMBER                          DEFAULT 0                     NOT NULL,
  NEXT_LOG_ID   NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  ENCNTR_ID     NUMBER                          DEFAULT 0                     NOT NULL,
  ACCESSION     VARCHAR2(20 BYTE),
  EVENT_DT_TM   DATE,
  MESSAGE_SIZE  NUMBER,
  MESSAGE       LONG RAW
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EXPEDITE_MANUAL
(
  EXPEDITE_MANUAL_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  PERSON_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  ENCNTR_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  ORDER_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  ACCESSION           VARCHAR2(20 BYTE)         DEFAULT ' '                   NOT NULL,
  OUTPUT_DEST_CD      NUMBER                    DEFAULT 0                     NOT NULL,
  OUTPUT_DEVICE_CD    NUMBER                    DEFAULT 0                     NOT NULL,
  PROVIDER_ID         NUMBER                    DEFAULT 0                     NOT NULL,
  PROVIDER_ROLE_CD    NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  CHART_CONTENT_FLAG  NUMBER,
  CHART_FORMAT_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  DEVICE_NAME         VARCHAR2(50 BYTE),
  OUTPUT_DEST_NAME    VARCHAR2(20 BYTE),
  SCOPE_FLAG          NUMBER,
  EVENT_IND           NUMBER,
  BEGIN_DT_TM         DATE,
  DATE_RANGE_IND      NUMBER,
  END_DT_TM           DATE,
  RRD_DELIVER_DT_TM   DATE,
  RRD_PHONE_SUFFIX    VARCHAR2(50 BYTE),
  TEMPLATE_ID         NUMBER                    DEFAULT 0,
  USER_ROLE_PROFILE   VARCHAR2(255 BYTE),
  COPIES_NBR          NUMBER                    DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EXPEDITE_MANUAL_EVENT
(
  EM_EVENT_ID         NUMBER                    DEFAULT 0                     NOT NULL,
  EXPEDITE_MANUAL_ID  NUMBER                    DEFAULT 0,
  EVENT_ID            NUMBER                    DEFAULT 0,
  EM_EVENT_SEQ        NUMBER,
  RESULT_STATUS_CD    NUMBER                    DEFAULT 0,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EXPEDITE_PARAMS
(
  EXPEDITE_PARAMS_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  NAME                VARCHAR2(100 BYTE)        DEFAULT ' '                   NOT NULL,
  NAME_KEY            VARCHAR2(100 BYTE)        DEFAULT ' '                   NOT NULL,
  CHART_CONTENT_FLAG  NUMBER,
  COPIES_FLAG         NUMBER,
  COPIES_OUTPUT_FLAG  NUMBER,
  CHART_FORMAT_ID     NUMBER                    DEFAULT 0,
  OUTPUT_DEST_CD      NUMBER                    DEFAULT 0,
  OUTPUT_DEVICE_CD    NUMBER                    DEFAULT 0,
  OUTPUT_FLAG         NUMBER,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  COPY_IND            NUMBER,
  EXP_PROV_IND        NUMBER                    DEFAULT 0,
  ORDER_DOC_FLAG      NUMBER                    DEFAULT 0,
  TEMPLATE_ID         NUMBER                    DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EXPEDITE_PARAMS_R
(
  EXPEDITE_TRIGGER_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  EXPEDITE_PARAMS_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  PRECEDENCE_SEQ       NUMBER,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EXPEDITE_TRIGGER
(
  EXPEDITE_TRIGGER_ID     NUMBER                DEFAULT 0                     NOT NULL,
  NAME                    VARCHAR2(100 BYTE)    DEFAULT ' '                   NOT NULL,
  NAME_KEY                VARCHAR2(100 BYTE)    DEFAULT ' '                   NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  LOCATION_CD             NUMBER                DEFAULT 0                     NOT NULL,
  LOCATION_CONTEXT_FLAG   NUMBER,
  REPORT_PRIORITY_CD      NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_RANGE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_CD               NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_NBR              NUMBER,
  REPORT_PROCESSING_CD    NUMBER                DEFAULT 0                     NOT NULL,
  REPORT_PROCESSING_NBR   NUMBER,
  SERVICE_RESOURCE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  CATALOG_TYPE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVITY_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  CATALOG_CD              NUMBER                DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD           NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_COMPLETE_FLAG     NUMBER,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  CODED_RESP_IND          NUMBER,
  PROVIDER_ID             NUMBER                DEFAULT 0                     NOT NULL,
  SYNONYM_ID              NUMBER                DEFAULT 0                     NOT NULL,
  DISCHARGED_FLAG         NUMBER,
  MIC_AFTER_COM_FLAG      NUMBER,
  MIC_COM_FLAG            NUMBER,
  MIC_COR_FLAG            NUMBER,
  MIC_VER_FLAG            NUMBER,
  REFERENCE_TASK_ID       NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE EXPIRE_RULE
(
  EXPIRE_RULE_ID          NUMBER                DEFAULT 0                     NOT NULL,
  RULE_NAME               VARCHAR2(250 BYTE)    DEFAULT ' '                   NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  RULE_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_DT_TM            DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  AUTHENTIC_FLAG_IND      NUMBER,
  OBSOLETE_IND            NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FAMILY_RELATION_EXCEPTION
(
  FAMILY_RELATION_EXCEPTION_ID  NUMBER          DEFAULT 0                     NOT NULL,
  PERSON_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  SUGGESTED_RELATED_PERSON_ID   NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FAV_FOLDER_CAT
(
  FAV_FOLDER_CAT_ID       NUMBER                DEFAULT 0                     NOT NULL,
  DESCRIPTION             VARCHAR2(200 BYTE)    DEFAULT ' '                   NOT NULL,
  CHILD_CAT_IND           NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  LOGICAL_DOMAIN_ID       NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FHX_ACTION
(
  FHX_ACTION_ID     NUMBER                      DEFAULT 0                     NOT NULL,
  FHX_ACTIVITY_ID   NUMBER                      DEFAULT 0                     NOT NULL,
  PRSNL_ID          NUMBER                      DEFAULT 0                     NOT NULL,
  ACTION_TYPE_MEAN  VARCHAR2(12 BYTE)           DEFAULT ' '                   NOT NULL,
  ACTION_DT_TM      DATE                        DEFAULT SYSDATE               NOT NULL,
  ACTION_TZ         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FHX_ACTIVITY
(
  FHX_ACTIVITY_ID         NUMBER                DEFAULT 0                     NOT NULL,
  FHX_ACTIVITY_GROUP_ID   NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  TYPE_MEAN               VARCHAR2(12 BYTE)     DEFAULT ' '                   NOT NULL,
  FHX_VALUE_FLAG          NUMBER                DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ONSET_AGE_PREC_CD       NUMBER                DEFAULT 0                     NOT NULL,
  ONSET_AGE               NUMBER,
  ONSET_AGE_UNIT_CD       NUMBER                DEFAULT 0                     NOT NULL,
  LIFE_CYCLE_STATUS_CD    NUMBER                DEFAULT 0                     NOT NULL,
  SEVERITY_CD             NUMBER                DEFAULT 0                     NOT NULL,
  COURSE_CD               NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  RELATED_PERSON_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FHX_ACTIVITY_R
(
  FHX_ACTIVITY_S_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  FHX_ACTIVITY_T_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  TYPE_MEAN          VARCHAR2(10 BYTE)          DEFAULT ' '                   NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FHX_LONG_TEXT_R
(
  FHX_LONG_TEXT_R_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  FHX_ACTIVITY_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  COMMENT_PRSNL_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  COMMENT_DT_TM          DATE                   DEFAULT SYSDATE               NOT NULL,
  COMMENT_DT_TM_TZ       NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  FHX_ACTIVITY_GROUP_ID  NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FHX_SECTION_DEF
(
  FHX_SECTION_DEF_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  CATEGORY_CD         NUMBER                    DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  PRSNL_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  ACTIVE_IND          NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FILING_NUMBER_POSITION
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  POSITION             NUMBER                   DEFAULT 0                     NOT NULL,
  SEQUENCE             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FILL_BATCH
(
  FILL_BATCH_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  FILL_TIME              NUMBER                 DEFAULT 0                     NOT NULL,
  FILL_UNIT_FLAG         NUMBER                 DEFAULT 0                     NOT NULL,
  CYCLE_TIME             NUMBER                 DEFAULT 0                     NOT NULL,
  CYCLE_UNIT_FLAG        NUMBER                 DEFAULT 0                     NOT NULL,
  DISCONTINUE_TIME       NUMBER                 DEFAULT 0,
  DISCONTINUE_UNIT_FLAG  NUMBER,
  SUSPEND_TIME           NUMBER                 DEFAULT 0,
  SUSPEND_UNIT_FLAG      NUMBER,
  UNVERIFIED_ORDER_IND   NUMBER,
  INCOMPLETE_ORDER_IND   NUMBER,
  PRN_FILL_TIME          NUMBER                 DEFAULT 0,
  PRN_FILL_UNIT_FLAG     NUMBER,
  DEF_OPERATION_FLAG     NUMBER,
  MAX_FILL_TIME          NUMBER                 DEFAULT 0,
  MAX_FILL_UNIT_FLAG     NUMBER,
  MAX_CYCLE_TIME         NUMBER                 DEFAULT 0,
  MAX_CYCLE_UNIT_FLAG    NUMBER,
  MIN_ELAPSED_TIME       NUMBER                 DEFAULT 0,
  MIN_ELAPSED_UNIT_FLAG  NUMBER,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  OUTPUT_FORMAT_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  DEFAULT_PRINTER_CD     NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_TYPE_FLAG        NUMBER,
  LOCATION_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  LOC_FACILITY_CD        NUMBER                 DEFAULT 0                     NOT NULL,
  MONTHLY_DOW_FLAG       NUMBER                 DEFAULT 0,
  MONTHLY_WEEK_FLAG      NUMBER                 DEFAULT 0,
  CALENDAR_DAY_NBR       NUMBER                 DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FILL_PRINT_ORD_HX
(
  RUN_ID                          NUMBER        DEFAULT 0                     NOT NULL,
  ORDER_ID                        NUMBER        DEFAULT 0                     NOT NULL,
  ORDER_ROW_SEQ                   NUMBER        DEFAULT 0                     NOT NULL,
  ENCNTR_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  PERSON_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  PERSON_NAME_S                   VARCHAR2(50 BYTE),
  FACILITY_CD                     NUMBER        DEFAULT 0                     NOT NULL,
  FACILITY_S                      CHAR(40 BYTE),
  LOCATION_CD                     NUMBER        DEFAULT 0                     NOT NULL,
  LOCATION_S                      CHAR(40 BYTE),
  ROOM_CD                         NUMBER        DEFAULT 0                     NOT NULL,
  ROOM_S                          CHAR(40 BYTE),
  BED_CD                          NUMBER        DEFAULT 0                     NOT NULL,
  BED_S                           CHAR(40 BYTE),
  RACE_CD                         NUMBER        DEFAULT 0                     NOT NULL,
  RACE_S                          CHAR(40 BYTE),
  SEX_CD                          NUMBER        DEFAULT 0                     NOT NULL,
  SEX_S                           CHAR(40 BYTE),
  HEIGHT                          FLOAT(126),
  HEIGHT_UNIT_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  HEIGHT_UNIT_S                   CHAR(40 BYTE),
  WEIGHT                          FLOAT(126),
  WEIGHT_UNIT_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  WEIGHT_UNIT_S                   CHAR(40 BYTE),
  BIRTH_DT_TM                     DATE,
  INS_CD                          NUMBER        DEFAULT 0                     NOT NULL,
  INS_POLICY                      CHAR(40 BYTE),
  ADMIT_PHYS_ID                   NUMBER        DEFAULT 0                     NOT NULL,
  ADMIT_PHYS_NAME                 VARCHAR2(50 BYTE),
  ADMIT_DT_TM                     DATE,
  ATTEND_PHYS_ID                  NUMBER        DEFAULT 0                     NOT NULL,
  ATTEND_PHYS_NAME                VARCHAR2(50 BYTE),
  ORD_DESC                        VARCHAR2(100 BYTE),
  DISPENSE_CATEGORY_CD            NUMBER        DEFAULT 0                     NOT NULL,
  DISPENSE_CATEGORY_S             CHAR(40 BYTE),
  ROUTE_CD                        NUMBER        DEFAULT 0                     NOT NULL,
  ROUTE_S                         CHAR(40 BYTE),
  FREQUENCY_CD                    NUMBER        DEFAULT 0                     NOT NULL,
  FREQUENCY_S                     CHAR(40 BYTE),
  PRN_IND                         NUMBER,
  ENTERED_DT_TM                   DATE,
  ORDER_START_DT_TM               DATE,
  ORDER_STOP_DT_TM                DATE,
  ORDER_STATUS_ENUM               NUMBER,
  ORDER_STATUS_S                  CHAR(40 BYTE),
  ORD_PHYS_ID                     NUMBER        DEFAULT 0                     NOT NULL,
  ORD_PHYS_NAME                   VARCHAR2(50 BYTE),
  RPH_ID                          NUMBER        DEFAULT 0                     NOT NULL,
  RPH_NAME                        VARCHAR2(50 BYTE),
  RPH_INITIALS                    CHAR(8 BYTE),
  ENTRY_ID                        NUMBER        DEFAULT 0                     NOT NULL,
  ENTRY_NAME                      VARCHAR2(50 BYTE),
  ORD_TYPE                        NUMBER,
  ORD_PEND_STATUS                 CHAR(20 BYTE),
  STATUS_DT_TM                    DATE,
  FILL_QUANTITY                   FLOAT(126),
  ERROR_LOG                       VARCHAR2(100 BYTE),
  OUTPUT_FORMAT_CD                NUMBER        DEFAULT 0                     NOT NULL,
  ENTER_USER_ID                   NUMBER        DEFAULT 0                     NOT NULL,
  NET_CART_IND                    NUMBER,
  NET_CART_QTY                    FLOAT(126),
  ADMIN_DT_TM                     DATE,
  ADMIN_COUNT                     NUMBER,
  LABEL_DESC                      CHAR(40 BYTE),
  REPORT_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  SCH_PRN_IND                     NUMBER,
  BAG_NBR                         NUMBER,
  IV_IN_SEQ                       NUMBER,
  IV_SET_SIZE                     NUMBER,
  UNIQUE_BAG_ID                   NUMBER        DEFAULT 0                     NOT NULL,
  ML_HR                           FLOAT(126),
  INFUSE_OVER                     FLOAT(126),
  INFUSE_UNIT_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  INFUSE_UNIT_S                   CHAR(40 BYTE),
  RATE                            FLOAT(126),
  LABEL_REASON_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  LABEL_REASON_S                  CHAR(40 BYTE),
  TOT_VOLUME                      FLOAT(126),
  OVERFILL_AMT                    FLOAT(126),
  LBL_ID                          NUMBER        DEFAULT 0                     NOT NULL,
  ORD_PRICE                       FLOAT(126),
  ORD_COST                        FLOAT(126),
  INGRED_CNT                      NUMBER,
  INGRED_DESC                     VARCHAR2(50 BYTE),
  INGRED_SEQ                      NUMBER,
  STRENGTH_UNIT_CD                NUMBER        DEFAULT 0                     NOT NULL,
  STRENGTH_UNIT_S                 CHAR(40 BYTE),
  STRENGTH                        FLOAT(126),
  VOLUME_UNIT_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  VOLUME_UNIT_S                   CHAR(40 BYTE),
  VOLUME                          FLOAT(126),
  FREETEXT_DOSE                   VARCHAR2(50 BYTE),
  LABEL1_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  LABEL2_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  PROD_CNT                        NUMBER,
  ITEM_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  PROD_DESC                       VARCHAR2(50 BYTE),
  GEN_NAME                        VARCHAR2(50 BYTE),
  BRAND_NAME                      VARCHAR2(50 BYTE),
  FORM_CD                         NUMBER        DEFAULT 0                     NOT NULL,
  FORM_S                          CHAR(40 BYTE),
  CHARGE_QTY                      FLOAT(126),
  CREDIT_QTY                      FLOAT(126),
  DOSE_QUANTITY                   FLOAT(126),
  DOSE_QUANTITY_UNIT_CD           NUMBER        DEFAULT 0                     NOT NULL,
  DOSE_QUANTITY_UNIT_S            CHAR(40 BYTE),
  FORMULARY_STATUS_CD             NUMBER        DEFAULT 0                     NOT NULL,
  FORMULARY_STATUS_S              CHAR(40 BYTE),
  NDC                             VARCHAR2(30 BYTE),
  LEGAL_STATUS_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  LEGAL_STATUS_S                  CHAR(40 BYTE),
  MEDREC_NBR_ID                   NUMBER        DEFAULT 0                     NOT NULL,
  MEDREC_NBR                      VARCHAR2(100 BYTE),
  FINNBR_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  FINNBR                          VARCHAR2(100 BYTE),
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  MED_FIN_IND                     NUMBER,
  ORDER_TYPE_FLAG                 NUMBER,
  REPLACE_EVERY                   FLOAT(126),
  REPLACE_EVERY_UNIT_CD           NUMBER        DEFAULT 0                     NOT NULL,
  REPLACE_EVERY_UNIT_S            VARCHAR2(40 BYTE),
  THER_CLASS_CODE                 VARCHAR2(20 BYTE),
  THER_CLASS_DESC                 VARCHAR2(100 BYTE),
  THER_CLASS_ID                   NUMBER        DEFAULT 0                     NOT NULL,
  DISPENSE_ID                     NUMBER        DEFAULT 0                     NOT NULL,
  TNF_ID                          NUMBER        DEFAULT 0                     NOT NULL,
  SIDE_EFFECT_CODE                VARCHAR2(10 BYTE),
  SORT_CLASS                      VARCHAR2(20 BYTE),
  THER_CLASS_SORT_CODE            VARCHAR2(20 BYTE),
  TITRATE_IND                     NUMBER,
  ACTION_SEQUENCE                 NUMBER,
  BSA                             FLOAT(126)    DEFAULT 0,
  BSA_UNIT_CD                     NUMBER        DEFAULT 0                     NOT NULL,
  BSA_UNIT_S                      VARCHAR2(40 BYTE),
  CDM                             VARCHAR2(25 BYTE),
  COMMENT1_WHERE_TO_PRINT         NUMBER,
  COMMENT2_WHERE_TO_PRINT         NUMBER,
  CRCL                            FLOAT(126)    DEFAULT 0,
  CRCL_UNIT_CD                    NUMBER        DEFAULT 0                     NOT NULL,
  CRCL_UNIT_S                     VARCHAR2(40 BYTE),
  DISPENSE_DEVICE_IND             NUMBER,
  FLOORSTOCK_IND                  NUMBER,
  IBW                             FLOAT(126)    DEFAULT 0,
  IBW_UNIT_CD                     NUMBER        DEFAULT 0                     NOT NULL,
  IBW_UNIT_S                      VARCHAR2(40 BYTE),
  IGNORE_IND                      NUMBER,
  LABEL_TYPE_CD                   NUMBER        DEFAULT 0                     NOT NULL,
  ORDER_STATUS_DT_TM              DATE,
  PATIENT_TEXT_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  PAT_TEXT_ID                     NUMBER        DEFAULT 0                     NOT NULL,
  DISP_QTY_UNIT_CD                NUMBER        DEFAULT 0                     NOT NULL,
  EARLY_REASON_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  EXTRA_REASON_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  LATE_REASON_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  RX_EXPIRE_DT_TM                 DATE,
  OTHER_COVERAGE_CD               NUMBER        DEFAULT 0                     NOT NULL,
  PHARM_TYPE_CD                   NUMBER        DEFAULT 0                     NOT NULL,
  LAST_REFILL_DT_TM               DATE,
  NEXT_DISPENSE_DT_TM             DATE,
  QTY_REMAINING                   FLOAT(126),
  REFILLS_REMAINING               FLOAT(126),
  TOTAL_RX_QTY                    FLOAT(126),
  SAFETY_CAP_S                    VARCHAR2(1 BYTE),
  AUTHORIZATION_NBR               VARCHAR2(50 BYTE),
  COMPOUND_IND                    NUMBER,
  COMPOUND_TEXT_ID                NUMBER        DEFAULT 0                     NOT NULL,
  COMPOUND_TOTAL                  FLOAT(126),
  CONTROL_NUMBER                  VARCHAR2(25 BYTE),
  COPAY                           FLOAT(126),
  DAW_CD                          NUMBER        DEFAULT 0                     NOT NULL,
  DAYS_SUPPLY                     FLOAT(126),
  DISPENSE_DT_TM                  DATE,
  DISPENSE_LOC_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  DISP_PRIORITY_CD                NUMBER        DEFAULT 0                     NOT NULL,
  DISP_PRIORITY_DT_TM             DATE,
  DISP_QTY                        FLOAT(126),
  DUR_CONFLICT_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  DUR_INTER_CD                    NUMBER        DEFAULT 0                     NOT NULL,
  DUR_OUTCOME_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  ELIGIBILITY_CLARIFY_CD          NUMBER        DEFAULT 0                     NOT NULL,
  FILL_NBR                        NUMBER,
  HEALTH_PLAN_ID                  NUMBER        DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_S                   VARCHAR2(40 BYTE),
  ICD9_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  ICD9_S                          VARCHAR2(100 BYTE),
  MANF_CD                         NUMBER        DEFAULT 0                     NOT NULL,
  NBR_OF_REFILLS                  FLOAT(126),
  ORDER_ENTRY_LOC_CD              NUMBER        DEFAULT 0                     NOT NULL,
  PAYMENT_METHOD_CD               NUMBER        DEFAULT 0                     NOT NULL,
  PA_BEG_DT_TM                    DATE,
  PA_END_DT_TM                    DATE,
  PA_NUMBER                       VARCHAR2(25 BYTE),
  PRICE_CODE_CD                   NUMBER        DEFAULT 0                     NOT NULL,
  REASON_FOR_USE                  VARCHAR2(100 BYTE),
  REFILL_QTY                      FLOAT(126),
  REIMBURSEMENT                   FLOAT(126),
  RX_NBR                          FLOAT(126),
  RX_NBR_CD                       NUMBER        DEFAULT 0                     NOT NULL,
  RX_NBR_IN_SET                   NUMBER,
  RX_NBR_S                        VARCHAR2(40 BYTE),
  RX_QTY                          FLOAT(126),
  RX_SET_SIZE                     NUMBER,
  SCRIPT_CLARIFY_CD               NUMBER        DEFAULT 0                     NOT NULL,
  SCRIPT_ORIGIN_CD                NUMBER        DEFAULT 0                     NOT NULL,
  SIG_ALT_LANG_TEXT_ID            NUMBER        DEFAULT 0                     NOT NULL,
  SIG_CODES                       VARCHAR2(100 BYTE),
  SIG_TEXT_ID                     NUMBER        DEFAULT 0                     NOT NULL,
  TECH_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  TECH_INITIALS                   VARCHAR2(8 BYTE),
  TECH_NAME                       VARCHAR2(50 BYTE),
  TRACK_NBR                       FLOAT(126),
  TRACK_NBR_CD                    NUMBER        DEFAULT 0                     NOT NULL,
  TRACK_NBR_S                     VARCHAR2(40 BYTE),
  UC_PRICE                        FLOAT(126),
  TOTAL_REFILLS                   FLOAT(126),
  DISPENSE_SR_CD                  FLOAT(126)    DEFAULT 0                     NOT NULL,
  DISPENSE_STATUS_HX_ID           FLOAT(126)    DEFAULT 0                     NOT NULL,
  MED_PRODUCT_ID                  NUMBER        DEFAULT 0                     NOT NULL,
  DOSE_FORM_CD                    NUMBER        DEFAULT 0                     NOT NULL,
  DOSE_FORM_S                     VARCHAR2(60 BYTE),
  ORDER_PRIORITY_CD               NUMBER        DEFAULT 0                     NOT NULL,
  ORDER_PRIORITY_S                VARCHAR2(60 BYTE),
  DISPENSE_FROM_CD                NUMBER        DEFAULT 0                     NOT NULL,
  DISPENSE_FROM_S                 VARCHAR2(60 BYTE),
  COMMUNICATION_TYPE_CD           NUMBER        DEFAULT 0                     NOT NULL,
  COMMUNICATION_TYPE_S            VARCHAR2(60 BYTE),
  FREETEXT_RATE                   VARCHAR2(255 BYTE),
  ORDERED_AS_MNEMONIC             VARCHAR2(100 BYTE),
  FILL_NOTE_ID                    NUMBER        DEFAULT 0                     NOT NULL,
  PRODUCT_NOTE_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  ORDER_COMMENT_ID                NUMBER        DEFAULT 0                     NOT NULL,
  PRN_REASON_CD                   NUMBER        DEFAULT 0                     NOT NULL,
  PRN_REASON_S                    VARCHAR2(60 BYTE),
  CREDIT_INV_IND                  NUMBER        DEFAULT 0,
  RX_WORKSTATION_CD               NUMBER        DEFAULT 0                     NOT NULL,
  PROXY_PRESCRIBER_ID             NUMBER        DEFAULT 0                     NOT NULL,
  PROXY_PRESCRIBER_NAME           VARCHAR2(50 BYTE),
  BIRTH_TZ                        NUMBER        DEFAULT 0,
  ADMIT_TZ                        NUMBER        DEFAULT 0,
  ENTERED_TZ                      NUMBER        DEFAULT 0,
  ORDER_START_TZ                  NUMBER        DEFAULT 0,
  ORDER_STOP_TZ                   NUMBER        DEFAULT 0,
  ADMIN_TZ                        NUMBER        DEFAULT 0,
  ORDER_STATUS_TZ                 NUMBER        DEFAULT 0,
  PA_BEG_TZ                       NUMBER        DEFAULT 0,
  PA_END_TZ                       NUMBER        DEFAULT 0,
  DISPENSE_TZ                     NUMBER        DEFAULT 0,
  DISP_PRIORITY_TZ                NUMBER        DEFAULT 0,
  RX_EXPIRE_TZ                    NUMBER        DEFAULT 0,
  LAST_REFILL_TZ                  NUMBER        DEFAULT 0,
  NEXT_DISPENSE_TZ                NUMBER        DEFAULT 0,
  LANGUAGE_CD                     NUMBER        DEFAULT 0                     NOT NULL,
  SAFETY_CAP_CD                   NUMBER        DEFAULT 0                     NOT NULL,
  NORMALIZED_RATE_UNIT_CD         NUMBER        DEFAULT 0,
  NORMALIZED_RATE                 FLOAT(126)    DEFAULT 0,
  FUTURE_ORDER_IND                NUMBER        DEFAULT 0,
  PKG_NBR                         NUMBER,
  PKG_QUANTITY                    NUMBER,
  PKG_COUNT                       FLOAT(126),
  CONCENTRATION_UNIT_S            VARCHAR2(40 BYTE),
  CONCENTRATION_UNIT_CD           NUMBER        DEFAULT 0,
  CONCENTRATION                   FLOAT(126)    DEFAULT 0,
  NORMALIZED_RATE_UNIT_S          VARCHAR2(40 BYTE),
  RX_PERSON_OWE_DOSES_CNT         FLOAT(126),
  TEMP_STOCK_IND                  NUMBER        DEFAULT 0,
  CUR_DISP_LOC_CD                 NUMBER        DEFAULT 0,
  TRANSFER_TO_LOC_S               VARCHAR2(40 BYTE),
  CUR_DISP_LOC_S                  VARCHAR2(40 BYTE),
  TRANSFER_TO_LOC_CD              NUMBER        DEFAULT 0,
  PATIENT_MED_IND                 NUMBER        DEFAULT 0,
  LOT_TRACKING_IND                NUMBER        DEFAULT 0,
  DOSES_OMITTED_IND               NUMBER        DEFAULT 0,
  PERSON_OWE_QTY                  FLOAT(126),
  VOLUME_WITH_OVERFILL_VALUE      FLOAT(126)    DEFAULT 0,
  STRENGTH_WITH_OVERFILL_UNIT_S   VARCHAR2(40 BYTE),
  STRENGTH_WITH_OVERFILL_UNIT_CD  NUMBER        DEFAULT 0,
  STRENGTH_WITH_OVERFILL_VALUE    FLOAT(126)    DEFAULT 0,
  VOLUME_WITH_OVERFILL_UNIT_S     VARCHAR2(40 BYTE),
  VOLUME_WITH_OVERFILL_UNIT_CD    NUMBER        DEFAULT 0,
  DOSING_METHOD_FLAG              NUMBER        DEFAULT 0,
  DOSE_QUANTITY_TXT               VARCHAR2(150 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FILM_EXAM
(
  SEQ_OBJECT_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  SEQ_EXAM_ID            NUMBER                 DEFAULT 0                     NOT NULL,
  FOLDER_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  FILM_COUNT             NUMBER,
  LOST_COUNT             NUMBER,
  LOST_COMMENT           VARCHAR2(255 BYTE),
  TEMP_FOLDER_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  MULTI_DAY_IN_PROC_IND  NUMBER,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  LOST_IND               NUMBER                 DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FINANCIAL_PERIOD
(
  FINANCIAL_PERIOD_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  FINANCIAL_YEAR_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  FROM_DT_TM           DATE                     DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  TO_DT_TM             DATE                     DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FINANCIAL_YEAR
(
  FINANCIAL_YEAR_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  YEAR_DT_TM         DATE                       DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  DESCRIPTION        VARCHAR2(100 BYTE),
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FN_OMF_ENCNTR
(
  FN_OMF_ENCNTR_ID            NUMBER            DEFAULT 0                     NOT NULL,
  TRACKING_GROUP_CD           NUMBER            DEFAULT 0                     NOT NULL,
  TRACKING_ID                 NUMBER            DEFAULT 0                     NOT NULL,
  PERSON_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  CHECKIN_ACUITY_ID           NUMBER            DEFAULT 0                     NOT NULL,
  CHECKOUT_ACUITY_ID          NUMBER            DEFAULT 0                     NOT NULL,
  PRIMARY_CARE_PHYSICIAN_ID   NUMBER            DEFAULT 0                     NOT NULL,
  PRIMARY_DOC_ID              NUMBER            DEFAULT 0                     NOT NULL,
  SECONDARY_DOC_ID            NUMBER            DEFAULT 0                     NOT NULL,
  PRIMARY_NURSE_ID            NUMBER            DEFAULT 0                     NOT NULL,
  SECONDARY_NURSE_ID          NUMBER            DEFAULT 0                     NOT NULL,
  DISCH_DIAG                  VARCHAR2(250 BYTE),
  SPECIALTY_ID                NUMBER            DEFAULT 0                     NOT NULL,
  LOC_BUILDING_CD             NUMBER            DEFAULT 0                     NOT NULL,
  LOC_FACILITY_CD             NUMBER            DEFAULT 0                     NOT NULL,
  LOC_AMBULATORY_UNIT_CD      NUMBER            DEFAULT 0                     NOT NULL,
  LOC_NURSE_UNIT_CD           NUMBER            DEFAULT 0                     NOT NULL,
  LOC_NURSE_UNIT_GRP          NUMBER,
  LOC_ROOM_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  LOC_ROOM_GRP                NUMBER,
  LOC_BED_CD                  NUMBER            DEFAULT 0                     NOT NULL,
  LOC_BED_GRP                 NUMBER,
  CHECKIN_DT_TM               DATE,
  CHECKIN_OMF_DT              NUMBER,
  CHECKIN_OMF_TM              NUMBER,
  CHECKOUT_DT_TM              DATE,
  CHECKOUT_OMF_DT             NUMBER,
  CHECKOUT_OMF_TM             NUMBER,
  ARRIVE_REQ_EVT_DT_TM        DATE,
  ARRIVE_REQ_EVT_OMF_DT       NUMBER,
  ARRIVE_REQ_EVT_OMF_TM       NUMBER,
  TRIAGE_COMP_EVT_DT_TM       DATE,
  TRIAGE_COMP_EVT_OMF_DT      NUMBER,
  TRIAGE_COMP_EVT_OMF_TM      NUMBER,
  BED_ASSIGN_COMP_EVT_DT_TM   DATE,
  BED_ASSIGN_COMP_EVT_OMF_DT  NUMBER,
  BED_ASSIGN_COMP_EVT_OMF_TM  NUMBER,
  RN_ASSESS_START_EVT_DT_TM   DATE,
  RN_ASSESS_START_EVT_OMF_DT  NUMBER,
  RN_ASSESS_START_EVT_OMF_TM  NUMBER,
  MD_ASSESS_START_EVT_DT_TM   DATE,
  MD_ASSESS_START_EVT_OMF_DT  NUMBER,
  MD_ASSESS_START_EVT_OMF_TM  NUMBER,
  REG_COMP_EVT_DT_TM          DATE,
  REG_COMP_EVT_OMF_DT         NUMBER,
  REG_COMP_EVT_OMF_TM         NUMBER,
  DISPO_REQ_EVT_DT_TM         DATE,
  DISPO_REQ_EVT_OMF_DT        NUMBER,
  DISPO_REQ_EVT_OMF_TM        NUMBER,
  DISPO_COMP_EVT_DT_TM        DATE,
  DISPO_COMP_EVT_OMF_DT       NUMBER,
  DISPO_COMP_EVT_OMF_TM       NUMBER,
  ACTIVE_IND                  NUMBER,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FOLDER
(
  SEQ_OBJECT_ID      NUMBER                     DEFAULT 0                     NOT NULL,
  PARENT_OBJECT_ID   NUMBER                     DEFAULT 0                     NOT NULL,
  PERSON_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  OLD_CERNER_NUMBER  VARCHAR2(50 BYTE),
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FOREIGN_CONTENT
(
  SEQ_FOREIGN_ID   NUMBER                       DEFAULT 0                     NOT NULL,
  SEQ_OBJECT_ID    NUMBER                       DEFAULT 0                     NOT NULL,
  CONTENT_NAME     VARCHAR2(255 BYTE),
  CONTENT_TYPE_CD  NUMBER                       DEFAULT 0                     NOT NULL,
  FILM_COUNT       NUMBER,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  ACTIVE_IND       NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FOREIGN_FOLDER
(
  SEQ_OBJECT_ID    NUMBER                       DEFAULT 0                     NOT NULL,
  PERSON_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  CONTENT_COMMENT  VARCHAR2(255 BYTE),
  LENDER_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  CUSTODIAN        VARCHAR2(50 BYTE),
  RECEIVED_DT_TM   DATE,
  DUE_DT_TM        DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FORMAT_ORG_RELTN
(
  CHART_FORMAT_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PRIMARY_FORMAT_IND      NUMBER,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FREQUENCY_SCHEDULE
(
  FREQUENCY_CD            NUMBER                DEFAULT 0                     NOT NULL,
  FREQ_QUALIFIER          NUMBER                DEFAULT 0                     NOT NULL,
  DESCRIPTION             VARCHAR2(100 BYTE),
  ROUND_TO                NUMBER,
  FREQUENCY_TYPE          NUMBER,
  INTERVAL                NUMBER,
  INTERVAL_UNITS          NUMBER,
  MIN_EVENT_PER_DAY       NUMBER,
  ACTIVE_IND              NUMBER,
  FIRST_DOSE_METHOD       NUMBER,
  FIRST_DOSE_RANGE        NUMBER,
  FIRST_DOSE_RANGE_UNITS  NUMBER,
  MAX_EVENT_PER_DAY       NUMBER,
  DEFAULT_PAR_VAL         NUMBER,
  PARENT_ENTITY           CHAR(32 BYTE),
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVITY_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  INSTANCE                NUMBER                DEFAULT 0                     NOT NULL,
  EFFECTIVE_DT_TM         DATE,
  FREQUENCY_ID            NUMBER                DEFAULT 0                     NOT NULL,
  PRN_DEFAULT_IND         NUMBER,
  CRITICAL_UPDT_DT_TM     DATE,
  CRITICAL_UPD_ID         NUMBER                DEFAULT 0                     NOT NULL,
  FACILITY_CD             NUMBER                DEFAULT 0                     NOT NULL,
  MIN_INTERVAL_UNIT_CD    NUMBER                DEFAULT 0,
  MIN_INTERVAL_NBR        NUMBER                DEFAULT 0,
  RX_TOD_DOW_ID           NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE FT_TERM_CANDIDATE_LIST
(
  FOLLOWUP_EVENT_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  REVIEW_CASE_ID     NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE GEL_BATCH
(
  GEL_BATCH_ID       NUMBER                     DEFAULT 0                     NOT NULL,
  GEL_BATCH_IND      NUMBER                     DEFAULT 0                     NOT NULL,
  GEL_BATCH_DESC     VARCHAR2(30 BYTE),
  RACK_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  PREPARED_PRSNL_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  PREPARED_DT_TM     DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE GEL_LOADING
(
  ORDER_ID      NUMBER                          DEFAULT 0                     NOT NULL,
  GEL_NUMBER    NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL,
  GEL_BATCH_ID  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE GEL_LOADING_POSN
(
  ORDER_ID       NUMBER                         DEFAULT 0                     NOT NULL,
  GEL_NUMBER     NUMBER                         DEFAULT 0                     NOT NULL,
  X_POS          NUMBER                         DEFAULT 0                     NOT NULL,
  Y_POS          NUMBER                         DEFAULT 0                     NOT NULL,
  LOT_NUMBER_ID  NUMBER                         DEFAULT 0                     NOT NULL,
  TUBE_NUMBER    NUMBER,
  POSITIVE_IND   NUMBER,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL,
  GEL_BATCH_ID   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE GEL_RESULT_COMMENT
(
  ORDER_ID      NUMBER                          DEFAULT 0                     NOT NULL,
  GEL_NUMBER    NUMBER                          DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID  NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL,
  GEL_BATCH_ID  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE GL_ALIAS
(
  GL_ALIAS_ID             NUMBER                DEFAULT 0                     NOT NULL,
  GL_ALIAS_NAME           VARCHAR2(100 BYTE),
  GL_ALIAS_NAME_KEY       VARCHAR2(100 BYTE),
  GL_ALIAS_LEVEL          NUMBER,
  DEFAULT_IND             NUMBER,
  CREATED_PRSNL_ID        NUMBER                DEFAULT 0                     NOT NULL,
  CREATED_DT_TM           DATE                  DEFAULT SYSDATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  GL_GROUP_NAME_TXT       VARCHAR2(32 BYTE),
  PREVIOUS_ALIAS_ID       NUMBER                DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ            NUMBER                DEFAULT 0                     NOT NULL,
  DESCRIPTION_TXT         VARCHAR2(255 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE GL_ALIAS_FIELD_RELTN
(
  GL_ALIAS_FIELD_RELTN_ID  NUMBER               DEFAULT 0                     NOT NULL,
  GL_ALIAS_ID              NUMBER               DEFAULT 0                     NOT NULL,
  GL_FIELD_MASTER_ID       NUMBER               DEFAULT 0                     NOT NULL,
  FIELD_SEQ                NUMBER,
  CREATED_PRSNL_ID         NUMBER               DEFAULT 0                     NOT NULL,
  CREATED_DT_TM            DATE                 DEFAULT SYSDATE,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE GL_ALIAS_FIELD_RESULT
(
  GL_ALIAS_FIELD_RESULT_ID  NUMBER              DEFAULT 0                     NOT NULL,
  GL_ALIAS_FIELD_RELTN_ID   NUMBER              DEFAULT 0                     NOT NULL,
  GL_FIELD_VALUE            NUMBER,
  CREATED_PRSNL_ID          NUMBER              DEFAULT 0                     NOT NULL,
  CREATED_DT_TM             DATE                DEFAULT SYSDATE,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE GL_FIELD_MASTER
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  CODE_SET                NUMBER,
  CONTROL_NBR             NUMBER                DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM     DATE,
  GL_FIELD_DESC           VARCHAR2(255 BYTE),
  GL_FIELD_MASTER_ID      NUMBER                DEFAULT 0                     NOT NULL,
  GL_FIELD_NAME           VARCHAR2(250 BYTE),
  GL_FIELD_NAME_KEY       VARCHAR2(250 BYTE),
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  CREATED_DT_TM           DATE                  DEFAULT SYSDATE,
  CREATED_PRSNL_ID        NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE GL_TRANS_LOG
(
  ACCOUNT_ALIAS_NBR          VARCHAR2(50 BYTE),
  ACCT_TYPE_CD               NUMBER             DEFAULT 0                     NOT NULL,
  ACCT_UNIT_ALIAS_NBR        VARCHAR2(50 BYTE),
  ACTIVE_IND                 NUMBER,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM        DATE,
  ACTIVE_STATUS_PRSNL_ID     NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVITY_DT_TM             DATE,
  ACTIVITY_ID                NUMBER             DEFAULT 0                     NOT NULL,
  AMOUNT                     FLOAT(126),
  BEG_EFFECTIVE_DT_TM        DATE               DEFAULT SYSDATE,
  COMPANY_ALIAS_NBR          VARCHAR2(50 BYTE),
  DR_CR_FLAG                 NUMBER,
  END_EFFECTIVE_DT_TM        DATE               DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  GL_ACCOUNT_ALIAS_NBR       VARCHAR2(100 BYTE),
  GL_ACCT_UNIT_ALIAS_NBR     VARCHAR2(100 BYTE),
  GL_COMPANY_ALIAS_NBR       VARCHAR2(100 BYTE),
  GL_COMPANY_UNIT_ALIAS_NBR  VARCHAR2(100 BYTE),
  GL_INTERFACE_DT_TM         DATE,
  GL_STATUS_CD               NUMBER             DEFAULT 0                     NOT NULL,
  GL_TRANS_LOG_ID            NUMBER             DEFAULT 0                     NOT NULL,
  PARENT_GL_TRANS_LOG_ID     NUMBER             DEFAULT 0                     NOT NULL,
  POSTED_DT_TM               DATE,
  SUB_ACCT_ALIAS_NBR         VARCHAR2(50 BYTE),
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  CREATED_DT_TM              DATE               DEFAULT SYSDATE,
  CREATED_PRSNL_ID           NUMBER             DEFAULT 0                     NOT NULL,
  RECLASSIFIED_IND           NUMBER             DEFAULT 0                     NOT NULL,
  PFT_FISCAL_PERIOD_ID       NUMBER             DEFAULT 0                     NOT NULL,
  SI_BATCH_ID                NUMBER             DEFAULT 0                     NOT NULL,
  LOGICAL_DOMAIN_ID          NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE GS_MED_CLAIM
(
  GS_MED_CLAIM_ID               NUMBER          DEFAULT 0                     NOT NULL,
  PERSON_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  PRODUCT_DESCRIPTION           VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  CATALOG_CKI                   VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  CATALOG_CD                    NUMBER          DEFAULT 0                     NOT NULL,
  PRODUCT_SYNONYM_CKI           VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  PRODUCT_SYNONYM_ID            NUMBER          DEFAULT 0                     NOT NULL,
  DISPENSE_QTY                  FLOAT(126)      DEFAULT 0                     NOT NULL,
  REFILL_NBR                    NUMBER          DEFAULT 0                     NOT NULL,
  PRESCRIBER_NAME               VARCHAR2(135 BYTE) DEFAULT ' ' NOT NULL,
  PRESCRIBER_ID                 NUMBER          DEFAULT 0                     NOT NULL,
  PHARMACY_NAME                 VARCHAR2(100 BYTE) DEFAULT ' ' NOT NULL,
  ACTIVE_IND                    NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD              NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID        NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM           DATE            DEFAULT SYSDATE               NOT NULL,
  CREATE_DT_TM                  DATE            DEFAULT SYSDATE               NOT NULL,
  SERVICE_DT_TM                 DATE            DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  CONTRIBUTOR_SYSTEM_CD         NUMBER          DEFAULT 0                     NOT NULL,
  PHARMACY_IDENTIFIER           VARCHAR2(100 BYTE) DEFAULT ' ' NOT NULL,
  ORIG_GS_MED_CLAIM_ID          NUMBER          DEFAULT 0                     NOT NULL,
  VERSION_NBR                   NUMBER          DEFAULT 0                     NOT NULL,
  PAYER_ORG_ID                  NUMBER          DEFAULT 0                     NOT NULL,
  EXT_PRESCRIBER_IDENT          VARCHAR2(200 BYTE),
  EXT_PRESCRIBER_IDENT_TYPE_CD  NUMBER          DEFAULT 0                     NOT NULL,
  PRESCRIPTION_HEALTH_PLAN_ID   NUMBER          DEFAULT 0                     NOT NULL,
  EXT_PRODUCT_IDENT             VARCHAR2(50 BYTE),
  EXT_PRODUCT_IDENT_TYPE_CD     NUMBER          DEFAULT 0                     NOT NULL,
  PRODUCT_DOSE_TXT              VARCHAR2(100 BYTE),
  EXT_PHARMACY_IDENT            VARCHAR2(50 BYTE),
  EXT_PHARMACY_IDENT_TYPE_CD    NUMBER          DEFAULT 0                     NOT NULL,
  WRITTEN_DT_TM                 DATE,
  LAST_FILL_DT_TM               DATE,
  DAYS_SUPPLY_QTY               FLOAT(126),
  OBTAINED_DT_TM                DATE,
  REFILL_NBR_NOT_APPLIED_IND    NUMBER          DEFAULT 0                     NOT NULL,
  RECEIVED_QTY_TXT              VARCHAR2(50 BYTE),
  REMAINING_REFILLS_TXT         VARCHAR2(50 BYTE),
  ORIGINAL_REFILLS_TXT          VARCHAR2(50 BYTE),
  DOSAGE_INSTRUCTIONS           VARCHAR2(160 BYTE),
  RECEIVED_QTY_UNIT_CD          NUMBER          DEFAULT 0,
  PRN_REFILL_FLAG               NUMBER          DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE GS_MED_CLAIM_ALIAS
(
  GS_MED_CLAIM_ALIAS_ID           NUMBER        DEFAULT 0                     NOT NULL,
  GS_MED_CLAIM_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD           NUMBER        DEFAULT 0                     NOT NULL,
  ALIAS                           VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  GS_MED_CLAIM_ALIAS_TYPE_CD      NUMBER        DEFAULT 0                     NOT NULL,
  ALIAS_POOL_CD                   NUMBER        DEFAULT 0                     NOT NULL,
  ACTIVE_IND                      NUMBER        DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD                NUMBER        DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM             DATE          DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID          NUMBER        DEFAULT 0                     NOT NULL,
  ASSIGN_AUTHORITY_SYS_CD         NUMBER        DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM             DATE          DEFAULT SYSDATE               NOT NULL,
  CHECK_DIGIT                     NUMBER        DEFAULT 0                     NOT NULL,
  CHECK_DIGIT_METHOD_CD           NUMBER        DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM             DATE,
  DATA_STATUS_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  DATA_STATUS_PRSNL_ID            NUMBER        DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM               DATE,
  GS_MED_CLAIM_ALIAS_SUB_TYPE_CD  NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HANDHELD_DETAIL
(
  HANDHELD_DETAIL_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  HANDHELD_UPLOAD_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  ACCESSION             VARCHAR2(20 BYTE),
  ALIAS1                VARCHAR2(200 BYTE),
  PERSON1_ID            NUMBER                  DEFAULT 0                     NOT NULL,
  ENCNTR1_ID            NUMBER                  DEFAULT 0                     NOT NULL,
  BARCODE_ALIAS1        VARCHAR2(200 BYTE),
  ALIAS2                VARCHAR2(200 BYTE),
  PERSON2_ID            NUMBER                  DEFAULT 0                     NOT NULL,
  ENCNTR2_ID            NUMBER                  DEFAULT 0                     NOT NULL,
  BARCODE_ALIAS2        VARCHAR2(200 BYTE),
  CONTAINER_ID          NUMBER                  DEFAULT 0                     NOT NULL,
  CONTAINER_NBR         NUMBER,
  ORDER_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  COLLECTION_STATUS_CD  NUMBER                  DEFAULT 0                     NOT NULL,
  COLLECTION_DT_TM      DATE,
  COLLECTION_METHOD_CD  NUMBER                  DEFAULT 0                     NOT NULL,
  ERROR_CD              NUMBER                  DEFAULT 0                     NOT NULL,
  OVERRIDE_IND          NUMBER,
  MISSED_REASON_CD      NUMBER                  DEFAULT 0                     NOT NULL,
  CANCEL_REASON_CD      NUMBER                  DEFAULT 0                     NOT NULL,
  COLLECTION_COMMENT    VARCHAR2(200 BYTE),
  RECEIVED_PRSNL_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  COLLECTION_PRSNL_ID   NUMBER                  DEFAULT 0                     NOT NULL,
  RECEIVED_DT_TM        DATE,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HANDHELD_UPLOAD
(
  HANDHELD_UPLOAD_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  HANDHELD_SESSION_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  UPLOAD_DT_TM         DATE,
  REPORT_NBR           NUMBER                   DEFAULT 0                     NOT NULL,
  DEVICE_DT_TM         DATE,
  LOGIN_LOCATION_CD    NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HAPLOTYPE_CHART
(
  HAPLOTYPE_CHART_ID        NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  HAPLOTYPE                 VARCHAR2(255 BYTE),
  PARENTAL_IND              NUMBER,
  PATERNAL_DEDUCED_IND      NUMBER,
  MATERNAL_DEDUCED_IND      NUMBER,
  COMMENT_LONG_TEXT_ID      NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  HAPLOTYPE2                VARCHAR2(255 BYTE),
  HAPLOTYPE2_ASSIGNMENT_CD  NUMBER              DEFAULT 0                     NOT NULL,
  HAPLOTYPE_ASSIGNMENT_CD   NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HAPLOTYPE_DONOR
(
  HAPLOTYPE_DONOR_ID        NUMBER              DEFAULT 0                     NOT NULL,
  HAPLOTYPE_CHART_ID        NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  HAPLOTYPE                 VARCHAR2(255 BYTE),
  CREATED_DT_TM             DATE,
  REMOVED_DT_TM             DATE,
  REMOVED_IND               NUMBER,
  COMMENT_LONG_TEXT_ID      NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  HAPLOTYPE2                VARCHAR2(255 BYTE),
  HAPLOTYPE2_ASSIGNMENT_CD  NUMBER              DEFAULT 0                     NOT NULL,
  HAPLOTYPE_ASSIGNMENT_CD   NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HEALTH_PLAN
(
  HEALTH_PLAN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  PLAN_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  PLAN_NAME               VARCHAR2(100 BYTE),
  PLAN_DESC               VARCHAR2(255 BYTE),
  FINANCIAL_CLASS_CD      NUMBER                DEFAULT 0                     NOT NULL,
  FT_ENTITY_NAME          VARCHAR2(32 BYTE),
  FT_ENTITY_ID            NUMBER                DEFAULT 0                     NOT NULL,
  BABY_COVERAGE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  COMB_BABY_BILL_CD       NUMBER                DEFAULT 0                     NOT NULL,
  PLAN_CLASS_CD           NUMBER                DEFAULT 0                     NOT NULL,
  GROUP_NBR               VARCHAR2(100 BYTE),
  GROUP_NAME              VARCHAR2(200 BYTE),
  POLICY_NBR              VARCHAR2(100 BYTE),
  PLAN_NAME_KEY           CHAR(100 BYTE),
  PLAN_NAME_KEY_NLS       VARCHAR2(202 BYTE),
  PAT_BILL_PREF_FLAG      NUMBER                DEFAULT 0                     NOT NULL,
  PRI_CONCURRENT_IND      NUMBER                DEFAULT 0                     NOT NULL,
  SEC_CONCURRENT_IND      NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_CD              NUMBER                DEFAULT 0                     NOT NULL,
  BENEFIT_SET_NAME        VARCHAR2(255 BYTE),
  LOGICAL_DOMAIN_ID       NUMBER                DEFAULT 0,
  FB_BENEFIT_SET_UID      VARCHAR2(255 BYTE)    DEFAULT ' ',
  SERVICE_TYPE_CD         NUMBER                DEFAULT 0,
  PLAN_NAME_KEY_A_NLS     VARCHAR2(400 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HEALTH_PLAN_ALIAS
(
  HEALTH_PLAN_ALIAS_ID    NUMBER                DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ALIAS_POOL_CD           NUMBER                DEFAULT 0                     NOT NULL,
  ALIAS                   VARCHAR2(100 BYTE),
  CHECK_DIGIT             NUMBER,
  CHECK_DIGIT_METHOD_CD   NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  PLAN_ALIAS_TYPE_CD      NUMBER                DEFAULT 0                     NOT NULL,
  PLAN_ALIAS_SUB_TYPE_CD  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HEALTH_PLAN_INFO
(
  HEALTH_PLAN_INFO_ID     NUMBER                DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  HP_INFO_TYPE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  HP_INFO_SUB_TYPE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_NUMERIC           NUMBER,
  VALUE_DT_TM             DATE,
  CHARTABLE_IND           NUMBER,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HEA_CLAIM_VISIT
(
  HEA_CLAIM_VISIT_ID      NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CLAIM_IDENTIFIER        VARCHAR2(100 BYTE)    DEFAULT ' '                   NOT NULL,
  CLAIM_COUNT             NUMBER                DEFAULT 0                     NOT NULL,
  VISIT_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  START_SERVICE_DT_TM     DATE,
  END_SERVICE_DT_TM       DATE,
  ATTENDING_PERSON_ID     NUMBER                DEFAULT 0                     NOT NULL,
  ADMITTING_PERSON_ID     NUMBER                DEFAULT 0                     NOT NULL,
  PROCEDURE1_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PROCEDURE2_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PROCEDURE3_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PROCEDURE4_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PROCEDURE5_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PROCEDURE6_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PROCEDURE7_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PROCEDURE8_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PROCEDURE9_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PROCEDURE10_ID          NUMBER                DEFAULT 0                     NOT NULL,
  DIAGNOSIS1_ID           NUMBER                DEFAULT 0                     NOT NULL,
  DIAGNOSIS2_ID           NUMBER                DEFAULT 0                     NOT NULL,
  DIAGNOSIS3_ID           NUMBER                DEFAULT 0                     NOT NULL,
  DIAGNOSIS4_ID           NUMBER                DEFAULT 0                     NOT NULL,
  DIAGNOSIS5_ID           NUMBER                DEFAULT 0                     NOT NULL,
  DIAGNOSIS6_ID           NUMBER                DEFAULT 0                     NOT NULL,
  DIAGNOSIS7_ID           NUMBER                DEFAULT 0                     NOT NULL,
  DIAGNOSIS8_ID           NUMBER                DEFAULT 0                     NOT NULL,
  DIAGNOSIS9_ID           NUMBER                DEFAULT 0                     NOT NULL,
  DIAGNOSIS10_ID          NUMBER                DEFAULT 0                     NOT NULL,
  DIAGNOSIS11_ID          NUMBER                DEFAULT 0                     NOT NULL,
  DIAGNOSIS12_ID          NUMBER                DEFAULT 0                     NOT NULL,
  DIAGNOSIS13_ID          NUMBER                DEFAULT 0                     NOT NULL,
  DIAGNOSIS14_ID          NUMBER                DEFAULT 0                     NOT NULL,
  DIAGNOSIS15_ID          NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_PROVIDER_ID     NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_FACILITY_CD     NUMBER                DEFAULT 0                     NOT NULL,
  BILLING_ORG_ID          NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE                  DEFAULT SYSDATE               NOT NULL,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HEA_CLAIM_VISIT_DETAIL
(
  HEA_CLAIM_VISIT_DETAIL_ID  NUMBER             DEFAULT 0                     NOT NULL,
  HEA_CLAIM_VISIT_ID         NUMBER             DEFAULT 0                     NOT NULL,
  CLAIM_COUNT                NUMBER             DEFAULT 0                     NOT NULL,
  SEQ_NUM                    NUMBER             DEFAULT 0                     NOT NULL,
  REVENUE_CODE               VARCHAR2(4 BYTE)   DEFAULT ' '                   NOT NULL,
  HCPCS_CPT_ID               NUMBER             DEFAULT 0                     NOT NULL,
  SERVICE_DT_TM              DATE,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID     NUMBER             DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM        DATE,
  END_EFFECTIVE_DT_TM        DATE,
  DATA_STATUS_CD             NUMBER             DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM          DATE               DEFAULT SYSDATE               NOT NULL,
  DATA_STATUS_PRSNL_ID       NUMBER             DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD      NUMBER             DEFAULT 0                     NOT NULL,
  REVENUE_CD                 NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HIM_EVENT_ALLOCATION
(
  HIM_EVENT_ALLOCATION_ID  NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  PRSNL_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_CD                 NUMBER               DEFAULT 0                     NOT NULL,
  ACTION_TYPE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  REQUEST_DT_TM            DATE,
  COMPLETED_DT_TM          DATE,
  ALLOCATION_DT_TM         DATE,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  ACTION_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HIM_EVENT_EXTENSION
(
  EVENT_CD                       NUMBER         DEFAULT 0                     NOT NULL,
  DOCUMENT_DISPLAY_ORDER         NUMBER,
  SIGNATURE_REQUIRED_IND         NUMBER,
  MATCHING_PHYSICIAN_IND         NUMBER,
  DICTATION_TURNAROUND_TIME      NUMBER,
  TRANSCRIPTION_TURNAROUND_TIME  NUMBER,
  SIGNATURE_TURNAROUND_TIME      NUMBER,
  DICTATION_DELINQUENCY_TIME     NUMBER,
  SIGNATURE_DELINQUENCY_TIME     NUMBER,
  MULTIPLE_EVENT_FLAG            NUMBER,
  COSIGN_IND                     NUMBER,
  COSIGN_PRSNL_TYPE_CD           NUMBER         DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM            DATE,
  END_EFFECTIVE_DT_TM            DATE,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVE_IND                     NUMBER,
  ACTIVE_STATUS_CD               NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM            DATE,
  ACTIVE_STATUS_PRSNL_ID         NUMBER         DEFAULT 0                     NOT NULL,
  SERV_RES_CD                    NUMBER         DEFAULT 0                     NOT NULL,
  TRAN_TIME_IND                  NUMBER,
  ORGANIZATION_ID                NUMBER         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HIM_LETTERS_TEMP
(
  HIM_LETTERS_TEMP_ID     NUMBER                DEFAULT 0                     NOT NULL,
  BATCH_NBR               NUMBER,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_ID                NUMBER                DEFAULT 0                     NOT NULL,
  AGE                     NUMBER,
  BEG_EFFECTIVE_DT_TM     DATE,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE         NUMBER                DEFAULT 0,
  ORDER_ID                NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HIM_PV_CHART
(
  HIM_PV_CHART_ID          NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  SEX_CD                   NUMBER               DEFAULT 0                     NOT NULL,
  BIRTH_DT_TM              DATE,
  ENCNTR_TYPE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  MED_SERVICE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  FINANCIAL_CLASS_CD       NUMBER               DEFAULT 0                     NOT NULL,
  REG_DT_TM                DATE,
  DISCH_DT_TM              DATE,
  ALLOCATION_DT_TM         DATE,
  ALLOCATION_DT_FLAG       NUMBER,
  ALLOCATION_DT_MODIFIER   NUMBER,
  CHART_STATUS_CD          NUMBER               DEFAULT 0                     NOT NULL,
  DEFICIENCY_IND           NUMBER,
  CHART_AGE                NUMBER,
  DELINQUENT_IND           NUMBER,
  CURRENT_LOC_CD           NUMBER               DEFAULT 0                     NOT NULL,
  MEDIA_TYPE_CD            NUMBER               DEFAULT 0                     NOT NULL,
  VOLUME_NBR               NUMBER,
  SUSPENDED_IND            NUMBER,
  TRACKING_ID              VARCHAR2(35 BYTE)    DEFAULT '0',
  ORG_NAME                 VARCHAR2(100 BYTE),
  ADMITTING_PERSON_ID      FLOAT(126)           DEFAULT 0                     NOT NULL,
  ATTENDING_PERSON_ID      FLOAT(126)           DEFAULT 0                     NOT NULL,
  DEF_ALLOCATION_DATE_IND  NUMBER,
  ORGANIZATION_ID          FLOAT(126)           DEFAULT 0                     NOT NULL,
  MEDIA_MASTER_ID          NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HIM_PV_DOCUMENT
(
  HIM_PV_DOCUMENT_ID      NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_GROUP_NAME        VARCHAR2(255 BYTE),
  ACTION_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ACTION_TYPE_CD          NUMBER                DEFAULT 0                     NOT NULL,
  ACTION_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  REQUEST_DT_TM           DATE,
  REQUEST_PRSNL_ID        NUMBER                DEFAULT 0                     NOT NULL,
  REQUEST_PRSNL_FT        VARCHAR2(255 BYTE),
  EVENT_CD                NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_ID                NUMBER                DEFAULT 0                     NOT NULL,
  VALID_UNTIL_DT_TM       DATE                  DEFAULT SYSDATE               NOT NULL,
  VIEW_LEVEL              NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_EVENT_ID         NUMBER                DEFAULT 0                     NOT NULL,
  VALID_FROM_DT_TM        DATE                  DEFAULT SYSDATE               NOT NULL,
  PUBLISH_FLAG            NUMBER                DEFAULT 0                     NOT NULL,
  STORAGE_CD              NUMBER                DEFAULT 0                     NOT NULL,
  PROFILE_STATUS          VARCHAR2(25 BYTE),
  PROFILE_STATUS_CD       NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ALIAS             VARCHAR2(25 BYTE),
  ORG_NAME                VARCHAR2(100 BYTE),
  EVENT_END_DT_TM         DATE,
  ORGANIZATION_ID         FLOAT(126)            DEFAULT 0                     NOT NULL,
  CHART_AGE               NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_ALLOCATION_DT_TM  DATE,
  PRSNL_POSITION_DESC     VARCHAR2(40 BYTE),
  EVENT_END_TZ            NUMBER                DEFAULT 0,
  REQUEST_TZ              NUMBER                DEFAULT 0,
  RESULT_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  POSITION_CD             NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HIM_PV_PHYSICIAN
(
  HIM_PV_PHYSICIAN_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  ENCNTR_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  ALIAS                VARCHAR2(200 BYTE),
  CHART_AGE            NUMBER,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_POSITION_DESC  VARCHAR2(40 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HIM_REQUEST
(
  HIM_REQUEST_ID           NUMBER               DEFAULT 0                     NOT NULL,
  REQUEST_TYPE_CD          NUMBER               DEFAULT 0                     NOT NULL,
  REQUEST_STATUS_CD        NUMBER               DEFAULT 0                     NOT NULL,
  REQUEST_STATUS_DT_TM     DATE,
  REQUEST_STATUS_PRSNL_ID  NUMBER               DEFAULT 0                     NOT NULL,
  REQUESTER_ID             NUMBER               DEFAULT 0                     NOT NULL,
  REQUEST_NUMBER           NUMBER,
  REQUEST_DT_TM            DATE,
  REQUIRED_DT_TM           DATE,
  REQUEST_NUMBER_POOL_CD   NUMBER               DEFAULT 0                     NOT NULL,
  TO_LOCATION_CD           NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE,
  END_EFFECTIVE_DT_TM      DATE,
  CREATE_PRSNL_ID          NUMBER               DEFAULT 0                     NOT NULL,
  LAST_UPDATE_PRSNL_ID     NUMBER               DEFAULT 0                     NOT NULL,
  CANCEL_PRSNL_ID          NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  PHONE_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD    NUMBER               DEFAULT 0                     NOT NULL,
  PULL_LIST_PRINTED_IND    NUMBER,
  PULL_LIST_PRINTED_DT_TM  DATE,
  LOCKED_IND               NUMBER,
  ORGANIZATION_ID          NUMBER               DEFAULT 0                     NOT NULL,
  ROI_REQUESTER_ID         NUMBER               DEFAULT 0                     NOT NULL,
  SCH_EVENT_ID             NUMBER               DEFAULT 0                     NOT NULL,
  ONSITE_IND               NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HIM_REQUEST_CRITERIA
(
  HIM_REQUEST_CRITERIA_ID   NUMBER              DEFAULT 0                     NOT NULL,
  HIM_REQUEST_ID            NUMBER              DEFAULT 0,
  PERSON_ID                 NUMBER              DEFAULT 0,
  ENCNTR_ID                 NUMBER              DEFAULT 0,
  CRITERIA_STATUS_CD        NUMBER              DEFAULT 0,
  CRITERIA_STATUS_DT_TM     DATE,
  CRITERIA_STATUS_PRSNL_ID  NUMBER              DEFAULT 0,
  BEG_EFFECTIVE_DT_TM       DATE,
  END_EFFECTIVE_DT_TM       DATE,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0,
  CRITERIA_TYPE_CD          NUMBER              DEFAULT 0,
  EVENT_ID                  NUMBER              DEFAULT 0,
  MEDIA_MASTER_ID           NUMBER              DEFAULT 0,
  PAPER_TYPE_CD             NUMBER              DEFAULT 0,
  HIM_REQUEST_PATIENT_ID    NUMBER              DEFAULT 0,
  PAPER_EVENT_DISPLAY_KEY   VARCHAR2(100 BYTE),
  MRP_SELECTED_IND          NUMBER              DEFAULT 0,
  PAPER_DOCUMENT_COMMENT    VARCHAR2(255 BYTE),
  DOCUMENT_STATUS_FLAG      NUMBER              DEFAULT 0,
  LONG_TEXT_ID              NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HIM_REQUEST_PATIENT
(
  HIM_REQUEST_PATIENT_ID       NUMBER           DEFAULT 0                     NOT NULL,
  HIM_REQUEST_ID               NUMBER           DEFAULT 0                     NOT NULL,
  REQUEST_STATUS_CD            NUMBER           DEFAULT 0                     NOT NULL,
  REQUEST_STATUS_DT_TM         DATE,
  REQUEST_STATUS_PRSNL_ID      NUMBER           DEFAULT 0                     NOT NULL,
  APPROVAL_IND                 NUMBER,
  BEG_EFFECTIVE_DT_TM          DATE,
  END_EFFECTIVE_DT_TM          DATE,
  PERSON_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  CREATE_PRSNL_ID              NUMBER           DEFAULT 0                     NOT NULL,
  LAST_UPDATE_PRSNL_ID         NUMBER           DEFAULT 0                     NOT NULL,
  CANCEL_PRSNL_ID              NUMBER           DEFAULT 0                     NOT NULL,
  REJECTED_REASON_CD           NUMBER           DEFAULT 0                     NOT NULL,
  AUTHORIZED_IND               NUMBER,
  AUTHORIZED_REJECT_REASON_CD  NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HIM_REQUEST_TEMPLATE_R
(
  HIM_REQUEST_TEMPLATE_R_ID  NUMBER             DEFAULT 0                     NOT NULL,
  TEMPLATE_ID                NUMBER             DEFAULT 0                     NOT NULL,
  REQUEST_TYPE_CD            NUMBER             DEFAULT 0                     NOT NULL,
  REQUEST_STATUS_CD          NUMBER             DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM        DATE               DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM        DATE               DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS'),
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  LETTER_TYPE_CD             NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HIM_RESTRICT_VIEW_HIST
(
  HIM_RESTRICT_VIEW_HIST_ID  NUMBER             DEFAULT 0                     NOT NULL,
  HIM_REQUEST_ID             NUMBER             DEFAULT 0                     NOT NULL,
  VIEW_PRSNL_ID              NUMBER             DEFAULT 0                     NOT NULL,
  VIEW_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  OVERRIDE_PRSNL_ID          NUMBER             DEFAULT 0                     NOT NULL,
  OVERRIDE_DT_TM             DATE,
  OVERRIDE_COMMENT           VARCHAR2(255 BYTE),
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  HIM_REQUEST_PATIENT_ID     NUMBER             DEFAULT 0                     NOT NULL,
  VIEW_STATUS_FLAG           NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HIM_TEMP_REQUEST_LOG
(
  HIM_TEMP_REQUEST_LOG_ID  NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  TABLE_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  SOURCE_FLAG              NUMBER               DEFAULT 0                     NOT NULL,
  REQUEST_NBR              NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HISTORY_ACTION
(
  HISTORY_ACTION_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  PRSNL_ID           NUMBER                     DEFAULT 0                     NOT NULL,
  PERSON_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  ACTION_DT_TM       DATE                       DEFAULT SYSDATE               NOT NULL,
  ACTION_DT_TZ       NUMBER                     DEFAULT 0                     NOT NULL,
  COMP_TYPE_MEAN     VARCHAR2(12 BYTE)          DEFAULT ' '                   NOT NULL,
  VIEW_TYPE_MEAN     VARCHAR2(12 BYTE)          DEFAULT ' '                   NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  ENCNTR_ID          NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_AB_SCREEN_RESULT
(
  ORDER_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  BATCH_NUMBER          NUMBER                  DEFAULT 0,
  BATCH_TRAY_NUMBER     NUMBER                  DEFAULT 0                     NOT NULL,
  BATCH_X_POS           NUMBER                  DEFAULT 0                     NOT NULL,
  BATCH_Y_POS           NUMBER                  DEFAULT 0                     NOT NULL,
  T_CELL_PRA            FLOAT(126),
  B_CELL_PRA            FLOAT(126),
  METHODOLOGY_CD        NUMBER                  DEFAULT 0                     NOT NULL,
  DILUTION_CD           NUMBER                  DEFAULT 0                     NOT NULL,
  COMMENT_LONG_TEXT_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  COMPLEMENT            VARCHAR2(20 BYTE),
  PLATED_PRSNL_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  READ_PRSNL_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  VIABILITY             NUMBER,
  BATCH_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  PLATED_DT_TM          DATE,
  READ_DT_TM            DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_AB_SCREEN_WELL_SCORE
(
  ORDER_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  BATCH_NUMBER          NUMBER                  DEFAULT 0,
  TRAY_NUMBER           NUMBER                  DEFAULT 0                     NOT NULL,
  X_POS                 NUMBER                  DEFAULT 0                     NOT NULL,
  Y_POS                 NUMBER                  DEFAULT 0                     NOT NULL,
  T_CELL_WELL_SCORE_CD  NUMBER                  DEFAULT 0                     NOT NULL,
  B_CELL_WELL_SCORE_CD  NUMBER                  DEFAULT 0                     NOT NULL,
  FALSE_POS_IND         NUMBER,
  FALSE_NEG_IND         NUMBER,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  BATCH_ID              NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_SCREEN_ANALYSIS
(
  CRITERIA_ID                NUMBER             DEFAULT 0                     NOT NULL,
  CROSS_SPECIMEN_ID          NUMBER             DEFAULT 0                     NOT NULL,
  BATCH_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  REMOVE_PERSON_ANTIGEN_IND  NUMBER             DEFAULT 0                     NOT NULL,
  POSITIVE_DEFINITION_CD     NUMBER             DEFAULT 0                     NOT NULL,
  CUTOFF_VALUE               FLOAT(126)         DEFAULT 0                     NOT NULL,
  CUTOFF_TYPE_FLAG           NUMBER             DEFAULT 0                     NOT NULL,
  ANALYSIS_DT_TM             DATE               DEFAULT SYSDATE               NOT NULL,
  ANALYSIS_DESC              VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_SCREEN_ANALYSIS_DETAIL
(
  SCREEN_ANALYSIS_DETAIL_ID  NUMBER             DEFAULT 0                     NOT NULL,
  CRITERIA_ID                NUMBER             DEFAULT 0                     NOT NULL,
  TCELL_LOCI_CD              NUMBER             DEFAULT 0                     NOT NULL,
  BCELL_LOCI_CD              NUMBER             DEFAULT 0                     NOT NULL,
  ANTIGEN_CD                 NUMBER             DEFAULT 0                     NOT NULL,
  CREG_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_SERA_QUERY_AB
(
  SERA_QUERY_SERUM_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  AB_SEQ               NUMBER                   DEFAULT 0                     NOT NULL,
  REACTION             CHAR(40 BYTE),
  T_CELL_PRA           FLOAT(126),
  B_CELL_PRA           FLOAT(126),
  METHODOLOGY          CHAR(40 BYTE),
  DILUTION             CHAR(40 BYTE),
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  OD_RATIO_VALUE       NUMBER                   DEFAULT -1,
  OD_VALUE             NUMBER                   DEFAULT -1,
  ANTIBODIES_LIST_TXT  VARCHAR2(4000 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_SERA_QUERY_R
(
  SERA_QUERY_QUERIES_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  SERA_QUERY_SERUM_ID    NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_SERA_QUERY_SERUM
(
  SERA_QUERY_SERUM_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  SERA_QUERY_ID        NUMBER                   DEFAULT 0                     NOT NULL,
  NAME_FULL_FORMATTED  VARCHAR2(100 BYTE),
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  MRN                  VARCHAR2(200 BYTE),
  UNOS                 VARCHAR2(200 BYTE),
  NMDP                 VARCHAR2(200 BYTE),
  RECIPIENT_STATUS     VARCHAR2(255 BYTE),
  ABORH                CHAR(80 BYTE),
  ACCESSION            CHAR(20 BYTE),
  FMT_ACCESSION        CHAR(40 BYTE),
  ORDER_MNEMONIC       VARCHAR2(100 BYTE),
  ORDER_STATUS         CHAR(40 BYTE),
  ORDER_DT_TM          DATE,
  ORDER_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  HLA_AB_SCREEN_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  ANTIBODIES           VARCHAR2(100 BYTE),
  LOCATION             VARCHAR2(255 BYTE),
  SERUM_QUERY_INFO     VARCHAR2(255 BYTE),
  REMOVED_IND          NUMBER,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  TRANSPLANT_CENTER    VARCHAR2(255 BYTE),
  POSSIBLE_AB_STRING   VARCHAR2(255 BYTE),
  HIC                  VARCHAR2(200 BYTE),
  OPO                  VARCHAR2(200 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_TYP_RES_TRAY
(
  ORDER_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  LOT_NUMBER_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  COMMENT_LONG_TEXT_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  COMPLEMENT            VARCHAR2(20 BYTE),
  MAGNETIC_BEADS        VARCHAR2(20 BYTE),
  PLATED_PRSNL_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  READ_PRSNL_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  SEPARATED_PRSNL_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  VIABILITY             NUMBER,
  PLATED_DT_TM          DATE,
  READ_DT_TM            DATE,
  SEPARATED_DT_TM       DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_TYP_TRAY_WELL_SCORE
(
  ORDER_ID       NUMBER                         DEFAULT 0                     NOT NULL,
  LOT_NUMBER_ID  NUMBER                         DEFAULT 0                     NOT NULL,
  X_POS          NUMBER                         DEFAULT 0                     NOT NULL,
  Y_POS          NUMBER                         DEFAULT 0                     NOT NULL,
  WELL_SCORE_CD  NUMBER                         DEFAULT 0                     NOT NULL,
  FALSE_POS_IND  NUMBER,
  FALSE_NEG_IND  NUMBER,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_XM_RES_TRAY
(
  HLA_XM_RES_TRAY_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  WORKLIST_ID           NUMBER                  DEFAULT 0                     NOT NULL,
  LOT_NUMBER_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  DONOR_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  BATCH_DESC            VARCHAR2(30 BYTE),
  COMMENT_LONG_TEXT_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  VIABILITY             NUMBER,
  COMPLEMENT            VARCHAR2(20 BYTE),
  MAGNETIC_BEADS        VARCHAR2(20 BYTE),
  SEPARATED_PRSNL_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  PLATED_PRSNL_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  READ_PRSNL_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  ORDER_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  SEPARATED_DT_TM       DATE,
  PLATED_DT_TM          DATE,
  READ_DT_TM            DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_XM_TRAY_WELL
(
  LOT_NUMBER_ID     NUMBER                      DEFAULT 0                     NOT NULL,
  TRAY_NUMBER       NUMBER                      DEFAULT 0                     NOT NULL,
  X_POS             NUMBER                      DEFAULT 0                     NOT NULL,
  Y_POS             NUMBER                      DEFAULT 0                     NOT NULL,
  METHODOLOGY_CD    NUMBER                      DEFAULT 0                     NOT NULL,
  DILUTION_CD       NUMBER                      DEFAULT 0                     NOT NULL,
  ORDER_ID          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  HLA_AB_SCREEN_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  QC_ACCESSION_ID   NUMBER                      DEFAULT 0                     NOT NULL,
  LOT_ID            NUMBER                      DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_XM_TRAY_WELL_SCORE
(
  HLA_XM_RES_TRAY_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  TRAY_NUMBER         NUMBER                    DEFAULT 0                     NOT NULL,
  X_POS               NUMBER                    DEFAULT 0                     NOT NULL,
  Y_POS               NUMBER                    DEFAULT 0                     NOT NULL,
  METHODOLOGY_CD      NUMBER                    DEFAULT 0                     NOT NULL,
  DILUTION_CD         NUMBER                    DEFAULT 0                     NOT NULL,
  ORDER_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  WELL_SCORE_CD       NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  HLA_AB_SCREEN_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  QC_ACCESSION_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  LOT_ID              NUMBER                    DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_X_SPECIMEN_ANALYSIS
(
  CROSS_SPECIMEN_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  PERSON_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  CROSS_SPECIMEN_DT_TM  DATE                    DEFAULT SYSDATE               NOT NULL,
  CROSS_SPECIMEN_DESC   VARCHAR2(250 BYTE)      DEFAULT ' '                   NOT NULL,
  POSSIBLE_ABS          VARCHAR2(250 BYTE)      DEFAULT ' '                   NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HLA_X_SPECIMEN_DETAIL
(
  CROSS_SPECIMEN_DETAIL_ID  NUMBER              DEFAULT 0                     NOT NULL,
  CROSS_SPECIMEN_ID         NUMBER              DEFAULT 0                     NOT NULL,
  BATCH_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  ORDER_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HM_EXPECT_MOD
(
  EXPECT_MOD_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(30 BYTE)     DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  MODIFIER_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  MODIFIER_REASON_CD      NUMBER                DEFAULT 0                     NOT NULL,
  MODIFIER_DT_TM          DATE                  DEFAULT SYSDATE               NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  LAST_ACTION_SEQ         NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  SAT_PRSNL_ID            NUMBER                DEFAULT 0                     NOT NULL,
  STATUS_IND              NUMBER                DEFAULT 1                     NOT NULL,
  STATUS_DT_TM            DATE                  DEFAULT SYSDATE               NOT NULL,
  STATUS_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  EXPECT_SAT_ID           NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HM_EXPECT_MOD_HIST
(
  EXPECT_MOD_ID             NUMBER              DEFAULT 0                     NOT NULL,
  ACTION_SEQ                NUMBER              DEFAULT 0                     NOT NULL,
  ACTION_TYPE_FLAG          NUMBER              DEFAULT 1                     NOT NULL,
  ACTION_DT_TM              DATE                DEFAULT SYSDATE               NOT NULL,
  PERSON_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME        VARCHAR2(30 BYTE)   DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID          NUMBER              DEFAULT 0                     NOT NULL,
  MODIFIER_TYPE_CD          NUMBER              DEFAULT 0                     NOT NULL,
  MODIFIER_REASON_CD        NUMBER              DEFAULT 0                     NOT NULL,
  MODIFIER_DT_TM            DATE                DEFAULT SYSDATE               NOT NULL,
  LONG_TEXT_ID              NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE,
  END_EFFECTIVE_DT_TM       DATE,
  ACTIVE_IND                NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  SAT_PRSNL_ID              NUMBER              DEFAULT 0                     NOT NULL,
  STATUS_IND                NUMBER              DEFAULT 1                     NOT NULL,
  STATUS_DT_TM              DATE                DEFAULT SYSDATE               NOT NULL,
  STATUS_PRSNL_ID           NUMBER              DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID           NUMBER              DEFAULT 0                     NOT NULL,
  EXPECT_SAT_ID             NUMBER              DEFAULT 0,
  RECOMMENDATION_ACTION_ID  NUMBER              DEFAULT 0,
  MIGRATED_FLAG             NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HM_EXPECT_SCHED_PERSON_R
(
  EXPECT_SCHED_PERSON_R_ID  NUMBER              DEFAULT 0                     NOT NULL,
  EXPECT_SCHED_ID           NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID              NUMBER              DEFAULT 0                     NOT NULL,
  STATUS_FLAG               NUMBER              DEFAULT 1                     NOT NULL,
  STATUS_DT_TM              DATE                DEFAULT SYSDATE               NOT NULL,
  SCHED_MODE_FLAG           NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE,
  END_EFFECTIVE_DT_TM       DATE,
  ACTIVE_IND                NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  SCHED_PERSON_NBR          FLOAT(126)          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HM_RECOMMENDATION
(
  RECOMMENDATION_ID               NUMBER        DEFAULT 0                     NOT NULL,
  PERSON_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  EXPECT_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  STATUS_FLAG                     NUMBER        DEFAULT 0                     NOT NULL,
  DUE_DT_TM                       DATE,
  FIRST_DUE_DT_TM                 DATE,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  STEP_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  LAST_SATISFIED_BY_ID            NUMBER        DEFAULT 0,
  LAST_SATISFACTION_DT_TM         DATE,
  OVERDUE_DT_TM                   DATE,
  QUALIFIED_DT_TM                 DATE          DEFAULT SYSDATE               NOT NULL,
  LAST_SATISFACTION_SOURCE        VARCHAR2(30 BYTE) DEFAULT ' ',
  FREQUENCY_VAL                   NUMBER        DEFAULT 0,
  FREQUENCY_UNIT_CD               NUMBER        DEFAULT 0,
  FREQUENCY_OVERRIDE_ACTION_ID    NUMBER        DEFAULT 0,
  DUE_OVERRIDE_ACTION_ID          NUMBER        DEFAULT 0,
  ASSIGNED_BY_PRSNL_ID            NUMBER        DEFAULT 0                     NOT NULL,
  EXPECTATION_FTDESC              VARCHAR2(255 BYTE),
  LAST_SATISFACTION_ID            NUMBER        DEFAULT 0,
  EXPIRE_DT_TM                    DATE,
  NEAR_DUE_DT_TM                  DATE,
  SYSTEM_FREQ_VAL                 NUMBER        DEFAULT 0,
  VERIFICATION_VERSION_NBR        NUMBER        DEFAULT 0,
  SYSTEM_FREQ_OVERRIDE_ACTION_ID  NUMBER        DEFAULT 0,
  SYSTEM_FREQ_UNIT_CD             NUMBER        DEFAULT 0,
  EXPECTATION_NAME_CD             NUMBER        DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HM_RECOMMENDATION_ACTION
(
  RECOMMENDATION_ACTION_ID      NUMBER          DEFAULT 0                     NOT NULL,
  RECOMMENDATION_ID             NUMBER          DEFAULT 0                     NOT NULL,
  ACTION_FLAG                   NUMBER          DEFAULT 0                     NOT NULL,
  REASON_CD                     NUMBER          DEFAULT 0                     NOT NULL,
  ON_BEHALF_OF_PRSNL_ID         NUMBER          DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  SATISFACTION_ID               NUMBER          DEFAULT 0                     NOT NULL,
  SATISFACTION_SOURCE           VARCHAR2(30 BYTE) DEFAULT ' ' NOT NULL,
  ACTION_DT_TM                  DATE,
  RECORD_NUMBER                 NUMBER          DEFAULT 0                     NOT NULL,
  DUE_DT_TM                     DATE,
  FREQUENCY_VAL                 NUMBER          DEFAULT 0,
  FREQUENCY_UNIT_CD             NUMBER          DEFAULT 0,
  FREQUENCY_OVERRIDE_ACTION_ID  NUMBER          DEFAULT 0,
  QUALIFY_AGE                   NUMBER          DEFAULT 0,
  QUALIFY_AGE_UNIT_CD           NUMBER          DEFAULT 0,
  EXPECTATION_FTDESC            VARCHAR2(255 BYTE),
  PREV_FREQUENCY_UNIT_CD        NUMBER          DEFAULT 0,
  PREV_DUE_DT_TM                DATE,
  OVERRIDE_IND                  NUMBER          DEFAULT 0,
  QUALIFIED_DT_TM               DATE,
  EXPIRE_DT_TM                  DATE,
  PREV_EXPIRE_DT_TM             DATE,
  PREV_QUALIFIED_DT_TM          DATE,
  EXPECT_MOD_ID                 NUMBER          DEFAULT 0,
  RELATED_ACTION_ID             NUMBER          DEFAULT 0,
  EXPECT_SAT_ID                 NUMBER          DEFAULT 0,
  SATISFACTION_DT_TM            DATE,
  PREV_FREQUENCY_VAL            NUMBER,
  PREV_EXPECTATION_NAME_CD      NUMBER          DEFAULT 0,
  EXPECTATION_NAME_CD           NUMBER          DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HNA_EXCEPT_AUDIT
(
  HNA_EXCEPT_AUDIT_ID     NUMBER                DEFAULT 0                     NOT NULL,
  EXCEPT_GROUP_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  LNAME                   VARCHAR2(100 BYTE),
  FNAME                   VARCHAR2(100 BYTE),
  SSN                     VARCHAR2(100 BYTE),
  DOB                     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  DOB_TZ                  NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HOLD_QUEUE
(
  HOLD_QUEUE_ID       NUMBER                    DEFAULT 0                     NOT NULL,
  HOLD_RULE_ID        NUMBER                    DEFAULT 0                     NOT NULL,
  QUEUE_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  PERSON_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  ENCNTR_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  ORDER_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  SCH_EVENT_ID        NUMBER                    DEFAULT 0                     NOT NULL,
  PERSON_COMBINE_IND  NUMBER,
  ENCNTR_COMBINE_IND  NUMBER,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  LGTMT_RELTN_ID      NUMBER                    DEFAULT 0,
  TRIGGER_ID          NUMBER                    DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HOLD_QUEUE_CONDITION
(
  HOLD_QUEUE_ID  NUMBER                         DEFAULT 0                     NOT NULL,
  SEQ_NUM        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HP_ALIAS_POOL_RELTN
(
  HP_ALIAS_POOL_RELTN_ID  NUMBER                DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  LOCATION_CD             NUMBER                DEFAULT 0                     NOT NULL,
  ALIAS_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  ALIAS_POOL_CD           NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  BEG_EFFECTIVE_DT_TM     DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HP_FINANCIAL
(
  HP_FINANCIAL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  COPAY                   NUMBER,
  COINSURANCE             NUMBER,
  DEDUCTIBLE              NUMBER,
  MAX_OUT_POCKET          NUMBER,
  MAX_FAM_OUT_POCKET      NUMBER,
  LIFETIME_MAX_BNFT       NUMBER,
  LOCATION_CD             NUMBER                DEFAULT 0                     NOT NULL,
  SPECIALTY_CD            NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(50 BYTE)     DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  REMARKS                 VARCHAR2(200 BYTE),
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE HP_GROUP_RELTN
(
  HP_GROUP_R_ID           NUMBER                DEFAULT 0                     NOT NULL,
  BT_COND_CRIT_R_ID       NUMBER                DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IB_RX_REQ
(
  IB_RX_REQ_ID                NUMBER            DEFAULT 0                     NOT NULL,
  TRANS_IDENTIFIER            VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  REQ_TYPE_FLAG               NUMBER            DEFAULT 0                     NOT NULL,
  TO_PRSNL_ID                 NUMBER            DEFAULT 0                     NOT NULL,
  PHARM_IDENTIFIER            VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  CREATE_DT_TM                DATE,
  IB_RX_REQ_PERSON_DEMOG_ID   NUMBER            DEFAULT 0                     NOT NULL,
  PHARMACIST_LAST_NAME        VARCHAR2(255 BYTE) DEFAULT ' ',
  PHARMACIST_MIDDLE_NAME      VARCHAR2(255 BYTE) DEFAULT ' ',
  PHARMACIST_FIRST_NAME       VARCHAR2(255 BYTE) DEFAULT ' ',
  PHARMACIST_SUFFIX_NAME      VARCHAR2(255 BYTE) DEFAULT ' ',
  PHARMACIST_PREFIX_NAME      VARCHAR2(255 BYTE) DEFAULT ' ',
  TECH_LAST_NAME              VARCHAR2(255 BYTE) DEFAULT ' ',
  TECH_FIRST_NAME             VARCHAR2(255 BYTE) DEFAULT ' ',
  TECH_MIDDLE_NAME            VARCHAR2(255 BYTE) DEFAULT ' ',
  TECH_SUFFIX_NAME            VARCHAR2(255 BYTE) DEFAULT ' ',
  TECH_PREFIX_NAME            VARCHAR2(255 BYTE) DEFAULT ' ',
  GROUP_AVAIL_IND             NUMBER            DEFAULT 0                     NOT NULL,
  DRUG_DESCRIPTION_TXT        VARCHAR2(255 BYTE) DEFAULT ' ',
  PROD_IDENT_TYPE_CD          NUMBER            DEFAULT 0                     NOT NULL,
  PRODUCT_IDENTIFIER          VARCHAR2(255 BYTE) DEFAULT ' ',
  DISPENSE_QTY                FLOAT(126)        DEFAULT 0                     NOT NULL,
  DISPENSE_QTY_UNIT_CD        NUMBER            DEFAULT 0                     NOT NULL,
  SPECIAL_INSTRUCTIONS_TXT    VARCHAR2(255 BYTE) DEFAULT ' ',
  LAST_FILL_DT_TM             DATE,
  ORDER_DT_TM                 DATE,
  DAYS_SUPPLY_NBR             NUMBER            DEFAULT 0                     NOT NULL,
  DISPENSE_AS_WRITTEN_CD      NUMBER            DEFAULT 0                     NOT NULL,
  REMAINING_REFILL_QTY        FLOAT(126)        DEFAULT 0                     NOT NULL,
  PRN_IND                     NUMBER            DEFAULT 0                     NOT NULL,
  PHARM_COMMENT_TXT           VARCHAR2(255 BYTE) DEFAULT ' ',
  REF_ORDER_ID                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT sysdate               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  PHARM_RX_TRANS_IDENT        VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  ZERO_REFILLS_SPECIFIED_IND  NUMBER            DEFAULT 0,
  PHARM_ZIP_CODE              VARCHAR2(255 BYTE),
  PHARM_STREET2_ADDR          VARCHAR2(255 BYTE),
  SURE_SCRIPT_VERSION_FLAG    NUMBER            DEFAULT 0,
  PHARM_PRIMARY_PHONE         VARCHAR2(80 BYTE),
  PHARM_NAME                  VARCHAR2(255 BYTE),
  PHARM_STREET_ADDR           VARCHAR2(255 BYTE),
  PHARM_CITY_NAME             VARCHAR2(255 BYTE),
  PHARM_STATE_NAME            VARCHAR2(255 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IB_RX_REQ_ACTION
(
  IB_RX_REQ_ACTION_ID    NUMBER                 DEFAULT 0                     NOT NULL,
  IB_RX_REQ_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  PROPOSED_PERSON_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  PROPOSED_ENCNTR_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  ACTION_PRSNL_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  ACTION_DT_TM           DATE,
  ACTION_SEQ_NBR         NUMBER                 DEFAULT 0                     NOT NULL,
  REQ_STATUS_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  BEGIN_EFFECTIVE_DT_TM  DATE                   DEFAULT sysdate               NOT NULL,
  END_EFFECTIVE_DT_TM    DATE                   DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT sysdate               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  ACTIVE_IND             NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IB_RX_REQ_CONTACT
(
  IB_RX_REQ_CONTACT_ID       NUMBER             DEFAULT 0                     NOT NULL,
  IB_RX_REQ_PERSON_DEMOG_ID  NUMBER             DEFAULT 0                     NOT NULL,
  PHONE_NBR_TYPE_CD          NUMBER             DEFAULT 0                     NOT NULL,
  PHONE_NBR_TXT              VARCHAR2(255 BYTE) DEFAULT ' ',
  EMAIL_ADDR                 VARCHAR2(255 BYTE) DEFAULT ' ',
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT sysdate               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IB_RX_REQ_DIAGNOSIS
(
  IB_RX_REQ_DIAGNOSIS_ID    NUMBER              DEFAULT 0                     NOT NULL,
  IB_RX_REQ_ID              NUMBER              DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID           NUMBER              DEFAULT 0                     NOT NULL,
  NOMEN_STRING_SOURCE_CD    NUMBER              DEFAULT 0                     NOT NULL,
  NOMEN_SOURCE_IDENT_VALUE  VARCHAR2(255 BYTE)  DEFAULT ' ',
  DIAGNOSIS_SOURCE_NAME     VARCHAR2(255 BYTE)  DEFAULT ' ',
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT sysdate               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  IB_RX_REQ_DRUG_ID         NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IB_RX_REQ_DRUG
(
  IB_RX_REQ_DRUG_ID           NUMBER            DEFAULT 0                     NOT NULL,
  IB_RX_REQ_ID                NUMBER            DEFAULT 0                     NOT NULL,
  DRUG_DESCRIPTION_TXT        VARCHAR2(255 BYTE),
  PROD_IDENT_TYPE_CD          NUMBER            DEFAULT 0                     NOT NULL,
  PRODUCT_IDENTIFIER          VARCHAR2(255 BYTE),
  DISPENSE_QTY                FLOAT(126),
  DISPENSE_QTY_UNIT_CD        NUMBER            DEFAULT 0                     NOT NULL,
  SPECIAL_INSTRUCTIONS_TXT    VARCHAR2(255 BYTE),
  LAST_FILL_DT_TM             DATE,
  ORDER_DT_TM                 DATE,
  DAYS_SUPPLY_NBR             NUMBER,
  DISPENSE_AS_WRITTEN_CD      NUMBER            DEFAULT 0                     NOT NULL,
  REMAINING_REFILL_QTY        FLOAT(126),
  PRN_IND                     NUMBER            DEFAULT 0                     NOT NULL,
  PHARM_COMMENT_TXT           VARCHAR2(255 BYTE),
  RENEWAL_TYPE_FLAG           NUMBER            DEFAULT 0                     NOT NULL,
  ZERO_REFILLS_SPECIFIED_IND  NUMBER            DEFAULT 0                     NOT NULL,
  REF_ORDER_ID                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  PRODUCT_TYPE_FLAG           NUMBER            DEFAULT 0                     NOT NULL,
  PRODUCT_SCHEDULE_FLAG       NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IB_RX_REQ_PERSON_DEMOG
(
  IB_RX_REQ_PERSON_DEMOG_ID   NUMBER            DEFAULT 0                     NOT NULL,
  LAST_NAME                   VARCHAR2(255 BYTE) DEFAULT ' ',
  FIRST_NAME                  VARCHAR2(255 BYTE) DEFAULT ' ',
  MIDDLE_NAME                 VARCHAR2(255 BYTE) DEFAULT ' ',
  SUFFIX_NAME                 VARCHAR2(255 BYTE) DEFAULT ' ',
  PREFIX_NAME                 VARCHAR2(255 BYTE) DEFAULT ' ',
  BIRTH_DT_TM                 DATE,
  GENDER_CD                   NUMBER            DEFAULT 0                     NOT NULL,
  BIRTH_PREC_FLAG             NUMBER            DEFAULT 0,
  PATIENT_IDENTIFIER_TYPE_CD  NUMBER            DEFAULT 0                     NOT NULL,
  PATIENT_IDENTIFIER          VARCHAR2(255 BYTE) DEFAULT ' ',
  STREET_ADDR                 VARCHAR2(255 BYTE) DEFAULT ' ',
  STREET2_ADDR                VARCHAR2(255 BYTE) DEFAULT ' ',
  CITY_NAME                   VARCHAR2(255 BYTE) DEFAULT ' ',
  STATE_NAME                  VARCHAR2(255 BYTE) DEFAULT ' ',
  ZIP_CODE                    VARCHAR2(255 BYTE) DEFAULT ' ',
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT sysdate               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  PERSON_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  IB_RX_REQ_ID                NUMBER            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IB_RX_REQ_PRSNL_ALIAS
(
  IB_RX_REQ_PRSNL_ALIAS_ID  NUMBER              DEFAULT 0                     NOT NULL,
  IB_RX_REQ_PRSNL_DEMOG_ID  NUMBER              DEFAULT 0                     NOT NULL,
  ALIAS_TYPE_CD             NUMBER              DEFAULT 0                     NOT NULL,
  ALIAS                     VARCHAR2(255 BYTE)  DEFAULT ' '                   NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IB_RX_REQ_PRSNL_CONTACT
(
  IB_RX_REQ_PRSNL_CONTACT_ID  NUMBER            DEFAULT 0                     NOT NULL,
  IB_RX_REQ_PRSNL_DEMOG_ID    NUMBER            DEFAULT 0                     NOT NULL,
  PHONE_NBR_TYPE_CD           NUMBER            DEFAULT 0                     NOT NULL,
  PHONE_NBR_TXT               VARCHAR2(255 BYTE),
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT sysdate               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IB_RX_REQ_PRSNL_DEMOG
(
  IB_RX_REQ_PRSNL_DEMOG_ID  NUMBER              DEFAULT 0                     NOT NULL,
  IB_RX_REQ_ID              NUMBER              DEFAULT 0                     NOT NULL,
  LAST_NAME                 VARCHAR2(255 BYTE),
  MIDDLE_NAME               VARCHAR2(255 BYTE),
  FIRST_NAME                VARCHAR2(255 BYTE),
  SUFFIX_NAME               VARCHAR2(255 BYTE),
  PREFIX_NAME               VARCHAR2(255 BYTE),
  STREET_ADDR               VARCHAR2(255 BYTE),
  STREET2_ADDR              VARCHAR2(255 BYTE),
  CITY_NAME                 VARCHAR2(255 BYTE),
  STATE_NAME                VARCHAR2(255 BYTE),
  ZIP_CODE                  VARCHAR2(255 BYTE),
  PRSNL_TYPE_FLAG           NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ICLASS_ACC_ORDER_R
(
  SEQ_OBJECT_ID  NUMBER                         DEFAULT 0                     NOT NULL,
  ORDER_ID       NUMBER                         DEFAULT 0                     NOT NULL,
  ACCESSION      VARCHAR2(20 BYTE),
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ICLASS_PERSON_RELTN
(
  SEQ_OBJECT_ID  NUMBER                         DEFAULT 0                     NOT NULL,
  PERSON_ID      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IDENTIFIER
(
  IDENTIFIER_ID           NUMBER                DEFAULT 0                     NOT NULL,
  IDENTIFIER_TYPE_CD      NUMBER                DEFAULT 0                     NOT NULL,
  VALUE                   VARCHAR2(255 BYTE)    DEFAULT ' '                   NOT NULL,
  VALUE_KEY               VARCHAR2(255 BYTE)    DEFAULT ' '                   NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX          NUMBER,
  CREATE_DT_TM            DATE,
  CREATE_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_TASK             NUMBER,
  VALUE_KEY_NLS           VARCHAR2(512 BYTE),
  SALABLE_BY_VENDOR_IND   NUMBER,
  SALABLE_BY_MFR_IND      NUMBER,
  PACKAGE_TYPE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  REPLACED_UPN_ID         NUMBER                DEFAULT 0                     NOT NULL,
  REPLACEMENT_UPN_ID      NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_CD          NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(32 BYTE)     DEFAULT ' '                   NOT NULL,
  VALUE_KEY_A_NLS         VARCHAR2(1020 BYTE),
  LOGICAL_DOMAIN_ID       NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IMAGE_CLASS
(
  SEQ_OBJECT_ID            NUMBER               DEFAULT 0                     NOT NULL,
  IMAGE_CLASS_TYPE_CD      NUMBER               DEFAULT 0                     NOT NULL,
  CREATION_DT_TM           DATE,
  HISTORY_LABEL_PRINT_IND  NUMBER,
  LOST_IND                 NUMBER,
  PURGE_IND                NUMBER,
  FILING_NUMBER            VARCHAR2(100 BYTE),
  LOST_COMMENT             VARCHAR2(255 BYTE),
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_VOLUME_IND        NUMBER,
  VOLUME                   NUMBER,
  UPDATEABLE_IND           NUMBER,
  NBR_EXAMS                NUMBER               DEFAULT 0,
  NEW_FOLD_IND             NUMBER,
  PENDING_EXAM_CNT         NUMBER               DEFAULT 0,
  LABEL_PRINT_DT_TM        DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IMAGE_CLASS_TYPE
(
  IMAGE_CLASS_TYPE_CD         NUMBER            DEFAULT 0                     NOT NULL,
  LIB_GROUP_CD                NUMBER            DEFAULT 0                     NOT NULL,
  LABEL_CNT                   NUMBER,
  BEG_EFFECTIVE_DT_TM         DATE              DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM         DATE              DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ACTIVE_IND                  NUMBER,
  LOANABLE_IND                NUMBER,
  MAX_EXAMS                   NUMBER,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  PARENT_IMAGE_CLASS_TYPE_CD  NUMBER            DEFAULT 0                     NOT NULL,
  DEFAULT_RETURN_LOCN_CD      NUMBER            DEFAULT 0                     NOT NULL,
  DEFAULT_TRACKING_POINT_CD   NUMBER            DEFAULT 0                     NOT NULL,
  STORE_EXAMS_IND             NUMBER,
  CONTENT_LABEL_CNT           NUMBER,
  CREATE_BY_ACC_IND           NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IMAGE_HISTORY
(
  SEQ_OBJECT_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  ACTION_CD             NUMBER                  DEFAULT 0                     NOT NULL,
  ACTION_DT_TM          DATE                    DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  TRK_PT_PARENT_NAME    VARCHAR2(32 BYTE),
  TRK_PT_PARENT_ID      NUMBER                  DEFAULT 0                     NOT NULL,
  ACTION_COMMENTS       VARCHAR2(255 BYTE),
  AGENT                 VARCHAR2(50 BYTE),
  ACTION_METHOD_CD      NUMBER                  DEFAULT 0                     NOT NULL,
  REQUEST_PARENT_NAME   VARCHAR2(32 BYTE),
  REQUEST_PARENT_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  REQUEST_DT_TM         DATE,
  REQUEST_RETURN_DT_TM  DATE,
  LOGGED_DT_TM          DATE,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  FROM_DT_TM            DATE,
  TRANSACTION_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  NBR_COPIES            NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IMMUNIZATION_MODIFIER
(
  IMMUNIZATION_MODIFIER_ID  NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  CLINICAL_EVENT_ID         NUMBER              DEFAULT 0                     NOT NULL,
  EXPECT_MEANING            VARCHAR2(250 BYTE)  DEFAULT ' '                   NOT NULL,
  EVENT_CD                  NUMBER              DEFAULT 0                     NOT NULL,
  VIS_DT_TM                 DATE,
  VFC_STATUS_CD             NUMBER              DEFAULT 0                     NOT NULL,
  CONSENT_LONG_TEXT_ID      NUMBER              DEFAULT 0                     NOT NULL,
  CONSENT_PERSON_REL_CD     NUMBER              DEFAULT 0                     NOT NULL,
  CONSENT_PERSON_ID         NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE,
  END_EFFECTIVE_DT_TM       DATE,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  EVENT_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID           NUMBER              DEFAULT 0                     NOT NULL,
  DEFAULT_EVENT_IND         NUMBER,
  VIS_PROVIDED_ON_DT_TM     DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IM_ACQUIRED_STUDY
(
  IM_ACQUIRED_STUDY_ID       NUMBER             DEFAULT 0                     NOT NULL,
  STUDY_UID                  VARCHAR2(64 BYTE),
  PATIENT_NAME               VARCHAR2(64 BYTE),
  PATIENT_IDENTIFIER         VARCHAR2(64 BYTE),
  BIRTH_DATE                 VARCHAR2(16 BYTE),
  BIRTH_TIME                 VARCHAR2(16 BYTE),
  SEX                        VARCHAR2(16 BYTE),
  ETHNIC_GROUP               VARCHAR2(16 BYTE),
  STUDY_IDENTIFIER           VARCHAR2(16 BYTE),
  STUDY_DATE                 VARCHAR2(16 BYTE),
  STUDY_TIME                 VARCHAR2(16 BYTE),
  ACCESSION                  VARCHAR2(16 BYTE),
  IM_DEVICE_ID               NUMBER             DEFAULT 0                     NOT NULL,
  REQUESTED_PROC_DESC        VARCHAR2(64 BYTE),
  REQUESTED_PROC_IDENTIFIER  VARCHAR2(16 BYTE),
  STUDY_DESCRIPTION          VARCHAR2(64 BYTE),
  REFERRING_PHYS_NAME        VARCHAR2(64 BYTE),
  STATION_NAME               VARCHAR2(16 BYTE),
  MANUFACTURER               VARCHAR2(64 BYTE),
  INSTITUTION_NAME           VARCHAR2(64 BYTE),
  MODEL_NAME                 VARCHAR2(64 BYTE),
  MATCHED_STUDY_ID           NUMBER             DEFAULT 0                     NOT NULL,
  MATCHED_PERSON_IDENTIFIER  VARCHAR2(64 BYTE),
  MATCHED_PERSON_NAME        VARCHAR2(64 BYTE),
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_DT_TM               DATE,
  ACTIVE_STATUS_PRSNL_ID     NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  ACQUIRED_DT_TM             DATE,
  UPLOAD_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  SENDING_DEVICE_ID          NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IM_DEVICE
(
  IM_DEVICE_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  VENDOR_CD              NUMBER                 DEFAULT 0                     NOT NULL,
  IP_ADDRESS             VARCHAR2(64 BYTE),
  AUTO_QC_IND            NUMBER,
  SERVICE_RESOURCE_CD    NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  DEVICE_NAME            VARCHAR2(25 BYTE),
  TIMEZONE               NUMBER                 DEFAULT 0,
  DEVICE_NAME_KEY        VARCHAR2(25 BYTE),
  DEVICE_NAME_KEY_NLS    VARCHAR2(52 BYTE),
  MODEL_NAME_KEY_NLS     VARCHAR2(130 BYTE),
  MODEL_NAME_KEY         VARCHAR2(64 BYTE),
  MODEL_NAME             VARCHAR2(64 BYTE),
  MODEL_NAME_KEY_A_NLS   VARCHAR2(256 BYTE),
  DEVICE_NAME_KEY_A_NLS  VARCHAR2(100 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IM_DEVICE_ACTIVITY
(
  IM_DEVICE_ID    NUMBER                        DEFAULT 0                     NOT NULL,
  IM_ACTIVITY_CD  NUMBER                        DEFAULT 0                     NOT NULL,
  AE_TITLE        VARCHAR2(16 BYTE),
  PORT            NUMBER,
  PRIMARY_IND     NUMBER,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IM_DEVICE_DISCIPLINE_R
(
  IM_DEVICE_ID   NUMBER                         DEFAULT 0                     NOT NULL,
  DISCIPLINE_CD  NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IM_DEVICE_MWL_RULE_R
(
  IM_DEVICE_MWL_RULE_R_ID  NUMBER               DEFAULT 0                     NOT NULL,
  IM_DEVICE_ID             NUMBER               DEFAULT 0                     NOT NULL,
  IM_MWL_RULE_ID           NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IM_DEVICE_ORG_R
(
  IM_DEVICE_ORG_R_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  IM_DEVICE_ID        NUMBER                    DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IM_DEVICE_RESOURCE_R
(
  IM_DEVICE_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IM_MATCH_EVENT
(
  IM_MATCH_EVENT_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  IM_ACQUIRED_STUDY_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  IM_STUDY_ID           NUMBER                  DEFAULT 0                     NOT NULL,
  IM_SERIES_ID          NUMBER                  DEFAULT 0                     NOT NULL,
  MATCH_EVENT_CD        NUMBER                  DEFAULT 0                     NOT NULL,
  MATCH_PRSNL_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IM_ROUTE
(
  IM_ROUTE_ID            NUMBER                 DEFAULT 0                     NOT NULL,
  IM_STUDY_ID            NUMBER                 DEFAULT 0                     NOT NULL,
  TRANSACTION_NBR        NUMBER                 DEFAULT 0                     NOT NULL,
  ACCESSION              VARCHAR2(20 BYTE)      DEFAULT ' '                   NOT NULL,
  SOURCE_DEVICE_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  DESTINATION_DEVICE_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  ROUTE_STATUS_CD        NUMBER                 DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM      DATE                   DEFAULT sysdate               NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT sysdate               NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IM_ROUTE_ACTIVITY
(
  IM_ROUTE_ACTIVITY_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  IM_ROUTE_ID           NUMBER                  DEFAULT 0                     NOT NULL,
  FAILED_DEVICE_ID      NUMBER                  DEFAULT 0                     NOT NULL,
  ROUTE_STATUS_CD       NUMBER                  DEFAULT 0                     NOT NULL,
  ATTEMPT_NUMBER        NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT sysdate               NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IM_STUDY_LOCATION
(
  IM_STUDY_ID   NUMBER                          DEFAULT 0                     NOT NULL,
  IM_DEVICE_ID  NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IM_U_NOTIFY
(
  IM_U_NOTIFY_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  IM_ACQUIRED_STUDY_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  U_NOTIFY_CD           NUMBER                  DEFAULT 0                     NOT NULL,
  U_NOTIFY_STATUS_CD    NUMBER                  DEFAULT 0                     NOT NULL,
  INSERT_DT_TM          DATE                    DEFAULT SYSDATE,
  NUMBER_OF_TRIES       NUMBER,
  IM_STUDY_ID           NUMBER                  DEFAULT 0                     NOT NULL,
  IM_SERIES_ID          NUMBER                  DEFAULT 0                     NOT NULL,
  PATIENT_NAME          VARCHAR2(64 BYTE),
  PATIENT_IDENTIFIER    VARCHAR2(64 BYTE),
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  CQM_STATUS_CD         NUMBER                  DEFAULT 0                     NOT NULL,
  CQM_NBR_RETRIES       NUMBER                  DEFAULT 0                     NOT NULL,
  IM_DEVICE_ID          NUMBER                  DEFAULT 0,
  ENCNTR_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  PERSON_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  REPLACED_IM_STUDY_ID  NUMBER                  DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IND_IDE_OWNERSHIP
(
  IND_IDE_OWNERSHIP_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  PERSON_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  AGENT_DEV_ID          NUMBER                  DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  ROLE_TYPE_CD          NUMBER                  DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM   DATE                    DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM   DATE                    DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  VALID_TO_DT_TM        DATE                    DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  VALID_FROM_DT_TM      DATE                    DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  IND_IDE_NBR           VARCHAR2(6 BYTE),
  OWNERSHIP_ID          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INFUSION_BILLING_EVENT
(
  INFUSION_BILLING_EVENT_ID       NUMBER        DEFAULT 0                     NOT NULL,
  PREV_INFUSION_BILLING_EVENT_ID  NUMBER        DEFAULT 0                     NOT NULL,
  ENCNTR_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  ORDER_ID                        NUMBER        DEFAULT 0                     NOT NULL,
  INFUSION_START_DT_TM            DATE          DEFAULT SYSDATE               NOT NULL,
  INFUSION_START_TZ               NUMBER        DEFAULT 0                     NOT NULL,
  INFUSION_END_DT_TM              DATE          DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  INFUSION_END_TZ                 NUMBER        DEFAULT 0                     NOT NULL,
  CREATE_PRSNL_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  COMMENT_LONG_TEXT_ID            NUMBER        DEFAULT 0                     NOT NULL,
  BEGIN_EFFECTIVE_DT_TM           DATE          DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM             DATE          DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_IND                      NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  INFUSION_DURATION_MINS          FLOAT(126)    DEFAULT 0                     NOT NULL,
  INFUSED_VOLUME_VALUE            FLOAT(126)    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INFUSION_CE_RELTN
(
  INFUSION_CE_RELTN_ID       NUMBER             DEFAULT 0                     NOT NULL,
  PREV_INFUSION_CE_RELTN_ID  NUMBER             DEFAULT 0                     NOT NULL,
  INFUSION_BILLING_EVENT_ID  NUMBER             DEFAULT 0                     NOT NULL,
  CLINICAL_EVENT_ID          NUMBER             DEFAULT 0                     NOT NULL,
  BEGIN_EFFECTIVE_DT_TM      DATE               DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM        DATE               DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  CLINICAL_EVENT_SEQ         NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INSTRUMENT_ASSIGNMENT
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INSTRUMENT_IMAGE
(
  INSTRUMENT_IMAGE_ID     NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PERFORM_DT_TM           DATE                  DEFAULT SYSDATE               NOT NULL,
  RESULT_IMAGE_NAME       VARCHAR2(64 BYTE),
  RESULT_IMAGE_VRSN_NBR   NUMBER                DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  REPEAT_NBR              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INSTR_ACCN_QUEUE
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  SEQUENCE             NUMBER                   DEFAULT 0                     NOT NULL,
  ACCESSION            VARCHAR2(20 BYTE)        DEFAULT ' '                   NOT NULL,
  IN_PROCESS_PRSNL_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  IN_PROCESS_DT_TM     DATE,
  QC_GROUP_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  PERF_DT_TM           DATE,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INTERFACE_CHARGE
(
  INTERFACE_CHARGE_ID         NUMBER            DEFAULT 0                     NOT NULL,
  ORDER_DEPT                  NUMBER,
  INTERFACE_FILE_ID           NUMBER            DEFAULT 0                     NOT NULL,
  CHARGE_ITEM_ID              NUMBER            DEFAULT 0                     NOT NULL,
  BATCH_NUM                   NUMBER,
  BILL_CODE1                  VARCHAR2(50 BYTE),
  BILL_CODE1_DESC             VARCHAR2(200 BYTE),
  BILL_CODE2                  VARCHAR2(50 BYTE),
  BILL_CODE2_DESC             VARCHAR2(200 BYTE),
  BILL_CODE3                  VARCHAR2(50 BYTE),
  BILL_CODE3_DESC             VARCHAR2(200 BYTE),
  PRIM_CDM                    VARCHAR2(50 BYTE),
  PRIM_CPT                    VARCHAR2(50 BYTE),
  DIAG_CODE1                  VARCHAR2(50 BYTE),
  DIAG_CODE2                  VARCHAR2(50 BYTE),
  DIAG_CODE3                  VARCHAR2(50 BYTE),
  PERSON_NAME                 VARCHAR2(100 BYTE),
  PERSON_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  FIN_NBR                     VARCHAR2(50 BYTE),
  MED_NBR                     VARCHAR2(50 BYTE),
  SERVICE_DT_TM               DATE,
  SECTION_CD                  NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CD              NUMBER            DEFAULT 0                     NOT NULL,
  PAYOR_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  QUANTITY                    FLOAT(126),
  PRICE                       FLOAT(126),
  NET_EXT_PRICE               FLOAT(126),
  ORGANIZATION_ID             NUMBER            DEFAULT 0                     NOT NULL,
  INSTITUTION_CD              NUMBER            DEFAULT 0                     NOT NULL,
  DEPARTMENT_CD               NUMBER            DEFAULT 0                     NOT NULL,
  SUBSECTION_CD               NUMBER            DEFAULT 0                     NOT NULL,
  LEVEL5_CD                   NUMBER            DEFAULT 0                     NOT NULL,
  FACILITY_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  BUILDING_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  NURSE_UNIT_CD               NUMBER            DEFAULT 0                     NOT NULL,
  ROOM_CD                     NUMBER            DEFAULT 0                     NOT NULL,
  BED_CD                      NUMBER            DEFAULT 0                     NOT NULL,
  REFERRING_PHYS_ID           NUMBER            DEFAULT 0                     NOT NULL,
  ORD_PHYS_ID                 NUMBER            DEFAULT 0                     NOT NULL,
  ORD_DOC_NBR                 VARCHAR2(20 BYTE),
  ADM_PHYS_ID                 NUMBER            DEFAULT 0                     NOT NULL,
  ATTENDING_PHYS_ID           NUMBER            DEFAULT 0                     NOT NULL,
  ADDITIONAL_ENCNTR_PHYS1_ID  NUMBER            DEFAULT 0                     NOT NULL,
  ADDITIONAL_ENCNTR_PHYS2_ID  NUMBER            DEFAULT 0                     NOT NULL,
  ADDITIONAL_ENCNTR_PHYS3_ID  NUMBER            DEFAULT 0                     NOT NULL,
  CHARGE_TYPE_CD              NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE,
  BEG_EFFECTIVE_DT_TM         DATE              DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM         DATE,
  DISCOUNT_AMOUNT             FLOAT(126),
  GROSS_PRICE                 FLOAT(126),
  ORDER_NBR                   VARCHAR2(200 BYTE),
  PERF_PHYS_ID                NUMBER            DEFAULT 0                     NOT NULL,
  POSTED_DT_TM                DATE,
  PRIM_CDM_DESC               VARCHAR2(200 BYTE),
  PRIM_CPT_DESC               VARCHAR2(200 BYTE),
  PROCESS_FLG                 NUMBER,
  MANUAL_IND                  NUMBER,
  DIAG_DESC1                  VARCHAR2(200 BYTE),
  DIAG_DESC2                  VARCHAR2(200 BYTE),
  DIAG_DESC3                  VARCHAR2(200 BYTE),
  ABN_STATUS_CD               NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVITY_TYPE_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ADMIT_TYPE_CD               NUMBER            DEFAULT 0                     NOT NULL,
  BILL_CODE_MORE_IND          NUMBER,
  BILL_CODE_TYPE_CDF          VARCHAR2(12 BYTE),
  CODE_MODIFIER1_CD           NUMBER            DEFAULT 0                     NOT NULL,
  CODE_MODIFIER2_CD           NUMBER            DEFAULT 0                     NOT NULL,
  CODE_MODIFIER3_CD           NUMBER            DEFAULT 0                     NOT NULL,
  CODE_MODIFIER_MORE_IND      NUMBER,
  COST_CENTER_CD              NUMBER            DEFAULT 0                     NOT NULL,
  DIAG_MORE_IND               NUMBER,
  FIN_NBR_TYPE_FLG            NUMBER            DEFAULT 0,
  ICD9_PROC_MORE_IND          NUMBER,
  MED_SERVICE_CD              NUMBER            DEFAULT 0                     NOT NULL,
  OVERRIDE_DESC               VARCHAR2(200 BYTE) DEFAULT ' ',
  PERF_LOC_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  PRIM_ICD9_PROC              VARCHAR2(50 BYTE),
  PRIM_ICD9_PROC_DESC         VARCHAR2(200 BYTE),
  USER_DEF_IND                NUMBER,
  CHARGE_DESCRIPTION          VARCHAR2(200 BYTE),
  VERIFY_PHYS_ID              NUMBER            DEFAULT 0                     NOT NULL,
  CODE_REVENUE_CD             NUMBER            DEFAULT 0                     NOT NULL,
  CODE_REVENUE_MORE_IND       NUMBER,
  QTY_CONV_FACTOR             FLOAT(126),
  EXT_BILL_QTY                NUMBER,
  NDC_IDENT                   VARCHAR2(40 BYTE) DEFAULT ' '
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INTERFACE_FILE
(
  INTERFACE_FILE_ID        NUMBER               DEFAULT 0                     NOT NULL,
  DESCRIPTION              VARCHAR2(100 BYTE)   DEFAULT ' '                   NOT NULL,
  FILE_NAME                VARCHAR2(32 BYTE),
  REALTIME_IND             NUMBER               DEFAULT 0,
  HOLD_PERIOD              FLOAT(126),
  BATCH_FREQUENCY          FLOAT(126),
  ACTIVE_IND               NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  CDM_SCHED_CD             NUMBER               DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD    NUMBER               DEFAULT 0                     NOT NULL,
  CPT_SCHED_CD             NUMBER               DEFAULT 0                     NOT NULL,
  DOC_NBR_CD               NUMBER               DEFAULT 0                     NOT NULL,
  EXPLODE_IND              NUMBER,
  MULT_BILL_CODE_SCHED_CD  NUMBER               DEFAULT 0                     NOT NULL,
  HL7_IND                  NUMBER               DEFAULT 0,
  FIN_NBR_SUSPEND_IND      NUMBER,
  MAX_FT1                  CHAR(5 BYTE),
  PROFIT_TYPE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  PERF_PHYS_CONT_IND       NUMBER               DEFAULT 0,
  REV_SCHED_CD             NUMBER               DEFAULT 0                     NOT NULL,
  ROUND_METHOD_FLAG        NUMBER,
  REPROCESS_IND            NUMBER               DEFAULT 0                     NOT NULL,
  REPROCESS_CPT_IND        NUMBER               DEFAULT 0,
  INTERFACE_TYPE_FLAG      NUMBER               DEFAULT 0,
  LOGICAL_DOMAIN_ID        NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INTERP_COMPONENT
(
  INTERP_ID               NUMBER                DEFAULT 0                     NOT NULL,
  INTERP_DETAIL_ID        NUMBER                DEFAULT 0                     NOT NULL,
  INCLUDED_ASSAY_CD       NUMBER                DEFAULT 0                     NOT NULL,
  SEQUENCE                NUMBER,
  CROSS_DRAWN_DT_TM_IND   NUMBER,
  TIME_WINDOW_MINUTES     NUMBER,
  TIME_WINDOW_UNITS_CD    NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_REQ_FLAG         NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  VERIFIED_FLAG           NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INTERP_DATA
(
  INTERP_DATA_ID          NUMBER                DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD           NUMBER                DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INTERP_RANGE
(
  INTERP_ID               NUMBER                DEFAULT 0                     NOT NULL,
  INTERP_DETAIL_ID        NUMBER                DEFAULT 0                     NOT NULL,
  INTERP_RANGE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  INCLUDED_ASSAY_CD       NUMBER                DEFAULT 0                     NOT NULL,
  SEQUENCE                NUMBER,
  AGE_FROM_UNITS_CD       NUMBER                DEFAULT 0                     NOT NULL,
  AGE_FROM_MINUTES        NUMBER,
  AGE_TO_UNITS_CD         NUMBER                DEFAULT 0                     NOT NULL,
  AGE_TO_MINUTES          NUMBER,
  SPECIES_CD              NUMBER                DEFAULT 0                     NOT NULL,
  GENDER_CD               NUMBER                DEFAULT 0                     NOT NULL,
  RACE_CD                 NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UNKNOWN_AGE_IND         NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INTERP_RESULT
(
  INTERP_RESULT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  INTERP_ID               NUMBER                DEFAULT 0                     NOT NULL,
  HASH_PATTERN            VARCHAR2(255 BYTE),
  RESULT_NOMENCLATURE_ID  NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_CD               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  DONOR_ELIGIBILITY_CD    NUMBER                DEFAULT 0                     NOT NULL,
  DAYS_INELIGIBLE         NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INTERP_TASK_ASSAY
(
  INTERP_ID               NUMBER                DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD           NUMBER                DEFAULT 0                     NOT NULL,
  INTERP_TYPE_CD          NUMBER                DEFAULT 0                     NOT NULL,
  GENERATE_INTERP_FLAG    NUMBER,
  INTERP_OPTION_CD        NUMBER                DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_CAT_CD            NUMBER                DEFAULT 0                     NOT NULL,
  PHASE_CD                NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INVEST_AGENT_DEV
(
  INVEST_AGENT_DEV_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  PROT_AMENDMENT_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  INVEST_AGENT_DEV_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  AGENT_DEV_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INVEST_DEV
(
  INVEST_DEV_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  AGENT_DEV_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  DEVICE_TYPE_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  DEVICE_NAME            VARCHAR2(20 BYTE),
  BEG_EFFECTIVE_DT_TM    DATE                   DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM    DATE                   DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  DEVICE_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  INVEST_DEVICE_NBR_TXT  VARCHAR2(12 BYTE)      DEFAULT ' '                   NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INVEST_NEW_DRUG
(
  INVEST_NEW_DRUG_DEV_ID  NUMBER                DEFAULT 0                     NOT NULL,
  AGENT_DEV_ID            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  CATALOG_CD              NUMBER                DEFAULT 0                     NOT NULL,
  INVEST_DRUG_NBR_TXT     VARCHAR2(12 BYTE)     DEFAULT ' '                   NOT NULL,
  NEW_DRUG_ID             NUMBER                DEFAULT 0                     NOT NULL,
  INVEST_DRUG_NAME        VARCHAR2(255 BYTE)    DEFAULT ' '
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INVOICE
(
  INVOICE_ID               NUMBER               DEFAULT 0                     NOT NULL,
  VENDOR_SITE_ID           NUMBER               DEFAULT 0                     NOT NULL,
  PURCHASE_ORDER_ID        NUMBER               DEFAULT 0                     NOT NULL,
  INVOICE_NBR              VARCHAR2(40 BYTE),
  VENDOR_CD                NUMBER               DEFAULT 0                     NOT NULL,
  MATCHED_IND              NUMBER,
  VOUCHER_STATUS_CD        NUMBER               DEFAULT 0                     NOT NULL,
  VOUCHER_USER_ID          NUMBER               DEFAULT 0                     NOT NULL,
  VOUCHER_DT_TM            DATE,
  PAID_STATUS_IND          NUMBER,
  PAYMENT_NBR              VARCHAR2(40 BYTE),
  PAYMENT_DT_TM            DATE,
  PAYMENT_AMOUNT           FLOAT(126),
  STATUS_CD                NUMBER               DEFAULT 0                     NOT NULL,
  INVOICE_DT_TM            DATE,
  VOUCHER_EFFECTIVE_DT_TM  DATE,
  VENDOR_PO_REF            VARCHAR2(40 BYTE),
  SEQUENCE                 NUMBER,
  LAST_INTERFACED_DT_TM    DATE,
  INVOICE_AMOUNT           FLOAT(126),
  TERMS_CD                 NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_DT_TM             DATE                 DEFAULT SYSDATE               NOT NULL,
  CREATE_ID                NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_TASK              NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX           NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  INVOICE_NBR_KEY          VARCHAR2(40 BYTE),
  INVOICE_NBR_KEY_NLS      VARCHAR2(82 BYTE),
  INV_PROFILE_ID           NUMBER               DEFAULT 0,
  REMIT_ADDRESS_ID         NUMBER               DEFAULT 0,
  SYSTEM_GENERATED_IND     NUMBER               DEFAULT 0,
  LAST_TRANSMIT_DT_TM      DATE,
  INVOICE_NBR_KEY_A_NLS    VARCHAR2(160 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INVOICE_LINE_ITEM
(
  INVOICE_LINE_ITEM_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  LINE_ITEM_ID          NUMBER                  DEFAULT 0                     NOT NULL,
  INVOICE_ID            NUMBER                  DEFAULT 0                     NOT NULL,
  PO_LINE_NBR           NUMBER,
  CHECKED_IND           NUMBER,
  MATCHED_IND           NUMBER,
  STATUS_CD             NUMBER                  DEFAULT 0                     NOT NULL,
  BUYER_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  COST_CENTER_CD        NUMBER                  DEFAULT 0                     NOT NULL,
  SUB_ACCOUNT_CD        NUMBER                  DEFAULT 0                     NOT NULL,
  CREATE_DT_TM          DATE                    DEFAULT SYSDATE               NOT NULL,
  CREATE_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  CREATE_TASK           NUMBER                  DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX        NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  TRANSMIT_CD           NUMBER                  DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INVOICE_PO_RECEIPT_R
(
  INVOICE_ID      NUMBER                        DEFAULT 0                     NOT NULL,
  PO_RECEIPT_ID   NUMBER                        DEFAULT 0                     NOT NULL,
  CREATE_DT_TM    DATE,
  CREATE_ID       NUMBER                        DEFAULT 0                     NOT NULL,
  CREATE_TASK     NUMBER,
  CREATE_APPLCTX  NUMBER,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INVTN_COMMUNICATION
(
  COMMUNICATION_ID          NUMBER              DEFAULT 0                     NOT NULL,
  PROGRAM_ID                NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  STATUS_FLAG               NUMBER              DEFAULT 0                     NOT NULL,
  REQUESTED_DT_TM           DATE,
  REQUESTED_PRSNL_ID        NUMBER              DEFAULT 0                     NOT NULL,
  GENERATED_DT_TM           DATE,
  SENT_DT_TM                DATE,
  SENT_PRSNL_ID             NUMBER              DEFAULT 0                     NOT NULL,
  RESENT_DT_TM              DATE,
  RESENT_PRSNL_ID           NUMBER              DEFAULT 0                     NOT NULL,
  CONTENT_TYPE_FLAG         NUMBER              DEFAULT 0                     NOT NULL,
  CONTENT_BLOB_ID           NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  SCHEDULED_DT_TM           DATE,
  FINAL_TRACKING_STATUS_CD  NUMBER              DEFAULT 0                     NOT NULL,
  METHOD_FLAG               NUMBER              DEFAULT 0,
  ACTIVE_IND                NUMBER              DEFAULT 1,
  GENERATED_PRSNL_ID        NUMBER              DEFAULT 0,
  FAILED_DT_TM              DATE,
  ACTIVE_STATUS_DT_TM       DATE                DEFAULT SYSDATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INVTN_FRAGMENT
(
  FRAGMENT_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  PREV_FRAGMENT_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  PROGRAM_GROUP_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  PROGRAM_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  TRACKING_STATUS_CD   NUMBER                   DEFAULT 0                     NOT NULL,
  CONTENT_TYPE_FLAG    NUMBER                   DEFAULT 0                     NOT NULL,
  CONTENT_BLOB_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 1                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  INVITATION_TYPE      VARCHAR2(50 BYTE)        DEFAULT ' '                   NOT NULL,
  METHOD_FLAG          NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INVTN_INVITATION
(
  INVITATION_ID               NUMBER            DEFAULT 0                     NOT NULL,
  PERSON_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  PROGRAM_ID                  NUMBER            DEFAULT 0                     NOT NULL,
  TRACKING_STATUS_CD          NUMBER            DEFAULT 0                     NOT NULL,
  COMMUNICATION_ID            NUMBER            DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME          VARCHAR2(30 BYTE) DEFAULT ' ' NOT NULL,
  PARENT_ENTITY_ID            NUMBER            DEFAULT 0                     NOT NULL,
  LIST_NAME                   VARCHAR2(50 BYTE) DEFAULT ' ' NOT NULL,
  SEQ_DT_TM                   DATE,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER            DEFAULT 0                     NOT NULL,
  ASSIGN_DT_TM                DATE,
  LAST_UPDATED_DT_TM          DATE,
  LAST_UPDATED_BY_ID          NUMBER            DEFAULT 0                     NOT NULL,
  SCHEDULED_COMMUNICATION_ID  NUMBER            DEFAULT 0                     NOT NULL,
  SCHEDULED_COMM_DT_TM        DATE,
  GENERATED_COMM_DT_TM        DATE,
  TRACKING_STATUS_DT_TM       DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INVTN_INVITATION_ACTION
(
  INVITATION_ACTION_ID   NUMBER                 DEFAULT 0                     NOT NULL,
  PROGRAM_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  ACTION_FLAG            NUMBER                 DEFAULT 0                     NOT NULL,
  ACTION_DT_TM           DATE,
  TRACKING_STATUS_CD     NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  COMMUNICATION_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  ACTION_PRSNL_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  TRIGGER_ENTITY_ID      NUMBER                 DEFAULT 0,
  TRIGGER_ENTITY_NAME    VARCHAR2(30 BYTE),
  TRACKING_STATUS_DT_TM  DATE,
  ACTIVE_IND             NUMBER                 DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INVTN_PROGRAM
(
  PROGRAM_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  PROGRAM_TYPE         VARCHAR2(100 BYTE)       DEFAULT ' '                   NOT NULL,
  PROGRAM_MEANING      VARCHAR2(100 BYTE)       DEFAULT ' '                   NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  PREV_PROGRAM_ID      NUMBER                   DEFAULT 0,
  PROGRAM_GROUP_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  WORKFLOW_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  PROGRAM_NAME         VARCHAR2(250 BYTE)       DEFAULT ' ',
  SOURCE_TYPE          VARCHAR2(100 BYTE)       DEFAULT ' '                   NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 0,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT SYSDATE,
  SOURCE_MEANING       VARCHAR2(250 BYTE)       DEFAULT ' '                   NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS')
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INVTN_PROGRAM_GROUP
(
  PROGRAM_GROUP_ID               NUMBER         DEFAULT 0                     NOT NULL,
  PREV_PROGRAM_GROUP_ID          NUMBER         DEFAULT 0                     NOT NULL,
  PROGRAM_GROUP_NAME             VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  COMMUNICATION_TEMPLATE         VARCHAR2(50 BYTE),
  LOOK_BACK_VALUE                NUMBER         DEFAULT 0                     NOT NULL,
  INVITATION_TYPE                VARCHAR2(50 BYTE) DEFAULT ' ' NOT NULL,
  ACTIVE_IND                     NUMBER         DEFAULT 1                     NOT NULL,
  BEG_EFFECTIVE_DT_TM            DATE           DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM            DATE           DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  LOOK_BACK_UNIT_CD              NUMBER         DEFAULT 0                     NOT NULL,
  NOTE_TYPE_ID                   NUMBER         DEFAULT 0                     NOT NULL,
  AUTO_GENERATE_IND              NUMBER         DEFAULT 0,
  SENDER_PRSNL_ID                NUMBER         DEFAULT 0,
  AUTO_GEN_CRITERIA_TEXT_ID      NUMBER         DEFAULT 0,
  AUTO_GEN_DESTINATION           VARCHAR2(50 BYTE),
  AUTO_GEN_START_DT_TM           DATE,
  AUTO_GEN_SCHEDULE              VARCHAR2(255 BYTE),
  AUTO_GEN_NEXT_SCHEDULED_DT_TM  DATE,
  AUTO_GEN_LAST_SUCCESS_DT_TM    DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE INVTN_PROGRAM_GROUP_RELTN
(
  PROGRAM_GROUP_RELTN_ID       NUMBER           DEFAULT 0                     NOT NULL,
  PREV_PROGRAM_GROUP_RELTN_ID  NUMBER           DEFAULT 0                     NOT NULL,
  PROGRAM_GROUP_ID             NUMBER           DEFAULT 0                     NOT NULL,
  CRITERIA_ID                  NUMBER           DEFAULT 0                     NOT NULL,
  CRITERIA_NAME                VARCHAR2(30 BYTE) DEFAULT ' ' NOT NULL,
  ACTIVE_IND                   NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  INVTN_VERSION                NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IO_TOTAL_START_TIME
(
  IO_TOTAL_START_TIME_ID  NUMBER                DEFAULT 0                     NOT NULL,
  TOTAL_START_DT_TM       DATE                  DEFAULT SYSDATE               NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_CD                NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IQH_AUTH_GRANT
(
  GRANT_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  REQUEST_ID                 NUMBER             DEFAULT 0                     NOT NULL,
  GRANTOR_PRSNL_ID           NUMBER             DEFAULT 0                     NOT NULL,
  GRANT_DT_TM                DATE               DEFAULT SYSDATE               NOT NULL,
  ACCEPT_DT_TM               DATE,
  ACCEPTOR_PRSNL_ID          NUMBER             DEFAULT 0                     NOT NULL,
  GRANTEE_PRSNL_ID           NUMBER             DEFAULT 0                     NOT NULL,
  AUTH_STATUS_CD             NUMBER             DEFAULT 0                     NOT NULL,
  FUNCTIONAL_AREA_CD         NUMBER             DEFAULT 0                     NOT NULL,
  PERMITTED_ACTION_MASK      VARCHAR2(50 BYTE)  DEFAULT ' '                   NOT NULL,
  FUNCTIONAL_AREA_RECORD_ID  NUMBER             DEFAULT 0                     NOT NULL,
  GRANTING_ACCOUNT_PRSNL_ID  NUMBER             DEFAULT 0                     NOT NULL,
  GRANT_START_DT_TM          DATE               DEFAULT SYSDATE               NOT NULL,
  GRANT_END_DT_TM            DATE,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID     NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IQH_CENTER
(
  IQH_CENTER_ID       NUMBER                    DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  CENTER_NAME_CD      NUMBER                    DEFAULT 0                     NOT NULL,
  CENTER_DESCRIPTION  VARCHAR2(2000 BYTE),
  ACTIVE_IND          NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IQH_CENTER_ELEMENT
(
  IQH_CENTER_ELEMENT_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  IQH_CENTER_MODULE_ID   NUMBER                 DEFAULT 0                     NOT NULL,
  ALIAS                  VARCHAR2(100 BYTE)     DEFAULT ' '                   NOT NULL,
  SEQUENCE               NUMBER                 DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM    DATE                   DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM    DATE                   DEFAULT TO_DATE ( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  PARENT_ENTITY_NAME     VARCHAR2(30 BYTE)      DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  ELEMENT_TEXT           VARCHAR2(2000 BYTE),
  ACTIVE_IND             NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IQH_CENTER_INFO
(
  IQH_CENTER_INFO_ID            NUMBER          DEFAULT 0                     NOT NULL,
  IQH_CENTER_ELEMENT_ID         NUMBER          DEFAULT 0                     NOT NULL,
  IQH_CENTER_MODULE_ID          NUMBER          DEFAULT 0                     NOT NULL,
  CENTER_NAME_CD                NUMBER          DEFAULT 0                     NOT NULL,
  SEQUENCE                      NUMBER          DEFAULT 0                     NOT NULL,
  PERSON_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  INSTANCE_TABLE_NAME           VARCHAR2(30 BYTE) DEFAULT ' ' NOT NULL,
  INSTANCE_TABLE_ID             NUMBER          DEFAULT 0                     NOT NULL,
  COMMENT_TXT                   VARCHAR2(2000 BYTE),
  ALIAS                         VARCHAR2(100 BYTE),
  BEG_EFFECTIVE_DT_TM           DATE            DEFAULT sysdate,
  END_EFFECTIVE_DT_TM           DATE            DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS'),
  ACTIVE_IND                    NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  CENTER_PLAN_NAME_CD           NUMBER          DEFAULT 0                     NOT NULL,
  IQH_CENTER_PERSON_ELEMENT_ID  NUMBER          DEFAULT 0                     NOT NULL,
  BATCH                         FLOAT(126)      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IQH_CENTER_INFO_DETAIL
(
  IQH_CENTER_INFO_DETAIL_ID  NUMBER             DEFAULT 0                     NOT NULL,
  IQH_CENTER_INFO_ID         NUMBER             DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME         VARCHAR2(30 BYTE)  DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID           NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IQH_CENTER_INFO_RR
(
  IQH_CENTER_INFO_RR_ID      NUMBER             DEFAULT 0                     NOT NULL,
  IQH_CENTER_INFO_ID         NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  REFERENCE_RANGE_FROM       FLOAT(126),
  REFERENCE_RANGE_TO         FLOAT(126),
  REFERENCE_RANGE_INCREMENT  FLOAT(126),
  OUTCOME_CD                 NUMBER             DEFAULT 0                     NOT NULL,
  EFFECTIVE_DT_TM            DATE               DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IQH_CENTER_MEDS
(
  IQH_CENTER_MEDS_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  IQH_CENTER_MODULE_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  CENTER_NAME_CD        NUMBER                  DEFAULT 0                     NOT NULL,
  CENTER_MEDS_DISPLAY   VARCHAR2(100 BYTE),
  ORDER_CATALOG_CD      NUMBER                  DEFAULT 0                     NOT NULL,
  DNUM                  VARCHAR2(100 BYTE),
  CATEGORY_CD           NUMBER                  DEFAULT 0                     NOT NULL,
  SYNONYM_ID            NUMBER                  DEFAULT 0                     NOT NULL,
  MEDS_COMMENT          VARCHAR2(2000 BYTE),
  BEG_EFFECTIVE_DT_TM   DATE                    DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM   DATE                    DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS'),
  ACTIVE_IND            NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT sysdate               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  CENTER_PLAN_NAME_CD   NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IQH_CENTER_MODULE
(
  IQH_CENTER_MODULE_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  IQH_CENTER_PLAN_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  CENTER_MODULE_NAME    VARCHAR2(100 BYTE),
  BEG_EFFECTIVE_DT_TM   DATE                    DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM   DATE                    DEFAULT TO_DATE ( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  ACTIVE_IND            NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IQH_CENTER_OUTCOME
(
  IQH_CENTER_OUTCOME_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  OUTCOME_VALUE          VARCHAR2(100 BYTE),
  OUTCOME_TYPE_CD        NUMBER                 DEFAULT 0                     NOT NULL,
  OUTCOME_COMMENT        VARCHAR2(2000 BYTE),
  OUTCOME_DT_TM          DATE                   DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND             NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  IQH_CENTER_INFO_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  OUTCOME_CD             NUMBER                 DEFAULT 0                     NOT NULL,
  SEQUENCE               FLOAT(126)             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IQH_CENTER_PERSON_ELEMENT
(
  IQH_CENTER_PERSON_ELEMENT_ID  NUMBER          DEFAULT 0                     NOT NULL,
  IQH_CENTER_MODULE_ID          NUMBER          DEFAULT 0                     NOT NULL,
  PERSON_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  CENTER_PERSON_ELEMENT_NAME    VARCHAR2(200 BYTE),
  CENTER_PERSON_ELEMENT_DESC    VARCHAR2(2000 BYTE),
  ACTIVE_IND                    NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IQH_CENTER_PERSON_MEDS
(
  IQH_CENTER_PERSON_MEDS_ID  NUMBER             DEFAULT 0                     NOT NULL,
  IQH_CENTER_MEDS_ID         NUMBER             DEFAULT 0                     NOT NULL,
  PERSON_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  TIME_VALUE                 VARCHAR2(200 BYTE),
  DOSE                       VARCHAR2(50 BYTE),
  FREQUENCY_CD               NUMBER             DEFAULT 0                     NOT NULL,
  ROUTE_CD                   NUMBER             DEFAULT 0                     NOT NULL,
  PERSON_MEDS_COMMENT        VARCHAR2(2000 BYTE),
  BEG_EFFECTIVE_DT_TM        DATE               DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM        DATE               DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS'),
  ACTIVE_IND                 NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT sysdate               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  SEQUENCE                   FLOAT(126)         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IQH_CENTER_PLAN
(
  IQH_CENTER_PLAN_ID       NUMBER               DEFAULT 0                     NOT NULL,
  IQH_CENTER_ID            NUMBER               DEFAULT 0                     NOT NULL,
  CENTER_PLAN_NAME_CD      NUMBER               DEFAULT 0                     NOT NULL,
  CENTER_PLAN_DESCRIPTION  VARCHAR2(2000 BYTE),
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE ( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  ACTIVE_IND               NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE IQH_IDENTIFICATION
(
  IDENTIFICATION_ID       NUMBER                DEFAULT 0                     NOT NULL,
  IDENTIFIED_PRSNL_ID     NUMBER                DEFAULT 0                     NOT NULL,
  ADMIN_PRSNL_ID          NUMBER                DEFAULT 0                     NOT NULL,
  IDENTIFIED_DT_TM        DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ITEM_CLASS_NODE_R
(
  CLASS_NODE_ID           NUMBER                DEFAULT 0                     NOT NULL,
  ITEM_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  CLASS_INSTANCE_CD       NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ITEM_COMPONENT
(
  ITEM_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  COMPONENT_ID     NUMBER                       DEFAULT 0                     NOT NULL,
  SEQUENCE         NUMBER                       DEFAULT 0                     NOT NULL,
  PACKAGE_TYPE_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  QTY              FLOAT(126)                   DEFAULT 0                     NOT NULL,
  CREATE_DT_TM     DATE                         DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  CREATE_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  CREATE_TASK      NUMBER                       DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX   NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ITEM_CONTROL_INFO
(
  LOCATION_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  ITEM_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  STOCK_PACKAGE_TYPE_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  STOCK_TYPE_IND         NUMBER,
  LOT_TRACKING_LEVEL_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  CHARGE_TYPE_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  COUNT_CYCLE_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  INSTANCE_IND           NUMBER,
  ABC_CLASS_CD           NUMBER                 DEFAULT 0                     NOT NULL,
  COST_CENTER_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  SUB_ACCOUNT_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  SCH_ROLE_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  LIST_ROLE_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  SCH_QTY                NUMBER,
  COUNTBACK_FLAG         NUMBER                 DEFAULT 0,
  FIRST_DOSE_FLAG        NUMBER,
  OVERRIDE_CLSFCTN_CD    NUMBER                 DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ITEM_DEFINITION
(
  ITEM_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  ITEM_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  REUSABLE_IND            NUMBER,
  BASE_ISSUE_FACTOR       FLOAT(126)            DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_DT_TM            DATE                  DEFAULT SYSDATE               NOT NULL,
  CREATE_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_TASK             NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX          NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  COMPONENT_IND           NUMBER,
  SHELF_LIFE              NUMBER,
  SHELF_LIFE_UOM_CD       NUMBER                DEFAULT 0                     NOT NULL,
  COMPONENT_USAGE_IND     NUMBER,
  BATCH_QTY               NUMBER,
  UNIQUE_FIELD            VARCHAR2(400 BYTE),
  APPROVED_IND            NUMBER,
  QUICKADD_IND            NUMBER,
  SUBSTITUTION_IND        NUMBER,
  LATEX_IND               NUMBER,
  PHA_TYPE_FLAG           NUMBER                DEFAULT 0,
  ITEM_LEVEL_FLAG         NUMBER                DEFAULT 0,
  LOGICAL_DOMAIN_ID       NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ITEM_INSTANCE
(
  INSTANCE_ID             NUMBER                DEFAULT 0                     NOT NULL,
  ACQUISITION_COST        FLOAT(126),
  ACQUISITION_TYPE_CD     NUMBER                DEFAULT 0,
  COMMISSION_DT_TM        DATE,
  CURRENT_LOCATION_CD     NUMBER                DEFAULT 0,
  DISPOSAL_DT_TM          DATE,
  EXPIRE_DT_TM            DATE,
  INSTANCE_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ITEM_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  LOAN_BORROW_IND         NUMBER,
  MANUFACTURER_CD         NUMBER                DEFAULT 0,
  PERSON_ID               NUMBER                DEFAULT 0,
  PURCHASE_ORDER_ID       NUMBER                DEFAULT 0,
  RENTAL_COST             FLOAT(126),
  RENTAL_USAGE_UOM_CD     NUMBER                DEFAULT 0,
  RENTED_DT_TM            DATE,
  STATUS_CD               NUMBER                DEFAULT 0,
  STERILE_IND             NUMBER,
  STORAGE_LOCATION_CD     NUMBER                DEFAULT 0,
  SVC_GROUP_CD            NUMBER                DEFAULT 0,
  VENDOR_CD               NUMBER                DEFAULT 0,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_DT_TM            DATE                  DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  CREATE_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_TASK             NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX          NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  PO_NBR                  VARCHAR2(40 BYTE),
  UNIQUE_FIELD            VARCHAR2(200 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ITEM_ITEM_XREF
(
  PARENT_ITEM_ID  NUMBER                        DEFAULT 0                     NOT NULL,
  CHILD_ITEM_ID   NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ITEM_LOCATION_COST
(
  ITEM_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  LOCATION_CD      NUMBER                       DEFAULT 0                     NOT NULL,
  COST_TYPE_CD     NUMBER                       DEFAULT 0                     NOT NULL,
  PACKAGE_TYPE_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  COST             FLOAT(126)                   DEFAULT 0                     NOT NULL,
  CREATE_DT_TM     DATE                         DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  CREATE_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  CREATE_TASK      NUMBER                       DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX   NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ITEM_ORG_RELTN
(
  ITEM_ORG_RELTN_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  ITEM_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  ORG_ID             NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ITEM_PRICE
(
  ITEM_PRICE_ID             NUMBER              DEFAULT 0                     NOT NULL,
  VENDOR_PRICE_SCHEDULE_ID  NUMBER              DEFAULT 0                     NOT NULL,
  PACKAGE_TYPE_ID           NUMBER              DEFAULT 0                     NOT NULL,
  PRICE                     FLOAT(126)          DEFAULT 0                     NOT NULL,
  PRICE_TYPE_CD             NUMBER              DEFAULT 0                     NOT NULL,
  CONTRACT_ID               NUMBER              DEFAULT 0                     NOT NULL,
  CONTRACT_DESCRIPTION      VARCHAR2(100 BYTE),
  CONTRACT_TYPE             VARCHAR2(100 BYTE),
  EFFECTIVE_DT_TM           DATE,
  EXPIRATION_DT_TM          DATE,
  FIXED_PRICE_IND           NUMBER,
  ORDER_QTY_MULTIPLE        NUMBER,
  CONTRIBUTOR_SYSTEM_CD     NUMBER              DEFAULT 0                     NOT NULL,
  PRICE_QUOTE_SOURCE        VARCHAR2(100 BYTE),
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX            NUMBER,
  CREATE_DT_TM              DATE,
  CREATE_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  CREATE_TASK               NUMBER,
  CONTRACT_LINE_ID          NUMBER              DEFAULT 0                     NOT NULL,
  CONTRACT_NBR              VARCHAR2(40 BYTE),
  MIN_ORDER_QTY             FLOAT(126),
  ORGANIZATION_ID           NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ITEM_SR_LOC_R
(
  ITEM_SR_LOC_TYPE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  LOCATION_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  ITEM_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  SEQUENCE             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LABEL_PRINTER_DEF
(
  KEY_ID               NUMBER                   DEFAULT 0                     NOT NULL,
  LOCATION_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  COLL_PRIORITY_CD     NUMBER                   DEFAULT 0                     NOT NULL,
  DEFAULT_TYPE_FLAG    NUMBER                   DEFAULT 0                     NOT NULL,
  LBL_PRINTER_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  LBL_QUEUE_NAME       VARCHAR2(20 BYTE),
  NURSE_PRINTER_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  NURSE_QUEUE_NAME     VARCHAR2(20 BYTE),
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  SEQUENCE             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LAB_BENCH
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  WORKLIST_BUILD_FLAG  NUMBER,
  WORKLIST_HOURS       NUMBER,
  WORKLIST_MAX         NUMBER,
  CONTAINER_IND        NUMBER,
  GATE_IND             NUMBER,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LAB_INSTRUMENT
(
  SERVICE_RESOURCE_CD            NUMBER         DEFAULT 0                     NOT NULL,
  STRT_MODEL_ID                  NUMBER         DEFAULT 0                     NOT NULL,
  INSTR_IDENTIFIER               NUMBER,
  OPER_MODE                      CHAR(1 BYTE),
  IDENTIFIER_FLAG                NUMBER,
  AUTO_VERIFY_FLAG               NUMBER,
  WORKLIST_BUILD_FLAG            NUMBER,
  WORKLIST_HOURS                 NUMBER,
  WORKLIST_MAX                   NUMBER,
  CONTAINER_IND                  NUMBER,
  GATE_IND                       NUMBER,
  INSTR_ALIAS                    VARCHAR2(100 BYTE),
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  VERBOSITY                      CHAR(1 BYTE),
  STATION                        CHAR(4 BYTE),
  INSTR_NAME                     VARCHAR2(20 BYTE),
  MIC_ID_PROB_LIMIT              NUMBER,
  MIC_AUTO_INTERP_FLAG           NUMBER,
  MIC_SEC_INTERP_IND             NUMBER,
  ACTIVE_IND                     NUMBER,
  CQM_APP_NAME                   VARCHAR2(12 BYTE),
  CQM_CONTRIB_NAME               VARCHAR2(48 BYTE),
  INSTRU_TYPE                    NUMBER,
  ID_MAP_JULIAN                  CHAR(18 BYTE),
  ID_MAP_PREFIX                  CHAR(18 BYTE),
  ID_NBR_SIZE                    CHAR(2 BYTE),
  ID_TYPE                        CHAR(1 BYTE),
  ISOLATE_NBR_SIZE               CHAR(1 BYTE),
  ISOLATE_TYPE                   CHAR(1 BYTE),
  CQM_ALIAS_NAME                 VARCHAR2(48 BYTE),
  PRSNL_ID                       NUMBER         DEFAULT 0                     NOT NULL,
  PRSNL_BEG_EFF_DT_TM            DATE,
  PRSNL_END_EFF_DT_TM            DATE,
  AV_IND                         NUMBER,
  AV_FLAG                        NUMBER,
  AV_QC_IND                      NUMBER,
  AV_REQ_QC_IND                  NUMBER,
  AV_CHK_PART_QC_IND             NUMBER,
  INTFC_PROGNAME                 CHAR(15 BYTE),
  MIC_DOWNLOAD_LEVEL_FLAG        NUMBER,
  AV_PART_IND                    NUMBER,
  ROBOTICS_NAME                  VARCHAR2(20 BYTE),
  ROBOTICS_DEST                  NUMBER,
  VERIFY_BARCODE_IND             NUMBER,
  ROUTE_AT_COMPLETION_IND        NUMBER,
  AV_QC_PART_IND                 NUMBER,
  POINT_OF_CARE_FLAG             NUMBER,
  MULTIPLEXOR_ALIAS              CHAR(20 BYTE),
  MULTIPLEXOR_IND                NUMBER,
  AUTHENTICATION_ID              NUMBER         DEFAULT 0                     NOT NULL,
  AUTO_EXPLODE_IND               NUMBER,
  AV_CHECK_PART_QC_FLAG          NUMBER         DEFAULT 0                     NOT NULL,
  UPDATE_REQUEST_NUMBER          NUMBER         DEFAULT 0                     NOT NULL,
  ROBOTICS_ALIQUOT_DIGIT         CHAR(1 BYTE),
  LOG_FLAG                       NUMBER         DEFAULT 0                     NOT NULL,
  RMOD                           VARCHAR2(20 BYTE),
  RESULT_FORMAT_CD               NUMBER         DEFAULT 0                     NOT NULL,
  HOLIDAY_SCHEDULE_CD            NUMBER         DEFAULT 0                     NOT NULL,
  SCHEDULE_CD                    NUMBER         DEFAULT 0                     NOT NULL,
  DISABLE_MICRO_PROBABILITY_IND  NUMBER         DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LH_MU_METRIC_DETAILS
(
  LH_MU_METRIC_DETAILS_ID  NUMBER               DEFAULT 0                     NOT NULL,
  LH_MU_FX_METRICS_ID      NUMBER               DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME       VARCHAR2(50 BYTE)    DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID         NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_DT_TM              DATE,
  NUMERATOR_IND            NUMBER               DEFAULT 0                     NOT NULL,
  METRIC_TYPE              VARCHAR2(50 BYTE),
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_SOURCE              VARCHAR2(50 BYTE),
  UPDT_TASK                VARCHAR2(50 BYTE),
  HEALTH_SYSTEM_ID         NUMBER               DEFAULT 0,
  FIRST_PROCESS_DT_TM      DATE,
  LAST_PROCESS_DT_TM       DATE,
  EXTRACT_DT_TM            DATE,
  BR_ELIGIBLE_PROVIDER_ID  NUMBER               DEFAULT 0,
  HEALTH_SYSTEM_SOURCE_ID  NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LIBRARY_GROUP
(
  SERVICE_RESOURCE_CD   NUMBER                  DEFAULT 0                     NOT NULL,
  CHK_DIFF_BORR_IND     NUMBER,
  DAILY_FOLDER_IND      NUMBER,
  FOLDER_NBR_FORMAT_CD  NUMBER                  DEFAULT 0                     NOT NULL,
  RETURN_LOC_FLAG       NUMBER,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UNREAD_FILMS_IND      NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LIB_GRP_RELTN
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  LIB_GROUP_CD         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LINE_ITEM
(
  LINE_ITEM_ID             NUMBER               DEFAULT 0                     NOT NULL,
  VENDOR_ITEM_ID           NUMBER               DEFAULT 0                     NOT NULL,
  VENDOR_CD                NUMBER               DEFAULT 0                     NOT NULL,
  ITEM_MASTER_ID           NUMBER               DEFAULT 0                     NOT NULL,
  REQUISITION_ID           NUMBER               DEFAULT 0                     NOT NULL,
  PURCHASE_ORDER_ID        NUMBER               DEFAULT 0                     NOT NULL,
  PO_LINE_NBR              NUMBER,
  REQ_LINE_NBR             NUMBER,
  DELIVER_TO_LOCATION_CD   NUMBER               DEFAULT 0                     NOT NULL,
  FILL_LOCATION_CD         NUMBER               DEFAULT 0                     NOT NULL,
  COST_CENTER_CD           NUMBER               DEFAULT 0                     NOT NULL,
  SUB_ACCOUNT_CD           NUMBER               DEFAULT 0                     NOT NULL,
  PROJECT_CD               NUMBER               DEFAULT 0                     NOT NULL,
  PRIORITY_CD              NUMBER               DEFAULT 0                     NOT NULL,
  DUE_DT_TM                DATE,
  REQ_LINE_STATUS_CD       NUMBER               DEFAULT 0                     NOT NULL,
  PO_LINE_STATUS_CD        NUMBER               DEFAULT 0                     NOT NULL,
  AUTO_RECEIVE_IND         NUMBER,
  REQUESTOR                VARCHAR2(100 BYTE),
  BUYER_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  ATTENTION                VARCHAR2(100 BYTE),
  REFERENCE                VARCHAR2(40 BYTE),
  SHIP_TO_LOCATION_CD      NUMBER               DEFAULT 0                     NOT NULL,
  PURCHASING_SVC_RES_CD    NUMBER               DEFAULT 0                     NOT NULL,
  VALID_PO_LINE_IND        NUMBER,
  VALID_REQ_LINE_IND       NUMBER,
  CREATE_DT_TM             DATE                 DEFAULT SYSDATE               NOT NULL,
  CREATE_ID                NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_TASK              NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX           NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  LINE_ACK_STATUS_CD       NUMBER               DEFAULT 0                     NOT NULL,
  ORIGINAL_VENDOR_ITEM_ID  NUMBER               DEFAULT 0                     NOT NULL,
  ORIGINAL_MANUF_ITEM_ID   NUMBER               DEFAULT 0                     NOT NULL,
  ACK_VENDOR_ITEM_NBR      VARCHAR2(40 BYTE),
  ACK_VENDOR_ITEM_DESC     VARCHAR2(100 BYTE),
  ACK_MANUF_ITEM_NBR       VARCHAR2(40 BYTE),
  ACK_MANUF_ITEM_DESC      VARCHAR2(100 BYTE),
  ACK_PKG_TYPE_QTY         FLOAT(126),
  ACK_UOM                  VARCHAR2(40 BYTE),
  LINE_ITEM_VERSION        NUMBER,
  NEXT_VERSION_NBR         NUMBER,
  MISC_CD                  NUMBER               DEFAULT 0                     NOT NULL,
  MANUF_ITEM_ID            NUMBER               DEFAULT 0                     NOT NULL,
  MANUF_CD                 NUMBER               DEFAULT 0                     NOT NULL,
  REQ_ALLOW_MOD_IND        NUMBER,
  CONSIGNMENT_IND          NUMBER,
  BILL_ONLY_IND            NUMBER,
  APPROVAL_STATUS_DT_TM    DATE,
  AUTO_DISTRIBUTE_IND      NUMBER,
  NC_MFR_ITEM_NBR          VARCHAR2(20 BYTE)    DEFAULT ' ',
  NC_MFR                   VARCHAR2(60 BYTE)    DEFAULT ' ',
  NC_VENDOR_ITEM_NBR       VARCHAR2(20 BYTE)    DEFAULT ' ',
  NC_DESCRIPTION           VARCHAR2(255 BYTE)   DEFAULT ' ',
  NON_CATALOG_IND          NUMBER               DEFAULT 0,
  NC_MFR_CD                NUMBER               DEFAULT 0                     NOT NULL,
  SUBSTITUTION_IND         NUMBER               DEFAULT 0,
  REQ_TRANSMIT_DT_TM       DATE,
  LOCKED_BY_PRSNL_ID       NUMBER               DEFAULT 0                     NOT NULL,
  LOCKED_DT_TM             DATE,
  CHARGE_FLAG              NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  REAL_TIME_OUTBOUND_IND   NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LINE_ITEM_QUANTITY
(
  PARENT_ENTITY_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  LINE_ITEM_QTY_TYPE_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  PACKAGE_TYPE_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME     VARCHAR2(40 BYTE)      DEFAULT ' '                   NOT NULL,
  QTY                    FLOAT(126)             DEFAULT 0                     NOT NULL,
  PACKAGE_TYPE_UOM_CD    NUMBER                 DEFAULT 0                     NOT NULL,
  PACKAGE_TYPE_DESC      VARCHAR2(100 BYTE),
  PACKAGE_TYPE_QTY       FLOAT(126),
  PACKAGE_TYPE_PRICE     FLOAT(126),
  ITEM_PRICE_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  PRICE_TYPE_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  BASE_PKG_TYPE_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  BASE_PKG_TYPE_UOM_CD   NUMBER                 DEFAULT 0                     NOT NULL,
  BASE_PKG_TYPE_DESC     VARCHAR2(100 BYTE),
  BASE_PKG_TYPE_QTY      FLOAT(126),
  REASON_CD              NUMBER                 DEFAULT 0                     NOT NULL,
  CREATE_DT_TM           DATE                   DEFAULT SYSDATE               NOT NULL,
  CREATE_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  CREATE_TASK            NUMBER                 DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX         NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  VEND_SHIP_DT_TM        DATE,
  SEL_PKG_TYPE_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  SEL_PKG_TYPE_UOM_CD    NUMBER                 DEFAULT 0                     NOT NULL,
  SEL_PKG_TYPE_DESC      VARCHAR2(100 BYTE),
  SEL_PKG_TYPE_QTY       FLOAT(126),
  TO_PKG_TYPE_DESC       VARCHAR2(100 BYTE),
  TO_PKG_TYPE_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  TO_PKG_TYPE_QTY        FLOAT(126),
  TO_PKG_TYPE_UOM_CD     NUMBER                 DEFAULT 0                     NOT NULL,
  EXTENDED_AMOUNT        FLOAT(126),
  EXTENDED_PRICE         FLOAT(126),
  UNIT_TAX               FLOAT(126)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LINE_SCHEDULED_QTY
(
  LINE_SCHEDULED_QTY_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  LINE_ITEM_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  SCHEDULED_DT_TM        DATE                   DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  SCHEDULED_QTY          FLOAT(126)             DEFAULT 0                     NOT NULL,
  CREATE_DT_TM           DATE                   DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  CREATE_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  CREATE_TASK            NUMBER                 DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX         NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LOCATION
(
  LOCATION_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  LOCATION_TYPE_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID              NUMBER           DEFAULT 0                     NOT NULL,
  RESOURCE_IND                 NUMBER,
  ACTIVE_IND                   NUMBER,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  CENSUS_IND                   NUMBER,
  CONTRIBUTOR_SYSTEM_CD        NUMBER           DEFAULT 0                     NOT NULL,
  DATA_STATUS_CD               NUMBER           DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM            DATE,
  DATA_STATUS_PRSNL_ID         NUMBER           DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  FACILITY_ACCN_PREFIX_CD      NUMBER           DEFAULT 0                     NOT NULL,
  DISCIPLINE_TYPE_CD           NUMBER           DEFAULT 0                     NOT NULL,
  VIEW_TYPE_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  EXP_LVL_CD                   NUMBER           DEFAULT 0,
  CHART_FORMAT_ID              NUMBER           DEFAULT 0,
  TRANSMIT_OUTBOUND_ORDER_IND  NUMBER,
  PATCARE_NODE_IND             NUMBER,
  REGISTRATION_IND             NUMBER,
  CONTRIBUTOR_SOURCE_CD        NUMBER           DEFAULT 0,
  REF_LAB_ACCT_NBR             VARCHAR2(20 BYTE),
  ICU_IND                      NUMBER,
  RESERVE_IND                  NUMBER           DEFAULT 0                     NOT NULL,
  APACHE_RELTN_FLAG            NUMBER           DEFAULT 0,
  TRANSFER_DT_TM_IND           NUMBER           DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LOCATION_GROUP
(
  PARENT_LOC_CD           NUMBER                DEFAULT 0                     NOT NULL,
  CHILD_LOC_CD            NUMBER                DEFAULT 0                     NOT NULL,
  LOCATION_GROUP_TYPE_CD  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  SEQUENCE                NUMBER,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ROOT_LOC_CD             NUMBER                DEFAULT 0                     NOT NULL,
  VIEW_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LOCATION_INV_INFO
(
  LOCATION_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  COST_CENTER_CD               NUMBER           DEFAULT 0                     NOT NULL,
  SHIP_TO_LOCATION_CD          NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  COST_TYPE_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID              NUMBER           DEFAULT 0                     NOT NULL,
  PICK_LIST_PRINTER            VARCHAR2(40 BYTE),
  STOCK_OUT_PRINTER            VARCHAR2(40 BYTE),
  BACKORDER_IND                NUMBER           DEFAULT 0,
  BACKORDER_PRINTER            VARCHAR2(40 BYTE),
  AUTO_DISTRIBUTE_IND          NUMBER           DEFAULT 0,
  CHK_AVAILABLE_IND            NUMBER           DEFAULT 0,
  SYS_CALC_PAR_FLAG            NUMBER           DEFAULT 0                     NOT NULL,
  PAR_CALC_PRINTER             VARCHAR2(40 BYTE),
  SYS_CALC_PAR_DAYS            NUMBER,
  MOBILE_PICKING_IND           NUMBER,
  PRINT_REQ_LINE_COMMENTS_IND  NUMBER           DEFAULT 0,
  PRINT_REQ_HDR_COMMENTS_IND   NUMBER           DEFAULT 0,
  COST_FLAG                    NUMBER           DEFAULT 0,
  PRINT_PT_BACKORDER_FLAG      NUMBER           DEFAULT 0,
  NO_AUTO_FILL_FLAG            NUMBER           DEFAULT 0,
  OFFSET_ACCOUNT_IND           NUMBER           DEFAULT 0,
  LOCK_REQ_UOM_FLAG            NUMBER           DEFAULT 0,
  ITEM_ORG_RELTN_IND           NUMBER           DEFAULT 0,
  SHOW_FILL_LOC_QOH_FLAG       NUMBER           DEFAULT 0,
  FILTER_CC_SA_IND             NUMBER           DEFAULT 0,
  LOC_DISPLAY_FLAG             NUMBER           DEFAULT 2,
  PATIENT_NAME_REQUIRED_IND    NUMBER           DEFAULT 0,
  REAL_TIME_REQ_OUTBOUND_IND   NUMBER           DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LOCATOR_ROLLUP
(
  LOCATION_CD           NUMBER                  DEFAULT 0                     NOT NULL,
  LOCATOR_CD            NUMBER                  DEFAULT 0                     NOT NULL,
  ITEM_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  RELATIONSHIP_TYPE_CD  NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  PACKAGE_TYPE_ID       NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LOC_RESOURCE_CALENDAR
(
  SERVICE_RESOURCE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  LOCATION_CD             NUMBER                DEFAULT 0                     NOT NULL,
  LOC_RESOURCE_TYPE_CD    NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  SEQUENCE                NUMBER                DEFAULT 0                     NOT NULL,
  CALENDAR_SEQ            NUMBER                DEFAULT 0                     NOT NULL,
  DOW                     NUMBER,
  PRIORITY_CD             NUMBER                DEFAULT 0                     NOT NULL,
  OPEN_TIME               NUMBER,
  CLOSE_TIME              NUMBER,
  AVAIL_IND               NUMBER,
  DESCRIPTION             VARCHAR2(200 BYTE),
  SPECIMEN_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE ( '12/31/210000:00:00' , 'MM/DD/YYYYHH24:MI:SS' ) NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  DISPENSE_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  AGE_FROM_MINUTES        NUMBER,
  AGE_FROM_UNITS_CD       NUMBER                DEFAULT 0                     NOT NULL,
  AGE_TO_MINUTES          NUMBER,
  AGE_TO_UNITS_CD         NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LOC_RESOURCE_R
(
  SERVICE_RESOURCE_CD            NUMBER         DEFAULT 0                     NOT NULL,
  LOCATION_CD                    NUMBER         DEFAULT 0                     NOT NULL,
  LOC_RESOURCE_TYPE_CD           NUMBER         DEFAULT 0                     NOT NULL,
  SEQUENCE                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  MM_VENDOR_CUSTOMER_ACCOUNT_ID  NUMBER         DEFAULT 0                     NOT NULL,
  GROUP_SEQUENCE                 NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LOGICAL_DOMAIN
(
  LOGICAL_DOMAIN_ID       NUMBER                DEFAULT 0                     NOT NULL,
  MNEMONIC                VARCHAR2(100 BYTE)    DEFAULT ' '                   NOT NULL,
  MNEMONIC_KEY            VARCHAR2(100 BYTE)    DEFAULT ' '                   NOT NULL,
  DESCRIPTION             VARCHAR2(255 BYTE)    DEFAULT ' '                   NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 1                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  MNEMONIC_KEY_NLS        VARCHAR2(202 BYTE)    DEFAULT ' '                   NOT NULL,
  SYSTEM_USER_ID          NUMBER                DEFAULT 0                     NOT NULL,
  MNEMONIC_KEY_A_NLS      VARCHAR2(400 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LOGICAL_DOMAIN_GRP_RELTN
(
  LOGICAL_DOMAIN_GRP_RELTN_ID  NUMBER           DEFAULT 0                     NOT NULL,
  LOGICAL_DOMAIN_ID            NUMBER           DEFAULT 0                     NOT NULL,
  LOGICAL_DOMAIN_GRP_ID        NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS'),
  ACTIVE_IND                   NUMBER           DEFAULT 1                     NOT NULL,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE LOT_NUMBER_LOCATION_INFO
(
  LOT_NUMBER_ID    NUMBER                       DEFAULT 0                     NOT NULL,
  LOCATION_CD      NUMBER                       DEFAULT 0                     NOT NULL,
  PACKAGE_TYPE_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  QTY              FLOAT(126)                   DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_ASSESSMENT_SERIES
(
  STUDY_ID           NUMBER                     DEFAULT 0                     NOT NULL,
  ASSESSMENT_ID      NUMBER                     DEFAULT 0                     NOT NULL,
  SEQUENCE           NUMBER                     DEFAULT 0                     NOT NULL,
  RECALL_INTERVAL    NUMBER                     DEFAULT 0                     NOT NULL,
  FOLLOW_UP_PROC_CD  NUMBER                     DEFAULT 0                     NOT NULL,
  ASSIGNED_DT_TM     DATE                       DEFAULT SYSDATE               NOT NULL,
  SERIES_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  SERIES_OPEN_IND    NUMBER,
  RAD_ID             NUMBER                     DEFAULT 0                     NOT NULL,
  LETTER_ID          NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_BREAST_FIND
(
  BREAST_FIND_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  STUDY_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  SIDE_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  BREAST_COMP_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  PRIOR_SURG_FOL_UP_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  CHANGES_ID            NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_FIND
(
  FIND_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  BREAST_FIND_ID   NUMBER                       DEFAULT 0                     NOT NULL,
  SEQUENCE         NUMBER,
  LESION_CLASS_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  PATH_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  SCD_TERM_ID      NUMBER                       DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_FIND_DETAIL
(
  FIND_DETAIL_ID  NUMBER                        DEFAULT 0                     NOT NULL,
  FIND_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  FIELD_ID        NUMBER                        DEFAULT 0                     NOT NULL,
  NUMERIC_VALUE   NUMBER,
  VALUE_DT_TM     DATE,
  TEXT_VALUE      VARCHAR2(255 BYTE),
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL,
  VALUE_TZ        NUMBER                        DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_FOLLOW_UP
(
  STUDY_ID        NUMBER                        DEFAULT 0                     NOT NULL,
  CATALOG_CD      NUMBER                        DEFAULT 0,
  CASE_STATUS_CD  NUMBER                        DEFAULT 0,
  RECALL_DT_TM    DATE,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_FOL_UP_LETTER_SECT
(
  MAMMO_FOL_UP_LETTER_SECT_ID  NUMBER           DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD          NUMBER           DEFAULT 0                     NOT NULL,
  FOL_UP_LETTER_TYPE_CD        NUMBER           DEFAULT 0                     NOT NULL,
  TEMPLATE_ID                  NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_LETTER_DETAIL
(
  LETTER_ID     NUMBER                          DEFAULT 0                     NOT NULL,
  SEQUENCE      NUMBER                          DEFAULT 0                     NOT NULL,
  TEMPLATE_ID   NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_NOTIFICATION
(
  STUDY_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  SEQUENCE                   NUMBER             DEFAULT 0                     NOT NULL,
  TEMPLATE_ID                NUMBER             DEFAULT 0                     NOT NULL,
  FOLLOW_UP_DEFAULT_TYPE_CD  NUMBER             DEFAULT 0                     NOT NULL,
  NOTIFY_DT_TM               DATE,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  LETTER_ID                  NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_NOTIFICATION_HIST
(
  STUDY_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  HIST_SEQUENCE              NUMBER             DEFAULT 0                     NOT NULL,
  SEQUENCE                   NUMBER             DEFAULT 0                     NOT NULL,
  TEMPLATE_ID                NUMBER             DEFAULT 0                     NOT NULL,
  FOLLOW_UP_DEFAULT_TYPE_CD  NUMBER             DEFAULT 0                     NOT NULL,
  NOTIFY_DT_TM               DATE,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  LETTER_ID                  NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_PROBLEM
(
  STUDY_ID      NUMBER                          DEFAULT 0                     NOT NULL,
  PROBLEM_ID    NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_RECOMMEND_SEQ
(
  STUDY_ID           NUMBER                     DEFAULT 0                     NOT NULL,
  RECOMMENDATION_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  SEQUENCE           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_RECOMMEND_SERIES
(
  STUDY_ID           NUMBER                     DEFAULT 0                     NOT NULL,
  RECOMMENDATION_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  SEQUENCE           NUMBER                     DEFAULT 0                     NOT NULL,
  SERIES_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_RISK
(
  STUDY_ID      NUMBER                          DEFAULT 0                     NOT NULL,
  FACTOR_ID     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_STUDY
(
  STUDY_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CATALOG_CD              NUMBER                DEFAULT 0                     NOT NULL,
  STUDY_DT_TM             DATE,
  REASON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ASSESSMENT_ID           NUMBER                DEFAULT 0                     NOT NULL,
  RECOMMENDATION_ID       NUMBER                DEFAULT 0                     NOT NULL,
  STAT_CAT_ID             NUMBER                DEFAULT 0                     NOT NULL,
  RECALL_INTERVAL         NUMBER,
  ACTIVE_IND              NUMBER,
  SUBSECTION_CD           NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  GROUP_REFERENCE_NBR     VARCHAR2(40 BYTE),
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  EDITION_NBR             NUMBER                DEFAULT 0                     NOT NULL,
  LETTER_ID               NUMBER                DEFAULT 0                     NOT NULL,
  STAT_CAT_FLAG           NUMBER,
  DOWNLOAD_IND            NUMBER                DEFAULT 0,
  NO_FOL_UP_REQ_IND       NUMBER                DEFAULT 0,
  STUDY_TZ                NUMBER                DEFAULT 0,
  EXCLUDE_FROM_AUDIT_IND  NUMBER                DEFAULT 0                     NOT NULL,
  SEQ_EXAM_ID             NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_STUDY_PRSNL
(
  STUDY_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_RELATION_FLAG  NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MAMMO_USER_DEF
(
  USER_VALUE_ID  NUMBER                         DEFAULT 0                     NOT NULL,
  STUDY_ID       NUMBER                         DEFAULT 0,
  FIELD_ID       NUMBER                         DEFAULT 0,
  NUMERIC_VALUE  NUMBER,
  VALUE_DT_TM    DATE,
  TEXT_VALUE     VARCHAR2(255 BYTE),
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL,
  VALUE_TZ       NUMBER                         DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MATCH_TAG_PARMS
(
  CONTRIBUTOR_SYSTEM_CD       NUMBER            DEFAULT 0                     NOT NULL,
  MATCH_FUNCTION_CD           NUMBER            DEFAULT 0                     NOT NULL,
  MATCH_FIELD_CD              NUMBER            DEFAULT 0                     NOT NULL,
  MATCH_SEQ                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM         DATE              DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM         DATE              DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ALIAS_ENTITY_NAME           VARCHAR2(32 BYTE),
  ALIAS_ENTITY_ALIAS_TYPE_CD  NUMBER            DEFAULT 0                     NOT NULL,
  MATCH_VALIDATION_CD         NUMBER            DEFAULT 0                     NOT NULL,
  PRIM_ALIAS_IND              NUMBER,
  ALIAS_POOL_CD               NUMBER            DEFAULT 0                     NOT NULL,
  BILLING_IND                 NUMBER            DEFAULT 0,
  ORDER_CONTROL_CD            NUMBER            DEFAULT 0                     NOT NULL,
  OPF_IND                     NUMBER,
  WEIGHT                      FLOAT(126),
  MATCH_TAG_PARMS_ID          NUMBER            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MDI_APPL_ACK
(
  MESSAGE_IDENT        VARCHAR2(32 BYTE),
  ORDER_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  ACCESSION            VARCHAR2(20 BYTE),
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  ERROR_COND           VARCHAR2(4 BYTE),
  CREATE_DT_TM         DATE,
  INPROCESS_IND        NUMBER,
  PROCESS_STATUS_FLAG  NUMBER,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MDI_PARAMETER
(
  MDI_PARAMETER_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  MDI_PARAMETER_CD     NUMBER                   DEFAULT 0                     NOT NULL,
  MDI_PARAMETER_DEF    VARCHAR2(12 BYTE),
  SELECTED_IND         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MDM_LOAD_HIST_PARAMS
(
  MDM_LOAD_HIST_PARAMS_ID  NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  CUTOFF_DT_TM             DATE                 DEFAULT TO_DATE( '01/01/1800 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MDM_PW_ACT_OUTCOME
(
  MDM_PW_ACT_OUTCOME_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  OUTCOME_ACTIVITY_ID    NUMBER                 DEFAULT 0                     NOT NULL,
  CUTOFF_DT_TM           DATE                   DEFAULT TO_DATE( '11/18/1858 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  CLINICAL_EVENT_SK      VARCHAR2(20 BYTE),
  ACT_OUTCOME            VARCHAR2(250 BYTE),
  OUTCOME_MET_IND        NUMBER,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MDM_TRANS_BATCH
(
  BATCH_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM   DATE                    DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM   DATE                    DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS'),
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  CLINICAL_EVENT_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  OUTCOME_PROCESS_FLAG  NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MEDIA
(
  SEQ_OBJECT_ID     NUMBER                      DEFAULT 0                     NOT NULL,
  CONTINUE_TAPE_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  TAPE_TYPE_CD      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MEDIA_ENCNTR_RELTN
(
  MEDIA_ENCNTR_RELTN_ID   NUMBER                DEFAULT 0                     NOT NULL,
  MEDIA_MASTER_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MEDIA_EXAM
(
  SEQ_EXAM_ID        NUMBER                     DEFAULT 0                     NOT NULL,
  SEQ_OBJECT_ID      NUMBER                     DEFAULT 0                     NOT NULL,
  ENCNTR_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  EXAM_POSN          NUMBER,
  OPTICAL_DISK_SIDE  NUMBER,
  TRACK_BEGIN        NUMBER,
  TRACK_END          NUMBER,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  PERSON_ID          NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MEDIA_MASTER
(
  MEDIA_MASTER_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  MEDIA_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_MEDIA_MASTER_ID  NUMBER                DEFAULT 0                     NOT NULL,
  PERMANENT_LOC_CD        NUMBER                DEFAULT 0                     NOT NULL,
  CURRENT_LOC_CD          NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_DT_TM            DATE,
  CREATE_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  RETURN_LOC_CD           NUMBER                DEFAULT 0                     NOT NULL,
  MEDIA_STATUS_CD         NUMBER                DEFAULT 0                     NOT NULL,
  EPISODE_ID              NUMBER                DEFAULT 0                     NOT NULL,
  VOLUME_NBR              NUMBER,
  STORAGE_CD              NUMBER                DEFAULT 0                     NOT NULL,
  MOVEMENT_DT_TM          DATE,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  PREV_INTERNAL_LOC_CD    NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  FRAME                   VARCHAR2(15 BYTE),
  FREETEXT_ROLL_FRAME     VARCHAR2(255 BYTE),
  MEDIA_COMMENT           VARCHAR2(255 BYTE),
  ROLL                    VARCHAR2(15 BYTE),
  PERSON_ALIAS_ID         NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MEDIA_MASTER_ALIAS
(
  MEDIA_MASTER_ALIAS_ID   NUMBER                DEFAULT 0                     NOT NULL,
  MEDIA_MASTER_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ALIAS                   NUMBER,
  ALIAS_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  ALIAS_POOL_CD           NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ALIAS_STR               VARCHAR2(200 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MEDIA_MASTER_HIST
(
  MEDIA_MASTER_HIST_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  MEDIA_MASTER_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  PERSON_ALIAS_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  ACTIVE_IND            NUMBER                  DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM   DATE,
  END_EFFECTIVE_DT_TM   DATE,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MEDIA_MOVEMENT
(
  MEDIA_MOVEMENT_ID        NUMBER               DEFAULT 0                     NOT NULL,
  MEDIA_MASTER_ID          NUMBER               DEFAULT 0                     NOT NULL,
  RECORDING_PRSNL_ID       NUMBER               DEFAULT 0                     NOT NULL,
  SYSTEM_ASSUMED_MOVEMENT  NUMBER,
  TO_LOCATION_CD           NUMBER               DEFAULT 0                     NOT NULL,
  TO_MEDIA_MASTER_ID       NUMBER               DEFAULT 0                     NOT NULL,
  FROM_LOCATION_CD         NUMBER               DEFAULT 0                     NOT NULL,
  FROM_MEDIA_MASTER_ID     NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_DT_TM             DATE,
  CREATE_PRSNL_ID          NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  FRAME                    VARCHAR2(15 BYTE),
  FREETEXT_ROLL_FRAME      VARCHAR2(255 BYTE),
  MEDIA_COMMENT            VARCHAR2(255 BYTE),
  ROLL                     VARCHAR2(15 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MEDIA_ORG_RELTN
(
  MEDIA_ORG_RELTN_ID      NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  MEDIA_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MEDICATION_DEFINITION
(
  ITEM_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  MDX_GFC_NOMEN_ID                NUMBER        DEFAULT 0                     NOT NULL,
  ORDER_SENTENCE_ID               NUMBER        DEFAULT 0                     NOT NULL,
  FORM_CD                         NUMBER        DEFAULT 0                     NOT NULL,
  STRENGTH                        FLOAT(126),
  STRENGTH_UNIT_CD                NUMBER        DEFAULT 0                     NOT NULL,
  VOLUME                          FLOAT(126),
  DIVISIBLE_IND                   NUMBER,
  VOLUME_UNIT_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  GIVEN_STRENGTH                  VARCHAR2(25 BYTE),
  FORMULARY_STATUS_CD             NUMBER        DEFAULT 0                     NOT NULL,
  DEFAULT_PAR_DOSES               NUMBER,
  MAX_PAR_SUPPLY                  NUMBER,
  LEGAL_STATUS_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  DISPENSE_CATEGORY_CD            NUMBER        DEFAULT 0                     NOT NULL,
  ALTERNATE_DISPENSE_CATEGORY_CD  NUMBER        DEFAULT 0                     NOT NULL,
  USED_AS_BASE_IND                NUMBER,
  ORDER_ALERT1_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  ORDER_ALERT2_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  COMMENT1_ID                     NUMBER        DEFAULT 0                     NOT NULL,
  COMMENT1_TYPE                   NUMBER,
  COMMENT2_ID                     NUMBER        DEFAULT 0                     NOT NULL,
  COMMENT2_TYPE                   NUMBER,
  OE_FORMAT_FLAG                  NUMBER        DEFAULT 0,
  MED_TYPE_FLAG                   NUMBER        DEFAULT 0,
  MED_FILTER_IND                  NUMBER        DEFAULT 0,
  INTERMITTENT_FILTER_IND         NUMBER        DEFAULT 0,
  CONTINUOUS_FILTER_IND           NUMBER        DEFAULT 0,
  COMPOUND_TEXT_ID                NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  PRICE_SCHED_ID                  NUMBER        DEFAULT 0                     NOT NULL,
  ALWAYS_DISPENSE_FROM_FLAG       NUMBER        DEFAULT 0,
  PRIMARY_MANF_ITEM_ID            NUMBER        DEFAULT 0                     NOT NULL,
  CKI                             VARCHAR2(255 BYTE),
  MEQ_FACTOR                      FLOAT(126)    DEFAULT 0,
  MMOL_FACTOR                     FLOAT(126)    DEFAULT 0,
  SIDE_EFFECT_CODE                VARCHAR2(10 BYTE),
  DISPENSE_QTY                    FLOAT(126)    DEFAULT 0                     NOT NULL,
  DISPENSE_QTY_UNIT_CD            FLOAT(126)    DEFAULT 0                     NOT NULL,
  INV_MASTER_ID                   NUMBER        DEFAULT 0                     NOT NULL,
  PARENT_ITEM_ID                  NUMBER        DEFAULT 0                     NOT NULL,
  PREMIX_IND                      NUMBER        DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MED_ADMIN_ALERT
(
  MED_ADMIN_ALERT_ID       NUMBER               DEFAULT 0                     NOT NULL,
  PRSNL_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  ALERT_TYPE_CD            NUMBER               DEFAULT 0                     NOT NULL,
  ALERT_SEVERITY_CD        NUMBER               DEFAULT 0                     NOT NULL,
  POSITION_CD              NUMBER               DEFAULT 0                     NOT NULL,
  NURSE_UNIT_CD            NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_DT_TM              DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  CAREAWARE_USED_IND       NUMBER               DEFAULT 0,
  SOURCE_APPLICATION_FLAG  NUMBER,
  NEXT_CALC_DT_TM          DATE,
  NEXT_CALC_TZ             NUMBER               DEFAULT 0,
  MED_ADMIN_EVENT_ID       NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MED_ADMIN_EVENT
(
  MED_ADMIN_EVENT_ID             NUMBER         DEFAULT 0                     NOT NULL,
  EVENT_ID                       NUMBER         DEFAULT 0                     NOT NULL,
  ORDER_ID                       NUMBER         DEFAULT 0                     NOT NULL,
  PRSNL_ID                       NUMBER         DEFAULT 0                     NOT NULL,
  DOCUMENTATION_ACTION_SEQUENCE  NUMBER         DEFAULT 0                     NOT NULL,
  POSITIVE_PATIENT_IDENT_IND     NUMBER         DEFAULT 0                     NOT NULL,
  POSITIVE_MED_IDENT_IND         NUMBER         DEFAULT 0                     NOT NULL,
  ORDER_RESULT_VARIANCE_IND      NUMBER         DEFAULT 0                     NOT NULL,
  CLINICAL_WARNING_CNT           NUMBER         DEFAULT 0                     NOT NULL,
  POSITION_CD                    NUMBER         DEFAULT 0                     NOT NULL,
  NURSE_UNIT_CD                  NUMBER         DEFAULT 0                     NOT NULL,
  BEG_DT_TM                      DATE,
  END_DT_TM                      DATE,
  EVENT_CNT                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  CAREAWARE_USED_IND             NUMBER         DEFAULT 0,
  SCHEDULED_TZ                   NUMBER,
  SCHEDULED_DT_TM                DATE,
  VERIFICATION_TZ                NUMBER,
  VERIFICATION_DT_TM             DATE,
  NEEDS_VERIFY_FLAG              NUMBER         DEFAULT 0,
  VERIFIED_PRSNL_ID              NUMBER         DEFAULT 0,
  TEMPLATE_ORDER_ID              NUMBER         DEFAULT 0                     NOT NULL,
  EVENT_TYPE_CD                  NUMBER         DEFAULT 0,
  SOURCE_APPLICATION_FLAG        NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MED_ADMIN_IDENT_ERROR
(
  MED_ADMIN_IDENT_ERROR_ID  NUMBER              DEFAULT 0                     NOT NULL,
  ALERT_TYPE_CD             NUMBER              DEFAULT 0                     NOT NULL,
  BAR_CODE_IDENT            VARCHAR2(50 BYTE)   DEFAULT ' '                   NOT NULL,
  EVENT_DT_TM               DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  PRSNL_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  NURSE_UNIT_CD             NUMBER              DEFAULT 0                     NOT NULL,
  CAREAWARE_USED_IND        NUMBER              DEFAULT 0,
  SOURCE_APPLICATION_FLAG   NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MED_ADMIN_MED_ERROR
(
  MED_ADMIN_MED_ERROR_ID  NUMBER                DEFAULT 0                     NOT NULL,
  MED_ADMIN_ALERT_ID      NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCOUNTER_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE         NUMBER                DEFAULT 0                     NOT NULL,
  ADMIN_ROUTE_CD          NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  SCHEDULED_DT_TM         DATE,
  SCHEDULED_TZ            NUMBER                DEFAULT 0,
  ADMIN_DT_TM             DATE,
  ADMIN_TZ                NUMBER                DEFAULT 0,
  REASON_CD               NUMBER                DEFAULT 0                     NOT NULL,
  FREETEXT_REASON         VARCHAR2(255 BYTE),
  VERIFIED_PRSNL_ID       NUMBER                DEFAULT 0,
  PREVIOUS_ADMIN_DT_TM    DATE,
  NEXT_ADMIN_DT_TM        DATE,
  VERIFICATION_TZ         NUMBER,
  VERIFICATION_DT_TM      DATE,
  NEEDS_VERIFY_FLAG       NUMBER                DEFAULT 0,
  TEMPLATE_ORDER_ID       NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MED_ADMIN_PT_ERROR
(
  MED_ADMIN_PT_ERROR_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  MED_ADMIN_ALERT_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  EXPECTED_PT_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  IDENTIFIED_PT_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  BAR_CODE_IDENT         VARCHAR2(50 BYTE)      DEFAULT ' '                   NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MED_COST_HX
(
  MED_COST_HX_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  MED_PRODUCT_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  COST_TYPE_CD         NUMBER                   DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  END_EFFECTIVE_DT_TM  DATE                     DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  COST                 FLOAT(126),
  ACTIVE_IND           NUMBER,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MED_DEF_FLEX
(
  MED_DEF_FLEX_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ITEM_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  MED_PACKAGE_TYPE_ID     NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(32 BYTE),
  SEQUENCE                NUMBER                DEFAULT 0                     NOT NULL,
  FLEX_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  FLEX_SORT_FLAG          NUMBER,
  PHARMACY_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_MED_DEF_FLEX_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MED_DEF_LOC_R
(
  MED_DEF_ITEM_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  LOCATION_CD      NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MED_DISPENSE
(
  MED_DISPENSE_ID             NUMBER            DEFAULT 0                     NOT NULL,
  ITEM_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  MED_PACKAGE_TYPE_ID         NUMBER            DEFAULT 0                     NOT NULL,
  PACKAGE_TYPE_ID             NUMBER            DEFAULT 0                     NOT NULL,
  PHARMACY_TYPE_CD            NUMBER            DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID            NUMBER            DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME          VARCHAR2(32 BYTE),
  FLEX_TYPE_CD                NUMBER            DEFAULT 0                     NOT NULL,
  FLEX_SORT_FLAG              NUMBER,
  STRENGTH                    FLOAT(126),
  STRENGTH_UNIT_CD            NUMBER            DEFAULT 0                     NOT NULL,
  VOLUME                      FLOAT(126),
  VOLUME_UNIT_CD              NUMBER            DEFAULT 0                     NOT NULL,
  DISPENSE_FACTOR             FLOAT(126),
  PAT_ORDERABLE_IND           NUMBER,
  LEGAL_STATUS_CD             NUMBER            DEFAULT 0                     NOT NULL,
  FORMULARY_STATUS_CD         NUMBER            DEFAULT 0                     NOT NULL,
  OE_FORMAT_FLAG              NUMBER,
  MED_FILTER_IND              NUMBER,
  CONTINUOUS_FILTER_IND       NUMBER,
  INTERMITTENT_FILTER_IND     NUMBER,
  DIVISIBLE_IND               NUMBER,
  USED_AS_BASE_IND            NUMBER,
  ALWAYS_DISPENSE_FROM_FLAG   NUMBER,
  DISPENSE_QTY                FLOAT(126),
  LABEL_RATIO                 NUMBER,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  INFINITE_DIV_IND            NUMBER,
  REUSABLE_IND                NUMBER            DEFAULT 0                     NOT NULL,
  BASE_ISSUE_FACTOR           FLOAT(126)        DEFAULT 0                     NOT NULL,
  PKG_DISP_MORE_IND           NUMBER            DEFAULT 0,
  PKG_QTY_PER_PKG             FLOAT(126)        DEFAULT -1,
  TPN_FILTER_IND              NUMBER,
  OVERRIDE_CLSFCTN_CD         NUMBER            DEFAULT 0,
  RX_STATION_NOTES_ID         NUMBER            DEFAULT 0,
  WITNESS_RETURN_IND          NUMBER            DEFAULT 0,
  WITNESS_DISPENSE_IND        NUMBER            DEFAULT 0,
  WITNESS_OVERRIDE_IND        NUMBER            DEFAULT 0,
  WITNESS_WASTE_IND           NUMBER            DEFAULT 0,
  WITNESS_ADHOC_IND           NUMBER            DEFAULT 0,
  TPN_OVERFILL_AMT            FLOAT(126),
  TPN_OVERFILL_UNIT_CD        NUMBER            DEFAULT 0,
  TPN_FILL_METHOD_CD          NUMBER            DEFAULT 0,
  TPN_INCLUDE_IONS_FLAG       NUMBER,
  TPN_DEFAULT_INGRED_ITEM_ID  NUMBER            DEFAULT 0,
  TPN_BALANCE_METHOD_CD       NUMBER            DEFAULT 0,
  TPN_CHLORIDE_PCT            FLOAT(126),
  INV_FACTOR_NBR              FLOAT(126)        DEFAULT 0,
  TPN_SCALE_FLAG              NUMBER,
  TPN_PRODUCT_TYPE_FLAG       NUMBER,
  LOT_TRACKING_IND            NUMBER            DEFAULT 0,
  WORKFLOW_CD                 NUMBER            DEFAULT 0,
  TPN_PREFERRED_CATION_CD     NUMBER            DEFAULT 0,
  POC_CHARGE_FLAG             NUMBER            DEFAULT 0,
  WITNESS_ADHOC_REFILL_IND    NUMBER            DEFAULT 0,
  WITNESS_SCHED_TASK_IND      NUMBER            DEFAULT 0,
  WITNESS_EXPIRE_MGMT_IND     NUMBER            DEFAULT 0,
  WITNESS_INV_COUNT_IND       NUMBER            DEFAULT 0,
  WITNESS_EMPTY_RETURN_IND    NUMBER            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MED_FLEX_OBJECT_IDX
(
  MED_FLEX_OBJECT_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  MED_DEF_FLEX_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  SEQUENCE             NUMBER                   DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME   VARCHAR2(32 BYTE),
  FLEX_OBJECT_TYPE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  VALUE                FLOAT(126)               DEFAULT 0,
  VALUE_UNIT           FLOAT(126)               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MED_IDENTIFIER
(
  MED_IDENTIFIER_ID       NUMBER                DEFAULT 0                     NOT NULL,
  MED_INGRED_SET_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ITEM_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  MED_PACKAGE_TYPE_ID     NUMBER                DEFAULT 0                     NOT NULL,
  MED_PRODUCT_ID          NUMBER                DEFAULT 0                     NOT NULL,
  MED_DEF_FLEX_ID         NUMBER                DEFAULT 0                     NOT NULL,
  SEQUENCE                NUMBER                DEFAULT 0                     NOT NULL,
  PHARMACY_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(32 BYTE),
  FLEX_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  FLEX_SORT_FLAG          NUMBER,
  MED_IDENTIFIER_TYPE_CD  NUMBER                DEFAULT 0                     NOT NULL,
  PRIMARY_IND             NUMBER,
  VALUE                   VARCHAR2(200 BYTE),
  VALUE_KEY               VARCHAR2(200 BYTE),
  MED_TYPE_FLAG           NUMBER,
  ACTIVE_IND              NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_KEY_A_NLS         VARCHAR2(800 BYTE),
  VALUE_KEY_NLS           VARCHAR2(402 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MED_INGRED_SET
(
  MED_INGRED_SET_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  PARENT_ITEM_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  SEQUENCE             NUMBER                   DEFAULT 0                     NOT NULL,
  CHILD_ITEM_ID        NUMBER                   DEFAULT 0                     NOT NULL,
  CHILD_MED_PROD_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  CHILD_PKG_TYPE_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  BASE_IND             NUMBER,
  CMPD_QTY             FLOAT(126),
  DEFAULT_ACTION_CD    NUMBER                   DEFAULT 0                     NOT NULL,
  INC_IN_TOTAL_IND     NUMBER                   DEFAULT 0,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  VOLUME               FLOAT(126)               DEFAULT 0,
  VOLUME_UNIT_CD       NUMBER                   DEFAULT 0,
  STRENGTH_UNIT_CD     NUMBER                   DEFAULT 0,
  STRENGTH             FLOAT(126)               DEFAULT 0,
  NORMALIZED_RATE_IND  NUMBER                   DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MED_OE_DEFAULTS
(
  MED_OE_DEFAULTS_ID              NUMBER        DEFAULT 0                     NOT NULL,
  STRENGTH                        FLOAT(126),
  STRENGTH_UNIT_CD                NUMBER        DEFAULT 0                     NOT NULL,
  VOLUME                          FLOAT(126),
  VOLUME_UNIT_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  FREETEXT_DOSE                   VARCHAR2(255 BYTE),
  ROUTE_CD                        NUMBER        DEFAULT 0                     NOT NULL,
  FREQUENCY_CD                    NUMBER        DEFAULT 0                     NOT NULL,
  PRN_IND                         NUMBER,
  INFUSE_OVER                     FLOAT(126),
  INFUSE_OVER_CD                  NUMBER        DEFAULT 0                     NOT NULL,
  DURATION                        FLOAT(126),
  DURATION_UNIT_CD                NUMBER        DEFAULT 0                     NOT NULL,
  STOP_TYPE_CD                    NUMBER        DEFAULT 0                     NOT NULL,
  DEFAULT_PAR_DOSES               NUMBER,
  MAX_PAR_SUPPLY                  NUMBER,
  DISPENSE_CATEGORY_CD            NUMBER        DEFAULT 0                     NOT NULL,
  ALTERNATE_DISPENSE_CATEGORY_CD  NUMBER        DEFAULT 0                     NOT NULL,
  COMMENT1_ID                     NUMBER        DEFAULT 0                     NOT NULL,
  COMMENT1_TYPE                   NUMBER,
  COMMENT2_ID                     NUMBER        DEFAULT 0                     NOT NULL,
  COMMENT2_TYPE                   NUMBER,
  PRICE_SCHED_ID                  NUMBER        DEFAULT 0                     NOT NULL,
  NBR_LABELS                      NUMBER,
  RX_QTY                          FLOAT(126),
  DAW_CD                          NUMBER        DEFAULT 0                     NOT NULL,
  SIG_CODES                       VARCHAR2(255 BYTE),
  ACTIVE_IND                      NUMBER,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  PRN_REASON_CD                   NUMBER        DEFAULT 0                     NOT NULL,
  ORD_AS_SYNONYM_ID               NUMBER        DEFAULT 0                     NOT NULL,
  NORMALIZED_RATE_NBR             FLOAT(126)    DEFAULT -1,
  NORMALIZED_RATE_UNIT_CD         NUMBER        DEFAULT 0,
  FREETEXT_RATE_TXT               VARCHAR2(100 BYTE),
  RATE_NBR                        FLOAT(126)    DEFAULT -1,
  RATE_UNIT_CD                    NUMBER        DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MED_PRODUCT
(
  MED_PRODUCT_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  MANF_ITEM_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  INNER_PKG_TYPE_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  OUTER_PKG_TYPE_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  MED_DEF_CKI          VARCHAR2(255 BYTE)       DEFAULT ' '                   NOT NULL,
  BIO_EQUIV_IND        NUMBER,
  BRAND_IND            NUMBER,
  UNIT_DOSE_IND        NUMBER,
  FORMULARY_STATUS_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  INV_FACTOR_NBR       FLOAT(126)               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MESSAGING_AUDIT
(
  MESSAGING_AUDIT_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  ORG_ID                 NUMBER                 DEFAULT 0                     NOT NULL,
  ENCNTR_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  PHARMACY_IDENTIFIER    VARCHAR2(100 BYTE),
  RX_IDENTIFIER          VARCHAR2(30 BYTE),
  STATUS_CD              NUMBER                 DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  AUDIT_TYPE_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  MSG_TEXT_ID            NUMBER                 DEFAULT 0                     NOT NULL,
  AUDIT_DT_TM            DATE                   DEFAULT SYSDATE               NOT NULL,
  ACTION_PRSNL_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  ORDERING_PHYS_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  PUBLISH_IND            NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  ERROR_CD               NUMBER                 DEFAULT 0                     NOT NULL,
  REF_TRANS_IDENTIFIER   VARCHAR2(255 BYTE),
  REF_ORDER_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  STATUS_COMMENT         VARCHAR2(255 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MESSAGING_FAVORITES
(
  FAVORITE_ID         NUMBER                    DEFAULT 0                     NOT NULL,
  FAVORITE_TYPE_CD    NUMBER                    DEFAULT 0                     NOT NULL,
  PRSNL_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  PRSNL_GROUP_ID      NUMBER                    DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME  VARCHAR2(30 BYTE)         DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MESSAGING_NOTIFY
(
  MESSAGING_NOTIFY_ID    NUMBER                 DEFAULT 0                     NOT NULL,
  TASK_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  NOTIFY_PRSNL_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  NOTIFY_PRSNL_GROUP_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  NOTIFY_TYPE_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  ACTIVE_IND             NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  NOTIFY_PRIORITY_CD     NUMBER                 DEFAULT 0                     NOT NULL,
  ASSIGN_PRSNL_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  ASSIGN_PRSNL_GROUP_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  ASSIGN_PERSON_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  DELAY_UNIT_FLAG        NUMBER                 DEFAULT 0,
  DELAY_VALUE            NUMBER                 DEFAULT 0,
  NOTIFY_EMAIL_INFO_ID   NUMBER                 DEFAULT 0,
  ASSIGN_EMAIL_INFO_ID   NUMBER                 DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MESSAGING_OUT_OF_OFFICE
(
  MESSAGING_OUT_OF_OFFICE_ID  NUMBER            DEFAULT 0                     NOT NULL,
  RETURN_DT_TM                DATE,
  PRSNL_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  PRSNL_GROUP_ID              NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_ABNORMAL_LIST
(
  CRITERIA_ID   NUMBER                          DEFAULT 0                     NOT NULL,
  ABNORMAL_CD   NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_ABN_ORG_RESPONSE_CODE
(
  CRITERIA_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  SOURCE_GROUPING_CD   NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  DIAGNOSIS_CD         NUMBER                   DEFAULT 0                     NOT NULL,
  ETHNIC_GROUP_CD      NUMBER                   DEFAULT 0                     NOT NULL,
  AGE_GROUP_CD         NUMBER                   DEFAULT 0                     NOT NULL,
  INCLUDE_EXCLUDE_IND  NUMBER,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_ABN_SUS_RESULT
(
  ABN_SUS_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  SOURCE_GROUPING_CD   NUMBER                   DEFAULT 0                     NOT NULL,
  ORGANISM_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  SUS_DETAIL_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  SUS_METHOD_CD        NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_ACT_ANG_SUM_RPT
(
  ANG_RUN_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  ORDER_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  SOURCE_CD            NUMBER                   DEFAULT 0                     NOT NULL,
  PRINT_SEQ            NUMBER                   DEFAULT 0                     NOT NULL,
  REPORT_CD            NUMBER                   DEFAULT 0                     NOT NULL,
  REPORT_STATUS_CD     NUMBER                   DEFAULT 0                     NOT NULL,
  TASK_LOG_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  PRINT_REPORT_FLAG    NUMBER                   DEFAULT 0                     NOT NULL,
  ENCNTR_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  ORDER_LOCK_DT_TM     DATE,
  ORDER_LOCK_ID        NUMBER                   DEFAULT 0                     NOT NULL,
  LOAD_DT_TM           DATE,
  ERROR_TEXT           VARCHAR2(150 BYTE),
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  DM2_MIG_SEQ_ID       NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_ANG_AUTOMATED
(
  ORDER_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  INSTR_RESOURCE_CD    NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  SOURCE_CD            NUMBER                   DEFAULT 0                     NOT NULL,
  ANG_ID               NUMBER                   DEFAULT 0                     NOT NULL,
  ANG_NEG_SEQ          NUMBER                   DEFAULT 0                     NOT NULL,
  START_DT_TM          DATE                     DEFAULT SYSDATE               NOT NULL,
  LAST_PRINT_DT_TM     DATE,
  ANG_RUN_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  PRINT_RPT_IND        NUMBER                   DEFAULT 0                     NOT NULL,
  COMPLETE_IND         NUMBER                   DEFAULT 0                     NOT NULL,
  POSITIVE_IND         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  END_REPORT_RANGE     NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_ANG_DISQUAL
(
  ANG_ID                NUMBER                  DEFAULT 0                     NOT NULL,
  DISQUAL_SEQ           NUMBER                  DEFAULT 0                     NOT NULL,
  DISQUAL_RESPONSES_CD  NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_ANG_STATUS
(
  ANG_RUN_ID      NUMBER                        DEFAULT 0                     NOT NULL,
  RUN_STATUS_IND  NUMBER                        DEFAULT 0                     NOT NULL,
  RUN_DT_TM       DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL,
  ANG_ID          NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_ANG_TIMES
(
  DAY_OF_WEEK          NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  TIME_SEQ             NUMBER                   DEFAULT 0                     NOT NULL,
  PRINTER_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  PRINT_RPT_IND        NUMBER,
  PERFORM_ONLY_IND     NUMBER,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  RUN_IND              NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_BIOCHEMICAL_TEST_RESULT
(
  TASK_LOG_ID         NUMBER                    DEFAULT 0                     NOT NULL,
  RESULT_SEQ          NUMBER                    DEFAULT 0                     NOT NULL,
  GROUP_BIO_CD        NUMBER                    DEFAULT 0                     NOT NULL,
  DETAIL_BIO_CD       NUMBER                    DEFAULT 0                     NOT NULL,
  RESULT_CD           NUMBER                    DEFAULT 0                     NOT NULL,
  RESULT_TEXTUAL      VARCHAR2(60 BYTE),
  CORRECTED_IND       NUMBER,
  RESULT_CURRENT_IND  NUMBER,
  RESULT_STATUS_CD    NUMBER                    DEFAULT 0                     NOT NULL,
  COMMENT_SEQ         NUMBER,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  LOT_INFORMATION_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  RESULT_SCHEDULE_ID  NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_BPA_SUS_RESULT
(
  PARENT_ENTITY_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME   VARCHAR2(32 BYTE)        DEFAULT ' '                   NOT NULL,
  PANEL_CD             NUMBER                   DEFAULT 0                     NOT NULL,
  ANTIBIOTIC_PLATE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  ANTIBIOTIC_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  RESULT_PRSNL_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  BPA_RESULT_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  RESULT_DT_TM         DATE                     DEFAULT SYSDATE               NOT NULL,
  LOCKED_RESULT_IND    NUMBER,
  ACTIVE_WELL_IND      NUMBER,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_CANCEL_REASON
(
  CREDIT_IND        NUMBER                      DEFAULT 0                     NOT NULL,
  CANCEL_REASON_CD  NUMBER                      DEFAULT 0                     NOT NULL,
  TASK_LOG_ID       NUMBER                      DEFAULT 0                     NOT NULL,
  DETAIL_SEQ        NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_CORRELATION_FOOTNOTE
(
  TASK_LOG_ID        NUMBER                     DEFAULT 0                     NOT NULL,
  RESPONSE_SEQ       NUMBER                     DEFAULT 0                     NOT NULL,
  SEQUENCE           NUMBER                     DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID       NUMBER                     DEFAULT 0                     NOT NULL,
  FAILURE_REASON_CD  NUMBER                     DEFAULT 0                     NOT NULL,
  WARNING_IND        NUMBER                     DEFAULT 0                     NOT NULL,
  ORG_TASK_LOG_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  CORR_TASK_LOG_ID   NUMBER                     DEFAULT 0                     NOT NULL,
  NEW_IND            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_EVENT_DETAIL
(
  TASK_LOG_ID            NUMBER                 DEFAULT 0                     NOT NULL,
  EVENT_LOG_SEQ          NUMBER                 DEFAULT 0                     NOT NULL,
  EVENT_DETAIL_SEQ       NUMBER                 DEFAULT 0                     NOT NULL,
  DETAIL_SUS_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  PANEL_CD               NUMBER                 DEFAULT 0                     NOT NULL,
  MEDIA_CD               NUMBER                 DEFAULT 0                     NOT NULL,
  QUANTITATION_CD        NUMBER                 DEFAULT 0                     NOT NULL,
  GROUP_BIOCHEM_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  DETAIL_BIOCHEM_CD      NUMBER                 DEFAULT 0                     NOT NULL,
  RESULT_NUMERIC         FLOAT(126),
  RESULT_TEXT            VARCHAR2(200 BYTE),
  RESULT_UNIT_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  RESULT_STATUS_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  POSITIVE_IND           NUMBER,
  ABNORMAL_IND           NUMBER,
  CHARTABLE_IND          NUMBER,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  RESULT_CD              NUMBER                 DEFAULT 0                     NOT NULL,
  PANEL_MED_CD           NUMBER                 DEFAULT 0                     NOT NULL,
  PREV_TASK_LOG_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  PREV_EVENT_LOG_SEQ     NUMBER                 DEFAULT 0                     NOT NULL,
  PREV_EVENT_DETAIL_SEQ  NUMBER                 DEFAULT 0                     NOT NULL,
  REPORT_IND             NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_EVENT_FOOTNOTE
(
  TASK_LOG_ID       NUMBER                      DEFAULT 0                     NOT NULL,
  EVENT_LOG_SEQ     NUMBER                      DEFAULT 0                     NOT NULL,
  EVENT_DETAIL_SEQ  NUMBER                      DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  EKM_IND           NUMBER                      DEFAULT 0,
  CHARTABLE_IND     NUMBER                      DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_EVENT_LOG
(
  TASK_LOG_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  EVENT_LOG_SEQ        NUMBER                   DEFAULT 0                     NOT NULL,
  EVENT_STATUS_CD      NUMBER                   DEFAULT 0                     NOT NULL,
  EVENT_DT_TM          DATE,
  EVENT_TECH_ID        NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  ORGANISM_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  CHARTABLE_IND        NUMBER,
  ABNORMAL_IND         NUMBER,
  POSITIVE_IND         NUMBER,
  LONG_TEXT_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  ORGANISM_SEQ         NUMBER                   DEFAULT 0,
  EVENT_LOG_FLAG       NUMBER                   DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_GROUP_RESPONSE
(
  GROUP_RESPONSE_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  GRP_RESPONSE_CD      NUMBER                   DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_IND           NUMBER,
  POSITIVE_IND         NUMBER,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  SOURCE_CD            NUMBER                   DEFAULT 0                     NOT NULL,
  GROUP_DISPLAY        VARCHAR2(40 BYTE),
  GROUP_DESCRIPTION    VARCHAR2(60 BYTE),
  STATISTICS_IND       NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_GROUP_RESPONSE_MBR
(
  GROUP_RESPONSE_ID   NUMBER                    DEFAULT 0                     NOT NULL,
  DETAIL_RESPONSE_CD  NUMBER                    DEFAULT 0                     NOT NULL,
  RESPONSE_SEQ        NUMBER                    DEFAULT 0                     NOT NULL,
  NEW_PHRASE_IND      NUMBER,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  STATISTICS_IND      NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_IC_ORDERS
(
  ORDER_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  ENCNTR_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  ACTIVITY_TYPE_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  COMPLETE_DT_TM         DATE                   DEFAULT SYSDATE,
  PROCEDURE_ORDER_DT_TM  DATE                   DEFAULT SYSDATE               NOT NULL,
  DRAWN_DT_TM            DATE                   DEFAULT SYSDATE               NOT NULL,
  RECEIVED_DT_TM         DATE                   DEFAULT SYSDATE               NOT NULL,
  ORDER_PROVIDER_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  CATALOG_CD             NUMBER                 DEFAULT 0                     NOT NULL,
  POSITIVE_IND           NUMBER                 DEFAULT 0,
  NOSOCOMIAL_IND         NUMBER                 DEFAULT 0,
  ACCESSION_NBR          VARCHAR2(20 BYTE)      DEFAULT ' '                   NOT NULL,
  CULTURE_START_DT_TM    DATE                   DEFAULT SYSDATE,
  SOURCE_CD              NUMBER                 DEFAULT 0                     NOT NULL,
  BODY_SITE_CD           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_INSTR_TRANS
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  MICRO_ALIAS          VARCHAR2(20 BYTE)        DEFAULT ' '                   NOT NULL,
  MICRO_FLAG           NUMBER                   DEFAULT 0                     NOT NULL,
  MICRO_CD             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_MEDIA_ACTIVITY
(
  ORDER_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  CATALOG_CD            NUMBER                  DEFAULT 0                     NOT NULL,
  MEDIA_CD              NUMBER                  DEFAULT 0                     NOT NULL,
  MEDIA_SEQ             NUMBER                  DEFAULT 0                     NOT NULL,
  INSTR_TRANS           CHAR(15 BYTE),
  POSITIVE_IND          NUMBER,
  POSITIVE_DT_TM        DATE,
  INITIAL_LOAD_DT_TM    DATE,
  FINAL_UNLOAD_DT_TM    DATE,
  LAST_RESULT_DT_TM     DATE,
  INSTR_MEDIA_LOCATION  CHAR(10 BYTE),
  START_DT_TM           DATE,
  START_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  LAST_RESULT_FLAG      NUMBER,
  LABEL_CNT             NUMBER,
  INSTR_STATUS          CHAR(20 BYTE),
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  TASK_LOG_ID           NUMBER                  DEFAULT 0                     NOT NULL,
  SUBCULTURE_IND        NUMBER,
  DM2_MIG_SEQ_ID        NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_MEDIA_DEFAULT
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  SOURCE_CD            NUMBER                   DEFAULT 0                     NOT NULL,
  MEDIA_CD             NUMBER                   DEFAULT 0                     NOT NULL,
  MEDIA_SEQ            NUMBER                   DEFAULT 0                     NOT NULL,
  MEDIA_LABEL_CNT      NUMBER,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  BODY_SITE_CD         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_MEDIA_LOT_RELTN
(
  MEDIA_LOT_RELTN_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  TASK_LOG_ID         NUMBER                    DEFAULT 0                     NOT NULL,
  MEDIA_SEQ           NUMBER                    DEFAULT 0                     NOT NULL,
  RESULT_SCHEDULE_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  LOT_INFORMATION_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_MEDICATION_RANGE
(
  ABN_SUS_ID         NUMBER                     DEFAULT 0                     NOT NULL,
  MEDICATION_CD      NUMBER                     DEFAULT 0                     NOT NULL,
  DEFAULT_RESULT_CD  NUMBER                     DEFAULT 0                     NOT NULL,
  LOW_VALUE          FLOAT(126)                 DEFAULT 0                     NOT NULL,
  HIGH_VALUE         FLOAT(126),
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_MEDS_ACTIVITY
(
  ORDER_ID       NUMBER                         DEFAULT 0                     NOT NULL,
  CATALOG_CD     NUMBER                         DEFAULT 0                     NOT NULL,
  MEDICATION_CD  NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_ORDER_LAB
(
  ORDER_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  CATALOG_CD                NUMBER              DEFAULT 0                     NOT NULL,
  DOWNLOAD_IND              NUMBER,
  ORDER_LOCK_ID             NUMBER              DEFAULT 0                     NOT NULL,
  ORDER_LOCK_DT_TM          DATE,
  POSITIVE_IND              NUMBER,
  PRELIMINARY_POSITIVE_IND  NUMBER,
  PURGE_DT_TM               DATE,
  RESTORED_DT_TM            DATE,
  ARCHIVE_DT_TM             DATE,
  SUSCEPTIBILITY_IND        NUMBER,
  REPORT_IND                NUMBER,
  STATUS_CD                 NUMBER              DEFAULT 0                     NOT NULL,
  SUS_INSTR_ID_NBR          CHAR(18 BYTE),
  EVENT_FLAG                NUMBER,
  CULTURE_START_DT_TM       DATE,
  COMPLETE_DT_TM            DATE,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  INTERP_TEXT_ID            NUMBER              DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD       NUMBER              DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD             NUMBER              DEFAULT 0                     NOT NULL,
  NOSOCOMIAL_IND            NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_ORGANISM_ID
(
  TASK_LOG_ID      NUMBER                       DEFAULT 0                     NOT NULL,
  ID_SEQ           NUMBER                       DEFAULT 0                     NOT NULL,
  ID_THRESHOLD     NUMBER,
  ID_ORGANISM_CD   NUMBER                       DEFAULT 0                     NOT NULL,
  BIO_TYPE_NUMBER  VARCHAR2(25 BYTE),
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_ORGANISM_OBSERVATION
(
  TASK_LOG_ID      NUMBER                       DEFAULT 0                     NOT NULL,
  MEDIA_SEQ        NUMBER                       DEFAULT 0                     NOT NULL,
  MEDIA_CD         NUMBER                       DEFAULT 0                     NOT NULL,
  QUANTITATION_CD  NUMBER                       DEFAULT 0                     NOT NULL,
  COMMENT_SEQ      NUMBER,
  OBSERVATION      VARCHAR2(100 BYTE),
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  REPORT_IND       NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_PATHOGEN
(
  ORDER_ID      NUMBER                          DEFAULT 0                     NOT NULL,
  CATALOG_CD    NUMBER                          DEFAULT 0                     NOT NULL,
  PATHOGEN_CD   NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_QC_RESULT
(
  RESULT_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  QC_ITEM_ID                 NUMBER             DEFAULT 0                     NOT NULL,
  ITEM_LOT_INFO_ID           NUMBER             DEFAULT 0                     NOT NULL,
  SETUP_DT_TM                DATE,
  SETUP_PERSONNEL_ID         NUMBER             DEFAULT 0                     NOT NULL,
  INSTRUMENT_IDENT           VARCHAR2(20 BYTE)  DEFAULT ' '                   NOT NULL,
  CURRENT_SUB_NBR            NUMBER             DEFAULT 0                     NOT NULL,
  RESULT_SCHEDULE_ID         NUMBER             DEFAULT 0                     NOT NULL,
  SUS_ALPHA_RESULT_CD        NUMBER             DEFAULT 0                     NOT NULL,
  SUS_INTERP_RESULT_CD       NUMBER             DEFAULT 0                     NOT NULL,
  BIOCHEMICAL_RESULT_CD      NUMBER             DEFAULT 0                     NOT NULL,
  MEDIA_RESULT_CD            NUMBER             DEFAULT 0                     NOT NULL,
  RESULT_NBR                 FLOAT(126)         DEFAULT 0.0                   NOT NULL,
  RESULT_DT_TM               DATE,
  RESULT_PERSONNEL_ID        NUMBER             DEFAULT 0                     NOT NULL,
  ABNORMAL_IND               NUMBER             DEFAULT 0                     NOT NULL,
  STATUS_CD                  NUMBER             DEFAULT 0                     NOT NULL,
  COMMENT_TEXT_ID            NUMBER             DEFAULT 0                     NOT NULL,
  CORRECTION_TEXT_ID         NUMBER             DEFAULT 0                     NOT NULL,
  PRIMARY_REVIEW_PRSNL_ID    NUMBER             DEFAULT 0                     NOT NULL,
  PRIMARY_REVIEW_DT_TM       DATE,
  SECONDARY_REVIEW_PRSNL_ID  NUMBER             DEFAULT 0                     NOT NULL,
  SECONDARY_REVIEW_DT_TM     DATE,
  TASK_DETAIL_ID             NUMBER             DEFAULT 0                     NOT NULL,
  CURRENT_NODE_ID            NUMBER             DEFAULT 0                     NOT NULL,
  PREVIOUS_NODE_ID           NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_QC_RESULT_SCHEDULE
(
  RESULT_SCHEDULE_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  SETUP_SCHED_DT_TM      DATE,
  RESULT_SCHED_DT_TM     DATE,
  PANEL_CD               NUMBER                 DEFAULT 0                     NOT NULL,
  ANTIBIOTIC_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  GROUP_BIOCHEMICAL_CD   NUMBER                 DEFAULT 0                     NOT NULL,
  DETAIL_BIOCHEMICAL_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  MEDIA_CD               NUMBER                 DEFAULT 0                     NOT NULL,
  QC_ITEM_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  COMPNT_LOT_INFO_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  SUB_MEDIA_IND          NUMBER                 DEFAULT 0                     NOT NULL,
  COMPLETE_IND           NUMBER                 DEFAULT 0                     NOT NULL,
  LOCK_PERSONNEL_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_REF_ANG
(
  ANG_ID               NUMBER                   DEFAULT 0                     NOT NULL,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  SOURCE_CD            NUMBER                   DEFAULT 0                     NOT NULL,
  AUTOMATED_IND        NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_REF_ANG_REPORT
(
  ANG_ID             NUMBER                     DEFAULT 0                     NOT NULL,
  AUTO_NEG_SEQ       NUMBER                     DEFAULT 0                     NOT NULL,
  BEGIN_RANGE        NUMBER                     DEFAULT 0                     NOT NULL,
  END_RANGE          NUMBER                     DEFAULT 0                     NOT NULL,
  UNITS_CD           NUMBER                     DEFAULT 0                     NOT NULL,
  REPORT_CD          NUMBER                     DEFAULT 0                     NOT NULL,
  CODED_RESPONSE_CD  NUMBER                     DEFAULT 0                     NOT NULL,
  APPEND_TIME_IND    NUMBER                     DEFAULT 0                     NOT NULL,
  VERIFY_IND         NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  GROUP_RESPONSE_ID  NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_REF_BILLING_AB
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  ANTIBIOTIC_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  ONCE_PER_ORG_IND     NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_REF_BILLING_PANEL
(
  VALID_PANEL_ID  NUMBER                        DEFAULT 0                     NOT NULL,
  PANEL_CD        NUMBER                        DEFAULT 0                     NOT NULL,
  BILL_IND        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM      DATE                          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID         NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_TASK       NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_CNT        NUMBER                        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX    NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_REF_BILLING_SUS
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  SUS_METHOD_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  ONCE_PER_ORG_IND     NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_REF_BIO_FORMAT
(
  TASK_ASSAY_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  WRAP                 NUMBER,
  FORMAT_ORDER_TYPE    NUMBER,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_REPORT_CORRELATION
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  FAILURE_REASON_CD    NUMBER                   DEFAULT 0                     NOT NULL,
  FORMAT_CD            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_REPORT_RESPONSE
(
  TASK_LOG_ID             NUMBER                DEFAULT 0                     NOT NULL,
  RESPONSE_SEQ            NUMBER                DEFAULT 0                     NOT NULL,
  RESPONSE_DISPLAY_ORDER  NUMBER,
  NBR_OF_WBC              NUMBER,
  NBR_OF_EPI              NUMBER,
  RESPONSE_CLASS_FLAG     NUMBER,
  RESPONSE_TYPE_FLAG      NUMBER,
  RESPONSE_CD             NUMBER                DEFAULT 0                     NOT NULL,
  ABNORMAL_IND            NUMBER,
  POSITIVE_IND            NUMBER,
  REQUEUE_IND             NUMBER,
  NEW_PHRASE_IND          NUMBER,
  COMMENT_SEQ             NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  GROUP_RESPONSE_CD       NUMBER                DEFAULT 0                     NOT NULL,
  RESPONSE_TEXT           VARCHAR2(200 BYTE),
  ORG_TASK_LOG_ID         NUMBER                DEFAULT 0                     NOT NULL,
  GROUP_RESPONSE_ID       NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_REQUIRED_TASK
(
  ORDER_ID         NUMBER                       DEFAULT 0                     NOT NULL,
  REQUIRED_SEQ     NUMBER                       DEFAULT 0,
  CATALOG_CD       NUMBER                       DEFAULT 0                     NOT NULL,
  TASK_CD          NUMBER                       DEFAULT 0                     NOT NULL,
  COMPLETION_IND   NUMBER                       DEFAULT 0,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  ANTIBIOTIC_CD    NUMBER                       DEFAULT 0                     NOT NULL,
  COMPLETED_DT_TM  DATE,
  COMPLETED_ID     NUMBER                       DEFAULT 0                     NOT NULL,
  DETAIL_CD        NUMBER                       DEFAULT 0                     NOT NULL,
  ORGANISM_CD      NUMBER                       DEFAULT 0                     NOT NULL,
  ORGANISM_SEQ     NUMBER                       DEFAULT 0                     NOT NULL,
  STATUS_CD        NUMBER                       DEFAULT 0                     NOT NULL,
  STATUS_FLAG      NUMBER,
  TASK_SEQ         NUMBER                       DEFAULT 0                     NOT NULL,
  TAT_MINUTES      NUMBER                       DEFAULT 0                     NOT NULL,
  TAT_UNITS_CD     NUMBER                       DEFAULT 0                     NOT NULL,
  DUE_DT_TM        DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_REQ_RPT
(
  CRITERIA_ID   NUMBER                          DEFAULT 0                     NOT NULL,
  REQUIRED_IND  NUMBER,
  TASK_CD       NUMBER                          DEFAULT 0                     NOT NULL,
  TAT_MINUTES   NUMBER                          DEFAULT 0                     NOT NULL,
  TAT_UNITS_CD  NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_RPT_LIMIT
(
  CRITERIA_ID   NUMBER                          DEFAULT 0                     NOT NULL,
  TASK_CD       NUMBER                          DEFAULT 0                     NOT NULL,
  REPORT_LIMIT  NUMBER,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_RPT_PARAMS
(
  CRITERIA_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  SOURCE_GROUPING_CD   NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_SCRIPT_TECH
(
  SCRIPT_ID      NUMBER                         DEFAULT 0                     NOT NULL,
  TECH_PRSNL_ID  NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_STAIN_CORRELATION
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  STAIN_CD             NUMBER                   DEFAULT 0                     NOT NULL,
  FAILURE_REASON_CD    NUMBER                   DEFAULT 0                     NOT NULL,
  FORMAT_CD            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_STAT_ARCHIVE
(
  ORDER_ID      NUMBER                          DEFAULT 0                     NOT NULL,
  ACTION_FLAG   NUMBER                          DEFAULT 0                     NOT NULL,
  PROCESS_ID    NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_STAT_BIOCHEMICAL
(
  TASK_LOG_ID      NUMBER                       DEFAULT 0                     NOT NULL,
  SEQUENCE         NUMBER                       DEFAULT 0                     NOT NULL,
  DETAIL_BIO_CD    NUMBER                       DEFAULT 0                     NOT NULL,
  STATUS_CD        NUMBER                       DEFAULT 0                     NOT NULL,
  RESULT_CD        NUMBER                       DEFAULT 0                     NOT NULL,
  RESULT_TEXTUAL   VARCHAR2(500 BYTE),
  RESULT_DT_TM     DATE,
  RESULT_DT_NBR    NUMBER                       DEFAULT 0                     NOT NULL,
  RESULT_MIN_NBR   NUMBER                       DEFAULT 0                     NOT NULL,
  RESULT_PRSNL_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_STAT_DUPLICATE
(
  ORDER_ID       NUMBER                         DEFAULT 0                     NOT NULL,
  COLLECT_DT_TM  DATE                           DEFAULT SYSDATE               NOT NULL,
  PROCESS_ID     NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_STAT_FOOTNOTE
(
  TASK_LOG_ID    NUMBER                         DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID   NUMBER                         DEFAULT 0                     NOT NULL,
  ANTIBIOTIC_CD  NUMBER                         DEFAULT 0                     NOT NULL,
  EKM_IND        NUMBER                         DEFAULT 0,
  CHARTABLE_IND  NUMBER                         DEFAULT 0,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_STAT_MEDICATION
(
  ORDER_ID       NUMBER                         DEFAULT 0                     NOT NULL,
  MEDICATION_CD  NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_CNT       NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM     DATE                           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID        NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_TASK      NUMBER                         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX   NUMBER                         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_STAT_ORDER
(
  ORDER_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  PERSON_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  ENCNTR_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  ACCESSION_NBR              VARCHAR2(20 BYTE),
  EXT_ACCESSION_NBR          VARCHAR2(30 BYTE),
  CATALOG_CD                 NUMBER             DEFAULT 0                     NOT NULL,
  CATALOG_SEQ                NUMBER             DEFAULT 0                     NOT NULL,
  SOURCE_CD                  NUMBER             DEFAULT 0                     NOT NULL,
  BODY_SITE_CD               NUMBER             DEFAULT 0                     NOT NULL,
  FREETEXT_SOURCE_ID         NUMBER             DEFAULT 0                     NOT NULL,
  ORDER_PROVIDER_ID          NUMBER             DEFAULT 0                     NOT NULL,
  ORDER_DT_TM                DATE,
  ORDER_DT_NBR               NUMBER             DEFAULT 0                     NOT NULL,
  ORDER_MIN_NBR              NUMBER             DEFAULT 0                     NOT NULL,
  ORDER_PRSNL_ID             NUMBER             DEFAULT 0                     NOT NULL,
  COLLECT_DT_TM              DATE,
  COLLECT_DT_NBR             NUMBER             DEFAULT 0                     NOT NULL,
  COLLECT_MIN_NBR            NUMBER             DEFAULT 0                     NOT NULL,
  COLLECT_PRSNL_ID           NUMBER             DEFAULT 0                     NOT NULL,
  COLLECT_LOC_FACILITY_CD    NUMBER             DEFAULT 0                     NOT NULL,
  COLLECT_LOC_BUILDING_CD    NUMBER             DEFAULT 0                     NOT NULL,
  COLLECT_LOC_NURSE_UNIT_CD  NUMBER             DEFAULT 0                     NOT NULL,
  RECEIVE_DT_TM              DATE,
  RECEIVE_DT_NBR             NUMBER             DEFAULT 0                     NOT NULL,
  RECEIVE_MIN_NBR            NUMBER             DEFAULT 0                     NOT NULL,
  RECEIVE_PRSNL_ID           NUMBER             DEFAULT 0                     NOT NULL,
  START_DT_TM                DATE,
  START_DT_NBR               NUMBER             DEFAULT 0                     NOT NULL,
  START_MIN_NBR              NUMBER             DEFAULT 0                     NOT NULL,
  COMPLETE_DT_TM             DATE,
  COMPLETE_DT_NBR            NUMBER             DEFAULT 0                     NOT NULL,
  COMPLETE_MIN_NBR           NUMBER             DEFAULT 0                     NOT NULL,
  COMPLETE_PRSNL_ID          NUMBER             DEFAULT 0                     NOT NULL,
  ORDER_LOC_FACILITY_CD      NUMBER             DEFAULT 0                     NOT NULL,
  ORDER_LOC_BUILDING_CD      NUMBER             DEFAULT 0                     NOT NULL,
  ORDER_LOC_NURSE_UNIT_CD    NUMBER             DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD        NUMBER             DEFAULT 0                     NOT NULL,
  POSITIVE_IND               NUMBER,
  INTERP_TEXT_ID             NUMBER             DEFAULT 0                     NOT NULL,
  ORDER_COMMENT_ID           NUMBER             DEFAULT 0                     NOT NULL,
  ORDER_NOTE_ID              NUMBER             DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD      NUMBER             DEFAULT 0                     NOT NULL,
  PURGE_DT_TM                DATE,
  NOSOCOMIAL_IND             NUMBER             DEFAULT 0                     NOT NULL,
  DAYS_TO_POSITIVE           NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  ORDER_PROVIDER_FT          VARCHAR2(100 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_STAT_ORGANISM_ID
(
  TASK_LOG_ID      NUMBER                       DEFAULT 0                     NOT NULL,
  SEQUENCE         NUMBER                       DEFAULT 0                     NOT NULL,
  ID_THRESHOLD     NUMBER                       DEFAULT 0                     NOT NULL,
  ID_ORGANISM_CD   NUMBER                       DEFAULT 0                     NOT NULL,
  BIO_TYPE_NUMBER  VARCHAR2(25 BYTE),
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_STAT_ORG_OBSERVATION
(
  TASK_LOG_ID      NUMBER                       DEFAULT 0                     NOT NULL,
  SEQUENCE         NUMBER                       DEFAULT 0                     NOT NULL,
  MEDIA_CD         NUMBER                       DEFAULT 0                     NOT NULL,
  QUANTITATION_CD  NUMBER                       DEFAULT 0                     NOT NULL,
  OBSERVATION      VARCHAR2(100 BYTE),
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  REPORT_IND       NUMBER                       DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_STAT_PATHOGEN
(
  ORDER_ID      NUMBER                          DEFAULT 0                     NOT NULL,
  PATHOGEN_CD   NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_STAT_PROCESS
(
  PROCESS_ID       NUMBER                       DEFAULT 0                     NOT NULL,
  BEGIN_DT_TM      DATE                         DEFAULT SYSDATE               NOT NULL,
  END_DT_TM        DATE                         DEFAULT SYSDATE               NOT NULL,
  PROCESS_TECH_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  COMPLETE_IND     NUMBER                       DEFAULT 0,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_STAT_REPORT_RESPONSE
(
  TASK_LOG_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  SEQUENCE             NUMBER                   DEFAULT 0                     NOT NULL,
  GROUP_RESPONSE_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  RESPONSE_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  RESPONSE_CLASS_FLAG  NUMBER                   DEFAULT 0                     NOT NULL,
  RESPONSE_TEXT        VARCHAR2(500 BYTE),
  ABNORMAL_IND         NUMBER                   DEFAULT 0,
  POSITIVE_IND         NUMBER                   DEFAULT 0,
  STATISTICS_FLAG      NUMBER                   DEFAULT 0,
  DUP_RESPONSE_IND     NUMBER                   DEFAULT 0,
  ORG_TASK_LOG_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_STAT_SUSCEPTIBILITY
(
  TASK_LOG_ID               NUMBER              DEFAULT 0                     NOT NULL,
  PANEL_CD                  NUMBER              DEFAULT 0                     NOT NULL,
  DETAIL_CD                 NUMBER              DEFAULT 0                     NOT NULL,
  ANTIBIOTIC_CD             NUMBER              DEFAULT 0                     NOT NULL,
  PANEL_DISPLAY_ORDER       NUMBER              DEFAULT 0                     NOT NULL,
  DETAIL_DISPLAY_ORDER      NUMBER              DEFAULT 0                     NOT NULL,
  ANTIBIOTIC_DISPLAY_ORDER  NUMBER              DEFAULT 0                     NOT NULL,
  ALPHA_RESULT_CD           NUMBER              DEFAULT 0                     NOT NULL,
  INTERP_RESULT_CD          NUMBER              DEFAULT 0                     NOT NULL,
  RESULT_NUMERIC            FLOAT(126)          DEFAULT 0                     NOT NULL,
  RESULT_UNITS_CD           NUMBER              DEFAULT 0                     NOT NULL,
  RESULT_GROUP_CD           NUMBER              DEFAULT 0                     NOT NULL,
  STATUS_CD                 NUMBER              DEFAULT 0                     NOT NULL,
  RESULT_DT_TM              DATE,
  RESULT_DT_NBR             NUMBER              DEFAULT 0                     NOT NULL,
  RESULT_MIN_NBR            NUMBER              DEFAULT 0                     NOT NULL,
  RESULT_PRSNL_ID           NUMBER              DEFAULT 0                     NOT NULL,
  ABNORMAL_IND              NUMBER              DEFAULT 0,
  CHARTABLE_IND             NUMBER              DEFAULT 0,
  DUP_ANTIBIOTIC_IND        NUMBER              DEFAULT 0,
  DETAIL_TYPE_FLAG          NUMBER              DEFAULT 0,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  DELTA_CHECKING_IND        NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_STAT_TASK
(
  TASK_LOG_ID             NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_ID                NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  DISPLAY_ORDER           NUMBER                DEFAULT 0                     NOT NULL,
  TASK_CD                 NUMBER                DEFAULT 0                     NOT NULL,
  TASK_QUAL               NUMBER                DEFAULT 0                     NOT NULL,
  TASK_CLASS_FLAG         NUMBER,
  TASK_TYPE_FLAG          NUMBER,
  TASK_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  ORGANISM_CD             NUMBER                DEFAULT 0                     NOT NULL,
  ORGANISM_QUAL           NUMBER                DEFAULT 0                     NOT NULL,
  INSTR_ID_NBR            VARCHAR2(20 BYTE),
  FREETEXT_RESULT_ID      NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_DT_TM             DATE,
  ORDER_DT_NBR            NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_MIN_NBR           NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_PRSNL_ID          NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_DT_TM            DATE,
  RESULT_DT_NBR           NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_MIN_NBR          NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ABNORMAL_IND            NUMBER,
  POSITIVE_IND            NUMBER,
  CORRELATION_IND         NUMBER,
  DUP_ORGANISM_IND        NUMBER,
  MOST_RECENT_REPORT_IND  NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_SUS_MED_RESULT
(
  TASK_LOG_ID             NUMBER                DEFAULT 0                     NOT NULL,
  DETAIL_SUS_SEQ          NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_SEQ              NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_CD               NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_NUMERIC          FLOAT(126),
  RESULT_UNITS_CD         NUMBER                DEFAULT 0                     NOT NULL,
  ABNORMAL_IND            NUMBER,
  PANEL_MEDICATION_CD     NUMBER                DEFAULT 0                     NOT NULL,
  MEDICATION_DILUTION_CD  NUMBER                DEFAULT 0                     NOT NULL,
  CHARTABLE_IND           NUMBER,
  REQUEUE_IND             NUMBER,
  STATUS_CD               NUMBER                DEFAULT 0                     NOT NULL,
  ROUTE_CD                NUMBER                DEFAULT 0                     NOT NULL,
  DOSAGE                  FLOAT(126),
  COST                    CHAR(18 BYTE),
  COMMENT_SEQ             NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  PENDING_IND             NUMBER,
  UPDT_TZ                 NUMBER                DEFAULT 0,
  PREV_TASK_LOG_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PREV_EVENT_LOG_SEQ      NUMBER                DEFAULT 0                     NOT NULL,
  PREV_EVENT_DETAIL_SEQ   NUMBER                DEFAULT 0                     NOT NULL,
  LOT_INFORMATION_ID      NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_SCHEDULE_ID      NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_SUS_ORDER_DETAIL
(
  TASK_LOG_ID       NUMBER                      DEFAULT 0                     NOT NULL,
  DETAIL_SUS_SEQ    NUMBER                      DEFAULT 0                     NOT NULL,
  DETAIL_SUS_CD     NUMBER                      DEFAULT 0                     NOT NULL,
  DETAIL_TYPE_FLAG  NUMBER,
  PANEL_CD          NUMBER                      DEFAULT 0                     NOT NULL,
  COMMENT_SEQ       NUMBER,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  STATUS_CD         NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_TASK_LOG
(
  TASK_LOG_ID         NUMBER                    DEFAULT 0                     NOT NULL,
  ORDER_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  CATALOG_CD          NUMBER                    DEFAULT 0                     NOT NULL,
  CORRECTED_IND       NUMBER,
  TASK_DISPLAY_ORDER  NUMBER,
  TASK_TECH_ID        NUMBER                    DEFAULT 0                     NOT NULL,
  TASK_CD             NUMBER                    DEFAULT 0                     NOT NULL,
  TASK_QUAL           NUMBER,
  TASK_CLASS_FLAG     NUMBER,
  TASK_TYPE_FLAG      NUMBER,
  TASK_STATUS_CD      NUMBER                    DEFAULT 0                     NOT NULL,
  TASK_DT_TM          DATE,
  TASK_LOCATION_CD    NUMBER                    DEFAULT 0                     NOT NULL,
  ORGANISM_CD         NUMBER                    DEFAULT 0                     NOT NULL,
  ORGANISM_QUAL       NUMBER,
  OBSERVATION         VARCHAR2(100 BYTE),
  Q_SCORE             NUMBER,
  CHARTABLE_IND       NUMBER,
  ABNORMAL_IND        NUMBER,
  POSITIVE_IND        NUMBER,
  COMMENT_IND         NUMBER,
  REQUEUE_IND         NUMBER,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  INSTR_ID_NBR        VARCHAR2(20 BYTE),
  INSTR_RESOURCE_CD   NUMBER                    DEFAULT 0                     NOT NULL,
  EXPEDITE_IND        NUMBER,
  LONG_TEXT_ID        NUMBER                    DEFAULT 0                     NOT NULL,
  ACTION_TECH_ID      NUMBER                    DEFAULT 0                     NOT NULL,
  ACTION_DT_TM        DATE,
  ACTION_TZ           NUMBER                    DEFAULT 0,
  EVENT_HISTORY_FLAG  NUMBER                    DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_VALID_PANEL
(
  VALID_PANEL_ID     NUMBER                     DEFAULT 0                     NOT NULL,
  PANEL_CD           NUMBER                     DEFAULT 0                     NOT NULL,
  DEFAULT_PANEL_IND  NUMBER,
  ID_ONLY_IND        NUMBER,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_VALID_SUS_PANEL
(
  VALID_PANEL_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  CATALOG_CD            NUMBER                  DEFAULT 0                     NOT NULL,
  SOURCE_GROUPING_CD    NUMBER                  DEFAULT 0                     NOT NULL,
  ORGANISM_GROUPING_CD  NUMBER                  DEFAULT 0                     NOT NULL,
  METHOD_CD             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD   NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MIC_WORKCARD_CORRELATION
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  FAILURE_REASON_CD    NUMBER                   DEFAULT 0                     NOT NULL,
  WARN_ONLY_IND        NUMBER,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  CATALOG_CD           NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MMC_ACTIVITY_LOG
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVITY_CD             NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVITY_LOG_DT_TM      DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVITY_LOG_ID         NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  CASE_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  COMMENTS                VARCHAR2(255 BYTE),
  CONTACT_CD              NUMBER                DEFAULT 0                     NOT NULL,
  CONTACT_PERSON_ID       NUMBER                DEFAULT 0                     NOT NULL,
  DURATION                NUMBER,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  INITIATED_BY_CD         NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_PERSON_ID         NUMBER                DEFAULT 0                     NOT NULL,
  REASON_CD               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MMC_CARE_PLAN
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  CARE_PLAN_DT_TM         DATE,
  CARE_PLAN_END_DT_TM     DATE,
  CARE_PLAN_ID            NUMBER                DEFAULT 0                     NOT NULL,
  CARE_PLAN_PRSNL_ID      NUMBER                DEFAULT 0                     NOT NULL,
  CARE_PLAN_START_DT_TM   DATE,
  CASE_DIAGNOSIS_ID       NUMBER                DEFAULT 0                     NOT NULL,
  CASE_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  STATUS_CD               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MMC_CASE
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  CASE_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  CASE_NBR                NUMBER,
  CATEGORY_CD             NUMBER                DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  NEXT_ACTIVITY_CD        NUMBER                DEFAULT 0                     NOT NULL,
  NEXT_ACTIVITY_DT_TM     DATE,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  TYPE_CD                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MMC_CASE_ASSIGN
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  CASE_ASSIGN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  CASE_ASSIGN_R_CD        NUMBER                DEFAULT 0                     NOT NULL,
  CASE_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_CD          NUMBER                DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE ( '12/31/210000:00:00' , 'MM/DD/YYYYHH24:MI:SS' ) NOT NULL,
  MANUAL_CREATE_DT_TM     DATE,
  MANUAL_CREATE_IND       NUMBER                DEFAULT 0                     NOT NULL,
  MANUAL_CREATE_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  MANUAL_INACT_DT_TM      DATE,
  MANUAL_INACT_IND        NUMBER                DEFAULT 0                     NOT NULL,
  MANUAL_INACT_PRSNL_ID   NUMBER                DEFAULT 0                     NOT NULL,
  NOTIFICATION_CD         NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(35 BYTE)     DEFAULT ' '                   NOT NULL,
  PARENT_TYPE_CD          NUMBER                DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ            NUMBER                DEFAULT 1                     NOT NULL,
  STATUS_CD               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MMC_CASE_DIAGNOSIS
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  CASE_DIAGNOSIS_DT_TM    DATE                  DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  CASE_DIAGNOSIS_ID       NUMBER                DEFAULT 0                     NOT NULL,
  CASE_DIAG_PRIORITY      NUMBER,
  CASE_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  CONFIRMATION_STATUS_CD  NUMBER                DEFAULT 0                     NOT NULL,
  DIAG_PRSNL_ID           NUMBER                DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  NOMENCLATURE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PROBLEM_DT_TM           DATE,
  PROBLEM_ID              NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MMC_CASE_HISTORY
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  CASE_HISTORY_DT_TM      DATE                  DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  CASE_HISTORY_ID         NUMBER                DEFAULT 0                     NOT NULL,
  CASE_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  COMMENTS                VARCHAR2(255 BYTE),
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  FREQUENCY_CD            NUMBER                DEFAULT 0                     NOT NULL,
  FREQ_PRSNL_ID           NUMBER                DEFAULT 0                     NOT NULL,
  INTENSITY_CD            NUMBER                DEFAULT 0                     NOT NULL,
  INTENSITY_PRSNL_ID      NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  STATUS_CD               NUMBER                DEFAULT 0                     NOT NULL,
  STATUS_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  STATUS_REASON_CD        NUMBER                DEFAULT 0                     NOT NULL,
  STATUS_REASON_FT        VARCHAR2(100 BYTE),
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MMC_CASE_VOLUME_ST
(
  CASE_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  CASE_NBR             VARCHAR2(25 BYTE),
  CASE_VOLUME_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  CATEGORY_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  FREQUENCY_CD         NUMBER                   DEFAULT 0                     NOT NULL,
  INTENSITY_CD         NUMBER                   DEFAULT 0                     NOT NULL,
  MRN                  VARCHAR2(25 BYTE),
  MTH_CANDIDATE_CNT    NUMBER,
  MTH_CLOSED_CNT       NUMBER,
  MTH_OPEN_CNT         NUMBER,
  MTH_UNOPENED_CNT     NUMBER,
  PCP_ID               NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  PRIM_HEALTH_PLAN_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  PRIM_HP_TYPE_CD      NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_PERSON_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  REASON_CANDIDATE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  REASON_CLOSED_CD     NUMBER                   DEFAULT 0                     NOT NULL,
  REASON_OPEN_CD       NUMBER                   DEFAULT 0                     NOT NULL,
  REASON_UNOPENED_CD   NUMBER                   DEFAULT 0                     NOT NULL,
  REFERRAL_CNT         NUMBER,
  SEC_HEALTH_PLAN_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  SEC_HP_TYPE_CD       NUMBER                   DEFAULT 0                     NOT NULL,
  STATUS_CD            NUMBER                   DEFAULT 0                     NOT NULL,
  STATUS_CDF_MEANING   VARCHAR2(15 BYTE),
  STATUS_REASON        VARCHAR2(100 BYTE),
  TYPE_CD              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  VOLUME_DT_NBR        NUMBER,
  VOLUME_DT_TM         DATE,
  YTD_CANDIDATE_CNT    NUMBER,
  YTD_CLOSED_CNT       NUMBER,
  YTD_OPEN_CNT         NUMBER,
  YTD_UNOPENED_CNT     NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MMC_CP_COMP_DETAILS
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  CP_COMP_DETAILS_ID      NUMBER                DEFAULT 0                     NOT NULL,
  DETAIL_GROUP_ID         NUMBER                DEFAULT 0                     NOT NULL,
  DISPLAY_CD              NUMBER                DEFAULT 0                     NOT NULL,
  DISPLAY_VALUE           VARCHAR2(25 BYTE),
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE ( '12/31/210000:00:00' , 'MM/DD/YYYYHH24:MI:SS' ) NOT NULL,
  SELECTED_COMP_ID        NUMBER                DEFAULT 0                     NOT NULL,
  SOURCE_VOCABULARY_CD    NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MMC_LOG_COLUMN_PREF
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  COLUMN_CD               NUMBER                DEFAULT 0                     NOT NULL,
  COL_CODE_SET            NUMBER                DEFAULT 0                     NOT NULL,
  COL_NUM                 NUMBER                DEFAULT 0                     NOT NULL,
  DATA_TYPE_FLAG          NUMBER                DEFAULT 0                     NOT NULL,
  HEADER_DISPLAY          VARCHAR2(35 BYTE)     DEFAULT ' '                   NOT NULL,
  LOG_COLUMN_PREF_ID      NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_PERSON_ID         NUMBER                DEFAULT 0                     NOT NULL,
  SORTED_IND              NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  VISIBLE_IND             NUMBER                DEFAULT 0                     NOT NULL,
  WIDTH                   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MMC_REQUEST
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  CASE_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  CASE_REQUEST_ID         NUMBER                DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  REASON_CD               NUMBER                DEFAULT 0                     NOT NULL,
  REASON_FREE_TXT         VARCHAR2(255 BYTE),
  REQUEST_DT_TM           DATE                  DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  SOURCE_DISCERN_RULE     VARCHAR2(35 BYTE),
  SOURCE_FREE_TXT         VARCHAR2(100 BYTE),
  SOURCE_PERSON_ID        NUMBER                DEFAULT 0                     NOT NULL,
  SOURCE_TYPE_CD          NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MMC_SELECTED_COMP
(
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  CARE_PLAN_COMP_ID       NUMBER                DEFAULT 0                     NOT NULL,
  CARE_PLAN_ID            NUMBER                DEFAULT 0                     NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE ( '12/31/210000:00:00' , 'MM/DD/YYYYHH24:MI:SS' ) NOT NULL,
  PARENT_COMP_ID          NUMBER                DEFAULT 0                     NOT NULL,
  SELECTED_COMP_ID        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MMC_SELECT_FILT_ITEM
(
  SELECT_FILT_ITEM_ID     NUMBER                DEFAULT 0                     NOT NULL,
  SELECT_FILT_TYPE_ID     NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(35 BYTE),
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  DATE_FLAG               NUMBER                DEFAULT 0                     NOT NULL,
  DATE1                   DATE,
  DATE2                   DATE,
  VALUE                   NUMBER,
  UNITS                   VARCHAR2(15 BYTE),
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MMC_SELECT_FILT_TYPE
(
  SELECT_FILT_TYPE_ID     NUMBER                DEFAULT 0                     NOT NULL,
  FILTER_TYPE_ID          NUMBER                DEFAULT 0                     NOT NULL,
  USER_DEF_FILT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE ( '12/31/210000:00:00' , 'MM/DD/YYYYHH24:MI:SS' ) NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MMC_USR_DEFINED_FILT
(
  USER_DEF_FILT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  APPLICATION_NBR         NUMBER                DEFAULT 0                     NOT NULL,
  FUNCTION_CD             NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  FILTER_NAME             VARCHAR2(255 BYTE),
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_APPROVAL
(
  APPROVAL_LINE_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  MM_APPROVAL_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  MM_APPROVAL_IND      NUMBER                   DEFAULT 0,
  MIN_APPROVAL_AMOUNT  NUMBER                   DEFAULT 0,
  ORGANIZATION_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  DESCRIPTION          VARCHAR2(40 BYTE),
  PRSNL_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  APPROVAL_LEVEL       NUMBER                   DEFAULT 0,
  APPROVAL_AMOUNT      NUMBER                   DEFAULT 0,
  SKIP_IND             NUMBER                   DEFAULT 0,
  VALIDATION_IND       NUMBER                   DEFAULT 0,
  CLASS_NODE_ID        NUMBER                   DEFAULT 0                     NOT NULL,
  COST_CENTER_CD       NUMBER                   DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX       NUMBER                   DEFAULT 0                     NOT NULL,
  CREATE_DT_TM         DATE                     DEFAULT SYSDATE               NOT NULL,
  CREATE_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  CREATE_TASK          NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_APPROVAL_LOG
(
  MM_APPROVAL_LOG_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  PRSNL_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  LINE_ITEM_ID        NUMBER                    DEFAULT 0                     NOT NULL,
  ITEM_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  ITEM_DESC           VARCHAR2(100 BYTE),
  ITEM_NBR            VARCHAR2(40 BYTE),
  PACKAGE_TYPE_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  REQUISITION_ID      NUMBER                    DEFAULT 0                     NOT NULL,
  REQ_NBR             VARCHAR2(40 BYTE),
  REQ_LINE_COST       NUMBER                    DEFAULT 0,
  REQ_LINE_PKG        VARCHAR2(40 BYTE),
  REQ_LINE_QTY        NUMBER                    DEFAULT 0,
  REQ_LOC_CD          NUMBER                    DEFAULT 0                     NOT NULL,
  APPROVAL_STATUS     NUMBER                    DEFAULT 0,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_APPROVAL_QUEUE
(
  APPROVAL_QUEUE_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  CUR_LEVEL            NUMBER                   DEFAULT 0,
  APPROVAL_AMOUNT      FLOAT(126)               DEFAULT 0,
  ITEM_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  ITEM_DESC            VARCHAR2(255 BYTE),
  ITEM_NBR             VARCHAR2(40 BYTE),
  SYSTEM_ITEM_NBR      VARCHAR2(40 BYTE),
  LINE_ITEM_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  MM_APPROVAL_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  MM_APPROVAL_IND      NUMBER                   DEFAULT 0,
  DESCRIPTION          VARCHAR2(40 BYTE),
  MIN_APPROVAL_AMOUNT  NUMBER                   DEFAULT 0,
  ORGANIZATION_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  ORG_NAME             VARCHAR2(100 BYTE),
  CLASS_NODE_ID        NUMBER                   DEFAULT 0                     NOT NULL,
  COST_CENTER_CD       NUMBER                   DEFAULT 0                     NOT NULL,
  REQUISITION_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  REQ_NBR              VARCHAR2(40 BYTE),
  REQ_LINE_NBR         NUMBER                   DEFAULT 0,
  REQ_LOCATION_CD      NUMBER                   DEFAULT 0                     NOT NULL,
  REQ_AMOUNT           FLOAT(126)               DEFAULT 0.0,
  REQ_CREATE_BY        VARCHAR2(40 BYTE),
  PACKAGE_TYPE_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  PACKAGE_TYPE_DESC    VARCHAR2(40 BYTE),
  QTY                  NUMBER                   DEFAULT 0,
  FILL_LOC_COST        FLOAT(126)               DEFAULT 0.0,
  PRICE                FLOAT(126)               DEFAULT 0.0,
  CREATE_APPLCTX       NUMBER                   DEFAULT 0                     NOT NULL,
  CREATE_DT_TM         DATE                     DEFAULT SYSDATE               NOT NULL,
  CREATE_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  CREATE_TASK          NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  IN_PROCESS_IND       NUMBER                   DEFAULT 0,
  FILL_LOCATION_CD     NUMBER                   DEFAULT 0                     NOT NULL,
  NON_CATALOG_IND      NUMBER                   DEFAULT 0,
  VENDOR_CD            NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_APPROVAL_STG
(
  LINE_ITEM_ID    NUMBER                        DEFAULT 0                     NOT NULL,
  REQUISITION_ID  NUMBER                        DEFAULT 0                     NOT NULL,
  CREATE_DT_TM    DATE                          DEFAULT SYSDATE               NOT NULL,
  CREATE_ID       NUMBER                        DEFAULT 0                     NOT NULL,
  CREATE_TASK     NUMBER                        DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX  NUMBER                        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_AP_LOG_HEADER_HMW
(
  HEADER_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  LOG_ID               NUMBER                   DEFAULT 0                     NOT NULL,
  COMPANY_CODE         VARCHAR2(20 BYTE),
  CREATE_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  CREATE_NAME          VARCHAR2(100 BYTE),
  FREIGHT_AMT          FLOAT(126),
  GROSS_AMT            FLOAT(126),
  INVOICE_DT_TM        DATE,
  INVOICE_ID           NUMBER                   DEFAULT 0                     NOT NULL,
  INVOICE_NBR          VARCHAR2(40 BYTE),
  ORGANIZATION_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  PAYMENT_TERMS        VARCHAR2(60 BYTE),
  PAYMENT_TERMS_CD     NUMBER                   DEFAULT 0                     NOT NULL,
  SALES_TAX_AMT        FLOAT(126),
  TOTAL_VOUCHER_LINES  NUMBER,
  VENDOR_CD            NUMBER                   DEFAULT 0                     NOT NULL,
  VENDOR               VARCHAR2(40 BYTE),
  VENDOR_ALIAS         VARCHAR2(20 BYTE),
  RAW_VOUCHER_HEADER   VARCHAR2(200 BYTE),
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_AP_LOG_LINE_HMW
(
  LINE_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  HEADER_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  COMPANY_CODE          VARCHAR2(20 BYTE),
  COST_CENTER           VARCHAR2(60 BYTE),
  COST_CENTER_CD        NUMBER                  DEFAULT 0                     NOT NULL,
  EXTENDED_AMT          FLOAT(126),
  INVOICE_LINE_ITEM_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  INVOICE_LINE_NBR      NUMBER,
  ITEM_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  ITEM_DESC             VARCHAR2(100 BYTE),
  ORGANIZATION_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  PURCHASE_ORDER_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  PO_NBR                VARCHAR2(40 BYTE),
  SUB_ACCOUNT           VARCHAR2(60 BYTE),
  SUB_ACCOUNT_CD        NUMBER                  DEFAULT 0                     NOT NULL,
  RAW_VOUCHER_LINE      VARCHAR2(200 BYTE),
  RAW_DIST_LINE         VARCHAR2(200 BYTE),
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_BUYER_ROUTING
(
  BUYER_ROUTING_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID   NUMBER                      DEFAULT 0                     NOT NULL,
  COST_CENTER_CD    NUMBER                      DEFAULT 0                     NOT NULL,
  BUYER_ID          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_CNTRCT_ACTION
(
  ACTION_ID         NUMBER                      DEFAULT 0                     NOT NULL,
  CNTRCT_ID         NUMBER                      DEFAULT 0                     NOT NULL,
  PERIOD_CD         NUMBER                      DEFAULT 0                     NOT NULL,
  REASON_CD         NUMBER                      DEFAULT 0                     NOT NULL,
  ACTION_DT_TM      DATE,
  PRSNL_ID          NUMBER                      DEFAULT 0                     NOT NULL,
  NOTIFICATION_IND  NUMBER,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  CREATE_DT_TM      DATE,
  CREATE_ID         NUMBER                      DEFAULT 0                     NOT NULL,
  CREATE_TASK       NUMBER,
  CREATE_APPLCTX    NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_CNTRCT_HDR_TIER
(
  PRICE_TIER_ID    NUMBER                       DEFAULT 0                     NOT NULL,
  CNTRCT_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  METRIC_CD        NUMBER                       DEFAULT 0                     NOT NULL,
  CLASS_NODE_ID    NUMBER                       DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  CREATE_DT_TM     DATE,
  CREATE_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  CREATE_TASK      NUMBER,
  CREATE_APPLCTX   NUMBER,
  PRODUCT_LEVEL    FLOAT(126)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_CNTRCT_LINE_TIER
(
  PRICE_TIER_ID      NUMBER                     DEFAULT 0                     NOT NULL,
  CNTRCT_LINE_ID     NUMBER                     DEFAULT 0                     NOT NULL,
  HDR_PRICE_TIER_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  DISCOUNT           NUMBER,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  CREATE_DT_TM       DATE,
  CREATE_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  CREATE_TASK        NUMBER,
  CREATE_APPLCTX     NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_CNTRCT_ORG
(
  ORGANIZATION_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  CNTRCT_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_CYCLE_CNT_FILTER
(
  MM_CYCLE_CNT_FILTER_ID  NUMBER                DEFAULT 0                     NOT NULL,
  MM_TEMPLATE_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ABC_CLASS_CD            NUMBER                DEFAULT 0                     NOT NULL,
  CLASS_NODE_ID           NUMBER                DEFAULT 0                     NOT NULL,
  SORT_METHOD_TXT         VARCHAR2(50 BYTE)     DEFAULT ' '                   NOT NULL,
  FILTER_TYPE_FLAG        NUMBER                DEFAULT 0                     NOT NULL,
  SORT_SEQ                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_DISCREPANCY
(
  MM_DISCREPANCY_ID            NUMBER           DEFAULT 0                     NOT NULL,
  LOCATION_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  FACILITY_CD                  NUMBER           DEFAULT 0                     NOT NULL,
  RXS_ITEM_COUNTBACK_ID        NUMBER           DEFAULT 0                     NOT NULL,
  STATUS_CD                    NUMBER           DEFAULT 0                     NOT NULL,
  RESOLVED_REASON_CD           NUMBER           DEFAULT 0                     NOT NULL,
  RESOLVED_PRSNL_ID            NUMBER           DEFAULT 0                     NOT NULL,
  RESOLVED_COMMENT_TEXT_ID     NUMBER           DEFAULT 0                     NOT NULL,
  RESOLVED_DT_TM               DATE,
  RESOLVED_TZ                  NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  CLUSTER_CD                   NUMBER           DEFAULT 0                     NOT NULL,
  LOCATOR_CD                   NUMBER           DEFAULT 0                     NOT NULL,
  WITNESS_PRSNL_ID             NUMBER           DEFAULT 0                     NOT NULL,
  CREATE_DT_TM                 DATE             DEFAULT SYSDATE               NOT NULL,
  CREATE_TZ                    NUMBER           DEFAULT 0                     NOT NULL,
  RESOLVED_PARENT_ENTITY_ID    NUMBER           DEFAULT 0                     NOT NULL,
  RESOLVED_PARENT_ENTITY_NAME  VARCHAR2(32 BYTE) DEFAULT ' ' NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_EXT_SRC_Q
(
  LINE_ITEM_ID  NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_INSTANCE
(
  MM_INSTANCE_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  CONTROL_IDENT        VARCHAR2(400 BYTE)       DEFAULT ' '                   NOT NULL,
  ORGANIZATION_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  ITEM_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  STORAGE_LOCATION_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  MFR_CD               NUMBER                   DEFAULT 0                     NOT NULL,
  STATUS_CD            NUMBER                   DEFAULT 0                     NOT NULL,
  ACTIVE_IND           NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  MODEL_NBR_TXT        VARCHAR2(60 BYTE)        DEFAULT ' '                   NOT NULL,
  PART_NBR_TXT         VARCHAR2(60 BYTE)        DEFAULT ' '                   NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_OMF_INVOICE
(
  INVOICE_ID                 NUMBER             DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID            NUMBER             DEFAULT 0                     NOT NULL,
  COMPANY_NBR                VARCHAR2(20 BYTE),
  INVOICE_AMOUNT             FLOAT(126),
  INVOICE_DT_TM              DATE,
  INVOICE_DT_NBR             NUMBER,
  INVOICE_MIN_NBR            NUMBER,
  INVOICE_NBR                VARCHAR2(20 BYTE),
  MATCHED_IND                NUMBER,
  PURCHASE_ORDER_ID          NUMBER             DEFAULT 0                     NOT NULL,
  REMIT_ADDRESS_ID           NUMBER             DEFAULT 0                     NOT NULL,
  SEQUENCE                   NUMBER,
  STATUS_CD                  NUMBER             DEFAULT 0                     NOT NULL,
  TERMS_CD                   NUMBER             DEFAULT 0                     NOT NULL,
  VENDOR_CD                  NUMBER             DEFAULT 0                     NOT NULL,
  VENDOR_PO_REF              VARCHAR2(20 BYTE),
  VENDOR_SITE_ID             NUMBER             DEFAULT 0                     NOT NULL,
  VOUCHER_DT_TM              DATE,
  VOUCHER_DT_NBR             NUMBER,
  VOUCHER_MIN_NBR            NUMBER,
  VOUCHER_EFFECTIVE_DT_TM    DATE,
  VOUCHER_EFFECTIVE_DT_NBR   NUMBER,
  VOUCHER_EFFECTIVE_MIN_NBR  NUMBER,
  VOUCHER_STATUS_CD          NUMBER             DEFAULT 0                     NOT NULL,
  VOUCHER_USER_ID            NUMBER             DEFAULT 0                     NOT NULL,
  INVOICE_COUNT              NUMBER,
  CHECKED_RCV_CNT            NUMBER,
  TOTAL_RCV_CNT              NUMBER,
  PO_NBR                     VARCHAR2(20 BYTE),
  TOTAL_ORDER_PRICE          FLOAT(126),
  TOTAL_RECEIPT_PRICE        FLOAT(126),
  TOTAL_INVOICE_PRICE        FLOAT(126),
  TOTAL_VOUCHER_PRICE        FLOAT(126),
  ORDER_DT_TM                DATE,
  ORDER_DT_NBR               NUMBER,
  ORDER_MIN_NBR              NUMBER,
  BUYER_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  PO_RCV_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  PO_STATUS_CD               NUMBER             DEFAULT 0                     NOT NULL,
  INV_CREATE_DT_TM           DATE,
  INV_CREATE_DT_NBR          NUMBER,
  INV_CREATE_MIN_NBR         NUMBER,
  INV_CREATE_ID              NUMBER             DEFAULT 0                     NOT NULL,
  INV_CREATE_TASK            NUMBER,
  INV_CREATE_APPLCTX         NUMBER,
  INV_UPDT_CNT               NUMBER,
  INV_UPDT_ID                NUMBER             DEFAULT 0                     NOT NULL,
  INV_UPDT_DT_TM             DATE,
  INV_UPDT_DT_NBR            NUMBER,
  INV_UPDT_MIN_NBR           NUMBER,
  INV_UPDT_TASK              NUMBER,
  INV_UPDT_APPLCTX           NUMBER,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  CITY_TAX                   FLOAT(126),
  FREIGHT_TAX                FLOAT(126),
  STATE_TAX                  FLOAT(126),
  VAT_TAX                    FLOAT(126),
  TAX                        FLOAT(126),
  OTHER_TAX                  FLOAT(126),
  SYSTEM_GENERATED_IND       NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_OMF_INVOICE_LINE
(
  INVOICE_LINE_ITEM_ID    NUMBER                DEFAULT 0                     NOT NULL,
  BASE_ACCEPTED_QTY       NUMBER,
  BASE_BACK_ORDER_QTY     NUMBER,
  BASE_CANCEL_QTY         NUMBER,
  BASE_INVOICE_QTY        NUMBER,
  BASE_ORDER_QTY          NUMBER,
  BASE_PRICE              FLOAT(126),
  BASE_RECEIPT_QTY        NUMBER,
  BUYER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  CHECKED_IND             NUMBER                DEFAULT 0,
  COMPANY_NBR             VARCHAR2(20 BYTE),
  COST_CENTER_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DELIVER_TO_LOCATION_CD  NUMBER                DEFAULT 0                     NOT NULL,
  EXTENDED_PRICE          FLOAT(126)            DEFAULT 0,
  INV_MATCHED_IND         NUMBER                DEFAULT 0,
  INVOICE_AMOUNT          FLOAT(126),
  INVOICE_ID              NUMBER                DEFAULT 0                     NOT NULL,
  INVOICE_NBR             VARCHAR2(20 BYTE),
  ITEM_MASTER_ID          NUMBER                DEFAULT 0                     NOT NULL,
  LINE_COUNT              NUMBER,
  LINE_CREATE_DT_NBR      NUMBER,
  LINE_CREATE_DT_TM       DATE,
  LINE_CREATE_ID          NUMBER                DEFAULT 0                     NOT NULL,
  LINE_CREATE_MIN_NBR     NUMBER,
  LINE_UPDT_DT_NBR        NUMBER,
  LINE_UPDT_DT_TM         DATE,
  LINE_UPDT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  LINE_UPDT_MIN_NBR       NUMBER,
  MFG_ITEM_ID             NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_DT_NBR            NUMBER,
  ORDER_DT_TM             DATE,
  ORDER_EXTENDED_PRICE    FLOAT(126),
  ORDER_MIN_NBR           NUMBER,
  ORDER_PKG_DESC          VARCHAR2(40 BYTE),
  ORDER_PKG_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_PKG_QTY           NUMBER                DEFAULT 0,
  ORDER_PKG_UOM_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_PRICE             FLOAT(126),
  ORDER_PRICE_TYPE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_QTY               NUMBER,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PKG_DESC                VARCHAR2(40 BYTE),
  PKG_ID                  NUMBER                DEFAULT 0                     NOT NULL,
  PKG_QTY                 NUMBER                DEFAULT 0,
  PKG_UOM_CD              NUMBER                DEFAULT 0                     NOT NULL,
  PO_COST_CENTER_CD       NUMBER                DEFAULT 0                     NOT NULL,
  PO_LINE_NBR             NUMBER,
  PO_NBR                  VARCHAR2(20 BYTE),
  PO_RCV_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  PO_STATUS_CD            NUMBER                DEFAULT 0                     NOT NULL,
  PO_SUB_ACCOUNT_CD       NUMBER                DEFAULT 0                     NOT NULL,
  PO_VENDOR_CD            NUMBER                DEFAULT 0                     NOT NULL,
  PRICE                   FLOAT(126)            DEFAULT 0,
  PURCHASE_ORDER_ID       NUMBER                DEFAULT 0                     NOT NULL,
  QTY                     NUMBER                DEFAULT 0,
  REMIT_ADDRESS_ID        NUMBER                DEFAULT 0                     NOT NULL,
  STATUS_CD               NUMBER                DEFAULT 0                     NOT NULL,
  SUB_ACCOUNT_CD          NUMBER                DEFAULT 0                     NOT NULL,
  TOTAL_ORDER_PRICE       FLOAT(126),
  TOTAL_RECEIPT_PRICE     FLOAT(126),
  TOTAL_VOUCHER_AMOUNT    FLOAT(126),
  TRANSMIT_CD             NUMBER                DEFAULT 0                     NOT NULL,
  VENDOR_CD               NUMBER                DEFAULT 0                     NOT NULL,
  VENDOR_ITEM_ID          NUMBER                DEFAULT 0                     NOT NULL,
  VENDOR_SITE_ID          NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  NC_MFR_ITEM_NBR         VARCHAR2(20 BYTE)     DEFAULT ' ',
  NC_MFR                  VARCHAR2(60 BYTE)     DEFAULT ' ',
  NC_VENDOR_ITEM_NBR      VARCHAR2(20 BYTE)     DEFAULT ' ',
  NC_DESCRIPTION          VARCHAR2(255 BYTE)    DEFAULT ' ',
  NON_CATALOG_IND         NUMBER                DEFAULT 0,
  NC_MFR_CD               NUMBER                DEFAULT 0                     NOT NULL,
  SUBSTITUTION_IND        NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_OMF_ITEMLOC
(
  ABC_CLASS_CD               NUMBER             DEFAULT 0                     NOT NULL,
  ACC_STOCKOUT_FREQ_CD       NUMBER             DEFAULT 0                     NOT NULL,
  ACQUIRE_UPDT_CNT           NUMBER,
  AVERAGE_LEAD_TIME          NUMBER,
  AVERAGE_DAILY_USAGE        NUMBER,
  AVERAGE_LEAD_TIME_UOM_CD   NUMBER             DEFAULT 0                     NOT NULL,
  CHARGE_TYPE_CD             NUMBER             DEFAULT 0                     NOT NULL,
  COST_CENTER_CD             NUMBER             DEFAULT 0                     NOT NULL,
  COUNT_CYCLE_CD             NUMBER             DEFAULT 0                     NOT NULL,
  CONSIGNMENT_IND            NUMBER,
  ECONOMIC_ORDER_QTY         NUMBER,
  FILL_LOCATION_CD           NUMBER             DEFAULT 0                     NOT NULL,
  ITEM_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  I_CTRL_UPDT_CNT            NUMBER,
  INSTANCE_IND               NUMBER,
  LOCATION_CD                NUMBER             DEFAULT 0                     NOT NULL,
  LOCATION_TYPE_CD           NUMBER             DEFAULT 0                     NOT NULL,
  VIEW_TYPE_CD               NUMBER             DEFAULT 0                     NOT NULL,
  LOT_TRACKING_LEVEL_CD      NUMBER             DEFAULT 0                     NOT NULL,
  MAXIMUM_LEVEL              NUMBER,
  MINIMUM_LEVEL              NUMBER,
  MAX_DAYS_ADU               NUMBER,
  MIN_DAYS_ADU               NUMBER,
  ORGANIZATION_ID            NUMBER             DEFAULT 0                     NOT NULL,
  PRIMARY_VENDOR_CD          NUMBER             DEFAULT 0                     NOT NULL,
  PRIMARY_VENDOR_ITEM_ID     NUMBER             DEFAULT 0                     NOT NULL,
  PRODUCT_ORIGIN_CD          NUMBER             DEFAULT 0                     NOT NULL,
  QTY_REQ_UPDT_CNT           NUMBER,
  REORDER_METHOD_CD          NUMBER             DEFAULT 0                     NOT NULL,
  REORDER_PACKAGE_TYPE_DESC  VARCHAR2(100 BYTE),
  REORDER_PACKAGE_TYPE_ID    NUMBER             DEFAULT 0                     NOT NULL,
  REORDER_POINT              NUMBER,
  REORDER_TYPE_CD            NUMBER             DEFAULT 0                     NOT NULL,
  SAFETY_STOCK_QTY           NUMBER,
  SEASONAL_ITEM_IND          NUMBER,
  STOCK_PACKAGE_TYPE_DESC    VARCHAR2(100 BYTE),
  STOCK_PACKAGE_TYPE_ID      NUMBER             DEFAULT 0                     NOT NULL,
  STOCK_TYPE_IND             NUMBER,
  SUB_ACCOUNT_CD             NUMBER             DEFAULT 0                     NOT NULL,
  SYSCALC_ABC_CLASS_IND      NUMBER,
  SYSCALC_PAR_LEVEL_IND      NUMBER,
  SYSCALC_REORDER_POINT_IND  NUMBER,
  SYSCALC_SAFETY_STOCK_IND   NUMBER,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  LAST_SYSCALC_DT_TM         DATE,
  COUNTBACK_FLAG             NUMBER             DEFAULT 0,
  LOCK_IND                   NUMBER             DEFAULT 0,
  FIXED_ORDER_QTY            FLOAT(126)         DEFAULT 0,
  LOCATOR_QTY                FLOAT(126)         DEFAULT 0,
  LOCATOR_TYPE_CD            NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_OMF_ITEM_MASTER
(
  ITEM_MASTER_ID            NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_CD                 NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_DT_NBR             NUMBER,
  ACTIVE_DT_TM              DATE,
  ACTIVE_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_MIN_NBR            NUMBER,
  APPROVED_IND              NUMBER,
  BASE_PKG_DESC             VARCHAR2(40 BYTE),
  BASE_PKG_ID               NUMBER              DEFAULT 0                     NOT NULL,
  BASE_PKG_QTY              NUMBER,
  BASE_PKG_UOM_CD           NUMBER              DEFAULT 0                     NOT NULL,
  CLASS_NAME                VARCHAR2(60 BYTE),
  CLASS_NODE_ID             NUMBER              DEFAULT 0                     NOT NULL,
  COMPONENT_IND             NUMBER,
  COUNTABLE_IND             NUMBER,
  CREATE_DT_NBR             NUMBER,
  CREATE_DT_TM              DATE,
  CREATE_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  CREATE_MIN_NBR            NUMBER,
  CRITICAL_IND              NUMBER,
  DESCRIPTION               VARCHAR2(200 BYTE),
  FDA_REPORTABLE_IND        NUMBER,
  ITEM_COUNT                NUMBER,
  LAST_ORDER_CONTRACT_DESC  VARCHAR2(100 BYTE),
  LAST_ORDER_DT_NBR         NUMBER,
  LAST_ORDER_DT_TM          DATE,
  LAST_ORDER_MIN_NBR        NUMBER,
  LAST_ORDER_PRICE          FLOAT(126),
  LAST_ORDER_PRICE_TYPE_CD  NUMBER              DEFAULT 0                     NOT NULL,
  LAST_RECEIPT_DT_NBR       NUMBER,
  LAST_RECEIPT_DT_TM        DATE,
  LAST_RECEIPT_MIN_NBR      NUMBER,
  LAST_UPDT_DT_NBR          NUMBER,
  LAST_UPDT_DT_TM           DATE,
  LAST_UPDT_ID              NUMBER              DEFAULT 0                     NOT NULL,
  LAST_UPDT_MIN_NBR         NUMBER,
  LAST_VOUCHER_DT_NBR       NUMBER,
  LAST_VOUCHER_DT_TM        DATE,
  LAST_VOUCHER_MIN_NBR      NUMBER,
  NDC                       VARCHAR2(40 BYTE),
  QUICKADD_IND              NUMBER,
  REUSABLE_IND              NUMBER,
  SCHEDUABLE_IND            NUMBER,
  SHORT_DESC                VARCHAR2(200 BYTE),
  STERILE_REQ_IND           NUMBER,
  STOCK_NBR                 VARCHAR2(40 BYTE),
  SYS_ITEM_NBR              VARCHAR2(20 BYTE),
  TYPE_CD                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  LAST_ORDER_PKG_DESC       VARCHAR2(40 BYTE),
  LAST_RECEIPT_PKG_DESC     VARCHAR2(40 BYTE),
  LAST_REQ_DT_TM            DATE,
  LAST_REQ_DT_NBR           NUMBER              DEFAULT 0,
  LAST_REQ_MIN_NBR          NUMBER              DEFAULT 0,
  LAST_DIST_DT_TM           DATE,
  LAST_DIST_DT_NBR          NUMBER              DEFAULT 0,
  LAST_DIST_MIN_NBR         NUMBER              DEFAULT 0,
  PHA_TYPE_FLAG             NUMBER              DEFAULT 0,
  ITEM_LEVEL_FLAG           NUMBER              DEFAULT 0,
  LOGICAL_DOMAIN_ID         NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_OMF_MFG_ITEM
(
  MFG_ITEM_ID               NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_CD                 NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_DT_NBR             NUMBER,
  ACTIVE_DT_TM              DATE,
  ACTIVE_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_MIN_NBR            NUMBER,
  AWP                       FLOAT(126),
  AWP_BULK                  FLOAT(126),
  AWP_FACTOR                FLOAT(126),
  BRAND_NAME                VARCHAR2(100 BYTE),
  COST1                     FLOAT(126),
  COST2                     FLOAT(126),
  CREATE_DT_NBR             NUMBER,
  CREATE_DT_TM              DATE,
  CREATE_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  CREATE_MIN_NBR            NUMBER,
  DESCRIPTION               VARCHAR2(200 BYTE),
  ITEM_COUNT                NUMBER,
  ITEM_NBR                  VARCHAR2(40 BYTE),
  LAST_UPDT_DT_NBR          NUMBER,
  LAST_UPDT_DT_TM           DATE,
  LAST_UPDT_ID              NUMBER              DEFAULT 0                     NOT NULL,
  LAST_UPDT_MIN_NBR         NUMBER,
  MFG_CD                    NUMBER              DEFAULT 0                     NOT NULL,
  NDC                       VARCHAR2(40 BYTE),
  QUICKADD_IND              NUMBER,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  LAST_ORDER_DT_TM          DATE,
  LAST_ORDER_MIN_NBR        NUMBER,
  LAST_ORDER_DT_NBR         NUMBER,
  LAST_RECEIPT_DT_TM        DATE,
  LAST_RECEIPT_MIN_NBR      NUMBER,
  LAST_RECEIPT_DT_NBR       NUMBER,
  LAST_VOUCHER_DT_TM        DATE,
  LAST_VOUCHER_MIN_NBR      NUMBER,
  LAST_VOUCHER_DT_NBR       NUMBER,
  LAST_REQ_DT_TM            DATE,
  LAST_REQ_MIN_NBR          NUMBER,
  LAST_REQ_DT_NBR           NUMBER,
  LAST_DIST_DT_TM           DATE,
  LAST_DIST_MIN_NBR         NUMBER,
  LAST_DIST_DT_NBR          NUMBER,
  LAST_ORDER_PKG_DESC       VARCHAR2(40 BYTE),
  LAST_ORDER_PRICE          FLOAT(126),
  LAST_ORDER_PRICE_TYPE_CD  NUMBER              DEFAULT 0                     NOT NULL,
  LAST_ORDER_CONTRACT_DESC  VARCHAR2(100 BYTE),
  LAST_RECEIPT_PKG_DESC     VARCHAR2(40 BYTE),
  LOGICAL_DOMAIN_ID         NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_OMF_PO
(
  PURCHASE_ORDER_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  BUYER_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  BILL_TO_ADDRESS_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  CLOSED_DT_NBR          NUMBER,
  CLOSED_DT_TM           DATE,
  CLOSED_MIN_NBR         NUMBER,
  COMMIT_DT_NBR          NUMBER,
  COMMIT_DT_TM           DATE,
  COMMIT_MIN_NBR         NUMBER,
  COMPANY_NBR            VARCHAR2(20 BYTE),
  CONFIRMED_BY           VARCHAR2(40 BYTE),
  CONTACT                VARCHAR2(40 BYTE),
  PO_CREATE_DT_NBR       NUMBER,
  PO_CREATE_DT_TM        DATE,
  PO_CREATE_MIN_NBR      NUMBER,
  PO_CREATE_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  EFFECTIVE_DT_NBR       NUMBER,
  EFFECTIVE_DT_TM        DATE,
  EFFECTIVE_MIN_NBR      NUMBER,
  FOB_CD                 NUMBER                 DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  PO_COUNT               NUMBER,
  PO_NBR                 VARCHAR2(20 BYTE),
  RECEIVE_STATUS_CD      NUMBER                 DEFAULT 0                     NOT NULL,
  SHIP_TO_ADDRESS_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  SHIP_TO_LOC_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  SHIP_VIA_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  STATUS_CD              NUMBER                 DEFAULT 0                     NOT NULL,
  TERMS_CD               NUMBER                 DEFAULT 0                     NOT NULL,
  TOTAL_ORDER_PRICE      FLOAT(126),
  TOTAL_RECEIVED_PRICE   FLOAT(126),
  TOTAL_VOUCHERED_PRICE  FLOAT(126),
  TYPE_CD                NUMBER                 DEFAULT 0                     NOT NULL,
  PO_UPDT_DT_NBR         NUMBER,
  PO_UPDT_DT_TM          DATE,
  PO_UPDT_MIN_NBR        NUMBER,
  PO_UPDT_CNT            NUMBER,
  PO_UPDT_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  VENDOR_CD              NUMBER                 DEFAULT 0                     NOT NULL,
  VOUCHER_STATUS_CD      NUMBER                 DEFAULT 0                     NOT NULL,
  LINE_COUNT             NUMBER,
  RECEIPT_COUNT          NUMBER,
  VOUCHER_COUNT          NUMBER,
  BILL_TO_ATTN           VARCHAR2(40 BYTE),
  PO_RELEASE             VARCHAR2(20 BYTE),
  PUR_PROFILE_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  REFERENCE              VARCHAR2(40 BYTE),
  SHIP_TO_ATTN           VARCHAR2(40 BYTE),
  VENDOR_ADDRESS_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  VENDOR_SITE_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  LAST_RECEIPT_DT_NBR    NUMBER,
  LAST_RECEIPT_DT_TM     DATE,
  LAST_RECEIPT_MIN_NBR   NUMBER,
  LAST_VOUCHER_DT_NBR    NUMBER,
  LAST_VOUCHER_DT_TM     DATE,
  LAST_VOUCHER_MIN_NBR   NUMBER,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  EXPIRATION_DT_TM       DATE,
  EXPIRATION_DT_NBR      NUMBER,
  EXPIRATION_MIN_NBR     NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_OMF_PO_LINE
(
  LINE_ITEM_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_PKG_ID            NUMBER                DEFAULT 0                     NOT NULL,
  BASE_BACKORDER_QTY      NUMBER,
  BASE_CANCEL_QTY         NUMBER,
  BASE_INVOICE_QTY        NUMBER,
  BASE_ORDER_QTY          NUMBER,
  BASE_RECEIPT_QTY        NUMBER,
  BASE_PRICE              FLOAT(126),
  BUYER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  COMPANY_NBR             VARCHAR2(20 BYTE),
  CONTRACT_DESC           VARCHAR2(100 BYTE),
  CONTRACT_IND            NUMBER,
  COST_CENTER_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DELIVER_TO_LOC_CD       NUMBER                DEFAULT 0                     NOT NULL,
  DSL_IM_ORDER            NUMBER,
  DSL_IM_RECEIPT          NUMBER,
  DSL_VI_ORDER            NUMBER,
  DSL_VI_RECEIPT          NUMBER,
  ITEM_BASE_PKG_DESC      VARCHAR2(40 BYTE),
  ITEM_BASE_PKG_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ITEM_BASE_PKG_QTY       NUMBER,
  ITEM_BASE_PKG_UOM_CD    NUMBER                DEFAULT 0                     NOT NULL,
  ITEM_MASTER_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ITEM_SUB_ACCOUNT_CD     NUMBER                DEFAULT 0                     NOT NULL,
  LAST_RECEIPT_DT_NBR     NUMBER,
  LAST_RECEIPT_DT_TM      DATE,
  LAST_RECEIPT_MIN_NBR    NUMBER,
  LAST_VOUCHER_DT_NBR     NUMBER,
  LAST_VOUCHER_DT_TM      DATE,
  LAST_VOUCHER_MIN_NBR    NUMBER,
  LINE_COUNT              NUMBER,
  LINE_CREATE_BUYER_ID    NUMBER                DEFAULT 0                     NOT NULL,
  LINE_CREATE_DT_NBR      NUMBER,
  LINE_CREATE_DT_TM       DATE,
  LINE_CREATE_MIN_NBR     NUMBER,
  LINE_NBR                NUMBER,
  LINE_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  LINE_UPDT_BUYER_ID      NUMBER                DEFAULT 0                     NOT NULL,
  LINE_UPDT_DT_NBR        NUMBER,
  LINE_UPDT_DT_TM         DATE,
  LINE_UPDT_MIN_NBR       NUMBER,
  MFG_CD                  NUMBER                DEFAULT 0                     NOT NULL,
  MFG_ITEM_ID             NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_PKG_DESC          VARCHAR2(40 BYTE),
  ORDER_PKG_QTY           NUMBER,
  ORDER_PKG_UOM_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_PRICE             FLOAT(126),
  ORDER_PRICE_TYPE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_QTY               NUMBER,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PO_CLOSED_DT_NBR        NUMBER,
  PO_CLOSED_DT_TM         DATE,
  PO_CLOSED_MIN_NBR       NUMBER,
  PO_COMMIT_DT_NBR        NUMBER,
  PO_COMMIT_DT_TM         DATE,
  PO_COMMIT_MIN_NBR       NUMBER,
  PO_CREATE_DT_NBR        NUMBER,
  PO_CREATE_DT_TM         DATE,
  PO_CREATE_MIN_NBR       NUMBER,
  PO_EFFECTIVE_DT_NBR     NUMBER,
  PO_EFFECTIVE_DT_TM      DATE,
  PO_EFFECTIVE_MIN_NBR    NUMBER,
  PO_NBR                  VARCHAR2(20 BYTE),
  PO_STATUS_CD            NUMBER                DEFAULT 0                     NOT NULL,
  PO_TYPE_CD              NUMBER                DEFAULT 0                     NOT NULL,
  PO_UPDT_DT_NBR          NUMBER,
  PO_UPDT_DT_TM           DATE,
  PO_UPDT_MIN_NBR         NUMBER,
  PURCHASE_ORDER_ID       NUMBER                DEFAULT 0                     NOT NULL,
  RECEIVE_STATUS_CD       NUMBER                DEFAULT 0                     NOT NULL,
  SHIP_TO_LOC_CD          NUMBER                DEFAULT 0                     NOT NULL,
  SUB_ACCOUNT_CD          NUMBER                DEFAULT 0                     NOT NULL,
  VENDOR_CD               NUMBER                DEFAULT 0                     NOT NULL,
  VENDOR_ITEM_ID          NUMBER                DEFAULT 0                     NOT NULL,
  VOUCHER_STATUS_CD       NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  NC_MFR_ITEM_NBR         VARCHAR2(20 BYTE)     DEFAULT ' ',
  NC_MFR                  VARCHAR2(60 BYTE)     DEFAULT ' ',
  NC_VENDOR_ITEM_NBR      VARCHAR2(20 BYTE)     DEFAULT ' ',
  NC_DESCRIPTION          VARCHAR2(255 BYTE)    DEFAULT ' ',
  NON_CATALOG_IND         NUMBER                DEFAULT 0,
  NC_MFR_CD               NUMBER                DEFAULT 0                     NOT NULL,
  SUBSTITUTION_IND        NUMBER                DEFAULT 0,
  CNTRCT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CNTRCT_TYPE_CD          NUMBER                DEFAULT 0                     NOT NULL,
  CNTRCT_NBR              VARCHAR2(40 BYTE),
  CNTRCT_BEG_EFF_DT_TM    DATE,
  CNTRCT_BEG_EFF_MIN_NBR  NUMBER,
  CNTRCT_BEG_EFF_DT_NBR   NUMBER,
  CNTRCT_END_EFF_DT_TM    DATE,
  CNTRCT_END_EFF_MIN_NBR  NUMBER,
  CNTRCT_END_EFF_DT_NBR   NUMBER,
  UNIT_TAX                FLOAT(126)            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_OMF_RECEIPT
(
  RECEIPT_ID            NUMBER                  DEFAULT 0                     NOT NULL,
  BILL_TO_ADDRESS_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  BILL_TO_ATTN          VARCHAR2(40 BYTE),
  BUYER_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  COMMIT_DT_NBR         NUMBER,
  COMMIT_DT_TM          DATE,
  COMMIT_MIN_NBR        NUMBER,
  COMPANY_NBR           VARCHAR2(20 BYTE),
  CONFIRMED_BY          VARCHAR2(40 BYTE),
  CONTACT               VARCHAR2(40 BYTE),
  EFFECTIVE_DT_NBR      NUMBER,
  EFFECTIVE_DT_TM       DATE,
  EFFECTIVE_MIN_NBR     NUMBER,
  FOB_CD                NUMBER                  DEFAULT 0                     NOT NULL,
  LAST_VOUCHER_DT_NBR   NUMBER,
  LAST_VOUCHER_DT_TM    DATE,
  LAST_VOUCHER_MIN_NBR  NUMBER,
  ORDER_DT_NBR          NUMBER,
  ORDER_DT_TM           DATE,
  ORDER_MIN_NBR         NUMBER,
  ORGANIZATION_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  PACK_SLIP_NBR         VARCHAR2(40 BYTE),
  PO_EFFECTIVE_DT_NBR   NUMBER,
  PO_EFFECTIVE_DT_TM    DATE,
  PO_EFFECTIVE_MIN_NBR  NUMBER,
  PO_NBR                VARCHAR2(20 BYTE),
  PO_RCV_STATUS_CD      NUMBER                  DEFAULT 0                     NOT NULL,
  PO_STATUS_CD          NUMBER                  DEFAULT 0                     NOT NULL,
  PO_TYPE_CD            NUMBER                  DEFAULT 0                     NOT NULL,
  PURCHASE_ORDER_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  RECEIPT_COUNT         NUMBER,
  RECEIPT_LINE_COUNT    NUMBER,
  RECEIVE_DT_NBR        NUMBER,
  RECEIVE_DT_TM         DATE,
  RECEIVE_LOCATION_CD   NUMBER                  DEFAULT 0                     NOT NULL,
  RECEIVE_MIN_NBR       NUMBER,
  REFERENCE             VARCHAR2(40 BYTE),
  SEQUENCE              NUMBER,
  SHIP_TO_ADDRESS_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  SHIP_TO_ATTN          VARCHAR2(40 BYTE),
  STATUS_CD             NUMBER                  DEFAULT 0                     NOT NULL,
  TOTAL_ORDER_PRICE     FLOAT(126),
  TOTAL_RECEIVE_PRICE   FLOAT(126),
  TOTAL_VOUCHER_PRICE   FLOAT(126),
  VENDOR_CD             NUMBER                  DEFAULT 0                     NOT NULL,
  VOUCHER_COUNT         NUMBER,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_OMF_RECEIPT_LINE
(
  RECEIPT_LINE_ITEM_ID    NUMBER                DEFAULT 0                     NOT NULL,
  ACTUAL_ITEM_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ACTUAL_MFG_ITEM_ID      NUMBER                DEFAULT 0                     NOT NULL,
  ACTUAL_VENDOR_ITEM_ID   NUMBER                DEFAULT 0                     NOT NULL,
  BASE_ORDER_QTY          NUMBER,
  BASE_PRICE              FLOAT(126),
  BASE_RECEIPT_QTY        NUMBER,
  COMPANY_NBR             VARCHAR2(20 BYTE),
  DELIVER_TO_LOCATION_CD  NUMBER                DEFAULT 0                     NOT NULL,
  EXTENDED_PRICE          FLOAT(126),
  FROM_COST_CENTER_CD     NUMBER                DEFAULT 0                     NOT NULL,
  FROM_SUB_ACCOUNT_CD     NUMBER                DEFAULT 0                     NOT NULL,
  INVOICE_COUNT           NUMBER,
  ITEM_MASTER_ID          NUMBER                DEFAULT 0                     NOT NULL,
  LINE_COUNT              NUMBER,
  LINE_CREATE_DT_NBR      NUMBER,
  LINE_CREATE_DT_TM       DATE,
  LINE_CREATE_ID          NUMBER                DEFAULT 0                     NOT NULL,
  LINE_CREATE_MIN_NBR     NUMBER,
  LINE_ITEM_ID            NUMBER                DEFAULT 0                     NOT NULL,
  LINE_UPDT_DT_NBR        NUMBER,
  LINE_UPDT_DT_TM         DATE,
  LINE_UPDT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  LINE_UPDT_MIN_NBR       NUMBER,
  MFG_ITEM_ID             NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_DT_NBR            NUMBER,
  ORDER_DT_TM             DATE,
  ORDER_MIN_NBR           NUMBER,
  ORDER_PERSON_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_PKG_DESC          VARCHAR2(40 BYTE),
  ORDER_PKG_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_PKG_QTY           NUMBER,
  ORDER_PKG_UOM_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_PRICE             FLOAT(126),
  ORDER_PRICE_TYPE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_QTY               NUMBER,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PO_EFFECTIVE_DT_NBR     NUMBER,
  PO_EFFECTIVE_DT_TM      DATE,
  PO_EFFECTIVE_MIN_NBR    NUMBER,
  PO_LINE_NBR             NUMBER,
  PO_NBR                  VARCHAR2(20 BYTE),
  PO_RCV_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  PO_STATUS_CD            NUMBER                DEFAULT 0                     NOT NULL,
  PURCHASE_ORDER_ID       NUMBER                DEFAULT 0                     NOT NULL,
  RCV_EFFECTIVE_DT_NBR    NUMBER,
  RCV_EFFECTIVE_DT_TM     DATE,
  RCV_EFFECTIVE_MIN_NBR   NUMBER,
  RECEIPT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  RECEIPT_PKG_DESC        VARCHAR2(40 BYTE),
  RECEIPT_PKG_ID          NUMBER                DEFAULT 0                     NOT NULL,
  RECEIPT_PKG_QTY         NUMBER,
  RECEIPT_PKG_UOM_CD      NUMBER                DEFAULT 0                     NOT NULL,
  RECEIPT_PRICE           FLOAT(126),
  RECEIPT_QTY             NUMBER,
  TO_COST_CENTER_CD       NUMBER                DEFAULT 0                     NOT NULL,
  TO_SUB_ACCOUNT_CD       NUMBER                DEFAULT 0                     NOT NULL,
  VENDOR_ITEM_ID          NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  BASE_ACCEPTED_QTY       NUMBER,
  BASE_BACK_ORDER_QTY     NUMBER,
  BASE_CANCEL_QTY         NUMBER,
  BASE_INVOICE_QTY        NUMBER,
  NC_MFR_ITEM_NBR         VARCHAR2(20 BYTE)     DEFAULT ' ',
  NC_MFR                  VARCHAR2(60 BYTE)     DEFAULT ' ',
  NC_VENDOR_ITEM_NBR      VARCHAR2(20 BYTE)     DEFAULT ' ',
  NC_DESCRIPTION          VARCHAR2(255 BYTE)    DEFAULT ' ',
  NON_CATALOG_IND         NUMBER                DEFAULT 0,
  NC_MFR_CD               NUMBER                DEFAULT 0                     NOT NULL,
  SUBSTITUTION_IND        NUMBER                DEFAULT 0,
  UNIT_TAX                FLOAT(126)            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_OMF_VENDOR_ITEM
(
  VENDOR_ITEM_ID            NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_CD                 NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_DT_NBR             NUMBER,
  ACTIVE_DT_TM              DATE,
  ACTIVE_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_MIN_NBR            NUMBER,
  CREATE_DT_NBR             NUMBER,
  CREATE_DT_TM              DATE,
  CREATE_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  CREATE_MIN_NBR            NUMBER,
  DESCRIPTION               VARCHAR2(200 BYTE),
  ITEM_COUNT                NUMBER,
  ITEM_NBR                  VARCHAR2(40 BYTE),
  LAST_ORDER_CONTRACT_DESC  VARCHAR2(100 BYTE),
  LAST_ORDER_DT_NBR         NUMBER,
  LAST_ORDER_DT_TM          DATE,
  LAST_ORDER_MIN_NBR        NUMBER,
  LAST_ORDER_PRICE          FLOAT(126),
  LAST_ORDER_PRICE_TYPE_CD  NUMBER              DEFAULT 0                     NOT NULL,
  LAST_RECEIPT_DT_NBR       NUMBER,
  LAST_RECEIPT_DT_TM        DATE,
  LAST_RECEIPT_MIN_NBR      NUMBER,
  LAST_UPDT_DT_NBR          NUMBER,
  LAST_UPDT_DT_TM           DATE,
  LAST_UPDT_ID              NUMBER              DEFAULT 0                     NOT NULL,
  LAST_UPDT_MIN_NBR         NUMBER,
  LAST_VOUCHER_DT_NBR       NUMBER,
  LAST_VOUCHER_DT_TM        DATE,
  LAST_VOUCHER_MIN_NBR      NUMBER,
  QUICKADD_IND              NUMBER,
  VENDOR_CD                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  LAST_REQ_DT_TM            DATE,
  LAST_REQ_MIN_NBR          NUMBER,
  LAST_REQ_DT_NBR           NUMBER,
  LAST_DIST_DT_TM           DATE,
  LAST_DIST_MIN_NBR         NUMBER,
  LAST_DIST_DT_NBR          NUMBER,
  LAST_ORDER_PKG_DESC       VARCHAR2(40 BYTE),
  LAST_RECEIPT_PKG_DESC     VARCHAR2(40 BYTE),
  LOGICAL_DOMAIN_ID         NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_PAYMENT
(
  MM_PAYMENT_ID        NUMBER                   DEFAULT 0                     NOT NULL,
  PURCHASE_ORDER_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  FOREIGN_VOUCHER_NBR  VARCHAR2(40 BYTE),
  REFERENCE_NBR        VARCHAR2(60 BYTE),
  PAYMENT_TYPE         VARCHAR2(60 BYTE),
  CHECK_NBR            VARCHAR2(40 BYTE),
  PAYMENT_DT_TM        DATE,
  MM_PAYMENT_COMMENT   VARCHAR2(255 BYTE),
  PRSNL_NAME           VARCHAR2(100 BYTE),
  PAYMENT_METHOD       VARCHAR2(60 BYTE),
  AMOUNT               FLOAT(126),
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  CREATE_DT_TM         DATE                     DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  CREATE_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  CREATE_TASK          NUMBER,
  CREATE_APPLCTX       NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_PROFILE
(
  PROFILE_ID                      NUMBER        DEFAULT 0                     NOT NULL,
  PROFILE_TYPE_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  DISPLAY                         VARCHAR2(40 BYTE),
  DESCRIPTION                     VARCHAR2(60 BYTE),
  ACK_VAR_IND                     NUMBER,
  ACK_VAR_PCT                     FLOAT(126),
  ACK_VAR_AMT                     FLOAT(126),
  CONTRACT_VAR_IND                NUMBER,
  CONTRACT_VAR_PCT                FLOAT(126),
  CONTRACT_VAR_AMT                FLOAT(126),
  ALLOW_BACKORDER_IND             NUMBER,
  PO_MAX_LINES                    NUMBER,
  ALLOW_OVERSHIPMENT_IND          NUMBER,
  BLIND_RECEIPT_IND               NUMBER,
  MANUAL_RECEIPT_IND              NUMBER,
  PO_INVOICE_VAR_PCT              FLOAT(126),
  PO_INVOICE_VAR_AMT              FLOAT(126),
  UNIT_PRICE_IND                  NUMBER,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  CREATE_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  CREATE_DT_TM                    DATE,
  CREATE_TASK                     NUMBER,
  CREATE_APPLCTX                  NUMBER,
  RCV_LOC_CD                      NUMBER        DEFAULT 0                     NOT NULL,
  ACTIVE_IND                      NUMBER,
  ACTIVE_STATUS_CD                NUMBER        DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM             DATE,
  ACTIVE_STATUS_PRSNL_ID          NUMBER        DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  VIEW_PRICE_IND                  NUMBER,
  INV_ADDL_AMT_VAR_AMT            FLOAT(126)    DEFAULT 0,
  INV_ADDL_AMT_VAR_IND            NUMBER        DEFAULT 0,
  EXCEPTION_EMAIL                 VARCHAR2(255 BYTE),
  EXCEPTION_PRINTER               VARCHAR2(60 BYTE),
  AUTO_PAY_IND                    NUMBER        DEFAULT 0,
  DEFAULT_FROM_RECEIVING_IND      NUMBER        DEFAULT 0,
  REMAINING_SHELF_LIFE_PCT        FLOAT(126)    DEFAULT 0,
  ALLOW_REMAINING_SHELF_LIFE_IND  NUMBER        DEFAULT 0,
  PO_INVOICE_LESS_VAR_PCT         FLOAT(126)    DEFAULT 0,
  PO_INVOICE_LESS_VAR_AMT         FLOAT(126)    DEFAULT 0,
  LOGICAL_DOMAIN_ID               NUMBER        DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_PROFILE_GROUP
(
  PROFILE_ID          NUMBER                    DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME  CHAR(32 BYTE)             DEFAULT ' '                   NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_REQ_FILL_ROUTE
(
  MM_REQ_FILL_ROUTE_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  FILL_LOC_CD           NUMBER                  DEFAULT 0                     NOT NULL,
  REQ_LOC_CD            NUMBER                  DEFAULT 0                     NOT NULL,
  ITEM_TYPE_CD          NUMBER                  DEFAULT 0                     NOT NULL,
  CLASS_NODE_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  ITEM_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  CREATE_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  CREATE_DT_TM          DATE,
  CREATE_TASK           NUMBER,
  CREATE_APPLCTX        NUMBER,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  FILL_LOC_SEQ          NUMBER,
  RCV_PROFILE_ID        NUMBER                  DEFAULT 0,
  PUR_PROFILE_ID        NUMBER                  DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_SUPPLY_CABINET
(
  MM_SUPPLY_CABINET_ID   NUMBER                 DEFAULT 0                     NOT NULL,
  BUS_DOMAIN_NAME        VARCHAR2(30 BYTE),
  SC_TRANS_FLAG          NUMBER                 DEFAULT 0                     NOT NULL,
  SC_TRANS_DT_TM         DATE,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  ITEM_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  SC_ITEM_TXT            VARCHAR2(255 BYTE)     DEFAULT ' '                   NOT NULL,
  SC_REASON_TXT          VARCHAR2(255 BYTE),
  SC_EXP_DT_TM           DATE,
  SC_ITEM_QTY            FLOAT(126),
  SC_MFR_NAME            VARCHAR2(60 BYTE),
  MFR_CD                 NUMBER                 DEFAULT 0                     NOT NULL,
  SC_MFR_CAT_NBR_TXT     VARCHAR2(255 BYTE),
  SC_SERIAL_NBR_TXT      VARCHAR2(255 BYTE),
  SC_LOT_NBR_TXT         VARCHAR2(40 BYTE),
  LOT_NUMBER_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  SC_SIZE_TXT            VARCHAR2(50 BYTE),
  PRSNL_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  LOC_CD                 NUMBER                 DEFAULT 0                     NOT NULL,
  SC_LATEX_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  LATEX_CD               NUMBER                 DEFAULT 0                     NOT NULL,
  PROCESS_FLAG           NUMBER                 DEFAULT 0                     NOT NULL,
  PROCESSED_BY_APP_NAME  VARCHAR2(30 BYTE),
  PROCESSED_BY_APP_ID    NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  DEVICE_IDENT           VARCHAR2(150 BYTE),
  SC_TRANS_IDENT         VARCHAR2(150 BYTE)     DEFAULT ' '                   NOT NULL,
  MFR_ITEM_ID            NUMBER                 DEFAULT 0                     NOT NULL,
  SURG_CASE_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  SC_SURG_CASE_NBR_TXT   VARCHAR2(25 BYTE),
  SEG_CD                 NUMBER                 DEFAULT 0                     NOT NULL,
  ITEM_CLASS_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  PROCESSED_BY_DOC_IND   NUMBER                 DEFAULT 0                     NOT NULL,
  PROCESSED_BY_PL_IND    NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_TEMPLATE
(
  MM_TEMPLATE_ID           NUMBER               DEFAULT 0                     NOT NULL,
  LOCATION_CD              NUMBER               DEFAULT 0                     NOT NULL,
  TEMPLATE_NAME            VARCHAR2(255 BYTE)   DEFAULT ' '                   NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  TEMPLATE_TYPE_CD         NUMBER               DEFAULT 0                     NOT NULL,
  TEMPLATE_NAME_KEY        VARCHAR2(255 BYTE)   DEFAULT ' '                   NOT NULL,
  TEMPLATE_NAME_KEY_NLS    VARCHAR2(512 BYTE)   DEFAULT ' '                   NOT NULL,
  ITEM_TEMPLATE_ID         NUMBER               DEFAULT 0                     NOT NULL,
  CYCLE_CNT_TYPE_CD        NUMBER               DEFAULT 0                     NOT NULL,
  MAX_ITEM_QTY             FLOAT(126)           DEFAULT 0                     NOT NULL,
  ADU_QTY                  FLOAT(126)           DEFAULT 0                     NOT NULL,
  ADU_OP_FLAG              NUMBER               DEFAULT 0                     NOT NULL,
  ITEM_DISTRIBUTION_FLAG   NUMBER               DEFAULT 0                     NOT NULL,
  SHEET_QTY                FLOAT(126)           DEFAULT 0                     NOT NULL,
  TEMPLATE_NAME_KEY_A_NLS  VARCHAR2(1020 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_TEMPLATE_ITEM
(
  MM_TEMPLATE_ITEM_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  MM_TEMPLATE_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  ITEM_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  ITEM_SEQ             NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_TRANS_ERROR_LOG
(
  ERROR_LOG_ID      NUMBER                      DEFAULT 0                     NOT NULL,
  TRANS_ERROR_CD    NUMBER                      DEFAULT 0                     NOT NULL,
  TRANS_COMMENT     VARCHAR2(255 BYTE),
  TRANSACTION_ID    NUMBER                      DEFAULT 0                     NOT NULL,
  MM_TRANS_LINE_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  MM_TRANS_GL_ID    NUMBER                      DEFAULT 0                     NOT NULL,
  CREATE_DT_TM      DATE                        DEFAULT SYSDATE               NOT NULL,
  CREATE_ID         NUMBER                      DEFAULT 0                     NOT NULL,
  CREATE_TASK       NUMBER,
  CREATE_APPLCTX    NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_TRANS_GL
(
  ADDITIONAL_TYPE_CD     NUMBER                 DEFAULT 0                     NOT NULL,
  MM_TRANS_GL_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  TRANSACTION_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  MM_TRANS_LINE_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  TRANS_STATUS_CD        NUMBER                 DEFAULT 0                     NOT NULL,
  TO_COST_CENTER_CD      NUMBER                 DEFAULT 0                     NOT NULL,
  TO_COST_CENTER_DISP    VARCHAR2(40 BYTE),
  TO_COST_CENTER_DESC    VARCHAR2(60 BYTE),
  TO_SUB_ACCOUNT_CD      NUMBER                 DEFAULT 0                     NOT NULL,
  TO_SUB_ACCOUNT_DISP    VARCHAR2(40 BYTE),
  TO_SUB_ACCOUNT_DESC    VARCHAR2(60 BYTE),
  FROM_COST_CENTER_CD    NUMBER                 DEFAULT 0                     NOT NULL,
  FROM_COST_CENTER_DISP  VARCHAR2(40 BYTE),
  FROM_COST_CENTER_DESC  VARCHAR2(60 BYTE),
  FROM_SUB_ACCOUNT_CD    NUMBER                 DEFAULT 0                     NOT NULL,
  FROM_SUB_ACCOUNT_DISP  VARCHAR2(40 BYTE),
  FROM_SUB_ACCOUNT_DESC  VARCHAR2(60 BYTE),
  AMOUNT                 FLOAT(126),
  CREATE_DT_TM           DATE                   DEFAULT SYSDATE               NOT NULL,
  CREATE_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  CREATE_TASK            NUMBER                 DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX         NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  FROM_COMPANY_CODE      VARCHAR2(16 BYTE),
  FROM_ORG_ID            NUMBER                 DEFAULT 0                     NOT NULL,
  FROM_ORG_NAME          VARCHAR2(100 BYTE),
  TO_COMPANY_CODE        VARCHAR2(16 BYTE),
  TO_ORG_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  TO_ORG_NAME            VARCHAR2(100 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_TRANS_HEADER
(
  TRANSACTION_ID      NUMBER                    DEFAULT 0                     NOT NULL,
  TRANS_NUMBER        VARCHAR2(40 BYTE),
  TRANS_DT_TM         DATE                      DEFAULT SYSDATE               NOT NULL,
  TRANS_TYPE_CD       NUMBER                    DEFAULT 0                     NOT NULL,
  TRANS_TYPE_DISP     VARCHAR2(40 BYTE),
  TRANS_TYPE_DESC     VARCHAR2(60 BYTE),
  TRANS_APP_NAME      VARCHAR2(60 BYTE),
  TRANS_TASK_NAME     VARCHAR2(60 BYTE),
  TRANS_REQ_NAME      VARCHAR2(40 BYTE),
  TRANS_PERSON_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  TRANS_PERSON_NAME   VARCHAR2(100 BYTE),
  PARENT_ENTITY_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME  VARCHAR2(32 BYTE),
  PARENT_ENTITY_REF   VARCHAR2(40 BYTE),
  CREATE_DT_TM        DATE                      DEFAULT SYSDATE               NOT NULL,
  CREATE_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  CREATE_TASK         NUMBER,
  CREATE_APPLCTX      NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  PURCHASE_ORDER_ID   NUMBER                    DEFAULT 0                     NOT NULL,
  PO_NBR              VARCHAR2(40 BYTE),
  PO_RECEIPT_ID       NUMBER                    DEFAULT 0                     NOT NULL,
  PO_RECEIPT_NBR      VARCHAR2(10 BYTE),
  REQUISITION_ID      NUMBER                    DEFAULT 0                     NOT NULL,
  REQ_NBR             VARCHAR2(40 BYTE),
  DISTRIBUTION_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  DIST_NBR            VARCHAR2(40 BYTE),
  BATCH_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  BATCH_SUBMIT_DT_TM  DATE,
  LOGICAL_DOMAIN_ID   NUMBER                    DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_TRANS_LINE
(
  MM_TRANS_LINE_ID            NUMBER            DEFAULT 0                     NOT NULL,
  TRANSACTION_ID              NUMBER            DEFAULT 0                     NOT NULL,
  TRANS_STATUS_CD             NUMBER            DEFAULT 0                     NOT NULL,
  TRANS_PARENT_TRANS_ID       NUMBER            DEFAULT 0                     NOT NULL,
  ITEM_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  ITEM_NBR_ID                 NUMBER            DEFAULT 0                     NOT NULL,
  ITEM_NBR                    VARCHAR2(200 BYTE),
  ITEM_DESC_ID                NUMBER            DEFAULT 0                     NOT NULL,
  ITEM_DESC                   VARCHAR2(200 BYTE),
  ITEM_TYPE_CD                NUMBER            DEFAULT 0                     NOT NULL,
  ITEM_TYPE_DISP              VARCHAR2(40 BYTE),
  ITEM_TYPE_DESC              VARCHAR2(60 BYTE),
  FROM_TRANS_QTY              FLOAT(126),
  FROM_QTY_UNIT_COST          FLOAT(126),
  FROM_LOCATION_CD            NUMBER            DEFAULT 0                     NOT NULL,
  FROM_LOCATION_DISP          VARCHAR2(40 BYTE),
  FROM_LOCATION_DESC          VARCHAR2(60 BYTE),
  FROM_LAST_COST_OLD          FLOAT(126),
  FROM_LAST_COST_NEW          FLOAT(126),
  FROM_AVERAGE_COST_OLD       FLOAT(126),
  FROM_AVERAGE_COST_NEW       FLOAT(126),
  FROM_PKG_TYPE_ID            NUMBER            DEFAULT 0                     NOT NULL,
  FROM_PKG_DESC               VARCHAR2(100 BYTE),
  FROM_PKG_UOM_CD             NUMBER            DEFAULT 0                     NOT NULL,
  FROM_PKG_UOM_DISP           VARCHAR2(40 BYTE),
  FROM_PKG_UOM_DESC           VARCHAR2(60 BYTE),
  FROM_PKG_QTY                FLOAT(126),
  FROM_QOH_OLD                FLOAT(126),
  FROM_QOH_NEW                FLOAT(126),
  FROM_QOH_TYPE_CD            NUMBER            DEFAULT 0                     NOT NULL,
  FROM_QOH_TYPE_DISP          VARCHAR2(40 BYTE),
  FROM_QOH_TYPE_DESC          VARCHAR2(60 BYTE),
  TO_LAST_COST_OLD            FLOAT(126),
  TO_LAST_COST_NEW            FLOAT(126),
  TO_AVERAGE_COST_NEW         FLOAT(126),
  TO_AVERAGE_COST_OLD         FLOAT(126),
  TO_LOCATION_CD              NUMBER            DEFAULT 0                     NOT NULL,
  TO_LOCATION_DISP            VARCHAR2(40 BYTE),
  TO_LOCATION_DESC            VARCHAR2(60 BYTE),
  TO_LOCATOR_CD               NUMBER            DEFAULT 0                     NOT NULL,
  TO_LOCATOR_DISP             VARCHAR2(40 BYTE),
  TO_LOCATOR_DESC             VARCHAR2(60 BYTE),
  TO_QOH_OLD                  FLOAT(126),
  TO_QOH_NEW                  FLOAT(126),
  TO_QOH_TYPE_CD              NUMBER            DEFAULT 0                     NOT NULL,
  TO_QOH_TYPE_DISP            VARCHAR2(40 BYTE),
  TO_QOH_TYPE_DESC            VARCHAR2(60 BYTE),
  TO_PKG_TYPE_ID              NUMBER            DEFAULT 0                     NOT NULL,
  TO_PKG_DESC                 VARCHAR2(100 BYTE),
  TO_PKG_UOM_CD               NUMBER            DEFAULT 0                     NOT NULL,
  TO_PKG_UOM_DISP             VARCHAR2(40 BYTE),
  TO_PKG_UOM_DESC             VARCHAR2(60 BYTE),
  TO_PKG_QTY                  FLOAT(126),
  TO_QTY_UNIT_COST            FLOAT(126),
  BASE_QTY                    FLOAT(126),
  BASE_PKG_TYPE_ID            NUMBER            DEFAULT 0                     NOT NULL,
  BASE_PKG_DESC               VARCHAR2(100 BYTE),
  BASE_PKG_UOM_CD             NUMBER            DEFAULT 0                     NOT NULL,
  BASE_PKG_UOM_DISP           VARCHAR2(40 BYTE),
  BASE_PKG_UOM_DESC           VARCHAR2(60 BYTE),
  BASE_PKG_QTY                FLOAT(126),
  REASON_CD                   NUMBER            DEFAULT 0                     NOT NULL,
  REASON_DISP                 VARCHAR2(40 BYTE),
  REASON_DESC                 VARCHAR2(60 BYTE),
  PROJECT_CODE_CD             NUMBER            DEFAULT 0                     NOT NULL,
  PROJECT_CODE_DISP           VARCHAR2(40 BYTE),
  PROJECT_CODE_DESC           VARCHAR2(60 BYTE),
  MISC_CODE                   VARCHAR2(40 BYTE),
  CONTROL_NBR                 VARCHAR2(40 BYTE),
  HOLD_IND                    NUMBER,
  PRICE_PO_ID                 NUMBER            DEFAULT 0                     NOT NULL,
  PRICE_PO_NBR                VARCHAR2(40 BYTE),
  PRICE_CHANGED_QTY           FLOAT(126),
  PRICE_COST_OLD              FLOAT(126),
  PRICE_COST_NEW              FLOAT(126),
  PRICE_ORIGINAL_TRANS_ID     NUMBER            DEFAULT 0                     NOT NULL,
  PRICE_ORIGINAL_TRANS_DT_TM  DATE,
  PRICE_VENDOR_CD             NUMBER            DEFAULT 0                     NOT NULL,
  PRICE_VENDOR_DISP           VARCHAR2(40 BYTE),
  PRICE_VENDOR_DESC           VARCHAR2(60 BYTE),
  CREATE_DT_TM                DATE              DEFAULT SYSDATE               NOT NULL,
  CREATE_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  CREATE_TASK                 NUMBER            DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX              NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  IMPACT_USAGE_IND            NUMBER,
  ACTUAL_FROM_PKG_TYPE_ID     NUMBER            DEFAULT 0                     NOT NULL,
  ACTUAL_TO_PKG_TYPE_ID       NUMBER            DEFAULT 0                     NOT NULL,
  ACTUAL_FROM_TRANS_QTY       FLOAT(126),
  ACTUAL_TO_TRANS_QTY         FLOAT(126),
  ACTUAL_FROM_QTY_UNIT_COST   FLOAT(126),
  TO_TRANS_QTY                FLOAT(126),
  FROM_LOCATOR_CD             NUMBER            DEFAULT 0                     NOT NULL,
  FROM_LOCATOR_DESC           VARCHAR2(60 BYTE),
  FROM_LOCATOR_DISP           CHAR(40 BYTE),
  BILL_ONLY_IND               NUMBER,
  LINE_ITEM_ID                NUMBER            DEFAULT 0                     NOT NULL,
  PO_LINE_NBR                 NUMBER,
  REQ_LINE_NBR                NUMBER,
  COST_OVERRIDE_IND           NUMBER,
  RECEIPT_LINE_ITEM_ID        NUMBER            DEFAULT 0                     NOT NULL,
  CONSIGN_IND                 NUMBER,
  CONSIGN_PROCESS_FLAG        NUMBER,
  PCB_LAST_COST               FLOAT(126),
  DB_LAST_COST                FLOAT(126),
  PCB_AVG_COST                FLOAT(126),
  DB_AVG_COST                 FLOAT(126),
  PATIENT_ID                  NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  BATCH_SUBMIT_DT_TM          DATE,
  BATCH_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  QOH_FLAG                    NUMBER            DEFAULT 0,
  TRANSFER_FLAG               NUMBER            DEFAULT 0,
  OFFSET_LOCATION_CD          NUMBER            DEFAULT 0,
  LOT_PARENT_ENTITY_NAME      VARCHAR2(32 BYTE) DEFAULT ' ',
  LOT_PARENT_ENTITY_ID        NUMBER            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_CNTRCT_ACTION
(
  TRANSACTION_ID    NUMBER                      DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_CD    NUMBER                      DEFAULT 0                     NOT NULL,
  ACTION_PERIOD     VARCHAR2(60 BYTE),
  ACTION_PERIOD_CD  NUMBER                      DEFAULT 0                     NOT NULL,
  ACTION_REASON     VARCHAR2(60 BYTE),
  ACTION_REASON_CD  NUMBER                      DEFAULT 0                     NOT NULL,
  ACTION_DT_TM      DATE,
  ACTION_USER       VARCHAR2(60 BYTE),
  ACTION_USER_ID    NUMBER                      DEFAULT 0                     NOT NULL,
  ACTION_FLAG       NUMBER,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  PROCESS_FLAG      NUMBER,
  TRANS_PARENT_ID   NUMBER                      DEFAULT 0                     NOT NULL,
  ACTION_ID         NUMBER                      DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX    NUMBER,
  CREATE_DT_TM      DATE,
  CREATE_ID         NUMBER                      DEFAULT 0                     NOT NULL,
  CREATE_TASK       NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_CNTRCT_HDR
(
  TRANSACTION_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_CD        NUMBER                  DEFAULT 0                     NOT NULL,
  PROCESS_FLAG          NUMBER                  DEFAULT 0                     NOT NULL,
  ACTION_FLAG           NUMBER                  DEFAULT 0                     NOT NULL,
  CNTRCT_NBR            VARCHAR2(40 BYTE)       DEFAULT ' '                   NOT NULL,
  CNTRCT_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  CNTRCT_NAME           VARCHAR2(100 BYTE),
  CNTRCT_TERM           VARCHAR2(60 BYTE),
  CNTRCT_TERM_CD        NUMBER                  DEFAULT 0                     NOT NULL,
  VENDOR                VARCHAR2(60 BYTE),
  CNTRCT_TYPE           VARCHAR2(60 BYTE),
  CNTRCT_TYPE_CD        NUMBER                  DEFAULT 0                     NOT NULL,
  STATUS                VARCHAR2(60 BYTE),
  STATUS_CD             NUMBER                  DEFAULT 0                     NOT NULL,
  MFR                   VARCHAR2(60 BYTE),
  CATALOG_NAME          VARCHAR2(100 BYTE),
  LOCATION              VARCHAR2(60 BYTE),
  LOCATION_CD           NUMBER                  DEFAULT 0                     NOT NULL,
  MSTR_AGREEMENT_IND    NUMBER,
  MSTR_AGREEMENT_NBR    VARCHAR2(40 BYTE),
  MSTR_AGREEMENT_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  REF_CNTRCT_NBR        VARCHAR2(40 BYTE),
  REF_CNTRCT_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  START_DT_TM           DATE,
  EFFECTIVE_DT_TM       DATE,
  EXPIRATION_DT_TM      DATE,
  SIGNED_BY_VENDOR      VARCHAR2(100 BYTE),
  SIGNED_BY_ORG         VARCHAR2(100 BYTE),
  COST_CENTER           VARCHAR2(60 BYTE),
  COST_CENTER_CD        NUMBER                  DEFAULT 0                     NOT NULL,
  CLASS_NODE            VARCHAR2(100 BYTE),
  CLASS_NODE_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  PROJECT_CODE          VARCHAR2(60 BYTE),
  PROJECT_CD            NUMBER                  DEFAULT 0                     NOT NULL,
  CAPITAL_CODE          VARCHAR2(60 BYTE),
  CAPITAL_CD            NUMBER                  DEFAULT 0                     NOT NULL,
  CNTRCT_SRC_TYPE       VARCHAR2(60 BYTE),
  CNTRCT_SRC_TYPE_CD    NUMBER                  DEFAULT 0                     NOT NULL,
  CNTRCT_MGR            VARCHAR2(60 BYTE),
  CNTRCT_MGR_ID         NUMBER                  DEFAULT 0                     NOT NULL,
  AGREEMENT_INFO        VARCHAR2(100 BYTE),
  PO_NBR                VARCHAR2(40 BYTE),
  PO_ID                 NUMBER                  DEFAULT 0                     NOT NULL,
  EXECUTED_DT_TM        DATE,
  EXECUTED_BY_ORG       VARCHAR2(100 BYTE),
  EXECUTED_BY_VENDOR    VARCHAR2(100 BYTE),
  HOSPITAL_CONTACT      VARCHAR2(60 BYTE),
  HOSPITAL_CONTACT_ID   NUMBER                  DEFAULT 0                     NOT NULL,
  DESCRIPTION           VARCHAR2(255 BYTE),
  SCNDRY_VENDOR         VARCHAR2(60 BYTE),
  SCNDRY_VENDOR_MARKUP  NUMBER,
  FILL_RATE             NUMBER,
  LEAD_TIME             NUMBER,
  EXT_CNTRCT_IND        NUMBER,
  EXT_PERIOD            VARCHAR2(60 BYTE),
  EXT_PERIOD_CD         NUMBER                  DEFAULT 0                     NOT NULL,
  EXT_END_DT_TM         DATE,
  EXT_REASON            VARCHAR2(60 BYTE),
  EXT_REASON_CD         NUMBER                  DEFAULT 0                     NOT NULL,
  EXT_NOTE              VARCHAR2(255 BYTE),
  EXCEED_PRICE_IND      NUMBER,
  GPO                   VARCHAR2(60 BYTE),
  GPO_CD                NUMBER                  DEFAULT 0                     NOT NULL,
  GPO_ID_NBR            VARCHAR2(100 BYTE),
  GPO_REF_NBR           VARCHAR2(100 BYTE),
  GPO_BID_NBR           VARCHAR2(100 BYTE),
  GPO_EST_DOLLAR_VALUE  NUMBER,
  GPO_DESCRIPTION       VARCHAR2(255 BYTE),
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  VENDOR_KEY            VARCHAR2(60 BYTE),
  END_TRANSACTION_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  VENDOR_MARKUP         NUMBER,
  CREATE_APPLCTX        NUMBER,
  CREATE_DT_TM          DATE,
  CREATE_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  CREATE_TASK           NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_CNTRCT_HDR_TIER
(
  TRANSACTION_ID   NUMBER                       DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_CD   NUMBER                       DEFAULT 0                     NOT NULL,
  TIER_METRIC      VARCHAR2(60 BYTE),
  TIER_METRIC_CD   NUMBER                       DEFAULT 0                     NOT NULL,
  CLASS_NODE       VARCHAR2(60 BYTE),
  CLASS_NODE_ID    NUMBER                       DEFAULT 0                     NOT NULL,
  ORGANIZATION     VARCHAR2(100 BYTE),
  ORGANIZATION_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  ACTION_FLAG      NUMBER,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  PROCESS_FLAG     NUMBER,
  TRANS_PARENT_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  PRICE_TIER_ID    NUMBER                       DEFAULT 0                     NOT NULL,
  PRODUCT_LEVEL    FLOAT(126),
  CREATE_APPLCTX   NUMBER,
  CREATE_DT_TM     DATE,
  CREATE_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  CREATE_TASK      NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_CNTRCT_LINE
(
  TRANSACTION_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  ITEM_NBR             VARCHAR2(200 BYTE),
  CONTRIBUTOR_CD       NUMBER                   DEFAULT 0                     NOT NULL,
  ITEM_DESC            VARCHAR2(200 BYTE),
  VENDOR_CATALOG_NBR   VARCHAR2(200 BYTE),
  VENDOR_CATALOG_DESC  VARCHAR2(200 BYTE),
  MFR_CATALOG_NBR      VARCHAR2(200 BYTE),
  MFR_CATALOG_DESC     VARCHAR2(200 BYTE),
  CNTRCT_UOM           VARCHAR2(40 BYTE),
  CNTRCT_UOM_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  CNTRCT_PACK_FACTOR   NUMBER,
  MARKUP_PERCENT       NUMBER,
  UPN                  VARCHAR2(200 BYTE),
  MODEL_NBR            VARCHAR2(200 BYTE),
  SERIAL_NBR           VARCHAR2(200 BYTE),
  SHORT_DESC           VARCHAR2(200 BYTE),
  LOCATION             VARCHAR2(60 BYTE),
  LOCATION_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  COST_CENTER          VARCHAR2(60 BYTE),
  COST_CENTER_CD       NUMBER                   DEFAULT 0                     NOT NULL,
  CAPITAL_CODE         VARCHAR2(60 BYTE),
  CAPITAL_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  PROJECT_CODE         VARCHAR2(60 BYTE),
  PROJECT_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  EST_USAGE            NUMBER,
  CNTRCT_MGR           VARCHAR2(60 BYTE),
  CNTRCT_MGR_ID        NUMBER                   DEFAULT 0                     NOT NULL,
  DIST_MARKUP_IND      NUMBER,
  REBATE_EXCEMPT_IND   NUMBER,
  ADJ_EXCEMPT_IND      NUMBER,
  ACTION_FLAG          NUMBER,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  MFR                  VARCHAR2(60 BYTE),
  PROCESS_FLAG         NUMBER,
  TRANS_PARENT_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  CNTRCT_LINE_ID       NUMBER                   DEFAULT 0                     NOT NULL,
  BASE_UOM_CD          FLOAT(126)               DEFAULT 0                     NOT NULL,
  BASE_UOM             VARCHAR2(20 BYTE),
  ACQ_PRICE            FLOAT(126),
  CNTRCT_PRICE         FLOAT(126),
  MIN_ORDER_QTY        FLOAT(126),
  CLASS_NODE_ID        NUMBER                   DEFAULT 0                     NOT NULL,
  CLASS_NODE           VARCHAR2(60 BYTE),
  CREATE_APPLCTX       NUMBER,
  CREATE_DT_TM         DATE,
  CREATE_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  CREATE_TASK          NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_CNTRCT_LINE_TIER
(
  TRANSACTION_ID     NUMBER                     DEFAULT 0                     NOT NULL,
  HDR_PRICE_TIER_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  DISCOUNT           NUMBER,
  ACTION_FLAG        NUMBER,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  PROCESS_FLAG       NUMBER,
  TRANS_PARENT_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  PRICE_TIER_ID      NUMBER                     DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX     NUMBER,
  CREATE_DT_TM       DATE,
  CREATE_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  CREATE_TASK        NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_CNTRCT_ORG
(
  TRANSACTION_ID   NUMBER                       DEFAULT 0                     NOT NULL,
  TRANS_PARENT_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  ORG              VARCHAR2(100 BYTE),
  ORG_ID           NUMBER                       DEFAULT 0                     NOT NULL,
  ACTION_FLAG      NUMBER,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  PROCESS_FLAG     NUMBER,
  CREATE_APPLCTX   NUMBER,
  CREATE_DT_TM     DATE,
  CREATE_ID        NUMBER                       DEFAULT 0                     NOT NULL,
  CREATE_TASK      NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_CNTRCT_PRICE_ADJ
(
  TRANSACTION_ID     NUMBER                     DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_CD     NUMBER                     DEFAULT 0                     NOT NULL,
  ADJ_METRIC         VARCHAR2(60 BYTE),
  ADJ_METRIC_CD      NUMBER                     DEFAULT 0                     NOT NULL,
  ADJ_TYPE           VARCHAR2(60 BYTE),
  ADJ_TYPE_CD        NUMBER                     DEFAULT 0                     NOT NULL,
  ADJ_CLASS_NODE     VARCHAR2(60 BYTE),
  ADJ_CLASS_NODE_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  ACTION_FLAG        NUMBER,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  PROCESS_FLAG       NUMBER,
  TRANS_PARENT_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  PRICE_ADJ_ID       NUMBER                     DEFAULT 0                     NOT NULL,
  ADJUSTMENT         FLOAT(126),
  CREATE_APPLCTX     NUMBER,
  CREATE_DT_TM       DATE,
  CREATE_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  CREATE_TASK        NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_CNTRCT_REBATE
(
  TRANSACTION_ID     NUMBER                     DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_CD     NUMBER                     DEFAULT 0                     NOT NULL,
  ACH_METRIC         VARCHAR2(60 BYTE),
  ACH_METRIC_CD      NUMBER                     DEFAULT 0                     NOT NULL,
  PROCESS_FLAG       NUMBER,
  REBATE_CALC_ON     VARCHAR2(60 BYTE),
  REBATE_CALC_ON_CD  NUMBER                     DEFAULT 0                     NOT NULL,
  REBATE_PERIOD      VARCHAR2(60 BYTE),
  REBATE_PERIOD_CD   NUMBER                     DEFAULT 0                     NOT NULL,
  ACTION_FLAG        NUMBER,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  TRANS_PARENT_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  REBATE_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  ACH_THRESHOLD      FLOAT(126),
  CREATE_APPLCTX     NUMBER,
  CREATE_DT_TM       DATE,
  CREATE_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  CREATE_TASK        NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_COST
(
  TRANSACTION_ID           NUMBER               DEFAULT 0                     NOT NULL,
  SEGMENT_IDENTIFIER       VARCHAR2(10 BYTE)    DEFAULT ' '                   NOT NULL,
  SEGMENT_VERSION          VARCHAR2(10 BYTE)    DEFAULT ' '                   NOT NULL,
  PROCESS_FLAG             NUMBER               DEFAULT 0                     NOT NULL,
  ACTION_FLAG              NUMBER               DEFAULT 0                     NOT NULL,
  BATCH_REF                VARCHAR2(100 BYTE),
  UPDATE_RULE_FLAG         NUMBER,
  CONTRIBUTOR              VARCHAR2(40 BYTE),
  CONTRIBUTOR_CD           NUMBER               DEFAULT 0                     NOT NULL,
  ORGANIZATION             VARCHAR2(100 BYTE),
  ORGANIZATION_ID          NUMBER               DEFAULT 0                     NOT NULL,
  LOCATION                 VARCHAR2(100 BYTE),
  LOCATION_CD              NUMBER               DEFAULT 0                     NOT NULL,
  ITEM_IDENTIFIER          VARCHAR2(100 BYTE),
  ITEM_IDENTIFIER_TYPE     VARCHAR2(40 BYTE),
  ITEM_IDENTIFIER_TYPE_CD  NUMBER               DEFAULT 0                     NOT NULL,
  ITEM_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  PKG_TYPE_UOM             VARCHAR2(40 BYTE),
  PKG_TYPE_UOM_CD          NUMBER               DEFAULT 0                     NOT NULL,
  PKG_TYPE_CONV            NUMBER,
  PKG_TYPE_ID              NUMBER               DEFAULT 0                     NOT NULL,
  COST                     FLOAT(126),
  COST_TYPE                VARCHAR2(40 BYTE),
  COST_TYPE_CD             NUMBER               DEFAULT 0                     NOT NULL,
  LOC_VIEW_CD              NUMBER               DEFAULT 0                     NOT NULL,
  LOC_VIEW                 VARCHAR2(100 BYTE),
  CREATE_APPLCTX           NUMBER,
  CREATE_DT_TM             DATE,
  CREATE_ID                NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_TASK              NUMBER,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  LOGICAL_DOMAIN_ID        NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_ITEM
(
  TRANSACTION_ID                 NUMBER         DEFAULT 0                     NOT NULL,
  SEGMENT_IDENTIFIER             VARCHAR2(10 BYTE),
  SEGMENT_VERSION                VARCHAR2(10 BYTE),
  PROCESS_FLAG                   NUMBER         DEFAULT 0,
  BATCH_REF                      VARCHAR2(100 BYTE),
  ACTION_FLAG                    NUMBER         DEFAULT 0,
  UPDATE_RULE_FLAG               NUMBER         DEFAULT 0,
  RELATION_ACTION_FLAG           NUMBER         DEFAULT 0,
  CONTRIBUTOR                    VARCHAR2(40 BYTE),
  CONTRIBUTOR_CD                 NUMBER         DEFAULT 0                     NOT NULL,
  ITEM_IDENTIFIER                VARCHAR2(100 BYTE),
  ITEM_IDENTIFIER_TYPE           VARCHAR2(40 BYTE),
  ITEM_IDENTIFIER_TYPE_CD        NUMBER         DEFAULT 0                     NOT NULL,
  ITEM_MASTER_ID                 NUMBER         DEFAULT 0                     NOT NULL,
  ITEM_NBR                       VARCHAR2(40 BYTE),
  ITEM_NBR_ID                    NUMBER         DEFAULT 0                     NOT NULL,
  ITEM_DESC                      VARCHAR2(255 BYTE),
  ITEM_DESC_ID                   NUMBER         DEFAULT 0                     NOT NULL,
  ITEM_SHORT_DESC                VARCHAR2(255 BYTE),
  ITEM_SHORT_DESC_ID             NUMBER         DEFAULT 0                     NOT NULL,
  COST_CENTER                    VARCHAR2(40 BYTE),
  COST_CENTER_CD                 NUMBER         DEFAULT 0                     NOT NULL,
  SUB_ACCOUNT                    VARCHAR2(40 BYTE),
  SUB_ACCOUNT_CD                 NUMBER         DEFAULT 0                     NOT NULL,
  COMPONENT_IND                  NUMBER         DEFAULT 0,
  EQUIPMENT_IND                  NUMBER         DEFAULT 0,
  COUNTABLE_IND                  NUMBER         DEFAULT 0,
  QUICKADD_IND                   NUMBER         DEFAULT 0,
  TRACK_COMPONENT_USAGE_IND      NUMBER         DEFAULT 0,
  SAFETY_CHECK_IND               NUMBER         DEFAULT 0,
  REUSABLE_IND                   NUMBER         DEFAULT 0,
  CRITICAL_IND                   NUMBER         DEFAULT 0,
  SHELF_LIFE                     NUMBER         DEFAULT 0,
  SHELF_LIFE_UOM                 VARCHAR2(40 BYTE),
  SHELF_LIFE_UOM_CD              NUMBER         DEFAULT 0                     NOT NULL,
  FDA_REPORTABLE_IND             NUMBER         DEFAULT 0,
  SCHEDUABLE_IND                 NUMBER         DEFAULT 0,
  STERILIZATION_REQUIRED_IND     NUMBER         DEFAULT 0,
  STORAGE_REQUIREMENT            VARCHAR2(40 BYTE),
  STORAGE_REQUIREMENT_CD         NUMBER         DEFAULT 0                     NOT NULL,
  BASE_PKG_TYPE_ID               NUMBER         DEFAULT 0                     NOT NULL,
  BASE_PKG_UOM                   VARCHAR2(40 BYTE),
  BASE_PKG_UOM_CD                NUMBER         DEFAULT 0                     NOT NULL,
  BASE_PKG_CONV                  NUMBER         DEFAULT 0,
  PKG_TYPE_ID                    NUMBER         DEFAULT 0                     NOT NULL,
  PKG_TYPE_UOM                   VARCHAR2(40 BYTE),
  PKG_TYPE_UOM_CD                NUMBER         DEFAULT 0                     NOT NULL,
  PKG_TYPE_CONV                  NUMBER         DEFAULT 0,
  PKG_TYPE_ACTION_FLAG           NUMBER         DEFAULT 0,
  MFR                            VARCHAR2(60 BYTE),
  MFR_CD                         NUMBER         DEFAULT 0                     NOT NULL,
  MFR_ITEM_ID                    NUMBER         DEFAULT 0                     NOT NULL,
  MFR_ITEM_NBR                   VARCHAR2(40 BYTE),
  MFR_ITEM_NBR_ID                NUMBER         DEFAULT 0                     NOT NULL,
  MFR_ITEM_DESC                  VARCHAR2(255 BYTE),
  MFR_ITEM_DESC_ID               NUMBER         DEFAULT 0                     NOT NULL,
  MFR_ITEM_BRAND_NAME            VARCHAR2(255 BYTE),
  MFR_ITEM_BRAND_NAME_ID         NUMBER         DEFAULT 0                     NOT NULL,
  MFR_ITEM_TRADE_NAME            VARCHAR2(255 BYTE),
  MFR_ITEM_TRADE_NAME_ID         NUMBER         DEFAULT 0                     NOT NULL,
  UPN                            VARCHAR2(40 BYTE),
  UPN_ID                         NUMBER         DEFAULT 0                     NOT NULL,
  UPN_SALABLE_BY_DIST_IND        NUMBER         DEFAULT 0,
  UPN_SALABLE_BY_MFR_IND         NUMBER         DEFAULT 0,
  REPLACEMENT_UPN                VARCHAR2(40 BYTE),
  REPLACEMENT_UPN_ID             NUMBER         DEFAULT 0                     NOT NULL,
  VENDOR                         VARCHAR2(60 BYTE),
  VENDOR_CD                      NUMBER         DEFAULT 0                     NOT NULL,
  VENDOR_ITEM_ID                 NUMBER         DEFAULT 0                     NOT NULL,
  VENDOR_ITEM_NBR                VARCHAR2(40 BYTE),
  VENDOR_ITEM_NBR_ID             NUMBER         DEFAULT 0                     NOT NULL,
  VENDOR_ITEM_DESC               VARCHAR2(255 BYTE),
  VENDOR_ITEM_DESC_ID            NUMBER         DEFAULT 0                     NOT NULL,
  PRICE_ID                       NUMBER         DEFAULT 0                     NOT NULL,
  PRICE                          FLOAT(126)     DEFAULT 0.0,
  PRICE_TYPE                     VARCHAR2(40 BYTE),
  PRICE_TYPE_CD                  NUMBER         DEFAULT 0                     NOT NULL,
  PRICE_CONTRACT_DESC            VARCHAR2(100 BYTE),
  PRICE_EFF_DT_TM                DATE,
  PRICE_EXP_DT_TM                DATE,
  PRICE_RULE_FLAG                NUMBER         DEFAULT 0,
  CREATE_APPLCTX                 NUMBER         DEFAULT 0,
  CREATE_DT_TM                   DATE,
  CREATE_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  CREATE_TASK                    NUMBER         DEFAULT 0,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  ITEM_ALIAS                     VARCHAR2(40 BYTE),
  ITEM_ALIAS_ID                  NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVATE_ITEM_IND              NUMBER,
  ITEM_CLINICAL_DESC             VARCHAR2(255 BYTE),
  ITEM_CLINICAL_DESC_ID          NUMBER         DEFAULT 0                     NOT NULL,
  ORGANIZATION                   VARCHAR2(100 BYTE) DEFAULT ' ',
  ORGANIZATION_ID                NUMBER         DEFAULT 0,
  TAX_VALUE                      NUMBER         DEFAULT 0,
  TAX_VALUE_FLAG                 NUMBER         DEFAULT 0,
  ADDITIONAL_AMOUNT_TYPE_CD      NUMBER         DEFAULT 0,
  ADDITIONAL_AMOUNT_TYPE         VARCHAR2(40 BYTE) DEFAULT ' ',
  ADDITIONAL_AMOUNT_ACTION_FLAG  NUMBER         DEFAULT 0,
  ITEM_ORG_RELTN_FLAG            NUMBER         DEFAULT 0,
  LOGICAL_DOMAIN_ID              NUMBER         DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_ITEMLOC
(
  TRANSACTION_ID             NUMBER             DEFAULT 0                     NOT NULL,
  SEGMENT_VERSION            VARCHAR2(10 BYTE),
  SEGMENT_IDENTIFIER         VARCHAR2(10 BYTE),
  BATCH_REF                  VARCHAR2(100 BYTE),
  ACTION_FLAG                NUMBER,
  UPDATE_RULE_FLAG           NUMBER,
  PROCESS_FLAG               NUMBER,
  CONTRIBUTOR                VARCHAR2(40 BYTE),
  CONTRIBUTOR_CD             NUMBER             DEFAULT 0                     NOT NULL,
  ORGANIZATION               VARCHAR2(100 BYTE),
  ORGANIZATION_ID            NUMBER             DEFAULT 0                     NOT NULL,
  LOCATION                   VARCHAR2(100 BYTE),
  LOCATION_CD                NUMBER             DEFAULT 0                     NOT NULL,
  ITEM_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  ITEM_IDENTIFIER            VARCHAR2(100 BYTE),
  ITEM_IDENTIFIER_TYPE       VARCHAR2(40 BYTE),
  ITEM_IDENTIFIER_TYPE_CD    NUMBER             DEFAULT 0                     NOT NULL,
  ABC_CLASS                  CHAR(1 BYTE),
  ABC_CLASS_CD               NUMBER             DEFAULT 0                     NOT NULL,
  ACC_STOCKOUT_FREQ          NUMBER,
  AVG_DAILY_USAGE            NUMBER,
  AVG_LEAD_TIME              NUMBER,
  AVG_WEEKS_ORDER_QTY        NUMBER,
  COST_CENTER                VARCHAR2(40 BYTE),
  COST_CENTER_CD             NUMBER             DEFAULT 0                     NOT NULL,
  SUB_ACCOUNT                VARCHAR2(40 BYTE),
  SUB_ACCOUNT_CD             NUMBER             DEFAULT 0                     NOT NULL,
  ECONOMIC_ORDER_QTY         NUMBER,
  LOT_TRACKING_LEVEL         VARCHAR2(40 BYTE),
  LOT_TRACKING_LEVEL_CD      NUMBER             DEFAULT 0                     NOT NULL,
  MAX_DAYS_ADU               NUMBER,
  MAX_LEVEL                  NUMBER,
  MIN_DAYS_ADU               NUMBER,
  MIN_LEVEL                  NUMBER,
  PRIMARY_VENDOR             VARCHAR2(100 BYTE),
  PRIMARY_VENDOR_CD          NUMBER             DEFAULT 0                     NOT NULL,
  PRODUCT_ORIGIN             VARCHAR2(40 BYTE),
  PRODUCT_ORIGIN_CD          NUMBER             DEFAULT 0                     NOT NULL,
  RECALC_METHOD              VARCHAR2(40 BYTE),
  RECALC_METHOD_CD           NUMBER             DEFAULT 0                     NOT NULL,
  REORDER_POINT              NUMBER,
  REORDER_PKG_TYPE_ID        NUMBER             DEFAULT 0                     NOT NULL,
  REORDER_PKG_TYPE_CONV      NUMBER,
  REORDER_PKG_TYPE_UOM       VARCHAR2(40 BYTE),
  REORDER_PKG_TYPE_UOM_CD    NUMBER             DEFAULT 0                     NOT NULL,
  REPLENISHMENT_TYPE         VARCHAR2(40 BYTE),
  REPLENISHMENT_TYPE_CD      NUMBER             DEFAULT 0                     NOT NULL,
  SAFETY_STOCK_QTY           NUMBER,
  SEASONAL_ITEM_IND          NUMBER,
  STOCK_PKG_TYPE_ID          NUMBER             DEFAULT 0                     NOT NULL,
  STOCK_PKG_TYPE_CONV        NUMBER,
  STOCK_PKG_TYPE_UOM         VARCHAR2(40 BYTE),
  STOCK_PKG_TYPE_UOM_CD      NUMBER             DEFAULT 0                     NOT NULL,
  STOCK_TYPE_IND             NUMBER,
  SYSCALC_ABC_IND            NUMBER,
  SYSCALC_EOQ_IND            NUMBER,
  SYSCALC_PARLEVEL_IND       NUMBER,
  SYSCALC_REORDER_POINT_IND  NUMBER,
  SYSCALC_SAFETY_STOCK_IND   NUMBER,
  CREATE_APPLCTX             NUMBER             DEFAULT 0                     NOT NULL,
  CREATE_DT_TM               DATE               DEFAULT SYSDATE               NOT NULL,
  CREATE_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  CREATE_TASK                NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  CONSIGNMENT_IND            NUMBER,
  PRIMARY_VENDOR_ITEM_ID     NUMBER             DEFAULT 0                     NOT NULL,
  LOCK_IND                   NUMBER             DEFAULT 0,
  LOCATOR_TYPE               VARCHAR2(40 BYTE)  DEFAULT ' ',
  FIXED_ORDER_QTY            FLOAT(126)         DEFAULT 0,
  LOCATOR_QTY                FLOAT(126)         DEFAULT 0,
  LOCATOR_TYPE_CD            NUMBER             DEFAULT 0,
  FILL_LOCATION_NAME         VARCHAR2(100 BYTE),
  FILL_LOCATION_CD           NUMBER             DEFAULT 0,
  LOGICAL_DOMAIN_ID          NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_LOCATOR
(
  TRANSACTION_ID           NUMBER               DEFAULT 0                     NOT NULL,
  PROCESS_FLAG             NUMBER               DEFAULT 0                     NOT NULL,
  SEGMENT_IDENTIFIER       VARCHAR2(10 BYTE)    DEFAULT ' '                   NOT NULL,
  SEGMENT_VERSION          VARCHAR2(10 BYTE)    DEFAULT ' '                   NOT NULL,
  BATCH_REF                VARCHAR2(100 BYTE),
  ACTION_FLAG              NUMBER               DEFAULT 0                     NOT NULL,
  UPDATE_RULE_FLAG         NUMBER,
  CONTRIBUTOR              VARCHAR2(40 BYTE),
  CONTRIBUTOR_CD           NUMBER               DEFAULT 0                     NOT NULL,
  ORGANIZATION             VARCHAR2(100 BYTE),
  ORGANIZATION_ID          NUMBER               DEFAULT 0                     NOT NULL,
  LOCATION                 VARCHAR2(100 BYTE)   DEFAULT ' '                   NOT NULL,
  LOCATION_CD              NUMBER               DEFAULT 0                     NOT NULL,
  ITEM_IDENTIFIER          VARCHAR2(100 BYTE)   DEFAULT ' '                   NOT NULL,
  ITEM_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  ITEM_IDENTIFIER_TYPE     VARCHAR2(40 BYTE),
  ITEM_IDENTIFIER_TYPE_CD  NUMBER               DEFAULT 0                     NOT NULL,
  LOCATOR                  VARCHAR2(60 BYTE)    DEFAULT ' '                   NOT NULL,
  LOCATOR_CD               NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_APPLCTX           NUMBER,
  CREATE_DT_TM             DATE,
  CREATE_ID                NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_TASK              NUMBER,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  LOC_VIEW_CD              NUMBER               DEFAULT 0                     NOT NULL,
  LOC_VIEW                 VARCHAR2(100 BYTE),
  PKG_TYPE_CONV            NUMBER,
  PKG_TYPE_ID              NUMBER               DEFAULT 0                     NOT NULL,
  PKG_TYPE_UOM             VARCHAR2(40 BYTE),
  PKG_TYPE_UOM_CD          NUMBER               DEFAULT 0                     NOT NULL,
  LOGICAL_DOMAIN_ID        NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_PAYMENT
(
  TRANSACTION_ID          NUMBER                DEFAULT 0                     NOT NULL,
  SEGMENT_IDENTIFIER      VARCHAR2(10 BYTE),
  SEGMENT_VERSION         VARCHAR2(10 BYTE),
  BATCH_REF               VARCHAR2(100 BYTE),
  REFERENCE_NBR           VARCHAR2(60 BYTE),
  MM_PAYMENT_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PURCHASE_ORDER_ID       NUMBER                DEFAULT 0                     NOT NULL,
  PAYMENT_TYPE            VARCHAR2(60 BYTE),
  FOREIGN_VOUCHER_NBR     VARCHAR2(40 BYTE),
  CHECK_NBR               VARCHAR2(40 BYTE),
  PAYMENT_DT_TM           DATE,
  PRSNL_NAME              VARCHAR2(100 BYTE),
  MM_XFI_PAYMENT_COMMENT  VARCHAR2(255 BYTE),
  PAYMENT_METHOD          VARCHAR2(60 BYTE),
  AMOUNT                  FLOAT(126),
  PROCESS_FLAG            NUMBER,
  ACTION_FLAG             NUMBER,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_DT_TM            DATE                  DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  CREATE_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CREATE_TASK             NUMBER,
  CREATE_APPLCTX          NUMBER                DEFAULT 0                     NOT NULL,
  LOGICAL_DOMAIN_ID       NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_QOH
(
  TRANSACTION_ID           NUMBER               DEFAULT 0                     NOT NULL,
  PROCESS_FLAG             NUMBER               DEFAULT 0                     NOT NULL,
  SEGMENT_IDENTIFIER       VARCHAR2(10 BYTE)    DEFAULT ' '                   NOT NULL,
  SEGMENT_VERSION          VARCHAR2(10 BYTE)    DEFAULT ' '                   NOT NULL,
  BATCH_REF                VARCHAR2(100 BYTE),
  ACTION_FLAG              NUMBER               DEFAULT 0                     NOT NULL,
  UPDATE_RULE_FLAG         NUMBER,
  ORGANIZATION             VARCHAR2(100 BYTE),
  LOCATION                 VARCHAR2(100 BYTE)   DEFAULT ' '                   NOT NULL,
  LOCATION_CD              NUMBER               DEFAULT 0                     NOT NULL,
  ITEM_IDENTIFIER          VARCHAR2(100 BYTE)   DEFAULT ' '                   NOT NULL,
  ITEM_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  ITEM_IDENTIFIER_TYPE     VARCHAR2(40 BYTE),
  ITEM_IDENTIFIER_TYPE_CD  NUMBER               DEFAULT 0                     NOT NULL,
  LOCATOR                  VARCHAR2(60 BYTE),
  LOCATOR_CD               NUMBER               DEFAULT 0                     NOT NULL,
  CONTRIBUTOR              VARCHAR2(40 BYTE),
  CONTRIBUTOR_CD           NUMBER               DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID          NUMBER               DEFAULT 0                     NOT NULL,
  QOH_TYPE                 VARCHAR2(40 BYTE),
  QOH_TYPE_CD              NUMBER               DEFAULT 0                     NOT NULL,
  PKG_TYPE_UOM             VARCHAR2(40 BYTE),
  PKG_TYPE_UOM_CD          NUMBER               DEFAULT 0                     NOT NULL,
  PKG_TYPE_CONV            NUMBER,
  PKG_TYPE_ID              NUMBER               DEFAULT 0                     NOT NULL,
  QOH_QTY                  NUMBER,
  CREATE_APPLCTX           NUMBER,
  CREATE_DT_TM             DATE,
  CREATE_ID                NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_TASK              NUMBER,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  LOC_VIEW_CD              NUMBER               DEFAULT 0                     NOT NULL,
  LOC_VIEW                 VARCHAR2(100 BYTE),
  LOGICAL_DOMAIN_ID        NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_REQ_FILL
(
  TRANSACTION_ID           NUMBER               DEFAULT 0                     NOT NULL,
  SEGMENT_IDENTIFIER       VARCHAR2(10 BYTE),
  SEGMENT_VERSION          VARCHAR2(10 BYTE),
  BATCH_REF                VARCHAR2(100 BYTE),
  ACTION_FLAG              NUMBER,
  PROCESS_FLAG             NUMBER,
  CONTRIBUTOR              VARCHAR2(40 BYTE),
  CONTRIBUTOR_CD           NUMBER               DEFAULT 0                     NOT NULL,
  REQ_IDENTIFIER           VARCHAR2(40 BYTE),
  REQUISITION_ID           NUMBER               DEFAULT 0                     NOT NULL,
  REQ_LINE_NBR             NUMBER,
  LINE_ITEM_ID             NUMBER               DEFAULT 0                     NOT NULL,
  ITEM_IDENTIFIER          VARCHAR2(100 BYTE),
  ITEM_IDENTIFIER_TYPE     VARCHAR2(40 BYTE),
  ITEM_IDENTIFIER_TYPE_CD  NUMBER               DEFAULT 0                     NOT NULL,
  ITEM_MASTER_ID           NUMBER               DEFAULT 0                     NOT NULL,
  FILL_UOM                 VARCHAR2(20 BYTE),
  FILL_UOM_CD              NUMBER               DEFAULT 0                     NOT NULL,
  PACKAGE_TYPE_ID          NUMBER               DEFAULT 0                     NOT NULL,
  SERIAL_NUMBER            VARCHAR2(40 BYTE),
  PROJECT_CODE             VARCHAR2(60 BYTE),
  PROJECT_CD               NUMBER               DEFAULT 0                     NOT NULL,
  MISC_CODE                VARCHAR2(40 BYTE),
  MISC_CD                  NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_DT_TM             DATE,
  CREATE_ID                NUMBER               DEFAULT 0                     NOT NULL,
  CREATE_TASK              NUMBER,
  CREATE_APPLCTX           NUMBER,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  FILL_QTY                 FLOAT(126)           DEFAULT 0,
  FILL_PACK_FACTOR         FLOAT(126)           DEFAULT 0,
  UNIT_COST                FLOAT(126)           DEFAULT 0,
  EXTENDED_COST            FLOAT(126)           DEFAULT 0,
  FOREIGN_DIST_NBR         VARCHAR2(20 BYTE),
  FROM_LOCATION            VARCHAR2(60 BYTE),
  FROM_LOCATION_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ORGANIZATION             VARCHAR2(100 BYTE),
  TO_LOCATION_CD           NUMBER               DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID          NUMBER               DEFAULT 0                     NOT NULL,
  AUTO_COMMIT_IND          NUMBER,
  TO_LOCATION              VARCHAR2(60 BYTE),
  TRANSFER_FLAG            NUMBER               DEFAULT 0,
  LOGICAL_DOMAIN_ID        NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MM_XFI_REQ_FILL_LOT
(
  TRANS_HEADER_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  TRANSACTION_ID     NUMBER                     DEFAULT 0                     NOT NULL,
  PROCESS_FLAG       NUMBER                     DEFAULT 0                     NOT NULL,
  LOT_NUMBER_ID      NUMBER                     DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_CD     NUMBER                     DEFAULT 0                     NOT NULL,
  ACTION_FLAG        NUMBER                     DEFAULT 0                     NOT NULL,
  LOT_NUMBER         VARCHAR2(40 BYTE)          DEFAULT ' '                   NOT NULL,
  MFR_TXT            VARCHAR2(60 BYTE)          DEFAULT ' '                   NOT NULL,
  MFR_CD             NUMBER                     DEFAULT 0                     NOT NULL,
  MFR_DT_TM          DATE,
  EXP_DT_TM          DATE,
  LOT_QTY            FLOAT(126)                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT sysdate               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  INCREASE_IND       NUMBER                     DEFAULT 0                     NOT NULL,
  LOGICAL_DOMAIN_ID  NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MODIFICATION
(
  PRODUCT_EVENT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  ORIG_EXPIRE_DT_TM       DATE,
  ORIG_VOLUME             NUMBER,
  ORIG_UNIT_MEAS_CD       NUMBER                DEFAULT 0                     NOT NULL,
  CUR_EXPIRE_DT_TM        DATE,
  CUR_VOLUME              NUMBER,
  CUR_UNIT_MEAS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  MODIFIED_QTY            NUMBER,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  CROSSOVER_REASON_CD     NUMBER                DEFAULT 0                     NOT NULL,
  OPTION_ID               NUMBER                DEFAULT 0                     NOT NULL,
  DEVICE_TYPE_CD          NUMBER                DEFAULT 0                     NOT NULL,
  START_DT_TM             DATE,
  STOP_DT_TM              DATE,
  LOT_NBR                 VARCHAR2(60 BYTE),
  ACCESSORY               VARCHAR2(60 BYTE),
  VIS_INSP_CD             NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MODIFY_DEVICE
(
  MODIFY_DEVICE_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PRODUCT_ID              NUMBER                DEFAULT 0                     NOT NULL,
  DEVICE_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MODIFY_OPTION
(
  OPTION_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ORIG_PRODUCT_CD          NUMBER               DEFAULT 0                     NOT NULL,
  DESCRIPTION              VARCHAR2(40 BYTE),
  BAG_TYPE_CD              NUMBER               DEFAULT 0                     NOT NULL,
  DISPOSE_ORIG_IND         NUMBER,
  ORIG_NBR_DAYS_EXP        NUMBER,
  ORIG_NBR_HRS_EXP         NUMBER,
  VALIDATE_VOL_IND         NUMBER,
  CALC_EXP_DRAWN_IND       NUMBER,
  CHG_ORIG_EXP_DT_IND      NUMBER,
  BAG_TYPE_VALID_IND       NUMBER,
  DIVISION_TYPE_FLAG       NUMBER,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  CROSSOVER_REASON_CD      NUMBER               DEFAULT 0                     NOT NULL,
  ALLOW_EXTEND_EXP_IND     NUMBER               DEFAULT 0                     NOT NULL,
  CALC_ORIG_EXP_DRAWN_IND  NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MODIFY_OPTION_TESTING
(
  MODIFY_OPTION_TST_ID    NUMBER                DEFAULT 0                     NOT NULL,
  NEW_PRODUCT_CD          NUMBER                DEFAULT 0                     NOT NULL,
  SPECIAL_TESTING_CD      NUMBER                DEFAULT 0                     NOT NULL,
  OPTION_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CALC_EXP_DRAWN_IND      NUMBER                DEFAULT 0,
  DEFAULT_EXP_DAYS        NUMBER                DEFAULT 0,
  DEFAULT_EXP_HRS         NUMBER                DEFAULT 0,
  MAX_PREP_HRS            NUMBER                DEFAULT 0,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MONTHLY_CYTOLOGY_COUNTS
(
  PRSNL_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  RECORD_DT_TM               DATE               DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  OUTSIDE_HOURS              FLOAT(126),
  QA_SLIDES                  FLOAT(126),
  PROFICIENCY_SLIDES         FLOAT(126),
  SCREEN_HOURS               FLOAT(126),
  GYN_SLIDES_IS              FLOAT(126),
  GYN_SLIDES_RS              FLOAT(126),
  NGYN_SLIDES_IS             FLOAT(126),
  NGYN_SLIDES_RS             FLOAT(126),
  GYN_CASES_IS               NUMBER,
  GYN_CASES_RS               NUMBER,
  NGYN_CASES_IS              NUMBER,
  NGYN_CASES_RS              NUMBER,
  NORMAL_CASES               NUMBER,
  CHR_CASES                  NUMBER,
  PREV_ATYPICAL_CASES        NUMBER,
  PREV_ABNORMAL_CASES        NUMBER,
  EXCEEDED_LIMIT_CASES       NUMBER,
  USER_PREFERENCE_CASES      NUMBER,
  GYN_INSTRUMENT_SCREENING   FLOAT(126),
  OUTSIDE_GYN_IS             FLOAT(126),
  OUTSIDE_GYN_RS             FLOAT(126),
  OUTSIDE_NGYN_IS            FLOAT(126),
  OUTSIDE_NGYN_RS            FLOAT(126),
  NORMAL_SLIDES              FLOAT(126),
  PREV_ATYPICAL_SLIDES       FLOAT(126),
  PREV_ABNORMAL_SLIDES       FLOAT(126),
  CHR_SLIDES                 FLOAT(126),
  EXCEEDED_LIMIT_SLIDES      FLOAT(126),
  USER_PREFERENCE_SLIDES     FLOAT(126),
  NORMAL_SLIDES_REQUEUED     FLOAT(126),
  PREV_ATYP_SLIDES_REQUEUED  FLOAT(126),
  PREV_ABN_SLIDES_REQUEUED   FLOAT(126),
  CHR_SLIDES_REQUEUED        FLOAT(126),
  UNSAT_CASES                NUMBER,
  UNSAT_SLIDES               FLOAT(126),
  UNSAT_SLIDES_REQUEUED      FLOAT(126),
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MRU_LOOKUP_ED_DOC
(
  MRU_LOOKUP_ED_DOC_ID   NUMBER                 DEFAULT 0                     NOT NULL,
  SUPPLIER_KEY_ID_VALUE  NUMBER                 DEFAULT 0                     NOT NULL,
  CONTENT_SUPPLIER_CD    NUMBER                 DEFAULT 0                     NOT NULL,
  PAT_ED_RELTN_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MSG_CONFIG_PUB_ASNMNT
(
  MSG_CONFIG_PUB_ASNMNT_ID  NUMBER              DEFAULT 0                     NOT NULL,
  MSG_CONFIG_ID             NUMBER              DEFAULT 0                     NOT NULL,
  PRSNL_GROUP_ID            NUMBER              DEFAULT 0                     NOT NULL,
  PRSNL_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  APPLICATION_NUMBER        NUMBER,
  POSITION_CD               NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MSG_DOC_FAVORITES
(
  MSG_DOC_FAVORITES_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  PRSNL_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  NOTE_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  POSITION_CD           NUMBER                  DEFAULT 0                     NOT NULL,
  MSGTYPE_CD            NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE MSG_LETTER_TEMPLATE
(
  MSG_LETTER_TEMPLATE_ID  NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  POSITION_CD             NUMBER                DEFAULT 0                     NOT NULL,
  LONG_BLOB_REF_ID        NUMBER                DEFAULT 0                     NOT NULL,
  TEXT_SEQUENCE           NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE NETWORK
(
  NETWORK_ID              NUMBER                DEFAULT 0                     NOT NULL,
  CARRIER_ID              NUMBER                DEFAULT 0                     NOT NULL,
  NETWORK_NAME            VARCHAR2(100 BYTE)    DEFAULT ' '                   NOT NULL,
  NETWORK_DESCRIPTION     VARCHAR2(200 BYTE),
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE NEW_PRODUCT
(
  OPTION_ID                NUMBER               DEFAULT 0                     NOT NULL,
  NEW_PRODUCT_CD           NUMBER               DEFAULT 0                     NOT NULL,
  DEFAULT_EXP_DAYS         NUMBER               DEFAULT 0,
  DEFAULT_EXP_HRS          NUMBER               DEFAULT 0,
  MAX_PREP_HRS             NUMBER               DEFAULT 0,
  SYNONYM_ID               NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE                 DEFAULT TO_DATE ( '01/01/190000:00:00' , 'MM/DD/YYYYHH24:MI:SS' ) NOT NULL,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  QUANTITY                 NUMBER               DEFAULT 0,
  SUB_PROD_ID_FLAG         NUMBER               DEFAULT 0,
  SPECIAL_TESTING_CD       NUMBER               DEFAULT 0                     NOT NULL,
  DEFAULT_VOLUME_IND       NUMBER               DEFAULT 0,
  DEFAULT_VOLUME           NUMBER               DEFAULT 0,
  DEFAULT_MEASURE_IND      NUMBER               DEFAULT 0,
  DEFAULT_UNIT_MEASURE_CD  NUMBER               DEFAULT 0                     NOT NULL,
  DFLT_ORIG_VOLUME_IND     NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE NOMENCLATURE_ENCNTR_DESC
(
  NOMENCLATURE_ENCNTR_DESC_ID  NUMBER           DEFAULT 0                     NOT NULL,
  PERSON_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID              NUMBER           DEFAULT 0                     NOT NULL,
  DESCRIPTION                  VARCHAR2(255 BYTE),
  BEG_EFFECTIVE_DT_TM          DATE,
  END_EFFECTIVE_DT_TM          DATE,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  SVC_CAT_HIST_ID              NUMBER           DEFAULT 0                     NOT NULL,
  ENCNTR_SLICE_ID              NUMBER           DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE NOMEN_ENTITY_RELTN
(
  NOMEN_ENTITY_RELTN_ID           NUMBER        DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME              VARCHAR2(32 BYTE) DEFAULT ' ' NOT NULL,
  PARENT_ENTITY_ID                NUMBER        DEFAULT 0                     NOT NULL,
  CHILD_ENTITY_NAME               VARCHAR2(32 BYTE) DEFAULT ' ' NOT NULL,
  CHILD_ENTITY_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  RELTN_TYPE_CD                   NUMBER        DEFAULT 0                     NOT NULL,
  FREETEXT_DISPLAY                VARCHAR2(255 BYTE),
  PERSON_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  ENCNTR_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  ACTIVE_IND                      NUMBER        DEFAULT 0,
  BEG_EFFECTIVE_DT_TM             DATE          DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM             DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  ACTIVITY_TYPE_CD                NUMBER        DEFAULT 0                     NOT NULL,
  PRIORITY                        NUMBER,
  RELTN_SUBTYPE_CD                NUMBER        DEFAULT 0                     NOT NULL,
  INACTIVE_ORDER_ACTION_SEQUENCE  NUMBER,
  ORDER_ACTION_SEQUENCE           NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE NOTE_PHRASE
(
  NOTE_PHRASE_ID   NUMBER                       DEFAULT 0                     NOT NULL,
  PRSNL_ID         NUMBER                       DEFAULT 0                     NOT NULL,
  ABBREVIATION     VARCHAR2(40 BYTE)            DEFAULT ' '                   NOT NULL,
  ABB_DESCRIPTION  VARCHAR2(255 BYTE),
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE NOTE_PHRASE_COMP
(
  NOTE_PHRASE_COMP_ID   NUMBER                  DEFAULT 0                     NOT NULL,
  NOTE_PHRASE_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  FKEY_NAME             VARCHAR2(80 BYTE)       DEFAULT ' '                   NOT NULL,
  FKEY_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  SEQUENCE              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  FORMAT_CD             NUMBER                  DEFAULT 0,
  SYSTEM_GENERATED_IND  NUMBER                  DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE NOTE_TYPE_LIST
(
  NOTE_TYPE_LIST_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  NOTE_TYPE_ID          NUMBER                  DEFAULT 0                     NOT NULL,
  ROLE_TYPE_CD          NUMBER                  DEFAULT 0                     NOT NULL,
  PRSNL_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  SEQ_NUM               NUMBER,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CLASS_CD  NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE NURSE_UNIT
(
  LOCATION_CD             NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  LOC_FACILITY_CD         NUMBER                DEFAULT 0                     NOT NULL,
  LOC_BUILDING_CD         NUMBER                DEFAULT 0                     NOT NULL,
  ATD_REQ_LOC             NUMBER,
  CART_QTY_IND            NUMBER,
  DISPENSE_WINDOW         NUMBER,
  LOC_OVERFLOW_CD         NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OBJECT_IDENTIFIER_INDEX
(
  OBJECT_IDENTIFIER_INDEX_ID  NUMBER            DEFAULT 0                     NOT NULL,
  OBJECT_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  OBJECT_TYPE_CD              NUMBER            DEFAULT 0                     NOT NULL,
  GENERIC_OBJECT              NUMBER,
  RELATIONSHIP_TYPE_CD        NUMBER            DEFAULT 0                     NOT NULL,
  IDENTIFIER_ID               NUMBER            DEFAULT 0                     NOT NULL,
  IDENTIFIER_TYPE_CD          NUMBER            DEFAULT 0                     NOT NULL,
  VALUE_KEY                   VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  VALUE                       VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  PRIMARY_NBR_IND             NUMBER            DEFAULT 0                     NOT NULL,
  PRIMARY_IND                 NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER,
  SEQUENCE                    NUMBER,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  VENDOR_MANF_CD              NUMBER            DEFAULT 0                     NOT NULL,
  OBJECT_PARENT_NODE_ID       NUMBER            DEFAULT 0                     NOT NULL,
  SHORT_PATH_TO_ITEM          VARCHAR2(200 BYTE),
  LONG_PATH_TO_ITEM           VARCHAR2(200 BYTE),
  APPROVED_IND                NUMBER,
  QUICKADD_IND                NUMBER,
  PRICE_REVIEW_IND            NUMBER,
  PARENT_ENTITY_ID            NUMBER            DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME          VARCHAR2(32 BYTE),
  REL_PARENT_ENTITY_ID        NUMBER            DEFAULT 0                     NOT NULL,
  REL_PARENT_ENTITY_NAME      VARCHAR2(32 BYTE),
  VALUE_KEY_NLS               VARCHAR2(512 BYTE),
  PHA_TYPE_FLAG               NUMBER            DEFAULT 0,
  ITEM_LEVEL_FLAG             NUMBER            DEFAULT 0,
  VALUE_KEY_A_NLS             VARCHAR2(1020 BYTE),
  LOGICAL_DOMAIN_ID           NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_ABSTRACT_DATA_ST
(
  ABSTRACT_DATA_ID        FLOAT(126)            DEFAULT 0                     NOT NULL,
  ABSTRACT_DEF_CD         FLOAT(126)            DEFAULT 0                     NOT NULL,
  ABSTRACT_FIELD_TYPE_CD  FLOAT(126)            DEFAULT 0                     NOT NULL,
  PERSON_ID               FLOAT(126)            DEFAULT 0                     NOT NULL,
  ENCNTR_ID               FLOAT(126)            DEFAULT 0                     NOT NULL,
  VALUE_FREE_TEXT         VARCHAR2(255 BYTE),
  VALUE_CD                FLOAT(126)            DEFAULT 0                     NOT NULL,
  VALUE_DT_TM             DATE,
  VALUE_NUMBER            NUMBER,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  BEG_EFFECTIVE_TZ        NUMBER                DEFAULT 0,
  END_EFFECTIVE_TZ        NUMBER                DEFAULT 0,
  VALUE_TZ                NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_ABST_CODING_RELTN_ST
(
  ABST_CODING_RELTN_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  ABSTRACT_DEF_CD       NUMBER                  DEFAULT 0                     NOT NULL,
  PERSON_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  ENCNTR_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID      NUMBER                  DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME    VARCHAR2(255 BYTE),
  NOMENCLATURE_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM   DATE,
  END_EFFECTIVE_DT_TM   DATE,
  ACTIVE_IND            NUMBER,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_APC_CODING_ST
(
  OMF_APC_CODING_ST_ID    NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  RELATED_IDENTIFIER_STR  VARCHAR2(255 BYTE),
  TOTAL_EST_REIMB_VALUE   FLOAT(126),
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  RELATIVE_WEIGHT         FLOAT(126),
  STATUS_INDICATOR        CHAR(1 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_CHARGE_ST
(
  CHARGE_ITEM_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  ENCNTR_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  BILL_CODE_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  CPT4_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  ICD9_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_PHYS_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_PHYS_GRP_CD      NUMBER                 DEFAULT 0                     NOT NULL,
  PERF_PHYS_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  PERF_PHYS_GRP_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  CHARGE_DT_TM           DATE,
  CHARGE_DT_NBR          NUMBER,
  CHARGE_MIN_NBR         NUMBER,
  INTERFACED_DT_TM       DATE,
  INTERFACED_DT_NBR      NUMBER,
  INTERFACED_MIN_NBR     NUMBER,
  ORDER_DT_TM            DATE,
  ORDER_DT_NBR           NUMBER,
  ORDER_MIN_NBR          NUMBER,
  SERVICE_DT_TM          DATE,
  SERVICE_DT_NBR         NUMBER,
  SERVICE_MIN_NBR        NUMBER,
  ACTIVITY_TYPE_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  ADMIT_TYPE_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  CATALOG_CD             NUMBER                 DEFAULT 0                     NOT NULL,
  COST_CENTER_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  DEPARTMENT_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  INSTITUTION_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  LOC_FACILITY_CD        NUMBER                 DEFAULT 0                     NOT NULL,
  LOC_NURSE_UNIT_CD      NUMBER                 DEFAULT 0                     NOT NULL,
  SECTION_CD             NUMBER                 DEFAULT 0                     NOT NULL,
  SUBSECTION_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  TIER_GROUP_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  PROCESS_FLG            NUMBER,
  MANUAL_IND             NUMBER,
  ITEM_QUANTITY          FLOAT(126),
  ITEM_PRICE             FLOAT(126),
  TRANSACTION_IND        NUMBER,
  PAYOR_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  DISCOUNT_AMOUNT        NUMBER,
  ACT_SERVICE_TO_CHARGE  NUMBER,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  ITEM_EXTENDED_PRICE    FLOAT(126),
  BILL_ITEM_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  TOTAL_STD_COST         FLOAT(126),
  STD_DIRECT_VAR_COST    FLOAT(126),
  STD_DIRECT_FIX_COST    FLOAT(126),
  STD_INDIRECT_VAR_COST  FLOAT(126),
  STD_INDIRECT_FIX_COST  FLOAT(126),
  TOTAL_ACT_COST         FLOAT(126),
  ACT_DIRECT_VAR_COST    FLOAT(126),
  ACT_DIRECT_FIX_COST    FLOAT(126),
  ACT_INDIRECT_VAR_COST  FLOAT(126),
  ACT_INDIRECT_FIX_COST  FLOAT(126),
  PROCESS_FLAG           NUMBER,
  CHARGE_DESCRIPTION     VARCHAR2(200 BYTE),
  CHARGE_TYPE_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  CDM_DESC               VARCHAR2(200 BYTE),
  CDM_NBR                VARCHAR2(200 BYTE),
  CPT4_DESC              VARCHAR2(200 BYTE),
  CPT4_NBR               VARCHAR2(200 BYTE),
  ICD9_DESC              VARCHAR2(200 BYTE),
  ICD9_NBR               VARCHAR2(200 BYTE),
  ACCESSION              VARCHAR2(20 BYTE),
  COST_CENTER_GRP_CD     NUMBER                 DEFAULT 0                     NOT NULL,
  REV_CODE_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  REV_CAT_CD             NUMBER                 DEFAULT 0                     NOT NULL,
  REV_CAT_GRP_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  CHARGE_TZ              NUMBER                 DEFAULT 0,
  INTERFACED_TZ          NUMBER                 DEFAULT 0,
  ORDER_TZ               NUMBER                 DEFAULT 0,
  SERVICE_TZ             NUMBER                 DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_CLINICAL_EVENT_ST
(
  EVENT_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  ENCNTR_ID                  FLOAT(126)         DEFAULT 0                     NOT NULL,
  EVENT_CD                   FLOAT(126)         DEFAULT 0                     NOT NULL,
  SERVICE_DT_TM              DATE,
  SERVICE_DATE               VARCHAR2(25 BYTE),
  SERVICE_DAY                NUMBER,
  SERVICE_HOUR               NUMBER,
  SERVICE_MONTH              NUMBER,
  NORMALCY_CD                FLOAT(126)         DEFAULT 0                     NOT NULL,
  NORMAL_IND                 NUMBER,
  NORMAL_LOW                 VARCHAR2(20 BYTE),
  NORMAL_HIGH                VARCHAR2(20 BYTE),
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  PERFORM_PRSNL_ID           FLOAT(126)         DEFAULT 0                     NOT NULL,
  RESULT_VAL                 VARCHAR2(255 BYTE),
  SOURCE_TYPE_CD             NUMBER             DEFAULT 0                     NOT NULL,
  SPECIMEN_ID                NUMBER             DEFAULT 0                     NOT NULL,
  BODY_SITE_CD               NUMBER             DEFAULT 0                     NOT NULL,
  EVENT_START_DT_TM          DATE,
  ORDER_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  PERSON_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  PROCESS_FLAG               NUMBER             DEFAULT 0,
  RESULT_UNITS_CD            NUMBER             DEFAULT 0                     NOT NULL,
  SERVICE_DT_NBR             NUMBER,
  SERVICE_MIN_NBR            NUMBER,
  TASK_ASSAY_CD              NUMBER             DEFAULT 0                     NOT NULL,
  CATALOG_CD                 NUMBER             DEFAULT 0                     NOT NULL,
  CE_RESULT_DT_NBR           NUMBER,
  CE_RESULT_MIN_NBR          NUMBER,
  CE_RESULT_NBR_VALUE        NUMBER,
  CE_RESULT_DT_TM            DATE,
  PERFORM_PRSNL_POSITION_CD  NUMBER             DEFAULT 0                     NOT NULL,
  CE_RESULT_TZ               NUMBER             DEFAULT 0,
  EVENT_START_TZ             NUMBER             DEFAULT 0,
  SERVICE_TZ                 NUMBER             DEFAULT 0,
  EVENT_START_DT_NBR         NUMBER,
  EVENT_START_MIN_NBR        NUMBER,
  PARENT_EVENT_ID            NUMBER             DEFAULT 0                     NOT NULL,
  EVENT_TITLE_TEXT           VARCHAR2(255 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_CODING_ST
(
  OMF_CODING_ST_ID          NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID           NUMBER              DEFAULT 0                     NOT NULL,
  SOURCE_VOCABULARY_CD      NUMBER              DEFAULT 0                     NOT NULL,
  PRINCIPLE_TYPE_CD         NUMBER              DEFAULT 0                     NOT NULL,
  PRIORITY                  NUMBER,
  PROCEDURE_MINUTES         NUMBER,
  PROCEDURE_DT_TM           DATE,
  PROCEDURE_DT_NBR          NUMBER,
  PROCEDURE_MIN_NBR         NUMBER,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  ANESTHESIA_CD             NUMBER              DEFAULT 0                     NOT NULL,
  ANESTHESIA_MINUTES        NUMBER,
  TISSUE_TYPE_CD            NUMBER              DEFAULT 0                     NOT NULL,
  ANESTHESIOLOGIST_ID       NUMBER              DEFAULT 0                     NOT NULL,
  ANESTHESIOLOGIST_KEY      VARCHAR2(255 BYTE),
  ANESTHESIOLOGIST_FT_NAME  VARCHAR2(255 BYTE),
  SERVICE_CATEGORY_CD       NUMBER              DEFAULT 0                     NOT NULL,
  ANESTH_POSITION_CD        NUMBER              DEFAULT 0                     NOT NULL,
  PROCEDURE_TZ              NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_COST
(
  OMF_COST_ID          NUMBER                   DEFAULT 0                     NOT NULL,
  BILL_ITEM_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  STD_IND              NUMBER,
  DIRECT_VAR_COST      FLOAT(126),
  DIRECT_FIX_COST      FLOAT(126),
  INDIRECT_VAR_COST    FLOAT(126),
  INDIRECT_FIX_COST    FLOAT(126),
  ACTIVE_IND           NUMBER,
  BEG_EFFECTIVE_DT_TM  DATE,
  END_EFFECTIVE_DT_TM  DATE,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  ORGANIZATION_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  COST_BASIS_TYPE_CD   NUMBER                   DEFAULT 0                     NOT NULL,
  TOTAL_COST           FLOAT(126),
  BEG_EFFECTIVE_TZ     NUMBER                   DEFAULT 0,
  END_EFFECTIVE_TZ     NUMBER                   DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_COST_PARAMS
(
  ORGANIZATION_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  COST_BASIS_TYPE_CD  NUMBER                    DEFAULT 0                     NOT NULL,
  SCHEDULE_TYPE_CD    NUMBER                    DEFAULT 0                     NOT NULL,
  TOTAL_ONLY_IND      NUMBER,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  BEG_FISCAL_DT_NBR   NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_ENCNTR_PRSNL_RELTN_ST
(
  ENCNTR_PRSNL_RELTN_ID     NUMBER              DEFAULT 0                     NOT NULL,
  PRSNL_PERSON_ID           NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_PRSNL_R_CD         NUMBER              DEFAULT 0                     NOT NULL,
  ENCNTR_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  PRSNL_PERSON_KEY          VARCHAR2(125 BYTE),
  PRSNL_PERSON_FT_NAME      VARCHAR2(100 BYTE),
  PRIORITY_SEQ              NUMBER,
  BEG_EFFECTIVE_DT_TM       DATE,
  BEG_EFFECTIVE_DT_NBR      NUMBER,
  BEG_EFFECTIVE_MIN_NBR     NUMBER,
  END_EFFECTIVE_DT_TM       DATE,
  END_EFFECTIVE_DT_NBR      NUMBER,
  END_EFFECTIVE_MIN_NBR     NUMBER,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  PRSNL_PERSON_GRP_CD       NUMBER              DEFAULT 0                     NOT NULL,
  PRSNL_PERSON_MED_SPEC_CD  NUMBER              DEFAULT 0                     NOT NULL,
  PRSNL_PERSON_POSITION_CD  NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_TZ          NUMBER              DEFAULT 0,
  END_EFFECTIVE_TZ          NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_ENCNTR_ST
(
  ENCNTR_ID                       FLOAT(126)    DEFAULT 0                     NOT NULL,
  PERSON_ID                       FLOAT(126)    DEFAULT 0                     NOT NULL,
  VISIT_IND                       NUMBER,
  ADMIT_IND                       NUMBER,
  VISIT_DT_TM                     DATE,
  VISIT_DT_NBR                    NUMBER,
  VISIT_MIN_NBR                   NUMBER,
  VISIT_MONTH                     NUMBER,
  VISIT_DAY                       NUMBER,
  VISIT_HOUR                      NUMBER,
  VISIT_DATE                      VARCHAR2(25 BYTE),
  ADMIT_DT_TM                     DATE,
  ADMIT_DT_NBR                    NUMBER,
  ADMIT_MIN_NBR                   NUMBER,
  ADMIT_MONTH                     NUMBER,
  ADMIT_DAY                       NUMBER,
  ADMIT_HOUR                      NUMBER,
  ADMIT_DATE                      VARCHAR2(25 BYTE),
  ICD9_PRIN_PROC_NOMEN_ID         FLOAT(126)    DEFAULT 0                     NOT NULL,
  ICD9_PRIN_PROC_DT_TM            DATE,
  ICD9_PRIN_PROC_DT_NBR           NUMBER,
  ICD9_PRIN_PROC_MIN_NBR          NUMBER,
  ICD9_PRIN_PROC_DATE             VARCHAR2(25 BYTE),
  ICD9_PRIN_PROC_MINUTES          NUMBER,
  ICD9_PRIN_PROC_GRP_CD           FLOAT(126)    DEFAULT 0                     NOT NULL,
  ICD9_PRIN_DIAG_NOMEN_ID         FLOAT(126)    DEFAULT 0                     NOT NULL,
  ICD9_PRIN_DIAG_GRP_CD           FLOAT(126)    DEFAULT 0                     NOT NULL,
  ICD9_ADMIT_DIAG_NOMEN_ID        FLOAT(126)    DEFAULT 0                     NOT NULL,
  ICD9_SEC_DIAG_STR               VARCHAR2(255 BYTE),
  ICD9_SEC_PROC_STR               VARCHAR2(255 BYTE),
  CPT4_PROC_STR                   VARCHAR2(255 BYTE),
  DEATH_IND                       NUMBER,
  DEATH_DT_TM                     DATE,
  DEATH_DT_NBR                    NUMBER,
  DEATH_MIN_NBR                   NUMBER,
  DEATH_DATE                      VARCHAR2(25 BYTE),
  LAST_IP_DISCH_DT_TM             DATE,
  LAST_IP_DISCH_DT_NBR            NUMBER,
  LAST_IP_DISCH_MIN_NBR           NUMBER,
  DISCH_IND                       NUMBER,
  DISCH_DT_TM                     DATE,
  DISCH_DT_NBR                    NUMBER,
  DISCH_MIN_NBR                   NUMBER,
  DISCH_DAY                       NUMBER,
  DISCH_MONTH                     NUMBER,
  DISCH_HOUR                      NUMBER,
  DISCH_DATE                      VARCHAR2(25 BYTE),
  DISCH_DISPOSITION_CD            FLOAT(126)    DEFAULT 0                     NOT NULL,
  DISCH_TO_LOCTN_CD               FLOAT(126)    DEFAULT 0                     NOT NULL,
  ADMIT_SRC_CD                    FLOAT(126)    DEFAULT 0                     NOT NULL,
  ADMIT_TYPE_CD                   FLOAT(126)    DEFAULT 0                     NOT NULL,
  ADMIT_PHYS_ID                   FLOAT(126)    DEFAULT 0                     NOT NULL,
  ADMIT_PHYS_KEY                  VARCHAR2(255 BYTE),
  ADMIT_PHYS_FT_NAME              VARCHAR2(255 BYTE),
  ADMIT_PHYS_GRP_CD               FLOAT(126)    DEFAULT 0                     NOT NULL,
  AMBULATORY_COND_CD              FLOAT(126)    DEFAULT 0                     NOT NULL,
  ATT_PHYS_ID                     FLOAT(126)    DEFAULT 0                     NOT NULL,
  ATT_PHYS_KEY                    VARCHAR2(255 BYTE),
  ATT_PHYS_FT_NAME                VARCHAR2(255 BYTE),
  ATT_PHYS_GRP_CD                 FLOAT(126)    DEFAULT 0                     NOT NULL,
  ETHNIC_GRP_CD                   FLOAT(126)    DEFAULT 0                     NOT NULL,
  SEX_CD                          FLOAT(126)    DEFAULT 0                     NOT NULL,
  FIN_CLASS_CD                    FLOAT(126)    DEFAULT 0                     NOT NULL,
  RACE_CD                         FLOAT(126)    DEFAULT 0                     NOT NULL,
  LANGUAGE_CD                     FLOAT(126)    DEFAULT 0                     NOT NULL,
  RELIGION_CD                     FLOAT(126)    DEFAULT 0                     NOT NULL,
  VIP_CD                          FLOAT(126)    DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CD                  FLOAT(126)    DEFAULT 0                     NOT NULL,
  ENCNTR_CLASS_CD                 FLOAT(126)    DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CLASS_CD            FLOAT(126)    DEFAULT 0                     NOT NULL,
  BIRTH_DT_TM                     DATE,
  BIRTH_DATE                      VARCHAR2(25 BYTE),
  MARITAL_STATUS_CD               FLOAT(126)    DEFAULT 0                     NOT NULL,
  SURGEON_ID                      FLOAT(126)    DEFAULT 0                     NOT NULL,
  SURGEON_KEY                     VARCHAR2(255 BYTE),
  SURGEON_FT_NAME                 VARCHAR2(255 BYTE),
  REF_PHYS_ID                     FLOAT(126)    DEFAULT 0                     NOT NULL,
  REF_PHYS_KEY                    VARCHAR2(255 BYTE),
  REF_PHYS_FT_NAME                VARCHAR2(255 BYTE),
  MED_SERV_CD                     FLOAT(126)    DEFAULT 0                     NOT NULL,
  MED_SERV_GRP_CD                 FLOAT(126)    DEFAULT 0                     NOT NULL,
  DRG_NOMEN_ID                    FLOAT(126)    DEFAULT 0                     NOT NULL,
  DRG_GRP_CD                      FLOAT(126)    DEFAULT 0                     NOT NULL,
  MDC_CD                          FLOAT(126)    DEFAULT 0                     NOT NULL,
  CURR_PAT_LOC_BED_CD             FLOAT(126)    DEFAULT 0                     NOT NULL,
  CURR_PAT_LOC_BDG_CD             FLOAT(126)    DEFAULT 0                     NOT NULL,
  CURR_PAT_LOC_FAC_CD             FLOAT(126)    DEFAULT 0                     NOT NULL,
  CURR_PAT_LOC_FAC_GRP_CD         FLOAT(126)    DEFAULT 0                     NOT NULL,
  CURR_PAT_LOC_NU_CD              FLOAT(126)    DEFAULT 0                     NOT NULL,
  CURR_PAT_LOC_NU_GRP_CD          FLOAT(126)    DEFAULT 0                     NOT NULL,
  CURR_PAT_LOC_ROOM_CD            FLOAT(126)    DEFAULT 0                     NOT NULL,
  ADMIT_PAT_LOC_BED_CD            FLOAT(126)    DEFAULT 0                     NOT NULL,
  ADMIT_PAT_LOC_BDG_CD            FLOAT(126)    DEFAULT 0                     NOT NULL,
  ADMIT_PAT_LOC_FAC_CD            FLOAT(126)    DEFAULT 0                     NOT NULL,
  ADMIT_PAT_LOC_NU_CD             FLOAT(126)    DEFAULT 0                     NOT NULL,
  ADMIT_PAT_LOC_ROOM_CD           FLOAT(126)    DEFAULT 0                     NOT NULL,
  AGE_DAYS                        NUMBER,
  AGE_YEARS                       NUMBER,
  AGE_YEARS_GRP_CD                FLOAT(126)    DEFAULT 0                     NOT NULL,
  ADMIT_7D_LADMIT_IND             NUMBER,
  ADMIT_15D_LADMIT_IND            NUMBER,
  ADMIT_24H_LADMIT_IND            NUMBER,
  ADMIT_30D_LADMIT_IND            NUMBER,
  ADMIT_48H_LADMIT_IND            NUMBER,
  DEATH_24H_ADMIT_IND             NUMBER,
  DEATH_24H_VISIT_IND             NUMBER,
  DEATH_24H_PRIN_PROC_IND         NUMBER,
  PRIM_INS_ASSIGN_BENEFITS_CD     FLOAT(126)    DEFAULT 0                     NOT NULL,
  SEC_INS_ASSIGN_BENEFITS_CD      FLOAT(126)    DEFAULT 0                     NOT NULL,
  COORDINATION_OF_BENEFITS_CD     FLOAT(126)    DEFAULT 0                     NOT NULL,
  PRIM_INS_BIRTH_DT_TM            DATE,
  SEC_INS_BIRTH_DT_TM             DATE,
  PRIM_INS_BEG_EFFECTIVE_DT_TM    DATE,
  PRIM_INS_BEG_EFFECTIVE_DT_NBR   NUMBER,
  PRIM_INS_BEG_EFFECTIVE_MIN_NBR  NUMBER,
  SEC_INS_BEG_EFFECTIVE_DT_TM     DATE,
  SEC_INS_BEG_EFFECTIVE_DT_NBR    NUMBER,
  SEC_INS_BEG_EFFECTIVE_MIN_NBR   NUMBER,
  PRIM_INS_END_EFFECTIVE_DT_TM    DATE,
  PRIM_INS_END_EFFECTIVE_DT_NBR   NUMBER,
  PRIM_INS_END_EFFECTIVE_MIN_NBR  NUMBER,
  SEC_INS_END_EFFECTIVE_DT_TM     DATE,
  SEC_INS_END_EFFECTIVE_DT_NBR    NUMBER,
  SEC_INS_END_EFFECTIVE_MIN_NBR   NUMBER,
  PRIM_EMP_ORGANIZATION_ID        FLOAT(126)    DEFAULT 0                     NOT NULL,
  SEC_EMP_ORGANIZATION_ID         FLOAT(126)    DEFAULT 0                     NOT NULL,
  PRIM_HEALTH_PLAN_ID             FLOAT(126)    DEFAULT 0                     NOT NULL,
  SEC_HEALTH_PLAN_ID              FLOAT(126)    DEFAULT 0                     NOT NULL,
  PRIM_INS_ORGANIZATION_ID        FLOAT(126)    DEFAULT 0                     NOT NULL,
  SEC_INS_ORGANIZATION_ID         FLOAT(126)    DEFAULT 0                     NOT NULL,
  PRIM_INS_PERSON_ID              FLOAT(126)    DEFAULT 0                     NOT NULL,
  SEC_INS_PERSON_ID               FLOAT(126)    DEFAULT 0                     NOT NULL,
  PRIM_INS_PERSON_RELTN_CD        FLOAT(126)    DEFAULT 0                     NOT NULL,
  SEC_INS_PERSON_RELTN_CD         FLOAT(126)    DEFAULT 0                     NOT NULL,
  PRIM_INS_PLAN_TYPE_CD           FLOAT(126)    DEFAULT 0                     NOT NULL,
  SEC_INS_PLAN_TYPE_CD            FLOAT(126)    DEFAULT 0                     NOT NULL,
  PRIM_HEALTH_PLAN_GROUP_CD       FLOAT(126)    DEFAULT 0                     NOT NULL,
  SEC_HEALTH_PLAN_GROUP_CD        FLOAT(126)    DEFAULT 0                     NOT NULL,
  PRIM_INS_GROUP_CD               FLOAT(126)    DEFAULT 0                     NOT NULL,
  SEC_INS_GROUP_CD                FLOAT(126)    DEFAULT 0                     NOT NULL,
  PRIM_ORG_PLAN_RELTN_ID          FLOAT(126)    DEFAULT 0                     NOT NULL,
  SEC_ORG_PLAN_RELTN_ID           FLOAT(126)    DEFAULT 0                     NOT NULL,
  REASON_FOR_VISIT                VARCHAR2(255 BYTE),
  CMG_NOMEN_ID                    FLOAT(126)    DEFAULT 0                     NOT NULL,
  DPG_NOMEN_ID                    FLOAT(126)    DEFAULT 0                     NOT NULL,
  MRD_NOMEN_ID                    FLOAT(126)    DEFAULT 0                     NOT NULL,
  MCC                             NUMBER,
  MCC_TEXT                        VARCHAR2(255 BYTE),
  ONTARIO_CASE_WT                 FLOAT(126),
  RELATIVE_INDEX_WT               FLOAT(126),
  PATIENT_STATUS_CD               FLOAT(126)    DEFAULT 0                     NOT NULL,
  TRIAGE_CD                       FLOAT(126)    DEFAULT 0                     NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  SURGEON_GRP_CD                  FLOAT(126)    DEFAULT 0                     NOT NULL,
  PERSON_HOME_ZIPCODE_GRP_CD      NUMBER        DEFAULT 0                     NOT NULL,
  CURR_PAT_LOC_ARRIVE_DT_TM       DATE,
  CURR_PAT_LOC_NU_GRP2_CD         NUMBER        DEFAULT 0                     NOT NULL,
  DISCH_SHIFT_GRP_CD              NUMBER        DEFAULT 0                     NOT NULL,
  DRG_AMLOS                       FLOAT(126),
  DRG_WEIGHT                      FLOAT(126),
  EST_REIMBURSEMENT               FLOAT(126),
  EXP_PM_DISCH_DT_NBR             NUMBER,
  EXP_PM_DISCH_DT_TM              DATE,
  EXP_PM_DISCH_MIN_NBR            NUMBER,
  ORGANIZATION_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  PCP_PHYS_FT_NAME                VARCHAR2(255 BYTE),
  PCP_PHYS_GRP_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  PCP_PHYS_ID                     NUMBER        DEFAULT 0                     NOT NULL,
  PCP_PHYS_KEY                    VARCHAR2(255 BYTE),
  PCP_PHYS_MED_SPEC_CD            NUMBER        DEFAULT 0                     NOT NULL,
  PREV_PAT_LOC_NU_CD              FLOAT(126)    DEFAULT 0                     NOT NULL,
  READMIT_15D_30D_IND             NUMBER,
  READMIT_24H_48H_IND             NUMBER,
  READMIT_30D_48D_IND             NUMBER,
  READMIT_7D_15D_IND              NUMBER,
  READMIT_GT_48D_IND              NUMBER,
  READMIT_GT_48H_IND              NUMBER,
  REF_PHYS_MED_SPEC_CD            NUMBER        DEFAULT 0                     NOT NULL,
  SURGEON_MED_SPEC_CD             NUMBER        DEFAULT 0                     NOT NULL,
  TOTAL_ACCUM_CHARGES             FLOAT(126),
  TOTAL_ACCUM_CHARGESF            FLOAT(126),
  TOTAL_ACT_COST                  FLOAT(126),
  TOTAL_ACT_DIRECT_FIX_COST       FLOAT(126),
  TOTAL_ACT_DIRECT_VAR_COST       FLOAT(126),
  TOTAL_ACT_INDIRECT_FIX_COST     FLOAT(126),
  TOTAL_ACT_INDIRECT_VAR_COST     FLOAT(126),
  TOTAL_STD_COST                  FLOAT(126),
  TOTAL_STD_DIRECT_FIX_COST       FLOAT(126),
  TOTAL_STD_DIRECT_VAR_COST       FLOAT(126),
  TOTAL_STD_INDIRECT_FIX_COST     FLOAT(126),
  TOTAL_STD_INDIRECT_VAR_COST     FLOAT(126),
  TRANSFER_REASON_CD              FLOAT(126)    DEFAULT 0                     NOT NULL,
  ACCOMMODATION_CD                FLOAT(126)    DEFAULT 0                     NOT NULL,
  ADMIT_48D_LADMIT_IND            NUMBER,
  ADMIT_PHYS_MED_SPEC_CD          NUMBER        DEFAULT 0                     NOT NULL,
  ADMIT_SHIFT_GRP_CD              NUMBER        DEFAULT 0                     NOT NULL,
  AGE_DAYS_GRP_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  ANESTHESIOLOGIST_FT_NAME        VARCHAR2(255 BYTE),
  ANESTHESIOLOGIST_ID             NUMBER        DEFAULT 0                     NOT NULL,
  ANESTHESIOLOGIST_KEY            VARCHAR2(255 BYTE),
  APRDRG_LOS                      FLOAT(126),
  APRDRG_NOMEN_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  APRDRG_ROM                      NUMBER,
  APRDRG_SOI                      NUMBER,
  ATT_PHYS_MED_SPEC_CD            NUMBER        DEFAULT 0                     NOT NULL,
  NBR_CONSULTS                    NUMBER,
  ISOLATION_CD                    NUMBER        DEFAULT 0                     NOT NULL,
  DRG_GRP2_CD                     NUMBER        DEFAULT 0                     NOT NULL,
  APRDRG_SOI_CD                   NUMBER        DEFAULT 0                     NOT NULL,
  APRDRG_MDC_CD                   NUMBER        DEFAULT 0                     NOT NULL,
  APRDRG_ROM_CD                   NUMBER        DEFAULT 0                     NOT NULL,
  EMP_ORGANIZATION_ID             NUMBER        DEFAULT 0                     NOT NULL,
  DRG_GMLOS                       FLOAT(126),
  DRG_ELOS                        FLOAT(126),
  SERVICE_CATEGORY_CD             NUMBER        DEFAULT 0                     NOT NULL,
  ATTEND_PHYS_POSITION_CD         NUMBER        DEFAULT 0                     NOT NULL,
  ADMIT_PHYS_POSITION_CD          NUMBER        DEFAULT 0                     NOT NULL,
  PCP_PHYS_POSITION_CD            NUMBER        DEFAULT 0                     NOT NULL,
  REF_PHYS_POSITION_CD            NUMBER        DEFAULT 0                     NOT NULL,
  SURGEON_POSITION_CD             NUMBER        DEFAULT 0                     NOT NULL,
  ANESTH_POSITION_CD              NUMBER        DEFAULT 0                     NOT NULL,
  OTHER_EMP_ORGANIZATION_ID       NUMBER        DEFAULT 0                     NOT NULL,
  OTHER_HEALTH_PLAN_GROUP_CD      NUMBER        DEFAULT 0                     NOT NULL,
  OTHER_HEALTH_PLAN_ID            NUMBER        DEFAULT 0                     NOT NULL,
  OTHER_INS_ASSIGN_BENEFITS_CD    NUMBER        DEFAULT 0                     NOT NULL,
  OTHER_INS_BEG_EFFECTIVE_DT_TM   DATE,
  OTHER_INS_BIRTH_DT_TM           DATE,
  OTHER_INS_ORGANIZATION_ID       NUMBER        DEFAULT 0                     NOT NULL,
  OTHER_INS_END_EFFECTIVE_DT_TM   DATE,
  OTHER_INS_GROUP_CD              NUMBER        DEFAULT 0                     NOT NULL,
  OTHER_ORG_PLAN_RELTN_ID         NUMBER        DEFAULT 0                     NOT NULL,
  OTHER_INS_PERSON_ID             NUMBER        DEFAULT 0                     NOT NULL,
  OTHER_INS_PERSON_RELTN_CD       NUMBER        DEFAULT 0                     NOT NULL,
  OTHER_INS_PLAN_TYPE_CD          NUMBER        DEFAULT 0                     NOT NULL,
  OTHER_INS_BEG_EFFECTIVE_DT_NBR  NUMBER,
  OTHER_INS_END_EFFECTIVE_DT_NBR  NUMBER,
  OTHER_INS_BEG_EFFECTIVE_MN_NBR  NUMBER,
  OTHER_INS_END_EFFECTIVE_MN_NBR  NUMBER,
  ICD9_SECONDARY1_DIAG_NOMEN_ID   NUMBER        DEFAULT 0                     NOT NULL,
  PREV_INP_ENCNTR_ID              NUMBER        DEFAULT 0                     NOT NULL,
  NEXT_INP_ENCNTR_ID              NUMBER        DEFAULT 0                     NOT NULL,
  NEXT_ENCNTR_ID                  NUMBER        DEFAULT 0                     NOT NULL,
  PREV_ENCNTR_ID                  NUMBER        DEFAULT 0                     NOT NULL,
  READMIT_48H_72H_IND             NUMBER,
  READMIT_GT_72H_IND              NUMBER,
  RETURN_ED_24H_IND               NUMBER,
  RETURN_ED_48H_IND               NUMBER,
  RETURN_ED_72H_IND               NUMBER,
  RETURN_ED_24H_48H_IND           NUMBER,
  RETURN_ED_49H_72H_IND           NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_ENCNTR_ST_EXT
(
  ENCNTR_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  RETURN_ED_GT_72H_IND         NUMBER,
  DAYS_NEXT_ED_VISIT           NUMBER,
  ADMIT_72H_LADMIT_IND         NUMBER,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  VISIT_TZ                     NUMBER           DEFAULT 0,
  ADMIT_TZ                     NUMBER           DEFAULT 0,
  ICD9_PRIN_PROC_TZ            NUMBER           DEFAULT 0,
  DEATH_TZ                     NUMBER           DEFAULT 0,
  LAST_IP_DISCH_TZ             NUMBER           DEFAULT 0,
  DISCH_TZ                     NUMBER           DEFAULT 0,
  BIRTH_TZ                     NUMBER           DEFAULT 0,
  SEC_INS_BEG_EFFECTIVE_TZ     NUMBER           DEFAULT 0,
  SEC_INS_BIRTH_TZ             NUMBER           DEFAULT 0,
  SEC_INS_END_EFFECTIVE_TZ     NUMBER           DEFAULT 0,
  PRIM_INS_BEG_EFFECTIVE_TZ    NUMBER           DEFAULT 0,
  PRIM_INS_BIRTH_TZ            NUMBER           DEFAULT 0,
  PRIM_INS_END_EFFECTIVE_TZ    NUMBER           DEFAULT 0,
  CURR_PAT_LOC_ARRIVE_TZ       NUMBER           DEFAULT 0,
  EXP_PM_DISCH_TZ              NUMBER           DEFAULT 0,
  OTHER_INS_BEG_EFFECTIVE_TZ   NUMBER           DEFAULT 0,
  OTHER_INS_BIRTH_TZ           NUMBER           DEFAULT 0,
  OTHER_INS_END_EFFECTIVE_TZ   NUMBER           DEFAULT 0,
  BIRTH_DT_NBR                 NUMBER,
  BIRTH_MIN_NBR                NUMBER,
  CURR_PAT_LOC_ARRIVE_DT_NBR   NUMBER,
  CURR_PAT_LOC_ARRIVE_MIN_NBR  NUMBER,
  SEC_INS_BIRTH_DT_NBR         NUMBER,
  SEC_INS_BIRTH_MIN_NBR        NUMBER,
  PRIM_INS_BIRTH_DT_NBR        NUMBER,
  PRIM_INS_BIRTH_MIN_NBR       NUMBER,
  OTHER_INS_BIRTH_DT_NBR       NUMBER,
  OTHER_INS_BIRTH_MIN_NBR      NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_ENCNTR_TYPE_HIST_ST
(
  ENCNTR_LOC_HIST_ID       NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  BEG_TRANSACTION_DT_TM    DATE,
  END_TRANSACTION_DT_TM    DATE,
  BEG_TRANSACTION_DT_NBR   NUMBER,
  BEG_TRANSACTION_MIN_NBR  NUMBER,
  END_TRANSACTION_DT_NBR   NUMBER,
  END_TRANSACTION_MIN_NBR  NUMBER,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  ENCNTR_TYPE_CLASS_CD     NUMBER               DEFAULT 0                     NOT NULL,
  NBR_BED_DAYS             NUMBER,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  BEG_TRANSACTION_TZ       NUMBER               DEFAULT 0,
  END_TRANSACTION_TZ       NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_LOCATION_HIST_ST
(
  ENCNTR_LOC_HIST_ID       NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  LOC_FACILITY_CD          NUMBER               DEFAULT 0                     NOT NULL,
  LOC_BUILDING_CD          NUMBER               DEFAULT 0                     NOT NULL,
  LOC_NURSE_UNIT_CD        NUMBER               DEFAULT 0                     NOT NULL,
  TRANSFER_REASON_CD       NUMBER               DEFAULT 0                     NOT NULL,
  BEG_TRANSACTION_DT_TM    DATE,
  END_TRANSACTION_DT_TM    DATE,
  BEG_TRANSACTION_DT_NBR   NUMBER,
  BEG_TRANSACTION_MIN_NBR  NUMBER,
  END_TRANSACTION_DT_NBR   NUMBER,
  END_TRANSACTION_MIN_NBR  NUMBER,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  LOC_ROOM_CD              NUMBER               DEFAULT 0                     NOT NULL,
  LOC_BED_CD               NUMBER               DEFAULT 0                     NOT NULL,
  PREVIOUS_NURSE_UNIT_CD   NUMBER               DEFAULT 0                     NOT NULL,
  TRANSACTION_IND          NUMBER,
  LOC_NURSE_UNIT_GRP_CD    NUMBER               DEFAULT 0                     NOT NULL,
  LOC_NURSE_UNIT_GRP2_CD   NUMBER               DEFAULT 0                     NOT NULL,
  NU_ARRIVE_DT_TM          DATE,
  NU_ARRIVE_DT_NBR         NUMBER,
  NU_ARRIVE_MIN_NBR        NUMBER,
  NU_DEPART_DT_TM          DATE,
  NU_DEPART_DT_NBR         NUMBER,
  NU_DEPART_MIN_NBR        NUMBER,
  BEG_TRANSACTION_TZ       NUMBER               DEFAULT 0,
  END_TRANSACTION_TZ       NUMBER               DEFAULT 0,
  NU_ARRIVE_TZ             NUMBER               DEFAULT 0,
  NU_DEPART_TZ             NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_MED_SERVICE_HIST_ST
(
  ENCNTR_LOC_HIST_ID       NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  MED_SERVICE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  BEG_TRANSACTION_DT_TM    DATE,
  END_TRANSACTION_DT_TM    DATE,
  BEG_TRANSACTION_DT_NBR   NUMBER,
  BEG_TRANSACTION_MIN_NBR  NUMBER,
  END_TRANSACTION_DT_NBR   NUMBER,
  END_TRANSACTION_MIN_NBR  NUMBER,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  BEG_TRANSACTION_TZ       NUMBER               DEFAULT 0,
  END_TRANSACTION_TZ       NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_ORDER_ST
(
  ORDER_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  PERSON_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  CKI                         VARCHAR2(255 BYTE),
  NEED_DOCTOR_COSIGN_IND      NUMBER,
  CATALOG_CD                  NUMBER            DEFAULT 0                     NOT NULL,
  PRIORITY_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVITY_TYPE_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ORDER_FACILITY_CD           NUMBER            DEFAULT 0                     NOT NULL,
  ORDER_FACILITY_GRP_CD       NUMBER            DEFAULT 0                     NOT NULL,
  ORDER_NURSE_UNIT_CD         NUMBER            DEFAULT 0                     NOT NULL,
  ORDER_NURSE_UNIT_GRP_CD     NUMBER            DEFAULT 0                     NOT NULL,
  ACTION_PERSONNEL_ID         NUMBER            DEFAULT 0                     NOT NULL,
  ORDER_PROVIDER_ID           NUMBER            DEFAULT 0                     NOT NULL,
  REVIEW_COMPLETE_IND         NUMBER,
  REVIEW_REQUIRED_IND         NUMBER,
  CANCEL_DT_TM                DATE,
  COMPLETE_DT_TM              DATE,
  CURRENT_START_DT_TM         DATE,
  DISCONTINUE_DT_TM           DATE,
  ORIG_ORDER_DT_TM            DATE,
  STATUS_DT_TM                DATE,
  CANCEL_DT_NBR               NUMBER,
  COMPLETE_DT_NBR             NUMBER,
  CURRENT_START_DT_NBR        NUMBER,
  DISCONTINUE_DT_NBR          NUMBER,
  ORIG_ORDER_DT_NBR           NUMBER,
  STATUS_DT_NBR               NUMBER,
  CANCEL_MIN_NBR              NUMBER,
  COMPLETE_MIN_NBR            NUMBER,
  CURRENT_START_MIN_NBR       NUMBER,
  DISCONTINUE_MIN_NBR         NUMBER,
  ORIG_ORDER_MIN_NBR          NUMBER,
  STATUS_MIN_NBR              NUMBER,
  ORDER_IND                   NUMBER,
  CANCEL_IND                  NUMBER,
  COMPLETE_IND                NUMBER,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  VISIT_DT_TM                 DATE,
  ICD9_PRIN_PROC_DT_TM        DATE,
  VISIT_DT_NBR                NUMBER,
  VISIT_MIN_NBR               NUMBER,
  ICD9_PRIN_PROC_DT_NBR       NUMBER,
  ICD9_PRIN_PROC_MIN_NBR      NUMBER,
  CANCEL_REASON_CD            NUMBER            DEFAULT 0                     NOT NULL,
  DISCONTINUE_REASON_CD       NUMBER            DEFAULT 0                     NOT NULL,
  CPT4_PROC_NOMENCLATURE_ID   NUMBER            DEFAULT 0                     NOT NULL,
  ICD9_PROC_NOMENCLATURE_ID   NUMBER            DEFAULT 0                     NOT NULL,
  ICD9_DIAG_NOMENCLATURE_ID   NUMBER            DEFAULT 0                     NOT NULL,
  CATALOG_TYPE_CD             NUMBER            DEFAULT 0                     NOT NULL,
  ACTION_PRSNL_POSITION_CD    NUMBER            DEFAULT 0                     NOT NULL,
  ORDER_PROVIDER_POSITION_CD  NUMBER            DEFAULT 0                     NOT NULL,
  CANCEL_TZ                   NUMBER            DEFAULT 0,
  DISCONTINUE_TZ              NUMBER            DEFAULT 0,
  ORIG_ORDER_TZ               NUMBER            DEFAULT 0,
  STATUS_TZ                   NUMBER            DEFAULT 0,
  VISIT_TZ                    NUMBER            DEFAULT 0,
  ICD9_PRIN_PROC_TZ           NUMBER            DEFAULT 0,
  COMPLETE_TZ                 NUMBER            DEFAULT 0,
  CURRENT_START_TZ            NUMBER            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_POSTED_CHARGE_ST
(
  CHARGE_ITEM_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  ENCNTR_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  BILL_ITEM_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  BILL_CODE_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  CPT4_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  ICD9_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_PHYS_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_PHYS_GRP_CD      NUMBER                 DEFAULT 0                     NOT NULL,
  PERF_PHYS_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  PERF_PHYS_GRP_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  CHARGE_DT_TM           DATE,
  CHARGE_DT_NBR          NUMBER,
  CHARGE_MIN_NBR         NUMBER,
  INTERFACED_DT_TM       DATE,
  INTERFACED_DT_NBR      NUMBER,
  INTERFACED_MIN_NBR     NUMBER,
  ORDER_DT_TM            DATE,
  ORDER_DT_NBR           NUMBER,
  ORDER_MIN_NBR          NUMBER,
  SERVICE_DT_TM          DATE,
  SERVICE_DT_NBR         NUMBER,
  SERVICE_MIN_NBR        NUMBER,
  ACTIVITY_TYPE_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  ADMIT_TYPE_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  CATALOG_CD             NUMBER                 DEFAULT 0                     NOT NULL,
  COST_CENTER_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  DEPARTMENT_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  INSTITUTION_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  LOC_FACILITY_CD        NUMBER                 DEFAULT 0                     NOT NULL,
  LOC_NURSE_UNIT_CD      NUMBER                 DEFAULT 0                     NOT NULL,
  SECTION_CD             NUMBER                 DEFAULT 0                     NOT NULL,
  SUBSECTION_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  TIER_GROUP_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  PROCESS_FLG            NUMBER,
  MANUAL_IND             NUMBER,
  ITEM_QUANTITY          FLOAT(126),
  ITEM_PRICE             FLOAT(126),
  ITEM_EXTENDED_PRICE    FLOAT(126),
  TRANSACTION_IND        NUMBER,
  PAYOR_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  DISCOUNT_AMOUNT        NUMBER,
  ACT_SERVICE_TO_CHARGE  NUMBER,
  TOTAL_STD_COST         FLOAT(126),
  STD_DIRECT_VAR_COST    FLOAT(126),
  STD_DIRECT_FIX_COST    FLOAT(126),
  STD_INDIRECT_VAR_COST  FLOAT(126),
  STD_INDIRECT_FIX_COST  FLOAT(126),
  TOTAL_ACT_COST         FLOAT(126),
  ACT_DIRECT_VAR_COST    FLOAT(126),
  ACT_DIRECT_FIX_COST    FLOAT(126),
  ACT_INDIRECT_VAR_COST  FLOAT(126),
  ACT_INDIRECT_FIX_COST  FLOAT(126),
  PROCESS_FLAG           NUMBER,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  CHARGE_DESCRIPTION     VARCHAR2(200 BYTE),
  CHARGE_TYPE_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  CDM_DESC               VARCHAR2(200 BYTE),
  CDM_NBR                VARCHAR2(200 BYTE),
  CPT4_DESC              VARCHAR2(200 BYTE),
  CPT4_NBR               VARCHAR2(200 BYTE),
  ICD9_DESC              VARCHAR2(200 BYTE),
  ICD9_NBR               VARCHAR2(200 BYTE),
  ACCESSION              VARCHAR2(20 BYTE),
  COST_CENTER_GRP_CD     NUMBER                 DEFAULT 0                     NOT NULL,
  REV_CODE_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  REV_CAT_CD             NUMBER                 DEFAULT 0                     NOT NULL,
  REV_CAT_GRP_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  CHARGE_TZ              NUMBER                 DEFAULT 0,
  INTERFACE_TZ           NUMBER                 DEFAULT 0,
  ORDER_TZ               NUMBER                 DEFAULT 0,
  SERVICE_TZ             NUMBER                 DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_PRSNL_PAYPERIOD_ST
(
  PRSNL_PAYPERIOD_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_ALIAS          VARCHAR2(200 BYTE),
  PRSNL_ALIAS_POOL_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  FACILITY_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  DEPARTMENT_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  COST_CENTER_CD       NUMBER                   DEFAULT 0                     NOT NULL,
  PERIOD_START_DT_NBR  NUMBER,
  PERIOD_END_DT_NBR    NUMBER,
  PERIOD_NBR           NUMBER,
  ROLE_CD              NUMBER                   DEFAULT 0                     NOT NULL,
  ROLE_START_DT_NBR    NUMBER,
  HIRE_DT_NBR          NUMBER,
  REG_AMT              FLOAT(126),
  REG_HRS              FLOAT(126),
  OT_AMT               FLOAT(126),
  OT_HRS               FLOAT(126),
  CALLIN_AMT           FLOAT(126),
  CALLIN_HRS           FLOAT(126),
  TIME_OFF_AMT         FLOAT(126),
  TIME_OFF_HRS         FLOAT(126),
  OTHER_NONP_AMT       FLOAT(126),
  OTHER_NONP_HRS       FLOAT(126),
  OTHER_PROD_AMT       FLOAT(126),
  OTHER_PROD_HRS       FLOAT(126),
  COMMISSION_AMT       FLOAT(126),
  STAND_BY_AMT         FLOAT(126),
  STAND_BY_HRS         FLOAT(126),
  AGENCY_AMT           FLOAT(126),
  AGENCY_HRS           FLOAT(126),
  EMP_PAID_TAX         FLOAT(126),
  STD_HRS              FLOAT(126),
  EXP_HRS              FLOAT(126),
  EXTRACT_DT_TM        DATE,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              FLOAT(126)               DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  ROLE_GRP_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_POSITION_CD   NUMBER                   DEFAULT 0                     NOT NULL,
  EXTRACT_TZ           NUMBER                   DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_PRSNL_TIMEDATE_ST
(
  PRSNL_TIMEDATE_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  FACILITY_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  DEPARTMENT_CD        NUMBER                   DEFAULT 0                     NOT NULL,
  COST_CENTER_CD       NUMBER                   DEFAULT 0                     NOT NULL,
  ROLE_CD              NUMBER                   DEFAULT 0                     NOT NULL,
  ROLE_START_DT_NBR    NUMBER,
  PERSON_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  PRSNL_ALIAS          VARCHAR2(200 BYTE),
  PRSNL_ALIAS_POOL_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  TIME_IN_DT_NBR       NUMBER,
  TIME_IN_MIN_NBR      NUMBER,
  TIME_IN_DT_TM        DATE,
  TIME_OUT_DT_NBR      NUMBER,
  TIME_OUT_MIN_NBR     NUMBER,
  TIME_OUT_DT_TM       DATE,
  SHIFT_GRP_CD         NUMBER                   DEFAULT 0                     NOT NULL,
  NUM_HRS              FLOAT(126),
  NUM_MIN              FLOAT(126),
  REG_NUM_HRS          FLOAT(126),
  REG_NUM_MIN          FLOAT(126),
  OT_START_DT_TM       DATE,
  OT_START_DT_NBR      NUMBER,
  OT_START_MIN_NBR     NUMBER,
  OT_NUM_HRS           FLOAT(126),
  OT_NUM_MIN           FLOAT(126),
  MISC_NUM_HRS         FLOAT(126),
  MISC_NUM_MIN         FLOAT(126),
  PRSNL_PAYPERIOD_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  PROCESS_FLAG         NUMBER,
  HIRE_DT_NBR          NUMBER,
  EXTRACT_DT_TM        DATE,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              FLOAT(126)               DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  ROLE_GRP_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  PERSON_POSITION_CD   NUMBER                   DEFAULT 0                     NOT NULL,
  EXTRACT_TZ           NUMBER                   DEFAULT 0,
  OT_START_TZ          NUMBER                   DEFAULT 0,
  TIME_IN_TZ           NUMBER                   DEFAULT 0,
  TIME_OUT_TZ          NUMBER                   DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_RADMGMT_ORDER_ST
(
  ORDER_ID                      NUMBER          DEFAULT 0                     NOT NULL,
  PATIENT_ID                    NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_PHYS_ID                 NUMBER          DEFAULT 0                     NOT NULL,
  RADIOLOGIST_ID                NUMBER          DEFAULT 0                     NOT NULL,
  TRANSCRIPTIONIST_ID           NUMBER          DEFAULT 0                     NOT NULL,
  ENCNTR_TYPE_CD                NUMBER          DEFAULT 0                     NOT NULL,
  PERF_INST_CD                  NUMBER          DEFAULT 0                     NOT NULL,
  PERF_DEPT_CD                  NUMBER          DEFAULT 0                     NOT NULL,
  SECTION_CD                    NUMBER          DEFAULT 0                     NOT NULL,
  SUBSECTION_CD                 NUMBER          DEFAULT 0                     NOT NULL,
  EXAM_ROOM_CD                  NUMBER          DEFAULT 0                     NOT NULL,
  PRIORITY_CD                   NUMBER          DEFAULT 0                     NOT NULL,
  CATALOG_CD                    NUMBER          DEFAULT 0                     NOT NULL,
  ACCESSION_NBR                 VARCHAR2(50 BYTE),
  NBR_REPORTS                   NUMBER,
  EXAM_COMPLETE_QTY             NUMBER          DEFAULT 0,
  EXAM_COMPLETE_HOUR            NUMBER,
  EXAM_COMPLETE_DAY             NUMBER,
  EXAM_COMPLETE_MONTH           VARCHAR2(10 BYTE),
  TAT_QUAL_IND                  NUMBER,
  RULE_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  EXP_OVERALL_TAT               NUMBER,
  EXP_ORD_START                 NUMBER,
  EXP_START_EX_COMP             NUMBER,
  EXP_EX_COMP_VIEW              NUMBER,
  EXP_VIEW_DICTATE              NUMBER,
  EXP_DICTATE_TRANS             NUMBER,
  EXP_TRANS_FINAL               NUMBER,
  ACT_OVERALL_TAT               NUMBER,
  ACT_ORD_START                 NUMBER,
  ACT_START_EX_COMP             NUMBER,
  ACT_EX_COMP_VIEW              NUMBER,
  ACT_VIEW_DICTATE              NUMBER,
  ACT_DICTATE_TRANS             NUMBER,
  ACT_TRANS_FINAL               NUMBER,
  ORDER_DT_TM                   DATE,
  START_DT_TM                   DATE,
  EXAM_COMPLETE_DT_TM           DATE,
  VIEW_DT_TM                    DATE,
  DICTATE_DT_TM                 DATE,
  TRANSCRIBE_DT_TM              DATE,
  FINAL_DT_TM                   DATE,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  RAD_REPORT_ID                 NUMBER          DEFAULT 0                     NOT NULL,
  EXAM_COMP_CREDIT_QTY          NUMBER          DEFAULT 0,
  PROCEDURE_TYPE_FLAG           NUMBER          DEFAULT 0,
  ENCNTR_ID                     NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_DT_NBR                  NUMBER,
  ORDER_MIN_NBR                 NUMBER,
  START_MIN_NBR                 NUMBER,
  START_DT_NBR                  NUMBER,
  EXAM_COMPLETE_DT_NBR          NUMBER,
  EXAM_COMPLETE_MIN_NBR         NUMBER,
  DICTATE_DT_NBR                NUMBER,
  DICTATE_MIN_NBR               NUMBER,
  TRANSCRIBE_DT_NBR             NUMBER,
  TRANSCRIBE_MIN_NBR            NUMBER,
  FINAL_DT_NBR                  NUMBER,
  FINAL_MIN_NBR                 NUMBER,
  ORDER_TZ                      NUMBER          DEFAULT 0,
  START_TZ                      NUMBER          DEFAULT 0,
  EXAM_COMPLETE_TZ              NUMBER          DEFAULT 0,
  TRANSCRIBE_TZ                 NUMBER          DEFAULT 0,
  DICTATE_TZ                    NUMBER          DEFAULT 0,
  FINAL_TZ                      NUMBER          DEFAULT 0,
  CANCEL_DT_TM                  DATE,
  CANCEL_DT_NBR                 NUMBER          DEFAULT 0,
  CANCEL_MIN_NBR                NUMBER          DEFAULT 0,
  CANCEL_TZ                     NUMBER          DEFAULT 0,
  CANCEL_REASON_CD              NUMBER          DEFAULT 0,
  CANCEL_BY_ID                  NUMBER          DEFAULT 0                     NOT NULL,
  VETTING_DT_TM                 DATE,
  VETTING_DT_NBR                NUMBER          DEFAULT 0,
  VETTING_MIN_NBR               NUMBER          DEFAULT 0,
  VETTING_TZ                    NUMBER,
  SCHED_DT_TM                   DATE,
  SCHED_DT_NBR                  NUMBER          DEFAULT 0,
  SCHED_MIN_NBR                 NUMBER          DEFAULT 0,
  SCHED_TZ                      NUMBER,
  ENCNTR_TYPE_AT_EXAM_CMPLT_CD  NUMBER          DEFAULT 0                     NOT NULL,
  ROOM_AT_EXAM_CMPLT_CD         NUMBER          DEFAULT 0                     NOT NULL,
  BED_AT_EXAM_CMPLT_CD          NUMBER          DEFAULT 0                     NOT NULL,
  LOC_AT_EXAM_CMPLT_CD          NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_PRSNL_ID                NUMBER          DEFAULT 0                     NOT NULL,
  PRECOMPLETE_CANCEL_IND        NUMBER          DEFAULT 0,
  REQUEST_MIN_NBR               NUMBER,
  REQUEST_TZ                    NUMBER,
  SCHED_CONFIRM_DT_TM           DATE,
  SCHED_CONFIRM_DT_NBR          NUMBER,
  SCHED_CONFIRM_MIN_NBR         NUMBER,
  SCHED_CONFIRM_TZ              NUMBER,
  EXP_ORDER_SCHED_CONFIRM       NUMBER,
  REQUEST_DT_TM                 DATE,
  REQUEST_DT_NBR                NUMBER,
  EXP_SCHED_CONFIRM_REQUEST     NUMBER,
  EXP_REQUEST_START             NUMBER,
  ACT_ORDER_SCHED_CONFIRM       NUMBER,
  ACT_SCHED_CONFIRM_REQUEST     NUMBER,
  ACT_REQUEST_START             NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_RADPROC_CLASS_ST
(
  ORDER_ID           NUMBER                     DEFAULT 0                     NOT NULL,
  CLASSIFICATION_CD  NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_RADREPEAT_ORDER_ST
(
  ORDER_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  REPEAT_SEQ                 NUMBER             DEFAULT 0                     NOT NULL,
  TECHNOLOGIST_ID            NUMBER             DEFAULT 0                     NOT NULL,
  REASON_CD                  NUMBER             DEFAULT 0                     NOT NULL,
  FILM_TYPE_CD               NUMBER             DEFAULT 0                     NOT NULL,
  FILM_SIZE_CD               NUMBER             DEFAULT 0                     NOT NULL,
  STANDARD_QTY               NUMBER,
  WASTE_QTY                  NUMBER,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  OMF_RADREPEAT_ORDER_ST_ID  NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_RADTECH_ORDER_ST
(
  ORDER_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  TECHNOLOGIST_ID          NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  OMF_RADTECH_ORDER_ST_ID  NUMBER               DEFAULT 0                     NOT NULL,
  PRIMARY_PRSNL_IND        NUMBER               DEFAULT 0                     NOT NULL,
  ROLE_CD                  NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_RADTRANS_ORDER_ST
(
  RAD_REPORT_ID             NUMBER              DEFAULT 0                     NOT NULL,
  RAD_REPORT_SEQ            NUMBER              DEFAULT 0                     NOT NULL,
  ORDER_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  TRANSCRIPTIONIST_ID       NUMBER              DEFAULT 0                     NOT NULL,
  NBR_LINES                 NUMBER,
  NBR_WORDS                 NUMBER,
  NBR_CHARACTERS            NUMBER,
  TRANSCRIBE_DT_TM          DATE,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  OMF_RADTRANS_ORDER_ST_ID  NUMBER              DEFAULT 0                     NOT NULL,
  ORIG_TRANS_DT_TM          DATE,
  RADIOLOGIST_ID            NUMBER              DEFAULT 0                     NOT NULL,
  ORIG_TRANSCRIBE_DT_NBR    NUMBER,
  ORIG_TRANSCRIBE_MIN_NBR   NUMBER,
  TRANSCRIBE_MIN_NBR        NUMBER,
  TRANSCRIBE_DT_NBR         NUMBER,
  ORIG_TRANSCRIBE_TZ        NUMBER              DEFAULT 0,
  TRANSCRIBE_TZ             NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_REVENUE_ST
(
  OMF_REVENUE_ST_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  ENCNTR_ID            NUMBER                   DEFAULT 0                     NOT NULL,
  REVENUE_CD           NUMBER                   DEFAULT 0                     NOT NULL,
  REVENUE_CATEGORY_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  CHARGE               FLOAT(126),
  SERVICE_DT_TM        DATE,
  SERVICE_UNITS        NUMBER,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_SVC_CAT_HIST_ST
(
  SVC_CAT_HIST_ID                NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  MED_SERVICE_CD                 NUMBER         DEFAULT 0                     NOT NULL,
  SERVICE_CATEGORY_CD            NUMBER         DEFAULT 0                     NOT NULL,
  PREV_SERVICE_CATEGORY_CD       NUMBER         DEFAULT 0                     NOT NULL,
  ATT_PRSNL_ID                   NUMBER         DEFAULT 0                     NOT NULL,
  BEG_TRANSACTION_DT_NBR         NUMBER,
  BEG_TRANSACTION_MIN_NBR        NUMBER,
  BEG_TRANSACTION_DT_TM          DATE,
  END_TRANSACTION_DT_NBR         NUMBER,
  END_TRANSACTION_MIN_NBR        NUMBER,
  END_TRANSACTION_DT_TM          DATE,
  DRG_NOMENCLATURE_ID            NUMBER         DEFAULT 0                     NOT NULL,
  DRG_GRP_CD                     NUMBER         DEFAULT 0                     NOT NULL,
  DRG_GRP2_CD                    NUMBER         DEFAULT 0                     NOT NULL,
  DRG_WEIGHT                     FLOAT(126),
  DRG_AMLOS                      FLOAT(126),
  DRG_GMLOS                      FLOAT(126),
  MDC_CD                         NUMBER         DEFAULT 0                     NOT NULL,
  ICD_PD_NOMENCLATURE_ID         NUMBER         DEFAULT 0                     NOT NULL,
  ICD_PD_GRP_CD                  NUMBER         DEFAULT 0                     NOT NULL,
  ICD_SD_STR                     VARCHAR2(255 BYTE),
  ICD_PP_NOMENCLATURE_ID         NUMBER         DEFAULT 0                     NOT NULL,
  ICD_PP_GRP_CD                  NUMBER         DEFAULT 0                     NOT NULL,
  ICD_PP_DT_NBR                  NUMBER,
  ICD_PP_MIN_NBR                 NUMBER,
  ICD_PP_DT_TM                   DATE,
  ICD_PP_MINUTES                 NUMBER,
  ICD_SP_STR                     VARCHAR2(255 BYTE),
  CPT_P_STR                      VARCHAR2(255 BYTE),
  ANESTHESIOLOGIST_ID            NUMBER         DEFAULT 0                     NOT NULL,
  DEATH_24H_PRIN_PROC_IND        NUMBER,
  SURGEON_ID                     NUMBER         DEFAULT 0                     NOT NULL,
  SURGEON_GRP_CD                 NUMBER         DEFAULT 0                     NOT NULL,
  SURGEON_MED_SPEC_CD            NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  ATT_PRSNL_GRP_CD               NUMBER         DEFAULT 0                     NOT NULL,
  ATT_PRSNL_MED_SPEC_CD          NUMBER         DEFAULT 0                     NOT NULL,
  ANESTH_POSITION_CD             NUMBER         DEFAULT 0                     NOT NULL,
  SURGEON_POSITION_CD            NUMBER         DEFAULT 0                     NOT NULL,
  ATTEND_PHYS_POSITION_CD        NUMBER         DEFAULT 0                     NOT NULL,
  ICD9_SECONDARY1_DIAG_NOMEN_ID  NUMBER         DEFAULT 0                     NOT NULL,
  BEG_TRANSACTION_TZ             NUMBER         DEFAULT 0,
  END_TRANSACTION_TZ             NUMBER         DEFAULT 0,
  ICD_PP_DT_TZ                   NUMBER         DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OMF_WL_PRODUCTIVITY_ST
(
  OMF_WL_PRODUCTIVITY_ST_ID  NUMBER             DEFAULT 0                     NOT NULL,
  PRSNL_ID                   NUMBER             DEFAULT 0                     NOT NULL,
  ORD_PHYS_ID                NUMBER             DEFAULT 0                     NOT NULL,
  SERVICE_DT_NBR             NUMBER,
  SERVICE_CATEGORY_CD        NUMBER             DEFAULT 0                     NOT NULL,
  DRG_NOMENCLATURE_ID        NUMBER             DEFAULT 0                     NOT NULL,
  CPT_NOMENCLATURE_ID        NUMBER             DEFAULT 0                     NOT NULL,
  NBR_DRGS                   NUMBER,
  NBR_ICD_PROCS              NUMBER,
  NBR_CPT_PROCS              NUMBER,
  RAW_COUNT                  NUMBER,
  MULTIPLIER                 FLOAT(126),
  UNITS                      FLOAT(126),
  QTY                        FLOAT(126),
  EXTENDED_UNITS             FLOAT(126),
  PROJ_WORKLOAD              FLOAT(126),
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    FLOAT(126)         DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  PRSNL_POSITION_CD          NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ONC_ADHOC_PHASE
(
  ONC_ADHOC_PHASE_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  ONC_ADHOC_PLAN_ID   NUMBER                    DEFAULT 0                     NOT NULL,
  PHASE_NAME          VARCHAR2(100 BYTE)        DEFAULT ' '                   NOT NULL,
  START_DT_TM         DATE,
  END_DT_TM           DATE,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ONC_ADHOC_PLAN
(
  ONC_ADHOC_PLAN_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  PERSON_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  PLAN_NAME          VARCHAR2(100 BYTE)         DEFAULT ' '                   NOT NULL,
  START_DT_TM        DATE,
  END_DT_TM          DATE,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ONC_FORM_ACTIVITY
(
  ONC_FORM_ACTIVITY_ID        NUMBER            DEFAULT 0                     NOT NULL,
  FORM_ACTIVITY_ID            NUMBER            DEFAULT 0                     NOT NULL,
  DOC_SET_REF_ID              NUMBER            DEFAULT 0                     NOT NULL,
  PROBLEM_ID                  NUMBER            DEFAULT 0                     NOT NULL,
  PERSON_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  EVENT_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  ONC_DOCSETREF_CAT_ID        NUMBER            DEFAULT 0                     NOT NULL,
  ONSET_DT_TM                 DATE,
  PERFORMED_PRSNL_ID          NUMBER            DEFAULT 0                     NOT NULL,
  FORM_STATUS_CD              NUMBER            DEFAULT 0                     NOT NULL,
  VERSION_DT_TM               DATE,
  VALID_FROM_DT_TM            DATE,
  VALID_UNTIL_DT_TM           DATE,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  TEXTUAL_RENDITION_EVENT_ID  NUMBER            DEFAULT 0                     NOT NULL,
  PRE_RECURRENCE_FORM_ACT_ID  NUMBER            DEFAULT 0                     NOT NULL,
  RECURRENCE_DT_TM            DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDERS
(
  ORDER_ID                       NUMBER         DEFAULT 0                     NOT NULL,
  OE_FORMAT_ID                   NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  PERSON_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  CATALOG_CD                     NUMBER         DEFAULT 0                     NOT NULL,
  SUSPEND_IND                    NUMBER,
  CONTRIBUTOR_SYSTEM_CD          NUMBER         DEFAULT 0                     NOT NULL,
  CATALOG_TYPE_CD                NUMBER         DEFAULT 0                     NOT NULL,
  ORIG_ORDER_DT_TM               DATE,
  ORDER_STATUS_CD                NUMBER         DEFAULT 0                     NOT NULL,
  ORDER_MNEMONIC                 VARCHAR2(100 BYTE),
  LAST_ACTION_SEQUENCE           NUMBER,
  LAST_UPDATE_PROVIDER_ID        NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVITY_TYPE_CD               NUMBER         DEFAULT 0                     NOT NULL,
  ORDER_DETAIL_DISPLAY_LINE      VARCHAR2(255 BYTE),
  TEMPLATE_ORDER_ID              NUMBER         DEFAULT 0                     NOT NULL,
  TEMPLATE_ORDER_FLAG            NUMBER,
  SYNONYM_ID                     NUMBER         DEFAULT 0                     NOT NULL,
  LINK_ORDER_FLAG                NUMBER,
  LINK_ORDER_ID                  NUMBER         DEFAULT 0                     NOT NULL,
  GROUP_ORDER_ID                 NUMBER         DEFAULT 0                     NOT NULL,
  GROUP_ORDER_FLAG               NUMBER,
  STATUS_DT_TM                   DATE,
  STATUS_PRSNL_ID                NUMBER         DEFAULT 0                     NOT NULL,
  IV_IND                         NUMBER,
  CONSTANT_IND                   NUMBER,
  PRN_IND                        NUMBER,
  ORDER_COMMENT_IND              NUMBER,
  NEED_RX_VERIFY_IND             NUMBER,
  NEED_NURSE_REVIEW_IND          NUMBER,
  NEED_DOCTOR_COSIGN_IND         NUMBER,
  CURRENT_START_DT_TM            DATE,
  PROJECTED_STOP_DT_TM           DATE,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_FINANCIAL_ID            NUMBER         DEFAULT 0                     NOT NULL,
  SUSPEND_EFFECTIVE_DT_TM        DATE,
  RESUME_IND                     NUMBER,
  RESUME_EFFECTIVE_DT_TM         DATE,
  DISCONTINUE_IND                NUMBER,
  DISCONTINUE_EFFECTIVE_DT_TM    DATE,
  PRODUCT_ID                     NUMBER         DEFAULT 0                     NOT NULL,
  CS_ORDER_ID                    NUMBER         DEFAULT 0                     NOT NULL,
  CS_FLAG                        NUMBER,
  ACTIVE_STATUS_CD               NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM            DATE,
  ACTIVE_STATUS_PRSNL_ID         NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVE_IND                     NUMBER,
  HNA_ORDER_MNEMONIC             VARCHAR2(100 BYTE),
  ORIG_ORD_AS_FLAG               NUMBER,
  INGREDIENT_IND                 NUMBER,
  DEPT_STATUS_CD                 NUMBER         DEFAULT 0                     NOT NULL,
  REF_TEXT_MASK                  NUMBER,
  CLINICAL_DISPLAY_LINE          VARCHAR2(255 BYTE),
  INTEREST_DT_TM                 DATE,
  DISCONTINUE_TYPE_CD            NUMBER         DEFAULT 0                     NOT NULL,
  RX_MASK                        NUMBER,
  SCH_STATE_CD                   NUMBER         DEFAULT 0                     NOT NULL,
  ORIG_ORDER_CONVS_SEQ           NUMBER         DEFAULT 0,
  DCP_CLIN_CAT_CD                NUMBER         DEFAULT 0                     NOT NULL,
  CKI                            VARCHAR2(255 BYTE),
  DEPT_MISC_LINE                 VARCHAR2(255 BYTE),
  HIDE_FLAG                      NUMBER,
  INTERVAL_IND                   NUMBER,
  ORDERABLE_TYPE_FLAG            NUMBER,
  INCOMPLETE_ORDER_IND           NUMBER         DEFAULT 0,
  LAST_INGRED_ACTION_SEQUENCE    NUMBER         DEFAULT 0,
  MED_ORDER_TYPE_CD              NUMBER         DEFAULT 0                     NOT NULL,
  NEED_PHYSICIAN_VALIDATE_IND    NUMBER,
  ORDERED_AS_MNEMONIC            VARCHAR2(100 BYTE),
  SOFT_STOP_DT_TM                DATE,
  TEMPLATE_CORE_ACTION_SEQUENCE  NUMBER         DEFAULT 0,
  ESO_NEW_ORDER_IND              NUMBER         DEFAULT 0,
  LAST_CORE_ACTION_SEQUENCE      NUMBER         DEFAULT 0,
  STOP_TYPE_CD                   NUMBER         DEFAULT 0                     NOT NULL,
  FREQUENCY_ID                   NUMBER         DEFAULT 0                     NOT NULL,
  FREQ_TYPE_FLAG                 NUMBER         DEFAULT 0,
  MODIFIED_START_DT_TM           DATE,
  COMMENT_TYPE_MASK              NUMBER         DEFAULT 0,
  OVERRIDE_FLAG                  NUMBER,
  REMAINING_DOSE_CNT             NUMBER         DEFAULT 0,
  VALID_DOSE_DT_TM               DATE,
  SOFT_STOP_TZ                   NUMBER         DEFAULT 0,
  PROJECTED_STOP_TZ              NUMBER         DEFAULT 0,
  RESUME_EFFECTIVE_TZ            NUMBER         DEFAULT 0,
  DISCONTINUE_EFFECTIVE_TZ       NUMBER         DEFAULT 0,
  ORIG_ORDER_TZ                  NUMBER         DEFAULT 0,
  SUSPEND_EFFECTIVE_TZ           NUMBER         DEFAULT 0,
  CURRENT_START_TZ               NUMBER         DEFAULT 0,
  LINK_TYPE_FLAG                 NUMBER         DEFAULT 0,
  LINK_NBR                       FLOAT(126),
  AD_HOC_ORDER_FLAG              NUMBER         DEFAULT 0                     NOT NULL,
  PATHWAY_CATALOG_ID             NUMBER         DEFAULT 0                     NOT NULL,
  IV_SET_SYNONYM_ID              NUMBER         DEFAULT 0,
  CLIN_RELEVANT_UPDT_TZ          NUMBER         DEFAULT 0,
  CLIN_RELEVANT_UPDT_DT_TM       DATE           DEFAULT SYSDATE               NOT NULL,
  SOURCE_CD                      NUMBER         DEFAULT 0,
  PRESCRIPTION_ORDER_ID          NUMBER         DEFAULT 0,
  NEED_RX_CLIN_REVIEW_FLAG       NUMBER         DEFAULT 0,
  SIMPLIFIED_DISPLAY_LINE        VARCHAR2(1000 BYTE),
  FUTURE_LOCATION_FACILITY_CD    NUMBER         DEFAULT 0,
  FUTURE_LOCATION_NURSE_UNIT_CD  NUMBER         DEFAULT 0,
  PRESCRIPTION_GROUP_VALUE       NUMBER,
  ORDER_SCHEDULE_PRECISION_BIT   NUMBER         DEFAULT 0,
  PROTOCOL_ORDER_ID              NUMBER         DEFAULT 0                     NOT NULL,
  DAY_OF_TREATMENT_SEQUENCE      NUMBER,
  WARNING_LEVEL_BIT              NUMBER         DEFAULT 0,
  DOSING_METHOD_FLAG             NUMBER         DEFAULT 0,
  FORMULARY_STATUS_CD            NUMBER,
  TEMPLATE_DOSE_SEQUENCE         NUMBER         DEFAULT 0,
  LAST_UTC_TS                    TIMESTAMP(9)   DEFAULT SYS_EXTRACT_UTC(SYSTIMESTAMP),
  LATEST_COMMUNICATION_TYPE_CD   NUMBER,
  ORDER_STATUS_REASON_BIT        NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_ACTION
(
  ORDER_ID                      NUMBER          DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE               NUMBER          DEFAULT 0                     NOT NULL,
  COMMUNICATION_TYPE_CD         NUMBER          DEFAULT 0                     NOT NULL,
  ACTION_REJECTED_IND           NUMBER,
  ORDER_CONVERSATION_ID         NUMBER          DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD         NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_CONVS_SEQ               NUMBER,
  ORDER_LOCN_CD                 NUMBER          DEFAULT 0                     NOT NULL,
  ACTION_TYPE_CD                NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_DT_TM                   DATE,
  ACTION_DT_TM                  DATE,
  ACTION_PERSONNEL_ID           NUMBER          DEFAULT 0                     NOT NULL,
  EFFECTIVE_DT_TM               DATE            DEFAULT SYSDATE,
  ORDER_PROVIDER_ID             NUMBER          DEFAULT 0                     NOT NULL,
  INCOMPLETE_ORDER_IND          NUMBER,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_APP_NBR                 NUMBER,
  ORDER_ACTION_ID               NUMBER          DEFAULT 0                     NOT NULL,
  NEEDS_VERIFY_IND              NUMBER,
  INACTIVE_FLAG                 NUMBER,
  ORDER_STATUS_CD               NUMBER          DEFAULT 0                     NOT NULL,
  DEPT_STATUS_CD                NUMBER          DEFAULT 0                     NOT NULL,
  SCH_STATE_CD                  NUMBER          DEFAULT 0                     NOT NULL,
  UNDO_ACTION_TYPE_CD           NUMBER          DEFAULT 0                     NOT NULL,
  MEDSTUDENT_ACTION_IND         NUMBER          DEFAULT 0,
  ESO_ACTION_CD                 NUMBER          DEFAULT 0                     NOT NULL,
  CLINICAL_DISPLAY_LINE         VARCHAR2(255 BYTE),
  ORDER_DETAIL_DISPLAY_LINE     VARCHAR2(255 BYTE),
  CORE_IND                      NUMBER,
  CONSTANT_IND                  NUMBER          DEFAULT 0                     NOT NULL,
  FREQUENCY_ID                  NUMBER          DEFAULT 0                     NOT NULL,
  PRN_IND                       NUMBER          DEFAULT 0                     NOT NULL,
  STOP_TYPE_CD                  NUMBER          DEFAULT 0                     NOT NULL,
  TEMPLATE_ORDER_FLAG           NUMBER          DEFAULT -1                    NOT NULL,
  ORDER_TZ                      NUMBER          DEFAULT 0,
  EFFECTIVE_TZ                  NUMBER          DEFAULT 0,
  ACTION_TZ                     NUMBER          DEFAULT 0,
  SUPERVISING_PROVIDER_ID       NUMBER          DEFAULT 0                     NOT NULL,
  DIGITAL_SIGNATURE_IDENT       VARCHAR2(64 BYTE),
  ACTION_INITIATED_DT_TM        DATE,
  ACTION_QUALIFIER_CD           NUMBER          DEFAULT 0,
  NEED_CLIN_REVIEW_FLAG         NUMBER          DEFAULT 0,
  SIMPLIFIED_DISPLAY_LINE       VARCHAR2(1000 BYTE),
  PROJECTED_STOP_TZ             NUMBER,
  PROJECTED_STOP_DT_TM          DATE,
  NEXT_DOSE_DT_TM               DATE,
  VALID_DOSE_DT_TM              DATE,
  CURRENT_START_DT_TM           DATE,
  CURRENT_START_TZ              NUMBER,
  SOURCE_DOT_ORDER_ID           NUMBER,
  SOURCE_DOT_ACTION_SEQ         NUMBER,
  SOURCE_PROTOCOL_ACTION_SEQ    NUMBER,
  BILLING_PROVIDER_FLAG         NUMBER,
  FORMULARY_STATUS_CD           NUMBER,
  ORDER_SCHEDULE_PRECISION_BIT  NUMBER          DEFAULT 0,
  LAST_UTC_TS                   TIMESTAMP(9)    DEFAULT SYS_EXTRACT_UTC(SYSTIMESTAMP),
  START_RANGE_NBR               NUMBER,
  START_RANGE_UNIT_FLAG         NUMBER,
  ORDER_STATUS_REASON_BIT       NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_ALIAS
(
  ORDER_ALIAS_ID           NUMBER               DEFAULT 0                     NOT NULL,
  ORDER_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  ALIAS_POOL_CD            NUMBER               DEFAULT 0                     NOT NULL,
  ORDER_ALIAS_TYPE_CD      NUMBER               DEFAULT 0                     NOT NULL,
  ALIAS                    VARCHAR2(200 BYTE),
  ORDER_ALIAS_SUB_TYPE_CD  NUMBER               DEFAULT 0                     NOT NULL,
  CHECK_DIGIT              NUMBER,
  CHECK_DIGIT_METHOD_CD    NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DATA_STATUS_CD           NUMBER               DEFAULT 0                     NOT NULL,
  DATA_STATUS_PRSNL_ID     NUMBER               DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD    NUMBER               DEFAULT 0                     NOT NULL,
  BILL_ORD_NBR_IND         NUMBER,
  PRIMARY_DISPLAY_IND      NUMBER,
  ASSIGN_AUTHORITY_SYS_CD  NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_CATALOG_ITEM_R
(
  CATALOG_CD    NUMBER                          DEFAULT 0                     NOT NULL,
  ITEM_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  SYNONYM_ID    NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_COMMENT
(
  ORDER_ID          NUMBER                      DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE   NUMBER                      DEFAULT 0                     NOT NULL,
  COMMENT_TYPE_CD   NUMBER                      DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID      NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  COMMENT_PRSNL_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  COMMENT_DT_TM     DATE,
  DISPLAY_MASK      NUMBER                      DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_COMPLIANCE
(
  ORDER_COMPLIANCE_ID            NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  PERFORMED_PRSNL_ID             NUMBER         DEFAULT 0                     NOT NULL,
  PERFORMED_DT_TM                DATE           DEFAULT SYSDATE               NOT NULL,
  PERFORMED_TZ                   NUMBER         DEFAULT 0                     NOT NULL,
  NO_KNOWN_HOME_MEDS_IND         NUMBER         DEFAULT 0                     NOT NULL,
  UNABLE_TO_OBTAIN_IND           NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_COMPLIANCE_STATUS_FLAG  NUMBER         DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_COMPLIANCE_DETAIL
(
  ORDER_COMPLIANCE_DETAIL_ID  NUMBER            DEFAULT 0                     NOT NULL,
  ORDER_COMPLIANCE_ID         NUMBER            DEFAULT 0                     NOT NULL,
  COMPLIANCE_STATUS_CD        NUMBER            DEFAULT 0                     NOT NULL,
  INFORMATION_SOURCE_CD       NUMBER            DEFAULT 0                     NOT NULL,
  LAST_OCCURRED_DT_TM         DATE              DEFAULT SYSDATE,
  LAST_OCCURRED_TZ            NUMBER            DEFAULT 0,
  LONG_TEXT_ID                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  ORDER_NBR                   FLOAT(126)        DEFAULT 0                     NOT NULL,
  COMPLIANCE_CAPTURE_DT_TM    DATE              DEFAULT SYSDATE               NOT NULL,
  LAST_OCCURRED_DT_ONLY_IND   NUMBER            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_CONTAINER_R
(
  CONTAINER_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  CATALOG_CD              NUMBER                DEFAULT 0                     NOT NULL,
  COLLECTION_STATUS_FLAG  NUMBER,
  REASON_MISSED_CD        NUMBER                DEFAULT 0                     NOT NULL,
  REASON_MISSED_ID        NUMBER                DEFAULT 0                     NOT NULL,
  REASON_MISSED_DT_TM     DATE,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  DEST_CONTAINER_ID       NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_DEMOG_HISTORY
(
  ORDER_DEMOG_HISTORY_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_DETAIL
(
  ORDER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE         NUMBER                DEFAULT 0                     NOT NULL,
  DETAIL_SEQUENCE         NUMBER                DEFAULT 0                     NOT NULL,
  OE_FIELD_ID             NUMBER                DEFAULT 0                     NOT NULL,
  OE_FIELD_DISPLAY_VALUE  VARCHAR2(255 BYTE),
  OE_FIELD_VALUE          NUMBER,
  OE_FIELD_MEANING        VARCHAR2(25 BYTE),
  OE_FIELD_MEANING_ID     NUMBER                DEFAULT 0                     NOT NULL,
  OE_FIELD_DT_TM_VALUE    DATE,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ACTION_SEQUENCE  NUMBER,
  OE_FIELD_TZ             NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_DETAIL_HISTORY
(
  ORDER_DETAIL_HISTORY_ID  NUMBER               DEFAULT 0                     NOT NULL,
  ORDER_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE          NUMBER               DEFAULT 0                     NOT NULL,
  DETAIL_SEQUENCE          NUMBER               DEFAULT 0                     NOT NULL,
  HISTORY_SEQUENCE         NUMBER               DEFAULT 0                     NOT NULL,
  OE_FIELD_ID              NUMBER               DEFAULT 0                     NOT NULL,
  OE_FIELD_MEANING_ID      NUMBER               DEFAULT 0                     NOT NULL,
  OE_FIELD_DISPLAY_VALUE   VARCHAR2(255 BYTE),
  OE_FIELD_DT_TM_VALUE     DATE,
  OE_FIELD_TZ              NUMBER,
  OE_FIELD_VALUE           NUMBER,
  DETAIL_ALTER_FLAG        NUMBER               DEFAULT 0                     NOT NULL,
  DETAIL_ALTER_TRIGGER_CD  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_DIAG_CONFIG
(
  ORDER_DIAG_CONFIG_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  VENUE_TYPE_FLAG       NUMBER                  DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  CATALOG_TYPE_CD       NUMBER                  DEFAULT 0                     NOT NULL,
  CONFIG_MEANING        VARCHAR2(12 BYTE)       DEFAULT ' '                   NOT NULL,
  CONFIG_VALUE          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_DISPENSE
(
  ORDER_ID                       NUMBER         DEFAULT 0                     NOT NULL,
  NEXT_DISPENSE_DT_TM            DATE,
  DISPENSE_CATEGORY_CD           NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  PRN_IND                        NUMBER,
  PRINT_IND                      NUMBER,
  TOTAL_DISPENSE_DOSES           FLOAT(126)     DEFAULT 0,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  FLOORSTOCK_IND                 NUMBER,
  NEXT_IV_SEQ                    NUMBER         DEFAULT 0,
  CART_FILL_DOSES1               NUMBER,
  CART_FILL_DOSES2               NUMBER,
  CART_FILL_DOSES3               NUMBER,
  CART_FILL_DT_TM1               DATE,
  CART_FILL_DT_TM2               DATE,
  CART_FILL_DT_TM3               DATE,
  CART_FILL_RUN_ID1              FLOAT(126),
  CART_FILL_RUN_ID2              FLOAT(126),
  CART_FILL_RUN_ID3              FLOAT(126),
  DEPT_STATUS_CD                 NUMBER         DEFAULT 0                     NOT NULL,
  DISPLAY_LINE                   VARCHAR2(255 BYTE),
  FLOORSTOCK_OVERRIDE_IND        NUMBER,
  FREQUENCY_ID                   NUMBER         DEFAULT 0                     NOT NULL,
  IGNORE_IND                     NUMBER,
  IV_SET_SIZE                    NUMBER,
  LAST_VER_ACT_SEQ               NUMBER,
  LAST_VER_INGR_SEQ              NUMBER,
  ORDER_COST_VALUE               NUMBER,
  ORDER_DISPENSE_IND             NUMBER,
  ORDER_PRICE_VALUE              NUMBER,
  ORDER_TYPE                     NUMBER,
  PAR_DOSES                      NUMBER,
  PRICE_SCHEDULE_ID              NUMBER         DEFAULT 0                     NOT NULL,
  REPLACE_EVERY                  FLOAT(126),
  REPLACE_EVERY_CD               NUMBER         DEFAULT 0                     NOT NULL,
  RESUME_DT_TM                   DATE,
  STOP_DT_TM                     DATE,
  STOP_TYPE_CD                   NUMBER         DEFAULT 0                     NOT NULL,
  SUSPEND_DT_TM                  DATE,
  LAST_FILL_STATUS               NUMBER,
  PRICE_CODE_CD                  NUMBER         DEFAULT 0                     NOT NULL,
  QTY_REMAINING                  FLOAT(126),
  REFILLS_REMAINING              FLOAT(126),
  RX_NBR                         FLOAT(126),
  RX_NBR_CD                      NUMBER         DEFAULT 0                     NOT NULL,
  TOTAL_RX_QTY                   FLOAT(126),
  TRANSFER_CNT                   NUMBER,
  CLAIM_FLAG                     NUMBER,
  DAW_CD                         NUMBER         DEFAULT 0                     NOT NULL,
  DAYS_SUPPLY                    FLOAT(126),
  FILL_NBR                       NUMBER,
  HEALTH_PLAN_ID                 NUMBER         DEFAULT 0                     NOT NULL,
  LAST_FILL_DISPENSE_HX_ID       NUMBER         DEFAULT 0                     NOT NULL,
  LAST_FILL_HX_ID                NUMBER         DEFAULT 0                     NOT NULL,
  LAST_REFILL_DT_TM              DATE,
  LEGAL_STATUS_CD                NUMBER         DEFAULT 0                     NOT NULL,
  PERSON_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  PHARM_TYPE_CD                  NUMBER         DEFAULT 0                     NOT NULL,
  LAST_FILL_ACT_SEQ              NUMBER,
  LAST_FILL_INGR_SEQ             NUMBER,
  EXPIRE_DT_TM                   DATE,
  LAST_RX_DISPENSE_HX_ID         NUMBER         DEFAULT 0                     NOT NULL,
  OWE_QTY                        FLOAT(126),
  RESEARCH_ACCOUNT_ID            NUMBER         DEFAULT 0                     NOT NULL,
  NEXT_DISPENSE_TZ               NUMBER         DEFAULT 0,
  CART_FILL1_TZ                  NUMBER         DEFAULT 0,
  CART_FILL2_TZ                  NUMBER         DEFAULT 0,
  CART_FILL3_TZ                  NUMBER         DEFAULT 0,
  RESUME_TZ                      NUMBER         DEFAULT 0,
  STOP_TZ                        NUMBER         DEFAULT 0,
  SUSPEND_TZ                     NUMBER         DEFAULT 0,
  LAST_REFILL_TZ                 NUMBER         DEFAULT 0,
  EXPIRE_TZ                      NUMBER         DEFAULT 0,
  NEED_RX_VERIFY_IND             NUMBER,
  UNVERIFIED_COMM_TYPE_CD        NUMBER         DEFAULT 0                     NOT NULL,
  UNVERIFIED_ACTION_TYPE_CD      NUMBER         DEFAULT 0                     NOT NULL,
  UNVERIFIED_ROUTE_CD            NUMBER         DEFAULT 0                     NOT NULL,
  UNVERIFIED_RX_ORD_PRIORITY_CD  NUMBER         DEFAULT 0                     NOT NULL,
  COB_IND                        NUMBER,
  PARENT_ORDER_ID                NUMBER         DEFAULT 0                     NOT NULL,
  SOURCE_PARENT_ACTION_SEQ       NUMBER         DEFAULT 0                     NOT NULL,
  REVIEWED_PARENT_ACTION_SEQ     NUMBER         DEFAULT 0                     NOT NULL,
  PROFILE_DISPLAY_DT_TM          DATE,
  WORKFLOW_CD                    NUMBER         DEFAULT 0,
  LAST_CLIN_REVIEW_INGR_SEQ      NUMBER         DEFAULT 0,
  LAST_CLIN_REVIEW_ACT_SEQ       NUMBER         DEFAULT 0,
  NEED_RX_PROD_ASSIGN_FLAG       NUMBER         DEFAULT 0,
  FUTURE_LOC_NURSE_UNIT_CD       NUMBER         DEFAULT 0                     NOT NULL,
  FUTURE_LOC_FACILITY_CD         NUMBER         DEFAULT 0                     NOT NULL,
  PATIENT_MED_IND                NUMBER         DEFAULT 0,
  START_DISPENSE_TZ              NUMBER         DEFAULT 0,
  START_DISPENSE_DT_TM           DATE,
  AUTO_CREDIT_IND                NUMBER         DEFAULT 0,
  RXA_SIG_OVERRIDE_IND           NUMBER         DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_FUTURE_INFO
(
  ORDER_FUTURE_INFO_ID   NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  START_RANGE_NBR        NUMBER,
  START_RANGE_UNIT_FLAG  NUMBER,
  BEGIN_DUE_DT_TM        DATE                   DEFAULT SYSDATE               NOT NULL,
  END_DUE_DT_TM          DATE                   DEFAULT SYSDATE               NOT NULL,
  EXPIRATION_DT_TM       DATE,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_HEALTH_PLAN
(
  ORDER_ID                       NUMBER         DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE                NUMBER         DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID                 NUMBER         DEFAULT 0                     NOT NULL,
  CONFLICT_CD                    NUMBER         DEFAULT 0                     NOT NULL,
  INTERVENTION_CD                NUMBER         DEFAULT 0                     NOT NULL,
  OUTCOME_CD                     NUMBER         DEFAULT 0                     NOT NULL,
  PRESCRIPTION_CD                NUMBER         DEFAULT 0                     NOT NULL,
  ELIGIBILITY_CD                 NUMBER         DEFAULT 0                     NOT NULL,
  PRIOR_AUTH_TYPE_CD             NUMBER         DEFAULT 0                     NOT NULL,
  PRIOR_AUTH_NBR_TXT             VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  PRIOR_AUTH_BEG_EFF_DT_TM       DATE,
  PRIOR_AUTH_END_EFF_DT_TM       DATE,
  OTHER_COVERAGE_CD              NUMBER         DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_SEQ                NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  PA_REQ_TYPE_CD                 NUMBER         DEFAULT 0                     NOT NULL,
  PA_REQ_BASIS_CD                NUMBER         DEFAULT 0                     NOT NULL,
  PA_REQ_BEG_DT_TM               DATE,
  PA_REQ_END_DT_TM               DATE,
  DUR_AGENT_QUAL_CD              NUMBER         DEFAULT 0                     NOT NULL,
  DUR_AGENT_QUAL_IDENT           VARCHAR2(30 BYTE) DEFAULT ' ' NOT NULL,
  WORKERS_COMP_FLAG              NUMBER         DEFAULT 0                     NOT NULL,
  DUR_LEVEL_OF_EFFORT_CD         NUMBER         DEFAULT 0                     NOT NULL,
  EMPLOYER_IDENT                 VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  PATIENT_LOCATION_ID_CD         NUMBER         DEFAULT 0                     NOT NULL,
  HOME_PLAN_IDENT                VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  FACILITY_IDENT                 VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  ORIG_PRESCRIBED_SERV_QUAL_CD   NUMBER         DEFAULT 0                     NOT NULL,
  ORIG_PRESCRIBED_SERV_QUAL_TXT  VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  ORIG_PRESCRIBED_QTY            FLOAT(126)     DEFAULT 0                     NOT NULL,
  ALTERNATE_IDENT                VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  SCHED_PRESCRIPT_ID_NBR_TXT     VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  INTER_AUTH_TYPE_ID_CD          NUMBER         DEFAULT 0                     NOT NULL,
  INTER_AUTH_IDENT               VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  LEVEL_OF_SERVICE_CD            NUMBER         DEFAULT 0                     NOT NULL,
  PATIENT_PAID_AMT               FLOAT(126)     DEFAULT 0                     NOT NULL,
  COUPON_TYPE_CD                 NUMBER         DEFAULT 0                     NOT NULL,
  COUPON_NBR_TXT                 VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  COUPON_AMT                     FLOAT(126)     DEFAULT 0                     NOT NULL,
  AUTH_REP_FIRST_NAME            VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  AUTH_REP_LAST_NAME             VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  AUTH_REP_STREET                VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  AUTH_REP_CITY                  VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  AUTH_REP_STATE                 VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  AUTH_REP_ZIP                   VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  PRIOR_AUTH_NBR_ASSIGN_TXT      VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  AUTH_NBR_TXT                   VARCHAR2(250 BYTE) DEFAULT ' ' NOT NULL,
  PRIOR_AUTH_SUPPORT_DOC_TXT     VARCHAR2(500 BYTE) DEFAULT ' ' NOT NULL,
  ASSOC_PRESCRIP_NBR             VARCHAR2(200 BYTE) DEFAULT ' ' NOT NULL,
  PARTIAL_FILL_TYPE_CD           NUMBER         DEFAULT 0                     NOT NULL,
  ACTUAL_DAYS_SUPPLY             NUMBER         DEFAULT 0                     NOT NULL,
  ASSOC_PRESCRIP_DT_TM           DATE,
  COMPOUND_FORM_CD               NUMBER         DEFAULT 0,
  ASSOC_PRESCRIP_TZ              NUMBER         DEFAULT 0,
  PA_REQ_TZ                      NUMBER         DEFAULT 0,
  PRIOR_AUTH_TZ                  NUMBER         DEFAULT 0,
  MANUAL_COPAY_AMT               FLOAT(126)     DEFAULT 0,
  MANUAL_ADJUDICATED_IND         NUMBER         DEFAULT 0,
  COB_OTHER_PAYER_PAY_TYPE_CD    NUMBER         DEFAULT 0,
  COB_OTHER_PAYER_PAY_AMT        FLOAT(126)     DEFAULT 0,
  COB_PAYER_CTRL_IDENT           VARCHAR2(30 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_HEALTH_PLAN_DETAIL
(
  ORDER_HEALTH_PLAN_DTL_ID  NUMBER              DEFAULT 0                     NOT NULL,
  ORDER_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  ACTION_SEQ                NUMBER              DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID            NUMBER              DEFAULT 0                     NOT NULL,
  DETAIL_FIELD_VALUE        NUMBER              DEFAULT 0                     NOT NULL,
  DETAIL_FIELD_DT_TM        DATE,
  DETAIL_FIELD_TXT          VARCHAR2(250 BYTE)  DEFAULT ' '                   NOT NULL,
  DETAIL_FIELD_SEQ          NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  DETAIL_FIELD_IDENT        NUMBER              DEFAULT 0                     NOT NULL,
  DETAIL_TZ                 NUMBER              DEFAULT 0,
  DETAIL_FIELD_MEANING      VARCHAR2(25 BYTE)   DEFAULT ' ',
  DETAIL_FIELD_ID           NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_INGREDIENT
(
  ORDER_ID                        NUMBER        DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE                 NUMBER        DEFAULT 0                     NOT NULL,
  COMP_SEQUENCE                   NUMBER        DEFAULT 0                     NOT NULL,
  CATALOG_TYPE_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  CATALOG_CD                      NUMBER        DEFAULT 0                     NOT NULL,
  SYNONYM_ID                      NUMBER        DEFAULT 0                     NOT NULL,
  ORDER_MNEMONIC                  VARCHAR2(100 BYTE),
  ORDER_DETAIL_DISPLAY_LINE       VARCHAR2(255 BYTE),
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  STRENGTH                        FLOAT(126),
  STRENGTH_UNIT                   FLOAT(126),
  VOLUME                          FLOAT(126),
  VOLUME_UNIT                     FLOAT(126),
  FREETEXT_DOSE                   VARCHAR2(100 BYTE),
  FREQ_CD                         NUMBER        DEFAULT 0                     NOT NULL,
  IV_SEQ                          NUMBER        DEFAULT 0,
  DOSE_QUANTITY                   FLOAT(126)    DEFAULT 0,
  DOSE_QUANTITY_UNIT              FLOAT(126)    DEFAULT 0,
  ORDERED_AS_MNEMONIC             VARCHAR2(100 BYTE),
  SUPPLIED_AS_MNEMONIC            VARCHAR2(100 BYTE),
  HNA_ORDER_MNEMONIC              VARCHAR2(100 BYTE),
  INGREDIENT_TYPE_FLAG            NUMBER        DEFAULT 0,
  CLINICALLY_SIGNIFICANT_FLAG     NUMBER        DEFAULT 0                     NOT NULL,
  INCLUDE_IN_TOTAL_VOLUME_FLAG    NUMBER        DEFAULT 0                     NOT NULL,
  ORDERED_DOSE_UNIT_CD            NUMBER        DEFAULT 0                     NOT NULL,
  ORDERED_DOSE                    FLOAT(126)    DEFAULT 0                     NOT NULL,
  INGREDIENT_SOURCE_FLAG          NUMBER        DEFAULT 0,
  DOSE_CALCULATOR_LONG_TEXT_ID    NUMBER        DEFAULT 0,
  NORMALIZED_RATE                 FLOAT(126)    DEFAULT 0,
  NORMALIZED_RATE_UNIT_CD         NUMBER        DEFAULT 0,
  CONCENTRATION                   FLOAT(126)    DEFAULT 0,
  CONCENTRATION_UNIT_CD           NUMBER        DEFAULT 0,
  DOSING_CAPACITY                 NUMBER        DEFAULT 0,
  DOSE_ADJUSTMENT_DISPLAY         VARCHAR2(255 BYTE) DEFAULT ' ',
  DAYS_OF_ADMINISTRATION_DISPLAY  VARCHAR2(100 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_INGREDIENT_DOSE
(
  ORDER_INGREDIENT_DOSE_ID     NUMBER           DEFAULT 0                     NOT NULL,
  ORDER_ID                     NUMBER           DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE              NUMBER           DEFAULT 0                     NOT NULL,
  COMP_SEQUENCE                NUMBER           DEFAULT 0                     NOT NULL,
  DOSE_SEQUENCE                NUMBER           DEFAULT 0                     NOT NULL,
  SCHEDULE_SEQUENCE            NUMBER           DEFAULT 0                     NOT NULL,
  STRENGTH_DOSE_VALUE          NUMBER           DEFAULT 0                     NOT NULL,
  STRENGTH_DOSE_VALUE_DISPLAY  VARCHAR2(100 BYTE),
  STRENGTH_DOSE_UNIT_CD        NUMBER           DEFAULT 0                     NOT NULL,
  VOLUME_DOSE_VALUE            NUMBER           DEFAULT 0                     NOT NULL,
  VOLUME_DOSE_VALUE_DISPLAY    VARCHAR2(100 BYTE),
  VOLUME_DOSE_UNIT_CD          NUMBER           DEFAULT 0                     NOT NULL,
  ORDERED_DOSE_VALUE           NUMBER           DEFAULT 0                     NOT NULL,
  ORDERED_DOSE_VALUE_DISPLAY   VARCHAR2(100 BYTE),
  ORDERED_DOSE_UNIT_CD         NUMBER           DEFAULT 0                     NOT NULL,
  ORDERED_DOSE_TYPE_FLAG       NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_INGREDIENT_HISTORY
(
  ORDER_INGREDIENT_HISTORY_ID  NUMBER           DEFAULT 0                     NOT NULL,
  ORDER_ID                     NUMBER           DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE              NUMBER           DEFAULT 0                     NOT NULL,
  COMP_SEQUENCE                NUMBER           DEFAULT 0                     NOT NULL,
  SYNONYM_ID                   NUMBER           DEFAULT 0                     NOT NULL,
  INGREDIENT_ALTER_FLAG        NUMBER           DEFAULT 0                     NOT NULL,
  INGREDIENT_ALTER_TRIGGER_CD  NUMBER           DEFAULT 0                     NOT NULL,
  FREETEXT_DOSE                VARCHAR2(100 BYTE),
  STRENGTH                     FLOAT(126),
  STRENGTH_UNIT_CD             NUMBER           DEFAULT 0                     NOT NULL,
  VOLUME                       FLOAT(126),
  VOLUME_UNIT_CD               NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_NOTIFICATION
(
  ORDER_NOTIFICATION_ID         NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_ID                      NUMBER          DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE               NUMBER          DEFAULT 0                     NOT NULL,
  PARENT_ORDER_NOTIFICATION_ID  NUMBER          DEFAULT 0                     NOT NULL,
  NOTIFICATION_TYPE_FLAG        NUMBER          DEFAULT 0                     NOT NULL,
  NOTIFICATION_DT_TM            DATE,
  FROM_PRSNL_ID                 NUMBER          DEFAULT 0                     NOT NULL,
  TO_PRSNL_ID                   NUMBER          DEFAULT 0                     NOT NULL,
  NOTIFICATION_COMMENT          VARCHAR2(255 BYTE),
  NOTIFICATION_REASON_CD        NUMBER          DEFAULT 0                     NOT NULL,
  NOTIFICATION_STATUS_FLAG      NUMBER          DEFAULT 0                     NOT NULL,
  STATUS_CHANGE_DT_TM           DATE,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  CAUSED_BY_FLAG                NUMBER          DEFAULT 0                     NOT NULL,
  NOTIFICATION_TZ               NUMBER          DEFAULT 0,
  STATUS_CHANGE_TZ              NUMBER          DEFAULT 0,
  NOTIFICATION_DISPLAY_TZ       NUMBER,
  NOTIFICATION_DISPLAY_DT_TM    DATE,
  TO_PRSNL_GROUP_ID             NUMBER          DEFAULT 0                     NOT NULL,
  FROM_PRSNL_GROUP_ID           NUMBER          DEFAULT 0,
  ASSIGNED_PRSNL_ID             NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_OPS
(
  ORDER_ID      NUMBER                          DEFAULT 0                     NOT NULL,
  OPS_FLAG      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0,
  UPDT_CNT      NUMBER                          DEFAULT 0,
  UPDT_TASK     NUMBER                          DEFAULT 0,
  UPDT_ID       NUMBER                          DEFAULT 0,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_ORDER_RELTN
(
  ORDER_ORDER_RELTN_ID     NUMBER               DEFAULT 0                     NOT NULL,
  RELATED_FROM_ORDER_ID    NUMBER               DEFAULT 0                     NOT NULL,
  RELATED_FROM_ACTION_SEQ  NUMBER               DEFAULT 0                     NOT NULL,
  RELATED_TO_ORDER_ID      NUMBER               DEFAULT 0                     NOT NULL,
  RELATION_TYPE_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ENTERED_BY_PRSNL_ID      NUMBER               DEFAULT 0                     NOT NULL,
  RELATION_CREATED_DT_TM   DATE                 DEFAULT SYSDATE               NOT NULL,
  RELATION_CREATED_TZ      NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_PRODUCT
(
  ITEM_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  ORDER_ID                        NUMBER        DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE                 NUMBER        DEFAULT 0                     NOT NULL,
  INGRED_SEQUENCE                 NUMBER        DEFAULT 0                     NOT NULL,
  TNF_ID                          NUMBER        DEFAULT 0                     NOT NULL,
  DOSE_QUANTITY                   FLOAT(126),
  DOSE_QUANTITY_UNIT_CD           NUMBER        DEFAULT 0                     NOT NULL,
  TOTAL_DISPENSE_QUANTITY         FLOAT(126),
  TOTAL_CHARGE_QUANTITY           FLOAT(126),
  TOTAL_CREDIT_QUANTITY           FLOAT(126),
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  IV_SEQ                          NUMBER,
  PACKAGE_TYPE_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  MED_PRODUCT_ID                  NUMBER        DEFAULT 0                     NOT NULL,
  IGNORE_IND                      NUMBER,
  COMPOUND_FLAG                   NUMBER,
  CMPD_BASE_IND                   NUMBER,
  PRODUCT_SEQ                     NUMBER,
  PARENT_PRODUCT_SEQ              NUMBER,
  LABEL_DESC                      VARCHAR2(100 BYTE),
  BRAND_DESC                      VARCHAR2(100 BYTE),
  GENERIC_DESC                    VARCHAR2(100 BYTE),
  DRUG_IDENTIFIER                 VARCHAR2(100 BYTE),
  DISP_QTY                        FLOAT(126),
  DISP_QTY_UNIT_CD                FLOAT(126)    DEFAULT 0                     NOT NULL,
  AUTO_ASSIGN_FLAG                NUMBER        DEFAULT 0                     NOT NULL,
  ON_ADMIN_IND                    NUMBER        DEFAULT 0                     NOT NULL,
  UNROUNDED_DOSE_QTY              FLOAT(126)    DEFAULT 0,
  VOLUME_WITH_OVERFILL_UNIT_CD    NUMBER        DEFAULT 0,
  STRENGTH_WITH_OVERFILL_VALUE    FLOAT(126)    DEFAULT 0,
  STRENGTH_WITH_OVERFILL_UNIT_CD  NUMBER        DEFAULT 0,
  VOLUME_WITH_OVERFILL_VALUE      FLOAT(126)    DEFAULT 0,
  DOSE_QUANTITY_TXT               VARCHAR2(150 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_PRODUCT_DOSE
(
  ORDER_PRODUCT_DOSE_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  ITEM_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  INGRED_SEQUENCE        NUMBER                 DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE        NUMBER                 DEFAULT 0                     NOT NULL,
  TNF_ID                 NUMBER                 DEFAULT 0                     NOT NULL,
  SCHEDULE_SEQ           NUMBER                 DEFAULT 0                     NOT NULL,
  DOSE_QUANTITY          FLOAT(126)             DEFAULT 0                     NOT NULL,
  DOSE_QUANTITY_UNIT_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  UNROUNDED_DOSE_QTY     FLOAT(126)             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT sysdate               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_PROPOSAL
(
  ORDER_PROPOSAL_ID              NUMBER         DEFAULT 0                     NOT NULL,
  ORDER_ID                       NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  PERSON_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  PROPOSAL_FROM_ACTION_SEQ       NUMBER         DEFAULT 0                     NOT NULL,
  PROPOSAL_TO_ACTION_SEQ         NUMBER         DEFAULT 0                     NOT NULL,
  PROPOSAL_STATUS_CD             NUMBER         DEFAULT 0                     NOT NULL,
  PROPOSAL_SOURCE_TYPE_CD        NUMBER         DEFAULT 0                     NOT NULL,
  PROPOSED_ACTION_TYPE_CD        NUMBER         DEFAULT 0                     NOT NULL,
  ENTERED_BY_PRSNL_ID            NUMBER         DEFAULT 0                     NOT NULL,
  RESPONSIBLE_PRSNL_ID           NUMBER         DEFAULT 0                     NOT NULL,
  CREATED_DT_TM                  DATE           DEFAULT SYSDATE               NOT NULL,
  CREATED_TZ                     NUMBER         DEFAULT 0                     NOT NULL,
  RESOLVED_BY_PRSNL_ID           NUMBER         DEFAULT 0                     NOT NULL,
  RESOLVED_DT_TM                 DATE,
  RESOLVED_TZ                    NUMBER,
  SYNONYM_ID                     NUMBER         DEFAULT 0                     NOT NULL,
  ORDERED_AS_MNEMONIC            VARCHAR2(1000 BYTE),
  ORDER_MNEMONIC                 VARCHAR2(1000 BYTE),
  CLINICAL_DISPLAY_LINE          VARCHAR2(2000 BYTE),
  SIMPLIFIED_DISPLAY_LINE        VARCHAR2(1000 BYTE),
  ORIG_ORD_AS_FLAG               NUMBER         DEFAULT 0                     NOT NULL,
  MED_ORDER_TYPE_CD              NUMBER         DEFAULT 0                     NOT NULL,
  PROJECTED_ORDER_ID             NUMBER         DEFAULT 0                     NOT NULL,
  PROPOSAL_GROUP_ID              NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  CATALOG_CD                     NUMBER         DEFAULT 0                     NOT NULL,
  OE_FORMAT_ID                   NUMBER         DEFAULT 0                     NOT NULL,
  HNA_ORDER_MNEMONIC             VARCHAR2(1000 BYTE),
  INCOMPLETE_PROPOSAL_BIT        NUMBER         DEFAULT 0,
  PROJECTED_CS_ORDER_ID          NUMBER         DEFAULT 0                     NOT NULL,
  IV_SET_SYNONYM_ID              NUMBER         DEFAULT 0,
  COMMUNICATION_TYPE_CD          NUMBER         DEFAULT 0,
  ORDER_SCHEDULE_PRECISION_BIT   NUMBER         DEFAULT 0,
  FUTURE_LOCATION_FACILITY_CD    NUMBER         DEFAULT 0,
  FUTURE_LOCATION_NURSE_UNIT_CD  NUMBER         DEFAULT 0,
  RELATED_ORDER_ID               NUMBER         DEFAULT 0,
  RELATED_ACTION_SEQ             NUMBER         DEFAULT 0,
  RELATED_TYPE_CD                NUMBER         DEFAULT 0,
  SUPERVISING_PROVIDER_ID        NUMBER         DEFAULT 0,
  BILLING_PROVIDER_FLAG          NUMBER         DEFAULT 0,
  ORDER_STATUS_REASON_BIT        NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_PROPOSAL_ADHOC_TIME
(
  ORDER_PROPOSAL_ADHOC_TIME_ID  NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_PROPOSAL_ID             NUMBER          DEFAULT 0                     NOT NULL,
  ADHOC_TIME_SEQUENCE           NUMBER          DEFAULT 0                     NOT NULL,
  TIME_OF_DAY                   NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_PROPOSAL_COMMENT
(
  ORDER_PROPOSAL_COMMENT_ID  NUMBER             DEFAULT 0                     NOT NULL,
  ORDER_PROPOSAL_ID          NUMBER             DEFAULT 0                     NOT NULL,
  COMMENT_TYPE_CD            NUMBER             DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_PROPOSAL_DETAIL
(
  ORDER_PROPOSAL_DETAIL_ID  NUMBER              DEFAULT 0                     NOT NULL,
  ORDER_PROPOSAL_ID         NUMBER              DEFAULT 0                     NOT NULL,
  DETAIL_SEQUENCE           NUMBER              DEFAULT 0                     NOT NULL,
  OE_FIELD_ID               NUMBER              DEFAULT 0                     NOT NULL,
  OE_FIELD_MEANING          VARCHAR2(25 BYTE),
  OE_FIELD_MEANING_ID       NUMBER              DEFAULT 0                     NOT NULL,
  OE_FIELD_DISPLAY_VALUE    VARCHAR2(255 BYTE),
  OE_FIELD_DT_TM_VALUE      DATE,
  OE_FIELD_TZ               NUMBER,
  OE_FIELD_VALUE            NUMBER,
  DETAIL_ALTER_FLAG         NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  DETAIL_DEFAULT_VALUE      VARCHAR2(255 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_PROPOSAL_DETAIL_HST
(
  ORDER_PROPOSAL_DETAIL_HST_ID  NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_PROPOSAL_DETAIL_ID      NUMBER          DEFAULT 0                     NOT NULL,
  OE_FIELD_DISPLAY_VALUE        VARCHAR2(255 BYTE),
  OE_FIELD_DT_TM_VALUE          DATE,
  OE_FIELD_TZ                   NUMBER,
  OE_FIELD_VALUE                NUMBER,
  DETAIL_ALTER_TRIGGER_CD       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_PROPOSAL_DIAG_RELTN
(
  ORDER_PROPOSAL_DIAG_RELTN_ID  NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_PROPOSAL_ID             NUMBER          DEFAULT 0                     NOT NULL,
  DIAGNOSIS_ID                  NUMBER          DEFAULT 0                     NOT NULL,
  RANK_SEQUENCE                 NUMBER          DEFAULT 0                     NOT NULL,
  DIAGNOSIS_ALTER_FLAG          NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_PROPOSAL_INGREDIENT
(
  ORDER_PROPOSAL_INGREDIENT_ID  NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_PROPOSAL_ID             NUMBER          DEFAULT 0                     NOT NULL,
  COMP_SEQUENCE                 NUMBER          DEFAULT 0                     NOT NULL,
  SYNONYM_ID                    NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_MNEMONIC                VARCHAR2(255 BYTE),
  ORDERED_AS_MNEMONIC           VARCHAR2(255 BYTE),
  INGREDIENT_DISPLAY_LINE       VARCHAR2(255 BYTE),
  STRENGTH                      FLOAT(126),
  STRENGTH_UNIT_CD              NUMBER          DEFAULT 0                     NOT NULL,
  VOLUME                        FLOAT(126),
  VOLUME_UNIT_CD                NUMBER          DEFAULT 0                     NOT NULL,
  FREETEXT_DOSE                 VARCHAR2(255 BYTE),
  INGREDIENT_TYPE_FLAG          NUMBER,
  CLINICALLY_SIGNIFICANT_FLAG   NUMBER          DEFAULT 0                     NOT NULL,
  INGREDIENT_SOURCE_FLAG        NUMBER          DEFAULT 0                     NOT NULL,
  INGREDIENT_ALTER_FLAG         NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  CATALOG_CD                    NUMBER          DEFAULT 0                     NOT NULL,
  CONCENTRATION_UNIT_CD         NUMBER          DEFAULT 0,
  CONCENTRATION                 FLOAT(126)      DEFAULT 0,
  NORMALIZED_RATE_UNIT_CD       NUMBER          DEFAULT 0,
  NORMALIZED_RATE               FLOAT(126)      DEFAULT 0,
  INCLUDE_IN_TOTAL_VOLUME_FLAG  NUMBER          DEFAULT 0,
  BAG_FREQUENCY_CD              NUMBER          DEFAULT 0,
  DOSE_CALCULATOR_LONG_TEXT_ID  NUMBER          DEFAULT 0,
  ORDERED_DOSE_UNIT_CD          NUMBER          DEFAULT 0,
  ORDERED_DOSE                  FLOAT(126)      DEFAULT 0,
  DOSE_ADJUSTMENT_DISPLAY       VARCHAR2(255 BYTE) DEFAULT ' '
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_PROPOSAL_INGRED_HST
(
  ORDER_PROPOSAL_INGRED_HST_ID  NUMBER          DEFAULT 0                     NOT NULL,
  ORDER_PROPOSAL_INGREDIENT_ID  NUMBER          DEFAULT 0                     NOT NULL,
  SYNONYM_ID                    NUMBER          DEFAULT 0                     NOT NULL,
  INGREDIENT_ALTER_TRIGGER_CD   NUMBER          DEFAULT 0                     NOT NULL,
  FREETEXT_DOSE                 VARCHAR2(255 BYTE),
  STRENGTH                      FLOAT(126),
  STRENGTH_UNIT_CD              NUMBER          DEFAULT 0                     NOT NULL,
  VOLUME                        FLOAT(126),
  VOLUME_UNIT_CD                NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_PROPOSAL_NOTIF
(
  ORDER_PROPOSAL_NOTIF_ID      NUMBER           DEFAULT 0                     NOT NULL,
  ORDER_PROPOSAL_ID            NUMBER           DEFAULT 0                     NOT NULL,
  PARENT_OP_NOTIFICATION_ID    NUMBER           DEFAULT 0                     NOT NULL,
  FROM_PRSNL_ID                NUMBER           DEFAULT 0                     NOT NULL,
  TO_PRSNL_ID                  NUMBER           DEFAULT 0                     NOT NULL,
  ASSIGNED_PRSNL_ID            NUMBER           DEFAULT 0                     NOT NULL,
  TO_PRSNL_GROUP_ID            NUMBER           DEFAULT 0                     NOT NULL,
  FROM_PRSNL_GROUP_ID          NUMBER           DEFAULT 0                     NOT NULL,
  NOTIFICATION_TYPE_FLAG       NUMBER           DEFAULT 0                     NOT NULL,
  NOTIFICATION_STATUS_FLAG     NUMBER           DEFAULT 0                     NOT NULL,
  NOTIFICATION_ORIGIN_FLAG     NUMBER           DEFAULT 0                     NOT NULL,
  NOTIFICATION_CREATED_DT_TM   DATE             DEFAULT SYSDATE               NOT NULL,
  NOTIFICATION_CREATED_TZ      NUMBER,
  NOTIFICATION_RESOLVED_DT_TM  DATE,
  NOTIFICATION_RESOLVED_TZ     NUMBER,
  NOTIFICATION_COMMENT         VARCHAR2(1000 BYTE),
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_PROPOSAL_THER_SBSTTN
(
  ORDER_PROPOSAL_THER_SBSTTN_ID  NUMBER         DEFAULT 0                     NOT NULL,
  ORDER_PROPOSAL_ID              NUMBER         DEFAULT 0                     NOT NULL,
  THERAP_SBSTTN_ID               NUMBER         DEFAULT 0                     NOT NULL,
  SUBSTITUTION_ACCEPT_FLAG       NUMBER         DEFAULT 0                     NOT NULL,
  OVERRIDE_REASON_CD             NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  COMP_SEQUENCE                  NUMBER         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_RADIOLOGY
(
  ORDER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ACCESSION_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ACCESSION               VARCHAR2(20 BYTE),
  CATALOG_CD              NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  COMMENTS                VARCHAR2(255 BYTE),
  REPORT_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  EXAM_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  PACKET_ROUTING_CD       NUMBER                DEFAULT 0                     NOT NULL,
  ORD_LOC_CD              NUMBER                DEFAULT 0                     NOT NULL,
  REFER_LOC_CD            NUMBER                DEFAULT 0                     NOT NULL,
  CANCEL_DT_TM            DATE,
  CANCEL_BY_ID            NUMBER                DEFAULT 0                     NOT NULL,
  REQUEST_DT_TM           DATE,
  SEQ_EXAM_ID             NUMBER                DEFAULT 0                     NOT NULL,
  REMOVED_DT_TM           DATE,
  REMOVED_BY_ID           NUMBER                DEFAULT 0                     NOT NULL,
  REMOVED_CD              NUMBER                DEFAULT 0                     NOT NULL,
  PULL_LIST_ID            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  START_DT_TM             DATE,
  COMPLETE_DT_TM          DATE,
  REASON_FOR_EXAM         VARCHAR2(255 BYTE),
  ORDER_PHYSICIAN_ID      NUMBER                DEFAULT 0                     NOT NULL,
  RESTORED_IND            NUMBER                DEFAULT 0,
  PRIORITY_CD             NUMBER                DEFAULT 0                     NOT NULL,
  TRANS_WORKGROUP_CD      NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ORDER_ID         NUMBER                DEFAULT 0                     NOT NULL,
  GROUP_REFERENCE_NBR     VARCHAR2(40 BYTE),
  GROUP_EVENT_ID          NUMBER                DEFAULT 0                     NOT NULL,
  RAD_PACS_ID             NUMBER                DEFAULT 0                     NOT NULL,
  REPLACED_ORDER_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ACC_ADD_ON_IND          NUMBER                DEFAULT 0                     NOT NULL,
  REQUESTED_TZ            NUMBER                DEFAULT 0,
  CANCEL_TZ               NUMBER                DEFAULT 0,
  START_TZ                NUMBER                DEFAULT 0,
  COMPLETE_TZ             NUMBER                DEFAULT 0,
  REPORTING_PRIORITY_CD   NUMBER                DEFAULT 0                     NOT NULL,
  VETTING_PRSNL_ID        NUMBER                DEFAULT 0                     NOT NULL,
  VETTING_STATUS_FLAG     NUMBER                DEFAULT 0,
  VETTING_TZ              NUMBER,
  VETTING_DT_TM           DATE,
  PROTOCOL_REQ_IND        NUMBER                DEFAULT 0,
  HIDE_PRELIM_REPORT_IND  NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_RECON
(
  ORDER_RECON_ID      NUMBER                    DEFAULT 0                     NOT NULL,
  ENCNTR_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  RECON_TYPE_FLAG     NUMBER                    DEFAULT 0                     NOT NULL,
  PERFORMED_PRSNL_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  PERFORMED_DT_TM     DATE                      DEFAULT SYSDATE               NOT NULL,
  PERFORMED_TZ        NUMBER                    DEFAULT 0                     NOT NULL,
  NO_KNOWN_MEDS_IND   NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  RECON_STATUS_CD     NUMBER                    DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_RECON_DETAIL
(
  ORDER_RECON_DETAIL_ID    NUMBER               DEFAULT 0                     NOT NULL,
  ORDER_RECON_ID           NUMBER               DEFAULT 0                     NOT NULL,
  CLINICAL_DISPLAY_LINE    VARCHAR2(2000 BYTE)  DEFAULT ' '                   NOT NULL,
  CONTINUE_ORDER_IND       NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  ORDER_NBR                FLOAT(126)           DEFAULT 0                     NOT NULL,
  RECON_ORDER_ACTION_MEAN  VARCHAR2(20 BYTE)    DEFAULT ' '                   NOT NULL,
  ORDER_MNEMONIC           VARCHAR2(1000 BYTE),
  SIMPLIFIED_DISPLAY_LINE  VARCHAR2(1000 BYTE),
  ORDER_PROPOSAL_ID        NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_REVIEW
(
  ORDER_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE          NUMBER               DEFAULT 0                     NOT NULL,
  REVIEW_SEQUENCE          NUMBER               DEFAULT 0                     NOT NULL,
  REVIEW_TYPE_FLAG         NUMBER,
  REVIEW_REQD_IND          NUMBER,
  PROVIDER_ID              NUMBER               DEFAULT 0                     NOT NULL,
  LOCATION_CD              NUMBER               DEFAULT 0                     NOT NULL,
  DEPT_CD                  NUMBER               DEFAULT 0                     NOT NULL,
  REVIEWED_STATUS_FLAG     NUMBER,
  REVIEW_PERSONNEL_ID      NUMBER               DEFAULT 0                     NOT NULL,
  REVIEW_DT_TM             DATE,
  PROXY_PERSONNEL_ID       NUMBER               DEFAULT 0                     NOT NULL,
  PROXY_REASON_CD          NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  REJECT_REASON_CD         NUMBER               DEFAULT 0                     NOT NULL,
  REVIEW_TZ                NUMBER               DEFAULT 0,
  DIGITAL_SIGNATURE_IDENT  VARCHAR2(64 BYTE),
  REVIEW_GRP_VALUE         NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_REVIEW_DECISION
(
  ORDER_REVIEW_DECISION_ID  NUMBER              DEFAULT 0                     NOT NULL,
  ORDER_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE           NUMBER              DEFAULT 0                     NOT NULL,
  DECISION_SEQUENCE         NUMBER              DEFAULT 0                     NOT NULL,
  REVIEW_TYPE_FLAG          NUMBER              DEFAULT 0                     NOT NULL,
  DECISION_SOURCE_FLAG      NUMBER              DEFAULT 0                     NOT NULL,
  DECISION_VALUE_FLAG       NUMBER              DEFAULT 0                     NOT NULL,
  DECISION_REASON_CD        NUMBER              DEFAULT 0                     NOT NULL,
  DECIDING_PRSNL_ID         NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_RX_SCRATCHPAD
(
  ORDER_RX_SCRATCHPAD_ID       NUMBER           DEFAULT 0                     NOT NULL,
  ORDER_ID                     NUMBER           DEFAULT 0                     NOT NULL,
  PERSON_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  ORDER_ENTRY_PRSNL_ID         NUMBER           DEFAULT 0                     NOT NULL,
  RESPONSIBLE_PROVIDER_ID      NUMBER           DEFAULT 0                     NOT NULL,
  CATALOG_CD                   NUMBER           DEFAULT 0                     NOT NULL,
  SYNONYM_ID                   NUMBER           DEFAULT 0                     NOT NULL,
  ORDERED_AS_MNEMONIC          VARCHAR2(1024 BYTE),
  DOSE                         FLOAT(126)       DEFAULT 0                     NOT NULL,
  DOSE_UNIT_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  FREETEXT_DOSE                VARCHAR2(1024 BYTE),
  ROUTE_OF_ADMINISTRATION_CD   NUMBER           DEFAULT 0                     NOT NULL,
  FREQUENCY_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  ROUTING_TYPE_FLAG            NUMBER,
  NUMBER_OF_REFILLS            NUMBER           DEFAULT 0                     NOT NULL,
  SAMPLE_QUANTITY              FLOAT(126)       DEFAULT 0                     NOT NULL,
  SAMPLE_QUANTITY_UNIT_CD      NUMBER           DEFAULT 0                     NOT NULL,
  DISPENSE_QUANTITY            FLOAT(126)       DEFAULT 0                     NOT NULL,
  DISPENSE_QUANTITY_UNIT_CD    NUMBER           DEFAULT 0                     NOT NULL,
  DURATION                     NUMBER           DEFAULT 0                     NOT NULL,
  DURATION_UNIT_CD             NUMBER           DEFAULT 0                     NOT NULL,
  STOP_TYPE_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  INCLUDE_DEA_NUMBER_IND       NUMBER           DEFAULT 0                     NOT NULL,
  DISPENSE_AS_WRITTEN_IND      NUMBER           DEFAULT 0                     NOT NULL,
  RENEWED_FROM_ORDER_ID        NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER           DEFAULT 0                     NOT NULL,
  SPECIAL_INSTRUCTIONS         VARCHAR2(1024 BYTE),
  PRN_INSTRUCTIONS             VARCHAR2(1024 BYTE),
  COMMENT_LONG_TEXT_ID         NUMBER           DEFAULT 0                     NOT NULL,
  PRN_IND                      NUMBER           DEFAULT 0                     NOT NULL,
  DOCUMENTED_IND               NUMBER           DEFAULT 0                     NOT NULL,
  NO_REQUIRED_DETAILS_IND      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  START_DT_TM                  DATE,
  STOP_DT_TM                   DATE,
  REQUISITION_ROUTING_CD       NUMBER           DEFAULT 0                     NOT NULL,
  ROUTING_PHARMACY_IDENTIFIER  VARCHAR2(100 BYTE),
  SUPERVISING_PROVIDER_ID      NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_SCHEDULE_EXCEPTION
(
  ORDER_SCHEDULE_EXCEPTION_ID     NUMBER        DEFAULT 0                     NOT NULL,
  ORDER_ID                        NUMBER        DEFAULT 0                     NOT NULL,
  ORDER_ACTION_SEQUENCE           NUMBER        DEFAULT 0                     NOT NULL,
  SCHEDULE_EXCEPTION_TYPE_CD      NUMBER        DEFAULT 0                     NOT NULL,
  ORIG_INSTANCE_DT_TM             DATE,
  ORIG_INSTANCE_TZ                NUMBER,
  NEW_INSTANCE_DT_TM              DATE,
  NEW_INSTANCE_TZ                 NUMBER,
  INACTIVE_ORDER_ACTION_SEQUENCE  NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_SERV_RES_CONTAINER
(
  SERVICE_RESOURCE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  ORDER_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  CONTAINER_ID         NUMBER                   DEFAULT 0                     NOT NULL,
  LOCATION_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  STATUS_FLAG          NUMBER,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  IN_LAB_DT_TM         DATE,
  CURRENT_LOCATION_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  AV_IND               NUMBER                   DEFAULT 0                     NOT NULL,
  ALERT_DT_TM          DATE,
  DISPLAY_DT_TM        DATE,
  WARNING_DT_TM        DATE,
  SPEC_WARNING_DT_TM   DATE,
  SPEC_EXPIRE_DT_TM    DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_THERAP_SBSTTN
(
  ORDER_THERAP_SBSTTN_ID    NUMBER              DEFAULT 0                     NOT NULL,
  ORDER_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE           NUMBER              DEFAULT 0                     NOT NULL,
  COMP_SEQUENCE             NUMBER              DEFAULT 0                     NOT NULL,
  THERAP_SBSTTN_ID          NUMBER              DEFAULT 0                     NOT NULL,
  SUBSTITUTION_ACCEPT_FLAG  NUMBER              DEFAULT 0                     NOT NULL,
  OVERRIDE_REASON_CD        NUMBER              DEFAULT 0                     NOT NULL,
  ITEM_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_THERMOCYCLER_RACK
(
  ORDER_ID      NUMBER                          DEFAULT 0                     NOT NULL,
  RACK_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_ID       NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM    DATE                            DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK     NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_CNT      NUMBER                          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX  NUMBER                          DEFAULT 0                     NOT NULL,
  GEL_BATCH_ID  NUMBER                          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORDER_WARNING
(
  ORDER_WARNING_ID          NUMBER              DEFAULT 0                     NOT NULL,
  ORDER_ID                  NUMBER              DEFAULT 0                     NOT NULL,
  RESOLVED_ACTION_SEQUENCE  NUMBER              DEFAULT 0                     NOT NULL,
  WARNING_LEVEL_FLAG        NUMBER              DEFAULT 0                     NOT NULL,
  WARNING_TYPE_FLAG         NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORD_ENTITY_RELTN
(
  ORD_ENTITY_RELTN_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  ORDER_ID             NUMBER                   DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME   VARCHAR2(32 BYTE)        DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID     NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORD_FAVORITE_DEST
(
  ORD_FAVORITE_DEST_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  OUTPUT_DEST_ID        NUMBER                  DEFAULT 0                     NOT NULL,
  PRSNL_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  FAVORITE_DEST_SEQ     NUMBER                  DEFAULT 0                     NOT NULL,
  DEST_TXT              VARCHAR2(100 BYTE),
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORD_RQSTN
(
  ORD_RQSTN_ID            NUMBER                DEFAULT 0                     NOT NULL,
  RQSTN_ASSIGNMENT_IDENT  VARCHAR2(16 BYTE)     DEFAULT ' '                   NOT NULL,
  CLIENT_ALIAS_NAME       VARCHAR2(6 BYTE)      DEFAULT ' '                   NOT NULL,
  SEQ_NBR                 FLOAT(126)            DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORD_RQSTN_ORD_R
(
  ORD_RQSTN_ORD_R_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  ORD_RQSTN_ID        NUMBER                    DEFAULT 0                     NOT NULL,
  ORDER_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORGANIZATION
(
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  ORG_NAME                VARCHAR2(100 BYTE)    DEFAULT ' '                   NOT NULL,
  ORG_NAME_KEY            VARCHAR2(100 BYTE),
  FEDERAL_TAX_ID_NBR      VARCHAR2(100 BYTE),
  ORG_STATUS_CD           NUMBER                DEFAULT 0                     NOT NULL,
  FT_ENTITY_ID            NUMBER                DEFAULT 0                     NOT NULL,
  FT_ENTITY_NAME          VARCHAR2(32 BYTE),
  ORG_CLASS_CD            NUMBER                DEFAULT 0                     NOT NULL,
  ORG_NAME_KEY_NLS        VARCHAR2(202 BYTE),
  CONTRIBUTOR_SOURCE_CD   NUMBER                DEFAULT 0,
  LOGICAL_DOMAIN_ID       NUMBER                DEFAULT 0,
  ORG_NAME_KEY_A_NLS      VARCHAR2(400 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORGANIZATION_ALIAS
(
  ORGANIZATION_ALIAS_ID   NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ALIAS_POOL_CD           NUMBER                DEFAULT 0                     NOT NULL,
  ORG_ALIAS_TYPE_CD       NUMBER                DEFAULT 0                     NOT NULL,
  ALIAS                   VARCHAR2(100 BYTE),
  ORG_ALIAS_SUB_TYPE_CD   NUMBER                DEFAULT 0                     NOT NULL,
  CHECK_DIGIT             NUMBER,
  CHECK_DIGIT_METHOD_CD   NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  ALIAS_KEY_NLS           VARCHAR2(202 BYTE),
  ALIAS_KEY               VARCHAR2(100 BYTE),
  ALIAS_KEY_A_NLS         VARCHAR2(400 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORGANIZATION_RESOURCE
(
  ORG_RES_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(25 BYTE),
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ORG_RESOURCE_TYPE_CD    NUMBER                DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  REF_LAB_IND             NUMBER,
  REF_LAB_DESCRIPTION     VARCHAR2(100 BYTE),
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_ALIAS_POOL_RELTN
(
  ORGANIZATION_ID             NUMBER            DEFAULT 0                     NOT NULL,
  ALIAS_ENTITY_NAME           VARCHAR2(32 BYTE) DEFAULT ' ' NOT NULL,
  ALIAS_ENTITY_ALIAS_TYPE_CD  NUMBER            DEFAULT 0                     NOT NULL,
  ALIAS_POOL_CD               NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM         DATE              DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM         DATE              DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  AUTO_ASSIGN_FLAG            NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_BARCODE_FORMAT
(
  ORG_BARCODE_FORMAT_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  BARCODE_TYPE_CD        NUMBER                 DEFAULT 0                     NOT NULL,
  PREFIX                 VARCHAR2(255 BYTE)     DEFAULT ' '                   NOT NULL,
  CHECK_DIGIT_IND        NUMBER                 DEFAULT 0                     NOT NULL,
  Z_DATA                 VARCHAR2(255 BYTE)     DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_NAME     VARCHAR2(32 BYTE)      DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  ALIAS_TYPE_CD          NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_BARCODE_ORG
(
  ORG_BARCODE_SEQ_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  SCAN_ORGANIZATION_ID   NUMBER                 DEFAULT 0                     NOT NULL,
  BARCODE_TYPE_CD        NUMBER                 DEFAULT 0                     NOT NULL,
  LABEL_ORGANIZATION_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_BNFT_SET_R
(
  ORG_BNFT_SET_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  HP_BNFT_SET_ID          NUMBER                DEFAULT 0                     NOT NULL,
  DESCRIPTION             VARCHAR2(200 BYTE),
  COVERAGE_STATUS_CD      NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_CMB
(
  ORG_CMB_ID              NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  FROM_ORG_ID             NUMBER                DEFAULT 0                     NOT NULL,
  TO_ORG_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  COMBINE_ACTION_CD       NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_CMB_DET
(
  ORG_CMB_DET_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ORG_CMB_ID              NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ENTITY_NAME             VARCHAR2(32 BYTE)     DEFAULT ' '                   NOT NULL,
  ENTITY_ID               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_CONTRIBUTOR_SYS_RELTN
(
  ORG_CONTRIBUTOR_SYS_RELTN_ID  NUMBER          DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID               NUMBER          DEFAULT 0                     NOT NULL,
  RELTN_TYPE_CD                 NUMBER          DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD         NUMBER          DEFAULT 0                     NOT NULL,
  ACTIVE_IND                    NUMBER          DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM           DATE            DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM           DATE            DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  AUTHORIZATION_TYPE_CD         NUMBER          DEFAULT 0,
  DOMAIN_ADDR                   VARCHAR2(255 BYTE) DEFAULT ' '
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_EVENT_SET_RELTN
(
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  EVENT_SET_NAME          VARCHAR2(40 BYTE)     DEFAULT ' '                   NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_GROUP
(
  ORG_GROUP_ID            NUMBER                DEFAULT 0                     NOT NULL,
  CHILD_ORG_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ORG_GROUP_CD            NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ORG_ID           NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_GROUP_RELTN
(
  ORG_GROUP_R_ID          NUMBER                DEFAULT 0                     NOT NULL,
  BT_COND_CRIT_R_ID       NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ORG_TYPE_CD             NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_INFO
(
  ORG_INFO_ID             NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  INFO_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  INFO_SUB_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_NUMERIC           NUMBER,
  VALUE_DT_TM             DATE,
  CHARTABLE_IND           NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_CD                NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_NTWK_PRVDR
(
  ORG_NTWK_PRVDR_ID       NUMBER                DEFAULT 0                     NOT NULL,
  NETWORK_ID              NUMBER                DEFAULT 0,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  SPECIALTY_CD            NUMBER                DEFAULT 0,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_ORG_RELTN
(
  ORG_ORG_RELTN_ID        NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ORG_ORG_RELTN_CD        NUMBER                DEFAULT 0                     NOT NULL,
  RELATED_ORG_ID          NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  COMMENT_TEXT            LONG,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_PLAN_RELTN
(
  ORG_PLAN_RELTN_ID       NUMBER                DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID          NUMBER                DEFAULT 0                     NOT NULL,
  ORG_PLAN_RELTN_CD       NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  GROUP_NBR               VARCHAR2(100 BYTE),
  GROUP_NAME              VARCHAR2(200 BYTE),
  CONTRACT_CODE           VARCHAR2(100 BYTE),
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  POLICY_NBR              VARCHAR2(100 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_SET_ORG_R
(
  ORG_SET_ID              NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  ORG_SET_ORG_R_ID        NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_SET_PRSNL_R
(
  ORG_SET_PRSNL_R_ID      NUMBER                DEFAULT 0                     NOT NULL,
  ORG_SET_ID              NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ORG_SET_TYPE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_SHIPMENT
(
  ORG_SHIPMENT_ID              NUMBER           DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID              NUMBER           DEFAULT 0                     NOT NULL,
  OWNER_AREA_CD                NUMBER           DEFAULT 0                     NOT NULL,
  INVENTORY_AREA_CD            NUMBER           DEFAULT 0                     NOT NULL,
  DESTROY_ONCE_EXPIRED_IND     NUMBER           DEFAULT 0                     NOT NULL,
  ACCEPT_QUARANTINED_PROD_IND  NUMBER           DEFAULT 0                     NOT NULL,
  REQ_TESTING_COMPLETE_IND     NUMBER           DEFAULT 0                     NOT NULL,
  ACCEPT_POS_RESULT_IND        NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  ACCEPT_EXPIRED_PROD_IND      NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_TRANS_IDENT
(
  ORG_TRANS_IDENT_ID   NUMBER                   DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  TRANSACTION_TYPE_CD  NUMBER                   DEFAULT 0                     NOT NULL,
  ORG_SUBMITTER_IDENT  VARCHAR2(15 BYTE)        DEFAULT ' '                   NOT NULL,
  ORG_USERNAME         VARCHAR2(15 BYTE)        DEFAULT ' '                   NOT NULL,
  ORG_PASSKEY          VARCHAR2(15 BYTE)        DEFAULT ' '                   NOT NULL,
  LOGICAL_DOMAIN_ID    NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_TRANS_PAYER_RELTN
(
  ORG_TRANS_PAYER_RELTN_ID  NUMBER              DEFAULT 0                     NOT NULL,
  ORG_TRANS_IDENT_ID        NUMBER              DEFAULT 0                     NOT NULL,
  PAYER_ORG_ID              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORG_TYPE_RELTN
(
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ORG_TYPE_CD             NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORM_ERROR_LOG
(
  ORM_ERROR_LOG_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_CONVERSATION_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  SYNONYM_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  ORDERED_AS_MNEMONIC    VARCHAR2(255 BYTE),
  ACTION_TYPE_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  ENCNTR_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  PRSNL_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_PROVIDER_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  COMMUNICATION_TYPE_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  REQUESTED_START_DT_TM  DATE,
  INGREDIENT_MNEMONICS   VARCHAR2(2000 BYTE),
  ACTION_DT_TM           DATE                   DEFAULT sysdate               NOT NULL,
  CLIENT_NODE_NAME       VARCHAR2(255 BYTE)     DEFAULT ' '                   NOT NULL,
  TASK_NUMBER            NUMBER                 DEFAULT 0                     NOT NULL,
  REQUEST_NUMBER         NUMBER                 DEFAULT 0                     NOT NULL,
  REQUEST_LONG_BLOB_ID   NUMBER                 DEFAULT 0                     NOT NULL,
  ERROR_STRING           VARCHAR2(1000 BYTE),
  ERROR_NBR              NUMBER                 DEFAULT 0,
  ERROR_SPECIFIC_STRING  VARCHAR2(1000 BYTE),
  ERROR_SPECIFIC_NBR     NUMBER                 DEFAULT 0,
  USERNAME               VARCHAR2(50 BYTE)      DEFAULT ' '                   NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  USER_TYPE_FLAG         NUMBER                 DEFAULT 0,
  APPLICATION_NUMBER     NUMBER                 DEFAULT 0,
  REQ_INDEX              NUMBER                 DEFAULT 0,
  ACTION_STATUS_FLAG     NUMBER                 DEFAULT 0,
  REQUESTED_START_TZ     NUMBER                 DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE ORM_ERX_ACTIVITY_LOG
(
  ORM_ERX_ACTIVITY_LOG_ID  NUMBER               DEFAULT 0                     NOT NULL,
  ORDER_ID                 NUMBER               DEFAULT 0                     NOT NULL,
  REQ_ROUTING_TYPE_FLAG    NUMBER               DEFAULT 0                     NOT NULL,
  FB_DETAIL_VIEWED_IND     NUMBER               DEFAULT 0                     NOT NULL,
  FB_BENEFIT_SET_UID_TXT   VARCHAR2(255 BYTE)   DEFAULT ' '                   NOT NULL,
  FB_FORMULARY_STATUS      NUMBER,
  FB_COPAY_FIXED_AMT       FLOAT(126),
  FB_COPAY_PCT_NBR         FLOAT(126),
  FB_COPAY_MTHD_TXT        VARCHAR2(20 BYTE),
  FB_COPAY_TIER_NBR        NUMBER,
  FB_AGE_LIMIT_IND         NUMBER,
  FB_PROD_EXC_IND          NUMBER,
  FB_GENDER_LIMIT_IND      NUMBER,
  FB_MED_NECESSITY_IND     NUMBER,
  FB_PRIOR_AUTH_IND        NUMBER,
  FB_QTY_LIMIT_IND         NUMBER,
  FB_RSRC_DRUG_IND         NUMBER,
  FB_RSRC_SMRY_IND         NUMBER,
  FB_STEP_MEDS_IND         NUMBER,
  FB_STEP_THERAPY_IND      NUMBER,
  FB_TXT_MSG_IND           NUMBER,
  ACTIVE_IND               NUMBER               DEFAULT 1                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  FB_BENEFIT_SET_ID        NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OSM_CLIENT_DEFAULTS
(
  ORGANIZATION_ID               NUMBER          DEFAULT 0                     NOT NULL,
  ALIAS_TYPE_CD                 NUMBER          DEFAULT 0                     NOT NULL,
  ALIAS_POOL_CD                 NUMBER          DEFAULT 0                     NOT NULL,
  FLEX_REG_IND                  NUMBER          DEFAULT 0,
  PATIENT_ALIAS_FLAG            NUMBER          DEFAULT 0,
  FINANCIAL_CLASS_FLAG          NUMBER          DEFAULT 0,
  ENCOUNTER_TYPE_FLAG           NUMBER          DEFAULT 0,
  VETERNARY_IND                 NUMBER          DEFAULT 0,
  PATIENT_BILL_ENCNTR_TYPE_CD   NUMBER          DEFAULT 0                     NOT NULL,
  CLIENT_BILL_ENCNTR_TYPE_CD    NUMBER          DEFAULT 0                     NOT NULL,
  SEARCH_START_FLAG             NUMBER          DEFAULT 0,
  BILL_TYPE_IND                 NUMBER          DEFAULT 0,
  FINANCIAL_CLASS_CD            NUMBER          DEFAULT 0                     NOT NULL,
  NEW_REG_FLAG                  NUMBER          DEFAULT 0,
  PROCEDURE_VIEW_FLAG           NUMBER          DEFAULT 0,
  CURTIME_IND                   NUMBER          DEFAULT 0,
  COLLECT_BY_PERSON_ID          NUMBER          DEFAULT 0                     NOT NULL,
  ADMITTING_PHYS_ID             NUMBER          DEFAULT 0                     NOT NULL,
  PHONE_TYPE_CD                 NUMBER          DEFAULT 0                     NOT NULL,
  RPT_PRIORITY_CD               NUMBER          DEFAULT 0                     NOT NULL,
  BILL_TYPE_FLAG                NUMBER          DEFAULT 0,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  CLIENT_BILL_FIN_CLASS_CD      NUMBER          DEFAULT 0                     NOT NULL,
  COLLECTION_PRIORITY_CD        NUMBER          DEFAULT 0                     NOT NULL,
  FLEX_REG_FLAG                 NUMBER          DEFAULT 0,
  LOCATION_FLAG                 NUMBER          DEFAULT 0,
  PATIENT_BILL_FIN_CLASS_CD     NUMBER          DEFAULT 0                     NOT NULL,
  COLLECT_BY_USER_IND           NUMBER          DEFAULT 0,
  CURDATE_IND                   NUMBER          DEFAULT 0,
  FINANCIAL_NUMBER_OPTION_FLAG  NUMBER          DEFAULT 0,
  MRN_OPTION_FLAG               NUMBER          DEFAULT 0,
  NEW_MRN_FLAG                  NUMBER          DEFAULT 0,
  PRI_INS_SUB_HP_FLAG           NUMBER,
  PRI_SPONSOR_FLAG              NUMBER,
  CMRN_OPTION_FLAG              NUMBER          DEFAULT 0,
  PROV_HLTH_NBR_FLAG            NUMBER          DEFAULT 0,
  SUB_MEMBER_NBR_FLAG           NUMBER          DEFAULT 4
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OSM_DEFAULTS
(
  LAB_ORG_ID                 NUMBER             DEFAULT 0                     NOT NULL,
  SSN_FLAG                   NUMBER             DEFAULT 0,
  FIRST_NAME_FLAG            NUMBER             DEFAULT 0,
  MIDDLE_NAME_FLAG           NUMBER             DEFAULT 0,
  SEX_FLAG                   NUMBER             DEFAULT 0,
  RACE_FLAG                  NUMBER             DEFAULT 0,
  BIRTH_DATE_FLAG            NUMBER             DEFAULT 0,
  BIRTH_TIME_FLAG            NUMBER             DEFAULT 0,
  AGE_FLAG                   NUMBER             DEFAULT 0,
  PHONE_FLAG                 NUMBER             DEFAULT 0,
  ORDER_COMMENT_FLAG         NUMBER             DEFAULT 0,
  REQUISITION_IND            NUMBER             DEFAULT 0,
  PHYS_ORG_FILTER_IND        NUMBER             DEFAULT 0,
  REG_CONTRIBUTOR_SYSTEM_CD  NUMBER             DEFAULT 0                     NOT NULL,
  ORDER_DONOR_PRODUCT_IND    NUMBER             DEFAULT 0,
  FINANCIAL_NUMBER_FLAG      NUMBER             DEFAULT 0,
  DX_FLAG                    NUMBER             DEFAULT 0,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  FINANCIAL_ASSIGNMENT_FLAG  NUMBER             DEFAULT 0,
  PHYS_ALIAS_TYPE_CD         NUMBER             DEFAULT 0                     NOT NULL,
  PHYS_FILTERED_ALIAS_IND    NUMBER             DEFAULT 0,
  ROE_DEMOGRAPHICS           VARCHAR2(100 BYTE),
  ROE_DUAL_ORDER             VARCHAR2(100 BYTE),
  ROE_DUAL_REGISTRATION      VARCHAR2(100 BYTE),
  ROE_MODIFY_ORDER           VARCHAR2(100 BYTE),
  ROE_MODIFY_REGISTRATION    VARCHAR2(100 BYTE),
  ROE_ENCNTR_SEARCH          VARCHAR2(100 BYTE),
  ROE_CANCEL_ORDER           VARCHAR2(100 BYTE),
  ROE_ADDON_LIMIT_DAYS       NUMBER             DEFAULT 0,
  LANGUAGE_FLAG              NUMBER,
  EEM_ABN_CHECK_IND          NUMBER,
  DFLT_HP_ADDR_TYPE_CD       NUMBER             DEFAULT 0                     NOT NULL,
  VOC_IND                    NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OSM_FORM_CLIENT_VALUES
(
  ORGANIZATION_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  LOCATION_CD         NUMBER                    DEFAULT 0                     NOT NULL,
  FORM_FIELD_ID       NUMBER                    DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME  VARCHAR2(40 BYTE),
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OSM_FORM_ORG_GRP_XREF
(
  ORGANIZATION_ID  NUMBER                       DEFAULT 0                     NOT NULL,
  LOCATION_CD      NUMBER                       DEFAULT 0                     NOT NULL,
  OSM_FORM_ID      NUMBER                       DEFAULT 0                     NOT NULL,
  GROUP_ID         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_DT_TM       DATE                         DEFAULT SYSDATE               NOT NULL,
  UPDT_ID          NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_TASK        NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_CNT         NUMBER                       DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX     NUMBER                       DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OSM_FORM_PRINTING
(
  OSM_FORM_ID        NUMBER                     DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  LOCATION_CD        NUMBER                     DEFAULT 0                     NOT NULL,
  THRESHOLD          NUMBER                     DEFAULT 0                     NOT NULL,
  NUMBER_COPIES      NUMBER                     DEFAULT 0                     NOT NULL,
  PRINT_IND          NUMBER                     DEFAULT 0                     NOT NULL,
  LAST_PRINT_NUMBER  NUMBER                     DEFAULT 0                     NOT NULL,
  LAST_PRINT_DT_TM   DATE,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OSM_INSURANCE
(
  ADDITIONAL_INFO    VARCHAR2(30 BYTE),
  ENCOUNTER_ID       NUMBER                     DEFAULT 0                     NOT NULL,
  GROUP_NAME         VARCHAR2(30 BYTE),
  GROUP_NBR          VARCHAR2(15 BYTE),
  HEALTH_PLAN        VARCHAR2(30 BYTE),
  FINANCIAL_CLASS    VARCHAR2(30 BYTE),
  INSURANCE_COMPANY  VARCHAR2(30 BYTE),
  MEMBER_NBR         VARCHAR2(15 BYTE),
  PRIORITY_SEQ       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  POLICY_NBR         VARCHAR2(15 BYTE),
  SPONSOR_ID         NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OSM_INSURANCE_RELTN
(
  OSM_INSURANCE_RELTN_ID  NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCOUNTER_ID            NUMBER                DEFAULT 0                     NOT NULL,
  EMPLOYER_NAME           VARCHAR2(100 BYTE),
  PERSON_NAME             VARCHAR2(100 BYTE),
  SSN                     VARCHAR2(15 BYTE),
  RELATION                VARCHAR2(15 BYTE),
  PRIORITY_SEQ            NUMBER                DEFAULT 0                     NOT NULL,
  TYPE_FLAG               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OSM_ORG_XREF
(
  ORGANIZATION_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_ID    NUMBER                    DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME  VARCHAR2(32 BYTE)         DEFAULT ' '                   NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OUTCOME_ACTION
(
  OUTCOME_ACTIVITY_ID   NUMBER                  DEFAULT 0                     NOT NULL,
  ACTION_SEQ            NUMBER                  DEFAULT 0                     NOT NULL,
  OUTCOME_STATUS_CD     NUMBER                  DEFAULT 0                     NOT NULL,
  OUTCOME_STATUS_DT_TM  DATE                    DEFAULT SYSDATE               NOT NULL,
  TARGET_TYPE_CD        NUMBER                  DEFAULT 0                     NOT NULL,
  START_DT_TM           DATE,
  END_DT_TM             DATE,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  END_TZ                NUMBER,
  OUTCOME_STATUS_TZ     NUMBER,
  START_TZ              NUMBER,
  ACTION_DT_TM          DATE,
  ACTION_TZ             NUMBER,
  END_ESTIMATED_IND     NUMBER                  DEFAULT 0,
  START_ESTIMATED_IND   NUMBER                  DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OUTCOME_ACTIVITY
(
  OUTCOME_ACTIVITY_ID      NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ENCNTR_ID                NUMBER               DEFAULT 0                     NOT NULL,
  EVENT_CD                 NUMBER               DEFAULT 0                     NOT NULL,
  TASK_ASSAY_CD            NUMBER               DEFAULT 0                     NOT NULL,
  OUTCOME_CATALOG_ID       NUMBER               DEFAULT 0                     NOT NULL,
  OUTCOME_CLASS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  OUTCOME_TYPE_CD          NUMBER               DEFAULT 0                     NOT NULL,
  DESCRIPTION              VARCHAR2(100 BYTE)   DEFAULT ' '                   NOT NULL,
  EXPECTATION              VARCHAR2(200 BYTE)   DEFAULT ' '                   NOT NULL,
  OUTCOME_STATUS_CD        NUMBER               DEFAULT 0                     NOT NULL,
  OUTCOME_STATUS_DT_TM     DATE                 DEFAULT SYSDATE               NOT NULL,
  RESULT_TYPE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  TARGET_TYPE_CD           NUMBER               DEFAULT 0                     NOT NULL,
  TARGET_DURATION_QTY      NUMBER,
  TARGET_DURATION_UNIT_CD  NUMBER               DEFAULT 0                     NOT NULL,
  EXPAND_QTY               NUMBER,
  EXPAND_UNIT_CD           NUMBER               DEFAULT 0                     NOT NULL,
  START_DT_TM              DATE,
  END_DT_TM                DATE,
  OPERAND_MEAN             CHAR(12 BYTE),
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  REFERENCE_TASK_ID        NUMBER               DEFAULT 0                     NOT NULL,
  REF_TEXT_RELTN_ID        NUMBER               DEFAULT 0,
  HIDE_EXPECTATION_IND     NUMBER               DEFAULT 0,
  SINGLE_SELECT_IND        NUMBER               DEFAULT 0,
  OUTCOME_STATUS_TZ        NUMBER,
  END_TZ                   NUMBER,
  START_TZ                 NUMBER,
  NOMEN_STRING_FLAG        NUMBER               DEFAULT 2,
  START_ESTIMATED_IND      NUMBER               DEFAULT 0,
  END_ESTIMATED_IND        NUMBER               DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE OUTCOME_CRITERIA
(
  OUTCOME_CRITERIA_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  OUTCOME_ACTIVITY_ID  NUMBER                   DEFAULT 0                     NOT NULL,
  OPERATOR_CD          NUMBER                   DEFAULT 0                     NOT NULL,
  RESULT_VALUE         NUMBER                   DEFAULT 0                     NOT NULL,
  RESULT_UNIT_CD       NUMBER                   DEFAULT 0                     NOT NULL,
  NOMENCLATURE_ID      NUMBER                   DEFAULT 0                     NOT NULL,
  SEQUENCE             NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_DT_TM           DATE                     DEFAULT SYSDATE               NOT NULL,
  UPDT_ID              NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_TASK            NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX         NUMBER                   DEFAULT 0                     NOT NULL,
  UPDT_CNT             NUMBER                   DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PACKAGE_TYPE
(
  PACKAGE_TYPE_ID         NUMBER                DEFAULT 0                     NOT NULL,
  DESCRIPTION             VARCHAR2(100 BYTE),
  UOM_CD                  NUMBER                DEFAULT 0                     NOT NULL,
  QTY                     FLOAT(126),
  BASE_PACKAGE_TYPE_IND   NUMBER,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ITEM_ID                 NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PATHOLOGY_CASE
(
  CASE_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  ACCESSION_NBR               CHAR(21 BYTE),
  ACCESSIONED_DT_TM           DATE,
  ACCESSION_PRSNL_ID          NUMBER            DEFAULT 0                     NOT NULL,
  PERSON_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  ENCNTR_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  GROUP_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  PREFIX_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  CASE_YEAR                   NUMBER            DEFAULT 0                     NOT NULL,
  CASE_NUMBER                 NUMBER            DEFAULT 0                     NOT NULL,
  RESPONSIBLE_RESIDENT_ID     NUMBER            DEFAULT 0                     NOT NULL,
  RESPONSIBLE_PATHOLOGIST_ID  NUMBER            DEFAULT 0                     NOT NULL,
  REQUESTING_PHYSICIAN_ID     NUMBER            DEFAULT 0                     NOT NULL,
  MAIN_REPORT_CMPLETE_DT_TM   DATE,
  CASE_RECEIVED_DT_TM         DATE,
  CASE_COLLECT_DT_TM          DATE,
  LOC_FACILITY_CD             NUMBER            DEFAULT 0                     NOT NULL,
  LOC_BUILDING_CD             NUMBER            DEFAULT 0                     NOT NULL,
  LOC_NURSE_UNIT_CD           NUMBER            DEFAULT 0                     NOT NULL,
  COMMENTS                    VARCHAR2(255 BYTE),
  CANCEL_CD                   NUMBER            DEFAULT 0                     NOT NULL,
  CANCEL_DT_TM                DATE,
  CANCEL_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  ORIGIN_FLAG                 NUMBER,
  RESERVED_IND                NUMBER,
  CHR_IND                     NUMBER,
  CASE_TYPE_CD                NUMBER            DEFAULT 0                     NOT NULL,
  AUTOPSY_SCOPE_CD            NUMBER            DEFAULT 0                     NOT NULL,
  AUTOPSY_DESCRIPTION         VARCHAR2(100 BYTE),
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD       NUMBER            DEFAULT 0                     NOT NULL,
  EXT_ACCESSION_NBR           CHAR(21 BYTE),
  BLOB_BITMAP                 NUMBER            DEFAULT 0,
  COMMENTS_LONG_TEXT_ID       NUMBER            DEFAULT 0                     NOT NULL,
  DATASET_UID                 VARCHAR2(128 BYTE) DEFAULT '0',
  SOURCE_OF_SMEAR_CD          NUMBER            DEFAULT 0                     NOT NULL,
  RECEIVED_SMEAR_IND          NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PATHWAY
(
  PATHWAY_ID                     NUMBER         DEFAULT 0                     NOT NULL,
  PATHWAY_CATALOG_ID             NUMBER         DEFAULT 0                     NOT NULL,
  PW_STATUS_CD                   NUMBER         DEFAULT 0                     NOT NULL,
  STATUS_DT_TM                   DATE           DEFAULT SYSDATE               NOT NULL,
  STATUS_PRSNL_ID                NUMBER         DEFAULT 0                     NOT NULL,
  PERSON_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  DESCRIPTION                    VARCHAR2(100 BYTE) DEFAULT ' ' NOT NULL,
  AGE_UNITS_CD                   NUMBER         DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID                   NUMBER         DEFAULT 0                     NOT NULL,
  ORDER_DT_TM                    DATE,
  START_DT_TM                    DATE,
  STARTED_IND                    NUMBER,
  CALC_END_DT_TM                 DATE,
  ACTUAL_END_DT_TM               DATE,
  ENDED_IND                      NUMBER,
  DC_REASON_CD                   NUMBER         DEFAULT 0                     NOT NULL,
  DISCONTINUED_IND               NUMBER,
  DISCONTINUED_DT_TM             DATE,
  LAST_ACTION_SEQ                NUMBER,
  VERSION                        NUMBER,
  VERSION_PATHWAY_ID             NUMBER         DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM            DATE,
  END_EFFECTIVE_DT_TM            DATE           DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND                     NUMBER,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  PW_FORMS_REF_ID                NUMBER         DEFAULT 0                     NOT NULL,
  COMP_FORMS_REF_ID              NUMBER         DEFAULT 0                     NOT NULL,
  RESTRICT_COMP_ADD_IND          NUMBER,
  RESTRICT_TF_ADD_IND            NUMBER,
  RESTRICT_CC_ADD_IND            NUMBER,
  PW_CAT_VERSION                 NUMBER,
  DC_TEXT_ID                     NUMBER         DEFAULT 0                     NOT NULL,
  CROSS_ENCNTR_IND               NUMBER         DEFAULT 0                     NOT NULL,
  TYPE_MEAN                      VARCHAR2(12 BYTE),
  DURATION_QTY                   NUMBER,
  DURATION_UNIT_CD               NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  PW_GROUP_NBR                   FLOAT(126),
  PW_CAT_GROUP_ID                NUMBER         DEFAULT 0                     NOT NULL,
  PW_GROUP_DESC                  VARCHAR2(100 BYTE),
  PATHWAY_TYPE_CD                NUMBER         DEFAULT 0                     NOT NULL,
  PATHWAY_CLASS_CD               NUMBER         DEFAULT 0                     NOT NULL,
  DISPLAY_METHOD_CD              NUMBER         DEFAULT 0                     NOT NULL,
  REF_OWNER_PERSON_ID            NUMBER         DEFAULT 0                     NOT NULL,
  CYCLE_NBR                      NUMBER         DEFAULT 0,
  PARENT_PHASE_DESC              VARCHAR2(100 BYTE),
  DEFAULT_VIEW_MEAN              VARCHAR2(12 BYTE) DEFAULT ' ',
  DIAGNOSIS_CAPTURE_IND          NUMBER         DEFAULT 0,
  DISCONTINUED_TZ                NUMBER,
  ORDER_TZ                       NUMBER,
  START_TZ                       NUMBER,
  ALERTS_ON_PLAN_UPD_IND         NUMBER         DEFAULT 0,
  ALERTS_ON_PLAN_IND             NUMBER         DEFAULT 0,
  STATUS_TZ                      NUMBER,
  CALC_END_TZ                    NUMBER,
  SYNONYM_NAME                   VARCHAR2(100 BYTE),
  CALC_END_ESTIMATED_IND         NUMBER         DEFAULT 0,
  PATHWAY_CUSTOMIZED_PLAN_ID     NUMBER         DEFAULT 0,
  PATHWAY_GROUP_ID               NUMBER         DEFAULT 0                     NOT NULL,
  REVIEW_STATUS_FLAG             NUMBER         DEFAULT 0,
  PERIOD_CUSTOM_LABEL            VARCHAR2(40 BYTE),
  PERIOD_NBR                     NUMBER         DEFAULT 0,
  CYCLE_END_NBR                  NUMBER         DEFAULT 0,
  START_ESTIMATED_IND            NUMBER         DEFAULT 0,
  FUTURE_LOCATION_NURSE_UNIT_CD  NUMBER         DEFAULT 0,
  FUTURE_LOCATION_FACILITY_CD    NUMBER         DEFAULT 0,
  CYCLE_LABEL_CD                 NUMBER         DEFAULT 0,
  WARNING_LEVEL_BIT              NUMBER         DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PATHWAY_ACTION
(
  PATHWAY_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  PW_ACTION_SEQ          NUMBER                 DEFAULT 0                     NOT NULL,
  PW_STATUS_CD           NUMBER                 DEFAULT 0                     NOT NULL,
  ACTION_TYPE_CD         NUMBER                 DEFAULT 0                     NOT NULL,
  ACTION_DT_TM           DATE                   DEFAULT TO_DATE( '01/01/1900 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ACTION_PRSNL_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  START_DT_TM            DATE,
  END_DT_TM              DATE,
  DURATION_UNIT_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  DURATION_QTY           NUMBER,
  COMMUNICATION_TYPE_CD  NUMBER                 DEFAULT 0,
  PROVIDER_ID            NUMBER                 DEFAULT 0,
  PATHWAY_CATALOG_ID     NUMBER                 DEFAULT 0,
  START_TZ               NUMBER,
  END_TZ                 NUMBER,
  ACTION_REASON_CD       NUMBER                 DEFAULT 0,
  PATHWAY_ACTION_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  ACTION_COMMENT         VARCHAR2(255 BYTE),
  ACTION_TZ              NUMBER,
  START_ESTIMATED_IND    NUMBER                 DEFAULT 0,
  END_ESTIMATED_IND      NUMBER                 DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PATHWAY_CUSTOMIZED_NOTIFY
(
  PATHWAY_CUSTOMIZED_NOTIFY_ID  NUMBER          DEFAULT 0                     NOT NULL,
  VERSION_PW_CAT_ID             NUMBER          DEFAULT 0                     NOT NULL,
  PATHWAY_CATALOG_ID            NUMBER          DEFAULT 0                     NOT NULL,
  PATHWAY_CUSTOMIZED_PLAN_ID    NUMBER          DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID                  NUMBER          DEFAULT 0                     NOT NULL,
  NOTIFICATION_DT_TM            DATE            DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND                    NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_ID                       NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                    DATE            DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                     NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                  NUMBER          DEFAULT 0                     NOT NULL,
  UPDT_CNT                      NUMBER          DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PATHWAY_CUSTOMIZED_PLAN
(
  PATHWAY_CUSTOMIZED_PLAN_ID  NUMBER            DEFAULT 0                     NOT NULL,
  PATHWAY_CATALOG_ID          NUMBER            DEFAULT 0                     NOT NULL,
  PRSNL_ID                    NUMBER            DEFAULT 0                     NOT NULL,
  PLAN_NAME                   VARCHAR2(100 BYTE) DEFAULT ' ' NOT NULL,
  PLAN_NAME_KEY               VARCHAR2(100 BYTE) DEFAULT ' ' NOT NULL,
  PLAN_NAME_KEY_A_NLS         VARCHAR2(400 BYTE),
  ACTIVE_IND                  NUMBER            DEFAULT 0                     NOT NULL,
  CREATE_DT_TM                DATE              DEFAULT SYSDATE               NOT NULL,
  STATUS_FLAG                 NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PATHWAY_NOTIFICATION
(
  PATHWAY_NOTIFICATION_ID         NUMBER        DEFAULT 0                     NOT NULL,
  PATHWAY_ID                      NUMBER        DEFAULT 0                     NOT NULL,
  PW_ACTION_SEQ                   NUMBER        DEFAULT 0                     NOT NULL,
  NOTIFICATION_STATUS_FLAG        NUMBER        DEFAULT 0                     NOT NULL,
  NOTIFICATION_TYPE_FLAG          NUMBER        DEFAULT 0                     NOT NULL,
  FROM_PRSNL_GROUP_ID             NUMBER        DEFAULT 0                     NOT NULL,
  FROM_PRSNL_ID                   NUMBER        DEFAULT 0                     NOT NULL,
  TO_PRSNL_GROUP_ID               NUMBER        DEFAULT 0                     NOT NULL,
  TO_PRSNL_ID                     NUMBER        DEFAULT 0                     NOT NULL,
  NOTIFICATION_CREATED_DT_TM      DATE,
  NOTIFICATION_CREATED_TZ         NUMBER        DEFAULT 0                     NOT NULL,
  NOTIFICATION_RESOLVED_DT_TM     DATE,
  NOTIFICATION_RESOLVED_TZ        NUMBER        DEFAULT 0                     NOT NULL,
  NOTIFICATION_COMMENT            VARCHAR2(255 BYTE),
  PARENT_PATHWAY_NOTIFICATION_ID  NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  FORWARDING_PRSNL_ID             NUMBER        DEFAULT 0                     NOT NULL,
  FORWARDING_PRSNL_GROUP_ID       NUMBER        DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PATHWAY_RELTN
(
  PATHWAY_S_ID            NUMBER                DEFAULT 0                     NOT NULL,
  PATHWAY_T_ID            NUMBER                DEFAULT 0                     NOT NULL,
  TYPE_MEAN               VARCHAR2(12 BYTE)     DEFAULT ' '                   NOT NULL,
  OFFSET_QTY              NUMBER,
  OFFSET_UNIT_CD          NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE,
  END_EFFECTIVE_DT_TM     DATE,
  ACTIVE_IND              NUMBER                NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PATHWAY_RULE
(
  PATHWAY_RULE_ID             NUMBER            DEFAULT 0                     NOT NULL,
  PATHWAY_CUSTOMIZED_PLAN_ID  NUMBER            DEFAULT 0                     NOT NULL,
  RULE_SEQUENCE               NUMBER            DEFAULT 0                     NOT NULL,
  ACTION_TYPE_FLAG            NUMBER            DEFAULT 0                     NOT NULL,
  ENTITY_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  ENTITY_NAME                 VARCHAR2(32 BYTE),
  ENTITY_UUID                 VARCHAR2(255 BYTE),
  ENTITY_VALUE                FLOAT(126)        DEFAULT 0                     NOT NULL,
  TARGET_UUID                 VARCHAR2(255 BYTE) DEFAULT ' ' NOT NULL,
  TARGET_PARENT_UUID          VARCHAR2(255 BYTE),
  TARGET_DESCRIPTION          VARCHAR2(500 BYTE),
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PATIENT_DISPENSE
(
  PRODUCT_EVENT_ID          NUMBER              DEFAULT 0                     NOT NULL,
  PRODUCT_ID                NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  DISPENSE_PROV_ID          NUMBER              DEFAULT 0                     NOT NULL,
  DISPENSE_REASON_CD        NUMBER              DEFAULT 0                     NOT NULL,
  DISPENSE_TO_LOCN_CD       NUMBER              DEFAULT 0                     NOT NULL,
  DISPENSE_FROM_LOCN_CD     NUMBER              DEFAULT 0                     NOT NULL,
  DEVICE_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  DISPENSE_VIS_INSP_CD      NUMBER              DEFAULT 0                     NOT NULL,
  DISPENSE_COOLER_ID        NUMBER              DEFAULT 0                     NOT NULL,
  DISPENSE_COOLER_TEXT      VARCHAR2(40 BYTE),
  DISPENSE_COURIER_ID       NUMBER              DEFAULT 0                     NOT NULL,
  DISPENSE_STATUS_FLAG      NUMBER,
  ORIG_DISPENSE_INTL_UNITS  NUMBER,
  CUR_DISPENSE_INTL_UNITS   NUMBER,
  ORIG_DISPENSE_QTY         NUMBER,
  CUR_DISPENSE_QTY          NUMBER,
  BB_ID_NBR                 VARCHAR2(20 BYTE),
  UNKNOWN_PATIENT_IND       NUMBER,
  UNKNOWN_PATIENT_TEXT      VARCHAR2(50 BYTE),
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  DISPENSE_COURIER_TEXT     VARCHAR2(100 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PAT_ED_DOCUMENT
(
  PAT_ED_DOCUMENT_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  ENCNTR_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  PERSON_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  EVENT_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  PAT_ED_DOMAIN_CD    NUMBER                    DEFAULT 0                     NOT NULL,
  CREATE_DT_TM        DATE,
  CREATE_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  SIGNED_DT_TM        DATE,
  SIGNED_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  STATUS_CD           NUMBER                    DEFAULT 0                     NOT NULL,
  ACTIVE_IND          NUMBER,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PAT_ED_DOC_ACTIVITY
(
  PAT_ED_DOC_ACTIVITY_ID  NUMBER                DEFAULT 0                     NOT NULL,
  PAT_ED_DOC_ID           NUMBER                DEFAULT 0                     NOT NULL,
  REFR_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  PAT_ED_RELTN_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  INSTRUCTION_DT_TM       DATE,
  INSTRUCTION_USER_ID     NUMBER                DEFAULT 0,
  PRINT_IND               NUMBER                DEFAULT 0,
  STATUS_CD               NUMBER                DEFAULT 0,
  DOC_LANG_ID_VALUE       NUMBER                DEFAULT 0,
  INSTRUCTION_NAME        VARCHAR2(1000 BYTE)   DEFAULT ' ',
  DOC_TYPES               VARCHAR2(255 BYTE),
  KEY_DOC_IDENT           VARCHAR2(255 BYTE),
  PAT_ED_DOMAIN_CD        NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PAT_ED_DOC_FOLLOWUP
(
  PAT_ED_DOC_FOLLOWUP_ID  NUMBER                DEFAULT 0                     NOT NULL,
  PAT_ED_DOC_ID           NUMBER                DEFAULT 0                     NOT NULL,
  PROVIDER_ID             NUMBER                DEFAULT 0                     NOT NULL,
  PROVIDER_NAME           VARCHAR2(255 BYTE),
  ADD_LONG_TEXT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  CMT_LONG_TEXT_ID        NUMBER                DEFAULT 0                     NOT NULL,
  FOL_WITHIN_DAYS         NUMBER,
  FOL_WITHIN_DT_TM        DATE,
  FOL_WITHIN_RANGE        VARCHAR2(100 BYTE),
  ACTIVE_IND              NUMBER,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  DAYS_OR_WEEKS           NUMBER,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ADDRESS_TYPE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  LOCATION_CD             NUMBER                DEFAULT 0                     NOT NULL,
  QUICK_PICK_CD           NUMBER                DEFAULT 0,
  FOLLOWUP_NEEDED_IND     NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PAT_ED_DOC_LEAFLET_ACTIVITY
(
  PAT_ED_DOC_LEAFLET_ACTIVITY_ID  NUMBER        DEFAULT 0                     NOT NULL,
  PAT_ED_DOC_ID                   NUMBER        DEFAULT 0                     NOT NULL,
  LEAFLET_NAME                    VARCHAR2(150 BYTE) DEFAULT ' ' NOT NULL,
  PRINT_IND                       NUMBER        DEFAULT 0                     NOT NULL,
  INSTRUCTION_PRSNL_ID            NUMBER        DEFAULT 0                     NOT NULL,
  INSTRUCTION_DT_TM               DATE          DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND                      NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  MED_LEAFLET_CKI                 VARCHAR2(255 BYTE) DEFAULT ' '
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PAT_ED_FAVORITES
(
  PAT_ED_FAVR_ID     NUMBER                     DEFAULT 0                     NOT NULL,
  PERSON_ID          NUMBER                     DEFAULT 0                     NOT NULL,
  PAT_ED_RELTN_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL,
  FAVORITE_TYPE_CD   NUMBER                     DEFAULT 0                     NOT NULL,
  TRACKING_GROUP_CD  NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PAT_ED_RELTN
(
  ACTIVE_IND                   NUMBER,
  PAT_ED_DOMAIN_CD             NUMBER           DEFAULT 0                     NOT NULL,
  PAT_ED_RELTN_DESC            VARCHAR2(1000 BYTE),
  PAT_ED_RELTN_ID              NUMBER           DEFAULT 0                     NOT NULL,
  PAT_ED_RELTN_PARENT_ID       NUMBER           DEFAULT 0                     NOT NULL,
  REFR_TEXT_ID                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  CUSTOM_IND                   NUMBER           DEFAULT 0                     NOT NULL,
  PRSNL_ID                     NUMBER           DEFAULT 0                     NOT NULL,
  PAT_ED_RELTN_DESC_KEY        VARCHAR2(1000 BYTE) DEFAULT ' ' NOT NULL,
  PAT_ED_RELTN_DESC_KEY_NLS    VARCHAR2(2002 BYTE),
  SHORTCUT_NAME                VARCHAR2(1000 BYTE),
  KEY_DOC_ID_VALUE             FLOAT(126)       DEFAULT 0                     NOT NULL,
  DOC_TYPES                    VARCHAR2(255 BYTE),
  DOC_LANG_ID_VALUE            FLOAT(126)       DEFAULT 0,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE,
  CONTENT_SUPPLIER_CD          NUMBER           DEFAULT 0                     NOT NULL,
  KEY_DOC_IDENT                VARCHAR2(255 BYTE),
  PAT_ED_RELTN_DESC_KEY_A_NLS  VARCHAR2(4000 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PAT_ED_SHORTCUT
(
  PAT_ED_SHORTCUT_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  PAT_ED_RELTN_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  SHORTCUT_NAME       VARCHAR2(1000 BYTE),
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  SHORTCUT_NAME_KEY   VARCHAR2(1000 BYTE)       DEFAULT ' '
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PAYMENT_DETAIL
(
  ACTIVITY_ID             NUMBER                DEFAULT 0                     NOT NULL,
  POST_DT_TM              DATE,
  PAYMENT_METHOD_CD       NUMBER                DEFAULT 0                     NOT NULL,
  PAYMENT_NUM_DESC        VARCHAR2(250 BYTE),
  PAYOR_NAME              VARCHAR2(100 BYTE),
  CC_BEG_EFF_DT_TM        DATE,
  CC_END_EFF_DT_TM        DATE,
  DEPOSIT_STATUS_CD       NUMBER                DEFAULT 0                     NOT NULL,
  CURRENT_CUR_CD          NUMBER                DEFAULT 0                     NOT NULL,
  ORIG_CUR_CD             NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  CC_AUTH_NBR             VARCHAR2(25 BYTE),
  PAYOR_NAME_KEY          VARCHAR2(250 BYTE),
  SESSION_ID              NUMBER                DEFAULT 0                     NOT NULL,
  CHECK_DATE              DATE,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(40 BYTE),
  CREATED_DT_TM           DATE                  DEFAULT SYSDATE,
  CREATED_PRSNL_ID        NUMBER                DEFAULT 0                     NOT NULL,
  POSTING_METHOD_CD       NUMBER                DEFAULT 0                     NOT NULL,
  PAYMENT_DETAIL_ID       NUMBER                DEFAULT 0                     NOT NULL,
  TOTAL_PAYMENT_AMOUNT    FLOAT(126)            DEFAULT 0                     NOT NULL,
  TENDERED_AMOUNT         FLOAT(126),
  CHANGE_DUE_AMOUNT       FLOAT(126),
  EXTERNAL_IDENT          VARCHAR2(250 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PCA_ENCNTR_MEASURE_OUTCOME
(
  PCA_ENCNTR_MEASURE_OUTCOME_ID  NUMBER         DEFAULT 0                     NOT NULL,
  ENCNTR_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  PCA_OUTCOME_ID                 NUMBER         DEFAULT 0                     NOT NULL,
  PCA_QUALITY_MEASURE_ID         NUMBER         DEFAULT 0                     NOT NULL,
  MEASURE_PROCESS_FLAG           NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  PERSON_ID                      NUMBER         DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PCA_ENCNTR_TOPIC_RELTN
(
  PCA_ENCNTR_TOPIC_RELTN_ID  NUMBER             DEFAULT 0                     NOT NULL,
  PCA_QUALITY_TOPIC_ID       NUMBER             DEFAULT 0                     NOT NULL,
  ENCNTR_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  PUBLISH_IND                NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  PERSON_ID                  NUMBER             DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PCA_PERSON_MEASURE_OUTCOME
(
  PCA_PERSON_MEASURE_OUTCOME_ID  NUMBER         DEFAULT 0                     NOT NULL,
  PERSON_ID                      NUMBER         DEFAULT 0                     NOT NULL,
  PCA_QUALITY_MEASURE_ID         NUMBER         DEFAULT 0                     NOT NULL,
  PCA_OUTCOME_ID                 NUMBER         DEFAULT 0                     NOT NULL,
  MEASURE_PROCESS_FLAG           NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                   NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_CNT                       NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                     DATE           DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                        NUMBER         DEFAULT 0                     NOT NULL,
  UPDT_TASK                      NUMBER         DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM            DATE           DEFAULT SYSDATE,
  ACTIVE_STATUS_CD               NUMBER         DEFAULT 0,
  ACTIVE_IND                     NUMBER         DEFAULT 1,
  ACTIVE_STATUS_PRSNL_ID         NUMBER         DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PCA_PERSON_TOPIC_RELTN
(
  PCA_PERSON_TOPIC_RELTN_ID  NUMBER             DEFAULT 0                     NOT NULL,
  PERSON_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  PCA_QUALITY_TOPIC_ID       NUMBER             DEFAULT 0                     NOT NULL,
  PUBLISH_IND                NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID     NUMBER             DEFAULT 0,
  ACTIVE_STATUS_DT_TM        DATE               DEFAULT SYSDATE,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0,
  ACTIVE_IND                 NUMBER             DEFAULT 1
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PCS_CHARGE_MOD_ABN
(
  CHARGE_MOD_ABN_ID  NUMBER                     DEFAULT 0                     NOT NULL,
  CHARGE_ITEM_ID     NUMBER                     DEFAULT 0                     NOT NULL,
  CHARGE_STATUS_CD   NUMBER                     DEFAULT 0                     NOT NULL,
  AS_OF_DT_TM        DATE                       DEFAULT SYSDATE               NOT NULL,
  ORGANIZATION_ID    NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_ID            NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_DT_TM         DATE                       DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK          NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX       NUMBER                     DEFAULT 0                     NOT NULL,
  UPDT_CNT           NUMBER                     DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PCS_FILTER_ITEM
(
  SELECTED_ITEM_ID        NUMBER                DEFAULT 0                     NOT NULL,
  FILTER_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(30 BYTE)     DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  FILTER_TYPE_CD          NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  FILTER_DT_TM            DATE                  DEFAULT SYSDATE,
  FILTER_VALUE            NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PCS_LOT_INFORMATION
(
  LOT_INFORMATION_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  LOT_IDENT              VARCHAR2(40 BYTE)      DEFAULT ' '                   NOT NULL,
  RECEIVED_QTY_NBR       NUMBER                 DEFAULT 0                     NOT NULL,
  RECEIVED_PERSONNEL_ID  NUMBER                 DEFAULT 0                     NOT NULL,
  EXPIRE_DT_TM           DATE                   DEFAULT SYSDATE               NOT NULL,
  STATUS_CD              NUMBER                 DEFAULT 0                     NOT NULL,
  EXEMPT_IND             NUMBER                 DEFAULT 0                     NOT NULL,
  COMMENT_TEXT_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM    DATE                   DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  END_EFFECTIVE_DT_TM    DATE                   DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS'),
  LOT_DEFINITION_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  RECEIVED_DT_TM         DATE                   DEFAULT SYSDATE               NOT NULL,
  LOT_SOURCE_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  KIT_INFORMATION_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PCS_ORDER_GROUP_R
(
  PCS_ORDER_GROUP_R_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  PCS_ORDER_GROUP_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  ORDER_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  ACTIVE_IND            NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM   DATE                    DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  BEG_EFFECTIVE_DT_TM   DATE                    DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PCS_PRSNL_FILTER
(
  FILTER_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  FILTER_NAME             VARCHAR2(40 BYTE)     DEFAULT ' '                   NOT NULL,
  APPLICATION_TYPE_CD     NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PCS_QUALIFYING_CRITERIA
(
  QUALIFYING_CRITERIA_ID  NUMBER                DEFAULT 0                     NOT NULL,
  REVIEW_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CRITERIA_ID             NUMBER                DEFAULT 0                     NOT NULL,
  SUB_CRITERIA_ID         NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PCS_QUEUE_ASSIGNMENT
(
  QUEUE_REVIEW_ID         NUMBER                DEFAULT 0                     NOT NULL,
  QUEUE_ID                NUMBER                DEFAULT 0                     NOT NULL,
  REVIEW_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  REVIEW_LEVEL_SEQ        NUMBER                DEFAULT 0                     NOT NULL,
  REVIEW_TYPE_CD          NUMBER                DEFAULT 0                     NOT NULL,
  FROM_QUEUE_REVIEW_ID    NUMBER                DEFAULT 0                     NOT NULL,
  FROM_PRSNL_ID           NUMBER                DEFAULT 0                     NOT NULL,
  RETURN_TO_SENDER_IND    NUMBER,
  REVIEW_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  PENDING_DT_TM           DATE                  DEFAULT SYSDATE               NOT NULL,
  COMPLETED_DT_TM         DATE,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PCS_QUEUE_PRSNL_RELTN
(
  QUEUE_PRSNL_RELTN_ID    NUMBER                DEFAULT 0                     NOT NULL,
  QUEUE_ID                NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PCS_REVIEW_HISTORY
(
  REVIEW_HISTORY_ID       NUMBER                DEFAULT 0                     NOT NULL,
  QUEUE_REVIEW_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PRSNL_ID                NUMBER                DEFAULT 0                     NOT NULL,
  REVIEW_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  STATUS_PRSNL_ID         NUMBER                DEFAULT 0                     NOT NULL,
  STATUS_DT_TM            DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PCS_REVIEW_ITEM
(
  REVIEW_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ENTITY_NAME      VARCHAR2(30 BYTE)     DEFAULT ' '                   NOT NULL,
  PARENT_ENTITY_ID        NUMBER                DEFAULT 0                     NOT NULL,
  MICRO_TASK_TYPE_CD      NUMBER                DEFAULT 0                     NOT NULL,
  ORDER_ID                NUMBER                DEFAULT 0                     NOT NULL,
  REVIEW_CRITERIA_ID      NUMBER                DEFAULT 0                     NOT NULL,
  HIERARCHY_ID            NUMBER                DEFAULT 0                     NOT NULL,
  REVIEW_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  CURRENT_USER_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PENDING_DT_TM           DATE,
  COMPLETED_DT_TM         DATE,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  ROUTE_PREF_FLAG         NUMBER                DEFAULT 0,
  BB_RH_PHENO_DEMOG_IND   NUMBER                DEFAULT 0,
  BB_COMPLETE_ORDER_IND   NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PC_REF_FORM_AUTHOR
(
  REF_FORM_AUTHOR_ID      NUMBER                DEFAULT 0                     NOT NULL,
  REF_FORM_ENCNTR_ID      NUMBER                DEFAULT 0                     NOT NULL,
  REF_FORM_SIGNED_IND     NUMBER                DEFAULT 0                     NOT NULL,
  REF_FORM_UPDT_DT_TM     DATE                  DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  REF_AUTHOR_SEQ          NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PC_REF_FORM_NOTE
(
  REF_FORM_NOTE_ID        NUMBER                DEFAULT 0                     NOT NULL,
  REF_FORM_ENCNTR_ID      NUMBER                DEFAULT 0                     NOT NULL,
  REF_NOTE_DT_TM          DATE                  DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  REF_NOTE_TXT            VARCHAR2(2000 BYTE),
  REF_NOTE_SEQ            NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT TO_DATE('01/01/1900 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE('12/31/2100 00:00:00','MM/DD/YYYY HH24:MI:SS') NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PEER_REVIEWER
(
  PEER_REVIEWER_ID         NUMBER               DEFAULT 0                     NOT NULL,
  PROT_MASTER_ID           NUMBER               DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID          NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  PEER_REVIEWER_STATUS_CD  NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERFORM_RESULT
(
  PERFORM_RESULT_ID          NUMBER             DEFAULT 0                     NOT NULL,
  RESULT_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  RESULT_VALUE_DT_TM         DATE,
  MULTIPLEX_RESOURCE_CD      NUMBER             DEFAULT 0                     NOT NULL,
  PARENT_PERFORM_RESULT_ID   NUMBER             DEFAULT 0                     NOT NULL,
  CONTAINER_ID               NUMBER             DEFAULT 0                     NOT NULL,
  SERVICE_RESOURCE_CD        NUMBER             DEFAULT 0                     NOT NULL,
  RESULT_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  PERFORM_PERSONNEL_ID       NUMBER             DEFAULT 0                     NOT NULL,
  PERFORM_DT_TM              DATE,
  RESULT_TYPE_CD             NUMBER             DEFAULT 0                     NOT NULL,
  RESULT_VALUE_NUMERIC       FLOAT(126),
  RESULT_VALUE_ALPHA         VARCHAR2(200 BYTE),
  NOMENCLATURE_ID            NUMBER             DEFAULT 0                     NOT NULL,
  REFERENCE_RANGE_FACTOR_ID  NUMBER             DEFAULT 0                     NOT NULL,
  NORMAL_CD                  NUMBER             DEFAULT 0                     NOT NULL,
  CRITICAL_CD                NUMBER             DEFAULT 0                     NOT NULL,
  REVIEW_CD                  NUMBER             DEFAULT 0                     NOT NULL,
  DELTA_CD                   NUMBER             DEFAULT 0                     NOT NULL,
  NORMAL_LOW                 FLOAT(126),
  NORMAL_HIGH                FLOAT(126),
  NORMAL_ALPHA               VARCHAR2(200 BYTE),
  DILUTION_FACTOR            FLOAT(126),
  EQUATION_ID                NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  LESS_GREAT_FLAG            NUMBER,
  NUMERIC_RAW_VALUE          NUMBER,
  INTERP_OVERRIDE_IND        NUMBER,
  ASCII_TEXT                 VARCHAR2(60 BYTE),
  RESULT_CODE_SET_CD         NUMBER             DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID               NUMBER             DEFAULT 0                     NOT NULL,
  ACTION_SEQUENCE            NUMBER,
  RESOURCE_ERROR_CODES       VARCHAR2(255 BYTE),
  UNITS_CD                   NUMBER             DEFAULT 0                     NOT NULL,
  INTERFACE_FLAG             NUMBER,
  INTERP_DATA_ID             NUMBER             DEFAULT 0                     NOT NULL,
  DELTA_PERF_RESULT_ID       NUMBER             DEFAULT 0                     NOT NULL,
  LINEAR_CD                  NUMBER             DEFAULT 0                     NOT NULL,
  FEASIBLE_CD                NUMBER             DEFAULT 0                     NOT NULL,
  ADVANCED_DELTA_ID          NUMBER             DEFAULT 0                     NOT NULL,
  REPEAT_NBR                 NUMBER             DEFAULT 0                     NOT NULL,
  IDENTIFIER                 VARCHAR2(20 BYTE),
  POST_ALPHA_IND             NUMBER,
  UNPERF_FLAG                NUMBER,
  RAW_RESULT_STR             VARCHAR2(255 BYTE),
  AV_ERROR_CD                NUMBER             DEFAULT 0                     NOT NULL,
  APP_MODE_IND               NUMBER             DEFAULT 0,
  PERFORM_TZ                 NUMBER             DEFAULT 0,
  QC_OVERRIDE_CD             NUMBER,
  NOTIFY_CD                  NUMBER             DEFAULT 0,
  WORKLIST_ID                NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERIOPERATIVE_DOCUMENT
(
  PERIOP_DOC_ID          NUMBER                 DEFAULT 0                     NOT NULL,
  SURG_CASE_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  PERIOP_DOC_TYPE_FLAG   NUMBER                 DEFAULT 0                     NOT NULL,
  SURG_AREA_CD           NUMBER                 DEFAULT 0                     NOT NULL,
  RETROSPECTIVE_DOC_IND  NUMBER,
  DOC_TERM_DT_TM         DATE,
  DOC_TERM_REASON_CD     NUMBER                 DEFAULT 0                     NOT NULL,
  DOC_TERM_BY_ID         NUMBER                 DEFAULT 0                     NOT NULL,
  REC_VER_DT_TM          DATE,
  REC_VER_ID             NUMBER                 DEFAULT 0                     NOT NULL,
  LAST_VER_DT_TM         DATE,
  LAST_VER_ID            NUMBER                 DEFAULT 0                     NOT NULL,
  CREATE_DT_TM           DATE,
  CREATE_PRSNL_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  CREATE_TASK            NUMBER,
  CREATE_APPLCTX         NUMBER,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  DOC_TYPE_CD            NUMBER                 DEFAULT 0                     NOT NULL,
  LONG_TEXT_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  LOCKED_APPLCTX         FLOAT(126)             DEFAULT 0,
  ROOM_COST_PT_DUR       FLOAT(126)             DEFAULT 0,
  ROOM_COST_SURG_DUR     FLOAT(126)             DEFAULT 0,
  TOT_ATTENDEE_COST      FLOAT(126)             DEFAULT 0,
  DOC_TERM_TZ            NUMBER                 DEFAULT 0,
  LAST_VER_TZ            NUMBER                 DEFAULT 0,
  REC_VER_TZ             NUMBER                 DEFAULT 0,
  ORIG_PRINT_DT_TM       DATE,
  LAST_PRINT_DT_TM       DATE,
  ORIG_PRINT_TZ          NUMBER,
  LAST_PRINT_TZ          NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON
(
  PERSON_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE,
  CREATE_DT_TM                DATE,
  CREATE_PRSNL_ID             NUMBER            DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM         DATE              DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM         DATE              DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  PERSON_TYPE_CD              NUMBER            DEFAULT 0                     NOT NULL,
  NAME_LAST_KEY               VARCHAR2(100 BYTE),
  NAME_FIRST_KEY              VARCHAR2(100 BYTE),
  NAME_FULL_FORMATTED         VARCHAR2(100 BYTE),
  AUTOPSY_CD                  NUMBER            DEFAULT 0                     NOT NULL,
  BIRTH_DT_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  BIRTH_DT_TM                 DATE,
  CONCEPTION_DT_TM            DATE,
  CAUSE_OF_DEATH              VARCHAR2(100 BYTE),
  DECEASED_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  DECEASED_DT_TM              DATE,
  ETHNIC_GRP_CD               NUMBER            DEFAULT 0                     NOT NULL,
  LANGUAGE_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  MARITAL_TYPE_CD             NUMBER            DEFAULT 0                     NOT NULL,
  PURGE_OPTION_CD             NUMBER            DEFAULT 0                     NOT NULL,
  RACE_CD                     NUMBER            DEFAULT 0                     NOT NULL,
  RELIGION_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  SEX_CD                      NUMBER            DEFAULT 0                     NOT NULL,
  SEX_AGE_CHANGE_IND          NUMBER,
  DATA_STATUS_CD              NUMBER            DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM           DATE,
  DATA_STATUS_PRSNL_ID        NUMBER            DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD       NUMBER            DEFAULT 0                     NOT NULL,
  LANGUAGE_DIALECT_CD         NUMBER            DEFAULT 0                     NOT NULL,
  NAME_LAST                   VARCHAR2(200 BYTE),
  NAME_FIRST                  VARCHAR2(200 BYTE),
  NAME_PHONETIC               CHAR(8 BYTE),
  LAST_ENCNTR_DT_TM           DATE,
  SPECIES_CD                  NUMBER            DEFAULT 0                     NOT NULL,
  CONFID_LEVEL_CD             NUMBER            DEFAULT 0                     NOT NULL,
  VIP_CD                      NUMBER            DEFAULT 0                     NOT NULL,
  NAME_FIRST_SYNONYM_ID       NUMBER            DEFAULT 0                     NOT NULL,
  CITIZENSHIP_CD              NUMBER            DEFAULT 0                     NOT NULL,
  VET_MILITARY_STATUS_CD      NUMBER            DEFAULT 0                     NOT NULL,
  MOTHER_MAIDEN_NAME          VARCHAR2(100 BYTE),
  NATIONALITY_CD              NUMBER            DEFAULT 0                     NOT NULL,
  FT_ENTITY_NAME              VARCHAR2(32 BYTE),
  FT_ENTITY_ID                NUMBER            DEFAULT 0                     NOT NULL,
  NAME_MIDDLE_KEY             VARCHAR2(100 BYTE),
  NAME_MIDDLE                 VARCHAR2(200 BYTE),
  NAME_LAST_PHONETIC          VARCHAR2(8 BYTE),
  NAME_FIRST_PHONETIC         VARCHAR2(8 BYTE),
  NAME_FIRST_KEY_NLS          VARCHAR2(202 BYTE),
  NAME_LAST_KEY_NLS           VARCHAR2(202 BYTE),
  NAME_MIDDLE_KEY_NLS         VARCHAR2(202 BYTE),
  MILITARY_RANK_CD            NUMBER            DEFAULT 0                     NOT NULL,
  MILITARY_BASE_LOCATION      VARCHAR2(100 BYTE),
  MILITARY_SERVICE_CD         NUMBER            DEFAULT 0                     NOT NULL,
  DECEASED_SOURCE_CD          NUMBER            DEFAULT 0                     NOT NULL,
  CAUSE_OF_DEATH_CD           NUMBER            DEFAULT 0                     NOT NULL,
  BIRTH_TZ                    NUMBER            DEFAULT 0,
  BIRTH_PREC_FLAG             NUMBER,
  ABS_BIRTH_DT_TM             DATE,
  ARCHIVE_STATUS_DT_TM        DATE,
  NEXT_RESTORE_DT_TM          DATE,
  LAST_ACCESSED_DT_TM         DATE              DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ARCHIVE_STATUS_CD           NUMBER            DEFAULT 0                     NOT NULL,
  ARCHIVE_ENV_ID              NUMBER            DEFAULT 0,
  AGE_AT_DEATH                NUMBER            DEFAULT 0,
  AGE_AT_DEATH_UNIT_CD        NUMBER            DEFAULT 0,
  DECEASED_TZ                 NUMBER            DEFAULT 0,
  DECEASED_DT_TM_PREC_FLAG    NUMBER            DEFAULT 0,
  AGE_AT_DEATH_PREC_MOD_FLAG  NUMBER            DEFAULT 0,
  DECEASED_ID_METHOD_CD       NUMBER            DEFAULT 0,
  LOGICAL_DOMAIN_ID           NUMBER            DEFAULT 0,
  NAME_LAST_KEY_A_NLS         VARCHAR2(400 BYTE),
  NAME_FIRST_KEY_A_NLS        VARCHAR2(400 BYTE),
  NAME_MIDDLE_KEY_A_NLS       VARCHAR2(400 BYTE),
  PERSON_STATUS_CD            NUMBER            DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_ABORH
(
  PERSON_ABORH_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ABO_CD                  NUMBER                DEFAULT 0                     NOT NULL,
  RH_CD                   NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  BEGIN_EFFECTIVE_DT_TM   DATE,
  END_EFFECTIVE_DT_TM     DATE,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  LAST_VERIFIED_DT_TM     DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_ABORH_RESULT
(
  PERSON_ABORH_RS_ID      NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_CD               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  CONTAINER_ID            NUMBER                DEFAULT 0                     NOT NULL,
  DRAWN_DT_TM             DATE,
  PERSON_ABORH_ID         NUMBER                DEFAULT 0                     NOT NULL,
  SPECIMEN_ID             NUMBER                DEFAULT 0                     NOT NULL,
  DONOR_ABORH_ID          NUMBER                DEFAULT 0                     NOT NULL,
  STANDARD_ABORH_CD       NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_ALIAS
(
  PERSON_ALIAS_ID           NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  ALIAS_POOL_CD             NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ALIAS_TYPE_CD      NUMBER              DEFAULT 0                     NOT NULL,
  ALIAS                     VARCHAR2(200 BYTE)  DEFAULT ' '                   NOT NULL,
  PERSON_ALIAS_SUB_TYPE_CD  NUMBER              DEFAULT 0                     NOT NULL,
  CHECK_DIGIT               NUMBER,
  CHECK_DIGIT_METHOD_CD     NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  DATA_STATUS_CD            NUMBER              DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM         DATE,
  DATA_STATUS_PRSNL_ID      NUMBER              DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD     NUMBER              DEFAULT 0                     NOT NULL,
  VISIT_SEQ_NBR             NUMBER,
  HEALTH_CARD_VER_CODE      CHAR(3 BYTE),
  HEALTH_CARD_PROVINCE      CHAR(3 BYTE),
  ASSIGN_AUTHORITY_SYS_CD   NUMBER              DEFAULT 0                     NOT NULL,
  HEALTH_CARD_ISSUE_DT_TM   DATE,
  HEALTH_CARD_EXPIRY_DT_TM  DATE,
  HEALTH_CARD_TYPE          VARCHAR2(32 BYTE),
  PERSON_ALIAS_STATUS_CD    NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_ALIAS_HIST
(
  PERSON_ALIAS_HIST_ID      NUMBER              DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID       NUMBER              DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM         DATE,
  CHANGE_BIT                NUMBER              DEFAULT 0                     NOT NULL,
  TRACKING_BIT              NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ALIAS_ID           NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ALIAS_STATUS_CD    NUMBER              DEFAULT 0                     NOT NULL,
  HEALTH_CARD_VER_CODE      VARCHAR2(3 BYTE),
  HEALTH_CARD_TYPE          VARCHAR2(32 BYTE),
  HEALTH_CARD_PROVINCE      VARCHAR2(3 BYTE),
  HEALTH_CARD_ISSUE_DT_TM   DATE,
  HEALTH_CARD_EXPIRY_DT_TM  DATE,
  ACTIVE_IND                NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  ALIAS                     VARCHAR2(200 BYTE)  DEFAULT ' '                   NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_ANTIBODY
(
  PERSON_ANTIBODY_ID      NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ANTIBODY_CD             NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  BB_RESULT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_ANTIGEN
(
  PERSON_ANTIGEN_ID       NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ANTIGEN_CD              NUMBER                DEFAULT 0                     NOT NULL,
  RESULT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  BB_RESULT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_RH_PHENOTYPE_ID  NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_BENEFIT_R
(
  PERSON_BENEFIT_R_ID          NUMBER           DEFAULT 0                     NOT NULL,
  PERSON_PLAN_RELTN_ID         NUMBER           DEFAULT 0                     NOT NULL,
  COVERAGE_TYPE_CD             NUMBER           DEFAULT 0                     NOT NULL,
  BALANCE_TYPE_CD              NUMBER           DEFAULT 0                     NOT NULL,
  DEDUCT_AMT                   FLOAT(126)       DEFAULT 0                     NOT NULL,
  DEDUCT_MET_AMT               FLOAT(126)       DEFAULT 0                     NOT NULL,
  DEDUCT_MET_DT_TM             DATE,
  FAM_DEDUCT_MET_AMT           FLOAT(126)       DEFAULT 0                     NOT NULL,
  FAM_DEDUCT_MET_DT_TM         DATE,
  MAX_OUT_PCKT_AMT             FLOAT(126)       DEFAULT 0                     NOT NULL,
  MAX_OUT_PCKT_DT_TM           DATE,
  BENEFIT_PLAN_CD              NUMBER           DEFAULT 0                     NOT NULL,
  SERVICE_TYPE_CD              NUMBER           DEFAULT 0                     NOT NULL,
  COVERAGE_DAYS                NUMBER           DEFAULT 0                     NOT NULL,
  COVERAGE_REMAIN_DAYS         NUMBER           DEFAULT 0                     NOT NULL,
  NON_COVERAGE_DAYS            NUMBER           DEFAULT 0                     NOT NULL,
  COINSURANCE_DAYS             NUMBER           DEFAULT 0                     NOT NULL,
  COINSURANCE_REMAIN_DAYS      NUMBER           DEFAULT 0                     NOT NULL,
  COINSURANCE_PCT              FLOAT(126)       DEFAULT 0                     NOT NULL,
  COPAY_AMT                    FLOAT(126)       DEFAULT 0                     NOT NULL,
  DEDUCT_PCT                   FLOAT(126)       DEFAULT 0                     NOT NULL,
  DEDUCT_REMAIN_AMT            FLOAT(126)       DEFAULT 0                     NOT NULL,
  ROOM_COVERAGE_AMT            FLOAT(126)       DEFAULT 0                     NOT NULL,
  ROOM_COVERAGE_AMT_QUAL_CD    NUMBER           DEFAULT 0                     NOT NULL,
  ROOM_COVERAGE_TYPE_CD        NUMBER           DEFAULT 0                     NOT NULL,
  ROOM_COVERAGE_BOARD_INCL_CD  NUMBER           DEFAULT 0                     NOT NULL,
  COMMENT_ID                   NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DATA_STATUS_CD               NUMBER           DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM            DATE,
  DATA_STATUS_PRSNL_ID         NUMBER           DEFAULT 0                     NOT NULL,
  INTERNAL_SEQ                 NUMBER           DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_BENEFIT_SCH_R
(
  PERSON_BENEFIT_SCH_R_ID  NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_BENEFIT_R_ID      NUMBER               DEFAULT 0                     NOT NULL,
  MEMBER_RESP_TYPE_CD      NUMBER               DEFAULT 0                     NOT NULL,
  RESP_RANGE_START_NBR     NUMBER               DEFAULT 0                     NOT NULL,
  RESP_RANGE_END_NBR       NUMBER               DEFAULT 0                     NOT NULL,
  RESP_TYPE_QUAL_CD        NUMBER               DEFAULT 0                     NOT NULL,
  RESP_RANGE_AMT           FLOAT(126)           DEFAULT 0                     NOT NULL,
  RESP_RANGE_QUAL_CD       NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER,
  ACTIVE_STATUS_CD         NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM      DATE,
  ACTIVE_STATUS_PRSNL_ID   NUMBER               DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM      DATE                 DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM      DATE                 DEFAULT TO_DATE ( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DATA_STATUS_CD           NUMBER               DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM        DATE,
  DATA_STATUS_PRSNL_ID     NUMBER               DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_CODE_VALUE_R
(
  PERSON_CODE_VALUE_R_ID  NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CODE_SET                NUMBER                DEFAULT 0                     NOT NULL,
  CODE_VALUE              NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0,
  ACTIVE_IND              NUMBER                DEFAULT 1,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' )
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_CODE_VALUE_R_HIST
(
  PERSON_CODE_VALUE_R_H_ID  NUMBER              DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID       NUMBER              DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM         DATE,
  CHANGE_BIT                NUMBER              DEFAULT 0                     NOT NULL,
  TRACKING_BIT              NUMBER              DEFAULT 0                     NOT NULL,
  CODE_SET                  NUMBER              DEFAULT 0                     NOT NULL,
  CODE_VALUE                NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE,
  END_EFFECTIVE_DT_TM       DATE,
  PERSON_ID                 NUMBER              DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_COMBINE
(
  PERSON_COMBINE_ID       NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  FROM_PERSON_ID          NUMBER                DEFAULT 0                     NOT NULL,
  TO_PERSON_ID            NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  COMBINE_ACTION_CD       NUMBER                DEFAULT 0                     NOT NULL,
  PREV_ACTIVE_IND         NUMBER,
  PREV_ACTIVE_STATUS_CD   NUMBER                DEFAULT 0                     NOT NULL,
  PREV_CONFID_LEVEL_CD    NUMBER                DEFAULT 0                     NOT NULL,
  ENCNTR_ID               NUMBER                DEFAULT 0                     NOT NULL,
  FROM_MRN                VARCHAR2(200 BYTE),
  FROM_ALIAS_POOL_CD      NUMBER                DEFAULT 0                     NOT NULL,
  FROM_ALIAS_TYPE_CD      NUMBER                DEFAULT 0                     NOT NULL,
  TO_MRN                  VARCHAR2(200 BYTE),
  TO_ALIAS_POOL_CD        NUMBER                DEFAULT 0                     NOT NULL,
  TO_ALIAS_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  APPLICATION_FLAG        NUMBER,
  COMBINE_WEIGHT          FLOAT(126),
  TRANSACTION_TYPE        VARCHAR2(8 BYTE),
  CMB_UPDT_ID             NUMBER,
  CMB_DT_TM               DATE,
  UCB_UPDT_ID             NUMBER,
  UCB_DT_TM               DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_COMBINE_DET
(
  PERSON_COMBINE_DET_ID   NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_COMBINE_ID       NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ENTITY_NAME             VARCHAR2(32 BYTE)     DEFAULT ' '                   NOT NULL,
  ENTITY_ID               NUMBER                DEFAULT 0                     NOT NULL,
  COMBINE_ACTION_CD       NUMBER                DEFAULT 0                     NOT NULL,
  ATTRIBUTE_NAME          VARCHAR2(32 BYTE),
  PREV_ACTIVE_IND         NUMBER,
  PREV_ACTIVE_STATUS_CD   NUMBER                DEFAULT 0                     NOT NULL,
  COMBINE_DESC_CD         NUMBER                DEFAULT 0                     NOT NULL,
  PREV_END_EFF_DT_TM      DATE,
  TO_RECORD_IND           NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_DOCUMENT
(
  DOCUMENT_ID             NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  DOCUMENT_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  DOCUMENT_LAST_DT_TM     DATE,
  DOCUMENT_LOCATION       VARCHAR2(100 BYTE),
  DOCUMENT_DESC           VARCHAR2(100 BYTE),
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_FLEX_HIST
(
  PERSON_FLEX_HIST_ID         NUMBER            DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID         NUMBER            DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM           DATE,
  CHANGE_BIT                  NUMBER            DEFAULT 0                     NOT NULL,
  TRACKING_BIT                NUMBER            DEFAULT 0                     NOT NULL,
  PERSON_ID                   NUMBER            DEFAULT 0                     NOT NULL,
  BIRTH_DT_TM                 DATE,
  SEX_CD                      NUMBER            DEFAULT 0                     NOT NULL,
  LANGUAGE_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  RACE_CD                     NUMBER            DEFAULT 0                     NOT NULL,
  DECEASED_CD                 NUMBER            DEFAULT 0                     NOT NULL,
  DECEASED_DT_TM              DATE,
  DECEASED_SOURCE_CD          NUMBER            DEFAULT 0                     NOT NULL,
  CAUSE_OF_DEATH              VARCHAR2(100 BYTE),
  CAUSE_OF_DEATH_CD           NUMBER            DEFAULT 0                     NOT NULL,
  AUTOPSY_CD                  NUMBER            DEFAULT 0                     NOT NULL,
  ETHNIC_GRP_CD               NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_IND                  NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM         DATE              DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID      NUMBER            DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD            NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_ID                     NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                  DATE              DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK                   NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                NUMBER            DEFAULT 0                     NOT NULL,
  UPDT_CNT                    NUMBER            DEFAULT 0                     NOT NULL,
  MARITAL_TYPE_CD             NUMBER            DEFAULT 0                     NOT NULL,
  BIRTH_TZ                    NUMBER            DEFAULT 0,
  DECEASED_ID_METHOD_CD       NUMBER            DEFAULT 0,
  ARCHIVE_STATUS_CD           NUMBER            DEFAULT 0,
  ARCHIVE_STATUS_DT_TM        DATE,
  LAST_ACCESSED_DT_TM         DATE              DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  NEXT_RESTORE_DT_TM          DATE,
  AGE_AT_DEATH                NUMBER            DEFAULT 0,
  ARCHIVE_ENV_ID              NUMBER            DEFAULT 0,
  AGE_AT_DEATH_UNIT_CD        NUMBER            DEFAULT 0,
  AGE_AT_DEATH_PREC_MOD_FLAG  NUMBER            DEFAULT 0,
  DECEASED_TZ                 NUMBER            DEFAULT 0,
  DECEASED_DT_TM_PREC_FLAG    NUMBER            DEFAULT 0,
  LOGICAL_DOMAIN_ID           NUMBER            DEFAULT 0,
  NAME_MIDDLE_KEY_A_NLS       VARCHAR2(400 BYTE),
  NAME_LAST_KEY_A_NLS         VARCHAR2(400 BYTE),
  NAME_FIRST_KEY_A_NLS        VARCHAR2(400 BYTE),
  PERSON_STATUS_CD            NUMBER            DEFAULT 0,
  CREATE_DT_TM                DATE,
  CREATE_PRSNL_ID             NUMBER            DEFAULT 0,
  END_EFFECTIVE_DT_TM         DATE              DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  PERSON_TYPE_CD              NUMBER            DEFAULT 0,
  NAME_LAST_KEY               VARCHAR2(100 BYTE),
  NAME_FIRST_KEY              VARCHAR2(100 BYTE),
  BEG_EFFECTIVE_DT_TM         DATE              DEFAULT SYSDATE,
  NAME_FULL_FORMATTED         VARCHAR2(100 BYTE),
  BIRTH_DT_CD                 NUMBER            DEFAULT 0,
  CONCEPTION_DT_TM            DATE,
  PURGE_OPTION_CD             NUMBER            DEFAULT 0,
  RELIGION_CD                 NUMBER            DEFAULT 0,
  SEX_AGE_CHANGE_IND          NUMBER,
  DATA_STATUS_CD              NUMBER            DEFAULT 0,
  DATA_STATUS_DT_TM           DATE,
  DATA_STATUS_PRSNL_ID        NUMBER            DEFAULT 0,
  CONTRIBUTOR_SYSTEM_CD       NUMBER            DEFAULT 0,
  LANGUAGE_DIALECT_CD         NUMBER            DEFAULT 0,
  NAME_LAST                   VARCHAR2(200 BYTE),
  NAME_FIRST                  VARCHAR2(200 BYTE),
  NAME_PHONETIC               CHAR(8 BYTE),
  LAST_ENCNTR_DT_TM           DATE,
  SPECIES_CD                  NUMBER            DEFAULT 0,
  CONFID_LEVEL_CD             NUMBER            DEFAULT 0,
  VIP_CD                      NUMBER            DEFAULT 0,
  NAME_FIRST_SYNONYM_ID       NUMBER            DEFAULT 0,
  CITIZENSHIP_CD              NUMBER            DEFAULT 0,
  VET_MILITARY_STATUS_CD      NUMBER            DEFAULT 0,
  MOTHER_MAIDEN_NAME          VARCHAR2(100 BYTE),
  NATIONALITY_CD              NUMBER            DEFAULT 0,
  FT_ENTITY_NAME              VARCHAR2(32 BYTE),
  FT_ENTITY_ID                NUMBER            DEFAULT 0,
  NAME_MIDDLE_KEY             VARCHAR2(100 BYTE),
  NAME_LAST_PHONETIC          VARCHAR2(8 BYTE),
  NAME_MIDDLE                 VARCHAR2(200 BYTE),
  NAME_LAST_KEY_NLS           VARCHAR2(202 BYTE),
  NAME_FIRST_KEY_NLS          VARCHAR2(202 BYTE),
  NAME_MIDDLE_KEY_NLS         VARCHAR2(202 BYTE),
  NAME_FIRST_PHONETIC         VARCHAR2(8 BYTE),
  MILITARY_RANK_CD            NUMBER            DEFAULT 0,
  MILITARY_BASE_LOCATION      VARCHAR2(100 BYTE),
  MILITARY_SERVICE_CD         NUMBER            DEFAULT 0,
  BIRTH_PREC_FLAG             NUMBER,
  ABS_BIRTH_DT_TM             DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_HLA_AB_SCN_AUDIT
(
  HLA_AB_SCN_AUDIT_ID   NUMBER                  DEFAULT 0                     NOT NULL,
  PERSON_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  HLA_AB_SCREEN_ID      NUMBER                  DEFAULT 0                     NOT NULL,
  AUDIT_DT_TM           DATE,
  T_CELL_PRA            NUMBER,
  B_CELL_PRA            NUMBER,
  METHODOLOGY_NOM_ID    NUMBER                  DEFAULT 0                     NOT NULL,
  DILUTION_NOM_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  PRSNL_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  ANTIBODY_DT_TM        DATE,
  ANTIBODIES            VARCHAR2(200 BYTE),
  COMMENT_LONG_TEXT_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  SPECIMEN_TYPE_CD      NUMBER                  DEFAULT 0                     NOT NULL,
  REACTION_NOM_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  OUTSIDE_SCREEN_IND    NUMBER                  DEFAULT 0,
  FLAG_IND              NUMBER                  DEFAULT 0,
  STORAGE_IND           NUMBER                  DEFAULT 0,
  POSSIBLE_AB_STRING    VARCHAR2(255 BYTE),
  COMPLETE_DT_TM        DATE,
  CHARTED_IND           NUMBER,
  OD_RATIO_VALUE        NUMBER                  DEFAULT -1,
  OD_VALUE              NUMBER                  DEFAULT -1
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_HLA_AB_SCREEN
(
  HLA_AB_SCREEN_ID       NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  ANTIBODY_DT_TM         DATE,
  T_CELL_PRA             FLOAT(126),
  B_CELL_PRA             FLOAT(126),
  METHODOLOGY_NOM_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  DILUTION_NOM_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  PRSNL_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  COMMENT_LONG_TEXT_ID   NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  REMOVED_DT_TM          DATE,
  REMOVED_IND            NUMBER,
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  SPECIMEN_TYPE_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  CHARTED_IND            NUMBER                 DEFAULT 0,
  REACTION_NOM_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  ACCESSION              CHAR(20 BYTE),
  MAP_SEQ_NUMBER         NUMBER,
  OUTSIDE_SCREEN_IND     NUMBER                 DEFAULT 0,
  FLAG_IND               NUMBER                 DEFAULT 0,
  STORAGE_IND            NUMBER                 DEFAULT 0,
  POSSIBLE_AB_STRING     VARCHAR2(255 BYTE),
  COMPLETE_DT_TM         DATE,
  OD_RATIO_VALUE         NUMBER                 DEFAULT -1,
  OD_VALUE               NUMBER                 DEFAULT -1
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_HLA_AB_SPEC
(
  HLA_AB_SPEC_ID    NUMBER                      DEFAULT 0                     NOT NULL,
  PERSON_ID         NUMBER                      DEFAULT 0                     NOT NULL,
  HLA_TYPE_NOM_ID   NUMBER                      DEFAULT 0                     NOT NULL,
  ORDER_ID          NUMBER                      DEFAULT 0                     NOT NULL,
  HLA_AB_SCREEN_ID  NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_DT_TM        DATE                        DEFAULT SYSDATE               NOT NULL,
  UPDT_ID           NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_TASK         NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_CNT          NUMBER                      DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX      NUMBER                      DEFAULT 0                     NOT NULL,
  MAP_AB_DTA_CD     NUMBER                      DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_HLA_EVENT
(
  HLA_EVENT_ID           NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  HLA_EVENT_DT_TM        DATE,
  HLA_EVENT_TYPE_CD      NUMBER                 DEFAULT 0                     NOT NULL,
  HLA_EVENT_TEXT_ID      NUMBER                 DEFAULT 0                     NOT NULL,
  PRSNL_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  REMOVED_DT_TM          DATE,
  REMOVED_IND            NUMBER,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_HLA_EVENT_AUDIT
(
  HLA_EVENT_AUDIT_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  PERSON_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  HLA_EVENT_ID        NUMBER                    DEFAULT 0                     NOT NULL,
  AUDIT_DT_TM         DATE,
  HLA_EVENT_DT_TM     DATE,
  HLA_EVENT_TYPE_CD   NUMBER                    DEFAULT 0                     NOT NULL,
  HLA_EVENT_TEXT_ID   NUMBER                    DEFAULT 0                     NOT NULL,
  PRSNL_ID            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_HLA_TYPE
(
  HLA_TYPE_ID            NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_ID              NUMBER                 DEFAULT 0                     NOT NULL,
  LOCI_CD                NUMBER                 DEFAULT 0                     NOT NULL,
  HLA_TYPE_NOM_ID        NUMBER                 DEFAULT 0                     NOT NULL,
  HLA_DT_TM              DATE,
  OUTSIDE_TYPING_IND     NUMBER,
  PRSNL_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  ORDER_ID               NUMBER                 DEFAULT 0                     NOT NULL,
  COMMENT_LONG_TEXT_ID   NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  REMOVED_DT_TM          DATE,
  REMOVED_IND            NUMBER,
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  SPECIMEN_TYPE_CD       NUMBER                 DEFAULT 0                     NOT NULL,
  REFERENCE_NBR          VARCHAR2(60 BYTE)      DEFAULT ' '                   NOT NULL,
  CHARTED_IND            NUMBER,
  ACCESSION              CHAR(20 BYTE),
  PRELIMINARY_IND        NUMBER,
  COMPLETE_DT_TM         DATE,
  TASK_ASSAY_CD          NUMBER                 DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_HLA_TYPE_AUDIT
(
  HLA_TYPE_AUDIT_ID     NUMBER                  DEFAULT 0                     NOT NULL,
  PERSON_ID             NUMBER                  DEFAULT 0                     NOT NULL,
  HLA_TYPE_ID           NUMBER                  DEFAULT 0                     NOT NULL,
  AUDIT_DT_TM           DATE,
  LOCI_CD               NUMBER                  DEFAULT 0                     NOT NULL,
  HLA_TYPE_NOM_ID       NUMBER                  DEFAULT 0                     NOT NULL,
  HLA_DT_TM             DATE,
  OUTSIDE_TYPING_IND    NUMBER,
  PRSNL_ID              NUMBER                  DEFAULT 0                     NOT NULL,
  COMMENT_LONG_TEXT_ID  NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_DT_TM            DATE                    DEFAULT SYSDATE               NOT NULL,
  UPDT_ID               NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_TASK             NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_CNT              NUMBER                  DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX          NUMBER                  DEFAULT 0                     NOT NULL,
  SPECIMEN_TYPE_CD      NUMBER                  DEFAULT 0                     NOT NULL,
  COMPLETE_DT_TM        DATE,
  TASK_ASSAY_CD         NUMBER                  DEFAULT 0,
  CHARTED_IND           NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_HLA_XM
(
  HLA_XM_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  PERSON_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  XM_DT_TM                     DATE,
  XM_TYPE_NOM_ID               NUMBER           DEFAULT 0                     NOT NULL,
  T_CELL_RESULT_NOM_ID         NUMBER           DEFAULT 0                     NOT NULL,
  B_CELL_RESULT_NOM_ID         NUMBER           DEFAULT 0                     NOT NULL,
  TB_CELL_RESULT_NOM_ID        NUMBER           DEFAULT 0                     NOT NULL,
  MONO_CELL_RESULT_NOM_ID      NUMBER           DEFAULT 0                     NOT NULL,
  INTERPRETATION_LONG_TEXT_ID  NUMBER           DEFAULT 0                     NOT NULL,
  ACCESSION                    CHAR(20 BYTE),
  DONOR_ID                     NUMBER           DEFAULT 0                     NOT NULL,
  COMMENT_LONG_TEXT_ID         NUMBER           DEFAULT 0                     NOT NULL,
  PRSNL_ID                     NUMBER           DEFAULT 0                     NOT NULL,
  ORDER_ID                     NUMBER           DEFAULT 0                     NOT NULL,
  HLA_XM_RES_TRAY_ID           NUMBER           DEFAULT 0                     NOT NULL,
  CHARTED_IND                  NUMBER,
  OUTSIDE_XM_IND               NUMBER,
  CONTRIBUTOR_SYSTEM_CD        NUMBER           DEFAULT 0                     NOT NULL,
  REMOVED_IND                  NUMBER,
  REMOVED_DT_TM                DATE,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  COMPLETE_DT_TM               DATE
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_HLA_XM_AUDIT
(
  HLA_XM_AUDIT_ID              NUMBER           DEFAULT 0                     NOT NULL,
  HLA_XM_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  AUDIT_DT_TM                  DATE,
  XM_DT_TM                     DATE,
  XM_TYPE_NOM_ID               NUMBER           DEFAULT 0                     NOT NULL,
  T_CELL_RESULT_NOM_ID         NUMBER           DEFAULT 0                     NOT NULL,
  B_CELL_RESULT_NOM_ID         NUMBER           DEFAULT 0                     NOT NULL,
  TB_CELL_RESULT_NOM_ID        NUMBER           DEFAULT 0                     NOT NULL,
  MONO_CELL_RESULT_NOM_ID      NUMBER           DEFAULT 0                     NOT NULL,
  INTERPRETATION_LONG_TEXT_ID  NUMBER           DEFAULT 0                     NOT NULL,
  DONOR_ID                     NUMBER           DEFAULT 0                     NOT NULL,
  COMMENT_LONG_TEXT_ID         NUMBER           DEFAULT 0                     NOT NULL,
  PRSNL_ID                     NUMBER           DEFAULT 0                     NOT NULL,
  OUTSIDE_XM_IND               NUMBER,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  COMPLETE_DT_TM               DATE,
  CHARTED_IND                  NUMBER
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_INFO
(
  PERSON_INFO_ID          NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  INFO_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  INFO_SUB_TYPE_CD        NUMBER                DEFAULT 0,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  LONG_TEXT_ID            NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_NUMERIC           NUMBER,
  VALUE_DT_TM             DATE,
  CHARTABLE_IND           NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ            NUMBER,
  INTERNAL_SEQ            NUMBER,
  VALUE_CD                NUMBER                DEFAULT 0,
  VALUE_NUMERIC_IND       NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_INFO_HIST
(
  PERSON_INFO_HIST_ID     NUMBER                DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID     NUMBER                DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM       DATE,
  CHANGE_BIT              NUMBER                DEFAULT 0                     NOT NULL,
  TRACKING_BIT            NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_INFO_ID          NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  INFO_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  CHARTABLE_IND           NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_LONG_TEXT_ID      NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_TYPE              FLOAT(126)            DEFAULT 0                     NOT NULL,
  VALUE_DT_TM             DATE,
  PRIORITY_SEQ            NUMBER,
  INTERNAL_SEQ            NUMBER,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_NUMERIC           NUMBER                DEFAULT 0                     NOT NULL,
  INFO_SUB_TYPE_CD        NUMBER                DEFAULT 0                     NOT NULL,
  VALUE_CD                NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_MATCHES
(
  PERSON_MATCHES_ID       NUMBER                DEFAULT 0                     NOT NULL,
  A_PERSON_ID             NUMBER                DEFAULT 0                     NOT NULL,
  B_PERSON_ID             NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  A_NAME_LAST_KEY         VARCHAR2(100 BYTE),
  B_NAME_LAST_KEY         VARCHAR2(100 BYTE),
  A_NAME_FIRST_KEY        VARCHAR2(100 BYTE),
  B_NAME_FIRST_KEY        VARCHAR2(100 BYTE),
  A_NAME_MIDDLE           VARCHAR2(100 BYTE),
  B_NAME_MIDDLE           VARCHAR2(100 BYTE),
  A_BIRTH_DT_CD           NUMBER                DEFAULT 0                     NOT NULL,
  B_BIRTH_DT_CD           NUMBER                DEFAULT 0                     NOT NULL,
  A_BIRTH_DT_TM           DATE,
  B_BIRTH_DT_TM           DATE,
  A_SEX_CD                NUMBER                DEFAULT 0                     NOT NULL,
  B_SEX_CD                NUMBER                DEFAULT 0                     NOT NULL,
  A_PHONETIC              CHAR(8 BYTE),
  B_PHONETIC              CHAR(8 BYTE),
  A_SSN_ALIAS             VARCHAR2(200 BYTE),
  B_SSN_ALIAS             VARCHAR2(200 BYTE),
  A_CREATE_PRSNL_ID       NUMBER                DEFAULT 0                     NOT NULL,
  B_CREATE_PRSNL_ID       NUMBER                DEFAULT 0                     NOT NULL,
  A_ACTIVE_STATUS_CD      NUMBER                DEFAULT 0                     NOT NULL,
  B_ACTIVE_STATUS_CD      NUMBER                DEFAULT 0                     NOT NULL,
  A_ALIAS                 VARCHAR2(200 BYTE),
  B_ALIAS                 VARCHAR2(200 BYTE),
  A_ALIAS_TYPE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  B_ALIAS_TYPE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  A_ALIAS_POOL_CD         NUMBER                DEFAULT 0                     NOT NULL,
  B_ALIAS_POOL_CD         NUMBER                DEFAULT 0                     NOT NULL,
  MATCH_STATUS_CD         NUMBER                DEFAULT 0                     NOT NULL,
  MATCH_DT_TM             DATE,
  MATCH_SOURCE_CD         NUMBER                DEFAULT 0                     NOT NULL,
  MATCH_WEIGHT            FLOAT(126),
  MATCH_STATUS_DT_TM      DATE,
  EXCEPTION_TYPE_CD       NUMBER                DEFAULT 0                     NOT NULL,
  MATCH_STATUS_CHG_DT_TM  DATE,
  A_BIRTH_TZ              NUMBER                DEFAULT 0,
  B_BIRTH_TZ              NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_MATCH_REV
(
  PERSON_MATCH_REV_ID     NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  MATCH_REV_FLAG          NUMBER,
  A_PERSON_ID             NUMBER                DEFAULT 0                     NOT NULL,
  B_PERSON_ID             NUMBER                DEFAULT 0                     NOT NULL,
  A_ALIAS1                VARCHAR2(200 BYTE),
  A_ALIAS_TYPE1_CD        NUMBER                DEFAULT 0                     NOT NULL,
  A_ALIAS_POOL1_CD        NUMBER                DEFAULT 0                     NOT NULL,
  B_ALIAS1                VARCHAR2(200 BYTE),
  B_ALIAS_TYPE1_CD        NUMBER                DEFAULT 0                     NOT NULL,
  B_ALIAS_POOL1_CD        NUMBER                DEFAULT 0                     NOT NULL,
  MATCH_VAL1_CD           NUMBER                DEFAULT 0                     NOT NULL,
  A_ALIAS2                VARCHAR2(200 BYTE),
  A_ALIAS_TYPE2_CD        NUMBER                DEFAULT 0                     NOT NULL,
  A_ALIAS_POOL2_CD        NUMBER                DEFAULT 0                     NOT NULL,
  B_ALIAS2                VARCHAR2(200 BYTE),
  B_ALIAS_TYPE2_CD        NUMBER                DEFAULT 0                     NOT NULL,
  B_ALIAS_POOL2_CD        NUMBER                DEFAULT 0                     NOT NULL,
  MATCH_VAL2_CD           NUMBER                DEFAULT 0                     NOT NULL,
  A_ALIAS3                VARCHAR2(200 BYTE),
  A_ALIAS_TYPE3_CD        NUMBER                DEFAULT 0                     NOT NULL,
  A_ALIAS_POOL3_CD        NUMBER                DEFAULT 0                     NOT NULL,
  B_ALIAS3                VARCHAR2(200 BYTE),
  B_ALIAS_TYPE3_CD        NUMBER                DEFAULT 0                     NOT NULL,
  B_ALIAS_POOL3_CD        NUMBER                DEFAULT 0                     NOT NULL,
  MATCH_VAL3_CD           NUMBER                DEFAULT 0                     NOT NULL,
  A_NAME_LAST_KEY         VARCHAR2(100 BYTE),
  B_NAME_LAST_KEY         VARCHAR2(100 BYTE),
  MATCH_VAL4_CD           NUMBER                DEFAULT 0                     NOT NULL,
  A_NAME_FIRST_KEY        VARCHAR2(100 BYTE),
  B_NAME_FIRST_KEY        VARCHAR2(100 BYTE),
  MATCH_VAL5_CD           NUMBER                DEFAULT 0                     NOT NULL,
  A_NAME_FULL             VARCHAR2(100 BYTE),
  B_NAME_FULL             VARCHAR2(100 BYTE),
  MATCH_VAL6_CD           NUMBER                DEFAULT 0                     NOT NULL,
  A_BIRTH_DT_TM           DATE,
  B_BIRTH_DT_TM           DATE,
  MATCH_VAL7_CD           NUMBER                DEFAULT 0                     NOT NULL,
  A_SEX_CD                NUMBER                DEFAULT 0                     NOT NULL,
  B_SEX_CD                NUMBER                DEFAULT 0                     NOT NULL,
  MATCH_VAL8_CD           NUMBER                DEFAULT 0                     NOT NULL,
  MATCH_DT_TM             DATE,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_NAME
(
  PERSON_NAME_ID          NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  NAME_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ),
  NAME_ORIGINAL           VARCHAR2(100 BYTE),
  NAME_FORMAT_CD          NUMBER                DEFAULT 0                     NOT NULL,
  NAME_FULL               VARCHAR2(100 BYTE),
  NAME_FIRST              VARCHAR2(100 BYTE),
  NAME_MIDDLE             VARCHAR2(100 BYTE),
  NAME_LAST               VARCHAR2(100 BYTE),
  NAME_DEGREE             VARCHAR2(100 BYTE),
  NAME_TITLE              VARCHAR2(100 BYTE),
  NAME_PREFIX             VARCHAR2(100 BYTE),
  NAME_SUFFIX             VARCHAR2(100 BYTE),
  NAME_INITIALS           VARCHAR2(100 BYTE),
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  NAME_FIRST_KEY          VARCHAR2(100 BYTE),
  NAME_FIRST_KEY_NLS      VARCHAR2(202 BYTE),
  NAME_LAST_KEY           VARCHAR2(100 BYTE),
  NAME_LAST_KEY_NLS       VARCHAR2(202 BYTE),
  NAME_MIDDLE_KEY         VARCHAR2(100 BYTE),
  NAME_MIDDLE_KEY_NLS     VARCHAR2(202 BYTE),
  SOURCE_IDENTIFIER       VARCHAR2(255 BYTE),
  NAME_TYPE_SEQ           NUMBER                DEFAULT 0,
  NAME_FIRST_KEY_A_NLS    VARCHAR2(400 BYTE),
  NAME_LAST_KEY_A_NLS     VARCHAR2(400 BYTE),
  NAME_MIDDLE_KEY_A_NLS   VARCHAR2(400 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_NAME_HIST
(
  PERSON_NAME_HIST_ID     NUMBER                DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID     NUMBER                DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM       DATE,
  CHANGE_BIT              NUMBER                DEFAULT 0                     NOT NULL,
  TRACKING_BIT            NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_NAME_ID          NUMBER                DEFAULT 0                     NOT NULL,
  NAME_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  NAME_FIRST              VARCHAR2(100 BYTE),
  NAME_FIRST_KEY          VARCHAR2(100 BYTE),
  NAME_FIRST_KEY_NLS      VARCHAR2(202 BYTE),
  NAME_LAST               VARCHAR2(100 BYTE),
  NAME_LAST_KEY           VARCHAR2(100 BYTE),
  NAME_LAST_KEY_NLS       VARCHAR2(202 BYTE),
  NAME_MIDDLE             VARCHAR2(100 BYTE),
  NAME_MIDDLE_KEY         VARCHAR2(100 BYTE),
  NAME_MIDDLE_KEY_NLS     VARCHAR2(202 BYTE),
  NAME_FULL               VARCHAR2(100 BYTE),
  NAME_DEGREE             VARCHAR2(100 BYTE),
  NAME_INITIALS           VARCHAR2(100 BYTE),
  NAME_PREFIX             VARCHAR2(100 BYTE),
  NAME_SUFFIX             VARCHAR2(100 BYTE),
  NAME_TITLE              VARCHAR2(100 BYTE),
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  NAME_FIRST_KEY_A_NLS    VARCHAR2(400 BYTE),
  NAME_LAST_KEY_A_NLS     VARCHAR2(400 BYTE),
  NAME_MIDDLE_KEY_A_NLS   VARCHAR2(400 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_ORGAN_DONOR
(
  PERSON_ORGAN_ID         NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  ORGAN_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  DONOR_TYPE_CD           NUMBER                DEFAULT 0                     NOT NULL,
  ORGAN_SIZE              FLOAT(126),
  UNOS_ASSIGNED_IND       NUMBER,
  NMDP_ASSIGNED_IND       NUMBER,
  CURRENT_DRUG_THERAPY    VARCHAR2(255 BYTE),
  DONATION_IND            NUMBER,
  DONATION_DT_TM          DATE,
  COMMENT_LONG_TEXT_ID    NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UNOS_ALIAS_ID           NUMBER                DEFAULT 0                     NOT NULL,
  NMDP_ALIAS_ID           NUMBER                DEFAULT 0                     NOT NULL,
  OPO_ALIAS_ID            NUMBER                DEFAULT 0                     NOT NULL,
  INTL_ALIAS_ID           NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_ORG_RELTN
(
  PERSON_ORG_RELTN_ID     NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ORG_RELTN_CD     NUMBER                DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID         NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DATA_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM       DATE,
  DATA_STATUS_PRSNL_ID    NUMBER                DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ORG_NBR          VARCHAR2(100 BYTE),
  PERSON_ORG_ALIAS        VARCHAR2(100 BYTE),
  EMPL_TYPE_CD            NUMBER                DEFAULT 0                     NOT NULL,
  EMPL_STATUS_CD          NUMBER                DEFAULT 0                     NOT NULL,
  EMPL_OCCUPATION_TEXT    VARCHAR2(100 BYTE),
  EMPL_OCCUPATION_CD      NUMBER                DEFAULT 0                     NOT NULL,
  EMPL_TITLE              VARCHAR2(100 BYTE),
  EMPL_POSITION           VARCHAR2(100 BYTE),
  EMPL_CONTACT            VARCHAR2(100 BYTE),
  EMPL_CONTACT_TITLE      VARCHAR2(100 BYTE),
  FREE_TEXT_IND           NUMBER,
  FT_ORG_NAME             VARCHAR2(100 BYTE),
  PRIORITY_SEQ            NUMBER,
  INTERNAL_SEQ            NUMBER,
  EMPL_RETIRE_DT_TM       DATE,
  EMPL_HIRE_DT_TM         DATE,
  EMPL_TERM_DT_TM         DATE,
  SOURCE_IDENTIFIER       VARCHAR2(255 BYTE)
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_ORG_RELTN_HIST
(
  PERSON_ORG_RELTN_HIST_ID  NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ORG_RELTN_ID       NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ORG_RELTN_CD       NUMBER              DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID           NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_PATIENT
(
  PERSON_ID                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_CNT                   NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                 DATE               DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                    NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_TASK                  NUMBER             DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX               NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_IND                 NUMBER,
  ACTIVE_STATUS_CD           NUMBER             DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM        DATE,
  ACTIVE_STATUS_PRSNL_ID     NUMBER             DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM        DATE               DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM        DATE               DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  ADOPTED_CD                 NUMBER             DEFAULT 0                     NOT NULL,
  BAD_DEBT_CD                NUMBER             DEFAULT 0                     NOT NULL,
  BAPTISED_CD                NUMBER             DEFAULT 0                     NOT NULL,
  BIRTH_MULTIPLE_CD          NUMBER             DEFAULT 0                     NOT NULL,
  BIRTH_ORDER                NUMBER,
  BIRTH_LENGTH               FLOAT(126),
  BIRTH_LENGTH_UNITS_CD      NUMBER             DEFAULT 0                     NOT NULL,
  BIRTH_NAME                 VARCHAR2(100 BYTE),
  BIRTH_WEIGHT               FLOAT(126),
  BIRTH_WEIGHT_UNITS_CD      NUMBER             DEFAULT 0                     NOT NULL,
  CHURCH_CD                  NUMBER             DEFAULT 0                     NOT NULL,
  CREDIT_HRS_TAKING          NUMBER,
  CUMM_LEAVE_DAYS            NUMBER,
  CURRENT_BALANCE            FLOAT(126),
  CURRENT_GRADE              NUMBER,
  CUSTODY_CD                 NUMBER             DEFAULT 0                     NOT NULL,
  DEGREE_COMPLETE_CD         NUMBER             DEFAULT 0                     NOT NULL,
  DIET_TYPE_CD               NUMBER             DEFAULT 0                     NOT NULL,
  FAMILY_INCOME              FLOAT(126),
  FAMILY_SIZE                NUMBER,
  HIGHEST_GRADE_COMPLETE_CD  NUMBER             DEFAULT 0                     NOT NULL,
  IMMUN_ON_FILE_CD           NUMBER             DEFAULT 0                     NOT NULL,
  INTERP_REQUIRED_CD         NUMBER             DEFAULT 0                     NOT NULL,
  INTERP_TYPE_CD             NUMBER             DEFAULT 0                     NOT NULL,
  MICROFILM_CD               NUMBER             DEFAULT 0                     NOT NULL,
  NBR_OF_BROTHERS            NUMBER,
  NBR_OF_SISTERS             NUMBER,
  ORGAN_DONOR_CD             NUMBER             DEFAULT 0                     NOT NULL,
  PARENT_MARITAL_STATUS_CD   NUMBER             DEFAULT 0                     NOT NULL,
  SMOKES_CD                  NUMBER             DEFAULT 0                     NOT NULL,
  TUMOR_REGISTRY_CD          NUMBER             DEFAULT 0                     NOT NULL,
  LAST_BILL_DT_TM            DATE,
  LAST_BIND_DT_TM            DATE,
  LAST_DISCHARGE_DT_TM       DATE,
  LAST_EVENT_UPDT_DT_TM      DATE,
  LAST_PAYMENT_DT_TM         DATE,
  LAST_ATD_ACTIVITY_DT_TM    DATE,
  DATA_STATUS_CD             NUMBER             DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM          DATE,
  DATA_STATUS_PRSNL_ID       NUMBER             DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD      NUMBER             DEFAULT 0                     NOT NULL,
  STUDENT_CD                 NUMBER             DEFAULT 0                     NOT NULL,
  LIVING_DEPENDENCY_CD       NUMBER             DEFAULT 0                     NOT NULL,
  LIVING_ARRANGEMENT_CD      NUMBER             DEFAULT 0                     NOT NULL,
  LIVING_WILL_CD             NUMBER             DEFAULT 0                     NOT NULL,
  NBR_OF_PREGNANCIES         NUMBER,
  LAST_TRAUMA_DT_TM          DATE,
  MOTHER_IDENTIFIER          VARCHAR2(100 BYTE),
  MOTHER_IDENTIFIER_CD       NUMBER             DEFAULT 0                     NOT NULL,
  DISEASE_ALERT_CD           NUMBER             DEFAULT 0                     NOT NULL,
  PROCESS_ALERT_CD           NUMBER             DEFAULT 0                     NOT NULL,
  CONTACT_LIST_CD            NUMBER             DEFAULT 0                     NOT NULL,
  GEST_AGE_AT_BIRTH          NUMBER,
  GEST_AGE_METHOD_CD         NUMBER             DEFAULT 0                     NOT NULL,
  CONTACT_TIME               VARCHAR2(255 BYTE),
  CALLBACK_CONSENT_CD        NUMBER             DEFAULT 0                     NOT NULL,
  CONTACT_METHOD_CD          NUMBER             DEFAULT 0                     NOT NULL,
  SOURCE_LAST_SYNC_DT_TM     DATE,
  SOURCE_VERSION_NUMBER      VARCHAR2(255 BYTE),
  BIRTH_ORDER_CD             NUMBER             DEFAULT 0,
  PREV_CONTACT_IND           NUMBER             DEFAULT 0,
  WRITTEN_FORMAT_CD          NUMBER             DEFAULT 0,
  SOURCE_SYNC_LEVEL_FLAG     NUMBER             DEFAULT 0,
  IQH_PARTICIPANT_CD         NUMBER             DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_PATIENT_HIST
(
  PERSON_PATIENT_HIST_ID  NUMBER                DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID     NUMBER                DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM       DATE,
  CHANGE_BIT              NUMBER                DEFAULT 0                     NOT NULL,
  TRACKING_BIT            NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_ID               NUMBER                DEFAULT 0                     NOT NULL,
  LIVING_WILL_CD          NUMBER                DEFAULT 0                     NOT NULL,
  ORGAN_DONOR_CD          NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER                NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  GEST_AGE_AT_BIRTH       NUMBER,
  GEST_AGE_METHOD_CD      NUMBER                DEFAULT 0                     NOT NULL,
  INTERP_REQUIRED_CD      NUMBER                DEFAULT 0,
  CALLBACK_CONSENT_CD     NUMBER                DEFAULT 0,
  BIRTH_ORDER_CD          NUMBER                DEFAULT 0,
  PREV_CONTACT_IND        NUMBER                DEFAULT 0,
  WRITTEN_FORMAT_CD       NUMBER                DEFAULT 0,
  CONTACT_METHOD_CD       NUMBER                DEFAULT 0,
  CONTACT_TIME            VARCHAR2(255 BYTE),
  IQH_PARTICIPANT_CD      NUMBER                DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_PERSON_RELTN
(
  PERSON_PERSON_RELTN_ID    NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_RELTN_TYPE_CD      NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_ID                 NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_RELTN_CD           NUMBER              DEFAULT 0                     NOT NULL,
  RELATED_PERSON_RELTN_CD   NUMBER              DEFAULT 0                     NOT NULL,
  RELATED_PERSON_ID         NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER,
  ACTIVE_STATUS_CD          NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM       DATE,
  ACTIVE_STATUS_PRSNL_ID    NUMBER              DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM       DATE                DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM       DATE                DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  DATA_STATUS_CD            NUMBER              DEFAULT 0                     NOT NULL,
  DATA_STATUS_DT_TM         DATE,
  DATA_STATUS_PRSNL_ID      NUMBER              DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD     NUMBER              DEFAULT 0                     NOT NULL,
  CONTACT_ROLE_CD           NUMBER              DEFAULT 0                     NOT NULL,
  GENETIC_RELATIONSHIP_IND  NUMBER,
  LIVING_WITH_IND           NUMBER,
  VISITATION_ALLOWED_CD     NUMBER              DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ              NUMBER,
  FREE_TEXT_CD              NUMBER              DEFAULT 0                     NOT NULL,
  FT_REL_PERSON_NAME        VARCHAR2(100 BYTE),
  INTERNAL_SEQ              NUMBER,
  DEFAULT_RELTN_IND         NUMBER              DEFAULT 0,
  FAMILY_RELTN_SUB_TYPE_CD  NUMBER              DEFAULT 0,
  COPY_CORRESPONDENCE_CD    NUMBER              DEFAULT 0,
  SOURCE_IDENTIFIER         VARCHAR2(255 BYTE),
  RELATION_SEQ              NUMBER              DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_PERSON_RELTN_HIST
(
  PERSON_PERSON_RELTN_HIST_ID  NUMBER           DEFAULT 0                     NOT NULL,
  PERSON_PERSON_RELTN_ID       NUMBER           DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM            DATE,
  COPY_CORRESPONDENCE_CD       NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_IND                   NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_CNT                     NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_ID                      NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_TASK                    NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                 NUMBER           DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                   DATE             DEFAULT SYSDATE               NOT NULL,
  PERSON_ID                    NUMBER           DEFAULT 0                     NOT NULL,
  PERSON_RELTN_TYPE_CD         NUMBER           DEFAULT 0                     NOT NULL,
  PERSON_RELTN_CD              NUMBER           DEFAULT 0                     NOT NULL,
  RELATED_PERSON_RELTN_CD      NUMBER           DEFAULT 0                     NOT NULL,
  RELATED_PERSON_ID            NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_CD             NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_PRSNL_ID       NUMBER           DEFAULT 0                     NOT NULL,
  DATA_STATUS_CD               NUMBER           DEFAULT 0                     NOT NULL,
  DATA_STATUS_PRSNL_ID         NUMBER           DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD        NUMBER           DEFAULT 0                     NOT NULL,
  CONTACT_ROLE_CD              NUMBER           DEFAULT 0                     NOT NULL,
  GENETIC_RELATIONSHIP_IND     NUMBER,
  LIVING_WITH_IND              NUMBER,
  VISITATION_ALLOWED_CD        NUMBER           DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ                 NUMBER,
  FREE_TEXT_CD                 NUMBER           DEFAULT 0                     NOT NULL,
  FT_REL_PERSON_NAME           VARCHAR2(100 BYTE),
  INTERNAL_SEQ                 NUMBER,
  FAMILY_RELTN_SUB_TYPE_CD     NUMBER           DEFAULT 0                     NOT NULL,
  DEFAULT_RELTN_IND            NUMBER           DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM          DATE,
  BEG_EFFECTIVE_DT_TM          DATE             DEFAULT SYSDATE               NOT NULL,
  DATA_STATUS_DT_TM            DATE,
  END_EFFECTIVE_DT_TM          DATE             DEFAULT TO_DATE('12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS') NOT NULL,
  RELATION_SEQ                 NUMBER           DEFAULT 0                     NOT NULL,
  SOURCE_IDENTIFIER            VARCHAR2(255 BYTE),
  CHANGE_BIT                   NUMBER           DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID          NUMBER           DEFAULT 0                     NOT NULL,
  TRACKING_BIT                 NUMBER           DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_PHR_INFO
(
  PERSON_PHR_INFO_ID  NUMBER                    DEFAULT 0                     NOT NULL,
  PERSON_ID           NUMBER                    DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID     NUMBER                    DEFAULT 0                     NOT NULL,
  PHR_STATUS_CD       NUMBER                    DEFAULT 0                     NOT NULL,
  ACTIVE_IND          NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_CNT            NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_ID             NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_TASK           NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX        NUMBER                    DEFAULT 0                     NOT NULL,
  UPDT_DT_TM          DATE                      DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_PHR_INFO_HIST
(
  PERSON_PHR_INFO_HIST_ID  NUMBER               DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID      NUMBER               DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM        DATE,
  CHANGE_BIT               NUMBER               DEFAULT 0                     NOT NULL,
  TRACKING_BIT             NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_PHR_INFO_ID       NUMBER               DEFAULT 0                     NOT NULL,
  PERSON_ID                NUMBER               DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID          NUMBER               DEFAULT 0                     NOT NULL,
  PHR_STATUS_CD            NUMBER               DEFAULT 0                     NOT NULL,
  ACTIVE_IND               NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_CNT                 NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_ID                  NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_TASK                NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX             NUMBER               DEFAULT 0                     NOT NULL,
  UPDT_DT_TM               DATE                 DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_PHR_RELTN
(
  PERSON_PHR_RELTN_ID    NUMBER                 DEFAULT 0                     NOT NULL,
  PERSON_PHR_INFO_ID     NUMBER                 DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD  NUMBER                 DEFAULT 0                     NOT NULL,
  ACTIVE_IND             NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_CNT               NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_ID                NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_TASK              NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX           NUMBER                 DEFAULT 0                     NOT NULL,
  UPDT_DT_TM             DATE                   DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_PHR_RELTN_HIST
(
  PERSON_PHR_RELTN_HIST_ID  NUMBER              DEFAULT 0                     NOT NULL,
  PM_HIST_TRACKING_ID       NUMBER              DEFAULT 0                     NOT NULL,
  TRANSACTION_DT_TM         DATE,
  CHANGE_BIT                NUMBER              DEFAULT 0                     NOT NULL,
  TRACKING_BIT              NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_PHR_RELTN_ID       NUMBER              DEFAULT 0                     NOT NULL,
  PERSON_PHR_INFO_ID        NUMBER              DEFAULT 0                     NOT NULL,
  CONTRIBUTOR_SYSTEM_CD     NUMBER              DEFAULT 0                     NOT NULL,
  ACTIVE_IND                NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_CNT                  NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_ID                   NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_TASK                 NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX              NUMBER              DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                DATE                DEFAULT SYSDATE               NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_PLAN_GRP
(
  PERSON_PLAN_GRP_ID      NUMBER                DEFAULT 0                     NOT NULL,
  PARENT_ID               NUMBER                DEFAULT 0                     NOT NULL,
  CHILD_ID                NUMBER                DEFAULT 0                     NOT NULL,
  PERSON_PLAN_GRP_CD      NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_CNT                NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_DT_TM              DATE                  DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                 NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_TASK               NUMBER                DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX            NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_IND              NUMBER,
  ACTIVE_STATUS_CD        NUMBER                DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM     DATE,
  ACTIVE_STATUS_PRSNL_ID  NUMBER                DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM     DATE                  DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM     DATE                  DEFAULT TO_DATE ( '12/31/210000:00:00' , 'MM/DD/YYYYHH24:MI:SS' ),
  CONTRIBUTOR_SYSTEM_CD   NUMBER                DEFAULT 0                     NOT NULL
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE PERSON_PLAN_RELTN
(
  PERSON_PLAN_RELTN_ID            NUMBER        DEFAULT 0                     NOT NULL,
  HEALTH_PLAN_ID                  NUMBER        DEFAULT 0                     NOT NULL,
  PERSON_ID                       NUMBER        DEFAULT 0                     NOT NULL,
  PERSON_PLAN_R_CD                NUMBER        DEFAULT 0                     NOT NULL,
  PERSON_ORG_RELTN_ID             NUMBER        DEFAULT 0                     NOT NULL,
  ORGANIZATION_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_CNT                        NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_DT_TM                      DATE          DEFAULT SYSDATE               NOT NULL,
  UPDT_ID                         NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_TASK                       NUMBER        DEFAULT 0                     NOT NULL,
  UPDT_APPLCTX                    NUMBER        DEFAULT 0                     NOT NULL,
  ACTIVE_IND                      NUMBER,
  ACTIVE_STATUS_CD                NUMBER        DEFAULT 0                     NOT NULL,
  ACTIVE_STATUS_DT_TM             DATE,
  ACTIVE_STATUS_PRSNL_ID          NUMBER        DEFAULT 0                     NOT NULL,
  BEG_EFFECTIVE_DT_TM             DATE          DEFAULT SYSDATE               NOT NULL,
  END_EFFECTIVE_DT_TM             DATE          DEFAULT TO_DATE( '12/31/2100 00:00:00' , 'MM/DD/YYYY HH24:MI:SS' ) NOT NULL,
  CONTRIBUTOR_SYSTEM_CD           NUMBER        DEFAULT 0                     NOT NULL,
  PRIORITY_SEQ                    NUMBER,
  MEMBER_NBR                      VARCHAR2(100 BYTE),
  SIGNATURE_ON_FILE_CD            NUMBER        DEFAULT 0                     NOT NULL,
  BALANCE_TYPE_CD                 NUMBER        DEFAULT 0                     NOT NULL,
  DEDUCT_AMT                      FLOAT(126),
  DEDUCT_MET_AMT                  FLOAT(126),
  DEDUCT_MET_DT_TM                DATE,
  COVERAGE_TYPE_CD                NUMBER        DEFAULT 0                     NOT NULL,
  MAX_OUT_PCKT_AMT                FLOAT(126),
  MAX_OUT_PCKT_DT_TM              DATE,
  FAM_DEDUCT_MET_AMT              FLOAT(126),
  FAM_DEDUCT_MET_DT_TM            DATE,
  VERIFY_STATUS_CD                NUMBER        DEFAULT 0                     NOT NULL,
  VERIFY_DT_TM                    DATE,
  VERIFY_PRSNL_ID                 NUMBER        DEFAULT 0                     NOT NULL,
  PLAN_TYPE_CD                    NUMBER        DEFAULT 0                     NOT NULL,
  PLAN_CLASS_CD                   NUMBER        DEFAULT 0                     NOT NULL,
  INSURED_CARD_NAME               VARCHAR2(100 BYTE),
  GROUP_NAME                      VARCHAR2(200 BYTE),
  GROUP_NBR                       VARCHAR2(100 BYTE),
  POLICY_NBR                      VARCHAR2(100 BYTE),
  SPONSOR_PERSON_ORG_RELTN_ID     NUMBER        DEFAULT 0                     NOT NULL,
  SUBSCRIBER_PERSON_ID            NUMBER        DEFAULT 0                     NOT NULL,
  MEMBER_PERSON_CODE              VARCHAR2(100 BYTE),
  LIFE_RSV_DAYS                   NUMBER        DEFAULT 0                     NOT NULL,
  LIFE_RSV_REMAIN_DAYS            NUMBER        DEFAULT 0                     NOT NULL,
  LIFE_RSV_DAILY_DED_AMT          FLOAT(126)    DEFAULT 0                     NOT NULL,
  LIFE_RSV_DAILY_DED_QUAL_CD      NUMBER        DEFAULT 0                     NOT NULL,
  CARD_ISSUE_NBR                  NUMBER        DEFAULT 0                     NOT NULL,
  CARD_CATEGORY_CD                NUMBER        DEFAULT 0                     NOT NULL,
  PROGRAM_STATUS_CD               NUMBER        DEFAULT 0                     NOT NULL,
  DENIAL_REASON_CD                NUMBER        DEFAULT 0                     NOT NULL,
  COVERAGE_COMMENTS_LONG_TEXT_ID  NUMBER        DEFAULT 0                     NOT NULL,
  CONTRACT_CODE                   VARCHAR2(100 BYTE),
  INSURED_CARD_NAME_FIRST         VARCHAR2(100 BYTE),
  INSURED_CARD_NAME_MIDDLE        VARCHAR2(100 BYTE),
  INSURED_CARD_NAME_LAST          VARCHAR2(100 BYTE),
  INSURED_CARD_NAME_SUFFIX        VARCHAR2(100 BYTE),
  VERIFY_SOURCE_CD                NUMBER        DEFAULT 0
)
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

